var __reflect = (this && this.__reflect) || function (p, c, t) {
    p.__class__ = c, t ? t.push(c) : t = [c], p.__types__ = p.__types__ ? t.concat(p.__types__) : t;
};
var __extends = this && this.__extends || function __extends(t, e) { 
 function r() { 
 this.constructor = t;
}
for (var i in e) e.hasOwnProperty(i) && (t[i] = e[i]);
r.prototype = e.prototype, t.prototype = new r();
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var ak;
(function (ak) {
    //计时器类
    var Timer = (function () {
        function Timer() {
            this.reset();
        }
        //获取计时器经历的时间（毫秒）
        Timer.prototype.getTime = function () {
            return new Date().getTime() - this.time;
        };
        //重置计时器
        Timer.prototype.reset = function () {
            this.time = new Date().getTime();
        };
        return Timer;
    }());
    ak.Timer = Timer;
    __reflect(Timer.prototype, "ak.Timer");
})(ak || (ak = {}));
var ak;
(function (ak) {
    var Client = (function () {
        function Client(wssSign, recvBuffSize) {
            if (wssSign === void 0) { wssSign = false; }
            if (recvBuffSize === void 0) { recvBuffSize = 1024 * 1024; }
            var _this = this;
            this.wssSign = false; //wss连接标记，true=使用wss连接，false=使用ws连接
            this.onlineSign = false; //在线标记
            this.wssSign = wssSign;
            this.socket = new egret.WebSocket();
            this.socket.type = egret.WebSocket.TYPE_BINARY;
            this.socket.addEventListener(egret.Event.CONNECT, function (e) {
                _this.onlineSign = true;
                _this.onConnect();
            }, this);
            this.socket.addEventListener(egret.IOErrorEvent.IO_ERROR, function () {
                _this.onlineSign = false;
                _this.onError();
            }, this);
            this.socket.addEventListener(egret.ProgressEvent.SOCKET_DATA, function (e) {
                var arr = new egret.ByteArray();
                _this.socket.readBytes(arr);
                var srcBuf = new DataView(arr.buffer);
                var buf = new ak.Buf(recvBuffSize);
                var len = arr.buffer.byteLength;
                for (var i = 0; i < len; ++i) {
                    var ch = srcBuf.getUint8(i);
                    buf.writeUint8(ch);
                }
                _this.onData(buf);
            }, this);
        }
        //连接
        Client.prototype.connect = function (domain, port) {
            if (this.wssSign) {
                this.socket.connectByUrl("wss://" + domain + ":" + port);
            }
            else {
                this.socket.connect(domain, port);
            }
        };
        //关闭
        Client.prototype.close = function () {
            this.socket.close();
        };
        //发送缓冲
        Client.prototype.send = function (buf) {
            var bytes = buf.size();
            if (bytes == 0)
                return;
            this.socket.writeBytes(new egret.ByteArray(buf.getData()), 0, buf.size());
            if (this.socket.connected == false) {
                this.onlineSign = false;
                this.onError();
            }
        };
        //发送字符串
        Client.prototype.sendString = function (str) {
            this.socket.writeUTF(str);
            if (this.socket.connected == false) {
                this.onError();
            }
        };
        //连接回调
        Client.prototype.onConnect = function () {
            //ak.log("onConnect:");
        };
        //接收回调
        Client.prototype.onData = function (buf) {
            //ak.log("onData");
        };
        //网络异常回调
        Client.prototype.onError = function () {
            //ak.log("onError");
        };
        //是否在线
        Client.prototype.isOnline = function () {
            return this.onlineSign;
        };
        return Client;
    }());
    ak.Client = Client;
    __reflect(Client.prototype, "ak.Client");
})(ak || (ak = {}));
var ak;
(function (ak) {
    //封装过的egret显示容器（调用destroy()或从父级节点移除后不要再使用，否则工作会不正常）
    var DisplayObjectContainer = (function (_super) {
        __extends(DisplayObjectContainer, _super);
        //构造时指定添加到父级节点
        function DisplayObjectContainer() {
            var _this = _super.call(this) || this;
            _this.eventObjArr = [];
            _this.changeParentSign = false;
            // private destroySign:boolean=false;
            _this.firstSign = true;
            //注册egret事件监听
            _this.egretEventCallbackInfoArr = [];
            _this.addEventListener(egret.Event.ADDED_TO_STAGE, _this.onAddedToStage, _this);
            return _this;
        }
        //初始化回调
        DisplayObjectContainer.prototype.onInit = function () {
        };
        //销毁回调
        DisplayObjectContainer.prototype.onDestroy = function () {
        };
        //更换父节点（不会触发销毁）
        DisplayObjectContainer.prototype.addToParent = function (parent) {
            if (!parent.stage) {
                var error = "parent未加入舞台";
            }
            this.changeParentSign = true;
            parent.addChild(this);
            this.changeParentSign = false;
            return this;
        };
        //监听egret事件（当本实例从舞台移除时自动移除on所添加的事件监听）
        DisplayObjectContainer.prototype.on = function (eventName, callback, thisObj, useCapture, priority) {
            this.addEventListener(eventName, callback, thisObj, useCapture, priority);
            this.eventObjArr.push([eventName, callback, thisObj, useCapture]);
        };
        //移除egret事件，对应on使用
        DisplayObjectContainer.prototype.off = function (eventName, callback, thisObj, useCapture) {
            this.removeEventListener(eventName, callback, thisObj, useCapture);
            var c = this.eventObjArr.length;
            for (var i = 0; i < c; ++i) {
                var info = this.eventObjArr[i];
                if (info[0] == eventName &&
                    info[1] == callback &&
                    info[2] == thisObj &&
                    info[3] == useCapture) {
                    this.eventObjArr.splice(i, 1);
                    break;
                }
            }
        };
        DisplayObjectContainer.prototype.onEgretEvent = function (obj, eventName, callback, thisObj, useCapture, priority) {
            obj.addEventListener(eventName, callback, thisObj, useCapture, priority);
            this.egretEventCallbackInfoArr.push([obj, eventName, callback, thisObj, useCapture]);
            ak.idMapAddCount(ak.EventMgr.egretEventMap, eventName, 1);
        };
        //注销egret事件监听
        DisplayObjectContainer.prototype.offEgretEvent = function (obj, eventName, callback, thisObj, useCapture) {
            obj.removeEventListener(eventName, callback, thisObj, useCapture);
            var c = this.egretEventCallbackInfoArr.length;
            for (var i = 0; i < c; ++i) {
                var info = this.egretEventCallbackInfoArr[i];
                if (info[0] == obj &&
                    info[1] == eventName &&
                    info[2] == callback &&
                    info[3] == thisObj &&
                    info[4] == useCapture) {
                    this.egretEventCallbackInfoArr.splice(i, 1);
                    ak.idMapAddCount(ak.EventMgr.egretEventMap, eventName, -1);
                    break;
                }
            }
        };
        //销毁（同时会从舞台移除）
        DisplayObjectContainer.prototype.destroy = function () {
            // this.destroySign=true;
            if (this.parent) {
                this.parent.removeChild(this);
            }
            // this.destroySign=false;
        };
        DisplayObjectContainer.prototype.onAddedToStage = function () {
            if (!this.changeParentSign) {
                var error = "请使用ak.DisplayObjectContainer.addToParent()更换父级节点，使用ak.DisplayObjectContainer.destroy()从父节点移除和销毁";
                ak.log(error);
                throw "";
            }
            if (this.firstSign) {
                this.addEventListener(egret.Event.REMOVED_FROM_STAGE, this.onRemoveFromStage, this);
                this.onInit();
                this.firstSign = false;
            }
        };
        DisplayObjectContainer.prototype.onRemoveFromStage = function () {
            if (this.changeParentSign) {
                return;
            }
            // if(!this.destroySign)
            // {
            // 	let error="请使用ak.DisplayObjectContainer.addToParent()更换父级节点，使用ak.DisplayObjectContainer.destroy()从父节点移除和销毁";
            // 	ak.log(error);
            // 	throw "";
            // }
            this.removeEventListener(egret.Event.ADDED_TO_STAGE, this.onAddedToStage, this);
            this.removeEventListener(egret.Event.REMOVED_FROM_STAGE, this.onRemoveFromStage, this);
            //注销事件
            var c = this.eventObjArr.length;
            for (var i = 0; i < c; ++i) {
                var info_1 = this.eventObjArr[i];
                var eventName = info_1[0];
                var callback = info_1[1];
                var thisObj = info_1[2];
                var useCapture = info_1[3];
                this.removeEventListener(eventName, callback, thisObj, useCapture);
            }
            this.eventObjArr = [];
            //销毁egret事件
            for (var i = 0; i < this.egretEventCallbackInfoArr.length; ++i) {
                var info = this.egretEventCallbackInfoArr[i];
                var obj = info[0];
                var eventName = info[1];
                var callback = info[2];
                var thisObj = info[3];
                var useCapture = info[4];
                if (useCapture == null) {
                    obj.removeEventListener(eventName, callback, thisObj);
                }
                else {
                    obj.removeEventListener(eventName, callback, thisObj, useCapture);
                }
                ak.idMapAddCount(ak.EventMgr.egretEventMap, eventName, -1);
            }
            this.egretEventCallbackInfoArr = [];
            this.onDestroy();
        };
        return DisplayObjectContainer;
    }(egret.DisplayObjectContainer));
    ak.DisplayObjectContainer = DisplayObjectContainer;
    __reflect(DisplayObjectContainer.prototype, "ak.DisplayObjectContainer");
})(ak || (ak = {}));
var ak;
(function (ak) {
    //FairyGUI界面基类
    var FairyGUI = (function () {
        function FairyGUI(groupName) {
            this.groupName = groupName;
        }
        //初始化（在首次ready()完成后会调用一次）
        FairyGUI.prototype.init = function () {
        };
        //打开界面
        /*
        uiInfoArr格式：[[UI001Class,...param],[UI002Class,...param],[callback002,thisObj002],...]
        数组中存在多个界面时，会按顺序进行打开
        */
        FairyGUI.open = function () {
            var uiInfoArr = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                uiInfoArr[_i] = arguments[_i];
            }
            var c = uiInfoArr.length;
            for (var i = 0; i < c; ++i) {
                var info = uiInfoArr[i];
                var className = info[0];
                var openUIArr = this.getOpenUI(className);
                if (openUIArr.length > 0) {
                    var openUI = openUIArr[openUIArr.length - 1];
                    if (!openUI.openMultiple) {
                        var callbackInfo_1 = this.getUICallbackInfo(uiInfoArr, i + 1);
                        ++i;
                        continue;
                    }
                }
                var CurClass = egret.getDefinitionByName(className);
                var ui = void 0;
                if (info.length > 1) {
                    var param = [];
                    for (var j = 1; j < info.length; ++j) {
                        param.push(info[j]);
                    }
                    ui = new (CurClass.bind.apply(CurClass, [void 0].concat(param)))();
                }
                else {
                    ui = new CurClass();
                }
                ui.className = className;
                var uiArr = this.openUIMap[className];
                if (!uiArr) {
                    uiArr = [];
                    this.openUIMap[className] = uiArr;
                }
                uiArr.push(ui);
                var callbackInfo = this.getUICallbackInfo(uiInfoArr, i + 1);
                if (callbackInfo) {
                    ui.openCallback = callbackInfo[0];
                    ui.openCallbackThisObj = callbackInfo[1];
                    ++i;
                }
                ak.log("openUI class=" + className);
            }
        };
        //检查index指向元素是否为回调函数，如果是则返回回调函数信息，否则返回null
        FairyGUI.getUICallbackInfo = function (uiInfoArr, index) {
            if (index >= uiInfoArr.length) {
                return null;
            }
            var info = uiInfoArr[index];
            if (info[0]) {
                return info;
            }
            return null;
        };
        //获取打开界面数组
        FairyGUI.getOpenUI = function (className) {
            var uiArr = this.openUIMap[className];
            if (!uiArr)
                uiArr = [];
            return uiArr;
        };
        // public static getOpenView(className:string): EasyUI
        // {
        // 	let uiArr:any[]=this.openUIMap[className];
        // 	if(!uiArr)uiArr=[];
        // 	return uiArr;
        // }
        //模拟点击
        FairyGUI.click = function (obj) {
            var e = new egret.TouchEvent(egret.TouchEvent.TOUCH_TAP);
            obj.dispatchEvent(e);
        };
        //准备函数，在回调中使用界面资源，确定资源加载完成
        FairyGUI.prototype.ready = function (callback, thisObj) {
            var _this = this;
            ak.ResMgr.loadGroup(this.groupName, function () {
                _this.init();
                callback.call(thisObj);
            }, this);
        };
        FairyGUI.start = function (stage) {
            var _this = this;
            //窗体尺寸变化
            stage.addEventListener(egret.Event.RESIZE, function () {
                //调整界面尺寸
                var c = _this.uiArr.length;
                for (var i = 0; i < c; ++i) {
                    var ui = _this.uiArr[i];
                    ui.ui.setSize(fairygui.GRoot.inst.width, fairygui.GRoot.inst.height);
                    ui.onResize();
                }
            }, this);
            //检测延时调用
            this.delayCallTime.reset();
            stage.addEventListener(egret.Event.ENTER_FRAME, function () {
                if (_this.delayCallTime.getTime() >= 1000) {
                    _this.delayCallTime.reset();
                    var ct = ak.time();
                    for (var i = _this.delayCallArr.length - 1; i >= 0; --i) {
                        var info = _this.delayCallArr[i];
                        var targetTime = info[2];
                        if (ct >= targetTime) {
                            _this.delayCallArr.splice(i, 1);
                            var callback = info[0];
                            var thisObj = info[1];
                            //回调
                            callback.call(thisObj);
                        }
                    }
                }
            }, this);
        };
        FairyGUI.delayCall = function (callback, thisObj, //回调
            delayTime //延时时间（秒）
        ) {
            if (delayTime <= 0) {
                callback.call(thisObj);
            }
            else {
                this.delayCallArr.push([callback, thisObj, ak.time() + delayTime]);
            }
        };
        FairyGUI.openUIMap = {}; //打开界面字典
        FairyGUI.clickSoundUrl = ""; //默认点击音效url
        //初始化
        FairyGUI.uiArr = [];
        //延时调用
        FairyGUI.delayCallTime = new ak.Timer();
        FairyGUI.delayCallArr = [];
        return FairyGUI;
    }());
    ak.FairyGUI = FairyGUI;
    __reflect(FairyGUI.prototype, "ak.FairyGUI");
    //简易自动回收资源界面
    var EasyUI = (function (_super) {
        __extends(EasyUI, _super);
        function EasyUI(gui, layer, data) {
            var _this = _super.call(this) || this;
            _this.openMultiple = false; //允许多开（同时打开多个界面）
            _this.firstInit = true;
            _this.bgShapeAutoRemove = false;
            //注册ak事件监听
            _this.callbackInfoArr = [];
            //注册egret事件监听
            _this.egretEventCallbackInfoArr = [];
            //注册fairygui事件监听
            _this.fairyguiEventCallbackInfoArr = [];
            //已使用的资源字典
            _this.useUrlMap = {};
            _this.data = data;
            _this.addEventListener(egret.Event.ADDED_TO_STAGE, function () {
                gui.ready(function () {
                    _this.once(egret.Event.ENTER_FRAME, function () {
                        //删除背景形状
                        if (_this.bgShape && _this.bgShapeAutoRemove) {
                            _this.removeChild(_this.bgShape);
                            _this.bgShape = null;
                        }
                        if (_this.firstInit) {
                            _this.firstInit = false;
                            _this.onInit();
                        }
                        //界面打开回调
                        if (_this.openCallback && _this.openCallbackThisObj) {
                            //回调
                            _this.openCallback.call(_this.openCallbackThisObj, _this);
                        }
                        //界面打开完成事件派发
                        _this.once(egret.Event.ENTER_FRAME, function () {
                            ak.EventMgr.dispatch("openUIComplete://");
                            ak.EventMgr.dispatch("openUIComplete://" + _this.className);
                        }, _this);
                    }, _this);
                }, _this);
            }, _this);
            _this.addEventListener(egret.Event.REMOVED_FROM_STAGE, function () {
                _this.onDestroy();
                _this.destroy();
                ak.EventMgr.dispatch("closeUI://");
                ak.EventMgr.dispatch("closeUI://" + _this.className);
                ak.log("closeUI class=" + _this.className);
            }, _this);
            if (layer instanceof egret.DisplayObjectContainer) {
                layer.addChild(_this);
            }
            else if (layer instanceof fairygui.GGraph) {
                layer.setNativeObject(_this);
            }
            ak.EventMgr.dispatch("openUIBegin://", [_this]);
            return _this;
        }
        //创建背景形状（在fui资源加载完之前，创建一个与屏幕尺寸一样的形状对象，避免点击可以穿过界面，界面资源加载完后此形状会删除）
        EasyUI.prototype.createBgShape = function (color, //背景形状颜色
            alpha, //背景形状透明度
            autoRemove ////背景形状是否在fui资源加载完后自动删除
        ) {
            if (color === void 0) { color = 0; }
            if (alpha === void 0) { alpha = 0; }
            if (autoRemove === void 0) { autoRemove = true; } ////背景形状是否在fui资源加载完后自动删除
            var bg = new egret.Shape();
            bg.graphics.beginFill(0x0, 0);
            bg.graphics.drawRect(0, 0, fairygui.GRoot.inst.width, fairygui.GRoot.inst.height);
            bg.graphics.endFill();
            bg.touchEnabled = true;
            this.addChild(bg);
            this.bgShape = bg;
            this.bgShapeAutoRemove = autoRemove;
        };
        //删除背景形状
        EasyUI.prototype.removeBgShape = function () {
            if (this.bgShape) {
                this.removeChild(this.bgShape);
            }
        };
        //创建界面
        EasyUI.prototype.create = function (pkgName, resName) {
            if (this.ui) {
                throw "ak.EasyUI.create() 重复调用";
            }
            var ui = fairygui.UIPackage.createObject(pkgName, resName).asCom;
            this.addChild(ui.displayObject);
            ui.setSize(fairygui.GRoot.inst.width, fairygui.GRoot.inst.height);
            this.ui = ui;
            FairyGUI.uiArr.push(this);
            //标记ui中使用的resource/static/中的资源，以便关闭的时候释放资源
            this.findLoaderUrlAndRemark(ui);
            //添加控制器状态改变事件，事件发生时再次扫描静态图并标记
            this.findCtrlAndRemark(ui);
            return ui;
        };
        EasyUI.prototype.on = function (eventName, callback, thisObj) {
            ak.EventMgr.addEventListener(eventName, callback, thisObj);
            this.callbackInfoArr.push([eventName, callback, thisObj]);
        };
        EasyUI.prototype.off = function (eventName, callback, thisObj) {
            ak.EventMgr.removeEventListener(eventName, callback, thisObj);
            for (var i = 0; i < this.callbackInfoArr.length; ++i) {
                var info = this.callbackInfoArr[i];
                if (eventName == info[0] && callback == info[1] && thisObj == info[2]) {
                    this.callbackInfoArr.splice(i, 1);
                    break;
                }
            }
        };
        EasyUI.prototype.onEgretEvent = function (obj, eventName, callback, thisObj, useCapture, priority) {
            obj.addEventListener(eventName, callback, thisObj, useCapture, priority);
            this.egretEventCallbackInfoArr.push([obj, eventName, callback, thisObj, useCapture]);
            ak.idMapAddCount(ak.EventMgr.egretEventMap, eventName, 1);
        };
        //注销egret事件监听
        EasyUI.prototype.offEgretEvent = function (obj, eventName, callback, thisObj, useCapture) {
            obj.removeEventListener(eventName, callback, thisObj, useCapture);
            for (var i = 0; i < this.egretEventCallbackInfoArr.length; ++i) {
                var info = this.egretEventCallbackInfoArr[i];
                if (eventName == info[1] && callback == info[2] && thisObj == info[3] && useCapture == info[4]) {
                    this.egretEventCallbackInfoArr.splice(i, 1);
                    ak.idMapAddCount(ak.EventMgr.egretEventMap, eventName, -1);
                    break;
                }
            }
        };
        EasyUI.prototype.onFairyguiEvent = function (obj, eventName, callback, thisObj) {
            obj.addEventListener(eventName, callback, thisObj);
            this.fairyguiEventCallbackInfoArr.push([obj, eventName, callback, thisObj]);
        };
        //标记ui中使用的resource/static/中的资源，以便关闭的时候释放资源
        EasyUI.prototype.findLoaderUrlAndRemark = function (obj) {
            if (!obj) {
                return;
            }
            var c = obj.numChildren;
            for (var i = 0; i < c; ++i) {
                var obj001 = obj.getChildAt(i);
                if (obj001.asLoader) {
                    var loader = obj001.asLoader;
                    var url = loader.url;
                    if (url && url.substr(0, EasyUI.allowUrlPre.length) == EasyUI.allowUrlPre) {
                        this.remarkUrl(url); //标记资源引用
                        // ak.log(url);
                    }
                }
                else {
                    this.findLoaderUrlAndRemark(obj001.asCom);
                }
            }
        };
        //添加控制器状态改变事件，事件发生时再次扫描静态图并标记
        EasyUI.prototype.findCtrlAndRemark = function (obj) {
            var _this = this;
            if (!obj) {
                return;
            }
            var c = obj.numChildren;
            for (var i = 0; i < c; ++i) {
                var obj001 = obj.getChildAt(i);
                this.findCtrlAndRemark(obj001.asCom);
            }
            //控制器状态改变时，再次扫描静态图并标记
            for (var i = 0;; ++i) {
                var ctrl = void 0;
                if (obj && obj.getControllerAt) {
                    obj.getControllerAt(i);
                }
                if (!ctrl)
                    break;
                this.onEgretEvent(ctrl, fairygui.StateChangeEvent.CHANGED, function (e) {
                    //标记ui中使用的resource/static/中的资源，以便关闭的时候释放资源
                    _this.findLoaderUrlAndRemark(_this.ui);
                }, this);
            }
        };
        //初始化回调
        EasyUI.prototype.onInit = function () {
        };
        //销毁回调
        EasyUI.prototype.onDestroy = function () {
        };
        //调整界面尺寸回调
        EasyUI.prototype.onResize = function () {
        };
        EasyUI.prototype.clickButtonSound = function (obj) {
            //播放点击音效
            var btn = obj.asButton;
            if (btn && btn.sound && btn.sound != "") {
                ak.SoundMgr.inst.playSound(btn.sound);
            }
            else {
                if (FairyGUI.clickSoundUrl != "") {
                    ak.SoundMgr.inst.playSound(FairyGUI.clickSoundUrl);
                }
            }
        };
        //点击监听
        EasyUI.prototype.addClickListener = function (obj, callback, thisObj) {
            var _this = this;
            obj.addClickListener(function () {
                var param = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    param[_i] = arguments[_i];
                }
                //播放点击效果
                _this.clickButtonSound(obj);
                callback.call.apply(callback, [thisObj].concat(param));
            }, this);
        };
        //检查指定位置(x,y)是否与fairygui组件发生碰撞
        EasyUI.prototype.hitTestPointWithFairyGUIComponent = function (obj, x, y //相对于舞台的坐标
        ) {
            if (!obj.visible)
                return false;
            var p = obj.localToGlobal(0, 0);
            var w = obj.width;
            var h = obj.height;
            var x0 = p.x;
            var y0 = p.y;
            var x1 = x0 + w;
            var y1 = y0 + h;
            if (x >= x0 && x < x1 && y >= y0 && y < y1) {
                //播放点击效果
                this.clickButtonSound(obj);
                return true;
            }
            return false;
            //直接使用obj.displayObject.hitTestPoint时，如果obj在fui中缩放过，会产生点击有效区域偏移的问题
            // return obj.displayObject.hitTestPoint(x,y);
        };
        //查询fui中loader组件加载图片是否完成
        EasyUI.prototype.isGLoaderComplete = function (loader) {
            if (loader.displayObject.$children) {
                return true;
            }
            return false;
        };
        //关闭界面
        EasyUI.prototype.close = function () {
            var c = FairyGUI.uiArr.length;
            for (var i = 0; i < c; ++i) {
                var ui = FairyGUI.uiArr[i];
                if (ui == this) {
                    FairyGUI.uiArr.splice(i, 1);
                    break;
                }
            }
            if (this.parent) {
                this.parent.removeChild(this);
            }
        };
        //销毁资源
        EasyUI.prototype.destroy = function () {
            for (var url in this.useUrlMap) {
                var c = this.useUrlMap[url];
                for (var i = 0; i < c; ++i) {
                    ak.ResMgr.releaseTexture(url);
                }
            }
            //移除事件监听
            for (var i = 0; i < this.callbackInfoArr.length; ++i) {
                var info = this.callbackInfoArr[i];
                ak.EventMgr.removeEventListener(info[0], info[1], info[2]);
            }
            //移除egret事件监听
            for (var i = 0; i < this.egretEventCallbackInfoArr.length; ++i) {
                var info = this.egretEventCallbackInfoArr[i];
                var obj = info[0];
                var eventName = info[1];
                var callback = info[2];
                var thisObj = info[3];
                var useCapture = info[4];
                if (useCapture == null) {
                    obj.removeEventListener(eventName, callback, thisObj);
                }
                else {
                    obj.removeEventListener(eventName, callback, thisObj, useCapture);
                }
                ak.idMapAddCount(ak.EventMgr.egretEventMap, eventName, -1);
            }
            //移除fairygui事件监听
            for (var i = 0; i < this.fairyguiEventCallbackInfoArr.length; ++i) {
                var info = this.fairyguiEventCallbackInfoArr[i];
                var obj = info[0];
                var eventName = info[1];
                var callback = info[2];
                var thisObj = info[3];
                obj.removeEventListener(eventName, callback, thisObj);
            }
            if (this.ui) {
                this.ui.dispose();
            }
            //从打开界面字典中移除
            var uiArr = ak.FairyGUI.getOpenUI(this.className);
            if (uiArr) {
                var c = uiArr.length;
                for (var i = 0; i < c; ++i) {
                    if (uiArr[i] == this) {
                        uiArr.splice(i, 1);
                        break;
                    }
                }
            }
        };
        //设置fairyGUI中的加载器路径
        EasyUI.prototype.setLoaderUrl = function (loader, //加载器
            url //资源名或url
        ) {
            // console.log("plat==", url, loader)
            if (url == "") {
                loader.url = "";
                return;
            }
            if (typeof url != "undefined" && url.substr(0, 5) == "ui://") 
            // if(url.substr)//设置的资源在fairygui资源包中存在
            {
                loader.url = url;
                return;
            }
            // if(url.substr && url.substr(0,EasyUI.allowUrlPre.length)==EasyUI.allowUrlPre)
            // {
            // 	throw "不允许在程序中直接设置"+EasyUI.allowUrlPre+"开头的资源";
            // }
            //加上EasyUI.urlPre前缀，在MyGLoader类中防止跳过调用此函数
            loader.url = EasyUI.urlPre + url;
            this.remarkUrl(url); //标记资源引用
        };
        //标记资源引用
        EasyUI.prototype.remarkUrl = function (url) {
            if (this.useUrlMap[url] == null) {
                this.useUrlMap[url] = 1;
            }
            else {
                ++this.useUrlMap[url];
            }
            ak.ResMgr.retainTexture(url);
        };
        EasyUI.urlPre = "##EasyUI.setLoaderUrl##"; //url前缀（用于防止跳过不使用setLoaderUrl()的情况
        EasyUI.allowUrlPre = "resource/static/"; //允许在fairygui编辑器中设置到loader组件url的前缀
        return EasyUI;
    }(egret.DisplayObjectContainer));
    ak.EasyUI = EasyUI;
    __reflect(EasyUI.prototype, "ak.EasyUI");
})(ak || (ak = {}));
var FightReadyViewSystem = (function (_super) {
    __extends(FightReadyViewSystem, _super);
    function FightReadyViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    FightReadyViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("RaceHelpView");
    };
    FightReadyViewSystem.inst = new FightReadyViewSystem("RaceHelpView");
    return FightReadyViewSystem;
}(ak.FairyGUI));
__reflect(FightReadyViewSystem.prototype, "FightReadyViewSystem");
/**
 * 英雄选择界面
 */
var FightReadyView = (function (_super) {
    __extends(FightReadyView, _super);
    /**
     * fighttype为战斗类型
     * 根据fighttype分别往本地存储不同的上阵数据
     * 1-为挂机战斗
     * 2-为每日试炼
     * 3-为爬塔战斗
     * 4-为好友boss战斗
     * 5-为竞技场防守阵容
     * 6-为和好友pk
     * 7-竞技场挑战对手
     * 8-公会boss
     */
    function FightReadyView(fighttype, id, num) {
        var _this = _super.call(this, RaceHelpViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.heroGroups = [];
        _this.fightGroups = [];
        _this.localStorage = [];
        _this.fightIndexGroups = [-1, -1, -1, -1, -1, -1, -1];
        _this.fightGroupsxy = [{ x: 48, y: 796 }, { x: 138, y: 796 }, { x: 245, y: 796 }, { x: 335, y: 796 }, { x: 425, y: 796 }, { x: 515, y: 796 }];
        _this.index = 0;
        /**战斗类型 */
        _this.fighttype = 0;
        /**存进来的id */
        _this.id = 0;
        /**存进来的次数 */
        _this.num = 1;
        _this.fighttype = fighttype;
        if (id)
            _this.id = id;
        if (num)
            _this.num = num;
        return _this;
    }
    /**回调 */
    FightReadyView.prototype.onInit = function () {
        var ui = this.create("RaceHelpView", "FightReadyView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.list = ui.getChild("list").asList;
        this.itemlist = ui.getChild("itemlist").asCom;
        this.typeCom = ui.getChild("typeCom").asCom;
        this.power = ui.getChild("power").asTextField;
        this.artifactbtn = ui.getChild("artifactbtn").asButton;
        this.fightbtn = ui.getChild("fightbtn").asButton;
        this.btn0 = this.itemlist.getChild("btn0").asButton;
        this.btn1 = this.itemlist.getChild("btn1").asButton;
        this.btn2 = this.itemlist.getChild("btn2").asButton;
        this.btn3 = this.itemlist.getChild("btn3").asButton;
        this.btn4 = this.itemlist.getChild("btn4").asButton;
        this.btn5 = this.itemlist.getChild("btn5").asButton;
        this.btn6 = this.itemlist.getChild("btn6").asButton;
        this.item0_1 = ui.getChild("item0_1").asCom;
        this.item1_1 = ui.getChild("item1_1").asCom;
        this.item2_1 = ui.getChild("item2_1").asCom;
        this.item3_1 = ui.getChild("item3_1").asCom;
        this.item4_1 = ui.getChild("item4_1").asCom;
        this.item5_1 = ui.getChild("item5_1").asCom;
        this.item6_1 = ui.getChild("item6_1").asCom;
        this.index = 0;
        this.fightGroups = [];
        this.fightIndexGroups = [-1, -1, -1, -1, -1, -1];
        this.GetLocalStorage_Group();
        this.static6itemInfo();
        this.updateInfo(0);
        this.updatezhenfaIcon();
        this.ClickAdd();
    };
    FightReadyView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.artifactbtn, this.onClick, this);
        this.addClickListener(this.fightbtn, this.onClick, this);
        this.addClickListener(this.btn0, this.onClick, this);
        this.addClickListener(this.btn1, this.onClick, this);
        this.addClickListener(this.btn2, this.onClick, this);
        this.addClickListener(this.btn3, this.onClick, this);
        this.addClickListener(this.btn4, this.onClick, this);
        this.addClickListener(this.btn5, this.onClick, this);
        this.addClickListener(this.btn6, this.onClick, this);
        this.addClickListener(this.typeCom, this.onClick, this);
        this.onFairyguiEvent(this.list, fairygui.ItemEvent.CLICK, this.itemonclick, this);
        for (var i = 0; i < 6; i++) {
            this.onEgretEvent(this["item" + i + "_1"], egret.TouchEvent.TOUCH_TAP, this.onComClick0, this);
            this.onEgretEvent(this["item" + i + "_1"], egret.TouchEvent.TOUCH_BEGIN, this.onComClick1, this);
        }
        this.onEgretEvent(this.ui, egret.TouchEvent.TOUCH_MOVE, this.onComClick2, this);
        this.onEgretEvent(this.ui, egret.TouchEvent.TOUCH_END, this.onComClick3, this);
    };
    FightReadyView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.artifactbtn:
                ak.FairyGUI.open(["ChooseShenqiView", this.fighttype]);
                break;
            case this.fightbtn:
                this.fighthandle();
                break;
            case this.btn0:
                this.updateInfo(0);
                break;
            case this.btn1:
                this.updateInfo(1);
                break;
            case this.btn2:
                this.updateInfo(2);
                break;
            case this.btn3:
                this.updateInfo(3);
                break;
            case this.btn4:
                this.updateInfo(4);
                break;
            case this.btn5:
                this.updateInfo(5);
                break;
            case this.btn6:
                this.updateInfo(6);
                break;
            case this.typeCom:
                ak.FairyGUI.open(["RaceHelpView"]);
                break;
        }
    };
    /**英雄点击事件 */
    FightReadyView.prototype.itemonclick = function (e) {
        var _this = this;
        if (e.itemObject.data.isChoose == true) {
            var item = (e.itemObject);
            var items = new ItemBase(item, this, 2);
            items.setGou(false);
            for (var i = 0; i < this.fightGroups.length; i++) {
                if (this.fightGroups[i].index == e.itemObject.data.index) {
                    this.fightGroups.splice(i, 1);
                    e.itemObject.data.isChoose = false;
                    var _loop_1 = function (i_1) {
                        if (this_1.fightIndexGroups[i_1] == e.itemObject.data.index) {
                            this_1.fightIndexGroups[i_1] = -1;
                            var start_x = e.itemObject.localToGlobal().x;
                            var start_y = e.itemObject.localToGlobal().y;
                            this_1["item" + i_1 + "_1"].visible = true;
                            this_1["item" + i_1 + "_1"].scaleX = 1;
                            this_1["item" + i_1 + "_1"].scaleY = 1;
                            this_1["item" + i_1 + "_1"].x = this_1.fightGroupsxy[i_1].x;
                            this_1["item" + i_1 + "_1"].y = this_1.fightGroupsxy[i_1].y;
                            this_1["item" + i_1 + "_1"].data = {};
                            this_1["item" + i_1 + "_1"].enabled = false;
                            egret.Tween.removeTweens(this_1["item" + i_1 + "_1"]);
                            egret.Tween.get(this_1["item" + i_1 + "_1"], { loop: false }).
                                to({ x: start_x, y: start_y, scaleX: 1.2, scaleY: 1.2 }, 200).call(function () {
                                _this["item" + i_1 + "_1"].visible = false;
                                _this["item" + i_1 + "_1"].enabled = true;
                                _this["item" + i_1 + "_1"].width = 100;
                                _this["item" + i_1 + "_1"].height = 100;
                                _this["item" + i_1 + "_1"].scaleX = 0.8;
                                _this["item" + i_1 + "_1"].scaleY = 0.8;
                            });
                        }
                    };
                    var this_1 = this;
                    //判断从哪个位置回去
                    for (var i_1 = 0; i_1 < this.fightIndexGroups.length; i_1++) {
                        _loop_1(i_1);
                    }
                }
            }
        }
        else {
            if (this.fightGroups.length >= 6) {
                TipsViewSystem.show("当前选择英雄已满");
            }
            else {
                var isfirst = true;
                var item = (e.itemObject);
                var items = new ItemBase(item, this, 2);
                items.setGou(true);
                e.itemObject.data.isChoose = true;
                this.fightGroups.push(e.itemObject.data);
                var _loop_2 = function (i) {
                    if (this_2.fightIndexGroups[i] == -1 && isfirst) {
                        isfirst = false;
                        this_2.fightIndexGroups[i] = e.itemObject.data.index;
                        var start_x = e.itemObject.localToGlobal().x;
                        var start_y = e.itemObject.localToGlobal().y;
                        var items2 = new ItemBase(this_2["item" + i + "_1"], this_2, 2);
                        items2.setItemData(e.itemObject.data.info.heroID, e.itemObject.data.info.race, e.itemObject.data.info.starMax);
                        items2.setNumber(e.itemObject.data.info.level);
                        this_2["item" + i + "_1"].visible = true;
                        this_2["item" + i + "_1"].scaleX = 1.2;
                        this_2["item" + i + "_1"].scaleY = 1.2;
                        this_2["item" + i + "_1"].x = start_x;
                        this_2["item" + i + "_1"].y = start_y;
                        this_2["item" + i + "_1"].data = { index: e.itemObject.data.index, info: e.itemObject.data.info };
                        this_2["item" + i + "_1"].enabled = false;
                        egret.Tween.removeTweens(this_2["item" + i + "_1"]);
                        egret.Tween.get(this_2["item" + i + "_1"], { loop: false }).
                            to({ x: this_2.fightGroupsxy[i].x, y: this_2.fightGroupsxy[i].y, scaleX: 0.8, scaleY: 0.8 }, 200).call(function () {
                            _this["item" + i + "_1"].enabled = true;
                            _this["item" + i + "_1"].width = 100;
                            _this["item" + i + "_1"].height = 100;
                            _this["item" + i + "_1"].scaleX = 0.8;
                            _this["item" + i + "_1"].scaleY = 0.8;
                        });
                    }
                };
                var this_2 = this;
                //判断放到哪个位置去
                for (var i = 0; i < this.fightIndexGroups.length; i++) {
                    _loop_2(i);
                }
            }
        }
        this.updatezhenfaIcon();
        this.updatePower();
    };
    /**6个英雄的事件 */
    FightReadyView.prototype.onComClick0 = function (evt) {
        var itemCom = evt.target;
        var final_x = 0;
        var final_y = 0;
        var isInFight = false;
        for (var i = 0; i < this.list.numChildren; i++) {
            var item = this.list.getChildAt(i).asCom;
            if (item.data.index == itemCom.data.index) {
                final_x = item.localToGlobal().x;
                final_y = item.localToGlobal().y;
                isInFight = true;
                var items = new ItemBase(item, this, 2);
                item.data.isChoose = false;
                items.setGou(false);
                break;
            }
            else {
                if (isInFight == false) {
                    final_x = 300;
                    final_y = 350;
                }
            }
        }
        for (var j = 0; j < this.fightIndexGroups.length; j++) {
            if (this.fightIndexGroups[j] == itemCom.data.index) {
                this.fightIndexGroups[j] = -1;
            }
        }
        for (var k = 0; k < this.fightGroups.length; k++) {
            if (this.fightGroups[k].index == itemCom.data.index) {
                this.fightGroups.splice(k, 1);
            }
        }
        egret.Tween.removeTweens(itemCom);
        egret.Tween.get(itemCom, { loop: false }).
            to({ x: final_x, y: final_y, scaleX: 1.2, scaleY: 1.2 }, 200).call(function () {
            itemCom.visible = false;
            itemCom.width = 100;
            itemCom.height = 100;
            itemCom.scaleX = 0.8;
            itemCom.scaleY = 0.8;
        });
        this.updatezhenfaIcon();
        this.updatePower();
    };
    FightReadyView.prototype.onComClick1 = function (evt) {
        this.touchCom = evt.target;
        if (!this.isIn6place(this.touchCom))
            return;
        this.item6_1.x = evt.target.x;
        this.item6_1.y = evt.target.y;
        this.item6_1.visible = false;
        var items2 = new ItemBase(this.item6_1, this, 2);
        items2.setItemData(evt.target.data.info.heroID, evt.target.data.info.race, evt.target.data.info.starMax);
        items2.setNumber(evt.target.data.info.level);
        this.item6_1.data = evt.target.data;
    };
    FightReadyView.prototype.onComClick2 = function (evt) {
        if (!(this.touchCom && this.touchCom.enabled == true))
            return;
        if (!this.isIn6place(this.touchCom))
            return;
        if (this.item6_1.data == null)
            return;
        if (this.touchCom && this.touchCom.enabled == true)
            this.touchCom.visible = false;
        this.item6_1.visible = true;
        this.item6_1.x = evt.stageX - 40;
        this.item6_1.y = evt.stageY - 40;
    };
    FightReadyView.prototype.onComClick3 = function (evt) {
        if (!(this.touchCom && this.touchCom.enabled == true))
            return;
        if (this.item6_1.data == null)
            return;
        var itemCom = this.touchCom;
        if (this.testItemxy(this.item6_1.x, this.item6_1.y) == -1) {
            this.item6_1.visible = false;
            this.item6_1.data = null;
            if (this.touchCom)
                this.touchCom.visible = true;
        }
        else {
            var Groupindex = -1;
            for (var i = 0; i < this.fightIndexGroups.length; i++) {
                if (itemCom.data.index == this.fightIndexGroups[i]) {
                    Groupindex = i;
                }
            }
            this.ishaveItem(Groupindex, this.testItemxy(this.item6_1.x, this.item6_1.y));
            this.item6_1.visible = false;
            this.item6_1.data = null;
        }
        this.updatezhenfaIcon();
    };
    /**判断该组件是否在6个位置上面 */
    FightReadyView.prototype.isIn6place = function (com) {
        for (var i = 0; i < this.fightGroupsxy.length; i++) {
            if (com.x == this.fightGroupsxy[i].x && com.y == this.fightGroupsxy[i].y) {
                return true;
            }
        }
        return false;
    };
    /**
     * 测试该物品拖动时是否在拖到其他地方上面
     * 1:如果在，判断该位置是否已经有卡牌，
     * （1）如果有，则两张卡牌交替位置（2）如果没有，则直接放入
     * 2:如果不在，直接回到原来的位置
     */
    FightReadyView.prototype.testItemxy = function (x, y) {
        var item0_place = { x: 48, y: 796 };
        var item1_place = { x: 138, y: 796 };
        var item2_place = { x: 245, y: 796 };
        var item3_place = { x: 335, y: 796 };
        var item4_place = { x: 425, y: 796 };
        var item5_place = { x: 515, y: 796 };
        var itemplaceGroup = [item0_place, item1_place, item2_place, item3_place, item4_place, item5_place];
        for (var i = 0; i < 6; i++) {
            if (Math.abs(x - itemplaceGroup[i].x) < 80 / 2 + 80 / 2 && Math.abs(y - itemplaceGroup[i].y) < 80 / 2 + 80 / 2) {
                return i;
            }
        }
        return -1;
    };
    FightReadyView.prototype.ishaveItem = function (starindex, finalindex) {
        if (this.fightIndexGroups[finalindex] == -1) {
            this.fightIndexGroups[finalindex] = this.fightIndexGroups[starindex];
            var items2 = new ItemBase(this["item" + finalindex + "_1"], this, 2);
            items2.setItemData(this["item" + starindex + "_1"].data.info.heroID, this["item" + starindex + "_1"].data.info.race, this["item" + starindex + "_1"].data.info.starMax);
            items2.setNumber(this["item" + starindex + "_1"].data.info.level);
            this["item" + finalindex + "_1"].visible = true;
            this["item" + finalindex + "_1"].data = this["item" + starindex + "_1"].data;
            this["item" + starindex + "_1"].data = {};
            this["item" + starindex + "_1"].visible = false;
            this["item" + starindex + "_1"].x = this.fightGroupsxy[starindex].x;
            this["item" + starindex + "_1"].y = this.fightGroupsxy[starindex].y;
            this["item" + finalindex + "_1"].x = this.fightGroupsxy[finalindex].x;
            this["item" + finalindex + "_1"].y = this.fightGroupsxy[finalindex].y;
            this.fightIndexGroups[starindex] = -1;
        }
        else {
            var star = this.fightIndexGroups[starindex];
            this.fightIndexGroups[starindex] = this.fightIndexGroups[finalindex];
            this.fightIndexGroups[finalindex] = star;
            var data = this["item" + starindex + "_1"].data;
            this["item" + starindex + "_1"].data = this["item" + finalindex + "_1"].data;
            this["item" + finalindex + "_1"].data = data;
            var items2 = new ItemBase(this["item" + finalindex + "_1"], this, 2);
            items2.setItemData(this["item" + finalindex + "_1"].data.info.heroID, this["item" + finalindex + "_1"].data.info.race, this["item" + finalindex + "_1"].data.info.starMax);
            items2.setNumber(this["item" + finalindex + "_1"].data.info.level);
            var items3 = new ItemBase(this["item" + starindex + "_1"], this, 2);
            items3.setItemData(this["item" + starindex + "_1"].data.info.heroID, this["item" + starindex + "_1"].data.info.race, this["item" + starindex + "_1"].data.info.starMax);
            items3.setNumber(this["item" + starindex + "_1"].data.info.level);
            //数据更新
            this["item" + starindex + "_1"].x = this.fightGroupsxy[starindex].x;
            this["item" + starindex + "_1"].y = this.fightGroupsxy[starindex].y;
            this["item" + finalindex + "_1"].x = this.fightGroupsxy[finalindex].x;
            this["item" + finalindex + "_1"].y = this.fightGroupsxy[finalindex].y;
            this["item" + starindex + "_1"].visible = true;
            this["item" + finalindex + "_1"].visible = true;
        }
        this.updatePower();
    };
    FightReadyView.prototype.updateInfo = function (index) {
        this.index = index;
        this.setHeroGroupInfo();
        this.updateList();
    };
    /**
     * 设置英雄数据
     * 根据index来设置不同英雄的数据
     */
    FightReadyView.prototype.setHeroGroupInfo = function () {
        this.heroGroups = [];
        this.heroGroups = HeroBagData.inst().GetHeroGroupInfoByIndex(this.index, 0);
    };
    FightReadyView.prototype.updateList = function () {
        this.list.setVirtual();
        this.list.itemRenderer = this.listItemRenderer.bind(this);
        this.list.callbackThisObj = this;
        this.list.numItems = this.heroGroups.length;
        /*
        this.list.removeChildrenToPool();
        for(let i=0 ; i < this.heroGroups.length ;i++) {
            let item:fairygui.GComponent = this.list.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
            let items = new ItemBase(item,this,2);
            items.setItemData(this.heroGroups[i][1].heroID,this.heroGroups[i][1].race,this.heroGroups[i][1].starMax);
            items.setNumber(this.heroGroups[i][1].level);

            let isInFight:boolean = false;
            for(let j=0; j<this.fightGroups.length; j++) {
                if(this.fightGroups[j].index == this.heroGroups[i][0]) {
                    items.setGou(true);
                    isInFight = true;
                    item.data = {index:this.heroGroups[i][0],info:this.heroGroups[i][1],isChoose:true};
                } else {
                    if(isInFight == false) {
                        items.setGou(false);
                        item.data = {index:this.heroGroups[i][0],info:this.heroGroups[i][1],isChoose:false};
                    }
                }
            }
            if(this.fightGroups.length == 0) {
                item.data = {index:this.heroGroups[i][0],info:this.heroGroups[i][1],isChoose:false};
            }
        }*/
    };
    FightReadyView.prototype.listItemRenderer = function (i, item) {
        var items = new ItemBase(item.asCom, this, 2);
        items.setItemData(this.heroGroups[i][1].heroID, this.heroGroups[i][1].race, this.heroGroups[i][1].starMax);
        items.setNumber(this.heroGroups[i][1].level);
        var isInFight = false;
        for (var j = 0; j < this.fightGroups.length; j++) {
            if (this.fightGroups[j].index == this.heroGroups[i][0]) {
                items.setGou(true);
                isInFight = true;
                item.data = { index: this.heroGroups[i][0], info: this.heroGroups[i][1], isChoose: true };
            }
            else {
                if (isInFight == false) {
                    items.setGou(false);
                    item.data = { index: this.heroGroups[i][0], info: this.heroGroups[i][1], isChoose: false };
                }
            }
        }
        if (this.fightGroups.length == 0) {
            item.data = { index: this.heroGroups[i][0], info: this.heroGroups[i][1], isChoose: false };
        }
    };
    FightReadyView.prototype.updatezhenfaIcon = function () {
        var icon = this.typeCom.getChild("icon").asLoader;
        var txt = this.typeCom.getChild("txt").asTextField;
        var fightIDGroup = [];
        for (var i = 0; i < this.fightGroups.length; i++) {
            fightIDGroup.push(this.fightGroups[i].info.heroID);
        }
        var id = FightData.inst().Getzhenfa(fightIDGroup);
        if (id == 0) {
            txt.visible = true;
        }
        else {
            txt.visible = false;
        }
        this.setLoaderUrl(icon, "ui://RaceHelpView/" + FightData.inst().GetzhenfaImg(id));
    };
    FightReadyView.prototype.fighthandle = function () {
        var _this = this;
        var nowfightIndexGroups = [];
        for (var i = 0; i < this.fightIndexGroups.length; i++) {
            nowfightIndexGroups.push(this.fightIndexGroups[i]);
        }
        if (FightReadyView.chooseID != -1) {
            if (nowfightIndexGroups.length > 6) {
                nowfightIndexGroups.pop();
            }
            nowfightIndexGroups.push(FightReadyView.chooseID);
        }
        if (this.fighttype == 1) {
            net.hookBattle(nowfightIndexGroups, function (report, dropMap) {
                _this.close();
                _this.localStorage_Group();
                ak.EventMgr.dispatch(GameEvent.fightRpcComplete);
                ak.FairyGUI.open(["FightView", report, dropMap]);
            }, this);
        }
        else if (this.fighttype == 2) {
            net.testBattle(this.id, nowfightIndexGroups, function (report, dropMap) {
                _this.close();
                _this.localStorage_Group();
                ak.EventMgr.dispatch(GameEvent.fightRpcComplete);
                ak.FairyGUI.open(["FightView", report, dropMap, 5]);
            }, this);
        }
        else if (this.fighttype == 3) {
            net.towerBattle(nowfightIndexGroups, function (report, dropMap) {
                _this.close();
                _this.localStorage_Group();
                ak.EventMgr.dispatch(GameEvent.fightRpcComplete);
                ak.FairyGUI.open(["FightView", report, dropMap]);
            }, this);
        }
        else if (this.fighttype == 4) {
            if (this.num == 1) {
                net.bossBattle(this.id, 1, nowfightIndexGroups, 0, function (report, dropMap, consumeHp, jifen) {
                    var info = { consumeHp: consumeHp, jifen: jifen };
                    var type = 1;
                    _this.close();
                    _this.localStorage_Group();
                    ak.EventMgr.dispatch(GameEvent.fightRpcComplete);
                    ak.FairyGUI.open(["FightView", report, dropMap, 1, info]);
                }, this);
            }
            else {
                net.bossBattle(this.id, this.num, nowfightIndexGroups, 1, function (dropMap, consumeHp, jifen) {
                    _this.close();
                    _this.localStorage_Group();
                    ak.EventMgr.dispatch(GameEvent.fightRpcComplete);
                    ak.FairyGUI.open(["SweepOverView", dropMap, consumeHp, jifen]);
                }, this);
            }
        }
        else if (this.fighttype == 5) {
            var isNull = 0;
            for (var i = 0; i < nowfightIndexGroups.length - 1; i++) {
                if (nowfightIndexGroups[i] == -1) {
                    isNull++;
                }
            }
            if (isNull == nowfightIndexGroups.length - 1) {
                TipsViewSystem.show("设置竞技场防守阵容");
            }
            else {
                net.stageSetDefCardArr(nowfightIndexGroups, function () {
                    if (ak.FairyGUI.getOpenUI("Arena1View").length > 0) {
                        _this.close();
                    }
                    else {
                        _this.close();
                        ak.FairyGUI.open(["Arena1View"]);
                    }
                }, this);
            }
        }
        else if (this.fighttype == 6) {
            net.friendPK(this.id, nowfightIndexGroups, function (report) {
                _this.close();
                _this.localStorage_Group();
                ak.EventMgr.dispatch(GameEvent.fightRpcComplete);
                ak.FairyGUI.open(["FightView", report, []]);
            }, this);
        }
        else if (this.fighttype == 7) {
            net.stageBatter(this.id, nowfightIndexGroups, function (report, dropMap, jifenMap) {
                _this.close();
                _this.localStorage_Group();
                ak.EventMgr.dispatch(GameEvent.fightRpcComplete);
                var info = {};
                var team1_head = report.team1.head;
                var team2_head = report.team2.head;
                var team1_level = report.team1.level;
                var team2_level = report.team2.level;
                var team1_nickname = report.team1.nickname;
                var team2_nickname = report.team2.nickname;
                var team1_jifen = jifenMap.userID;
                var team2_jifen = jifenMap.enemyUserID;
                info = { team1_head: team1_head, team2_head: team2_head, team1_level: team1_level, team2_level: team2_level,
                    team1_nickname: team1_nickname, team2_nickname: team2_nickname, team1_jifen: team1_jifen, team2_jifen: team2_jifen };
                ak.FairyGUI.open(["FightView", report, dropMap, 2, info]);
            }, this);
        }
        else if (this.fighttype == 8) {
            net.hitUnionBoss(this.id, nowfightIndexGroups, function (report, dropMap) {
                _this.close();
                _this.localStorage_Group();
                ak.EventMgr.dispatch(GameEvent.fightRpcComplete);
                ak.FairyGUI.open(["FightView", report, dropMap, 4]);
            }, this);
        }
    };
    /**存储本地数据 */
    FightReadyView.prototype.localStorage_Group = function () {
        this.localStorage = [];
        for (var i = 0; i < this.fightIndexGroups.length; i++) {
            var isfirst = true;
            for (var j = 0; j < this.fightGroups.length; j++) {
                if (this.fightIndexGroups[i] == this.fightGroups[j].index) {
                    if (isfirst)
                        this.localStorage.push(this.fightGroups[j].info.id);
                    isfirst = false;
                }
            }
            if (isfirst)
                this.localStorage.push(-1);
        }
        if (this.fighttype == 1) {
            GameLocalStorage.save(GameLocalStorage.explorationFightGroup, this.localStorage.join(','));
            GameLocalStorage.save(GameLocalStorage.explorationFightWeaponID, "" + FightReadyView.chooseID);
        }
        else if (this.fighttype == 2) {
            GameLocalStorage.save(GameLocalStorage.testFightGroup, this.localStorage.join(','));
            GameLocalStorage.save(GameLocalStorage.testFightWeaponID, "" + FightReadyView.chooseID);
        }
        else if (this.fighttype == 3) {
            GameLocalStorage.save(GameLocalStorage.towerFightGroup, this.localStorage.join(','));
            GameLocalStorage.save(GameLocalStorage.towerFightWeaponID, "" + FightReadyView.chooseID);
        }
        else if (this.fighttype == 4) {
            GameLocalStorage.save(GameLocalStorage.friendBossFightGroup, this.localStorage.join(','));
            GameLocalStorage.save(GameLocalStorage.friendBossFightWeaponID, "" + FightReadyView.chooseID);
        }
        else if (this.fighttype == 6) {
            GameLocalStorage.save(GameLocalStorage.friendPKFightGroup, this.localStorage.join(','));
            GameLocalStorage.save(GameLocalStorage.friendPKFightWeaponID, "" + FightReadyView.chooseID);
        }
        else if (this.fighttype == 7) {
            GameLocalStorage.save(GameLocalStorage.arenaChallengeRivalFightGroup, this.localStorage.join(','));
            GameLocalStorage.save(GameLocalStorage.arenaChallengeRivalFightWeaponID, "" + FightReadyView.chooseID);
        }
        else if (this.fighttype == 8) {
            GameLocalStorage.save(GameLocalStorage.guildbossFightGroup, this.localStorage.join(','));
            GameLocalStorage.save(GameLocalStorage.guildbossFightWeaponID, "" + FightReadyView.chooseID);
        }
    };
    /**获得本地存储 */
    FightReadyView.prototype.GetLocalStorage_Group = function () {
        var fightGroup = [];
        var key = "";
        var key2 = "";
        if (this.fighttype == 1) {
            key = GameLocalStorage.explorationFightGroup;
            key2 = GameLocalStorage.explorationFightWeaponID;
        }
        else if (this.fighttype == 2) {
            key = GameLocalStorage.testFightGroup;
            key2 = GameLocalStorage.testFightWeaponID;
        }
        else if (this.fighttype == 3) {
            key = GameLocalStorage.towerFightGroup;
            key2 = GameLocalStorage.towerFightWeaponID;
        }
        else if (this.fighttype == 4) {
            key = GameLocalStorage.friendBossFightGroup;
            key2 = GameLocalStorage.friendBossFightWeaponID;
        }
        else if (this.fighttype == 6) {
            key = GameLocalStorage.friendPKFightGroup;
            key2 = GameLocalStorage.friendPKFightWeaponID;
        }
        else if (this.fighttype == 7) {
            key = GameLocalStorage.arenaChallengeRivalFightGroup;
            key2 = GameLocalStorage.arenaChallengeRivalFightWeaponID;
        }
        else if (this.fighttype == 8) {
            key = GameLocalStorage.guildbossFightGroup;
            key2 = GameLocalStorage.guildbossFightWeaponID;
        }
        FightReadyView.chooseID = Number(GameLocalStorage.load(key2));
        var str = GameLocalStorage.load(key);
        if (this.fighttype != 5) {
            if (str != "" && str != null) {
                fightGroup = str.split(',');
                this.fightGroups = [];
                this.fightIndexGroups = [];
            }
        }
        else {
            if (MyData.user.json.stage.upCardIDArr.length != 0) {
                for (var i = 0; i < MyData.user.json.stage.upCardIDArr.length; i++) {
                    if (i < 6) {
                        fightGroup.push(MyData.user.json.stage.upCardIDArr[i]);
                    }
                }
                this.fightGroups = [];
                this.fightIndexGroups = [];
            }
            else {
                fightGroup = [];
            }
        }
        for (var i = 0; i < fightGroup.length; i++) {
            var index = HeroBagData.inst().GetIndexByid(fightGroup[i]);
            if (index != -1) {
                var info = HeroBagData.inst().GetcardByIndex(index)[1];
                this.fightGroups.push({ index: index, info: info, isChoose: true });
            }
            this.fightIndexGroups.push(index);
        }
        this.updatePower();
    };
    FightReadyView.prototype.static6itemInfo = function () {
        for (var i = 0; i < this.fightIndexGroups.length; i++) {
            if (this.fightIndexGroups[i] != -1) {
                var info = {};
                for (var j = 0; j < this.fightGroups.length; j++) {
                    if (this.fightIndexGroups[i] == this.fightGroups[j].index) {
                        info = this.fightGroups[j].info;
                    }
                }
                var items2 = new ItemBase(this["item" + i + "_1"], this, 2);
                items2.setItemData(info.heroID, info.race, info.starMax);
                items2.setNumber(info.level);
                this["item" + i + "_1"].visible = true;
                this["item" + i + "_1"].data = { index: this.fightIndexGroups[i], info: info };
            }
            else {
                this["item" + i + "_1"].visible = false;
            }
        }
    };
    /**更新战斗力 */
    FightReadyView.prototype.updatePower = function () {
        var allpower = 0;
        for (var i = 0; i < this.fightIndexGroups.length; i++) {
            if (this.fightIndexGroups[i] != -1) {
                allpower += Formula.getCardIndexPower(this.fightIndexGroups[i]);
            }
        }
        this.power.text = "" + allpower;
    };
    /**交换位置
     * (新手引导添加)
     */
    FightReadyView.prototype.changeIndex = function (star, finaly) {
        if (this.fightIndexGroups[star] == -1 || this.fightIndexGroups[finaly] == -1) {
            return;
        }
        else {
            this.ishaveItem(star, finaly);
        }
    };
    /**神器id */
    FightReadyView.chooseID = -1;
    return FightReadyView;
}(ak.EasyUI));
__reflect(FightReadyView.prototype, "FightReadyView");
//数据
var MyData = (function () {
    function MyData() {
    }
    MyData.serverDomain = ""; //区服地址
    MyData.serverPort = 0; //区服端口
    MyData.uid = ""; //平台uid
    MyData.serverID = 1; //区服ID
    MyData.timeBase = 0; //服务端与本地时间差（秒），本地时间加上timeBase等于服务端时间
    MyData.worldChatArr = []; //世界聊天信息数组
    MyData.worldChatUnreadCount = 0; //世界聊天信息未读数量
    MyData.recruitChatArr = []; //招募聊天信息数组
    MyData.recruitChatUnreadCount = 0; //招募聊天信息未读数量
    MyData.unionChatArr = []; //公会聊天信息数组
    MyData.unionChatUnreadCount = 0; //公会聊天信息未读数量
    return MyData;
}());
__reflect(MyData.prototype, "MyData");
//游戏类
var MyGame = (function (_super) {
    __extends(MyGame, _super);
    function MyGame() {
        var _this = _super.call(this) || this;
        //游戏层级
        _this.mainCityLayer = new egret.DisplayObjectContainer(); //主城界面层
        _this.uiLayer = new egret.DisplayObjectContainer(); //界面层1（英雄、背包、公会）
        _this.uiLayer3 = new egret.DisplayObjectContainer(); //界面层3（探险挂机界面）
        _this.uiLayer4 = new egret.DisplayObjectContainer(); //界面层4（底部主菜单）
        _this.uiLayer2_1 = new egret.DisplayObjectContainer(); //界面层2_1（低于玩家信息界面）
        _this.uiLayer2 = new egret.DisplayObjectContainer(); //界面层2（玩家信息界面）
        _this.uiLayer2_2 = new egret.DisplayObjectContainer(); //界面层2_2（高于玩家信息界面）
        _this.tipLayer = new egret.DisplayObjectContainer(); //提示层（各种弹出提示）
        _this.guideLayer = new egret.DisplayObjectContainer(); //新手引导层
        _this.loadingLayer = new egret.DisplayObjectContainer(); //加载界面层（loading动画）
        _this.topLayer = new egret.DisplayObjectContainer(); //最高层（点击光圈动画）
        //进入游戏
        _this.firstLogin = false;
        _this.addEventListener(egret.Event.ADDED_TO_STAGE, _this.startApp, _this);
        return _this;
        // ak.EventMgr.addEventListener(GameEvent.guide_myPowerFull,()=>{
        // 	let scene=BattleScene.sceneArr[0];
        // 	scene.pause();
        // },this);
    }
    //妈蛋用这个方法来判断是否app还是win端
    MyGame.prototype.startApp = function () {
        // console.log("aff",MyConfig.loginType)
        // if(MyConfig.loginType == 0){
        // 	egret.Tween.get(MyGame.inst.topLayer).to({}, 10).call(()=>{
        // 		MyGame.inst.start()
        // 	});
        // }
        egret.ExternalInterface.addCallback("isAppCall", function (msg) {
            console.log("平台=", msg);
            if (msg == "ios") {
                MyConfig.loginType = 3;
            }
            else {
                MyConfig.loginType = 1;
            }
            egret.Tween.removeTweens(MyGame.inst.topLayer);
            MyGame.inst.start();
        });
        egret.ExternalInterface.call("isApp", "");
        egret.ExternalInterface.addCallback("apkVersion", function (msg) {
            MyConfig.appVersion = msg;
        });
        egret.ExternalInterface.addCallback("restartApp", function (msg) {
            window.location.reload();
            window.location.href = window.location.href; // + Math.random()
        });
        egret.ExternalInterface.addCallback("SdkToJs_init", function (msg) {
            // MyGame.inst.sdkinitComplele = true
        });
    };
    //启动游戏
    MyGame.prototype.start = function () {
        var _this = this;
        //初始化ak库
        console.log("启动游戏");
        ak.debug = MyConfig.debug;
        ak.FariyGUI_GLoader.staticResRoot = MyConfig.staticResRoot;
        ak.ResMgr.start(MyConfig.ver);
        ak.EventMgr.start();
        ak.FairyGUI.start(this.stage);
        ak.SoundMgr.inst.musicVolume = 0.5;
        if (MyConfig.openClickSound) {
            ak.FairyGUI.clickSoundUrl = "resource/sound/dianji.mp3"; //默认点击音效
        }
        fairygui.UIConfig.defaultFont = "Microsoft YaHei";
        //点击时出现的圈
        this.stage.addEventListener(egret.TouchEvent.TOUCH_BEGIN, function (e) {
            var tt = new ClickCircle();
            tt.x = e.stageX;
            tt.y = e.stageY;
            _this.topLayer.addChild(tt);
        }, this, true, 999999);
        //添加游戏层级
        this.addChild(this.mainCityLayer);
        this.addChild(this.uiLayer);
        this.addChild(this.uiLayer3);
        this.addChild(this.uiLayer4);
        this.addChild(this.uiLayer2_1);
        this.addChild(this.uiLayer2);
        this.addChild(this.uiLayer2_2);
        this.addChild(this.tipLayer);
        this.addChild(this.guideLayer);
        this.addChild(this.loadingLayer);
        this.addChild(this.topLayer);
        //初始化fairygui
        fairygui.UIObjectFactory.setLoaderExtension(ak.FariyGUI_GLoader);
        this.addChild(fairygui.GRoot.inst.displayObject);
        // fairygui.UIPackage.addPackage("common");//添加公共资源包
        //获取url参数
        this.getUrlParam();
        //音效
        SetupView.soundSetup();
        //注册数据更新事件
        net.regDataUpdateEvent();
        this.addEventListener(egret.Event.ENTER_FRAME, this.onEnterFrame, this);
        ak.EventMgr.addEventListener(ak.Event.KEY_PRESS, function (e) {
            if (e.params.key == "`") {
                // ak.FairyGUI.open(["GMorderView"]);
                // GMorderViewSystem.show();
            }
            else if (e.params.key == "-") {
                // if(BattleScene.sceneArr.length>0)
                // {
                // 		let scene=BattleScene.sceneArr[0];
                // 		scene.timeScale=2;
                // }
                // //测试战报
                // MyClient.inst.rpc(["testBattle"],(msg)=>{
                // 	while(BattleScene.sceneArr.length>0)
                // 	{
                // 		BattleScene.sceneArr[0].destroy();
                // 	}
                // 	let report=msg[1];
                // 	new BattleScene().addToParent(this.guideLayer).start(report);
                // },this);
            }
        }, this);
        //加载第1波配置
        console.log("加载第1波配置");
        // let toaltext = "你们你妈235这久游堂些首人，都是微沙₁雕吗" 
        // let toaltext2 = SensitiveWordFilter.inst.replaceSensitiveWord(toaltext)
        // console.log("===",toaltext)
        // console.log("===",toaltext2)
        ak.FairyGUI.open(["ChooseServerView"]);
        var jsonTabCfg = RES.getRes("json_table_json");
        ak.JsonTableMgr.load(MyConfig.jsonTableRoot, jsonTabCfg.first, function () {
            HotUpdate.inst.checkIsNeedUpdate(function (res) {
                if (res == 0) {
                    _this.starGame();
                }
            }, _this);
        }, this, false);
        egret.ExternalInterface.call("getNetWorkIp", "");
        egret.ExternalInterface.addCallback("NetWorkIp", function (msg) {
            MyData.deviceIp = msg;
        });
    };
    MyGame.prototype.starGame = function () {
        var _this = this;
        if (MyData.serverDomain == "") {
            this.getServerList(function () {
                _this.loginSdk();
            }, this);
        }
        else {
            //进入游戏
            this.enterGame();
        }
        this.stage.removeChild(Main.loadingView);
    };
    MyGame.prototype.loginSdk = function () {
        var _this = this;
        if (MyConfig.loginType == 0) {
            this.getAccount(function () {
                // ak.FairyGUI.open(["ChooseServerView"]);
                ak.EventMgr.dispatch(GameEvent.openChooseServerView);
            }, this);
        }
        else if (MyConfig.loginType == 1 || MyConfig.loginType == 3 || MyConfig.loginType == 4) {
            CPSDK.inst.initAppSdk(function (userInfo) { }, this);
            egret.setTimeout(function () {
                CPSDK.inst.login(function () {
                    console.log("SDK登录成功");
                    _this.getAccount(function () {
                        ak.EventMgr.dispatch(GameEvent.openChooseServerView);
                    }, _this);
                });
            }, this, 1500);
        }
        else if (MyConfig.loginType == 2) {
            CPSDK.inst.initH5Sdk(function (userInfo) {
            }, this);
            CPSDK.inst.Login_h5(function (res) {
                ak.EventMgr.dispatch(GameEvent.openChooseServerView);
            }, this);
        }
    };
    MyGame.prototype.enterGame = function () {
        var _this = this;
        if (!this.firstLogin) {
            PreloadSystem.inst.showBigLoading(true);
        }
        this.firstLogin = true;
        ak.ResMgr.loadGroup("common", function () {
            //添加公共资源包
            fairygui.UIPackage.addPackage("common");
            //加载第2波配置文件
            _this.loadJsonTableBySecond(function () {
                //新手引导开始
                Guide.inst.start();
                //显示主界面
                ak.FairyGUI.open(["MainUI"], [function (ui) {
                        ak.log("open MainUI complete");
                    }, _this]);
                TopViewSystem.show();
            }, _this);
        }, this);
    };
    //加载第2波配置文件
    MyGame.prototype.loadJsonTableBySecond = function (callback, thisObj) {
        if (MyConfig.useClientTables) {
            ak.JsonTableMgr.loadBigTable(MyConfig.jsonTableRoot, MyConfig.clientTablesUrl, function () {
                callback.call(thisObj);
            }, this, true);
        }
        else {
            var jsonTabCfg = RES.getRes("json_table_json");
            ak.JsonTableMgr.load(MyConfig.jsonTableRoot, jsonTabCfg.second, function () {
                callback.call(thisObj);
            }, this, true);
        }
    };
    MyGame.prototype.onEnterFrame = function () {
        MyClient.inst.sendHeartbeat();
    };
    //获取区服列表
    MyGame.prototype.getServerList = function (callback, thisObj) {
        var _this = this;
        PreloadSystem.inst.showSmallLoading(true);
        var serverList = MyConfig.serverListJsonUrl;
        if (MyConfig.loginType == 0 || MyConfig.loginType == 4) {
            serverList = MyConfig.LocalserverListJsonUrl;
        }
        console.log("服务器列表地址2：", serverList);
        new ak.Form(serverList, //+"?"+new Date().getTime(),
        "get", {}, 
        //onSucc
        function (data) {
            MyData.serverList = ak.json_decode(data);
            PreloadSystem.inst.showSmallLoading(false);
            callback.call(thisObj);
        }, 
        //onError
        function () {
            ak.log("getServerList error");
            var timer = new egret.Timer(1000, 1);
            timer.once(egret.TimerEvent.TIMER_COMPLETE, function () {
                _this.getServerList(callback, thisObj);
            }, _this);
            timer.start();
        }, this, true);
    };
    /**
     * 获取账号服
     */
    MyGame.prototype.getAccount = function (callback, thisObj) {
        PreloadSystem.inst.showSmallLoading(true);
        var uid = MyData.uid;
        var accountUrl = MyConfig.accountJsonUrl;
        if (MyConfig.loginType == 0 || MyConfig.loginType == 4) {
            accountUrl = MyConfig.LocalaccountJsonUrl;
            uid = "test";
        }
        console.log("获取帐号服地址3：", accountUrl);
        new ak.Form(accountUrl, //+"?"+new Date().getTime(),
        "post", { uid: uid }, function (data) {
            console.log("数据格式：data = ", data);
            MyData.accountList = ak.json_decode(data);
            MyData.accountList = MyData.accountList; // || []
            PreloadSystem.inst.showSmallLoading(false);
            callback.call(thisObj);
        }, function () {
            ak.log("getAccount error");
            // let timer=new egret.Timer(1000,1);
            // timer.once(egret.TimerEvent.TIMER_COMPLETE,()=>{
            // 	this.getServerList(callback,thisObj);
            // },this);
            // timer.start();
        }, this);
    };
    //获取url参数
    MyGame.prototype.getUrlParam = function () {
        var uid = ak.get_html_url_var("uid");
        MyData.uid = uid;
        var serverID = ak.get_html_url_var("serverID");
        if (serverID != "") {
            MyData.serverID = parseInt(serverID);
        }
        var domain = ak.get_html_url_var("domain");
        if (domain != "") {
            MyData.serverDomain = domain;
        }
        var port = ak.get_html_url_var("port");
        if (port != "") {
            MyData.serverPort = parseInt(port);
        }
    };
    MyGame.inst = new MyGame();
    return MyGame;
}(egret.DisplayObjectContainer));
__reflect(MyGame.prototype, "MyGame");
var DebugPlatform = (function () {
    function DebugPlatform() {
    }
    DebugPlatform.prototype.getUserInfo = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, { nickName: "username" }];
            });
        });
    };
    DebugPlatform.prototype.login = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/];
            });
        });
    };
    return DebugPlatform;
}());
__reflect(DebugPlatform.prototype, "DebugPlatform", ["Platform"]);
if (!window.platform) {
    window.platform = new DebugPlatform();
}
var ak;
(function (ak) {
    var Buf = (function () {
        function Buf(blockSize) {
            if (blockSize === void 0) { blockSize = 512; }
            this.little_endian = true;
            this.mLength = 0;
            this.mPoint = 0;
            this.mBlockSize = blockSize;
            this.mMaxBytes = blockSize;
            this.mBytes = new ArrayBuffer(blockSize);
            this.mBuf = new DataView(this.mBytes);
        }
        Buf.prototype.writeUint32String = function (str) {
            var tmp = new Buf();
            tmp.writeString(str);
            var len = tmp.size();
            this.writeUint32(len);
            this.writeString(str);
        };
        Buf.prototype.readUint32String = function () {
            try {
                var len = this.readUint32();
                return this.readString(len);
            }
            catch (e) {
                throw "readUint32String error";
            }
        };
        Buf.prototype.writeString = function (str) {
            str = str + "";
            var len = str.length;
            for (var i = 0; i < len; i++) {
                var c = str.charCodeAt(i);
                if (c <= 0x7F) {
                    this.writeUint8(c);
                }
                else if (c <= 0x7FF) {
                    this.writeUint8(0xC0 | (c >> 6));
                    this.writeUint8(0x80 | (c & 63));
                }
                else if (c <= 0xFFFF) {
                    this.writeUint8(0xE0 | (c >> 12));
                    this.writeUint8(0x80 | ((c >> 6) & 63));
                    this.writeUint8(0x80 | (c & 63));
                }
                else {
                    this.writeUint8(0xF0 | (c >> 18));
                    this.writeUint8(0x80 | ((c >> 12) & 63));
                    this.writeUint8(0x80 | ((c >> 6) & 63));
                    this.writeUint8(0x80 | (c & 63));
                }
            }
            this.writeUint8(0);
        };
        Buf.prototype.readString = function (len) {
            var value = "";
            var max = this.mPoint + len;
            var spareSize = this.mLength - this.mPoint;
            if (spareSize < len)
                throw "readString error";
            var c = 0, c2 = 0, c3 = 0;
            while (this.mPoint < max) {
                c = this.mBuf.getUint8(this.mPoint++);
                if (c < 0x80) {
                    value += String.fromCharCode(c);
                }
                else if (c < 0xE0) {
                    value += String.fromCharCode(((c & 0x3F) << 6) | (this.mBuf.getUint8(this.mPoint++) & 0x7F));
                }
                else if (c < 0xF0) {
                    c2 = this.mBuf.getUint8(this.mPoint++);
                    value += String.fromCharCode(((c & 0x1F) << 12) | ((c2 & 0x7F) << 6) | (this.mBuf.getUint8(this.mPoint++) & 0x7F));
                }
                else {
                    c2 = this.mBuf.getUint8(this.mPoint++);
                    c3 = this.mBuf.getUint8(this.mPoint++);
                    value += String.fromCharCode(((c & 0x0F) << 18) | ((c2 & 0x7F) << 12) | ((c3 << 6) & 0x7F) | (this.mBuf.getUint8(this.mPoint++) & 0x7F));
                }
            }
            return value;
        };
        Buf.prototype.writeDouble = function (num) {
            var dataSize = 8;
            this.resize(this.mPoint + dataSize);
            this.mBuf.setFloat64(this.mPoint, num, this.little_endian);
            this.mPoint += dataSize;
            if (this.mPoint > this.mLength)
                this.mLength = this.mPoint;
        };
        Buf.prototype.writeFloat = function (num) {
            var dataSize = 4;
            this.resize(this.mPoint + dataSize);
            this.mBuf.setFloat32(this.mPoint, num, this.little_endian);
            this.mPoint += dataSize;
            if (this.mPoint > this.mLength)
                this.mLength = this.mPoint;
        };
        Buf.prototype.writeUint32 = function (num) {
            var dataSize = 4;
            this.resize(this.mPoint + dataSize);
            this.mBuf.setUint32(this.mPoint, num, this.little_endian);
            this.mPoint += dataSize;
            if (this.mPoint > this.mLength)
                this.mLength = this.mPoint;
        };
        Buf.prototype.writeInt32 = function (num) {
            var dataSize = 4;
            this.resize(this.mPoint + dataSize);
            this.mBuf.setInt32(this.mPoint, num, this.little_endian);
            this.mPoint += dataSize;
            if (this.mPoint > this.mLength)
                this.mLength = this.mPoint;
        };
        Buf.prototype.writeUint16 = function (num) {
            var dataSize = 2;
            this.resize(this.mPoint + dataSize);
            this.mBuf.setUint16(this.mPoint, num, this.little_endian);
            this.mPoint += dataSize;
            if (this.mPoint > this.mLength)
                this.mLength = this.mPoint;
        };
        Buf.prototype.writeInt16 = function (num) {
            var dataSize = 2;
            this.resize(this.mPoint + dataSize);
            this.mBuf.setInt16(this.mPoint, num, this.little_endian);
            this.mPoint += dataSize;
            if (this.mPoint > this.mLength)
                this.mLength = this.mPoint;
        };
        Buf.prototype.writeUint8 = function (num) {
            var dataSize = 1;
            this.resize(this.mPoint + dataSize);
            this.mBuf.setUint8(this.mPoint, num);
            this.mPoint += dataSize;
            if (this.mPoint > this.mLength)
                this.mLength = this.mPoint;
        };
        Buf.prototype.writeInt8 = function (num) {
            var dataSize = 1;
            this.resize(this.mPoint + dataSize);
            this.mBuf.setInt8(this.mPoint, num);
            this.mPoint += dataSize;
            if (this.mPoint > this.mLength)
                this.mLength = this.mPoint;
        };
        Buf.prototype.readDouble = function () {
            var dataSize = 8;
            var spareSize = this.mLength - this.mPoint;
            if (spareSize < dataSize)
                throw "readDouble error";
            var val = this.mBuf.getFloat64(this.mPoint, this.little_endian);
            this.mPoint += dataSize;
            return val;
        };
        Buf.prototype.readFloat = function () {
            var dataSize = 4;
            var spareSize = this.mLength - this.mPoint;
            if (spareSize < dataSize)
                throw "readFloat error";
            var val = this.mBuf.getFloat32(this.mPoint, this.little_endian);
            this.mPoint += dataSize;
            return val;
        };
        Buf.prototype.readUint32 = function () {
            var dataSize = 4;
            var spareSize = this.mLength - this.mPoint;
            if (spareSize < dataSize)
                throw "readUint32 error";
            var val = this.mBuf.getUint32(this.mPoint, this.little_endian);
            this.mPoint += dataSize;
            return val;
        };
        Buf.prototype.readInt32 = function () {
            var dataSize = 4;
            var spareSize = this.mLength - this.mPoint;
            if (spareSize < dataSize)
                throw "readInt32 error";
            var val = this.mBuf.getInt32(this.mPoint, this.little_endian);
            this.mPoint += dataSize;
            return val;
        };
        Buf.prototype.readUint16 = function () {
            var dataSize = 2;
            var spareSize = this.mLength - this.mPoint;
            if (spareSize < dataSize)
                throw "readUint16 error";
            var val = this.mBuf.getUint16(this.mPoint, this.little_endian);
            this.mPoint += dataSize;
            return val;
        };
        Buf.prototype.readInt16 = function () {
            var dataSize = 2;
            var spareSize = this.mLength - this.mPoint;
            if (spareSize < dataSize)
                throw "readInt16 error";
            var val = this.mBuf.getInt16(this.mPoint, this.little_endian);
            this.mPoint += dataSize;
            return val;
        };
        Buf.prototype.readUint8 = function () {
            var dataSize = 1;
            var spareSize = this.mLength - this.mPoint;
            if (spareSize < dataSize)
                throw "readUint8 error";
            var val = this.mBuf.getUint8(this.mPoint);
            this.mPoint += dataSize;
            return val;
        };
        Buf.prototype.readInt8 = function () {
            var dataSize = 1;
            var spareSize = this.mLength - this.mPoint;
            if (spareSize < dataSize)
                throw "readUint8 error";
            var val = this.mBuf.getInt8(this.mPoint);
            this.mPoint += dataSize;
            return val;
        };
        Buf.prototype.setPos = function (pos) {
            this.mPoint = pos;
            this.resize(this.mPoint);
            if (this.mPoint > this.mLength)
                this.mLength = this.mPoint;
        };
        Buf.prototype.getPos = function () {
            return this.mPoint;
        };
        Buf.prototype.size = function () {
            return this.mLength;
        };
        Buf.prototype.getData = function () {
            return this.mBytes;
        };
        Buf.prototype.resize = function (size) {
            if (size < this.mMaxBytes)
                return;
            var c = Math.floor(size / this.mBlockSize);
            if ((size % this.mBlockSize) != 0)
                ++c;
            this.mMaxBytes = c * this.mBlockSize;
            var bytes = new ArrayBuffer(this.mMaxBytes);
            var buf2 = new DataView(bytes);
            for (var i = 0; i < this.mLength; ++i) {
                var ch = this.mBuf.getUint8(i);
                buf2.setUint8(i, ch);
            }
            this.mBytes = bytes;
            this.mBuf = new DataView(this.mBytes);
        };
        Buf.prototype.serialize = function (data) {
            var buf = this;
            var typeStr = (String)(typeof data);
            if (typeStr == "object") {
                if (data instanceof Array) {
                    typeStr = "Array";
                }
                else {
                    typeStr = "Object";
                }
            }
            switch (typeStr) {
                case "number":
                    {
                        buf.writeUint8(2);
                        buf.writeDouble(data);
                        break;
                    }
                case "string":
                    {
                        buf.writeUint8(1);
                        buf.writeUint32String(data);
                        break;
                    }
                case "Array":
                    {
                        buf.writeUint8(3 + 11);
                        var arr = data;
                        var c = arr.length;
                        buf.writeUint32(c);
                        for (var i = 0; i < c; ++i) {
                            var curVar = arr[i];
                            if (typeof curVar == "undefined" || curVar == null) {
                                throw "包含的数组存在不连续";
                            }
                            this.serialize(curVar);
                        }
                        c = 0;
                        buf.writeUint32(c);
                        break;
                    }
                case "Object":
                    {
                        buf.writeUint8(3 + 12);
                        var dict = data;
                        buf.writeUint32(0);
                        var c = 0;
                        for (var key in dict)
                            ++c;
                        buf.writeUint32(c);
                        for (var key in dict) {
                            var curVar = dict[key];
                            buf.writeUint32String(key);
                            this.serialize(curVar);
                        }
                        break;
                    }
                default:
                    {
                        throw "不支持的数据格式";
                    }
            }
            return true;
        };
        Buf.prototype.unserialize = function (first) {
            (first === void 0) && (first = true);
            var buf = this;
            if (first) {
                if (buf.size() == 0)
                    return null;
                buf.setPos(0);
            }
            try {
                var varType = 0;
                varType = buf.readUint8();
                switch (varType) {
                    case 0:
                        {
                            return null;
                        }
                    case 2:
                        {
                            var num = buf.readDouble();
                            return num;
                        }
                    case 1:
                        {
                            var str = buf.readUint32String();
                            str = str.replace(/\0/g, "");
                            return str;
                        }
                    case (3 + 11):
                        {
                            var c = 0;
                            var arr = new Array();
                            c = buf.readUint32();
                            for (var i = 0; i < c; ++i) {
                                arr.push(this.unserialize(false));
                            }
                            c = buf.readUint32();
                            return arr;
                        }
                    case (3 + 12):
                        {
                            var c = 0;
                            var dict = new Object();
                            c = buf.readUint32();
                            for (i = 0; i < c; ++i) {
                                var numKey = buf.readUint32();
                                var val = this.unserialize(false);
                                dict[numKey] = val;
                            }
                            c = buf.readUint32();
                            for (var i = 0; i < c; ++i) {
                                var key = buf.readUint32String();
                                key = key.replace(/\0/g, "");
                                var val = this.unserialize(false);
                                dict[key] = val;
                            }
                            return dict;
                        }
                }
            }
            catch (error) {
            }
            return null;
        };
        return Buf;
    }());
    ak.Buf = Buf;
    __reflect(Buf.prototype, "ak.Buf");
})(ak || (ak = {}));
var HotUpdate = (function () {
    function HotUpdate() {
        this._curStep = 0; //当前进度
        this.curHotUpState = "";
        this.maxfileSize = 0;
        this.curfileSize = 0;
        this.init();
    }
    HotUpdate.prototype.init = function () {
        // this.curResVersion = 
    };
    /**检测是否需要更新 */
    HotUpdate.prototype.checkIsNeedUpdate = function (callback, thisObj) {
        this.Logincallback = callback;
        this.LoginthisObj = thisObj;
        console.log("game版本", MyConfig.loginType);
        if (MyConfig.loginType == 1 || MyConfig.loginType == 3) {
            this.handleUpdateUrl();
        }
        else {
            this.Logincallback.call(this.LoginthisObj, 0);
        }
        // callback.call(thisObj);
    };
    HotUpdate.prototype.handleUpdateUrl = function () {
        var _this = this;
        this.needUpdateRes = [];
        this.getReslistFile(function (serverRes) {
            console.log("服务器资源", JSON.stringify(_this.serverResVersion));
            var updateAppPath = _this.checkAppVersion(_this.serverResVersion);
            // RES.getResByUrl(MyConfig.LocalclientResUrl, (res) => {
            if (updateAppPath) {
                _this.goUpdateApp(updateAppPath);
                // GameLocalStorage.saveByUid(GameLocalStorage.localresVersion, "");//清空本地的资源版本记录
                GameLocalStorage.saveByUid(GameLocalStorage.localresVersion, ak.json_encode(_this.serverResVersion)); //将最新的资源版本号写入当前版本
            }
            else {
                _this.getLocalresVersion(function (res) {
                    console.log("本地资源版本：", JSON.stringify(res));
                    //检测资源版本更新
                    _this.checkHotUpdateConfigDif(_this.serverResVersion, res);
                    console.log("待下载的数据:", _this.needUpdateRes.length);
                    if (_this.needUpdateRes.length > 0) {
                        _this.goUpdateGame();
                    }
                    else {
                        _this.Logincallback.call(_this.LoginthisObj, 0);
                    }
                }, _this);
            }
            // }, this);
        }, this);
    };
    HotUpdate.prototype.getLocalresVersion = function (callback, thisObj) {
        var str = GameLocalStorage.loadByUid(GameLocalStorage.localresVersion);
        var arr = [];
        if (str && str != "") {
            arr = ak.json_decode(str);
            callback.call(thisObj, arr);
        }
        else {
            RES.getResByUrl(MyConfig.LocalclientResUrl, function (res) {
                GameLocalStorage.saveByUid(GameLocalStorage.localresVersion, ak.json_encode(res));
                callback.call(thisObj, res);
            });
        }
    };
    HotUpdate.prototype.checkHotUpdateConfigDif = function (configServer, configLocal) {
        if (configServer && configLocal) {
            for (var i = 0; i < configServer.length; i++) {
                for (var k = 0; k < configLocal.length; k++) {
                    if (configServer[i].resName == configLocal[k].resName) {
                        if (configServer[i].resVersion != configLocal[k].resVersion) {
                            this.needUpdateRes.push(configServer[i]);
                        }
                    }
                }
            }
        }
    };
    HotUpdate.prototype.checkAppVersion = function (configServer) {
        if (MyConfig.appVersion && MyConfig.appVersion != "") {
            for (var i = 0; i < configServer.length; i++) {
                if (configServer[i].resName == "AppVersion") {
                    if (MyConfig.appVersion != configServer[i].resVersion) {
                        return configServer[i].path;
                    }
                }
            }
        }
    };
    //整包更新
    HotUpdate.prototype.goUpdateApp = function (path) {
        this.registerDownLoad();
        this.initHotUpdateUI();
        egret.ExternalInterface.call("DownLoadApk", path);
        ak.EventMgr.dispatch(GameEvent.UpdatehotUpdateBar);
        //更新描述
        this.curstepData = { resName: "AppVersion" };
        ak.EventMgr.dispatch(GameEvent.StopHotUpdateDesc);
    };
    //热更
    HotUpdate.prototype.goUpdateGame = function () {
        this.registerDownLoad();
        this.initHotUpdateUI();
        this.nextStep();
        ak.EventMgr.dispatch(GameEvent.UpdatehotUpdateBar);
    };
    //获取区服列表
    HotUpdate.prototype.getReslistFile = function (callback, thisObj) {
        var _this = this;
        PreloadSystem.inst.showSmallLoading(true);
        var respath = MyConfig.loginType == 1 ? MyConfig.clientResUrl : MyConfig.clientResUrl_ios;
        // RES.getResByUrl(respath,   (data)=>{
        // 	this.serverResVersion = ak.json_decode(data);
        // 	console.log("获取外部地址成功===", this.serverResVersion)
        // 	PreloadSystem.inst.showSmallLoading(false);
        // 	callback.call(thisObj);
        // }, this,RES.ResourceItem.TYPE_JSON);
        RES.destroyRes(respath);
        new ak.Form(respath, //+"?"+new Date().getTime(),
        "get", {}, function (data) {
            _this.serverResVersion = ak.json_decode(data);
            PreloadSystem.inst.showSmallLoading(false);
            callback.call(thisObj);
        }, function () {
            ak.log("getServerList error");
            var timer = new egret.Timer(1000, 1);
            timer.once(egret.TimerEvent.TIMER_COMPLETE, function () {
                _this.getReslistFile(callback, thisObj);
            }, _this);
            timer.start();
        }, this, true);
    };
    /**注册加载进度 */
    HotUpdate.prototype.registerDownLoad = function () {
        //下载完成
        egret.ExternalInterface.addCallback("DownLoadComplete", function (msg) {
            HotUpdate.inst.curfileSize = 0;
            HotUpdate.inst.curHotUpState = "unZip";
        });
        egret.ExternalInterface.addCallback("unZipComplete", function (msg) {
            HotUpdate.inst.curHotUpState = "downLoad";
            HotUpdate.inst.nextStep();
        });
        egret.ExternalInterface.addCallback("DownLoadProgress", function (size) {
            HotUpdate.inst.curfileSize += Number(size) / 1024;
        });
        egret.ExternalInterface.addCallback("DownLoadZipSize", function (size) {
            HotUpdate.inst.curfileSize = 0;
            HotUpdate.inst.maxfileSize = Number(size) / 1024;
        });
        egret.ExternalInterface.addCallback("DownLoadUnZipProgress", function (size) {
            HotUpdate.inst.curfileSize += Number(size) / 1024;
        });
    };
    HotUpdate.prototype.nextStep = function () {
        this.curstepData = this.needUpdateRes[0];
        console.log("第" + this._curStep + "步", this.curstepData);
        if (this.curstepData) {
            ak.EventMgr.dispatch(GameEvent.StopHotUpdateDesc);
            this._curStep++;
            this.downloadFlistFile();
            this.needUpdateRes.splice(0, 1);
        }
        else {
            this.OnLoadComplete();
        }
    };
    //下载数据
    HotUpdate.prototype.downloadFlistFile = function () {
        this.curHotUpState = "downLoad";
        var preStep = this.needUpdateRes[0];
        var zipPath = preStep.path + "/" + preStep.resName + ".zip";
        egret.ExternalInterface.call("LoadZip", zipPath);
    };
    /**打开更新UI */
    HotUpdate.prototype.initHotUpdateUI = function () {
        ak.EventMgr.dispatch(GameEvent.openHotUpdateView);
    };
    /**更新结束 */
    HotUpdate.prototype.OnLoadComplete = function () {
        ak.EventMgr.dispatch(GameEvent.StopHotUpdateBar);
        console.log("结束更新，存储结果", ak.json_encode(this.serverResVersion));
        GameLocalStorage.saveByUid(GameLocalStorage.localresVersion, ak.json_encode(this.serverResVersion));
        if (MyConfig.loginType == 1) {
            egret.Tween.get(MyGame.inst.topLayer).to({}, 1000).call(function () {
                window.location.reload();
                window.location.href = window.location.href; // + Math.random()
            });
        }
        else {
            egret.ExternalInterface.call("resumeJs", "");
        }
    };
    HotUpdate.inst = new HotUpdate();
    return HotUpdate;
}());
__reflect(HotUpdate.prototype, "HotUpdate");
var ak;
(function (ak) {
    //获取时间戳（毫秒）
    function time_milli() {
        return new Date().getTime();
    }
    ak.time_milli = time_milli;
    //获取时间戳（秒）
    function time() {
        return Math.floor(new Date().getTime() / 1000);
    }
    ak.time = time;
    //json编码
    function json_encode(obj) {
        return JSON.stringify(obj);
    }
    ak.json_encode = json_encode;
    //json解码
    function json_decode(str) {
        return JSON.parse(str);
        // return eval("("+str+")");
    }
    ak.json_decode = json_decode;
    function AKBase64() {
        var base64EncodeChars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
        var base64DecodeChars = new Array(-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 62, -1, -1, -1, 63, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, -1, -1, -1, -1, -1, -1, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, -1, -1, -1, -1, -1, -1, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, -1, -1, -1, -1, -1);
        function base64encode(str) {
            var out, i, len;
            var c1, c2, c3;
            len = str.length;
            i = 0;
            out = "";
            while (i < len) {
                c1 = str.charCodeAt(i++) & 0xff;
                if (i == len) {
                    out += base64EncodeChars.charAt(c1 >> 2);
                    out += base64EncodeChars.charAt((c1 & 0x3) << 4);
                    out += "==";
                    break;
                }
                c2 = str.charCodeAt(i++);
                if (i == len) {
                    out += base64EncodeChars.charAt(c1 >> 2);
                    out += base64EncodeChars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xF0) >> 4));
                    out += base64EncodeChars.charAt((c2 & 0xF) << 2);
                    out += "=";
                    break;
                }
                c3 = str.charCodeAt(i++);
                out += base64EncodeChars.charAt(c1 >> 2);
                out += base64EncodeChars.charAt(((c1 & 0x3) << 4) | ((c2 & 0xF0) >> 4));
                out += base64EncodeChars.charAt(((c2 & 0xF) << 2) | ((c3 & 0xC0) >> 6));
                out += base64EncodeChars.charAt(c3 & 0x3F);
            }
            return out;
        }
        function base64decode(str) {
            var c1, c2, c3, c4;
            var i, len, out;
            len = str.length;
            i = 0;
            out = "";
            while (i < len) {
                /* c1 */
                do {
                    c1 = base64DecodeChars[str.charCodeAt(i++) & 0xff];
                } while (i < len && c1 == -1);
                if (c1 == -1)
                    break;
                /* c2 */
                do {
                    c2 = base64DecodeChars[str.charCodeAt(i++) & 0xff];
                } while (i < len && c2 == -1);
                if (c2 == -1)
                    break;
                out += String.fromCharCode((c1 << 2) | ((c2 & 0x30) >> 4));
                /* c3 */
                do {
                    c3 = str.charCodeAt(i++) & 0xff;
                    if (c3 == 61)
                        return out;
                    c3 = base64DecodeChars[c3];
                } while (i < len && c3 == -1);
                if (c3 == -1)
                    break;
                out += String.fromCharCode(((c2 & 0XF) << 4) | ((c3 & 0x3C) >> 2));
                /* c4 */
                do {
                    c4 = str.charCodeAt(i++) & 0xff;
                    if (c4 == 61)
                        return out;
                    c4 = base64DecodeChars[c4];
                } while (i < len && c4 == -1);
                if (c4 == -1)
                    break;
                out += String.fromCharCode(((c3 & 0x03) << 6) | c4);
            }
            return out;
        }
        function utf16to8(str) {
            var out, i, len, c;
            out = "";
            len = str.length;
            for (i = 0; i < len; i++) {
                c = str.charCodeAt(i);
                if ((c >= 0x0001) && (c <= 0x007F)) {
                    out += str.charAt(i);
                }
                else if (c > 0x07FF) {
                    out += String.fromCharCode(0xE0 | ((c >> 12) & 0x0F));
                    out += String.fromCharCode(0x80 | ((c >> 6) & 0x3F));
                    out += String.fromCharCode(0x80 | ((c >> 0) & 0x3F));
                }
                else {
                    out += String.fromCharCode(0xC0 | ((c >> 6) & 0x1F));
                    out += String.fromCharCode(0x80 | ((c >> 0) & 0x3F));
                }
            }
            return out;
        }
        function utf8to16(str) {
            var out, i, len, c;
            var char2, char3;
            out = "";
            len = str.length;
            i = 0;
            while (i < len) {
                c = str.charCodeAt(i++);
                switch (c >> 4) {
                    case 0:
                    case 1:
                    case 2:
                    case 3:
                    case 4:
                    case 5:
                    case 6:
                    case 7:
                        // 0xxxxxxx
                        out += str.charAt(i - 1);
                        break;
                    case 12:
                    case 13:
                        // 110x xxxx   10xx xxxx
                        char2 = str.charCodeAt(i++);
                        out += String.fromCharCode(((c & 0x1F) << 6) | (char2 & 0x3F));
                        break;
                    case 14:
                        // 1110 xxxx  10xx xxxx  10xx xxxx
                        char2 = str.charCodeAt(i++);
                        char3 = str.charCodeAt(i++);
                        out += String.fromCharCode(((c & 0x0F) << 12) |
                            ((char2 & 0x3F) << 6) |
                            ((char3 & 0x3F) << 0));
                        break;
                }
            }
            return out;
        }
        function CharToHex(str) {
            var out, i, len, c, h;
            out = "";
            len = str.length;
            i = 0;
            while (i < len) {
                c = str.charCodeAt(i++);
                h = c.toString(16);
                if (h.length < 2)
                    h = "0" + h;
                out += "\\x" + h + " ";
                if (i > 0 && i % 8 == 0)
                    out += "\r\n";
            }
            return out;
        }
        this.encode = function (str) {
            return base64encode(utf16to8(str));
        };
        this.decode = function (str) {
            return utf8to16(base64decode(str));
        };
    }
    //base64编码
    function base64_encode(str) {
        return new AKBase64().encode(str);
    }
    ak.base64_encode = base64_encode;
    //base64解码
    function base64_decode(str) {
        return new AKBase64().decode(str);
    }
    ak.base64_decode = base64_decode;
    //字符串str中将全部str1替换为str2
    function strReplace(str, str1, str2) {
        function strcmp(str1, str2, begin, size) {
            if ((begin + size) > str1.length)
                return false;
            for (var i = 0; i < size; ++i) {
                if (str1[i + begin] != str2[i])
                    return false;
            }
            return true;
        }
        var targetStr = "";
        var c = str.length;
        var ll = str1.length;
        for (var i = 0; i < c;) {
            if (strcmp(str, str1, i, ll)) {
                targetStr += str2;
                i += ll;
            }
            else {
                targetStr += str[i];
                ++i;
            }
        }
        return targetStr;
    }
    ak.strReplace = strReplace;
    //根据ak定制的敏感字符进行安全替换的逆过程
    function AKReplaceInverse(str) {
        str = strReplace(str, '&#39;', '\'');
        str = strReplace(str, '&quot;', '"');
        str = strReplace(str, '&lt;', '<');
        str = strReplace(str, '&gt;', '>');
        str = strReplace(str, '&#92;', '\\');
        str = strReplace(str, '&#47;', '/');
        return str;
    }
    ak.AKReplaceInverse = AKReplaceInverse;
    //时分秒字符串转秒数
    function dateStrToSeconds(timeStr //时分秒字符串，格式：10:00:30
    ) {
        var t = timeStr.split(":");
        if (t.length != 3)
            return 0;
        var t0 = parseInt(t[0]);
        var t1 = parseInt(t[1]);
        var t2 = parseInt(t[2]);
        return (t0 * 60 * 60 + t1 * 60 + t2);
    }
    ak.dateStrToSeconds = dateStrToSeconds;
    //检查身份证号码是否有效
    function isIDCardValid(code) {
        var city = { 11: "北京", 12: "天津", 13: "河北", 14: "山西", 15: "内蒙古", 21: "辽宁", 22: "吉林", 23: "黑龙江 ", 31: "上海", 32: "江苏", 33: "浙江", 34: "安徽", 35: "福建", 36: "江西", 37: "山东", 41: "河南", 42: "湖北 ", 43: "湖南", 44: "广东", 45: "广西", 46: "海南", 50: "重庆", 51: "四川", 52: "贵州", 53: "云南", 54: "西藏 ", 61: "陕西", 62: "甘肃", 63: "青海", 64: "宁夏", 65: "新疆", 71: "台湾", 81: "香港", 82: "澳门", 91: "国外 " };
        var tip = "";
        var pass = true;
        if (!code || !/^\d{6}(18|19|20)?\d{2}(0[1-9]|1[12])(0[1-9]|[12]\d|3[01])\d{3}(\d|X)$/i.test(code)) {
            tip = "身份证号格式错误";
            pass = false;
        }
        else if (!city[code.substr(0, 2)]) {
            tip = "地址编码错误";
            pass = false;
        }
        else {
            //18位身份证需要验证最后一位校验位
            if (code.length == 18) {
                code = code.split('');
                //∑(ai×Wi)(mod 11)
                //加权因子
                var factor = [7, 9, 10, 5, 8, 4, 2, 1, 6, 3, 7, 9, 10, 5, 8, 4, 2];
                //校验位
                var parity = [1, 0, 'X', 9, 8, 7, 6, 5, 4, 3, 2];
                var sum = 0;
                var ai = 0;
                var wi = 0;
                for (var i = 0; i < 17; i++) {
                    ai = code[i];
                    wi = factor[i];
                    sum += ai * wi;
                }
                var last = parity[sum % 11];
                if (parity[sum % 11] != code[17]) {
                    tip = "校验位错误";
                    pass = false;
                }
            }
        }
        //if(!pass) alert(tip);
        return pass;
    }
    ak.isIDCardValid = isIDCardValid;
    //是否全是中文
    function isAllChinese(str) {
        for (var i = 0; i < str.length; ++i) {
            if (str.charCodeAt(i) <= 127)
                return false;
        }
        return true;
    }
    ak.isAllChinese = isAllChinese;
    function md5(srcStr) {
        /*
        * A JavaScript implementation of the RSA Data Security, Inc. MD5 Message
        * Digest Algorithm, as defined in RFC 1321.
        * Version 2.1 Copyright (C) Paul Johnston 1999 - 2002.
        * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
        * Distributed under the BSD License
        * See http://pajhome.org.uk/crypt/md5 for more info.
        */
        /*
        * Configurable variables. You may need to tweak these to be compatible with
        * the server-side, but the defaults work in most cases.
        */
        var hexcase = 0; /* hex output format. 0 - lowercase; 1 - uppercase  */
        var b64pad = ""; /* base-64 pad character. "=" for strict RFC compliance */
        var chrsz = 8; /* bits per input character. 8 - ASCII; 16 - Unicode  */
        /*
        * These are the functions you'll usually want to call
        * They take string arguments and return either hex or base-64 encoded strings
        */
        function hex_md5(s) { return binl2hex(core_md5(str2binl(s), s.length * chrsz)); }
        function b64_md5(s) { return binl2b64(core_md5(str2binl(s), s.length * chrsz)); }
        function str_md5(s) { return binl2str(core_md5(str2binl(s), s.length * chrsz)); }
        function hex_hmac_md5(key, data) { return binl2hex(core_hmac_md5(key, data)); }
        function b64_hmac_md5(key, data) { return binl2b64(core_hmac_md5(key, data)); }
        function str_hmac_md5(key, data) { return binl2str(core_hmac_md5(key, data)); }
        /*
        * Perform a simple self-test to see if the VM is working
        */
        function md5_vm_test() {
            return hex_md5("abc") == "900150983cd24fb0d6963f7d28e17f72";
        }
        /*
        * Calculate the MD5 of an array of little-endian words, and a bit length
        */
        function core_md5(x, len) {
            /* append padding */
            x[len >> 5] |= 0x80 << ((len) % 32);
            x[(((len + 64) >>> 9) << 4) + 14] = len;
            var a = 1732584193;
            var b = -271733879;
            var c = -1732584194;
            var d = 271733878;
            for (var i = 0; i < x.length; i += 16) {
                var olda = a;
                var oldb = b;
                var oldc = c;
                var oldd = d;
                a = md5_ff(a, b, c, d, x[i + 0], 7, -680876936);
                d = md5_ff(d, a, b, c, x[i + 1], 12, -389564586);
                c = md5_ff(c, d, a, b, x[i + 2], 17, 606105819);
                b = md5_ff(b, c, d, a, x[i + 3], 22, -1044525330);
                a = md5_ff(a, b, c, d, x[i + 4], 7, -176418897);
                d = md5_ff(d, a, b, c, x[i + 5], 12, 1200080426);
                c = md5_ff(c, d, a, b, x[i + 6], 17, -1473231341);
                b = md5_ff(b, c, d, a, x[i + 7], 22, -45705983);
                a = md5_ff(a, b, c, d, x[i + 8], 7, 1770035416);
                d = md5_ff(d, a, b, c, x[i + 9], 12, -1958414417);
                c = md5_ff(c, d, a, b, x[i + 10], 17, -42063);
                b = md5_ff(b, c, d, a, x[i + 11], 22, -1990404162);
                a = md5_ff(a, b, c, d, x[i + 12], 7, 1804603682);
                d = md5_ff(d, a, b, c, x[i + 13], 12, -40341101);
                c = md5_ff(c, d, a, b, x[i + 14], 17, -1502002290);
                b = md5_ff(b, c, d, a, x[i + 15], 22, 1236535329);
                a = md5_gg(a, b, c, d, x[i + 1], 5, -165796510);
                d = md5_gg(d, a, b, c, x[i + 6], 9, -1069501632);
                c = md5_gg(c, d, a, b, x[i + 11], 14, 643717713);
                b = md5_gg(b, c, d, a, x[i + 0], 20, -373897302);
                a = md5_gg(a, b, c, d, x[i + 5], 5, -701558691);
                d = md5_gg(d, a, b, c, x[i + 10], 9, 38016083);
                c = md5_gg(c, d, a, b, x[i + 15], 14, -660478335);
                b = md5_gg(b, c, d, a, x[i + 4], 20, -405537848);
                a = md5_gg(a, b, c, d, x[i + 9], 5, 568446438);
                d = md5_gg(d, a, b, c, x[i + 14], 9, -1019803690);
                c = md5_gg(c, d, a, b, x[i + 3], 14, -187363961);
                b = md5_gg(b, c, d, a, x[i + 8], 20, 1163531501);
                a = md5_gg(a, b, c, d, x[i + 13], 5, -1444681467);
                d = md5_gg(d, a, b, c, x[i + 2], 9, -51403784);
                c = md5_gg(c, d, a, b, x[i + 7], 14, 1735328473);
                b = md5_gg(b, c, d, a, x[i + 12], 20, -1926607734);
                a = md5_hh(a, b, c, d, x[i + 5], 4, -378558);
                d = md5_hh(d, a, b, c, x[i + 8], 11, -2022574463);
                c = md5_hh(c, d, a, b, x[i + 11], 16, 1839030562);
                b = md5_hh(b, c, d, a, x[i + 14], 23, -35309556);
                a = md5_hh(a, b, c, d, x[i + 1], 4, -1530992060);
                d = md5_hh(d, a, b, c, x[i + 4], 11, 1272893353);
                c = md5_hh(c, d, a, b, x[i + 7], 16, -155497632);
                b = md5_hh(b, c, d, a, x[i + 10], 23, -1094730640);
                a = md5_hh(a, b, c, d, x[i + 13], 4, 681279174);
                d = md5_hh(d, a, b, c, x[i + 0], 11, -358537222);
                c = md5_hh(c, d, a, b, x[i + 3], 16, -722521979);
                b = md5_hh(b, c, d, a, x[i + 6], 23, 76029189);
                a = md5_hh(a, b, c, d, x[i + 9], 4, -640364487);
                d = md5_hh(d, a, b, c, x[i + 12], 11, -421815835);
                c = md5_hh(c, d, a, b, x[i + 15], 16, 530742520);
                b = md5_hh(b, c, d, a, x[i + 2], 23, -995338651);
                a = md5_ii(a, b, c, d, x[i + 0], 6, -198630844);
                d = md5_ii(d, a, b, c, x[i + 7], 10, 1126891415);
                c = md5_ii(c, d, a, b, x[i + 14], 15, -1416354905);
                b = md5_ii(b, c, d, a, x[i + 5], 21, -57434055);
                a = md5_ii(a, b, c, d, x[i + 12], 6, 1700485571);
                d = md5_ii(d, a, b, c, x[i + 3], 10, -1894986606);
                c = md5_ii(c, d, a, b, x[i + 10], 15, -1051523);
                b = md5_ii(b, c, d, a, x[i + 1], 21, -2054922799);
                a = md5_ii(a, b, c, d, x[i + 8], 6, 1873313359);
                d = md5_ii(d, a, b, c, x[i + 15], 10, -30611744);
                c = md5_ii(c, d, a, b, x[i + 6], 15, -1560198380);
                b = md5_ii(b, c, d, a, x[i + 13], 21, 1309151649);
                a = md5_ii(a, b, c, d, x[i + 4], 6, -145523070);
                d = md5_ii(d, a, b, c, x[i + 11], 10, -1120210379);
                c = md5_ii(c, d, a, b, x[i + 2], 15, 718787259);
                b = md5_ii(b, c, d, a, x[i + 9], 21, -343485551);
                a = safe_add(a, olda);
                b = safe_add(b, oldb);
                c = safe_add(c, oldc);
                d = safe_add(d, oldd);
            }
            return Array(a, b, c, d);
        }
        /*
        * These functions implement the four basic operations the algorithm uses.
        */
        function md5_cmn(q, a, b, x, s, t) {
            return safe_add(bit_rol(safe_add(safe_add(a, q), safe_add(x, t)), s), b);
        }
        function md5_ff(a, b, c, d, x, s, t) {
            return md5_cmn((b & c) | ((~b) & d), a, b, x, s, t);
        }
        function md5_gg(a, b, c, d, x, s, t) {
            return md5_cmn((b & d) | (c & (~d)), a, b, x, s, t);
        }
        function md5_hh(a, b, c, d, x, s, t) {
            return md5_cmn(b ^ c ^ d, a, b, x, s, t);
        }
        function md5_ii(a, b, c, d, x, s, t) {
            return md5_cmn(c ^ (b | (~d)), a, b, x, s, t);
        }
        /*
        * Calculate the HMAC-MD5, of a key and some data
        */
        function core_hmac_md5(key, data) {
            var bkey = str2binl(key);
            if (bkey.length > 16)
                bkey = core_md5(bkey, key.length * chrsz);
            var ipad = Array(16), opad = Array(16);
            for (var i = 0; i < 16; i++) {
                ipad[i] = bkey[i] ^ 0x36363636;
                opad[i] = bkey[i] ^ 0x5C5C5C5C;
            }
            var hash = core_md5(ipad.concat(str2binl(data)), 512 + data.length * chrsz);
            return core_md5(opad.concat(hash), 512 + 128);
        }
        /*
        * Add integers, wrapping at 2^32. This uses 16-bit operations internally
        * to work around bugs in some JS interpreters.
        */
        function safe_add(x, y) {
            var lsw = (x & 0xFFFF) + (y & 0xFFFF);
            var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
            return (msw << 16) | (lsw & 0xFFFF);
        }
        /*
        * Bitwise rotate a 32-bit number to the left.
        */
        function bit_rol(num, cnt) {
            return (num << cnt) | (num >>> (32 - cnt));
        }
        /*
        * Convert a string to an array of little-endian words
        * If chrsz is ASCII, characters >255 have their hi-byte silently ignored.
        */
        function str2binl(str) {
            var bin = Array();
            var mask = (1 << chrsz) - 1;
            for (var i = 0; i < str.length * chrsz; i += chrsz)
                bin[i >> 5] |= (str.charCodeAt(i / chrsz) & mask) << (i % 32);
            return bin;
        }
        /*
        * Convert an array of little-endian words to a string
        */
        function binl2str(bin) {
            var str = "";
            var mask = (1 << chrsz) - 1;
            for (var i = 0; i < bin.length * 32; i += chrsz)
                str += String.fromCharCode((bin[i >> 5] >>> (i % 32)) & mask);
            return str;
        }
        /*
        * Convert an array of little-endian words to a hex string.
        */
        function binl2hex(binarray) {
            var hex_tab = hexcase ? "0123456789ABCDEF" : "0123456789abcdef";
            var str = "";
            for (var i = 0; i < binarray.length * 4; i++) {
                str += hex_tab.charAt((binarray[i >> 2] >> ((i % 4) * 8 + 4)) & 0xF) +
                    hex_tab.charAt((binarray[i >> 2] >> ((i % 4) * 8)) & 0xF);
            }
            return str;
        }
        /*
        * Convert an array of little-endian words to a base-64 string
        */
        function binl2b64(binarray) {
            var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
            var str = "";
            for (var i = 0; i < binarray.length * 4; i += 3) {
                var triplet = (((binarray[i >> 2] >> 8 * (i % 4)) & 0xFF) << 16)
                    | (((binarray[i + 1 >> 2] >> 8 * ((i + 1) % 4)) & 0xFF) << 8)
                    | ((binarray[i + 2 >> 2] >> 8 * ((i + 2) % 4)) & 0xFF);
                for (var j = 0; j < 4; j++) {
                    if (i * 8 + j * 6 > binarray.length * 32)
                        str += b64pad;
                    else
                        str += tab.charAt((triplet >> 6 * (3 - j)) & 0x3F);
                }
            }
            return str;
        }
        return hex_md5(srcStr);
    }
    ak.md5 = md5;
    function htmlspecialchars(str) {
        str = str.replace(/&/g, '&amp;');
        str = str.replace(/</g, '&lt;');
        str = str.replace(/>/g, '&gt;');
        str = str.replace(/"/g, '&quot;');
        str = str.replace(/'/g, '&#039;');
        return str;
    }
    ak.htmlspecialchars = htmlspecialchars;
    //日期字串转时间（秒）
    function strtotime(datetime) {
        if (datetime.indexOf(":") < 0) {
            datetime += " 00:00:00";
        }
        var tmp_datetime = datetime.replace(/:/g, '-');
        tmp_datetime = tmp_datetime.replace(/ /g, '-');
        var arr = tmp_datetime.split("-");
        if (arr.length == 6)
            var now = new Date(Date.UTC(arr[0], arr[1] - 1, arr[2], arr[3] - 8, arr[4], arr[5]));
        else
            var now = new Date(Date.UTC(arr[0], arr[1] - 1, arr[2]));
        return now.getTime() / 1000;
    }
    ak.strtotime = strtotime;
    //时间（秒）转日期时间字串
    function timetostr(time) {
        function add0(m) {
            return m < 10 ? '0' + m : m;
        }
        time = Math.floor(time) * 1000;
        var time1 = new Date(time);
        var y = time1.getFullYear();
        var m = time1.getMonth() + 1;
        var d = time1.getDate();
        var h = time1.getHours();
        var mm = time1.getMinutes();
        var s = time1.getSeconds();
        return y + '-' + add0(m) + '-' + add0(d) + ' ' + add0(h) + ':' + add0(mm) + ':' + add0(s);
    }
    ak.timetostr = timetostr;
    //时间（秒）转日期字串
    function timetodate(time) {
        function add0(m) {
            return m < 10 ? '0' + m : m;
        }
        time = Math.floor(time) * 1000;
        var time1 = new Date(time);
        var y = time1.getFullYear();
        var m = time1.getMonth() + 1;
        var d = time1.getDate();
        return y + '-' + add0(m) + '-' + add0(d);
    }
    ak.timetodate = timetodate;
    //获取time所在星期的开始时间（秒）
    function getWeekBeginTime(time //时间戳（秒）
    ) {
        var dateStr = ak.timetostr(time);
        dateStr = dateStr.split(" ")[0];
        var day = weekday(dateStr);
        var t = strtotime(dateStr);
        t -= (day - 1) * 24 * 60 * 60;
        return (t);
    }
    ak.getWeekBeginTime = getWeekBeginTime;
    //获取time当日的开始时间（秒）
    function getDayBeginTime(time //时间戳（秒）
    ) {
        var dateStr = timetostr(time);
        dateStr = dateStr.split(" ")[0];
        var t = strtotime(dateStr);
        return (t);
    }
    ak.getDayBeginTime = getDayBeginTime;
    //获取周几（根据时间）
    function weekdayByTime(time //时间秒
    ) {
        return this.weekday(this.timetodate(time));
    }
    ak.weekdayByTime = weekdayByTime;
    //获取周几
    function weekday(dateStr) {
        var arr = dateStr.split("-");
        var y = parseInt(arr[0]);
        var m = parseInt(arr[1]);
        var d = parseInt(arr[2]);
        if (m == 1 || m == 2) {
            m += 12;
            y--;
        }
        var day = (d + 2 * m + Math.floor(3 * (m + 1) / 5) + y + Math.floor(y / 4) - Math.floor(y / 100) + Math.floor(y / 400)) % 7;
        return day + 1;
    }
    ak.weekday = weekday;
    //获取html文件?后url中的变量值
    function get_html_url_var(varName, //变量名
        windowObj //可选，不填代表当前window对象，也可指定，例如window.parent
    ) {
        if (!window.location.search) {
            return "";
        }
        var str = windowObj ? windowObj.location.search.substr(1) : window.location.search.substr(1);
        var arr = str.split("&");
        var c = arr.length;
        for (var i = 0; i < c; ++i) {
            var t = arr[i];
            var pos = t.indexOf("=");
            if (pos >= 0) {
                var key = t.substr(0, pos);
                var val = t.substr(pos + 1);
                if (key == varName) {
                    return val;
                }
            }
        }
        return "";
    }
    ak.get_html_url_var = get_html_url_var;
    //格式化字串，格式：strFormat("%0只猪，%1条鱼",100,200);
    function strFormat(str) {
        var p = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            p[_i - 1] = arguments[_i];
        }
        for (var i = p.length - 1; i >= 0; --i) {
            str = strReplace(str, "%" + i, p[i]);
        }
        return str;
    }
    ak.strFormat = strFormat;
    //调试标记
    ak.debug = true;
    //打印调试信息
    function log() {
        var p = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            p[_i] = arguments[_i];
        }
        if (ak.debug == false) {
            return;
        }
        console.log.apply(this, p);
    }
    ak.log = log;
    //整形函数001，作用：将num从arr区间映射到arr2区间，其中arr和arr2的长度必须一致且大于2，且元素需从小到大
    function shaping001(num, //输入值
        arr, //输入分段数组，如：0,10,20,100
        arr2) {
        var c = arr.length;
        if (c < 2 || c != arr2.length) {
            throw "shaping001 error";
        }
        for (var i = 1; i < c; ++i) {
            var a = arr[i - 1];
            var b = arr[i];
            if (num >= a && num <= b) {
                var aa = arr2[i - 1];
                var bb = arr2[i];
                var percent = (num - a) / (b - a);
                return aa + (bb - aa) * percent;
            }
        }
        throw "shaping001 error";
    }
    ak.shaping001 = shaping001;
    //id字典对id对应的数值进行加法
    function idMapAddCount(map, id, count, zeroRemove //选填，元素为0时，是否自动删除元素
    ) {
        if (zeroRemove === void 0) { zeroRemove = true; } //选填，元素为0时，是否自动删除元素
        if (map[id]) {
            map[id] += count;
            if (map[id] == 0 && zeroRemove) {
                delete map[id];
            }
        }
        else {
            if (count != 0) {
                map[id] = count;
            }
        }
    }
    ak.idMapAddCount = idMapAddCount;
    //id字典元素获取id对应数值
    function idMapGetCount(map, id) {
        if (map[id]) {
            return map[id];
        }
        return 0;
    }
    ak.idMapGetCount = idMapGetCount;
    //返回当前日期，格式：2019-02-20
    function date() {
        var d = new Date();
        var yy = d.getFullYear();
        var mm = (d.getMonth() + 1) >= 10 ? (d.getMonth() + 1) : "0" + (d.getMonth() + 1);
        var dd = (d.getDate()) >= 10 ? d.getDate() : '0' + d.getDate();
        var str = yy + "-" + mm + "-" + dd;
        return (str);
    }
    ak.date = date;
    //返回当前日期，格式：2019-02-20 10:14:30
    function now() {
        var d = new Date();
        var yy = d.getFullYear();
        var mm = (d.getMonth() + 1) >= 10 ? (d.getMonth() + 1) : "0" + (d.getMonth() + 1);
        var dd = (d.getDate()) >= 10 ? d.getDate() : '0' + d.getDate();
        var h = d.getHours() >= 10 ? d.getHours() : "0" + d.getHours();
        var m = d.getMinutes() >= 10 ? d.getMinutes() : "0" + d.getMinutes();
        var s = d.getSeconds() >= 10 ? d.getSeconds() : "0" + d.getSeconds();
        var str = yy + "-" + mm + "-" + dd + " " + h + ":" + m + ":" + s;
        return (str);
    }
    ak.now = now;
    //检测ch是否中文字符
    function isChinese(ch) {
        var ascii = ch.charCodeAt(0);
        if (ascii >= 0x4e00 && ascii <= 0x9fa5) {
            return true;
        }
        return false;
    }
    ak.isChinese = isChinese;
    //检测ch是否字母
    function isLetter(ch) {
        var ascii = ch.charCodeAt(0);
        if (ascii >= 97 && ascii <= 122) {
            return true;
        }
        if (ascii >= 65 && ascii <= 90) {
            return true;
        }
        return false;
    }
    ak.isLetter = isLetter;
    //检测ch是否数字
    function isNumber(ch) {
        var ascii = ch.charCodeAt(0);
        if (ascii >= 48 && ascii <= 57) {
            return true;
        }
        return false;
    }
    ak.isNumber = isNumber;
    //检查字串是否只包含中文和字母
    function isChineseAndLetter(str) {
        for (var i = 0; i < str.length; ++i) {
            var ch = str[i];
            if (isChinese(ch) || isLetter(ch)) {
            }
            else {
                return false;
            }
        }
        return true;
    }
    ak.isChineseAndLetter = isChineseAndLetter;
    //单个数字转中文
    var numArr = ["零", "一", "二", "三", "四", "五", "六", "七", "八", "九"];
    function numToChinese(num) {
        num = Math.floor(num);
        if (num >= 0 && num < numArr.length) {
            return numArr[num];
        }
    }
    ak.numToChinese = numToChinese;
    //数组元素交换
    function exchange(arr, index1, index2) {
        var a = arr[index1];
        var b = arr[index2];
        arr[index1] = b;
        arr[index2] = a;
    }
    ak.exchange = exchange;
    //判断是否为空对象
    function isNull(obj) {
        if (obj == null) {
            return true;
        }
        return false;
    }
    ak.isNull = isNull;
    //数值补0
    function prefix0(num, //数值
        n //保证的位数
    ) {
        var str = "" + num;
        if (str.length < n) {
            var c = n - str.length;
            for (var i = 0; i < c; ++i) {
                str = "0" + str;
            }
        }
        return str;
    }
    ak.prefix0 = prefix0;
    //秒数转时间字串
    function secToStr(sec, //秒数
        //////////////////////////////////////////////
        format
        /*格式：
            1="分:秒";
            2="时:分:秒";
        */
        //////////////////////////////////////////////
    ) {
        sec = Math.floor(sec);
        switch (format) {
            case 1://"分:秒"
                {
                    var t1 = prefix0(sec % 60, 2);
                    var t2 = prefix0(Math.floor(sec / 60), 2);
                    return t2 + ":" + t1;
                }
            case 2://"时:分:秒"
                {
                    var t1 = prefix0(sec % 60, 2);
                    var t2 = prefix0(Math.floor(sec / 60) % 60, 2);
                    var t3 = prefix0(Math.floor(sec / 60 / 60), 2);
                    return t3 + ":" + t2 + ":" + t1;
                }
        }
        return null;
    }
    ak.secToStr = secToStr;
})(ak || (ak = {}));
var Main = (function (_super) {
    __extends(Main, _super);
    function Main() {
        var _this = _super.call(this) || this;
        _this.addEventListener(egret.Event.ADDED_TO_STAGE, _this.onAddToStage, _this);
        _this.addEventListener(egret.Event.ADDED_TO_STAGE, _this.onAddToStage, _this);
        //设置允许跨域访问图片
        egret.ImageLoader.crossOrigin = "anonymous";
        return _this;
    }
    Main.prototype.onAddToStage = function (event) {
        egret.lifecycle.addLifecycleListener(function (context) {
            // custom lifecycle plugin
            context.onUpdate = function () {
            };
        });
        egret.lifecycle.onPause = function () {
            // egret.ticker.pause();
            ak.SoundMgr.inst.openMusic = false;
            ak.SoundMgr.inst.openSound = false;
        };
        egret.lifecycle.onResume = function () {
            // egret.ticker.resume();
            SetupView.soundSetup();
        };
        this.runGame().catch(function (e) {
            ak.log(e);
        });
    };
    Main.prototype.runGame = function () {
        return __awaiter(this, void 0, void 0, function () {
            var userInfo;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.loadResource()];
                    case 1:
                        _a.sent();
                        this.createGameScene();
                        return [4 /*yield*/, platform.login()];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, platform.getUserInfo()];
                    case 3:
                        userInfo = _a.sent();
                        ak.log(userInfo);
                        return [2 /*return*/];
                }
            });
        });
    };
    Main.prototype.loadResource = function () {
        return __awaiter(this, void 0, void 0, function () {
            var e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 3, , 4]);
                        Main.loadingView = new LoadingUI();
                        this.stage.addChild(Main.loadingView);
                        return [4 /*yield*/, RES.loadConfig(MyConfig.resJsonUrl + "?" + MyConfig.ver, MyConfig.resDir)];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, RES.loadGroup("preload", 0, Main.loadingView)];
                    case 2:
                        _a.sent();
                        SensitiveWordFilter.inst.init();
                        return [3 /*break*/, 4];
                    case 3:
                        e_1 = _a.sent();
                        console.error(e_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    Main.prototype.createGameScene = function () {
        //启动游戏
        console.log("-------------##  启动游戏  ###----------");
        this.addChild(MyGame.inst);
    };
    return Main;
}(egret.DisplayObjectContainer));
__reflect(Main.prototype, "Main");
var ak;
(function (ak) {
    var Dragonbones = (function (_super) {
        __extends(Dragonbones, _super);
        function Dragonbones(skeJsonUrl, //骨骼动画描述文件（bin为true时，传入xx_ske.dbbin文件，bin为false时传入xx_ske.json文件）
            texJsonUrl, //纹理描述文件，格式：xx_tex.json
            pngUrl, //纹理文件，格式：xx_tex.png
            armatureName, //骨架名
            bin //是否使用二进制龙骨
        ) {
            if (bin === void 0) { bin = false; } //是否使用二进制龙骨
            var _this = _super.call(this) || this;
            _this.bin = false;
            _this._timeScale = 1;
            _this.isStop = false;
            _this._isActionPlaying = false; //动作是否播放中
            _this.skeJsonUrl = skeJsonUrl;
            _this.texJsonUrl = texJsonUrl;
            _this.pngUrl = pngUrl;
            _this.armatureName = armatureName;
            _this.bin = bin;
            return _this;
        }
        Object.defineProperty(Dragonbones.prototype, "timeScale", {
            get: function () {
                return this._timeScale;
            },
            set: function (scale) {
                this._timeScale = scale;
                if (this.ani) {
                    this.ani.animation.timeScale = this._timeScale;
                }
            },
            enumerable: true,
            configurable: true
        });
        //初始化回调
        Dragonbones.prototype.onInit = function () {
            //加入舞台后，再进行资源加载
            this.load();
        };
        //销毁回调
        Dragonbones.prototype.onDestroy = function () {
            //从舞台移除时，销毁资源
            this._destroy();
        };
        //加载
        Dragonbones.prototype.load = function () {
            if (RES.hasRes(this.skeJsonUrl)) {
                RES.getResAsync(this.skeJsonUrl, this.onLoadSkeJsonComplete, this);
            }
            else {
                if (this.bin) {
                    RES.getResByUrl(ak.ResMgr.getUrlFromVer(this.skeJsonUrl), this.onLoadSkeJsonComplete, this, RES.ResourceItem.TYPE_BIN);
                }
                else {
                    RES.getResByUrl(ak.ResMgr.getUrlFromVer(this.skeJsonUrl), this.onLoadSkeJsonComplete, this, RES.ResourceItem.TYPE_JSON);
                }
            }
            if (RES.hasRes(this.texJsonUrl)) {
                RES.getResAsync(this.texJsonUrl, this.onLoadTexJsonComplete, this);
            }
            else {
                RES.getResByUrl(ak.ResMgr.getUrlFromVer(this.texJsonUrl), this.onLoadTexJsonComplete, this, RES.ResourceItem.TYPE_JSON);
            }
            ak.ResMgr.loadImg(this.pngUrl, this.onLoadPngComplete, this);
        };
        Dragonbones.prototype.onLoadSkeJsonComplete = function (data, url) {
            if (!this.stage) {
                return;
            }
            this.skeJsonData = data;
            this.createAni();
        };
        Dragonbones.prototype.onLoadTexJsonComplete = function (data, url) {
            if (!this.stage) {
                return;
            }
            this.texJsonData = data;
            this.createAni();
        };
        Dragonbones.prototype.onLoadPngComplete = function (tex, url) {
            if (!this.stage) {
                ak.ResMgr.releaseTexture(url);
                return;
            }
            this.texture = tex;
            this.createAni();
        };
        Dragonbones.prototype.createAni = function () {
            var _this = this;
            if (this.skeJsonData && this.texJsonData && this.texture) {
                this.egretFactory = new dragonBones.EgretFactory();
                try {
                    this.egretFactory.parseDragonBonesData(this.skeJsonData);
                }
                catch (e) {
                    ak.log("data error", this.skeJsonUrl);
                }
                this.egretFactory.parseTextureAtlasData(this.texJsonData, this.texture);
                this.ani = this.egretFactory.buildArmatureDisplay(this.armatureName);
                this.ani.animation.timeScale = this._timeScale;
                this.addChild(this.ani);
                if (this.isStop) {
                    this.stop();
                }
                else if (this.actionName) {
                    this.setAction(this.actionName, this.playTime);
                    this.actionName = "";
                    this.playTime = -1;
                }
                this.onEgretEvent(this.ani, dragonBones.EventObject.COMPLETE, function (e) {
                    _this._isActionPlaying = false;
                    if (_this.playCompleteCallback && _this.playCompleteThisObj) {
                        var actionName = e.animationState.name;
                        _this.playCompleteCallback.call(_this.playCompleteThisObj, actionName);
                    }
                }, this);
                if (this.readyCallback && this.readyThisObj) {
                    this.readyCallback.call(this.readyThisObj, this.ani);
                }
            }
        };
        //动作是否播放中
        Dragonbones.prototype.isActionPlaying = function () {
            return this._isActionPlaying;
        };
        //设置动作
        Dragonbones.prototype.setAction = function (actionName, playTime //循环播放次数。 [-1: 使用动画数据默认值, 0: 无限循环播放, [1~N]: 循环播放 N 次] （默认: -1）
        ) {
            var _this = this;
            this.isStop = false;
            this._isActionPlaying = true;
            this.lastActionName = actionName;
            if (playTime == null) {
                playTime = -1;
            }
            if (this.ani) {
                if (this.isExistAction(actionName)) {
                    this.ani.animation.play(actionName, playTime);
                }
                else {
                    //当作是动作立即完成
                    this.once(egret.Event.ENTER_FRAME, function () {
                        _this._isActionPlaying = false;
                        if (_this.playCompleteCallback && _this.playCompleteThisObj) {
                            _this.playCompleteCallback.call(_this.playCompleteThisObj, actionName);
                        }
                    }, this);
                }
            }
            else {
                this.actionName = actionName;
                this.playTime = playTime;
            }
        };
        //查询动作是否存在
        Dragonbones.prototype.isExistAction = function (actionName) {
            if (!this.ani) {
                return false;
            }
            if (this.ani.animation.animationNames.indexOf(actionName) >= 0) {
                //存在
                return true;
            }
            else {
                //不存在
                return false;
            }
        };
        //继续播放动作
        Dragonbones.prototype.play = function () {
            this.isStop = false;
            if (this.ani) {
                this.ani.animation.play();
            }
        };
        //停止播放动作
        Dragonbones.prototype.stop = function () {
            this.isStop = true;
            if (this.ani) {
                this.ani.animation.stop();
            }
        };
        //获取最后播放的动作名
        Dragonbones.prototype.getActionName = function () {
            return this.lastActionName;
        };
        //设置动作完成回调
        Dragonbones.prototype.setActionPlayCompleteCallback = function (callback, thisObj) {
            this.playCompleteCallback = callback;
            this.playCompleteThisObj = thisObj;
        };
        //注册准备好回调(在此可自行注册更多龙骨事件回调)
        Dragonbones.prototype.ready = function (callback, thisObj) {
            this.readyCallback = callback;
            this.readyThisObj = thisObj;
        };
        //销毁
        Dragonbones.prototype._destroy = function () {
            this.removeChildren();
            if (this.ani) {
                this.ani.dispose();
            }
            if (this.egretFactory) {
                this.egretFactory.clear();
            }
            if (this.texture) {
                ak.ResMgr.releaseTexture(this.pngUrl);
            }
            this.ani = null;
            this.egretFactory = null;
            this.texture = null;
            this.skeJsonData = null;
            this.texJsonData = null;
        };
        return Dragonbones;
    }(ak.DisplayObjectContainer));
    ak.Dragonbones = Dragonbones;
    __reflect(Dragonbones.prototype, "ak.Dragonbones");
})(ak || (ak = {}));
var ak;
(function (ak) {
    //事件管理器
    var EventMgr = (function () {
        function EventMgr() {
        }
        EventMgr.start = function () {
            document.addEventListener("keydown", function (e) {
                EventMgr.onKeyDown(e);
            });
            document.addEventListener("keyup", function (e) {
                EventMgr.onKeyUp(e);
            });
            document.addEventListener("keypress", function (e) {
                EventMgr.onKeyPress(e);
            });
        };
        EventMgr.onKeyDown = function (e) {
            this.dispatch(Event.KEY_DOWN, e);
        };
        EventMgr.onKeyUp = function (e) {
            this.dispatch(Event.KEY_UP, e);
        };
        EventMgr.onKeyPress = function (e) {
            this.dispatch(Event.KEY_PRESS, e);
        };
        //添加事件监听
        EventMgr.addEventListener = function (eventName, callback, thisObj) {
            var listenerArr = EventMgr.eventMap[eventName];
            if (!listenerArr) {
                listenerArr = [];
                EventMgr.eventMap[eventName] = listenerArr;
            }
            var listener = new EventListener();
            listener.callback = callback;
            listener.thisObj = thisObj;
            listenerArr.push(listener);
            return listener;
        };
        //添加一次事件监听
        EventMgr.once = function (eventName, callback, thisObj) {
            var listener = this.addEventListener(eventName, callback, thisObj);
            listener.once = true; //监听一次
        };
        //删除事件监听
        EventMgr.removeEventListener = function (eventName, callback, thisObj) {
            var listenerArr = EventMgr.eventMap[eventName];
            if (!listenerArr) {
                return;
            }
            var c = listenerArr.length;
            for (var i = 0; i < c;) {
                var info = listenerArr[i];
                if (info.callback == callback && info.thisObj == thisObj) {
                    if (this.dispatchLayer == 0) {
                        listenerArr.splice(i, 1);
                        --c;
                    }
                    else {
                        //标记删除
                        info.deleteSign = true;
                        ++i;
                    }
                }
                else {
                    ++i;
                }
            }
        };
        //派发事件
        EventMgr.dispatch = function (eventName, params) {
            var e = new Event();
            e.name = eventName;
            e.params = params;
            var listenerArr = EventMgr.eventMap[eventName];
            if (listenerArr) {
                ++this.dispatchLayer;
                var c = listenerArr.length;
                for (var i = 0; i < c; ++i) {
                    var info = listenerArr[i];
                    if (!info.deleteSign) {
                        info.callback.call(info.thisObj, e);
                        if (info.once) {
                            //标记删除
                            info.deleteSign = true;
                        }
                    }
                }
                --this.dispatchLayer;
                if (this.dispatchLayer == 0) {
                    //删除所有标记删除的注册事件
                    this.clean();
                }
            }
        };
        //删除所有标记删除的注册事件
        EventMgr.clean = function () {
            var eventMap = EventMgr.eventMap;
            for (var eventName in eventMap) {
                var listenerArr = eventMap[eventName];
                var c = listenerArr.length;
                for (var i = c - 1; i >= 0; --i) {
                    var info = listenerArr[i];
                    if (info.deleteSign) {
                        //删除
                        listenerArr.splice(i, 1);
                    }
                }
            }
        };
        EventMgr.eventMap = {};
        EventMgr.dispatchLayer = 0; //派发事件层数计数
        //egret事件统计
        EventMgr.egretEventMap = {};
        return EventMgr;
    }());
    ak.EventMgr = EventMgr;
    __reflect(EventMgr.prototype, "ak.EventMgr");
    var Event = (function () {
        function Event() {
        }
        //内置事件
        Event.KEY_DOWN = "KEY_DOWN";
        Event.KEY_UP = "KEY_UP";
        Event.KEY_PRESS = "KEY_PRESS";
        return Event;
    }());
    ak.Event = Event;
    __reflect(Event.prototype, "ak.Event");
    //事件监听器
    var EventListener = (function () {
        function EventListener() {
            this.deleteSign = false; //删除标记
            this.once = false; //是否监听一次
        }
        return EventListener;
    }());
    __reflect(EventListener.prototype, "EventListener");
})(ak || (ak = {}));
var MyClient = (function (_super) {
    __extends(MyClient, _super);
    function MyClient() {
        var _this = 
        // super(MyConfig.wss);
        _super.call(this) || this;
        _this.loginDate = ""; //登录日期
        _this.heartbeatTimer = new ak.Timer();
        _this.autoCnnSign = true; //自动重连标记
        _this.rpcResponseName = "";
        //远程调用
        _this.rpcArr = [];
        return _this;
    }
    //发送心跳
    MyClient.prototype.sendHeartbeat = function () {
        if (!this.isOnline())
            return;
        if (this.heartbeatTimer.getTime() < 10 * 1000)
            return;
        this.sendMsg([""]);
        this.heartbeatTimer.reset();
    };
    // //登录
    // public sendLogin()
    // {
    //     if(!this.isOnline())return;
    //     let date=(new Date().toISOString()).substr(0,10);
    //     if(date!=this.loginDate&&MyData.inst.userID!=0&&MyData.inst.tick!="")
    //     {
    //         this.loginDate=date;
    //         this.sendMsg(["login",MyData.inst.userID,MyData.inst.tick]);
    //     }
    // }
    //发送网络消息
    MyClient.prototype.sendMsg = function (msg) {
        var buf = new ak.Buf(10240);
        buf.serialize(msg);
        this.send(buf);
    };
    //连接
    MyClient.prototype.connectServer = function (callback, thisObj) {
        MyClient.inst.autoCnnSign = true;
        PreloadSystem.inst.showSmallLoading(true);
        this.close();
        this.connectCallback = callback;
        this.connectThisObj = thisObj;
        this.connect(MyData.serverDomain, MyData.serverPort);
    };
    MyClient.prototype.reset = function () {
        this.rpcCallback = null;
        this.rpcThisObj = null;
        this.rpcResponseName = "";
        this.loginDate = ""; //清理登录日期，将会重新登录
        // //清空通行证
        // MyData.inst.userID=0;
        // MyData.inst.tick="";
    };
    //关闭连接
    MyClient.prototype.closeConnectServer = function () {
        MyClient.inst.autoCnnSign = false;
        this.reset();
        this.close();
    };
    MyClient.prototype.rpc = function (msg, callback, thisObj) {
        ak.log(msg);
        if (this.rpcCallback != null) {
            throw "rpc 不允许同时发起多个请求";
        }
        PreloadSystem.inst.showSmallLoading(true);
        this.rpcCallback = callback;
        this.rpcThisObj = thisObj;
        this.rpcResponseName = msg[0] + "Result";
        this.sendMsg(msg);
        // if(!this.isOnline())
        // {
        //     this.onError();
        //     return;
        // }
    };
    //连接回调
    MyClient.prototype.onConnect = function () {
        ak.log("onConnect:");
        if (this.connectCallback != null) {
            var callback = this.connectCallback;
            var thisObj = this.connectThisObj;
            this.connectCallback = null;
            this.connectThisObj = null;
            PreloadSystem.inst.showSmallLoading(false);
            callback.call(thisObj, true);
        }
    };
    //接收回调
    MyClient.prototype.onData = function (buf) {
        //ak.log("onData");
        var rtMsg = buf.unserialize();
        ak.log(rtMsg);
        var msgName = rtMsg[0];
        if (this.rpcResponseName != "" && msgName == this.rpcResponseName) {
            var rpcCallback = this.rpcCallback;
            var rpcThisObj = this.rpcThisObj;
            this.rpcCallback = null;
            this.rpcThisObj = null;
            this.rpcResponseName = "";
            PreloadSystem.inst.showSmallLoading(false);
            rpcCallback.call(rpcThisObj, rtMsg);
            //消息分发
            var eventName = "netmsg://" + msgName;
            ak.EventMgr.dispatch(eventName, rtMsg);
        }
        else {
            //消息分发
            var eventName = "netmsg://" + msgName;
            ak.EventMgr.dispatch(eventName, rtMsg);
        }
    };
    //网络异常回调
    MyClient.prototype.onError = function () {
        //重置
        this.reset();
        //
        ak.log("onError");
        if (this.connectCallback != null) {
            this.connectCallback.call(this.connectThisObj, false);
            this.connectCallback = null;
            this.connectThisObj = null;
        }
        //
        this.rpcCallback = null;
        this.rpcThisObj = null;
        this.rpcResponseName = "";
        if (this.autoCnnSign) {
            //网络异常界面
            ak.FairyGUI.open(["NetErrorUI"]);
        }
        PreloadSystem.inst.showSmallLoading(false);
        PreloadSystem.inst.showBigLoading(false);
    };
    MyClient.inst = new MyClient();
    return MyClient;
}(ak.Client));
__reflect(MyClient.prototype, "MyClient");
var ak;
(function (ak) {
    var FariyGUI_GLoader = (function (_super) {
        __extends(FariyGUI_GLoader, _super);
        function FariyGUI_GLoader() {
            return _super.call(this) || this;
        }
        FariyGUI_GLoader.prototype.loadExternal = function () {
            var url = this.url;
            if (url == "") {
                this.onExternalLoadSuccess(null);
            }
            if (url.substr(0, ak.EasyUI.allowUrlPre.length) == ak.EasyUI.allowUrlPre) {
                url = FariyGUI_GLoader.staticResRoot + url;
            }
            else {
                if (url.indexOf(ak.EasyUI.urlPre) < 0) {
                    throw "请使用 ak.EasyUI.setLoaderUrl() 加载图片资源";
                }
                url = ak.strReplace(url, ak.EasyUI.urlPre, "");
            }
            if (RES.hasRes(url)) {
                var res = RES.getRes(url);
                if (res) {
                    this.__myGetResCompleted(res, url);
                }
                else {
                    RES.getResAsync(url, this.onGetResAsync, this);
                }
            }
            else {
                if (url.indexOf("?") >= 0) {
                }
                else {
                    //补上版本号
                    url += "?" + ak.ResMgr.ver;
                }
                var res = RES.getRes(url);
                if (res) {
                    this.__myGetResCompleted(res, url);
                }
                else {
                    RES.getResByUrl(url, this.onGetResByUrl, this, RES.ResourceItem.TYPE_IMAGE);
                }
            }
        };
        FariyGUI_GLoader.prototype.onGetResAsync = function (res, key) {
            if (res instanceof egret.Texture) {
                this.__myGetResCompleted(res, key);
            }
            else {
                RES.getResAsync(key, this.onGetResAsync, this);
            }
        };
        FariyGUI_GLoader.prototype.onGetResByUrl = function (res, key) {
            if (res instanceof egret.Texture) {
                this.__myGetResCompleted(res, key);
            }
            else {
                RES.getResByUrl(key, this.onGetResByUrl, this, RES.ResourceItem.TYPE_IMAGE);
            }
        };
        FariyGUI_GLoader.prototype.__myGetResCompleted = function (res, key) {
            if (res instanceof egret.Texture) {
                this.onExternalLoadSuccess(res);
            }
            else {
                this.onExternalLoadFailed();
            }
        };
        FariyGUI_GLoader.staticResRoot = ""; //resource/static/资源前缀（例如微信小程序需要从指定某域名前缀来加载图片）
        return FariyGUI_GLoader;
    }(fairygui.GLoader));
    ak.FariyGUI_GLoader = FariyGUI_GLoader;
    __reflect(FariyGUI_GLoader.prototype, "ak.FariyGUI_GLoader");
})(ak || (ak = {}));
var ak;
(function (ak) {
    //提交表单
    var Form = (function () {
        function Form(url, //网络路径
            method, //get或post
            params, //参数字典
            onSucc, //成功回调函数
            onError, //失败回调函数
            obj, //回调函数的绑定对象
            notCache) {
            if (notCache === void 0) { notCache = false; }
            this.obj = obj;
            this.onSucc = onSucc;
            this.onError = onError;
            method = method.toLowerCase();
            var paramsStr = "";
            for (var key in params) {
                var val = params[key];
                if (paramsStr == "")
                    paramsStr = key + "=" + val;
                else
                    paramsStr += "&" + key + "=" + val;
            }
            if (method == "get") {
                if (paramsStr != "")
                    url += "?" + paramsStr;
                paramsStr = "";
            }
            if (notCache) {
                url += "?" + Math.random();
            }
            // url +="?" + Math.random();
            console.log("请求网络=", url);
            var req = new egret.HttpRequest();
            req.responseType = egret.HttpResponseType.TEXT;
            if (method == "get")
                req.open(url, egret.HttpMethod.GET);
            else if (method == "post")
                req.open(url, egret.HttpMethod.POST);
            else
                throw "error";
            if (notCache) {
                console.log("设置不用缓存2");
                req.setRequestHeader('Cache-Control', "max-age=0");
                req.setRequestHeader('Cache-Control', 'no-cache');
                // req.setRequestHeader('Cache-Control', 'no-store'); 
            }
            req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded;charset=UTF-8");
            if (paramsStr == "")
                req.send();
            else
                req.send(paramsStr);
            req.addEventListener(egret.Event.COMPLETE, function (event) {
                var req = event.currentTarget;
                var data = req.response;
                onSucc.call(obj, data);
            }, this);
            req.addEventListener(egret.IOErrorEvent.IO_ERROR, function () {
                onError.call(obj);
            }, this);
            //        req.addEventListener(egret.ProgressEvent.PROGRESS,() => {
            //            //
            //        },this);
        }
        return Form;
    }());
    ak.Form = Form;
    __reflect(Form.prototype, "ak.Form");
    var FormMethod = (function () {
        function FormMethod() {
        }
        FormMethod.get = "get";
        FormMethod.post = "post";
        return FormMethod;
    }());
    ak.FormMethod = FormMethod;
    __reflect(FormMethod.prototype, "ak.FormMethod");
})(ak || (ak = {}));
var ak;
(function (ak) {
    var Img = (function (_super) {
        __extends(Img, _super);
        function Img() {
            var _this = _super.call(this) || this;
            _this.addEventListener(egret.Event.ADDED_TO_STAGE, function () {
                if (_this._url) {
                    _this.loadUrl(_this._url);
                }
            }, _this);
            _this.addEventListener(egret.Event.REMOVED_FROM_STAGE, function () {
                //从舞台移除时
                _this.destroy();
            }, _this);
            return _this;
        }
        Object.defineProperty(Img.prototype, "url", {
            get: function () {
                return this._url;
            },
            set: function (url) {
                this.loadUrl(url);
            },
            enumerable: true,
            configurable: true
        });
        //加载
        Img.prototype.loadUrl = function (url) {
            if (this.numChildren > 0 && url == this._url) {
                return;
            }
            this.destroy();
            if (url != "") {
                this._url = url;
                if (this.stage) {
                    ak.ResMgr.loadImg(url, this.onImgLoadComplete, this);
                }
            }
        };
        Img.prototype.onImgLoadComplete = function (tex, url) {
            if (!this.stage) {
                return;
            }
            if (this._url == url) {
                var bmp = new egret.Bitmap(tex);
                this.addChild(bmp);
            }
        };
        //销毁
        Img.prototype.destroy = function () {
            if (this.numChildren == 0) {
                return;
            }
            if (this._url == "") {
                return;
            }
            ak.ResMgr.releaseTexture(this._url);
            this._url = "";
            this.removeChildren();
        };
        return Img;
    }(egret.DisplayObjectContainer));
    ak.Img = Img;
    __reflect(Img.prototype, "ak.Img");
})(ak || (ak = {}));
var ak;
(function (ak) {
    //json数值表管理器
    var JsonTableMgr = (function () {
        function JsonTableMgr() {
        }
        JsonTableMgr.get = function (jsonName) {
            return this.table[jsonName];
        };
        //加载数值大表
        JsonTableMgr.loadBigTable = function (root, //url根
            clientTablesUrl, //json数值大表url
            callback, //回调函数
            thisObj, //回调函数对象
            isUseVer //是否使用版本号（微信小程序填false）
        ) {
            var _this = this;
            //加载数值表版本文件
            var verFileName = "ver.txt";
            var verUrl = root + verFileName;
            if (isUseVer) {
                verUrl += "?" + new Date().getTime();
            }
            ak.ResMgr.loadTxt([[verFileName, verUrl]], function () {
                var verStr = ak.ResMgr.getTxt(verFileName); //版本号字符串
                ////////////////////////////////////////////////////////////////////////////////////////////////////
                if (isUseVer) {
                    clientTablesUrl; //+="?"+verStr+"_"+ResMgr.ver;
                }
                ak.ResMgr.loadTxt([[clientTablesUrl, clientTablesUrl]], function () {
                    var clientTablesJson = ak.json_decode(ak.ResMgr.getTxt(clientTablesUrl));
                    //保存json表
                    for (var name_1 in clientTablesJson) {
                        var json = clientTablesJson[name_1];
                        _this.table[name_1] = new JsonTable(ak.json_encode(json));
                    }
                    //回调
                    callback.call(thisObj);
                }, _this);
                ////////////////////////////////////////////////////////////////////////////////////////////////////
            }, this);
        };
        JsonTableMgr.load = function (root, //url根
            jsonNameArr, //json数值表名数组
            callback, //回调函数
            thisObj, //回调函数对象
            isUseVer //是否使用版本号（微信小程序填false）
        ) {
            var _this = this;
            //加载数值表版本文件
            var verFileName = "ver.txt";
            var verUrl = root + verFileName;
            if (isUseVer) {
                verUrl += "?" + new Date().getTime();
            }
            ak.ResMgr.loadTxt([[verFileName, verUrl]], function () {
                var verStr = ak.ResMgr.getTxt(verFileName); //版本号字符串
                ////////////////////////////////////////////////////////////////////////////////////////////////////
                var jsonInfoArr = [];
                for (var i = 0; i < jsonNameArr.length; ++i) {
                    var jsonName = jsonNameArr[i] + ".json";
                    var url = root + jsonName;
                    if (isUseVer) {
                        url += "?" + verStr;
                    }
                    jsonInfoArr.push([jsonName, url]);
                }
                //AKResGroupMgr.inst.loadTxt(jsonInfoArr,callback,thisObj);
                ak.ResMgr.loadTxt(jsonInfoArr, function () {
                    //保存json表
                    for (var i = 0; i < jsonNameArr.length; ++i) {
                        var name_2 = jsonNameArr[i];
                        _this.table[name_2] = new JsonTable(ak.ResMgr.getTxt(name_2 + ".json"));
                    }
                    //回调
                    callback.call(thisObj);
                }, _this);
                ////////////////////////////////////////////////////////////////////////////////////////////////////
            }, this);
        };
        JsonTableMgr.table = {};
        return JsonTableMgr;
    }());
    ak.JsonTableMgr = JsonTableMgr;
    __reflect(JsonTableMgr.prototype, "ak.JsonTableMgr");
    //json数值表
    var JsonTable = (function () {
        function JsonTable(jsonStr) {
            this.colMap = {};
            this.colNameMapMap = {};
            this.json = ak.json_decode(jsonStr);
            this.initColMap();
        }
        JsonTable.prototype.size = function () {
            return this.json['data'].length;
        };
        //获取表头信息
        JsonTable.prototype.getHead = function () {
            return this.json['head'];
        };
        //根据行号获取行
        JsonTable.prototype.getRow = function (rowIndex) {
            if (rowIndex < 0 || rowIndex >= this.size()) {
                throw "行不存在";
            }
            return new JsonTableRow(this.json['data'][rowIndex], this.colMap);
        };
        //用于加速getRowFromColName的查询
        JsonTable.prototype.initColNameMap = function (colName) {
            var colNameMapMap = this.colNameMapMap;
            if (colNameMapMap[colName]) {
                return;
            }
            var colNameMap = {};
            var c = this.size();
            var i = 0;
            while (i < c) {
                var row = this.getRow(i);
                var val = row.getValFromColName(colName);
                var rowArr = void 0;
                if (ak.isNull(colNameMap[val])) {
                    rowArr = [];
                    colNameMap[val] = rowArr;
                }
                else {
                    rowArr = colNameMap[val];
                }
                rowArr.push(row);
                ++i;
            }
            colNameMapMap[colName] = colNameMap;
        };
        //根据列名获取多行
        JsonTable.prototype.getRowsFromColName = function (colName, val) {
            var rowArr = [];
            this.initColNameMap(colName);
            var colNameMapMap = this.colNameMapMap;
            var colNameMap = colNameMapMap[colName];
            if (ak.isNull(colNameMap[val])) {
                return (rowArr);
            }
            var curRowArr = colNameMap[val];
            var i = 0;
            var c = curRowArr.length;
            while (i < c) {
                rowArr.push(curRowArr[i]);
                ++i;
            }
            return (rowArr);
        };
        //根据列名获取一行
        JsonTable.prototype.getRowFromColName = function (colName, val) {
            this.initColNameMap(colName);
            var colNameMapMap = this.colNameMapMap;
            var colNameMap = colNameMapMap[colName];
            if (ak.isNull(colNameMap[val])) {
                // throw("行不存在");
                return null;
            }
            return (colNameMap[val][0]);
        };
        //根据2个列名匹配获取一行
        JsonTable.prototype.getRowFrom2ColName = function (colName1, val1, colName2, val2) {
            this.initColNameMap(colName1);
            var colNameMapMap = this.colNameMapMap;
            var colNameMap = colNameMapMap[colName1];
            if (ak.isNull(colNameMap[val1])) {
                // throw("行不存在");
                return null;
            }
            var curRowArr = colNameMap[val1];
            var i = 0;
            var c = curRowArr.length;
            while (i < c) {
                var curRow = curRowArr[i];
                var curVal = curRow.getValFromColName(colName2);
                if (val2 == curVal) {
                    return (curRow);
                }
                ++i;
            }
            return null;
        };
        JsonTable.prototype.initColMap = function () {
            var head = this.json['head'];
            var c = head.length;
            for (var i = 0; i < c; ++i) {
                var info = head[i];
                this.colMap[info[0]] = i;
            }
        };
        return JsonTable;
    }());
    ak.JsonTable = JsonTable;
    __reflect(JsonTable.prototype, "ak.JsonTable");
    ;
    //json数值表行
    var JsonTableRow = (function () {
        function JsonTableRow(row, colMap) {
            this.row = row;
            this.colMap = colMap;
        }
        //根据列名获取列值
        JsonTableRow.prototype.getValFromColName = function (colName) {
            var index = this.colMap[colName];
            return this.row[index];
        };
        //根据列索引获取列值
        JsonTableRow.prototype.getVal = function (index) {
            if (index < 0 || index >= this.size()) {
                throw "列不存在";
            }
            return this.row[index];
        };
        //获取对象（根据指定列名，返回对象）
        JsonTableRow.prototype.getObj = function (colNameArr) {
            var obj = {};
            var c = colNameArr.length;
            for (var i = 0; i < c; ++i) {
                var colName = colNameArr[i];
                obj[colName] = this.getValFromColName(colName);
            }
            return obj;
        };
        //获取数组（根据指定列名，返回数组）
        JsonTableRow.prototype.getArr = function (colNameArr) {
            var arr = [];
            var c = colNameArr.length;
            for (var i = 0; i < c; ++i) {
                var colName = colNameArr[i];
                arr.push(this.getValFromColName(colName));
            }
            return arr;
        };
        JsonTableRow.prototype.size = function () {
            return this.row.length;
        };
        return JsonTableRow;
    }());
    ak.JsonTableRow = JsonTableRow;
    __reflect(JsonTableRow.prototype, "ak.JsonTableRow");
})(ak || (ak = {}));
var ak;
(function (ak) {
    var MovieClip = (function (_super) {
        __extends(MovieClip, _super);
        function MovieClip(jsonUrl, pngUrl, actionName, playCount) {
            if (playCount === void 0) { playCount = -1; }
            var _this = _super.call(this) || this;
            _this.jsonUrl = jsonUrl;
            _this.pngUrl = pngUrl;
            _this.actionName = actionName;
            _this.playCount = playCount;
            _this.addEventListener(egret.Event.ADDED_TO_STAGE, function () {
                //加入舞台后，再进行资源加载
                _this.load();
            }, _this);
            _this.addEventListener(egret.Event.REMOVED_FROM_STAGE, function () {
                //从舞台移除时，销毁资源
                _this.destroy();
            }, _this);
            return _this;
        }
        //重新设置动画
        MovieClip.prototype.setAction = function (jsonUrl, pngUrl, actionName, playCount) {
            if (playCount === void 0) { playCount = -1; }
            if (this.jsonUrl == jsonUrl && this.actionName == actionName) {
                this.gotoAndPlay(1, playCount);
                return;
            }
            this.destroy();
            this.jsonUrl = jsonUrl;
            this.pngUrl = pngUrl;
            this.actionName = actionName;
            this.playCount = playCount;
            this.load();
        };
        //加载
        MovieClip.prototype.load = function () {
            if (RES.hasRes(this.jsonUrl)) {
                RES.getResAsync(this.jsonUrl, this.onLoadJsonComplete, this);
            }
            else {
                RES.getResByUrl(ak.ResMgr.getUrlFromVer(this.jsonUrl), this.onLoadJsonComplete, this, RES.ResourceItem.TYPE_JSON);
            }
        };
        MovieClip.prototype.onLoadJsonComplete = function (data, url) {
            if (!this.stage) {
                return;
            }
            if (this.jsonUrl != ak.ResMgr.getUrlOnly(url)) {
                return;
            }
            this.jsonData = data;
            ak.ResMgr.loadImg(this.pngUrl, this.onLoadPngComplete, this);
        };
        MovieClip.prototype.onLoadPngComplete = function (tex, url) {
            if (!this.stage) {
                ak.ResMgr.releaseTexture(url);
                return;
            }
            if (this.pngUrl == url) {
                this.texture = tex;
                this.createAni();
            }
        };
        //销毁
        MovieClip.prototype.destroy = function () {
            if (this.mcFactory) {
                this.mcFactory.clearCache();
            }
            if (this.texture) {
                ak.ResMgr.releaseTexture(this.pngUrl);
            }
            this.mcFactory = null;
            this.texture = null;
            this.jsonData = null;
        };
        //创建动画
        MovieClip.prototype.createAni = function () {
            if (!this.stage) {
                this.destroy();
                return;
            }
            if (this.jsonData && this.texture) {
                var frameRate = this.frameRate;
                if (this.mcFactory) {
                    this.mcFactory.clearCache();
                }
                else {
                    this.mcFactory = new egret.MovieClipDataFactory();
                }
                this.mcFactory.mcDataSet = this.jsonData;
                this.mcFactory.texture = this.texture;
                this.movieClipData = this.mcFactory.generateMovieClipData(this.actionName);
                this.gotoAndPlay(1, this.playCount);
                if (frameRate) {
                    this.frameRate = frameRate;
                }
            }
        };
        return MovieClip;
    }(egret.MovieClip));
    ak.MovieClip = MovieClip;
    __reflect(MovieClip.prototype, "ak.MovieClip");
})(ak || (ak = {}));
var ak;
(function (ak) {
    //资源管理器
    var ResMgr = (function () {
        function ResMgr() {
        }
        ResMgr.start = function (ver) {
            var _this = this;
            ResMgr._ver = ver;
            if (!this.startSign) {
                this.startSign = true;
                egret.setInterval(this.check, this, this.checkTime);
                RES.addEventListener(RES.ResourceEvent.GROUP_COMPLETE, function (e) {
                    ak.log("ak.ResMgr load " + e.groupName + " succ");
                    delete _this.loadGroupNameMap[e.groupName];
                    var c = _this.loadInfoArr.length;
                    for (var i = 0; i < c;) {
                        var info = _this.loadInfoArr[i];
                        if (info.groupName == e.groupName) {
                            --c;
                            _this.loadInfoArr.splice(i, 1);
                            info.callback.call(info.thisObj);
                        }
                        else {
                            ++i;
                        }
                    }
                }, this);
                RES.addEventListener(RES.ResourceEvent.GROUP_LOAD_ERROR, function (e) {
                    ak.log("ak.ResMgr load " + e.groupName + " error");
                    RES.loadGroup(e.groupName); //重新加载
                }, this);
            }
        };
        Object.defineProperty(ResMgr, "ver", {
            get: function () {
                return ResMgr._ver;
            },
            enumerable: true,
            configurable: true
        });
        //给url加上?和版本号
        ResMgr.getUrlFromVer = function (url) {
            if (ResMgr.ver == "")
                return url;
            return url + "?" + ResMgr.ver;
        };
        //删除url的?和版本号
        ResMgr.getUrlOnly = function (url) {
            return url.split("?")[0];
        };
        //引用纹理
        ResMgr.retainTexture = function (url) {
            var key = url; //tex.hashCode;
            if (this.textureMap[key]) {
                ++this.textureMap[key].count;
            }
            else {
                this.textureMap[key] = new TextureInfo(url);
            }
        };
        //释放纹理
        ResMgr.releaseTexture = function (url) {
            var key = url;
            var info = this.textureMap[key];
            if (info) {
                if (info.count > 0) {
                    --info.count;
                    if (info.count == 0) {
                        info.time = ak.time_milli();
                    }
                }
            }
        };
        ResMgr.check = function () {
            var ct = ak.time_milli();
            for (var key in this.textureMap) {
                var info = this.textureMap[key];
                // ak.log(info);
                if (info.count == 0 && (ct - info.time) >= this.releaseTimeout) {
                    var url2 = ResMgr.getUrlFromVer(info.url);
                    if (RES.getRes(url2))
                        RES.destroyRes(url2);
                    if (RES.getRes(info.url))
                        RES.destroyRes(info.url);
                    delete this.textureMap[key];
                    ak.log("destroy", info.url);
                }
            }
        };
        //获取网络文本文件
        ResMgr.getTxt = function (name) {
            return this.txtMap[name];
        };
        //加载网络文本文件
        ResMgr.loadTxt = function (fileInfoArr, //json资源对列表，例如：[["hero","http://xxoo.com/hero.json"],["item","http://xxoo.com/item.json"],...]
            callback, //回调函数
            thisObj //回调函数对象
        ) {
            if (this.loadTxtCallback != null) {
                ak.log(this.fileInfoArr);
                throw "ak.ResMgr.inst.loadTxt 不能同时加载多次";
            }
            this.fileInfoArr = fileInfoArr;
            this.loadTxtCallback = callback;
            this.loadTxtThisObj = thisObj;
            this.continueLoadTxt();
        };
        ResMgr.continueLoadTxt = function () {
            var _this = this;
            if (this.fileInfoArr.length == 0) {
                var callback = this.loadTxtCallback;
                var thisObj = this.loadTxtThisObj;
                this.loadTxtCallback = null;
                this.loadTxtThisObj = null;
                callback.call(thisObj);
            }
            else {
                this.fileInfo = this.fileInfoArr[0];
                new ak.Form(this.fileInfo[1], "get", {}, 
                //onSucc
                function (data) {
                    _this.fileInfoArr.splice(0, 1);
                    _this.txtMap[_this.fileInfo[0]] = data;
                    _this.continueLoadTxt();
                }, 
                //onError
                function () {
                    ak.log("AKResGroupMgr.inst.loadTxt error");
                    var timer = new egret.Timer(3000, 1);
                    timer.once(egret.TimerEvent.TIMER_COMPLETE, function () {
                        _this.continueLoadTxt();
                    }, _this);
                    timer.start();
                }, this, true);
            }
        };
        //加载资源组
        ResMgr.loadGroup = function (groupName, callback, thisObj) {
            if (RES.isGroupLoaded(groupName)) {
                callback.call(thisObj);
            }
            else {
                var info = new LoadInfo();
                info.groupName = groupName;
                info.callback = callback;
                info.thisObj = thisObj;
                this.loadInfoArr.push(info);
                if (!this.loadGroupNameMap[groupName]) {
                    RES.loadGroup(groupName);
                }
            }
        };
        //加载资源组fui静态图
        ResMgr.loadGroupByStatic = function (groupName, //资源组名
            callback, thisObj) {
            var urlArr = [];
            var infoArr = RES.getGroupByName(groupName);
            for (var i = 0; i < infoArr.length; ++i) {
                var info = infoArr[i];
                urlArr.push(this.getUrlOnly(info.root + info.url));
            }
            this.loadImgArr(urlArr, callback, thisObj);
        };
        //加载图片数组
        ResMgr.loadImgArr = function (urlArr, //资源名或资源url数组
            callback, thisObj) {
            if (this.urlArrForLoadImgArr) {
                throw ("ResMgr.loadImgArr() 同时多次调用错误");
            }
            if (urlArr.length == 0) {
                callback.call(thisObj);
                return;
            }
            this.callbackForLoadImgArr = callback;
            this.thisObjForLoadImgArr = thisObj;
            this.urlArrForLoadImgArr = urlArr;
            this.indexForLoadImgArr = 0;
            this.loadImg(this.urlArrForLoadImgArr[this.indexForLoadImgArr], this.onLoadCompleteForloadImgArr, this);
        };
        ResMgr.onLoadCompleteForloadImgArr = function () {
            ++this.indexForLoadImgArr;
            if (this.indexForLoadImgArr >= this.urlArrForLoadImgArr.length) {
                //完成所有加载
                this.callbackForLoadImgArr.call(this.thisObjForLoadImgArr);
                //重置
                this.indexForLoadImgArr = 0;
                this.urlArrForLoadImgArr = null;
                this.callbackForLoadImgArr = null;
                this.thisObjForLoadImgArr = null;
                return;
            }
            this.loadImg(this.urlArrForLoadImgArr[this.indexForLoadImgArr], this.onLoadCompleteForloadImgArr, this);
        };
        //加载单张图片
        ResMgr.loadImg = function (url, //资源名或资源url
            callback, thisObj) {
            this.retainTexture(url);
            var info = this.textureMap[url];
            if (info.reqLoadSign) {
                var targetUrl = "";
                if (RES.hasRes(url)) {
                    targetUrl = url;
                }
                else {
                    targetUrl = this.getUrlFromVer(url);
                }
                if (RES.getRes(targetUrl)) {
                    if (RES.hasRes(url)) {
                        var tex = RES.getRes(url);
                        callback.call(thisObj, tex, url);
                    }
                    else {
                        var tex = RES.getRes(targetUrl);
                        callback.call(thisObj, tex, url);
                    }
                }
                else {
                    info.callbackInfoArr.push([callback, thisObj]);
                }
            }
            else {
                info.reqLoadSign = true;
                info.callbackInfoArr.push([callback, thisObj]);
                if (RES.hasRes(url)) {
                    RES.getResAsync(url, this.onImgLoadComplete, this);
                }
                else {
                    RES.getResByUrl(this.getUrlFromVer(url), this.onImgLoadComplete, this, RES.ResourceItem.TYPE_IMAGE);
                }
            }
        };
        ResMgr.onImgLoadComplete = function (tex, url) {
            url = ak.ResMgr.getUrlOnly(url);
            var key = url;
            var texInfo = this.textureMap[key];
            for (var i = 0; i < texInfo.callbackInfoArr.length; ++i) {
                var callbackArr = texInfo.callbackInfoArr[i];
                callbackArr[0].call(callbackArr[1], tex, url);
            }
            texInfo.callbackInfoArr.length = 0;
        };
        ResMgr.releaseTimeout = 300 * 1000; //释放多久回收资源（毫秒）
        ResMgr.checkTime = 5 * 1000; //检测时间（毫秒）
        ResMgr.startSign = false; //启动标识
        ResMgr.textureMap = {}; //纹理引用计数字典
        ResMgr._ver = ""; //资源版本号
        ResMgr.loadInfoArr = [];
        ResMgr.loadGroupNameMap = {};
        //json table配置文件
        ResMgr.txtMap = {};
        ResMgr.indexForLoadImgArr = 0;
        return ResMgr;
    }());
    ak.ResMgr = ResMgr;
    __reflect(ResMgr.prototype, "ak.ResMgr");
    var TextureInfo = (function () {
        function TextureInfo(url) {
            this.count = 1; //引用计数
            this.time = 0; //计数清0时间戳
            this.reqLoadSign = false; //是否已发起加载
            this.callbackInfoArr = [];
            this.url = url;
        }
        return TextureInfo;
    }());
    __reflect(TextureInfo.prototype, "TextureInfo");
    var LoadInfo = (function () {
        function LoadInfo() {
        }
        return LoadInfo;
    }());
    __reflect(LoadInfo.prototype, "LoadInfo");
})(ak || (ak = {}));
var ak;
(function (ak) {
    //声音管理器
    var SoundMgr = (function () {
        function SoundMgr() {
            this.soundMap = {};
            this.playSoundArr = []; //音效播放数组
            this._musicVolume = 1; //背景音量（音量：0~1）
            this._soundVolume = 1; //背景音量（音量：0~1）
            this._openMusic = 1;
            this._openSound = 1;
            //音乐淡入淡出时间（毫秒）
            this.musicFadeDt = 0;
            //音乐淡入淡出百分比
            this._musicFadePercent = 1;
        }
        Object.defineProperty(SoundMgr.prototype, "musicFadePercent", {
            get: function () {
                return this._musicFadePercent;
            },
            set: function (percent) {
                this._musicFadePercent = percent;
                if (this.playMusicObj != null && this.playMusicObj.channel != null) {
                    this.playMusicObj.channel.volume = this._musicVolume * this._openMusic * this._musicFadePercent;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoundMgr.prototype, "openMusic", {
            get: function () {
                return this._openMusic == 1 ? true : false;
            },
            set: function (isOpen) {
                if (isOpen)
                    this._openMusic = 1;
                else
                    this._openMusic = 0;
                this.musicVolume = this.musicVolume;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoundMgr.prototype, "openSound", {
            get: function () {
                return this._openSound == 1 ? true : false;
            },
            set: function (isOpen) {
                if (isOpen)
                    this._openSound = 1;
                else
                    this._openSound = 0;
                this.soundVolume = this.soundVolume;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoundMgr.prototype, "volume", {
            //设置音量（全部声效+背景音乐）
            set: function (volume //音量：0~1
            ) {
                this.musicVolume = volume;
                this.soundVolume = volume;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoundMgr.prototype, "musicVolume", {
            //获取背景音乐音量
            get: function () {
                return this._musicVolume;
            },
            //设置背景音乐音量
            set: function (volume //音量：0~1
            ) {
                this._musicVolume = volume;
                if (this.playMusicObj != null && this.playMusicObj.channel != null) {
                    this.playMusicObj.channel.volume = volume * this._openMusic;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(SoundMgr.prototype, "soundVolume", {
            //获取音效音量
            get: function () {
                return this._soundVolume;
            },
            //设置音效音量
            set: function (volume //音量：0~1
            ) {
                this._soundVolume = volume;
                for (var i = 0; i < this.playSoundArr.length; ++i) {
                    var playSound = this.playSoundArr[i];
                    if (playSound.channel != null) {
                        playSound.channel.volume = volume * this._openSound;
                    }
                }
            },
            enumerable: true,
            configurable: true
        });
        //播放音效
        SoundMgr.prototype.playSound = function (url) {
            if (this._openSound == 0) {
                return;
            }
            this.playSoundArr.push(new AKPlaySound(url));
            var sound = this.soundMap[url];
            if (sound == null) {
                var mySound = new AKSound(url);
                this.soundMap[url] = mySound;
            }
            else {
                this.continuePlaySound();
            }
        };
        //播放背景音乐（新音乐替换旧音乐）
        SoundMgr.prototype.playMusic = function (url) {
            var _this = this;
            if (this.playMusicObj != null && this.playMusicObj.url == url) {
                return;
            }
            if (this.musicFadeDt > 0) {
                egret.Tween.get(this)
                    .to({ musicFadePercent: 0 }, this.musicFadeDt)
                    .call(function () {
                    _this._PlayMusic(url);
                }, this)
                    .to({ musicFadePercent: 1 }, this.musicFadeDt);
            }
            else {
                this._PlayMusic(url);
            }
        };
        SoundMgr.prototype._PlayMusic = function (url) {
            this.stopMusic();
            this.playMusicObj = new AKPlayMusic(url);
            var sound = this.soundMap[url];
            if (sound == null) {
                var mySound = new AKSound(url);
                this.soundMap[url] = mySound;
            }
            else {
                this.continuePlaySound();
            }
        };
        //关闭背景音乐
        SoundMgr.prototype.stopMusic = function () {
            if (this.playMusicObj != null) {
                if (this.playMusicObj.channel != null) {
                    this.playMusicObj.channel.stop();
                }
            }
        };
        //关闭所有音效
        SoundMgr.prototype.stopAllSound = function () {
            var playSoundArr = this.playSoundArr;
            for (var i = 0; i < playSoundArr.length; ++i) {
                var myPlaySound = playSoundArr[i];
                if (myPlaySound.channel != null) {
                    myPlaySound.channel.volume = 0;
                    myPlaySound.channel.stop();
                    // ak.log("stop",myPlaySound.channel.$hashCode);
                }
            }
            playSoundArr.splice(0, playSoundArr.length);
        };
        SoundMgr.prototype.continuePlaySound = function () {
            var playSoundArr = this.playSoundArr;
            for (var i = 0; i < playSoundArr.length; ++i) {
                var myPlaySound = playSoundArr[i];
                var mySound = this.soundMap[myPlaySound.url];
                if (mySound.loadComplete) {
                    myPlaySound.play(mySound.sound);
                }
            }
            if (this.playMusicObj != null && this.playMusicObj.status == 0) {
                var mySound = this.soundMap[this.playMusicObj.url];
                if (mySound.loadComplete) {
                    this.playMusicObj.play(mySound.sound);
                }
            }
        };
        //清理播放完或播放超时的播放请求
        SoundMgr.prototype.clean = function () {
            var playSoundArr = this.playSoundArr;
            for (var i = 0; i < playSoundArr.length;) {
                var myPlaySound = playSoundArr[i];
                var dt = Date.now() - myPlaySound.genTime;
                if (myPlaySound.status == 0 && dt >= (1000 * 5)) {
                    playSoundArr.splice(i, 1);
                }
                if (myPlaySound.status == 2) {
                    playSoundArr.splice(i, 1);
                }
                else {
                    ++i;
                }
            }
        };
        SoundMgr.inst = new SoundMgr();
        return SoundMgr;
    }());
    ak.SoundMgr = SoundMgr;
    __reflect(SoundMgr.prototype, "ak.SoundMgr");
    var AKSound = (function () {
        function AKSound(url) {
            var _this = this;
            this.loadComplete = false;
            this.sound = new egret.Sound();
            this.sound.addEventListener(egret.Event.COMPLETE, function () {
                _this.loadComplete = true;
                SoundMgr.inst.continuePlaySound();
            }, this);
            this.sound.addEventListener(egret.IOErrorEvent.IO_ERROR, function () {
            }, this);
            this.sound.load(url);
        }
        return AKSound;
    }());
    __reflect(AKSound.prototype, "AKSound");
    var AKPlaySound = (function () {
        function AKPlaySound(url) {
            this.genTime = Date.now();
            this.status = 0; //状态：0=未播放；1=播放中；2=播放完；
            this.url = url;
        }
        AKPlaySound.prototype.play = function (sound) {
            var _this = this;
            if (this.status != 0)
                return;
            this.channel = sound.play(0, 1);
            if (SoundMgr.inst.openSound) {
                this.channel.volume = SoundMgr.inst.soundVolume;
            }
            else {
                this.channel.volume = 0;
            }
            this.status = 1;
            // ak.log("play",this.channel.$hashCode);
            this.channel.addEventListener(egret.Event.SOUND_COMPLETE, function () {
                _this.channel.stop();
                _this.status = 2;
                SoundMgr.inst.clean();
            }, this);
        };
        return AKPlaySound;
    }());
    __reflect(AKPlaySound.prototype, "AKPlaySound");
    var AKPlayMusic = (function () {
        function AKPlayMusic(url) {
            this.status = 0; //状态：0=未播放；1=播放中；
            this.url = url;
        }
        AKPlayMusic.prototype.play = function (sound) {
            this.channel = sound.play(0, 0);
            if (SoundMgr.inst.openMusic) {
                this.channel.volume = SoundMgr.inst.musicVolume;
            }
            else {
                this.channel.volume = 0;
            }
            this.status = 1;
        };
        return AKPlayMusic;
    }());
    __reflect(AKPlayMusic.prototype, "AKPlayMusic");
})(ak || (ak = {}));
//配置
var MyConfig = (function () {
    function MyConfig() {
    }
    MyConfig.debug = true; //控制台是否输出调试信息
    MyConfig.testPay = false; //模拟支付
    MyConfig.wss = false; //wss连接开关（websocket）
    MyConfig.ver = "021"; //游戏版本号
    MyConfig.appVersion = "";
    MyConfig.useClientTables = true; //使用前端合并大表（server/wwww/json_table/clientTables.json）
    MyConfig.loginType = 1; //登录方式：0=本地模式；1=QUICKSDK_App; 2=QUICKSDK_H5; 3=QUICKSDK_IOS;4=测试QUICKSDK_App
    MyConfig.loginHotUpdate = false;
    //区服列表文件路径
    // public static serverListJsonUrl= "http://47.107.110.39/serverList.json"; //正式服
    MyConfig.serverListJsonUrl = "http://120.76.142.133:8889/serverList.json"; //专属服
    MyConfig.LocalserverListJsonUrl = "http://120.76.142.133:8889/serverList.json"; // "../serverList.json";//"http://119.29.33.233/serverList.json"; //测试服
    //账号服
    // public static accountJsonUrl= "http://47.107.110.39:5899/api/getUsers"; 	//正式服
    MyConfig.accountJsonUrl = "http://120.76.142.133:5889/api/getUsers"; //专属服
    MyConfig.LocalaccountJsonUrl = "http://120.76.142.133:5889/api/getUsers"; //"http://119.29.33.233:5899/api/getUsers";//测试服
    //客户端资源表
    //  public static clientResUrl:string= "http://47.107.110.39/clientRes/resVersion.json"; 		//正式服
    //  public static clientResUrl_ios:string= "http://47.107.110.39/clientRes_ios/resVersion.json";//正式服
    MyConfig.clientResUrl = "http://120.76.142.133:8889/clientRes/resVersion.json"; //专属服
    MyConfig.clientResUrl_ios = "http://120.76.142.133:8889/clientRes_ios/resVersion.json"; //专属服
    //json数值表url根
    MyConfig.jsonTableRoot = "http://120.76.142.133:8889/json_table/";
    //json数值表前端大表路径
    MyConfig.clientTablesUrl = "http://120.76.142.133:8889/clientTables.json"; //"resource/clientTables.json";//
    MyConfig.LocalclientResUrl = "resVersion.json";
    //////////////////////////////////////////////////////////////////////////////////////////////////////////////
    //资源列表文件路径
    MyConfig.resJsonUrl = "resource/default.res.json";
    //资源目录
    MyConfig.resDir = "resource/"; //"resource/";//"http://47.107.110.39/resource/";
    //fairygui中访问静态资源时加上前缀（一般微信小游戏由于资源是放在其它服务器上的所以会用到）
    MyConfig.staticResRoot = ""; //"http://47.107.110.39/client/";//"http://47.107.110.39/";
    //////////////////////////////////////////////////////////////////////////////////////////////////////////////
    MyConfig.openClickSound = false; //打开默认点击音效
    MyConfig.openGuide = true; //是否打开新手引导
    MyConfig.openActivity = true; //是否打开活动列表
    MyConfig.openBuyDiamond = true; //是否显示购买钻石按钮
    MyConfig.openBuyMoney = true; //是否显示点金按钮
    return MyConfig;
}());
__reflect(MyConfig.prototype, "MyConfig");
var ak;
(function (ak) {
    //2D向量类
    var Vector2D = (function () {
        function Vector2D(x, y) {
            this.x = 0;
            this.y = 0;
            if (x)
                this.x = x;
            if (y)
                this.y = y;
        }
        Vector2D.prototype.off = function (dx, dy) {
            this.x += dx;
            this.y += dy;
            return this;
        };
        Vector2D.prototype.setFromPos = function (pos) {
            this.x = pos.x;
            this.y = pos.y;
            return this;
        };
        Vector2D.prototype.set = function (x, y) {
            this.x = x;
            this.y = y;
            return this;
        };
        //获取相反的向量
        Vector2D.prototype.invert = function () {
            return new Vector2D(-this.x, -this.y);
        };
        //点乘
        Vector2D.prototype.mul = function (num) {
            this.x *= num;
            this.y *= num;
            return this;
        };
        //向量归一化（转换为单位向量）
        Vector2D.prototype.normalized = function () {
            var len = Math.sqrt(this.x * this.x + this.y * this.y);
            if (len > 0) {
                this.x /= len;
                this.y /= len;
            }
            return this;
        };
        //计算与另一位置的距离
        Vector2D.prototype.getLengthWhitPos = function (pos) {
            var dx = pos.x - this.x;
            var dy = pos.y - this.y;
            return Math.sqrt(dx * dx + dy * dy);
        };
        //根据[与场景x轴所成的角度]转换为向量（场景坐标系）
        Vector2D.prototype.setFromAngle = function (angle) {
            var radian = angle * Math.PI / 180;
            this.x = Math.cos(radian);
            this.y = Math.sin(radian);
            return this;
        };
        //[单位向量]转为[其与场景x轴所成的角度]（场景坐标系）
        Vector2D.prototype.vector2Angle = function () {
            var angle = this._vector2Angle();
            if (angle == 0)
                return 0;
            else
                return 360 - angle;
        };
        //[单位向量]转为[其与场景x轴所成的角度]（场景坐标系）
        Vector2D.prototype._vector2Angle = function () {
            var v = new Vector2D(this.x, this.y);
            v.normalized(); //归一化
            if (v.x == 0 && v.y == 0)
                return 0;
            var dx = Math.abs(v.x);
            var dy = Math.abs(v.y);
            if (v.x == 0) {
                if (v.y < 0)
                    return 90;
                else
                    return 270;
            }
            else if (v.y == 0) {
                if (v.x < 0)
                    return 180;
                else
                    return 0;
            }
            var angle = Math.atan(dy / dx) * 180 / Math.PI;
            if (v.x > 0 && v.y < 0) {
                return angle;
            }
            else if (v.x < 0 && v.y < 0) {
                return 180 - angle;
            }
            else if (v.x < 0 && v.y > 0) {
                return 180 + angle;
            }
            return 360 - angle;
        };
        return Vector2D;
    }());
    ak.Vector2D = Vector2D;
    __reflect(Vector2D.prototype, "ak.Vector2D");
})(ak || (ak = {}));
//特效
var Effect = (function (_super) {
    __extends(Effect, _super);
    function Effect(resName, playCount) {
        var _this = _super.call(this) || this;
        _this.resName = resName;
        _this.playCount = playCount;
        return _this;
    }
    //初始化回调
    Effect.prototype.onInit = function () {
        var _this = this;
        var resName = this.resName;
        var mc = new ak.MovieClip(resName + "_json", resName + "_png", resName, this.playCount);
        this.onEgretEvent(mc, egret.Event.COMPLETE, function () {
            _this.destroy();
        }, this);
        this.addChild(mc);
        this.mc = mc;
    };
    return Effect;
}(ak.DisplayObjectContainer));
__reflect(Effect.prototype, "Effect");
//战斗特效
var BattleEffect = (function (_super) {
    __extends(BattleEffect, _super);
    function BattleEffect(resName) {
        var _this = _super.call(this) || this;
        _this.resName = resName;
        return _this;
    }
    //初始化回调
    BattleEffect.prototype.onInit = function () {
        var _this = this;
        var resName = this.resName;
        var mc = new ak.MovieClip(resName + "_json", resName + "_png", resName, 1);
        if (BattleScene.sceneArr.length > 0) {
            mc.frameRate = 24 * BattleScene.sceneArr[0].timeScale;
        }
        this.onEgretEvent(mc, egret.Event.COMPLETE, function () {
            _this.destroy();
        }, this);
        this.addChild(mc);
        this.mc = mc;
    };
    return BattleEffect;
}(ak.DisplayObjectContainer));
__reflect(BattleEffect.prototype, "BattleEffect");
//战斗场景
var BattleScene = (function (_super) {
    __extends(BattleScene, _super);
    function BattleScene() {
        var _this = _super.call(this) || this;
        _this.eventIndex = 0;
        _this.roleLayer = new egret.DisplayObjectContainer(); //角色层
        _this.heroArr1 = [null, null, null, null, null, null];
        _this.heroArr2 = [null, null, null, null, null, null];
        _this.pauseSign = false; //暂停标记
        _this._timeScale = 1; //时间缩放
        //播放战斗音乐
        MusicMgr.playBattleMusic();
        return _this;
    }
    Object.defineProperty(BattleScene.prototype, "timeScale", {
        get: function () {
            return this._timeScale;
        },
        set: function (scale) {
            this._timeScale = scale;
            var heroArr1 = this.heroArr1;
            for (var i = 0; i < heroArr1.length; ++i) {
                var role = heroArr1[i];
                if (role) {
                    role.timeScale = scale;
                }
            }
            var heroArr2 = this.heroArr2;
            for (var i = 0; i < heroArr2.length; ++i) {
                var role = heroArr2[i];
                if (role) {
                    role.timeScale = scale;
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    //初始化回调
    BattleScene.prototype.onInit = function () {
        var bg = new ak.Img();
        bg.url = "zhandou_01_jpg";
        this.addChild(bg);
        //层级
        this.addChild(this.roleLayer);
        //添加到战斗场景数组
        BattleScene.sceneArr.push(this);
    };
    //销毁回调
    BattleScene.prototype.onDestroy = function () {
        var sceneArr = BattleScene.sceneArr;
        for (var i = 0; i < sceneArr.length; ++i) {
            if (sceneArr[i] == this) {
                //从战斗场景数组删除
                sceneArr.splice(i, 1);
                break;
            }
        }
        //播放主城音乐
        MusicMgr.playMainCityMusic();
    };
    //战斗暂停
    BattleScene.prototype.pause = function () {
        this.pauseSign = true;
    };
    //战斗结束
    BattleScene.prototype.end = function () {
        this.pauseSign = true;
        ak.EventMgr.dispatch(GameEvent.fightComplete);
    };
    //战斗恢复
    BattleScene.prototype.resume = function () {
        this.pauseSign = false;
        this.next();
    };
    //启动（播放战报）
    BattleScene.prototype.start = function (report //战报
    ) {
        this.report = report;
        this.formatReport();
        var roleArr1 = report.roleArr1;
        var roleArr2 = report.roleArr2;
        this.createRoleArr(roleArr1, 1);
        this.createRoleArr(roleArr2, 2);
        this.sortAllRole();
        this.next();
    };
    //向前查找事件并合并删除buff伤害
    BattleScene.prototype.findAndRemoveBuffHurt = function (eventIndex, teamID, pos) {
        var totalHurt = 0;
        var eventArr = this.report.eventArr;
        for (var i = eventIndex - 1; i >= 0; --i) {
            var event_1 = eventArr[i];
            var eventName = event_1[0];
            if (eventName == "line") {
                break;
            }
            else if (eventName == "buffSubHP") {
                var curTeamID = event_1[1];
                var curPos = event_1[2];
                var curHp = event_1[3]; //减血
                if (curTeamID == teamID && curPos == pos) {
                    totalHurt += curHp;
                    eventArr.splice(i, 1);
                    ++i;
                    --eventIndex;
                }
            }
        }
        for (var i = eventIndex + 1; i < eventArr.length; ++i) {
            var event_2 = eventArr[i];
            var eventName = event_2[0];
            if (eventName == "line") {
                break;
            }
            else if (eventName == "buffSubHP") {
                var curTeamID = event_2[1];
                var curPos = event_2[2];
                var curHp = event_2[3]; //减血
                if (curTeamID == teamID && curPos == pos) {
                    totalHurt += curHp;
                    eventArr.splice(i, 1);
                    --i;
                }
            }
        }
        return [eventIndex, totalHurt];
    };
    //合并战报中伤害
    BattleScene.prototype.formatReport = function () {
        var eventArr = this.report.eventArr;
        for (var i = 0; i < eventArr.length; ++i) {
            var event_3 = eventArr[i];
            var eventName = event_3[0];
            switch (eventName) {
                case 'atk':
                case 'skill':
                    var defTeamID = event_3[4];
                    var defInfoArr = event_3[5];
                    for (var j = 0; j < defInfoArr.length; ++j) {
                        var defRoleInfo = defInfoArr[j];
                        var defPos = defRoleInfo[0];
                        // let hurtPoint=defRoleInfo[1];
                        var info = this.findAndRemoveBuffHurt(i, defTeamID, defPos);
                        i = info[0];
                        defRoleInfo[1] += info[1];
                    }
                    break;
            }
        }
    };
    BattleScene.prototype.next = function () {
        if (!this.stage) {
            return;
        }
        if (this.pauseSign) {
            return;
        }
        var eventArr = this.report.eventArr;
        if (this.eventIndex >= eventArr.length) {
            return;
        }
        var loop = true;
        while (loop) {
            loop = false;
            var event_4 = eventArr[this.eventIndex];
            this.curEvent = event_4;
            var eventName = event_4[0];
            switch (eventName) {
                case 'atk':
                case 'skill':
                    this.atk(event_4);
                    break;
                case 'buffAddHP'://buff加血
                    this.buffAddHP(event_4);
                    loop = true;
                    break;
                case 'buffSubHP'://buff扣血
                    this.buffSubHP(event_4);
                    loop = true;
                    break;
                case 'addBuff'://添加buff
                    this.addBuff(event_4);
                    loop = true;
                    break;
                case 'removeBuff'://删除buff
                    this.removeBuff(event_4);
                    loop = true;
                    break;
                case 'cleanAllBuff':
                    this.cleanAllBuff(event_4);
                    loop = true;
                    break;
                case 'reborn':
                    this.reborn(event_4);
                    loop = true;
                    break;
                case 'addPower':
                    this.addPower(event_4);
                    loop = true;
                    break;
                case 'godWeaponPower':
                    this.godWeaponPower(event_4);
                    // loop=true;
                    egret.Tween.get(this).to({}, 500).call(this.next, this);
                    break;
                case 'win':
                    break;
                case 'round':
                    //回合开始
                    var num = event_4[1];
                    ak.EventMgr.dispatch(GameEvent.fightRoundupdate, num);
                default:
                    loop = true;
                    break;
            }
            ++this.eventIndex;
            if (this.eventIndex >= eventArr.length) {
                //战斗结束
                ak.EventMgr.dispatch(GameEvent.fightComplete);
                break;
            }
        }
        this.sortAllRole();
    };
    //显示扣血动画
    BattleScene.prototype.showSubHPAni = function (defHero, hurtPoint, isCrit, hurtBySkill) {
        if (hurtPoint == 0)
            return;
        var ani;
        if (isCrit == 1) {
            ani = new BattleHPSubAni(this, 3, hurtPoint);
        }
        else {
            if (hurtBySkill) {
                ani = new BattleHPSubAni(this, 2, hurtPoint);
            }
            else {
                ani = new BattleHPSubAni(this, 1, hurtPoint);
            }
        }
        var x = defHero.x;
        var y = defHero.y - 80;
        ani.x = x;
        ani.y = y;
        var dir = defHero.teamID == 1 ? -1 : 1;
        egret.Tween.get(ani).to({ x: x + dir * 100 }, 1000).call(function () {
            // egret.Tween.removeTweens(ani);
            ani.close();
        });
    };
    //显示加血动画
    BattleScene.prototype.showAddHPAni = function (hero, addPoint) {
        var ani = new BattleHPSubAni(this, 4, addPoint);
        var x = hero.x;
        var y = hero.y - 80;
        ani.x = x;
        ani.y = y;
        var dir = hero.teamID == 1 ? -1 : 1;
        egret.Tween.get(ani).to({ x: x + dir * 100 }, 1000).call(function () {
            // egret.Tween.removeTweens(ani);
            ani.close();
        });
    };
    BattleScene.prototype.buffAddHP = function (event) {
        var teamID = event[1];
        var pos = event[2];
        var hp = event[3]; //显示加血
        var realHP = event[4]; //实际加血
        var hero = this.getHero(teamID, pos);
        hero.hp += realHP;
        hero.updateHeadUI();
        this.showAddHPAni(hero, hp);
    };
    BattleScene.prototype.buffSubHP = function (event) {
        var teamID = event[1];
        var pos = event[2];
        var hp = event[3]; //减血
        var hero = this.getHero(teamID, pos);
        hero.hp = hero.hp < hp ? 0 : hero.hp - hp;
        hero.updateHeadUI();
        this.showSubHPAni(hero, hp, 0, false);
        if (hero.hp <= 0) {
            //egret.Tween.get(hero).to({},1).call(()=>{
            hero.setAction("die", 1);
            //},this);
        }
    };
    BattleScene.prototype.addBuff = function (event) {
        var teamID = event[1];
        var pos = event[2];
        var buffID = event[3];
        var hero = this.getHero(teamID, pos);
        //增加buff
        hero.addBuff(buffID, 1);
    };
    BattleScene.prototype.godWeaponPower = function (event) {
        var teamID = event[1];
        var pos = event[2];
        var power = event[3];
        var hero = this.getHero(teamID, pos);
        hero.setPower(power);
        //神器能量事件
        ak.EventMgr.dispatch(GameEvent.godWeaponPower, [teamID, power]);
    };
    BattleScene.prototype.addPower = function (event) {
        var teamID = event[1];
        var pos = event[2];
        var power = event[3];
        var hero = this.getHero(teamID, pos);
        hero.addPower(power);
    };
    BattleScene.prototype.reborn = function (event) {
        var teamID = event[1];
        var pos = event[2];
        var hp = event[3];
        var hero = this.getHero(teamID, pos);
        hero.reborn(hp);
        this.showAddHPAni(hero, hp);
    };
    BattleScene.prototype.cleanAllBuff = function (event) {
        var teamID = event[1];
        var pos = event[2];
        var hero = this.getHero(teamID, pos);
        hero.cleanAllBuff();
    };
    BattleScene.prototype.removeBuff = function (event) {
        var teamID = event[1];
        var pos = event[2];
        var buffID = event[3];
        var hero = this.getHero(teamID, pos);
        //减少buff
        hero.addBuff(buffID, -1);
    };
    //反击
    BattleScene.prototype.hitBack = function (hitBackRole, targetRole, skillID, hurtPoint) {
        var skillActiveTab = ak.JsonTableMgr.get("skillActive");
        var row = skillActiveTab.getRowFromColName("id", "" + skillID);
        var hitEffect = row.getValFromColName("hitAni"); //受击特效
        var defHeroArr = [];
        defHeroArr.push(targetRole);
        targetRole.hp -= hurtPoint;
        targetRole.hurtPoint = hurtPoint;
        targetRole.hurtBySkill = false;
        targetRole.hitEffect = hitEffect;
        hitBackRole.atk(skillID, defHeroArr);
    };
    //攻击
    BattleScene.prototype.atk = function (event) {
        var isSkill = event[0] == 'skill' ? true : false;
        var skillID = event[1];
        var atkTeamID = event[2];
        var atkPos = event[3];
        var atkHero = this.getHero(atkTeamID, atkPos);
        if (isSkill) {
            atkHero.power = 0;
            if (atkHero.pos == 6) {
                //神器能量事件
                ak.EventMgr.dispatch(GameEvent.godWeaponPower, [atkHero.teamID, atkHero.power]);
            }
        }
        else {
            atkHero.power += 50;
        }
        atkHero.updateHeadUI();
        var skillActiveTab = ak.JsonTableMgr.get("skillActive");
        var row = skillActiveTab.getRowFromColName("id", "" + skillID);
        // let isMove=row.getValFromColName("moveTo")==1?true:false;
        var hitEffect = row.getValFromColName("hitAni"); //受击特效
        var defHeroArr = [];
        var defTeamID = event[4];
        var defInfoArr = event[5];
        for (var i = 0; i < defInfoArr.length; ++i) {
            var defPos = defInfoArr[i][0];
            var hurtPoint = defInfoArr[i][1];
            var isCrit = defInfoArr[i][2];
            var hitBackHp = defInfoArr[i][3]; //反击血量
            var hitBackSkillID = defInfoArr[i][4]; //反击技能ID
            var defHero = this.getHero(defTeamID, defPos);
            defHeroArr.push(defHero);
            defHero.hp -= hurtPoint;
            if (defHero.canAddPowerByHit()) {
                defHero.power += (isCrit == 1) ? 20 : 10;
            }
            if (atkHero.pos == 6) {
                //神器受击数字示为暴击
                defHero.isCrit = 1;
            }
            else {
                defHero.isCrit = isCrit;
            }
            defHero.hitBackHp = hitBackHp;
            defHero.hitBackSkillID = hitBackSkillID;
            defHero.hurtPoint = hurtPoint;
            defHero.hurtBySkill = false;
            defHero.hitEffect = hitEffect;
        }
        egret.Tween.get(atkHero).to({}, 200).call(function () {
            atkHero.atk(skillID, defHeroArr);
        }, this);
    };
    BattleScene.prototype.getHero = function (teamID, pos) {
        var heroArr;
        if (teamID == 1) {
            heroArr = this.heroArr1;
        }
        else {
            heroArr = this.heroArr2;
        }
        return heroArr[pos];
    };
    BattleScene.prototype.createRoleArr = function (roleArr, teamID) {
        var _this = this;
        var heroArr = (teamID == 1) ? this.heroArr1 : this.heroArr2;
        var pos2IndexArr = [4, 1, 5, 3, 2, 0];
        var _loop_3 = function (i) {
            var role = roleArr[i];
            var dir = teamID == 1 ? 1 : -1;
            var heroID = role.heroID;
            var dd = new Hero(heroID, this_3).addToParent(this_3.roleLayer);
            heroArr[role.pos] = dd;
            dd.level = role.level;
            dd.race = role.race;
            dd.teamID = teamID;
            dd.hp = role.hp;
            dd.hpMax = role.hpMax;
            dd.pos = role.pos;
            dd.power = role.power;
            if (role.pos < 2) {
                dd.x = this_3.getX(220, dir);
            }
            else if (role.pos == 2 || role.pos == 5) {
                dd.x = this_3.getX(160, dir);
            }
            else {
                dd.x = this_3.getX(100, dir);
            }
            var yBase = 480;
            dd.y = yBase + pos2IndexArr[role.pos] * 120;
            if (role.pos == 0) {
                dd.y -= 30;
            }
            else if (role.pos == 1) {
                dd.y += 30;
            }
            else if (role.pos == 3) {
                dd.y += 50;
            }
            else if (role.pos == 4) {
                dd.y -= 50;
            }
            dd.y = yBase + (dd.y - yBase) * 0.8;
            if (role.pos == 6) {
                dd.x = this_3.getX(100, dir);
                ;
                dd.y = 300;
            }
            dd.setPos(dd.x, dd.y);
            var scale = dd.y / 1136 / 10 + 0.55;
            dd.scaleSkin(scale * dir, scale);
            dd.onActionPlayComplete(function (actionName) {
                if (actionName == "atk") {
                    var event_5 = _this.curEvent;
                    var eventName = event_5[0];
                    switch (eventName) {
                        case 'atk':
                        case 'skill':
                            var atkTeamID = event_5[2];
                            var atkPos = event_5[3];
                            if (atkTeamID == dd.teamID && atkPos == dd.pos) {
                                //获取第一个反击者
                                var info = _this.getFirstHitBackRoleInfo(event_5);
                                if (info) {
                                    var hitBackRole = info[0];
                                    var hitBackHp = info[1];
                                    var hitBackSkillID = info[2];
                                    _this.hitBack(hitBackRole, dd, hitBackSkillID, hitBackHp);
                                }
                                else {
                                    dd.goBack();
                                    _this.next();
                                }
                            }
                            else {
                                dd.goBack();
                                var role_1 = _this.getHero(atkTeamID, atkPos); //攻击者
                                var info = _this.getNextHitBackRoleInfo(event_5, dd);
                                if (info) {
                                    var hitBackRole = info[0];
                                    var hitBackHp = info[1];
                                    var hitBackSkillID = info[2];
                                    _this.hitBack(hitBackRole, role_1, hitBackSkillID, hitBackHp);
                                }
                                else {
                                    role_1.goBack();
                                    _this.next();
                                }
                            }
                            break;
                        default:
                            break;
                    }
                }
            }, this_3);
            if (dd.pos != 6) {
                dd.openHeadUI();
            }
        };
        var this_3 = this;
        for (var i = 0; i < roleArr.length; ++i) {
            _loop_3(i);
        }
    };
    //查找第一个反击者
    BattleScene.prototype.getFirstHitBackRoleInfo = function (event) {
        var defTeamID = event[4];
        var defInfoArr = event[5];
        for (var i = 0; i < defInfoArr.length; ++i) {
            var hitBackHp = defInfoArr[i][3]; //反击血量
            if (hitBackHp > 0) {
                var defPos = defInfoArr[i][0];
                var hitBackSkillID = defInfoArr[i][4]; //反击技能ID
                var role = this.getHero(defTeamID, defPos);
                return [role, hitBackHp, hitBackSkillID];
            }
        }
        return null;
    };
    //查找下一个反击者
    BattleScene.prototype.getNextHitBackRoleInfo = function (event, curHitBackRole) {
        var ready = false;
        var defTeamID = event[4];
        var defInfoArr = event[5];
        for (var i = 0; i < defInfoArr.length; ++i) {
            var hitBackHp = defInfoArr[i][3]; //反击血量
            if (hitBackHp > 0) {
                var defPos = defInfoArr[i][0];
                var hitBackSkillID = defInfoArr[i][4]; //反击技能ID
                var role = this.getHero(defTeamID, defPos);
                if (ready) {
                    return [role, hitBackHp, hitBackSkillID];
                }
                else {
                    if (role == curHitBackRole) {
                        ready = true;
                    }
                }
            }
        }
        return null;
    };
    BattleScene.prototype.getX = function (x, dir) {
        if (dir < 0) {
            return 640 - x;
        }
        return x;
    };
    //角色排序
    BattleScene.prototype.sortAllRole = function () {
        var roleLayer = this.roleLayer;
        for (var i = 0; i < roleLayer.numChildren; ++i) {
            for (var j = i + 1; j < roleLayer.numChildren; ++j) {
                var h001 = roleLayer.getChildAt(i);
                var h002 = roleLayer.getChildAt(j);
                if (h002.ySrc < h001.ySrc || (h002.ySrc == h001.ySrc && h002.xSrc < h001.xSrc)) {
                    roleLayer.setChildIndex(h001, j);
                    roleLayer.setChildIndex(h002, i);
                }
            }
        }
    };
    //振屏
    BattleScene.prototype.shake = function () {
        egret.Tween.get(this)
            .to({ y: -10 }, 20)
            .to({ y: +10 }, 20)
            .to({ y: -10 }, 20)
            .to({ y: +10 }, 20)
            .to({ y: -10 }, 20)
            .to({ y: +10 }, 20)
            .to({ y: 0 }, 10);
    };
    //振屏2
    BattleScene.prototype.shake2 = function () {
        egret.Tween.get(this)
            .to({ y: -10 }, 40)
            .to({ y: +10 }, 40)
            .to({ y: -10 }, 40)
            .to({ y: +10 }, 40)
            .to({ y: -10 }, 40)
            .to({ y: +10 }, 40)
            .to({ y: 0 }, 10);
    };
    BattleScene.sceneArr = []; //战斗场景数组
    return BattleScene;
}(ak.DisplayObjectContainer));
__reflect(BattleScene.prototype, "BattleScene");
var BattleSystem = (function (_super) {
    __extends(BattleSystem, _super);
    function BattleSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BattleSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("BattleUI");
    };
    BattleSystem.inst = new BattleSystem("BattleUI");
    return BattleSystem;
}(ak.FairyGUI));
__reflect(BattleSystem.prototype, "BattleSystem");
//战斗角色头顶界面(显示：种族、等级、血条、能量条)
var BattleRoleHeadUI = (function (_super) {
    __extends(BattleRoleHeadUI, _super);
    function BattleRoleHeadUI(layer, role) {
        var _this = _super.call(this, BattleSystem.inst, layer) || this;
        _this.role = role;
        return _this;
    }
    BattleRoleHeadUI.prototype.onInit = function () {
        var ui = this.create("BattleUI", "headBar");
        this.level = ui.getChild("level").asTextField;
        this.raceCtrl = ui.getChild("race").asCom.getController("c1");
        this.life = ui.getChild("life").asProgress;
        this.energy = ui.getChild("energy").asProgress;
        this.buffList = ui.getChild("buffList").asList;
        this.buffList.setVirtual();
        this.buffList.itemRenderer = this.buffListItemRenderer;
        this.buffList.callbackThisObj = this;
        this.buffList.numItems = 0;
        //刷新显示
        this.updateView();
    };
    BattleRoleHeadUI.prototype.buffListItemRenderer = function (index, item) {
        var arr = this.role.buffArr;
        var info = arr[index];
        var buffID = info[0];
        var count = info[1];
        item.getChild("num").text = "" + count;
        var skillBuffTab = ak.JsonTableMgr.get("skillBuff");
        var row = skillBuffTab.getRowFromColName("id", "" + buffID);
        var buffType = row.getValFromColName("type");
        var skillBuffTypeTab = ak.JsonTableMgr.get("skillBuffType");
        var typeRow = skillBuffTypeTab.getRowFromColName("id", "" + buffType);
        var icon = typeRow.getValFromColName("icon");
        this.setLoaderUrl(item.getChild("icon").asLoader, icon);
    };
    //刷新显示
    BattleRoleHeadUI.prototype.updateView = function () {
        if (!this.ui) {
            return;
        }
        this.level.text = "" + this.role.level;
        this.life.max = this.role.hpMax;
        this.life.tweenValue(this.role.hp, 0.5);
        this.energy.max = 100;
        this.energy.tweenValue(this.role.power, 0.5);
        this.raceCtrl.selectedIndex = this.role.race;
        this.buffList.numItems = this.role.buffArr.length;
    };
    return BattleRoleHeadUI;
}(ak.EasyUI));
__reflect(BattleRoleHeadUI.prototype, "BattleRoleHeadUI");
//战斗HP扣减动画
var BattleHPSubAni = (function (_super) {
    __extends(BattleHPSubAni, _super);
    function BattleHPSubAni(layer, id, hurtPoint) {
        var _this = _super.call(this, BattleSystem.inst, layer) || this;
        _this.id = id;
        _this.hurtPoint = hurtPoint;
        return _this;
    }
    //初始化回调
    BattleHPSubAni.prototype.onInit = function () {
        var ui = this.create("BattleUI", "num" + this.id);
        if (this.id == 4) {
            ui.getChild("num").asTextField.text = "+" + this.hurtPoint;
        }
        else {
            ui.getChild("num").asTextField.text = "-" + this.hurtPoint;
        }
        ui.getTransition("t0").play();
    };
    return BattleHPSubAni;
}(ak.EasyUI));
__reflect(BattleHPSubAni.prototype, "BattleHPSubAni");
//点击时出现的圈
var ClickCircle = (function (_super) {
    __extends(ClickCircle, _super);
    function ClickCircle() {
        var _this = _super.call(this) || this;
        var img = new ak.Img();
        img.url = "dianji_png";
        img.x = -74 / 2;
        img.y = -74 / 2;
        _this.addChild(img);
        var tw = egret.Tween.get(_this);
        tw.to({ scaleX: 2, scaleY: 2 }, 200);
        tw.to({ alpha: 0 }, 200).call(function () {
            _this.parent.removeChild(_this);
        }, _this);
        return _this;
    }
    return ClickCircle;
}(egret.DisplayObjectContainer));
__reflect(ClickCircle.prototype, "ClickCircle");
//英雄类
var Hero = (function (_super) {
    __extends(Hero, _super);
    function Hero(heroID, scene) {
        var _this = _super.call(this) || this;
        _this.teamID = 0;
        _this.hitBackHp = 0; //反击血量
        _this.hitBackSkillID = 0; //反击技能ID
        _this.buffMap = {};
        _this.buffArr = [];
        //控制状态，值为0时代表不被控制
        _this.limit1 = 0; //禁魔：无法释放主动技能
        _this.limit2 = 0; //沉默：无法释放主动技能
        _this.limit3 = 0; //石化：无法行动，且被攻击无法回复能量
        _this.limit4 = 0; //眩晕：无法行动，被攻击可以回复能量
        _this.limit5 = 0; //冰冻：无法行动，且被攻击无法回复能量
        //buff类型状态，值为0时代表没有中此类型buff
        _this.buffType50 = 0; //暴击印记
        _this.heroID = heroID;
        _this.scene = scene;
        return _this;
    }
    //被打时能否恢复能量
    Hero.prototype.canAddPowerByHit = function () {
        if ((this.limit3 + this.limit5) > 0)
            return false;
        return true;
    };
    //清除所有buff
    Hero.prototype.cleanAllBuff = function () {
        this.buffMap = {};
        this.limit1 = 0;
        this.limit2 = 0;
        this.limit3 = 0;
        this.limit4 = 0;
        this.limit5 = 0;
        //刷新角色顶部界面
        this.updateHeadUI();
    };
    Hero.prototype.reborn = function (hp) {
        this.hp = hp;
        this.power = 0;
        egret.Tween.removeTweens(this);
        this.alpha = 1;
        this.setAction("wait", 0);
        //刷新角色顶部界面
        this.updateHeadUI();
    };
    Hero.prototype.addPower = function (power) {
        this.power += power;
        //刷新角色顶部界面
        this.updateHeadUI();
    };
    Hero.prototype.setPower = function (power) {
        this.power = power;
        //刷新角色顶部界面
        this.updateHeadUI();
    };
    //增加buff，num<0时=减少buff
    Hero.prototype.addBuff = function (buffID, num) {
        if (num > 0) {
            ak.idMapAddCount(this.buffMap, buffID, num);
            this.buffArr = this.buffMap2buffArr(this.buffMap);
        }
        else if (num < 0) {
            ak.idMapAddCount(this.buffMap, buffID, -1);
            if (ak.idMapGetCount(this.buffMap, buffID) <= 0) {
                delete this.buffMap[buffID];
            }
            this.buffArr = this.buffMap2buffArr(this.buffMap);
        }
        var skillBuffTab = ak.JsonTableMgr.get("skillBuff");
        var row = skillBuffTab.getRowFromColName("id", "" + buffID);
        var buffType = row.getValFromColName("type");
        switch (buffType) {
            case 43://禁魔：无法释放主动技能
                this.limit1 += num;
                break;
            case 44://沉默：无法释放主动技能
                this.limit2 += num;
                break;
            case 45://石化：无法行动，且被攻击无法回复能量
                this.limit3 += num;
                break;
            case 46://眩晕：无法行动，被攻击可以回复能量
                this.limit4 += num;
                break;
            case 47://冰冻：无法行动，且被攻击无法回复能量
                this.limit5 += num;
                break;
            case 50://暴击印记
                this.buffType50 += num;
                break;
        }
        var canWait = true;
        //沉默
        if (this.limit2 > 0) {
            this.showSilent(true);
        }
        else {
            this.showSilent(false);
        }
        //石化
        if (this.limit3 > 0) {
            this.setAction("shihua");
            canWait = false;
        }
        //眩晕
        if (this.limit4 > 0) {
            this.showHalo(true);
            canWait = false;
        }
        else {
            this.showHalo(false);
        }
        //冰冻
        if (this.limit5 > 0) {
            this.showIce(true);
            canWait = false;
        }
        else {
            this.showIce(false);
        }
        //暴击印记
        if (this.buffType50 > 0) {
            this.showCritSign(true);
        }
        else {
            this.showCritSign(false);
        }
        if (canWait) {
            this.setAction("wait", 0);
        }
        //刷新角色顶部界面
        this.updateHeadUI();
    };
    Hero.prototype.buffMap2buffArr = function (idMap) {
        var skillBuffTab = ak.JsonTableMgr.get("skillBuff");
        var skillBuffTypeTab = ak.JsonTableMgr.get("skillBuffType");
        var arr = [];
        for (var id in idMap) {
            var row = skillBuffTab.getRowFromColName("id", "" + id);
            var buffType = row.getValFromColName("type");
            var typeRow = skillBuffTypeTab.getRowFromColName("id", "" + buffType);
            if (typeRow.getValFromColName("icon") != "0") {
                var count = idMap[id];
                arr.push([id, count]);
            }
        }
        return arr;
    };
    Object.defineProperty(Hero.prototype, "power", {
        get: function () {
            return this._power;
        },
        set: function (num) {
            this._power = num;
            if (num >= 100) {
                if (this.teamID == 1) {
                    //我方怒气满
                    ak.EventMgr.dispatch(GameEvent.guide_myPowerFull);
                }
            }
        },
        enumerable: true,
        configurable: true
    });
    //初始化回调
    Hero.prototype.onInit = function () {
        var _this = this;
        var heroID = this.heroID;
        var heroTab = ak.JsonTableMgr.get("hero");
        var row = heroTab.getRowFromColName("id", "" + heroID);
        var aniName = row.getValFromColName("dragonBones");
        this.skin = new ak.Dragonbones(aniName + "_ske_json", aniName + "_tex_json", aniName + "_tex_png", "armatureName" //骨架名
        ).addToParent(this);
        this.timeScale = 1;
        //设置待机动作
        this.setAction("wait", 0);
        //注册事件
        this.skin.ready(function (ani) {
            //帧事件回调
            _this.onEgretEvent(ani, dragonBones.EventObject.FRAME_EVENT, function (e) {
                var eventName = e.frameLabel;
                if (eventName == "hit") {
                    var skillActiveTab = ak.JsonTableMgr.get("skillActive");
                    if (_this.targetHeroArr && _this.targetHeroArr.length > 0) {
                        if (_this.scene instanceof HookScene) {
                            if (BattleScene.sceneArr.length == 0) {
                                var row_1 = skillActiveTab.getRowFromColName("id", "" + _this.atkSkillID);
                                if (row_1) {
                                    var sound = row_1.getValFromColName("sound");
                                    ak.SoundMgr.inst.playSound(sound);
                                }
                            }
                        }
                        else if (_this.scene instanceof BattleScene) {
                            var scene = _this.scene;
                            var event_6 = scene.curEvent;
                            var eventName_1 = event_6[0];
                            if (eventName_1 == "skill" || eventName_1 == "atk") {
                                var skillID = event_6[1];
                                var atkTeamID = event_6[2];
                                var atkPos = event_6[3];
                                var atkHero = scene.getHero(atkTeamID, atkPos);
                                if (_this == atkHero) {
                                    var row_2 = skillActiveTab.getRowFromColName("id", skillID);
                                    if (row_2) {
                                        var sound = row_2.getValFromColName("sound");
                                        ak.SoundMgr.inst.playSound(sound);
                                        if (eventName_1 == "skill") {
                                            //振屏
                                            var shake = row_2.getValFromColName("shake");
                                            switch (shake) {
                                                case 1:
                                                    _this.scene.shake();
                                                    break;
                                                case 2:
                                                    _this.scene.shake2();
                                                    break;
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        var _loop_4 = function (i) {
                            //受击方播受击特效
                            var targetHero = _this.targetHeroArr[i];
                            targetHero.hit();
                            var dx = targetHero.x - _this.x;
                            var dy = targetHero.y - _this.y;
                            //攻击方播攻击特效
                            switch (_this.atkEffectType) {
                                case 0://不移动
                                    if (_this.atkEffect != "0") {
                                        //攻击特效
                                        var effect = new BattleEffect(_this.atkEffect).addToParent(_this);
                                        if (_this.teamID == 1) {
                                            effect.scaleX *= 1;
                                        }
                                        else {
                                            effect.scaleX *= -1;
                                        }
                                        // effect.rotation=new ak.Vector2D(dx,dy).vector2Angle();
                                        effect.y -= 80;
                                        if (_this.teamID == 1) {
                                            effect.x += 200;
                                        }
                                        else {
                                            effect.x -= 200;
                                        }
                                    }
                                    break;
                                case 1://飞行
                                    {
                                        //攻击特效
                                        var effect_1 = new BattleEffect(_this.atkEffect).addToParent(_this.getScene());
                                        if (_this.teamID == 1) {
                                            effect_1.x = _this.x + 50;
                                        }
                                        else {
                                            effect_1.x = _this.x - 50;
                                        }
                                        effect_1.y = _this.ySrc - 100;
                                        if (_this.atkEffectTime == 0) {
                                            if (_this.teamID == 1) {
                                                effect_1.scaleX = 1;
                                            }
                                            else {
                                                effect_1.scaleX = -1;
                                            }
                                            egret.Tween.get(effect_1).to({ x: targetHero.x, y: targetHero.y - 30 }, _this.atkEffectTime).call(function () {
                                                // egret.Tween.removeTweens(effect);
                                            });
                                        }
                                        else {
                                            effect_1.rotation = new ak.Vector2D(dx, dy).vector2Angle();
                                            egret.Tween.get(effect_1).to({ x: targetHero.x, y: targetHero.y - 80 }, _this.atkEffectTime).call(function () {
                                                effect_1.destroy();
                                                // egret.Tween.removeTweens(effect);
                                            });
                                        }
                                        break;
                                    }
                                case 2://激光
                                    {
                                        var effectWidth = 300;
                                        //攻击特效
                                        var effect = new BattleEffect(_this.atkEffect).addToParent(_this.getScene());
                                        effect.mc.x = effectWidth / 2;
                                        if (_this.teamID == 1) {
                                            effect.x = _this.x + 50;
                                        }
                                        else {
                                            effect.x = _this.x - 50;
                                        }
                                        effect.y = _this.ySrc - 100;
                                        effect.scaleX = 0;
                                        effect.rotation = new ak.Vector2D(dx, dy).vector2Angle();
                                        var targetScaleX = Math.sqrt(dx * dx + dy * dy) / effectWidth;
                                        egret.Tween.get(effect).to({ scaleX: targetScaleX }, 200).call(function () {
                                            // egret.Tween.removeTweens(effect);
                                        });
                                        break;
                                    }
                                case 3://从目标头上落下
                                    {
                                        //攻击特效
                                        var effect_2 = new BattleEffect(_this.atkEffect).addToParent(_this.getScene());
                                        effect_2.x = targetHero.x;
                                        effect_2.y = targetHero.y - 500;
                                        egret.Tween.get(effect_2).to({ x: targetHero.x, y: targetHero.y - 80 }, 200).call(function () {
                                            effect_2.destroy();
                                        });
                                        break;
                                    }
                                case 4://屏幕中间播放
                                    {
                                        //攻击特效
                                        var effect = new BattleEffect(_this.atkEffect).addToParent(_this.getScene());
                                        effect.x = _this.stage.stageWidth / 2;
                                        effect.y = _this.stage.stageHeight / 2;
                                        break;
                                    }
                            }
                        };
                        for (var i = 0; i < _this.targetHeroArr.length; ++i) {
                            _loop_4(i);
                        }
                        _this.targetHeroArr.length = 0;
                    }
                }
            }, _this);
            //动作完成回调
            _this.onEgretEvent(ani, dragonBones.EventObject.COMPLETE, function (e) {
                var actionName = e.animationState.name;
                if (actionName == "atk") {
                    // this.atkSign=false;
                    _this.setAction("wait", 0);
                }
                if (actionName == "byatk") {
                    _this.setAction("wait", 0);
                }
                if (actionName == "die") {
                    egret.Tween.get(_this).to({ alpha: 0 }, 1000).call(function () {
                        // egret.Tween.removeTweens(this);
                    });
                }
                if (_this.onActionPlayCompleteCallback && _this.onActionPlayCompleteThisObj) {
                    _this.onActionPlayCompleteCallback.call(_this.onActionPlayCompleteThisObj, actionName, _this.onActionPlayCompleteData);
                }
            }, _this);
            // //每帧回调
            // this.onEgretEvent(this,egret.Event.ENTER_FRAME,()=>{
            // 	if(this.getActionName()=="wait"&&this.hp<=0)
            // 	{
            // 		this.setAction("die",1);
            // 	}
            // },this);
        }, this);
    };
    Hero.prototype.getScene = function () {
        if (this.scene) {
            return this.scene;
        }
        return this.parent;
    };
    //设置诞生位置
    Hero.prototype.setPos = function (x, y) {
        this.x = x;
        this.y = y;
        this.xSrc = x;
        this.ySrc = y;
    };
    //回到诞生位置
    Hero.prototype.goBack = function () {
        if (this.x != this.xSrc || this.y != this.ySrc) {
            egret.Tween.get(this).to({ x: this.xSrc, y: this.ySrc }, 100).call(function () {
                // egret.Tween.removeTweens(this);
            });
        }
    };
    //设置皮肤比例
    Hero.prototype.scaleSkin = function (scaleX, scaleY) {
        this.skin.scaleX = scaleX;
        this.skin.scaleY = scaleY;
    };
    Object.defineProperty(Hero.prototype, "timeScale", {
        //设置动画播放速度
        set: function (scale) {
            if (this.scene) {
                this.skin.timeScale = scale * 1.66;
            }
            else {
                this.skin.timeScale = scale;
            }
        },
        enumerable: true,
        configurable: true
    });
    //显示头顶信息
    Hero.prototype.openHeadUI = function () {
        if (!this.headUI) {
            this.headUI = new BattleRoleHeadUI(this, this);
            this.headUI.y = -150;
            this.headUI.x = -122 / 2 - 25;
        }
    };
    //更新头顶信息
    Hero.prototype.updateHeadUI = function () {
        if (this.headUI) {
            this.headUI.updateView();
        }
    };
    //销毁回调
    Hero.prototype.onDestroy = function () {
    };
    //播放动作
    Hero.prototype.setAction = function (actionName, playTime) {
        if (this.getActionName() == "atk" && this.isActionPlaying()) {
            //攻击动作不能被打断
            return;
        }
        if (this.getActionName() == "die" && this.isActionPlaying()) {
            if (actionName != "atk") {
                //死亡动作不能被打断（攻击除外）
                return;
            }
        }
        this.skin.setAction(actionName, playTime);
    };
    //获取当前播放运作名
    Hero.prototype.getActionName = function () {
        return this.skin.getActionName();
    };
    //当前动作是否正在播放
    Hero.prototype.isActionPlaying = function () {
        return this.skin.isActionPlaying();
    };
    //使用技能（攻击）
    Hero.prototype.atk = function (skillID, targetHeroArr) {
        var _this = this;
        egret.Tween.removeTweens(this);
        var skillActiveTab = ak.JsonTableMgr.get("skillActive");
        var row = skillActiveTab.getRowFromColName("id", "" + skillID);
        if (row == null) {
            ak.log("技能ID", skillID, "不存在");
        }
        var isMove = row.getValFromColName("moveTo") == 1 ? true : false;
        var hitEffect = row.getValFromColName("hitAni"); //受击特效
        var defHero001 = targetHeroArr[0];
        var xDest = defHero001.x; //defHero001.xSrc;
        var yDest = defHero001.y; //defHero001.ySrc;
        //攻击特效
        this.atkEffect = row.getValFromColName("ani"); //攻击特效
        this.atkEffectType = row.getValFromColName("moveType"); //攻击特效类型（0=不移动，1=飞行，2=激光）
        //特殊处理
        if (this.atkEffectType == 0 && hitEffect == "0") {
            this.atkEffectType = 1;
            this.atkEffectTime = 0; //子弹飞行时间
        }
        else {
            this.atkEffectTime = 200; //子弹飞行时间
        }
        if (isMove) {
            var xOff = void 0;
            if (this.teamID == 1) {
                xOff = -100;
            }
            else {
                xOff = 100;
            }
            egret.Tween.get(this).to({ x: xDest + xOff, y: yDest + 5 }, 100).call(function () {
                _this.atk2(skillID, targetHeroArr);
            });
        }
        else {
            this.atk2(skillID, targetHeroArr);
        }
    };
    //使用技能（攻击）步骤2
    Hero.prototype.atk2 = function (skillID, targetHeroArr) {
        this.targetHeroArr = targetHeroArr;
        this.setAction("atk", 1);
        // this.addToParent(this.parent);
    };
    //受击
    Hero.prototype.hit = function () {
        //受击特效
        if (this.hitEffect != null && this.hitEffect != "0") {
            var eff = new BattleEffect(this.hitEffect).addToParent(this);
            eff.y -= 100;
        }
        if (this.scene instanceof BattleScene) {
            //受击动作
            if (this.hp > 0) {
                if ((this.limit3 + this.limit4 + this.limit5) == 0) {
                    this.setAction("byatk", 1);
                }
            }
            else {
                this.setAction("die", 1);
            }
            //显示扣血动画
            this.scene.showSubHPAni(this, this.hurtPoint, this.isCrit, this.hurtBySkill);
        }
        else {
            this.setAction("byatk", 1);
        }
        this.updateHeadUI();
    };
    Hero.prototype.showIce = function (isShow) {
        if (isShow) {
            if (!this.ice2) {
                this.ice2 = new ak.MovieClip("buff_bingdong2_json", "buff_bingdong2_png", "buff_bingdong2");
                this.addChild(this.ice2);
            }
            if (!this.ice) {
                this.ice = new ak.MovieClip("buff_bingdong_json", "buff_bingdong_png", "buff_bingdong");
                this.addChild(this.ice);
            }
            this.skin.stop();
        }
        else {
            if (this.ice) {
                this.ice.parent.removeChild(this.ice);
                this.ice = null;
            }
            if (this.ice2) {
                this.ice2.parent.removeChild(this.ice2);
                this.ice2 = null;
            }
        }
    };
    Hero.prototype.showHalo = function (isShow) {
        if (isShow) {
            if (!this.halo) {
                this.halo = new ak.MovieClip("buff_xuanyun_json", "buff_xuanyun_png", "buff_xuanyun");
                this.halo.y = -170;
                this.addChild(this.halo);
            }
            this.skin.stop();
        }
        else {
            if (this.halo) {
                this.halo.parent.removeChild(this.halo);
                this.halo = null;
            }
        }
    };
    Hero.prototype.showSilent = function (isShow) {
        if (isShow) {
            if (!this.silent) {
                this.silent = new ak.MovieClip("buff_chenmo_json", "buff_chenmo_png", "buff_chenmo");
                this.silent.y = -170;
                this.addChild(this.silent);
            }
            this.skin.stop();
        }
        else {
            if (this.silent) {
                this.silent.parent.removeChild(this.silent);
                this.silent = null;
            }
        }
    };
    Hero.prototype.showCritSign = function (isShow) {
        if (isShow) {
            if (!this.critSign) {
                this.critSign = new ak.MovieClip("buff_baoji_json", "buff_baoji_png", "buff_baoji");
                this.critSign.y = -50;
                this.addChild(this.critSign);
            }
            this.skin.stop();
        }
        else {
            if (this.critSign) {
                this.critSign.parent.removeChild(this.critSign);
                this.critSign = null;
            }
        }
    };
    //注册
    Hero.prototype.onActionPlayComplete = function (callback, thisObj, data) {
        this.onActionPlayCompleteCallback = callback;
        this.onActionPlayCompleteThisObj = thisObj;
        this.onActionPlayCompleteData = data;
    };
    return Hero;
}(ak.DisplayObjectContainer));
__reflect(Hero.prototype, "Hero");
//挂机场景
var HookScene = (function (_super) {
    __extends(HookScene, _super);
    function HookScene() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.heroArr = [];
        _this.heroArr1 = [];
        _this.heroArr2 = [];
        _this.hitEmenyCount = 0;
        _this.roleLayer = new egret.DisplayObjectContainer(); //角色层
        _this.who = 0;
        return _this;
    }
    HookScene.prototype.onInit = function () {
        var _this = this;
        //层级
        this.addChild(this.roleLayer);
        var heroIDArr = []; //[11011,11023,11044];
        var cardArr = MyData.user.json.cardArr;
        for (var i = 0; i < cardArr.length; ++i) {
            var card = cardArr[i];
            heroIDArr.push(card.heroID);
        }
        while (heroIDArr.length > 3) {
            var index = Math.floor(Math.random() * heroIDArr.length);
            heroIDArr.splice(index, 1);
        }
        var heroTab = ak.JsonTableMgr.get("hero");
        var _loop_5 = function (i) {
            var heroID = heroIDArr[i];
            var row = heroTab.getRowFromColName("id", "" + heroID);
            var skillID = row.getValFromColName("normalSkill");
            var dd = new Hero(heroID, this_4).addToParent(this_4.roleLayer);
            dd.teamID = 1;
            dd.scaleX = 0.7;
            dd.scaleY = 0.7;
            var x = 100 + (i % 2) * 120;
            var y = 700 + i * 100;
            dd.setPos(x, y);
            dd.atkSkillID = skillID;
            // dd.touchEnabled=true;
            dd.onActionPlayComplete(function (actionName) {
                if (actionName == "atk") {
                    dd.goBack();
                    // this.next();
                }
                else if (actionName == "byatk") {
                    _this.next();
                }
            }, this_4);
            this_4.heroArr1.push(dd);
            this_4.heroArr.push(dd);
        };
        var this_4 = this;
        for (var i = 0; i < heroIDArr.length; ++i) {
            _loop_5(i);
        }
        //创建敌方英雄
        this.changeEmeny();
        if (this.heroArr1.length > 0) {
            this.next();
        }
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, function () {
            _this.sortAllRole();
        }, this);
    };
    HookScene.prototype.onEmenyActionPlayComplete = function (actionName, dd) {
        var _this = this;
        if (actionName == "atk") {
            dd.goBack();
            // this.next();
        }
        else if (actionName == "byatk") {
            ++this.hitEmenyCount;
            if (this.hitEmenyCount >= 5) {
                this.hitEmenyCount = 0;
                dd.setAction("die", 1);
            }
            else {
                this.next();
            }
        }
        else if (actionName == "die") {
            egret.Tween.get(this).to({}, 2000).call(function () {
                _this.changeEmeny();
                _this.next();
            }, this);
        }
    };
    //更换一批敌方英雄
    HookScene.prototype.changeEmeny = function () {
        var barrierID = MyData.user.getResBarrierID;
        var barrierTab = ak.JsonTableMgr.get("barrier");
        var barrierRow = barrierTab.getRowFromColName("id", "" + barrierID);
        var monsterGroupID = barrierRow.getValFromColName("monster");
        var rowArr = MonsterMgr.getMonsterRowArr(monsterGroupID);
        var row = rowArr[Math.floor(rowArr.length * Math.random())];
        //随机选择当前关卡怪物
        var heroIDArr2 = [row.getValFromColName("heroID")];
        //删除旧的敌人
        for (var i = 0; i < this.heroArr2.length; ++i) {
            var hero = this.heroArr2[i];
            var index = this.heroArr.indexOf(hero);
            this.heroArr.splice(index, 1);
            hero.destroy();
        }
        this.heroArr2.length = 0;
        var heroTab = ak.JsonTableMgr.get("hero");
        for (var i = 0; i < heroIDArr2.length; ++i) {
            var heroID = heroIDArr2[i];
            var row_3 = heroTab.getRowFromColName("id", "" + heroID);
            var skillID = row_3.getValFromColName("normalSkill");
            var dd = new Hero(heroID, this).addToParent(this.roleLayer);
            dd.teamID = 2;
            dd.scaleX = -0.8 * 2 / 3;
            dd.scaleY = 0.8 * 2 / 3;
            var x = 540;
            var y = 800;
            dd.setPos(x, y);
            dd.atkSkillID = skillID;
            // dd.touchEnabled=true;
            dd.onActionPlayComplete(this.onEmenyActionPlayComplete, this, dd);
            this.heroArr2.push(dd);
            this.heroArr.push(dd);
        }
    };
    //下一个英雄行动
    HookScene.prototype.next = function () {
        if (!this.stage) {
            return;
        }
        egret.Tween.get(this).to({}, 500).call(this.next2, this);
    };
    HookScene.prototype.next2 = function () {
        var curHero = this.heroArr[this.who];
        var targetHero = null;
        if (curHero.teamID == 1) {
            targetHero = this.heroArr2[0];
        }
        else {
            var index = Math.floor(Math.random() * this.heroArr1.length);
            targetHero = this.heroArr1[index];
        }
        var skillID = curHero.atkSkillID;
        // curHero.atk(skillID,[targetHero]);
        this.atk(curHero, [targetHero]);
        ++this.who;
        if (this.who >= this.heroArr.length) {
            this.who = 0;
        }
    };
    HookScene.prototype.atk = function (hero, targetHeroArr) {
        var skillID = hero.atkSkillID;
        var skillActiveTab = ak.JsonTableMgr.get("skillActive");
        var row = skillActiveTab.getRowFromColName("id", "" + skillID);
        // let isMove=row.getValFromColName("moveTo")==1?true:false;
        var hitEffect = row.getValFromColName("hitAni"); //受击特效
        for (var i = 0; i < targetHeroArr.length; ++i) {
            var defHero = targetHeroArr[i];
            defHero.hitEffect = hitEffect;
        }
        hero.atk(skillID, targetHeroArr);
    };
    //角色排序
    HookScene.prototype.sortAllRole = function () {
        var roleLayer = this.roleLayer;
        for (var i = 0; i < roleLayer.numChildren; ++i) {
            for (var j = i + 1; j < roleLayer.numChildren; ++j) {
                var h001 = roleLayer.getChildAt(i);
                var h002 = roleLayer.getChildAt(j);
                if (h002.y < h001.y || (h002.y == h001.y && h002.x < h001.x)) {
                    roleLayer.setChildIndex(h001, j);
                    roleLayer.setChildIndex(h002, i);
                }
            }
        }
    };
    return HookScene;
}(ak.DisplayObjectContainer));
__reflect(HookScene.prototype, "HookScene");
//新手引导
var Guide = (function () {
    function Guide() {
        this.isFrist = true;
        this.GuideInfo = {};
    }
    Guide.prototype.start = function () {
        var _this = this;
        ak.EventMgr.addEventListener(GameEvent.guide_open, function () {
            var GuideID = GuideData.inst().GetGuideIDByTab();
            if (GuideID != 0 && _this.isFrist) {
                //判断等级
                if (!MyConfig.openGuide)
                    return;
                if (MyData.user && MyData.user.level >= GuideData.inst().getMaxLv()) {
                    return;
                }
                else {
                    if (GuideData.inst().GetTabInfoById(GuideID).beginCondition == 0) {
                        _this.openView(GuideID);
                        _this.isFrist = false;
                    }
                    else {
                        //判断是否符合条件
                        if (GuideData.inst().GetTabInfoById(GuideID).beginCondition.barrier) {
                            if (MyData.user.barrierID == GuideData.inst().GetTabInfoById(GuideID).beginCondition.barrier && ak.FairyGUI.getOpenUI("ExplorationView").length != 0) {
                                _this.openView(GuideID);
                                _this.isFrist = false;
                                return;
                            }
                            else {
                                return;
                            }
                        }
                        if (GuideData.inst().GetTabInfoById(GuideID).beginCondition.lv) {
                            if (MyData.user.level >= GuideData.inst().GetTabInfoById(GuideID).beginCondition.lv && ak.FairyGUI.getOpenUI("ExplorationView").length != 0) {
                                _this.openView(GuideID);
                                _this.isFrist = false;
                                return;
                            }
                            else {
                                return;
                            }
                        }
                        _this.openView(GuideID);
                        _this.isFrist = false;
                    }
                }
            }
        }, this);
        ak.EventMgr.addEventListener(GameEvent.guide_Exopen, function () {
            var GuideID = GuideData.inst().GetGuideIDByTab();
            if (GuideID != 0) {
                //判断等级
                if (!MyConfig.openGuide)
                    return;
                if (MyData.user && MyData.user.level >= GuideData.inst().getMaxLv()) {
                    return;
                }
                else {
                    //判断是否符合条件
                    if (GuideData.inst().GetTabInfoById(GuideID).beginCondition.barrier) {
                        if (MyData.user.barrierID == GuideData.inst().GetTabInfoById(GuideID).beginCondition.barrier && ak.FairyGUI.getOpenUI("ExplorationView").length != 0) {
                            _this.openView(GuideID);
                            _this.isFrist = false;
                            return;
                        }
                        else {
                            return;
                        }
                    }
                    if (GuideData.inst().GetTabInfoById(GuideID).beginCondition.lv) {
                        if (MyData.user.level >= GuideData.inst().GetTabInfoById(GuideID).beginCondition.lv && ak.FairyGUI.getOpenUI("ExplorationView").length != 0) {
                            _this.openView(GuideID);
                            _this.isFrist = false;
                            return;
                        }
                        else {
                            return;
                        }
                    }
                }
            }
        }, this);
        //监听战斗界面关闭
        ak.EventMgr.addEventListener(GameEvent.guide_barrierIDchange, function () {
            if (MyData.user.barrierID == 10 && ak.FairyGUI.getOpenUI("ExplorationView").length != 0) {
                ak.EventMgr.dispatch(GameEvent.guide_Exopen);
            }
        }, this);
    };
    Guide.prototype.addEventHandle = function () {
        this.removeEvent();
        if (this.GuideInfo.nextCondition == 0) {
            ak.EventMgr.addEventListener(GameEvent.guide_nextGuide, this.nextHanle1, this);
        }
        else {
            ak.EventMgr.addEventListener(this.GuideInfo.nextCondition[0], this.nextHanle2, this);
        }
    };
    Guide.prototype.nextHanle1 = function () {
        if (ak.FairyGUI.getOpenUI("GuideView").length == 0) {
            this.breakPointHandle();
            this.nextGuideView();
        }
    };
    Guide.prototype.nextHanle2 = function (msg) {
        if (ak.FairyGUI.getOpenUI("GuideView").length == 0) {
            var nextCondition = this.GuideInfo.nextCondition;
            if (nextCondition != 0) {
                var arr = nextCondition;
                var msgName = msg.name;
                var msgParams = msg.params;
                if (arr[0] != msgName) {
                    return;
                }
                if (msgParams) {
                    var arr2 = arr[1];
                    var c = arr2.length;
                    for (var i = 0; i < c; ++i) {
                        var tt = arr2[i];
                        if (tt != null) {
                            if (tt != msgParams[i]) {
                                return;
                            }
                        }
                    }
                }
            }
            this.breakPointHandle();
            this.nextGuideView();
        }
        ;
    };
    /**下一步 */
    Guide.prototype.nextGuideView = function () {
        this.removeEvent();
        var nextGuideID = GuideData.inst().GetNextGuideID(this.GuideInfo.id);
        var GuideID = 0;
        if (nextGuideID == 0) {
            return;
        }
        else {
            GuideID = nextGuideID;
            this.openView(GuideID);
        }
    };
    /**存点 */
    Guide.prototype.breakPointHandle = function () {
        var completeGuideGroupIDstr = "";
        if (MyData.user) {
            completeGuideGroupIDstr = GameLocalStorage.load(GameLocalStorage.completeGuideGroupID);
        }
        var GroupIDarr = {};
        if (completeGuideGroupIDstr != "" && completeGuideGroupIDstr != null) {
            GroupIDarr = ak.json_decode(completeGuideGroupIDstr);
        }
        GroupIDarr[this.GuideInfo.group] = this.GuideInfo.group;
        var GroupIDarrstr = JSON.stringify(GroupIDarr);
        if (this.GuideInfo.savePoint == 1) {
            GameLocalStorage.save(GameLocalStorage.completeGuideGroupID, GroupIDarrstr);
        }
    };
    Guide.prototype.removeEvent = function () {
        if (this.GuideInfo.nextCondition == 0) {
            ak.EventMgr.removeEventListener(GameEvent.guide_nextGuide, this.nextHanle1, this);
        }
        else {
            ak.EventMgr.removeEventListener(this.GuideInfo.nextCondition[0], this.nextHanle2, this);
        }
    };
    Guide.prototype.openView = function (GuideID) {
        PreloadSystem.inst.showSmallLoading(true);
        ak.FairyGUI.open(["GuideView", GuideID], [function () {
                PreloadSystem.inst.showSmallLoading(false);
            }, this]);
    };
    Guide.prototype.setTimeout = function () {
        var timeEvent = setTimeout(function () {
            clearTimeout(timeEvent);
            ak.EventMgr.dispatch(GameEvent.guide_nextGuide);
        }, 500);
    };
    /**是否在新手引导 */
    Guide.isInGuide = function () {
        if (MyGame.inst.guideLayer.numChildren != 0) {
            return true;
        }
        else {
            return false;
        }
    };
    Guide.inst = new Guide();
    return Guide;
}());
__reflect(Guide.prototype, "Guide");
var GuideData = (function () {
    function GuideData() {
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    GuideData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new GuideData();
        }
        return Class._instance;
    };
    /**根据引导id获取该行的数据 */
    GuideData.prototype.GetTabInfoById = function (ids) {
        var guideTab = ak.JsonTableMgr.get("guide");
        var guideInfo = guideTab.getRowFromColName("id", "" + ids);
        var id = guideInfo.getValFromColName("id");
        var group = guideInfo.getValFromColName("group");
        var savePoint = guideInfo.getValFromColName("savePoint");
        var ui = guideInfo.getValFromColName("ui");
        var content = guideInfo.getValFromColName("content");
        var cmd = guideInfo.getValFromColName("cmd");
        var type = guideInfo.getValFromColName("type");
        var beginCondition = guideInfo.getValFromColName("beginCondition");
        var nextCondition = guideInfo.getValFromColName("nextCondition");
        var isSkip = guideInfo.getValFromColName("isSkip");
        var fingerFather = guideInfo.getValFromColName("fingerFather");
        var finger = guideInfo.getValFromColName("finger");
        var mask = guideInfo.getValFromColName("mask");
        var sound = guideInfo.getValFromColName("sound");
        var info = { id: id, group: group, savePoint: savePoint, ui: ui, content: content, cmd: cmd, type: type,
            beginCondition: beginCondition, nextCondition: nextCondition, isSkip: isSkip, fingerFather: fingerFather, finger: finger, mask: mask, sound: sound };
        return info;
    };
    /**
     * 获得新手引导id
     * 判断是有id（不等于0），就从id开始，如果没有开始遍历。
     * 遍历规则，检查新手引导已完成组id是否已有此组，有的话下一个组id查找，查到没有的，再次判断是否符合条件，
     * 如果不符合，查下一个组id，符合条件获取其id保存，如果都没有，就为id=0（没有引导）
     */
    GuideData.prototype.GetGuideID = function () {
        //let str = egret.localStorage.getItem(GameLocalStorage.guideID);
        var str = GameLocalStorage.load(GameLocalStorage.guideID);
        var id = 0;
        if (str != "" && str != null) {
            id = Number(str);
            if (id == 0) {
                return this.GetGuideIDByTab();
            }
        }
        else {
            return this.GetGuideIDByTab();
        }
        return 0;
    };
    /**
     * 遍历表获得id
     */
    GuideData.prototype.GetGuideIDByTab = function () {
        var guideTab = ak.JsonTableMgr.get("guide");
        var failGroup = {};
        //let completeGuideGroupIDstr = egret.localStorage.getItem(GameLocalStorage.completeGuideGroupID);
        var completeGuideGroupIDstr = "";
        if (MyData.user) {
            completeGuideGroupIDstr = GameLocalStorage.load(GameLocalStorage.completeGuideGroupID);
        }
        var GroupIDarr = {};
        if (completeGuideGroupIDstr != "" && completeGuideGroupIDstr != null) {
            GroupIDarr = ak.json_decode(completeGuideGroupIDstr);
        }
        for (var i = 0; i < guideTab.size(); i++) {
            var guideInfo = guideTab.getRow(i);
            var group = guideInfo.getValFromColName("group");
            if (!GroupIDarr[group] && !failGroup[group]) {
                var beginCondition = guideInfo.getValFromColName("beginCondition");
                var id = guideInfo.getValFromColName("id");
                if (beginCondition == 0) {
                    return id;
                }
                var isReturn = true;
                for (var expName in beginCondition) {
                    switch (expName) {
                        case 'charater'://角色存在
                            if (MyData.user) {
                                isReturn = false;
                            }
                            break;
                        case 'lv'://达到等级
                            if (MyData.user.level < beginCondition.expName) {
                                isReturn = false;
                            }
                            break;
                        case 'barrier'://达到关卡
                            if (MyData.user.barrierID < beginCondition.expName) {
                                isReturn = false;
                            }
                            break;
                    }
                }
                if (isReturn) {
                    return id;
                }
                else {
                    failGroup[group] = group;
                }
            }
        }
        return 0;
    };
    /**获得下一个引导ID */
    GuideData.prototype.GetNextGuideID = function (id) {
        var guideTab = ak.JsonTableMgr.get("guide");
        for (var i = 0; i < guideTab.size(); i++) {
            if (i == guideTab.size() - 1)
                return 0;
            var guideInfo = guideTab.getRow(i);
            var id0 = guideInfo.getValFromColName("id");
            if (id0 == id) {
                var nextguideInfo = guideTab.getRow(i + 1);
                var nextid = nextguideInfo.getValFromColName("id");
                return nextid;
            }
        }
        return 0;
    };
    /**新手引导最大等级 */
    GuideData.prototype.getMaxLv = function () {
        var guideConfigTab = ak.JsonTableMgr.get("guideConfig");
        var guideConfigInfo = guideConfigTab.getRow(0);
        var guideLvMax = guideConfigInfo.getValFromColName("guideLvMax");
        return guideLvMax;
    };
    return GuideData;
}());
__reflect(GuideData.prototype, "GuideData");
/**
 * 新手引导系统
 */
var GuideViewSystem = (function (_super) {
    __extends(GuideViewSystem, _super);
    function GuideViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GuideViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guide");
    };
    GuideViewSystem.inst = new GuideViewSystem("GuideView");
    return GuideViewSystem;
}(ak.FairyGUI));
__reflect(GuideViewSystem.prototype, "GuideViewSystem");
var GuideView = (function (_super) {
    __extends(GuideView, _super);
    function GuideView(GuideID) {
        var _this = _super.call(this, GuideViewSystem.inst, MyGame.inst.guideLayer) || this;
        _this.GuideID = 0;
        _this.nextGuideID = 0;
        _this.isbreakPoint = false;
        _this.info = {};
        _this.timer = new ak.Timer();
        _this.GuideID = GuideID;
        var bg = new egret.Shape();
        bg.graphics.beginFill(0xffffff, 0);
        bg.graphics.drawRect(0, 0, fairygui.GRoot.inst.width, fairygui.GRoot.inst.height);
        bg.graphics.endFill();
        _this.addChild(bg);
        bg.touchEnabled = true;
        _this.bg = bg;
        return _this;
    }
    /**回调 */
    GuideView.prototype.onInit = function () {
        this.removeChild(this.bg);
        this.bg = null;
        var ui = this.create("Guide", "GuideView");
        this.bgimg = ui.getChild("bgimg").asImage;
        this.figure = ui.getChild("figure").asImage;
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.fnger = ui.getChild("fnger").asCom;
        this.talkGroup = ui.getChild("talkGroup").asGroup;
        this.talkGroup2 = ui.getChild("talkGroup2").asGroup;
        this.talketxt = ui.getChild("talketxt").asTextField;
        this.talktxt = ui.getChild("talktxt").asTextField;
        this.skipbtn = ui.getChild("skipbtn").asButton;
        this.staticView();
        this.updateView();
        this.ClickAdd();
    };
    GuideView.prototype.staticView = function () {
        var tt2 = new egret.DisplayObjectContainer();
        var obj2 = this.ui.getChild("jb").asGraph;
        obj2.touchable = false;
        obj2.setNativeObject(tt2);
        this.girl = new ak.Dragonbones("newBee_ske_json", "newBee_tex_json", "newBee_tex_png", "armatureName");
        this.girl.addToParent(tt2);
        this.girl.x = 135;
        this.girl.y = 380;
        this.girl.scaleX = 0.8;
        this.girl.scaleY = 0.8;
        this.girl.setAction("wait", 0);
    };
    GuideView.prototype.ClickAdd = function () {
        this.addClickListener(this.skipbtn, this.onClick, this);
        this.addClickListener(this.fnger, this.onClick, this);
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.talktxt, this.onClick, this);
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.setTimeOutSkip, this);
    };
    //模拟点击
    GuideView.prototype.click = function (ui, info) {
        if (info.constructor == Array) {
            var arr = info;
            var list = ui.getChild(arr[0]).asList;
            var index = info[1];
            var item = void 0;
            if (index < 0) {
                item = list.getChildAt(list.numItems + index).asCom;
            }
            else {
                item = list.getChildAt(index).asCom;
            }
            var childName = info[2];
            if (childName) {
                var child = item.getChild(childName).asCom;
                var p = child.displayObject.localToGlobal(0, 0);
                item.dispatchEvent(new egret.TouchEvent(egret.TouchEvent.TOUCH_TAP, true, true, p.x, p.y));
            }
            else {
                var p = item.displayObject.localToGlobal(0, 0);
                item.dispatchEvent(new egret.TouchEvent(egret.TouchEvent.TOUCH_TAP, true, true, p.x, p.y));
            }
        }
        else if (info.constructor == String) {
            var name_3 = info;
            ak.FairyGUI.click(ui.getChild(name_3));
        }
    };
    GuideView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.skipbtn:
                //记录组id并跳过引导
                this.skipbtnPointHandle();
                this.close();
                break;
            case this.fnger:
                //隐藏手指
                this.fnger.visible = false;
                //模拟点击(如果是存点则把id写进缓存),做完后就下一步(手指消失)
                var fingerfather = null;
                if (this.info.fingerFather.length != 0) {
                    fingerfather = ak.FairyGUI.getOpenUI(this.info.ui)[0].ui.getChild(this.info.fingerFather[0]);
                }
                if (this.info.finger.constructor == Array) {
                    if (this.info.finger.length == 2) {
                        if (this.info.finger[1] < 0) {
                            var list = void 0;
                            if (fingerfather != null) {
                                list = fingerfather.getChild(this.info.finger[0]).asList;
                            }
                            else {
                                list = ak.FairyGUI.getOpenUI(this.info.ui)[0].ui.getChild(this.info.finger[0]);
                            }
                            var index = this.info.finger[1];
                            var item = list.getChildAt(list.numItems + index);
                            if (fingerfather != null) {
                                this.click(fingerfather, this.info.finger);
                            }
                            else {
                                this.click(ak.FairyGUI.getOpenUI(this.info.ui)[0].ui, this.info.finger);
                            }
                        }
                        else {
                            var list = void 0;
                            if (fingerfather != null) {
                                list = fingerfather.getChild(this.info.finger[0]).asList;
                            }
                            else {
                                list = ak.FairyGUI.getOpenUI(this.info.ui)[0].ui.getChild(this.info.finger[0]);
                            }
                            var index = this.info.finger[1];
                            var item = list.getChildAt(index);
                            if (fingerfather != null) {
                                this.click(fingerfather, this.info.finger);
                            }
                            else {
                                this.click(ak.FairyGUI.getOpenUI(this.info.ui)[0].ui, this.info.finger);
                            }
                        }
                    }
                    else {
                        var list = void 0;
                        if (fingerfather != null) {
                            list = fingerfather.getChild(this.info.finger[0]).asList;
                        }
                        else {
                            list = ak.FairyGUI.getOpenUI(this.info.ui)[0].ui.getChild(this.info.finger[0]);
                        }
                        var index = this.info.finger[1];
                        var item = list.getChildAt(index).asCom;
                        var btn = item.getChild(this.info.finger[2]);
                        if (fingerfather != null) {
                            this.click(fingerfather, this.info.finger);
                        }
                        else {
                            this.click(ak.FairyGUI.getOpenUI(this.info.ui)[0].ui, this.info.finger);
                        }
                    }
                    if (this.info.nextCondition == 0) {
                        ak.EventMgr.dispatch(GameEvent.guide_nextGuide);
                    }
                }
                else {
                    var btn = void 0;
                    if (fingerfather != null) {
                        btn = fingerfather.getChild(this.info.finger).asCom;
                    }
                    else {
                        btn = ak.FairyGUI.getOpenUI(this.info.ui)[0].ui.getChild(this.info.finger);
                    }
                    if (fingerfather != null) {
                        this.click(fingerfather, this.info.finger);
                    }
                    else {
                        this.click(ak.FairyGUI.getOpenUI(this.info.ui)[0].ui, this.info.finger);
                    }
                    if (this.info.nextCondition == 0) {
                        ak.EventMgr.dispatch(GameEvent.guide_nextGuide);
                    }
                }
                break;
            case this.bgclose:
                //下一步(如果有手指，则不生效)
                if (this.info.type == 1 || this.info.type == 2) {
                    if (this.fnger.visible) {
                        return;
                    }
                    else {
                        //派发下一步
                        ak.EventMgr.dispatch(GameEvent.guide_nextGuide);
                    }
                }
                break;
            case this.talktxt:
                //下一步(如果有手指，则不生效)
                if (this.info.type == 1 || this.info.type == 2) {
                    if (this.fnger.visible) {
                        return;
                    }
                    else {
                        //派发下一步
                        ak.EventMgr.dispatch(GameEvent.guide_nextGuide);
                    }
                }
                break;
        }
    };
    /**更新界面 */
    GuideView.prototype.updateView = function () {
        var _this = this;
        var info = GuideData.inst().GetTabInfoById(this.GuideID);
        this.info = {};
        this.info = info;
        Guide.inst.GuideInfo = {};
        Guide.inst.GuideInfo = info;
        Guide.inst.addEventHandle();
        //重启倒计时
        this.timer.reset();
        //播放语音
        ak.SoundMgr.inst.stopAllSound();
        if (info.sound != "0") {
            ak.SoundMgr.inst.playSound(info.sound);
        }
        //判断对话
        if (info.type == 1) {
            this.talkGroup.visible = false;
            this.girl.visible = true;
            if (this.GuideID == 400) {
                this.talktxt.text = Common.exchangeString(info.content, "[nickname]", "" + MyData.user.nickname);
            }
            else {
                this.talktxt.text = "" + info.content;
            }
            //动效
            var jb = this.ui.getChild("jb").asGraph;
            jb.x = -240;
            jb.y = 765;
            egret.Tween.get(jb).to({ x: -54, y: 765 }, 300).call(function () {
            });
            this.talkGroup2.visible = true;
            this.talkGroup2.x = 0;
            this.talkGroup2.y = 1136;
            egret.Tween.get(this.talkGroup2).to({ x: 0, y: 992 }, 300).call(function () {
            });
        }
        else if (info.type == 2) {
            this.talkGroup2.visible = false;
            this.girl.visible = true;
            this.talketxt.text = "" + info.content;
            //动效
            var jb = this.ui.getChild("jb").asGraph;
            jb.x = -240;
            jb.y = 765;
            this.talkGroup.visible = false;
            egret.Tween.get(jb).to({ x: -54, y: 765 }, 300).call(function () {
                _this.talkGroup.visible = true;
            });
        }
        else {
            this.talkGroup.visible = false;
            this.talkGroup2.visible = false;
            this.girl.visible = false;
        }
        //判断跳过按钮的显示
        if (info.isSkip == 1) {
            this.skipbtn.visible = true;
        }
        else {
            this.skipbtn.visible = false;
        }
        //判断遮罩
        if (info.mask == 1) {
            this.bgimg.visible = true;
        }
        else {
            this.bgimg.visible = false;
        }
        //判断手指
        if (info.finger == "0") {
            this.fnger.visible = false;
        }
        else {
            //设置手指的位置
            this.fnger.visible = true;
            var fingerfather = null;
            if (info.fingerFather.length != 0) {
                fingerfather = ak.FairyGUI.getOpenUI(info.ui)[0].ui.getChild(info.fingerFather[0]);
            }
            if (info.finger.constructor == Array) {
                if (info.finger.length == 2) {
                    if (info.finger[1] < 0) {
                        var list = void 0;
                        if (fingerfather != null) {
                            list = fingerfather.getChild(info.finger[0]).asList;
                        }
                        else {
                            if (ak.FairyGUI.getOpenUI(info.ui).length == 0) {
                                this.skipbtn.visible = true;
                                this.fnger.visible = false;
                                return;
                            }
                            list = ak.FairyGUI.getOpenUI(info.ui)[0].ui.getChild(info.finger[0]);
                        }
                        var index = info.finger[1];
                        if (list.numItems < Math.abs(index) + 1) {
                            this.skipbtn.visible = true;
                            this.fnger.visible = false;
                            return;
                        }
                        var item = list.getChildAt(list.numItems + index).asCom;
                        if (!item) {
                            this.skipbtn.visible = true;
                            this.fnger.visible = false;
                        }
                        else {
                            this.fnger.x = item.localToGlobal().x + item.width / 2 - this.fnger.width / 2;
                            this.fnger.y = item.localToGlobal().y + item.height / 2 - this.fnger.height / 2;
                        }
                    }
                    else {
                        var list = void 0;
                        if (fingerfather != null) {
                            list = fingerfather.getChild(info.finger[0]).asList;
                        }
                        else {
                            if (ak.FairyGUI.getOpenUI(info.ui).length == 0) {
                                this.skipbtn.visible = true;
                                this.fnger.visible = false;
                                return;
                            }
                            list = ak.FairyGUI.getOpenUI(info.ui)[0].ui.getChild(info.finger[0]);
                        }
                        var index = info.finger[1];
                        if (list.numItems < index + 1) {
                            this.skipbtn.visible = true;
                            this.fnger.visible = false;
                            return;
                        }
                        var item = list.getChildAt(index).asCom;
                        if (!item) {
                            this.skipbtn.visible = true;
                            this.fnger.visible = false;
                        }
                        else {
                            this.fnger.x = item.localToGlobal().x + item.width / 2 - this.fnger.width / 2;
                            this.fnger.y = item.localToGlobal().y + item.height / 2 - this.fnger.height / 2;
                        }
                    }
                }
                else {
                    var list = void 0;
                    if (fingerfather != null) {
                        list = fingerfather.getChild(info.finger[0]).asList;
                    }
                    else {
                        if (ak.FairyGUI.getOpenUI(info.ui).length == 0) {
                            this.skipbtn.visible = true;
                            this.fnger.visible = false;
                            return;
                        }
                        list = ak.FairyGUI.getOpenUI(info.ui)[0].ui.getChild(info.finger[0]);
                    }
                    var index = info.finger[1];
                    if (list.numItems < index + 1) {
                        this.skipbtn.visible = true;
                        this.fnger.visible = false;
                        return;
                    }
                    var item = list.getChildAt(index).asCom;
                    if (!item) {
                        this.skipbtn.visible = true;
                        this.fnger.visible = false;
                    }
                    else {
                        var btn = item.getChild(info.finger[2]);
                        this.fnger.x = btn.localToGlobal().x + btn.width / 2 - this.fnger.width / 2;
                        this.fnger.y = btn.localToGlobal().y + btn.height / 2 - this.fnger.height / 2;
                    }
                }
            }
            else {
                var btn = void 0;
                if (fingerfather != null) {
                    btn = fingerfather.getChild(info.finger).asCom;
                }
                else {
                    if (ak.FairyGUI.getOpenUI(info.ui).length == 0) {
                        this.skipbtn.visible = true;
                        this.fnger.visible = false;
                        return;
                    }
                    btn = ak.FairyGUI.getOpenUI(info.ui)[0].ui.getChild(info.finger);
                }
                if (!btn) {
                    this.skipbtn.visible = true;
                    this.fnger.visible = false;
                }
                else {
                    this.fnger.x = btn.localToGlobal().x + btn.width / 2 - this.fnger.width / 2;
                    this.fnger.y = btn.localToGlobal().y + btn.height / 2 - this.fnger.height / 2;
                }
            }
        }
        //判断是否存点
        if (info.savePoint == 1) {
            //存点
            this.isbreakPoint = true;
        }
        else {
            //不存
            this.isbreakPoint = false;
        }
        //进入下一步条件
        this.cleanEvent();
        if (info.nextCondition == 0) {
            this.on(GameEvent.guide_nextGuide, this.nextHanle1, this);
        }
        else {
            this.on(this.info.nextCondition[0], this.nextHanle2, this);
        }
        //系统命令
        if (info.cmd != 0) {
            for (var expName in info.cmd) {
                switch (expName) {
                    //打开界面
                    case 'open':
                        ak.FairyGUI.open(info.cmd["open"]);
                        break;
                    //滑动事件
                    case 'scroll':
                        var ui = ak.FairyGUI.getOpenUI(info.ui)[0].ui.getChild("map").asCom;
                        var scrollPane = ui.scrollPane;
                        scrollPane.scrollToView(ui.getChild(info.cmd.scroll), true);
                        //派发下一步
                        Guide.inst.setTimeout();
                        break;
                    //战斗停止事件
                    case 'pauseBattle':
                        var scene0 = BattleScene.sceneArr[0];
                        scene0.pause();
                        if (info.type == 3) {
                            this.close();
                        }
                        ak.EventMgr.dispatch(GameEvent.guide_nextGuide);
                        break;
                    //战斗重启事件
                    case 'resumeBattle':
                        var scene1 = BattleScene.sceneArr[0];
                        scene1.resume();
                        if (info.type == 3) {
                            this.close();
                        }
                        break;
                    //拖动动画操作
                    case 'switchHero':
                        ak.FairyGUI.open(["switchHero", this.info]);
                        break;
                    //开放系统
                    case 'systemOpen':
                        var systemOpenIdGroupstr = "";
                        if (MyData.user) {
                            systemOpenIdGroupstr = GameLocalStorage.load(GameLocalStorage.systemOpenIdGroup);
                        }
                        var GroupIDarr = {};
                        if (systemOpenIdGroupstr != "" && systemOpenIdGroupstr != null) {
                            GroupIDarr = ak.json_decode(systemOpenIdGroupstr);
                        }
                        GroupIDarr[info.cmd.systemOpen] = info.cmd.systemOpen;
                        var GroupIDarrstr = JSON.stringify(GroupIDarr);
                        GameLocalStorage.save(GameLocalStorage.systemOpenIdGroup, GroupIDarrstr);
                        //派发更新开放系统
                        ak.EventMgr.dispatch(GameEvent.systemOpen_update);
                        break;
                }
            }
        }
        if (info.type == 3) {
            this.close();
        }
    };
    /**下一步 */
    GuideView.prototype.nextGuideView = function () {
        this.cleanEvent();
        Guide.inst.removeEvent();
        this.nextGuideID = GuideData.inst().GetNextGuideID(this.GuideID);
        if (this.nextGuideID == 0) {
            this.close();
        }
        else {
            this.GuideID = this.nextGuideID;
            //判断是否满足条件
            if (GuideData.inst().GetTabInfoById(this.GuideID).beginCondition == 0) {
                this.updateView();
            }
            else {
                if (GuideData.inst().GetTabInfoById(this.GuideID).beginCondition.barrier) {
                    if (MyData.user.barrierID == GuideData.inst().GetTabInfoById(this.GuideID).beginCondition.barrier && ak.FairyGUI.getOpenUI("ExplorationView").length != 0) {
                        this.updateView();
                        return;
                    }
                    else {
                        this.close();
                        return;
                    }
                }
                if (GuideData.inst().GetTabInfoById(this.GuideID).beginCondition.lv) {
                    if (MyData.user.level >= GuideData.inst().GetTabInfoById(this.GuideID).beginCondition.lv && ak.FairyGUI.getOpenUI("ExplorationView").length != 0) {
                        this.updateView();
                        return;
                    }
                    else {
                        this.close();
                        return;
                    }
                }
                this.updateView();
            }
        }
    };
    /**存点 */
    GuideView.prototype.breakPointHandle = function () {
        var completeGuideGroupIDstr = "";
        if (MyData.user) {
            completeGuideGroupIDstr = GameLocalStorage.load(GameLocalStorage.completeGuideGroupID);
        }
        var GroupIDarr = {};
        if (completeGuideGroupIDstr != "" && completeGuideGroupIDstr != null) {
            GroupIDarr = ak.json_decode(completeGuideGroupIDstr);
        }
        GroupIDarr[this.info.group] = this.info.group;
        var GroupIDarrstr = JSON.stringify(GroupIDarr);
        if (this.isbreakPoint) {
            GameLocalStorage.save(GameLocalStorage.completeGuideGroupID, GroupIDarrstr);
        }
    };
    GuideView.prototype.skipbtnPointHandle = function () {
        var completeGuideGroupIDstr = "";
        this.cleanEvent();
        Guide.inst.removeEvent();
        if (MyData.user) {
            completeGuideGroupIDstr = GameLocalStorage.load(GameLocalStorage.completeGuideGroupID);
        }
        var GroupIDarr = {};
        if (completeGuideGroupIDstr != "" && completeGuideGroupIDstr != null) {
            GroupIDarr = ak.json_decode(completeGuideGroupIDstr);
        }
        GroupIDarr[this.info.group] = this.info.group;
        var GroupIDarrstr = JSON.stringify(GroupIDarr);
        if (this.info.isSkip == 2 || this.info.isSkip == 1) {
            GameLocalStorage.save(GameLocalStorage.completeGuideGroupID, GroupIDarrstr);
        }
    };
    /**清除事件 */
    GuideView.prototype.cleanEvent = function () {
        if (this.info.nextCondition == 0) {
            this.off(GameEvent.guide_nextGuide, this.nextHanle1, this);
        }
        else {
            this.off(this.info.nextCondition[0], this.nextHanle2, this);
        }
    };
    GuideView.prototype.nextHanle1 = function () {
        this.breakPointHandle();
        this.nextGuideView();
    };
    GuideView.prototype.nextHanle2 = function (msg) {
        var nextCondition = this.info.nextCondition;
        if (nextCondition != 0) {
            var arr = nextCondition;
            var msgName = msg.name;
            var msgParams = msg.params;
            if (arr[0] != msgName) {
                return;
            }
            if (msgParams) {
                var arr2 = arr[1];
                var c = arr2.length;
                for (var i = 0; i < c; ++i) {
                    var tt = arr2[i];
                    if (tt != null) {
                        if (tt != msgParams[i]) {
                            return;
                        }
                    }
                }
            }
        }
        this.breakPointHandle();
        this.nextGuideView();
    };
    GuideView.prototype.setTimeOutSkip = function () {
        if (this.timer.getTime() >= 1 * 1000) {
            var info = this.info;
            if (info.isSkip == 2) {
                this.skipbtn.visible = true;
            }
        }
    };
    //销毁回调
    GuideView.prototype.onDestroy = function () {
        //清理
        this.removeEventListener(egret.Event.ENTER_FRAME, this.setTimeOutSkip, this);
    };
    return GuideView;
}(ak.EasyUI));
__reflect(GuideView.prototype, "GuideView");
var switchHeroSystem = (function (_super) {
    __extends(switchHeroSystem, _super);
    function switchHeroSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    switchHeroSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guide");
    };
    switchHeroSystem.inst = new switchHeroSystem("GuideView");
    return switchHeroSystem;
}(ak.FairyGUI));
__reflect(switchHeroSystem.prototype, "switchHeroSystem");
/**
 * 打开动画界面
 */
var switchHero = (function (_super) {
    __extends(switchHero, _super);
    function switchHero(info) {
        var _this = _super.call(this, switchHeroSystem.inst, MyGame.inst.guideLayer) || this;
        _this.info = {};
        _this.isFrist = true;
        _this.info = info;
        return _this;
    }
    /**回调 */
    switchHero.prototype.onInit = function () {
        var ui = this.create("Guide", "switchHero");
        this.ClickAdd();
        this.isFrist = true;
    };
    switchHero.prototype.ClickAdd = function () {
        this.addClickListener(this.ui, this.updateGuide, this);
    };
    switchHero.prototype.updateGuide = function () {
        var _this = this;
        if (this.isFrist) {
            this.isFrist = false;
            //交换操作
            var fightReadyView = ak.FairyGUI.getOpenUI(this.info.ui)[0];
            fightReadyView.changeIndex(2, 0);
            var timeEvent_1 = setTimeout(function () {
                clearTimeout(timeEvent_1);
                _this.close();
                ak.EventMgr.dispatch(_this.info.nextCondition);
            }, 300);
        }
    };
    return switchHero;
}(ak.EasyUI));
__reflect(switchHero.prototype, "switchHero");
var net;
(function (net) {
    //注册数据更新事件
    function regDataUpdateEvent() {
        //角色数据返回
        ak.EventMgr.addEventListener("netmsg://userResult", function (e) {
            ak.log("角色数据更新");
            var msg = e.params;
            MyData.user = msg[1];
            console.log(MyData.user);
            CPSDK.inst.uploadRoleInfo();
        }, this);
        //物品数组返回
        ak.EventMgr.addEventListener("netmsg://itemArrResult", function (e) {
            ak.log("物品数组更新");
            var msg = e.params;
            MyData.user.json.itemArr = msg[1];
        }, this);
        //卡牌数组返回
        ak.EventMgr.addEventListener("netmsg://cardArrResult", function (e) {
            ak.log("卡牌数组更新");
            var msg = e.params;
            MyData.user.json.cardArr = msg[1];
        }, this);
        //卡牌ID字典返回
        ak.EventMgr.addEventListener("netmsg://cardMapIDResult", function (e) {
            ak.log("卡牌ID字典更新");
            var msg = e.params;
            MyData.user.json.cardIDMap = msg[1];
        }, this);
        //卡牌数据返回
        ak.EventMgr.addEventListener("netmsg://cardDataResult", function (e) {
            ak.log("卡牌更新");
            var msg = e.params;
            var card = msg[1];
            var index = msg[2];
            MyData.user.json.cardArr[index] = card;
        }, this);
        //资源数据返回
        ak.EventMgr.addEventListener("netmsg://resourceResult", function (e) {
            ak.log("资源数据更新");
            var msg = e.params;
            MyData.user.diamond = msg[1];
            MyData.user.diamond2 = msg[2];
            MyData.user.money = msg[3];
            MyData.user.cardExp = msg[4];
            MyData.user.magicCrystal = msg[5];
            MyData.user.offerScore = msg[6];
            MyData.user.exp = msg[7];
            MyData.user.level = msg[8];
            MyData.user.magicCrystalTime = msg[9];
            CPSDK.inst.uploadRoleInfo();
        }, this);
        //抽卡数据返回
        ak.EventMgr.addEventListener("netmsg://randomCardDataResult", function (e) {
            ak.log("抽卡数据更新");
            var msg = e.params;
            MyData.user.randCardCount0 = msg[1];
            MyData.user.randCardCount1 = msg[2];
            MyData.user.randCardCount2 = msg[3];
            MyData.user.randCardTime0 = msg[4];
            MyData.user.randCardTime1 = msg[5];
            MyData.user.randCardScore = msg[6];
        }, this);
        //充值数据返回
        ak.EventMgr.addEventListener("netmsg://rechargeDataResult", function (e) {
            ak.log("充值数据更新");
            var msg = e.params;
            MyData.user.vip = msg[1];
            MyData.user.rmb = msg[2];
            MyData.user.vipExp = msg[3];
            MyData.user.json.recharge = msg[4];
            MyData.user.json.rightMap = msg[5];
        }, this);
        //玩家属性数据返回
        ak.EventMgr.addEventListener("netmsg://playerDataResult", function (e) {
            ak.log("玩家属性数据更新");
            var msg = e.params;
            MyData.user.nickname = msg[1];
            MyData.user.head = msg[2];
            MyData.user.cardMaxCount = msg[3];
            MyData.user.upgradeCardMaxCount = msg[4];
            MyData.user.unionName = msg[5];
            MyData.user.battlePower = msg[6];
            MyData.user.defBattlePower = msg[7];
            MyData.user.json.modifNicknameCount = msg[8];
            MyData.user.unionID = msg[9];
            CPSDK.inst.uploadRoleInfo();
        }, this);
        //世界树数据返回
        ak.EventMgr.addEventListener("netmsg://worldTreeDataResult", function (e) {
            ak.log("世界树数据更新");
            var msg = e.params;
            MyData.user.json.worldTree = msg[1];
        }, this);
        //宝石转换数据返回
        ak.EventMgr.addEventListener("netmsg://gemClearDataResult", function (e) {
            ak.log("宝石转换数据更新");
            var msg = e.params;
            MyData.user.json.gemClear = msg[1];
        }, this);
        //关卡数据返回
        ak.EventMgr.addEventListener("netmsg://barrierDataResult", function (e) {
            ak.log("关卡数据更新");
            var msg = e.params;
            MyData.user.barrierID = msg[1];
            MyData.user.getResBarrierID = msg[2];
            MyData.user.hookTime = msg[3];
            MyData.user.json.hook = msg[4];
        }, this);
        //酒馆数据返回
        ak.EventMgr.addEventListener("netmsg://pubDataResult", function (e) {
            ak.log("酒馆数据更新");
            var msg = e.params;
            MyData.user.json.pub = msg[1];
        }, this);
        //爬塔数据返回
        ak.EventMgr.addEventListener("netmsg://towerDataResult", function (e) {
            ak.log("爬塔数据更新");
            var msg = e.params;
            MyData.user.towerID = msg[1];
        }, this);
        //试练数据返回
        ak.EventMgr.addEventListener("netmsg://testDataResult", function (e) {
            ak.log("试练数据更新");
            var msg = e.params;
            MyData.user.json.test = msg[1];
        }, this);
        //市场数据返回
        ak.EventMgr.addEventListener("netmsg://marketDataResult", function (e) {
            ak.log("市场数据更新");
            var msg = e.params;
            MyData.user.json.market = msg[1];
        }, this);
        //许愿池数据返回
        ak.EventMgr.addEventListener("netmsg://wishPoolDataResult", function (e) {
            ak.log("许愿池数据更新");
            var msg = e.params;
            MyData.user.json.wishPool = msg[1];
        }, this);
        //点金数据返回
        ak.EventMgr.addEventListener("netmsg://getGoldDataResult", function (e) {
            ak.log("点金数据更新");
            var msg = e.params;
            MyData.user.json.getGold = msg[1];
        }, this);
        //成就任务返回
        ak.EventMgr.addEventListener("netmsg://achievementTaskDataResult", function (e) {
            ak.log("成就任务数据更新");
            var msg = e.params;
            MyData.user.json.achievementTask = msg[1];
        }, this);
        //日常任务数据返回
        ak.EventMgr.addEventListener("netmsg://dailyTaskDataResult", function (e) {
            ak.log("日常任务数据更新");
            var msg = e.params;
            MyData.user.json.dailyTask = msg[1];
        }, this);
        //聊天数据返回
        ak.EventMgr.addEventListener("netmsg://worldChat", function (e) {
            ak.log("聊天数据更新");
            var msg = e.params;
            msg.splice(0, 1);
            var channel = msg[7];
            switch (channel) {
                case 0://世界频道
                    ++MyData.worldChatUnreadCount;
                    MyData.worldChatArr.push(msg);
                    break;
                case 1://招募频道
                    ++MyData.recruitChatUnreadCount;
                    MyData.recruitChatArr.push(msg);
                    break;
                case 2://公会频道
                    ++MyData.unionChatUnreadCount;
                    MyData.unionChatArr.push(msg);
                    break;
            }
        }, this);
        //好友数据返回
        ak.EventMgr.addEventListener("netmsg://friendDataResult", function (e) {
            ak.log("竞技场数据更新");
            var msg = e.params;
            MyData.user.json.friendSys = msg[1];
        }, this);
        //竞技场数据返回
        ak.EventMgr.addEventListener("netmsg://stageDataResult", function (e) {
            ak.log("竞技场数据更新");
            var msg = e.params;
            MyData.user.json.stage = msg[1];
            MyData.user.upCardCount = msg[2];
        }, this);
        //膜拜数据返回
        ak.EventMgr.addEventListener("netmsg://worshipDataResult", function (e) {
            ak.log("膜拜数据更新");
            var msg = e.params;
            MyData.user.json.worship = msg[1];
        }, this);
        //英雄商店数据返回
        ak.EventMgr.addEventListener("netmsg://heroShopDataResult", function (e) {
            ak.log("英雄商店数据更新");
            var msg = e.params;
            MyData.user.json.heroShop = msg[1];
        }, this);
        //许愿池商店数据返回
        ak.EventMgr.addEventListener("netmsg://wishPoolShopDataResult", function (e) {
            ak.log("许愿池商店数据更新");
            var msg = e.params;
            MyData.user.json.wishPoolShop = msg[1];
        }, this);
        //在线奖励数据返回
        ak.EventMgr.addEventListener("netmsg://onlineRewardDataResult", function (e) {
            ak.log("在线奖励数据更新");
            var msg = e.params;
            MyData.user.json.onlineReward = msg[1];
        }, this);
        //签到数据返回
        ak.EventMgr.addEventListener("netmsg://signInDataResult", function (e) {
            ak.log("签到数据更新");
            var msg = e.params;
            MyData.user.json.signIn = msg[1];
        }, this);
        //公会信息数据返回
        ak.EventMgr.addEventListener("netmsg://unionInfoDataResult", function (e) {
            ak.log("公会信息数据更新");
            var msg = e.params;
            MyData.user.json.unionInfo = msg[1];
        }, this);
        //公会商店数据返回
        ak.EventMgr.addEventListener("netmsg://unionShopDataResult", function (e) {
            ak.log("公会商店数据更新");
            var msg = e.params;
            MyData.user.json.unionShop = msg[1];
        }, this);
        //远征数据返回
        ak.EventMgr.addEventListener("netmsg://remoteBattleDataResult", function (e) {
            ak.log("远征数据更新");
            var msg = e.params;
            MyData.user.json.remoteBattle = msg[1];
        }, this);
        //通知充值完成
        ak.EventMgr.addEventListener("netmsg://notifyPayComplete", function (e) {
            ak.log("通知充值完成");
            //触发批量发货
            net.batchGetGoodsFromPay();
        }, this);
        //每日商店数据返回
        ak.EventMgr.addEventListener("netmsg://dailyShopDataResult", function (e) {
            ak.log("每日商店数据更新");
            var msg = e.params;
            MyData.user.json.dailyShop = msg[1];
        }, this);
        //有新邮件
        ak.EventMgr.addEventListener("netmsg://notifyMail", function (e) {
            ak.log("有新邮件");
            //触发批量发货
            net.getMailNow();
        }, this);
        //获取邮件列表
        ak.EventMgr.addEventListener("netmsg://mail/getMailArrResult", function (e) {
            var mailArr = e.params[1];
            MyData.mailArr = mailArr;
        }, this);
        //超级基金数据返回
        ak.EventMgr.addEventListener("netmsg://superfundDataResult", function (e) {
            ak.log("超级基金数据更新");
            var msg = e.params;
            MyData.user.json.superfund = msg[1];
        }, this);
        //特权礼包数据返回
        ak.EventMgr.addEventListener("netmsg://rightPackageDataResult", function (e) {
            ak.log("特权礼包数据更新");
            var msg = e.params;
            MyData.user.json.rightPackage = msg[1];
        }, this);
        //福利礼包数据返回
        ak.EventMgr.addEventListener("netmsg://welfarePackageDataResult", function (e) {
            ak.log("福利礼包数据更新");
            var msg = e.params;
            MyData.user.json.welfarePackage = msg[1];
        }, this);
        //限时礼包数据返回
        ak.EventMgr.addEventListener("netmsg://limitPackageDataResult", function (e) {
            ak.log("限时礼包数据更新");
            var msg = e.params;
            MyData.user.json.limitPackage = msg[1];
        }, this);
        //创角7天活动数据返回
        ak.EventMgr.addEventListener("netmsg://createUser7DayDataResult", function (e) {
            ak.log("创角7天活动数据更新");
            var msg = e.params;
            MyData.user.json.createUser7Day = msg[1];
        }, this);
        //VIP礼包数据返回
        ak.EventMgr.addEventListener("netmsg://vipPackageDataResult", function (e) {
            ak.log("VIP礼包数据更新");
            var msg = e.params;
            MyData.user.json.vipPackage = msg[1];
        }, this);
        //区服数据返回
        ak.EventMgr.addEventListener("netmsg://serverDataResult", function (e) {
            ak.log("区服数据更新");
            var msg = e.params;
            MyData.serverName = msg[1];
            MyData.beginDate = msg[2];
            MyData.joinDate = msg[3];
            CPSDK.inst.uploadRoleInfo();
        }, this);
        //限时活动数据返回
        ak.EventMgr.addEventListener("netmsg://limitActivityDataResult", function (e) {
            ak.log("限时活动数据更新");
            var msg = e.params;
            MyData.user.json.limitActivity = msg[1];
        }, this);
        //月卡数据返回
        ak.EventMgr.addEventListener("netmsg://monthCardDataResult", function (e) {
            ak.log("月卡数据更新");
            var msg = e.params;
            MyData.user.json.monthCard = msg[1];
        }, this);
        //福利数据返回
        ak.EventMgr.addEventListener("netmsg://welfareDataResult", function (e) {
            ak.log("福利数据更新");
            var msg = e.params;
            MyData.user.json.welfare = msg[1];
        }, this);
        //英雄招募数据返回
        ak.EventMgr.addEventListener("netmsg://getHeroActivityResult", function (e) {
            ak.log("英雄招募数据更新");
            var msg = e.params;
            MyData.user.json.getHeroActivity = msg[1];
        }, this);
        //玩家升级数据返回
        ak.EventMgr.addEventListener("netmsg://playerLevelUpDataResult", function (e) {
            ak.log("玩家升级数据更新");
            var msg = e.params;
            MyData.user.level = msg[1];
            MyData.user.exp = msg[2];
            /**升级标记 */
            GainitemView.isLevelup = true;
        }, this);
        //发送神器数据返回
        ak.EventMgr.addEventListener("netmsg://godWeaponSysDataResult", function (e) {
            ak.log("神器数据更新");
            var msg = e.params;
            MyData.user.json.godWeaponSys = msg[1];
        }, this);
        //CDKEY数据返回
        ak.EventMgr.addEventListener("netmsg://cdkeyDateResult", function (e) {
            ak.log("CDKEY数据更新");
            var msg = e.params;
            MyData.user.json.cdkey = msg[1];
        }, this);
    }
    net.regDataUpdateEvent = regDataUpdateEvent;
})(net || (net = {}));
//AK的网络通信
var net;
(function (net) {
    //连接登录
    function cnnlogin() {
        var _this = this;
        //连接区服
        MyClient.inst.connectServer(function (isSucc) {
            if (isSucc) {
                ak.log("connectServer succ");
                //登录
                _this.login();
            }
        }, this);
    }
    net.cnnlogin = cnnlogin;
    //登录或创角后操作
    function afterLoginOrCreateRole() {
        var _this = this;
        //触发批量充值发货
        net.batchGetGoodsFromPay();
        //首次获取邮件
        net.getMail(function () {
            //首次获取聊天记录
            net.getWorldChat(function () {
                //首次获取好友列表
                net.getFriend(function () {
                    net.get_type1(function () {
                        ak.EventMgr.dispatch(GameEvent.guide_open);
                        PreloadSystem.inst.showBigLoading(false);
                    }, _this);
                }, _this);
            }, _this);
        }, this);
    }
    net.afterLoginOrCreateRole = afterLoginOrCreateRole;
    //登录
    function login() {
        var uid = MyData.uid;
        var sid = MyData.serverID;
        var token = MyData.Tokenid || "";
        var userid = MyData.account || "0";
        var ip = MyData.deviceIp || "";
        console.log("登录参数uid=：", uid);
        console.log("登录参数serverID=：", sid);
        console.log("登录参数Tokenid=：", token);
        console.log("登录参数account=：", userid);
        console.log("登录参数ip=：", ip);
        MyClient.inst.rpc(["login", uid, sid, token, userid, ip], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1://登录成功
                    ak.log("登录成功");
                    //计算客户端与服务端时间差
                    var serverTime = msg[2];
                    MyData.timeBase = serverTime - new Date().getTime() / 1000;
                    //登录或创角后操作
                    net.afterLoginOrCreateRole();
                    break;
                case -2://角色不存在
                    ak.log("角色不存在");
                    if (MyConfig.openGuide) {
                        ak.EventMgr.dispatch(GameEvent.guide_open);
                        PreloadSystem.inst.showBigLoading(false);
                    }
                    else {
                        //打开创角界面
                        ak.FairyGUI.open(["CreateRole"]);
                    }
                    break;
                case -3://
                    PreloadSystem.inst.showSmallLoading(true);
                    MyClient.inst.close();
                    setTimeout(function () {
                        PreloadSystem.inst.showSmallLoading(false);
                        net.cnnlogin();
                    }, 1000);
                    break;
            }
        }, this);
    }
    net.login = login;
    //抽卡
    function randomCard(type, //抽卡类型//召唤（1=普通1次，2=普通10次，3=高级1次，4=高级10次，5=友情1次，6=友情10次，7=积分召唤）
        callback, thisObj) {
        MyClient.inst.rpc(["randomCard", type], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("抽卡成功");
                    var getCardArr = msg[2];
                    callback.call(thisObj, getCardArr);
                    break;
                case -1:
                    TipsViewSystem.show("抽卡类型无效");
                    break;
                case -2:
                    TipsViewSystem.show("道具不足");
                    break;
                case -3:
                    TipsViewSystem.show("钻石不足");
                    break;
                case -4:
                    TipsViewSystem.show("积分不足");
                    break;
                case -5:
                    TipsViewSystem.show("VIP等级不足");
                    break;
                case -6:
                    TipsViewSystem.show("背包容量不足");
                    break;
                case -7:
                    TipsViewSystem.show("没达到VIP等级");
                    break;
            }
        }, this);
    }
    net.randomCard = randomCard;
    //GM命令
    function GM(orderStr //GM命令
    ) {
        MyClient.inst.rpc(["gm", orderStr], function (msg) {
            var result = msg[1];
            if (result != -1) {
                TipsViewSystem.show("执行成功");
            }
            else {
                TipsViewSystem.show("执行失败");
            }
        }, this);
    }
    net.GM = GM;
    //物品出售（装备、饰品）
    function itemSell(itemIndex, //出售物品索引
        sellCount, //出售数量
        callback, thisObj) {
        MyClient.inst.rpc(["bag/itemSell", itemIndex, sellCount], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("出售成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("出售数量错误");
                    break;
                case -2:
                    TipsViewSystem.show("物品不存在");
                    break;
                case -3:
                    TipsViewSystem.show("物品不能出售");
                    break;
                case -4:
                    var itemID = MyData.user.json.itemArr[itemIndex].itemID;
                    var name_4 = Common.getResourceItemName(itemID, 1);
                    TipsViewSystem.show(name_4 + "不足");
                    break;
            }
        }, this);
    }
    net.itemSell = itemSell;
    //碎片合成
    function itemPieceCompose(itemIndex, //碎片物品索引
        itemCount, //合成数量
        callback, thisObj) {
        MyClient.inst.rpc(["bag/itemCompose", itemIndex, itemCount], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("合成成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("碎片不存在");
                    break;
                case -2:
                    TipsViewSystem.show("非法碎片");
                    break;
                case -3:
                    TipsViewSystem.show("碎片不足");
                    break;
                case -4:
                    TipsViewSystem.show("背包不足");
                    break;
            }
        }, this);
    }
    net.itemPieceCompose = itemPieceCompose;
    //卡牌合成
    function cardCompose(targetHeroID, //目标英雄ID
        cardIndexArr, //材料卡索引数组
        callback, thisObj) {
        MyClient.inst.rpc(["bag/cardCompose", targetHeroID, cardIndexArr], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("合成成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("材料卡数量太多");
                    break;
                case -2:
                    TipsViewSystem.show("材料卡重复");
                    break;
                case -3:
                    TipsViewSystem.show("材料卡不存在");
                    break;
                case -4:
                    TipsViewSystem.show("材料卡不正确");
                    break;
                case -5:
                    TipsViewSystem.show("材料卡被锁定");
                    break;
                case -6:
                    TipsViewSystem.show("heroCompose数值表错误");
                    break;
                case -7:
                    TipsViewSystem.show("金币不足");
                    break;
                case -8:
                    TipsViewSystem.show("合成失败-勇气徽章不足");
                    break;
                case -9:
                    TipsViewSystem.show("升星前需要达到最高等阶");
                    break;
            }
        }, this);
    }
    net.cardCompose = cardCompose;
    //卡牌分解
    function cardDecompose(cardIndexArr, //分解卡牌索引数组
        callback, thisObj) {
        MyClient.inst.rpc(["bag/cardDecompose", cardIndexArr], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("分解成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("材料卡数量太多");
                    break;
                case -2:
                    TipsViewSystem.show("材料卡重复");
                    break;
                case -3:
                    TipsViewSystem.show("材料卡被锁定");
                    break;
                case -4:
                    TipsViewSystem.show("不能分解最后一个英雄");
                    break;
            }
        }, this);
    }
    net.cardDecompose = cardDecompose;
    //扩展卡牌背包
    function upgradeCardMaxCount(callback, thisObj) {
        MyClient.inst.rpc(["bag/upgradeCardMaxCount"], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("扩展卡牌背包成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("已经达到最大值");
                    break;
                case -2:
                    TipsViewSystem.show("钻石不足");
                    break;
            }
        }, this);
    }
    net.upgradeCardMaxCount = upgradeCardMaxCount;
    //设置卡牌锁
    function cardLock(cardIndex, //卡牌索引
        isLock, //是否锁定：0=否；1=是；
        callback, thisObj) {
        MyClient.inst.rpc(["bag/cardLock", cardIndex, isLock], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("设置卡牌锁成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("卡牌锁错误");
                    break;
                case -2:
                    TipsViewSystem.show("非法卡牌索引");
                    break;
            }
        }, this);
    }
    net.cardLock = cardLock;
    //卡牌升级
    function cardUp(cardIndex, //卡牌索引
        callback, thisObj) {
        MyClient.inst.rpc(["bag/cardUp", cardIndex], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("卡牌升级成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("非法卡牌索引");
                    break;
                case -2:
                    TipsViewSystem.show("已达到最高等级");
                    break;
                case -3:
                    TipsViewSystem.show("金币不足");
                    break;
                case -4:
                    TipsViewSystem.show("经验不足");
                    break;
            }
        }, this);
    }
    net.cardUp = cardUp;
    //卡牌进阶（升星）
    function cardUpStar(cardIndex, //卡牌索引
        callback, thisObj) {
        MyClient.inst.rpc(["bag/cardUpStar", cardIndex], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("卡牌进阶成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("非法卡牌索引");
                    break;
                case -2:
                    TipsViewSystem.show("已达到最高星级");
                    break;
                case -3:
                    TipsViewSystem.show("金币不足");
                    break;
                case -4:
                    var star = MyData.user.json.cardArr[cardIndex].star;
                    var heroPromotionTab = ak.JsonTableMgr.get("heroPromotion");
                    var row = heroPromotionTab.getRowFromColName("star", "" + star);
                    var itemID = row.getValFromColName("item");
                    var name_5 = Common.getResourceItemName(itemID, 1);
                    TipsViewSystem.show(name_5 + "不足");
                    break;
            }
        }, this);
    }
    net.cardUpStar = cardUpStar;
    //卡牌穿装
    function cardWearEqu(cardIndex, //卡牌索引
        itemIndex, //装备物品索引
        callback, thisObj) {
        MyClient.inst.rpc(["bag/cardWearEqu", cardIndex, itemIndex], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("卡牌穿装成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("非法卡牌索引");
                    break;
                case -2:
                    TipsViewSystem.show("非法物品索引");
                    break;
                case -3:
                    TipsViewSystem.show("非法装备");
                    break;
                case -4:
                    TipsViewSystem.show("未知类型装备");
                    break;
            }
        }, this);
    }
    net.cardWearEqu = cardWearEqu;
    //卡牌脱装
    function cardUnwearEqu(cardIndex, //卡牌索引
        equType, //装备类型：1=武器；2=戒子；3=头盔；4=衣服；5=饰品；
        callback, thisObj) {
        MyClient.inst.rpc(["bag/cardUnwearEqu", cardIndex, equType], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("卡牌脱装成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("非法卡牌索引");
                    break;
                case -2:
                    TipsViewSystem.show("非法装备类型");
                    break;
            }
        }, this);
    }
    net.cardUnwearEqu = cardUnwearEqu;
    //卡牌一键脱装
    function cardOneKeyUnwearEqu(cardIndex, //卡牌索引
        callback, thisObj) {
        MyClient.inst.rpc(["bag/cardOneKeyUnwearEqu", cardIndex], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("一键脱装成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("非法卡牌索引");
                    break;
            }
        }, this);
    }
    net.cardOneKeyUnwearEqu = cardOneKeyUnwearEqu;
    //卡牌一键穿装
    function cardOneKeyWearEqu(cardIndex, //卡牌索引
        callback, thisObj) {
        MyClient.inst.rpc(["bag/cardOneKeyWearEqu", cardIndex], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("一键穿装成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("非法卡牌索引");
                    break;
            }
        }, this);
    }
    net.cardOneKeyWearEqu = cardOneKeyWearEqu;
    //世界树抽卡
    function worldTreeRandomCard(raceID, //种族ID
        callback, thisObj) {
        MyClient.inst.rpc(["worldTree/randomCard", raceID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("世界树抽卡成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("非法种族ID");
                    break;
                case -2:
                    TipsViewSystem.show("道具不足");
                    break;
                case -3:
                    TipsViewSystem.show("背包容量不足");
                    break;
            }
        }, this);
    }
    net.worldTreeRandomCard = worldTreeRandomCard;
    //世界树卡牌置换发起
    function worldTreeCardSwap(cardIndex, //卡牌索引
        callback, thisObj) {
        MyClient.inst.rpc(["worldTree/cardSwap", cardIndex], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("世界树发起置换");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("非法卡牌索引");
                    break;
                case -2:
                    TipsViewSystem.show("卡牌星级不符合条件");
                    break;
                case -3:
                    TipsViewSystem.show("卡牌种族不符合条件");
                    break;
                case -4:
                    TipsViewSystem.show("道具不足");
                    break;
                case -5:
                    TipsViewSystem.show("掉落组没有掉落，请检查数值表");
                    break;
            }
        }, this);
    }
    net.worldTreeCardSwap = worldTreeCardSwap;
    //世界树卡牌同意置换
    function worldTreeCardSwapYes(cardIndex, //卡牌索引
        callback, thisObj) {
        MyClient.inst.rpc(["worldTree/cardSwapYes", cardIndex], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("世界树置换成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("未发起置换");
                    break;
                case -2:
                    TipsViewSystem.show("非法卡牌索引");
                    break;
                case -3:
                    TipsViewSystem.show("原卡牌不存在");
                    break;
            }
        }, this);
    }
    net.worldTreeCardSwapYes = worldTreeCardSwapYes;
    //卡牌穿戴的饰品升级
    function cardLookingUp(cardIndex, //穿戴饰品的卡牌索引
        lookingIndexArr, //材料索引数组
        lookingCountArr, //材料数量数组
        callback, thisObj) {
        MyClient.inst.rpc(["bag/cardLookingUp", cardIndex, lookingIndexArr, lookingCountArr], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("饰品升级成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("非法卡牌索引");
                    break;
                case -2:
                    TipsViewSystem.show("无效材料ID");
                    break;
                case -3:
                    TipsViewSystem.show("材料重复");
                    break;
                case -4:
                    TipsViewSystem.show("材料不存在");
                    break;
                case -5:
                    TipsViewSystem.show("材料不足");
                    break;
                case -6:
                    TipsViewSystem.show("无效材料ID");
                    break;
                case -7:
                    TipsViewSystem.show("饰品不存在");
                    break;
                case -8:
                    TipsViewSystem.show("饰品无效");
                    break;
                case -9:
                    TipsViewSystem.show("达到等级上限");
                    break;
                case -10:
                    TipsViewSystem.show("材料经验不足");
                    break;
            }
        }, this);
    }
    net.cardLookingUp = cardLookingUp;
    //宝石升级
    function cardGemUp(cardIndex, //卡牌索引
        isLock, //是否锁定属性：0=否；1=是；
        callback, thisObj) {
        MyClient.inst.rpc(["bag/cardGemUp", cardIndex, isLock], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("宝石升级成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("卡牌锁错误");
                    break;
                case -2:
                    TipsViewSystem.show("非法卡牌索引");
                    break;
                case -3:
                    TipsViewSystem.show("已达到最大等级");
                    break;
                case -4:
                    TipsViewSystem.show("金币不足");
                    break;
                case -5:
                    var gemLevel = MyData.user.json.cardArr[cardIndex].gemLevel;
                    var stoneTab = ak.JsonTableMgr.get("stone");
                    var row = stoneTab.getRowFromColName("level", "" + gemLevel);
                    var levelItemID = row.getValFromColName("levelItemID");
                    var name_6 = Common.getResourceItemName(levelItemID, 1);
                    TipsViewSystem.show(name_6 + "不足");
                    break;
                case -6:
                    TipsViewSystem.show("钻石不足");
                    break;
            }
        }, this);
    }
    net.cardGemUp = cardGemUp;
    //宝石激活
    function cardGemStart(cardIndex, //卡牌索引
        callback, thisObj) {
        MyClient.inst.rpc(["bag/cardGemStart", cardIndex], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("宝石激活成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("非法卡牌索引");
                    break;
                case -2:
                    TipsViewSystem.show("已激活");
                    break;
                case -3:
                    TipsViewSystem.show("卡牌等级不足");
                    break;
            }
        }, this);
    }
    net.cardGemStart = cardGemStart;
    //发起宝石转换（洗练）
    function cardGemClear(cardIndex, //卡牌索引
        callback, thisObj) {
        MyClient.inst.rpc(["bag/cardGemClear", cardIndex], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("宝石转换成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("非法卡牌索引");
                    break;
                case -2:
                    TipsViewSystem.show("未激活");
                    break;
                case -3:
                    TipsViewSystem.show("金币不足");
                    break;
                case -4:
                    var card = MyData.user.json.cardArr[cardIndex];
                    var gemLevel = card.gemLevel;
                    var stoneTab = ak.JsonTableMgr.get("stone");
                    var row = stoneTab.getRowFromColName("level", "" + gemLevel);
                    var changeItemID = row.getValFromColName("changeItemID");
                    var name_7 = Common.getResourceItemName(changeItemID, 1);
                    TipsViewSystem.show(name_7 + "不足");
                    break;
            }
        }, this);
    }
    net.cardGemClear = cardGemClear;
    //宝石转换同意
    function cardGemClearYes(cardIndex, //卡牌索引
        callback, thisObj) {
        MyClient.inst.rpc(["bag/cardGemClearYes", cardIndex], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("宝石转换成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("未发起置换");
                    break;
                case -2:
                    TipsViewSystem.show("非法卡牌索引");
                    break;
                case -3:
                    TipsViewSystem.show("原卡牌不存在");
                    break;
            }
        }, this);
    }
    net.cardGemClearYes = cardGemClearYes;
    //装备合成
    function cardEquCompose(equID, //目标装备ID
        count, //合成数量
        callback, thisObj) {
        MyClient.inst.rpc(["bag/cardEquCompose", equID, count], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("装备合成成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("合成数量错误");
                    break;
                case -2:
                    TipsViewSystem.show("非法装备");
                    break;
                case -3:
                    TipsViewSystem.show("金币不足");
                    break;
                case -4:
                    TipsViewSystem.show("材料不足");
                    break;
            }
        }, this);
    }
    net.cardEquCompose = cardEquCompose;
    //挑战领主
    function hookBattle(upCardIndexArr, //上阵卡牌索引数组，长度为6，空位为-1
        callback, thisObj) {
        MyClient.inst.rpc(["hook/battle", upCardIndexArr], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("挑战领主战报返回");
                    var report = msg[2];
                    var dropMap = null;
                    if (report.winTeamID == 1) {
                        dropMap = msg[3];
                    }
                    callback.call(thisObj, report, dropMap);
                    break;
                case -1:
                    TipsViewSystem.show("达到最后一关");
                    break;
                case -2:
                    TipsViewSystem.show("上阵卡牌索引数组错误");
                    break;
                case -3:
                    TipsViewSystem.show("上阵卡牌索引错误");
                    break;
                case -4:
                    TipsViewSystem.show("上阵人数为0");
                    break;
                case -5:
                    TipsViewSystem.show("重复上阵");
                    break;
            }
        }, this);
    }
    net.hookBattle = hookBattle;
    //设置挂机地点
    function hookSelectPlace(selectBarrierID, //挂机关卡ID
        callback, thisObj) {
        MyClient.inst.rpc(["hook/selectPlace", selectBarrierID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("设置挂机地点成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("非法挂机关卡");
                    break;
            }
        }, this);
    }
    net.hookSelectPlace = hookSelectPlace;
    //获取挂机奖励
    function hookGetRes(callback, thisObj) {
        MyClient.inst.rpc(["hook/getRes"], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("获取挂机奖励成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("获取太频繁");
                    break;
            }
        }, this);
    }
    net.hookGetRes = hookGetRes;
    //刷新酒馆任务
    function pubFlush(callback, thisObj) {
        MyClient.inst.rpc(["pub/flush"], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("刷新酒馆任务成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("钻石不足");
                    break;
            }
        }, this);
    }
    net.pubFlush = pubFlush;
    //接受酒馆任务
    function pubBeginTask(taskIndex, //任务索引
        cardIndexArr, //上阵卡牌索引数组	
        callback, thisObj) {
        MyClient.inst.rpc(["pub/beginTask", taskIndex, cardIndexArr], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("接受酒馆任务成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("非法任务索引");
                    break;
                case -2:
                    TipsViewSystem.show("卡牌数量异常");
                    break;
                case -3:
                    TipsViewSystem.show("卡牌重复");
                    break;
                case -4:
                    TipsViewSystem.show("非法卡牌索引");
                    break;
                case -5:
                    TipsViewSystem.show("卡牌已参与任务");
                    break;
                case -6:
                    TipsViewSystem.show("星级不满足条件");
                    break;
                case -7:
                    TipsViewSystem.show("种族不满足条件");
                    break;
                case -8:
                    TipsViewSystem.show("悬赏积分不足");
                    break;
            }
        }, this);
    }
    net.pubBeginTask = pubBeginTask;
    //完成酒馆任务
    function pubEndTask(taskIndex, //任务索引
        callback, thisObj) {
        MyClient.inst.rpc(["pub/endTask", taskIndex], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("完成酒馆任务成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("非法任务索引");
                    break;
                case -2:
                    TipsViewSystem.show("时间未到");
                    break;
            }
        }, this);
    }
    net.pubEndTask = pubEndTask;
    //加速完成酒馆任务
    function pubEndTaskQuick(taskIndex, //任务索引
        callback, thisObj) {
        MyClient.inst.rpc(["pub/endTaskQuick", taskIndex], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("完成酒馆任务成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("非法任务索引");
                    break;
                case -2:
                    TipsViewSystem.show("钻石不足");
                    break;
            }
        }, this);
    }
    net.pubEndTaskQuick = pubEndTaskQuick;
    //爬塔战斗
    function towerBattle(upCardIndexArr, //上阵卡牌索引数组，长度为6，空位为-1
        callback, thisObj) {
        MyClient.inst.rpc(["tower/battle", upCardIndexArr], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("爬塔战斗返回");
                    var report = msg[2];
                    var dropMap = null;
                    if (report.winTeamID == 1) {
                        dropMap = msg[3];
                    }
                    callback.call(thisObj, report, dropMap);
                    break;
                case -1:
                    TipsViewSystem.show("法术结晶不足");
                    break;
                case -2:
                    TipsViewSystem.show("已达到最高层");
                    break;
                case -3:
                    TipsViewSystem.show("上阵卡牌索引数组错误");
                    break;
                case -4:
                    TipsViewSystem.show("重复上阵");
                    break;
                case -5:
                    TipsViewSystem.show("上阵卡牌索引错误");
                    break;
                case -6:
                    TipsViewSystem.show("上阵人数为0");
                    break;
            }
        }, this);
    }
    net.towerBattle = towerBattle;
    //购买法术结晶
    function towerBuyMagicCrystal(buyCount, //购买数量
        callback, thisObj) {
        MyClient.inst.rpc(["tower/buyMagicCrystal", buyCount], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("购买法术结晶成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("购买数量错误");
                    break;
                case -2:
                    TipsViewSystem.show("钻石不足");
                    break;
            }
        }, this);
    }
    net.towerBuyMagicCrystal = towerBuyMagicCrystal;
    //试练战斗
    function testBattle(trialID, //试练ID，对应trial.xlsx中id
        upCardIndexArr, //上阵卡牌索引数组，长度为6，空位为-1
        callback, thisObj) {
        MyClient.inst.rpc(["test/battle", trialID, upCardIndexArr], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("试练战斗返回");
                    var report = msg[2];
                    var dropMap = null;
                    if (report.winTeamID == 1) {
                        dropMap = msg[3];
                    }
                    callback.call(thisObj, report, dropMap);
                    break;
                case -1:
                    TipsViewSystem.show("非法试练ID");
                    break;
                case -2:
                    TipsViewSystem.show("玩家等级不足");
                    break;
                case -3:
                    TipsViewSystem.show("试练次数不足");
                    break;
                case -4:
                    TipsViewSystem.show("上阵卡牌索引数组错误");
                    break;
                case -5:
                    TipsViewSystem.show("重复上阵");
                    break;
                case -6:
                    TipsViewSystem.show("上阵卡牌索引错误");
                    break;
                case -7:
                    TipsViewSystem.show("上阵人数为0");
                    break;
            }
        }, this);
    }
    net.testBattle = testBattle;
    //试练次数购买
    function testBuy(type, //试练类型
        count, //购买次数
        callback, thisObj) {
        MyClient.inst.rpc(["test/buy", type, count], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("试练次数购买成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("非法试练类型");
                    break;
                case -2:
                    TipsViewSystem.show("非法购买次数");
                    break;
                case -3:
                    TipsViewSystem.show("钻石不足");
                    break;
                case -4:
                    TipsViewSystem.show("超过购买次数");
                    break;
            }
        }, this);
    }
    net.testBuy = testBuy;
    //快速探险
    function getResQuick(callback, thisObj) {
        MyClient.inst.rpc(["hook/getResQuick"], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("快速探险成功");
                    var dropMap = msg[2];
                    callback.call(thisObj, dropMap);
                    break;
                case -1:
                    TipsViewSystem.show("快速探险次数购买用完");
                    break;
                case -2:
                    TipsViewSystem.show("钻石不足");
                    break;
            }
        }, this);
    }
    net.getResQuick = getResQuick;
    //领取探险成就奖励
    function getResFromHookAchievement(achievementID, //探险成就ID，对应barrierAchivement.xlsx
        callback, thisObj) {
        MyClient.inst.rpc(["hook/getResFromAchievement", achievementID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("领取探险成就奖励成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("探险成就ID错误");
                    break;
                case -2:
                    TipsViewSystem.show("已领取");
                    break;
                case -3:
                    TipsViewSystem.show("未达到条件");
                    break;
            }
        }, this);
    }
    net.getResFromHookAchievement = getResFromHookAchievement;
    //获取探险通关排行榜
    function hookRank(callback, thisObj) {
        MyClient.inst.rpc(["hook/rank"], function (msg) {
            ak.log("获取探险通关排行榜成功");
            callback.call(thisObj, msg);
        }, this);
    }
    net.hookRank = hookRank;
    //刷新市场出售物品
    function marketFlush(callback, thisObj) {
        MyClient.inst.rpc(["market/flush"], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("刷新市场出售物品成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("钻石不足");
                    break;
            }
        }, this);
    }
    net.marketFlush = marketFlush;
    //市场购买
    function marketBuy(itemArrIndex, //市场物品数组索引
        callback, thisObj) {
        MyClient.inst.rpc(["market/buy", itemArrIndex], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("市场购买成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("物品索引错误");
                    break;
                case -2:
                    TipsViewSystem.show("该物品已被购买");
                    break;
                case -3:
                    TipsViewSystem.show("物品不存在");
                    break;
                case -4:
                    TipsViewSystem.show("金币不足");
                    break;
                case -5:
                    TipsViewSystem.show("钻石不足");
                    break;
            }
        }, this);
    }
    net.marketBuy = marketBuy;
    //获取邮件列表
    function getMail(callback, thisObj) {
        MyClient.inst.rpc(["mail/getMailArr"], function (msg) {
            ak.log("获取邮件列表成功");
            var mailArr = msg[1];
            MyData.mailArr = mailArr;
            callback.call(thisObj, mailArr);
        }, this);
    }
    net.getMail = getMail;
    //获取邮件列表
    function getMailNow() {
        MyClient.inst.sendMsg(["mail/getMailArr"]);
    }
    net.getMailNow = getMailNow;
    //获取邮件物品
    function getMailRes(mailID, //邮件ID，为0时代表所有邮件
        callback, thisObj) {
        MyClient.inst.rpc(["mail/getMailRes", mailID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    var mailID_1 = msg[2];
                    ak.log("获取邮件物品成功");
                    callback.call(thisObj, mailID_1);
                    break;
                case -1:
                    TipsViewSystem.show("邮件物品获取太频繁");
                    break;
            }
        }, this);
    }
    net.getMailRes = getMailRes;
    //删除邮件
    function removeMail(mailID, //邮件ID，为0时代表所有邮件
        callback, thisObj) {
        MyClient.inst.rpc(["mail/removeMail", mailID], function (msg) {
            var mailID = msg[1];
            ak.log("删除邮件成功");
            callback.call(thisObj, mailID);
        }, this);
    }
    net.removeMail = removeMail;
    //发送世界聊天信息
    function sendWorldChat(chatStr, //聊天信息
        chatType //聊天信息类型，参考mysql有chat_world中type描述
    ) {
        var channel = 0; //频道
        MyClient.inst.rpc(["chat/worldChat", chatStr, chatType, channel], function (msg) {
            ak.log("发送世界聊天信息成功");
        }, this);
    }
    net.sendWorldChat = sendWorldChat;
    //发送招募聊天信息
    function sendRecruitChat(chatStr, //聊天信息
        chatType //聊天信息类型，参考mysql有chat_world中type描述
    ) {
        var channel = 1; //频道
        MyClient.inst.rpc(["chat/worldChat", chatStr, chatType, channel], function (msg) {
            ak.log("发送招募聊天信息成功");
        }, this);
    }
    net.sendRecruitChat = sendRecruitChat;
    //发送公会聊天信息
    function sendUnionChat(chatStr, //聊天信息
        chatType //聊天信息类型，参考mysql有chat_world中type描述
    ) {
        var channel = 2; //频道
        MyClient.inst.rpc(["chat/worldChat", chatStr, chatType, channel], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("发送公会聊天信息成功");
                    break;
                case -1:
                    TipsViewSystem.show("请先加入公会");
                    break;
            }
        }, this);
    }
    net.sendUnionChat = sendUnionChat;
    //获取聊天记录
    function getWorldChat(callback, thisObj) {
        MyClient.inst.rpc(["chat/getWorldChat"], function (msg) {
            var arr = msg[1];
            var worldChatArr = arr[0];
            worldChatArr.reverse();
            MyData.worldChatArr = worldChatArr;
            MyData.worldChatUnreadCount = worldChatArr.length;
            var recruitChatArr = arr[1];
            recruitChatArr.reverse();
            MyData.recruitChatArr = recruitChatArr;
            MyData.recruitChatUnreadCount = recruitChatArr.length;
            var unionChatArr = arr[2];
            unionChatArr.reverse();
            MyData.unionChatArr = unionChatArr;
            MyData.unionChatUnreadCount = unionChatArr.length;
            ak.log("获取聊天记录成功");
            callback.call(thisObj);
        }, this);
    }
    net.getWorldChat = getWorldChat;
    //设置竞技场防守阵容
    function stageSetDefCardArr(upCardIndexArr, //上阵卡牌索引数组，长度为6，空位为-1
        callback, thisObj) {
        MyClient.inst.rpc(["stage/setDefCardArr", upCardIndexArr], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("设置竞技场防守阵容成功");
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("上阵卡牌索引数组错误");
                    break;
                case -2:
                    TipsViewSystem.show("重复上阵");
                    break;
                case -3:
                    TipsViewSystem.show("上阵卡牌索引错误");
                    break;
                case -4:
                    TipsViewSystem.show("上阵英雄不能为空");
                    break;
            }
        }, this);
    }
    net.stageSetDefCardArr = stageSetDefCardArr;
    //获取角色基础信息
    function getRoleBaseInfo(userID, //角色ID
        callback, thisObj) {
        MyClient.inst.rpc(["getRoleBaseInfo", userID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    ak.log("获取角色基础信息成功");
                    callback.call(thisObj, msg[2]);
                    break;
                case -1:
                    TipsViewSystem.show("获取角色基础信息成功失败，角色不存在");
                    break;
            }
        }, this);
    }
    net.getRoleBaseInfo = getRoleBaseInfo;
    //获取战力排行榜
    function battlePowerRank(callback, thisObj) {
        MyClient.inst.rpc(["battlePowerRank"], function (msg) {
            ak.log("获取战力排行榜成功");
            callback.call(thisObj, msg);
        }, this);
    }
    net.battlePowerRank = battlePowerRank;
    //获取爬塔排行榜
    function towerRank(callback, thisObj) {
        MyClient.inst.rpc(["tower/rank"], function (msg) {
            ak.log("获取爬塔排行榜成功");
            callback.call(thisObj, msg);
        }, this);
    }
    net.towerRank = towerRank;
    //触发批量充值发货
    function batchGetGoodsFromPay() {
        MyClient.inst.sendMsg(["recharge/batchGetGoodsFromPay"]);
    }
    net.batchGetGoodsFromPay = batchGetGoodsFromPay;
    //生成充值订单
    function genPayOrder(payID) {
        console.log("充值:", payID);
        MyClient.inst.rpc(["recharge/genOrder", payID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    var orderNum = msg[2];
                    var rmb = msg[3];
                    ak.log("生成充值订单成功", orderNum, rmb);
                    if (MyConfig.testPay == false) {
                        //调用SDK充值接口...
                        if (MyConfig.loginType == 1 || MyConfig.loginType == 4 || MyConfig.loginType == 3) {
                            CPSDK.inst.pay(orderNum, rmb, "充值", "充值");
                        }
                    }
                    break;
                case -1:
                    TipsViewSystem.show("充值ID错误");
                    break;
            }
        }, this);
    }
    net.genPayOrder = genPayOrder;
})(net || (net = {}));
//启顺的网络通信
var net;
(function (net) {
    /**
     * 创建角色
     */
    function register(name) {
        MyClient.inst.rpc(["createUser", name], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    // TipsViewSystem.show("创角成功");
                    CreateRoleSystem.createRoleUI.close();
                    CreateRoleSystem.createRoleUI = null;
                    //登录或创角后操作
                    net.afterLoginOrCreateRole();
                    break;
                case -1:
                    TipsViewSystem.show("角色已存在");
                    break;
                case -2:
                    TipsViewSystem.show("昵称不合法");
                    break;
                case -3:
                    TipsViewSystem.show("昵称重名");
                    break;
                default:
                    TipsViewSystem.show("创角失败");
            }
        }, this);
    }
    net.register = register;
    /**
     * 许愿池刷新
     */
    function wishPoolFlush(type, callback, thisObj) {
        MyClient.inst.rpc(["wishPool/flush", type], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("刷新类型错误");
                    break;
                case -2:
                    TipsViewSystem.show("钻石不足");
                    break;
            }
        }, this);
    }
    net.wishPoolFlush = wishPoolFlush;
    /**
     * 抽奖
     * type：（1=普通许愿池，2=高级许愿池）
     * num：（1=一抽，2=十抽）
     */
    function luckDraw(type, num, callback, thisObj) {
        MyClient.inst.rpc(["wishPool/luckDraw", type, num], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("抽奖类型错误");
                    break;
                case -2:
                    TipsViewSystem.show("许愿币不足");
                    break;
                case -3:
                    TipsViewSystem.show("普通10连抽，没达到VIP等级");
                    break;
                case -4:
                    TipsViewSystem.show("高级许愿池，没达到VIP等级");
                    break;
            }
        }, this);
    }
    net.luckDraw = luckDraw;
    /**
     * 购买普通抽奖道具
     * count 购买數量
     */
    function wishPoolBuy(count, callback, thisObj) {
        MyClient.inst.rpc(["wishPool/buy", count], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj);
                    break;
                case -2:
                    TipsViewSystem.show("钻石不足");
                    break;
            }
        }, this);
    }
    net.wishPoolBuy = wishPoolBuy;
    /**
     * 排行榜
     */
    function get10(callback, thisObj) {
        MyClient.inst.rpc(["wishPool/get10"], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
            }
        }, this);
    }
    net.get10 = get10;
    /**
     * 点金
     * getGoldID 点金id
     */
    function getGold(getGoldID, callback, thisObj) {
        MyClient.inst.rpc(["getGold/getGold", getGoldID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    var dropMap = msg[2];
                    callback.call(thisObj, dropMap);
                    break;
                case -1:
                    TipsViewSystem.show("点金错误");
                    break;
                case -2:
                    TipsViewSystem.show("点金次数不足");
                    break;
                case -3:
                    TipsViewSystem.show("钻石不足");
                    break;
            }
        }, this);
    }
    net.getGold = getGold;
    /**
     * 成就任务
     * taskID	成就任务ID
     */
    function finishAchievementTask(taskID, callback, thisObj) {
        MyClient.inst.rpc(["task/finishAchievementTask", taskID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("成就任务ID错误");
                    break;
                case -2:
                    TipsViewSystem.show("成就条件未满足");
                    break;
                case -3:
                    TipsViewSystem.show("成就已完成");
                    break;
            }
        }, this);
    }
    net.finishAchievementTask = finishAchievementTask;
    /**
     * 日常任务
     * taskID	日常任务ID
     */
    function finishDailyTask(taskID, callback, thisObj) {
        MyClient.inst.rpc(["task/finishDailyTask", taskID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("日常任务ID错误");
                    break;
                case -2:
                    TipsViewSystem.show("日常任务条件未满足");
                    break;
                case -3:
                    TipsViewSystem.show("日常任务已完成");
                    break;
            }
        }, this);
    }
    net.finishDailyTask = finishDailyTask;
    /**
     * 好友申请
     * targetUserID 目标userID
     */
    function reqFirend(targetUserID, callback, thisObj) {
        MyClient.inst.rpc(["friend/reqFriend", targetUserID], function (msg) {
            var result = msg[1];
            switch (result) {
                case -1:
                    TipsViewSystem.show("好友已存在");
                    break;
                case -2:
                    TipsViewSystem.show("不能添加自己为好友");
                    break;
                case -3:
                    TipsViewSystem.show("角色不存在");
                    break;
                default:
                    callback.call(thisObj);
            }
        }, this);
    }
    net.reqFirend = reqFirend;
    /**
     * 接受或拒绝好友申请
     * targetUserID  目标userID
     * pass			 0=不同意;1=同意
     */
    function agreeReqFriend(targetUserID, pass, callback, thisObj) {
        MyClient.inst.rpc(["friend/agreeReqFriend", targetUserID, pass], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj);
                    break;
                case -1:
                    TipsViewSystem.show("已达到好友上限");
                    break;
            }
        }, this);
    }
    net.agreeReqFriend = agreeReqFriend;
    /**
     * 获取好友申请列表
     */
    function getReqFriend(callback, thisObj) {
        MyClient.inst.rpc(["friend/getReqFriend"], function (msg) {
            callback.call(thisObj, msg);
        }, this);
    }
    net.getReqFriend = getReqFriend;
    /**
     * 获取好友列表
     */
    function getFriend(callback, thisObj) {
        MyClient.inst.rpc(["friend/getFriend"], function (msg) {
            MyData.friendMap = msg[1];
            callback.call(thisObj, msg);
        }, this);
    }
    net.getFriend = getFriend;
    /**
     * 获取黑名单列表
     */
    function getBlack(callback, thisObj) {
        MyClient.inst.rpc(["friend/getBlack"], function (msg) {
            callback.call(thisObj, msg);
        }, this);
    }
    net.getBlack = getBlack;
    /**
     * 给好友送心
     * targetUserID		好友userID 0=所有好友
     */
    function giveHeart(targetUserID, callback, thisObj) {
        MyClient.inst.rpc(["friend/giveHeart", targetUserID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    MyData.user.json.friendSys.giveHeartCount = msg[2];
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("每日发送爱心上限");
                    break;
            }
        }, this);
    }
    net.giveHeart = giveHeart;
    /**
     * 收获好友送的心
     * targetUserID  目标userID 0=收获所有好友送的心
     */
    function recvHeart(targetUserID, callback, thisObj) {
        MyClient.inst.rpc(["friend/recvHeart", targetUserID], function (msg) {
            var result = msg[1];
            switch (result) {
                case -1:
                    TipsViewSystem.show("每日获得爱心上限");
                    break;
                case 0:
                    TipsViewSystem.show("无法收心");
                    break;
                default:
                    MyData.user.json.friendSys.recvHeartCount = msg[2];
                    callback.call(thisObj);
            }
        }, this);
    }
    net.recvHeart = recvHeart;
    /**
     * 删除好友或黑名单
     * targetUserID  目标userID
     */
    function removeFriend(targetUserID, callback, thisObj) {
        MyClient.inst.rpc(["friend/removeFriend", targetUserID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj);
                    break;
            }
        }, this);
    }
    net.removeFriend = removeFriend;
    /**
     * 拉进黑名单
     */
    function addBlackFriend(targetUserID, callback, thisObj) {
        MyClient.inst.rpc(["friend/addBlackFriend", targetUserID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj);
                    break;
            }
        }, this);
    }
    net.addBlackFriend = addBlackFriend;
    /**
     * 一键收送心
     */
    function oneKeyFriendHeart(callback, thisObj) {
        var _this = this;
        MyClient.inst.rpc(["friend/recvHeart", 0], function (msg) {
            MyClient.inst.rpc(["friend/giveHeart", 0], function (msg1) {
                callback.call(thisObj, msg, msg1);
            }, _this);
        }, this);
    }
    net.oneKeyFriendHeart = oneKeyFriendHeart;
    /**
     * 探宝
     */
    function searchTreasure(callback, thisObj) {
        MyClient.inst.rpc(["friend/searchTreasure"], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case 2:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("存在BOSS,不能探宝");
                    break;
                case -2:
                    TipsViewSystem.show("探宝时间未到");
                    break;
            }
        }, this);
    }
    net.searchTreasure = searchTreasure;
    /**
     * 删除或同意所有好友请求
     * type			0=删除所有请求；1=同意所有请求
     */
    function handleAllReqFriend(type, callback, thisObj) {
        MyClient.inst.rpc(["friend/handleAllReqFriend", type], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("已达到好友上限");
                    break;
                case -2:
                    TipsViewSystem.show("好友剩余空位不足");
                    break;
            }
        }, this);
    }
    net.handleAllReqFriend = handleAllReqFriend;
    /**
     * 获取好友BOSS状态
     * friendUserID			好友BOSSuserID
     */
    function getBoss(friendUserID, callback, thisObj) {
        MyClient.inst.rpc(["friend/getBoss", friendUserID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
            }
        }, this);
    }
    net.getBoss = getBoss;
    /**
     * 打好友BOSS
     * friendUserID		好友userID
     * stamina			体力数量
     * upCardIndexArr	上阵卡牌索引数组，长度为6，空位为-1
     * type				0=战斗；1=扫荡
     */
    function bossBattle(friendUserID, stamina, upCardIndexArr, type, callback, thisObj) {
        MyClient.inst.rpc(["friend/bossBattle", friendUserID, stamina, upCardIndexArr, type], function (msg) {
            var result = msg[1];
            switch (result) {
                default:
                    if (type) {
                        var dropMap = result[0]; //掉落
                        var consumeHp = result[1]; //伤害
                        var jifen = result[2]; //积分
                        callback.call(thisObj, dropMap, consumeHp, jifen);
                    }
                    else {
                        var report = result[0];
                        var dropMap = result[1]; //掉落
                        var consumeHp = result[2]; //伤害
                        var jifen = result[3]; //积分
                        callback.call(thisObj, report, dropMap, consumeHp, jifen);
                    }
                    break;
                case -1:
                    TipsViewSystem.show("上阵卡牌索引数组错误");
                    break;
                case -2:
                    TipsViewSystem.show("重复上阵");
                    break;
                case -3:
                    TipsViewSystem.show("上阵卡牌索引错误");
                    break;
                case -4:
                    TipsViewSystem.show("上阵人数为0");
                    break;
                case -5:
                    TipsViewSystem.show("体力不足");
                    break;
                case -6:
                    TipsViewSystem.show("等级不符合条件");
                    break;
                case -7:
                    TipsViewSystem.show("BOSS已死亡");
                    break;
            }
        }, this);
    }
    net.bossBattle = bossBattle;
    /**
     * 更换头像
     * headID		头像ID
     */
    function changHead(headID, callback, thisObj) {
        MyClient.inst.rpc(["head/changHead", headID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("头像ID错误");
                    break;
                case -2:
                    TipsViewSystem.show("未获得头像");
                    break;
            }
        }, this);
    }
    net.changHead = changHead;
    /**
     * 获取好友BOSS积分排行榜
     */
    function getFriendRank(callback, thisObj) {
        MyClient.inst.rpc(["friend/rank"], function (msg) {
            callback.call(thisObj, msg);
        }, this);
    }
    net.getFriendRank = getFriendRank;
    /**
     * 挑战对手
     * friendUserID		好友userID
     * * upCardIndexArr	上阵卡牌索引数组，长度为6，空位为-1
     */
    function friendPK(friendUserID, upCardIndexArr, callback, thisObj) {
        MyClient.inst.rpc(["friend/pk", friendUserID, upCardIndexArr], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    var report = msg[2];
                    callback.call(thisObj, report);
                    break;
                case -1:
                    TipsViewSystem.show("上阵卡牌索引数组错误");
                    break;
                case -2:
                    TipsViewSystem.show("重复上阵");
                    break;
                case -3:
                    TipsViewSystem.show("上阵卡牌索引错误");
                    break;
                case -4:
                    TipsViewSystem.show("上阵人数为0");
                    break;
                case -5:
                    TipsViewSystem.show("角色不存在");
                    break;
            }
        }, this);
    }
    net.friendPK = friendPK;
    //获取竞技排行榜
    function stageRank(callback, thisObj) {
        MyClient.inst.rpc(["stage/rank"], function (msg) {
            callback.call(thisObj, msg);
        }, this);
    }
    net.stageRank = stageRank;
    //获得好友推荐
    function getAnyFriends(callback, thisObj) {
        MyClient.inst.rpc(["friend/getAnyFriends"], function (msg) {
            MyData.friendArr = msg[2];
            callback.call(thisObj, msg);
        }, this);
    }
    net.getAnyFriends = getAnyFriends;
    /**
     * 膜拜
     * rankID		排行榜ID
     */
    function worship(rankID, callback, thisObj) {
        MyClient.inst.rpc(["worship", rankID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("今天已膜拜");
                    break;
            }
        }, this);
    }
    net.worship = worship;
    /**
     * 购买竞技场门票
     * buyCount		购买数量
     */
    function buyArenaTicket(buyCount, callback, thisObj) {
        MyClient.inst.rpc(["stage/buyTicket", buyCount], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("钻石不足");
                    break;
            }
        }, this);
    }
    net.buyArenaTicket = buyArenaTicket;
    /**
     * 更改昵称
     * nickname		新的昵称
     */
    function changeNickname(nickname, callback, thisObj) {
        MyClient.inst.rpc(["head/changeNickname", nickname], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("昵称不合法");
                    break;
                case -2:
                    TipsViewSystem.show("昵称已存在");
                    break;
                case -3:
                    TipsViewSystem.show("钻石不足");
                    break;
                case -4:
                    TipsViewSystem.show("昵称相同");
                    break;
            }
        }, this);
    }
    net.changeNickname = changeNickname;
    /**
     * 竞技场随机对手
     */
    function randomEnemy(callback, thisObj) {
        MyClient.inst.rpc(["stage/randomEnemy"], function (msg) {
            callback.call(thisObj, msg);
        }, this);
    }
    net.randomEnemy = randomEnemy;
    /**
     * 获取我在竞技排行榜中的信息
     */
    function getMyStageInfo(callback, thisObj) {
        MyClient.inst.rpc(["stage/getMyStageInfo"], function (msg) {
            callback.call(thisObj, msg);
        }, this);
    }
    net.getMyStageInfo = getMyStageInfo;
    /**
     * 竞技场挑战对手
     * enemyUserID		对手角色ID
     * upCardIndexArr	上阵卡牌索引数组，长度为6，空位为-1
     */
    function stageBatter(enemyUserID, upCardIndexArr, callback, thisObj) {
        MyClient.inst.rpc(["stage/battle", enemyUserID, upCardIndexArr], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    var report = msg[2];
                    var dropMap = msg[3];
                    var jifenMap = msg[4];
                    callback.call(thisObj, report, dropMap, jifenMap);
                    break;
                case -1:
                    TipsViewSystem.show("上阵卡牌索引数组错误");
                    break;
                case -2:
                    TipsViewSystem.show("重复上阵");
                    break;
                case -3:
                    TipsViewSystem.show("上阵卡牌索引错误");
                    break;
                case -4:
                    TipsViewSystem.show("上阵人数为0");
                    break;
                case -5:
                    TipsViewSystem.show("角色不存在");
                    break;
                case -6:
                    TipsViewSystem.show("对手ID错误");
                    break;
                case -7:
                    TipsViewSystem.show("竞技场门票不足");
                    break;
            }
        }, this);
    }
    net.stageBatter = stageBatter;
    /**
     * 获取竞技场战报
     */
    function getStageBattleReport(callback, thisObj) {
        MyClient.inst.rpc(["stage/getMyStageReport"], function (msg) {
            callback.call(thisObj, msg);
        }, this);
    }
    net.getStageBattleReport = getStageBattleReport;
    /**
     * 获取竞技场每周战斗次数奖励
     * battleCount		战斗次数
     */
    function getBattleCountReward(battleCount, callback, thisObj) {
        MyClient.inst.rpc(["stage/getBattleCountReward", battleCount], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("已领取奖励");
                    break;
                case -2:
                    TipsViewSystem.show("战斗次数不足");
                    break;
                case -3:
                    TipsViewSystem.show("战斗次数错误");
                    break;
            }
        }, this);
    }
    net.getBattleCountReward = getBattleCountReward;
    /**
     * 英雄商店刷新
     */
    function shopHeroFlush(callback, thisObj) {
        MyClient.inst.rpc(["heroShop/flush"], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    var shopHeroConfigTab = ak.JsonTableMgr.get("shopHeroConfig");
                    var row = shopHeroConfigTab.getRow(0);
                    var freshCost = row.getValFromColName("freshCost"); //刷新消耗物品
                    var name_8 = Common.getResourceItemName(freshCost, 1);
                    TipsViewSystem.show(name_8 + "不足");
                    break;
            }
        }, this);
    }
    net.shopHeroFlush = shopHeroFlush;
    /**
     * 英雄商店购买
     * buyID		商品ID，对应shopHero.xlsx中id
     */
    function shopHeroBuy(buyID, callback, thisObj) {
        MyClient.inst.rpc(["heroShop/buy", buyID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("已达到限购数量");
                    break;
                case -2:
                    var shopHeroTab = ak.JsonTableMgr.get("shopHero");
                    var row = shopHeroTab.getRowFromColName("id", "" + buyID);
                    var costItem = row.getValFromColName("costItem"); //购买需要物品
                    var name_9 = Common.getResourceItemName(costItem, 1);
                    TipsViewSystem.show(name_9 + "不足");
                    break;
            }
        }, this);
    }
    net.shopHeroBuy = shopHeroBuy;
    /**
     * 许愿池商店购买
     * buyIndex		buyIndex对应WishPoolShop.buyIDArr的索引
     */
    function wishPoolShopBuy(buyIndex, callback, thisObj) {
        MyClient.inst.rpc(["wishPool/shopBuy", buyIndex], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("此物品ID错误");
                    break;
                case -2:
                    TipsViewSystem.show("已达到最大购买次数");
                    break;
                case -3:
                    var buyID = MyData.user.json.wishPoolShop.buyIDArr[buyIndex];
                    var shopWishPoolTab = ak.JsonTableMgr.get("shopWishPool");
                    var row = shopWishPoolTab.getRowFromColName("id", "" + buyID);
                    var costItem = row.getValFromColName("costItem"); //购买需要物品
                    var name_10 = Common.getResourceItemName(costItem, 1);
                    TipsViewSystem.show(name_10 + "不足");
                    break;
            }
        }, this);
    }
    net.wishPoolShopBuy = wishPoolShopBuy;
    /**
     * 许愿池商店刷新
     */
    function wishPoolShopFlush(callback, thisObj) {
        MyClient.inst.rpc(["wishPool/shopFlush"], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    var shopWishPoolConfigTab = ak.JsonTableMgr.get("shopWishPoolConfig");
                    var row = shopWishPoolConfigTab.getRow(0);
                    var freshCost = row.getValFromColName("freshCost"); //刷新消耗物品
                    var name_11 = Common.getResourceItemName(freshCost, 1);
                    TipsViewSystem.show(name_11 + "不足");
                    break;
            }
        }, this);
    }
    net.wishPoolShopFlush = wishPoolShopFlush;
    /**
     * 领取累充奖励
     * firstRechargeID		充值档ID，对应fristRecharge.xlsx中id
     * day					领取对应天数奖励，从1开始
     */
    function firstRechargeReward(firstRechargeID, day, callback, thisObj) {
        MyClient.inst.rpc(["recharge/firstRechargeReward", firstRechargeID, day], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("请充值");
                    break;
                case -2:
                    TipsViewSystem.show("累计天数未达到");
                    break;
                case -3:
                    TipsViewSystem.show("当前奖励已领取");
                    break;
                case -4:
                    TipsViewSystem.show("没有此天奖励");
                    break;
            }
        }, this);
    }
    net.firstRechargeReward = firstRechargeReward;
    /**
     * 在线奖励
     * prizeID		在线新手奖励id  对应onlinePrize.xlsx中id
     */
    function onlineReward(prizeID, callback, thisObj) {
        MyClient.inst.rpc(["online/onlineReward", prizeID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("已领取当前奖励");
                    break;
                case -2:
                    TipsViewSystem.show("在线时间不足");
                    break;
            }
        }, this);
    }
    net.onlineReward = onlineReward;
    /**
     * 签到
     */
    function signIn(callback, thisObj) {
        MyClient.inst.rpc(["online/signIn"], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("已签到");
                    break;
            }
        }, this);
    }
    net.signIn = signIn;
    /**
     * 创建公会
     * unionName		公会名
     * flag				会旗
     */
    function createUnion(unionName, flag, callback, thisObj) {
        MyClient.inst.rpc(["union/createUnion", unionName, flag], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("名称合法");
                    break;
                case -2:
                    TipsViewSystem.show("请求太频繁");
                    break;
                case -3:
                    TipsViewSystem.show("公会已存在");
                    break;
                case -4:
                    TipsViewSystem.show("旗子不存在");
                    break;
                case -5:
                    TipsViewSystem.show("钻石不足");
                    break;
                case -6:
                    TipsViewSystem.show("昵称重名");
                    break;
                case -7:
                    TipsViewSystem.show("公会已存在");
                    break;
            }
        }, this);
    }
    net.createUnion = createUnion;
    /**
     * 获取我的公会信息
     */
    function myUnionInfo(callback, thisObj) {
        MyClient.inst.rpc(["union/myUnionInfo"], function (msg) {
            var result = msg[1];
            switch (result) {
                default:
                    MyData.myUnionInfo = msg[1];
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("没有加入公会");
                    callback.call(thisObj, msg);
                    break;
            }
        }, this);
    }
    net.myUnionInfo = myUnionInfo;
    /**
     * 获取公会列表
     */
    function unionList(callback, thisObj) {
        MyClient.inst.rpc(["union/unionList"], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
            }
        }, this);
    }
    net.unionList = unionList;
    /**
     * 申请加入公会
     * unionID			公会ID
     */
    function reqUnion(unionID, callback, thisObj) {
        MyClient.inst.rpc(["union/reqUnion", unionID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("公会不存在");
                    break;
                case -2:
                    TipsViewSystem.show("已加入公会");
                    break;
                case -3:
                    TipsViewSystem.show("已是公会成员");
                    break;
                case -4:
                    TipsViewSystem.show("已申请加入公会");
                    break;
                case -5:
                    TipsViewSystem.show("退会后等待时间不足");
                    break;
            }
        }, this);
    }
    net.reqUnion = reqUnion;
    /**
     * 同意或拒绝申请加入公会
     * reqUserID			申请人角色ID
     * type					同意或拒绝  0=不同意，1=同意
     */
    function agreeReqUnion(reqUserID, type, callback, thisObj) {
        MyClient.inst.rpc(["union/agreeReqUnion", reqUserID, type], function (msg) {
            var result = msg[1][0];
            switch (result) {
                case 1:
                    var result1 = msg[1][1];
                    if (result1 == -5) {
                        TipsViewSystem.show("已加入其它公会");
                    }
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("不是公会成员");
                    break;
                case -2:
                    TipsViewSystem.show("没有申请记录");
                    break;
                case -3:
                    TipsViewSystem.show("不是官员或会长，无权操作");
                    break;
                case -4:
                    TipsViewSystem.show("已达到当前公会等级最大人数");
                    break;
            }
        }, this);
    }
    net.agreeReqUnion = agreeReqUnion;
    /**
     * 公会踢人
     * reqUserID			被T角色ID
     */
    function kick(reqUserID, callback, thisObj) {
        MyClient.inst.rpc(["union/kick", reqUserID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("不能操作自己");
                    break;
                case -2:
                    TipsViewSystem.show("不是公会成员");
                    break;
                case -3:
                    TipsViewSystem.show("不是官员或会长，无权操作");
                    break;
                case -4:
                    TipsViewSystem.show("被T角色不是公会成员");
                    break;
                case -5:
                    TipsViewSystem.show("被T角色是官员，无权操作");
                    break;
            }
        }, this);
    }
    net.kick = kick;
    /**
     * 退出公会
     */
    function quitUnion(callback, thisObj) {
        MyClient.inst.rpc(["union/quitUnion"], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("不是公会成员");
                    break;
                case -2:
                    TipsViewSystem.show("会长不能退出公会");
                    break;
                case -3:
                    TipsViewSystem.show("没有加入公会");
                    break;
            }
        }, this);
    }
    net.quitUnion = quitUnion;
    /**
     * 升为官员或降为普通成员
     * reqUserID		升为官员ID
     * type				0=普通成员，1=官员
     */
    function upJob(reqUserID, type, callback, thisObj) {
        MyClient.inst.rpc(["union/upJob", reqUserID, type], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("不是公会成员");
                    break;
                case -2:
                    TipsViewSystem.show("会长不能退出公会");
                    break;
                case -3:
                    TipsViewSystem.show("没有加入公会");
                    break;
                case -4:
                    TipsViewSystem.show("已达到最大官员数量");
                    break;
                case -5:
                    TipsViewSystem.show("不能设置自己为官员");
                    break;
            }
        }, this);
    }
    net.upJob = upJob;
    /**
     * 公会会长传位
     * reqUserID		传位userID
     */
    function changeUnionLeader(reqUserID, callback, thisObj) {
        MyClient.inst.rpc(["union/changeUnionLeader", reqUserID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("不能传位自己");
                    break;
                case -2:
                    TipsViewSystem.show("不是公会成员");
                    break;
                case -3:
                    TipsViewSystem.show("不是会长，不能操作");
                    break;
                case -4:
                    TipsViewSystem.show("不是公会成员");
                    break;
            }
        }, this);
    }
    net.changeUnionLeader = changeUnionLeader;
    /**
     * 公会改名
     * changeName		修改后的公会名
     */
    function changeUnionName(changeName, callback, thisObj) {
        MyClient.inst.rpc(["union/changeUnionName", changeName], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("名称不合法");
                    break;
                case -2:
                    TipsViewSystem.show("钻石不足");
                    break;
                case -3:
                    TipsViewSystem.show("名称重名");
                    break;
                case -4:
                    TipsViewSystem.show("不是公会成员");
                    break;
                case -5:
                    TipsViewSystem.show("不是会长，不能操作");
                    break;
            }
        }, this);
    }
    net.changeUnionName = changeUnionName;
    /**
     * 公会捐献
     * donateID		捐献ID，对应guildDonate.xlsx中id
     */
    function unionDonate(donateID, callback, thisObj) {
        MyClient.inst.rpc(["union/unionDonate", donateID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("没有此捐献档次");
                    break;
                case -2:
                    TipsViewSystem.show("钻石不足");
                    break;
                case -3:
                    TipsViewSystem.show("金币不足");
                    break;
                case -4:
                    TipsViewSystem.show("每天捐献次数不能超过当前公会最大人数");
                    break;
                case -5:
                    TipsViewSystem.show("今天已捐献");
                    break;
            }
        }, this);
    }
    net.unionDonate = unionDonate;
    //公会排行榜
    function unionRank(callback, thisObj) {
        MyClient.inst.rpc(["union/rank"], function (msg) {
            ak.log("获取公会排行榜成功");
            callback.call(thisObj, msg);
        }, this);
    }
    net.unionRank = unionRank;
    /**
     * 升级公会技能
     * skillID		公会技能ID，对应guildSkill.xlsx中id
     */
    function upUnionSkill(skillID, callback, thisObj) {
        MyClient.inst.rpc(["union/upUnionSkill", skillID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("没有此技能");
                    break;
                case -2:
                    TipsViewSystem.show("前置技能等级不足");
                    break;
                case -3:
                    TipsViewSystem.show("已达到最大等级");
                    break;
                case -4:
                    TipsViewSystem.show("金币不足");
                    break;
                case -5:
                    TipsViewSystem.show("道具不足");
                    break;
            }
        }, this);
    }
    net.upUnionSkill = upUnionSkill;
    /**
     * 打公会BOSS
     * bossID				对应guildBoss.xlsx中id
     * upCardIndexArr		上阵卡牌索引数组，长度为6，空位为-1
     */
    function hitUnionBoss(bossID, upCardIndexArr, callback, thisObj) {
        MyClient.inst.rpc(["union/hitUnionBoss", bossID, upCardIndexArr], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    var report = msg[2][1];
                    var dropMap = msg[2][3];
                    callback.call(thisObj, report, dropMap);
                    break;
                case -1:
                    TipsViewSystem.show("没有加入公会");
                    break;
                case -2:
                    TipsViewSystem.show("已达到当天打BOSS最大次数");
                    break;
                case -3:
                    TipsViewSystem.show("钻石不足");
                    break;
                case -4:
                    TipsViewSystem.show("当前BOSS已死亡");
                    break;
                case -5:
                    TipsViewSystem.show("已击杀全部BOSS");
                    break;
                case -6:
                    TipsViewSystem.show("正在打公会BOSS");
                    break;
                case -7:
                    TipsViewSystem.show("上阵卡牌索引数组错误");
                    break;
                case -8:
                    TipsViewSystem.show("重复上阵");
                    break;
                case -9:
                    TipsViewSystem.show("上阵索引数组转上阵卡牌数组");
                    break;
                case -10:
                    TipsViewSystem.show("上阵人数为0");
                    break;
            }
        }, this);
    }
    net.hitUnionBoss = hitUnionBoss;
    /**
     * 设置公会加入等级限制
     * level					设置限制等级
     */
    function setUnionJoinLevel(level, callback, thisObj) {
        MyClient.inst.rpc(["union/setUnionJoinLevel", level], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("不是公会成员");
                    break;
                case -2:
                    TipsViewSystem.show("不是会长，不能操作");
                    break;
            }
        }, this);
    }
    net.setUnionJoinLevel = setUnionJoinLevel;
    /**
     * 设置公会公告
     * str					公告字串
     */
    function setUnionPublicMsg(str, callback, thisObj) {
        MyClient.inst.rpc(["union/setUnionPublicMsg", str], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("不是公会成员");
                    break;
                case -2:
                    TipsViewSystem.show("不是会长，不能操作");
                    break;
            }
        }, this);
    }
    net.setUnionPublicMsg = setUnionPublicMsg;
    /**
     * 公会商店刷新
     */
    function unionShopFlush(callback, thisObj) {
        MyClient.inst.rpc(["unionShop/flush"], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    var shopHeroConfigTab = ak.JsonTableMgr.get("shopGuildConfig");
                    var row = shopHeroConfigTab.getRow(0);
                    var freshCost = row.getValFromColName("freshCost"); //刷新消耗物品
                    var name_12 = Common.getResourceItemName(freshCost, 1);
                    TipsViewSystem.show(name_12 + "不足");
                    break;
            }
        }, this);
    }
    net.unionShopFlush = unionShopFlush;
    /**
     * 公会商店购买
     * buyID		商品ID，对应shopGuild.xlsx中id
     */
    function unionShopBuy(buyID, callback, thisObj) {
        MyClient.inst.rpc(["unionShop/buy", buyID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("已达到限购数量");
                    break;
                case -2:
                    var shopHeroTab = ak.JsonTableMgr.get("shopGuild");
                    var row = shopHeroTab.getRowFromColName("id", "" + buyID);
                    var costItem = row.getValFromColName("costItem"); //购买需要物品
                    var name_13 = Common.getResourceItemName(costItem, 1);
                    TipsViewSystem.show(name_13 + "不足");
                    break;
            }
        }, this);
    }
    net.unionShopBuy = unionShopBuy;
    /**
     * 公会技能重置
     * job				职业ID
     */
    function unionSkillReset(job, callback, thisObj) {
        MyClient.inst.rpc(["union/unionSkillReset", job], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("钻石不足");
                    break;
            }
        }, this);
    }
    net.unionSkillReset = unionSkillReset;
    /**
     * 远征匹配对手
     */
    function findEnemy(callback, thisObj) {
        MyClient.inst.rpc(["remoteBattle/findEnemy"], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -2:
                    TipsViewSystem.show("对手已存在");
                    break;
                case -3:
                    TipsViewSystem.show("已通过所有关卡");
                    break;
            }
        }, this);
    }
    net.findEnemy = findEnemy;
    /**
     * 远征战斗
     */
    function findEnemyBattle(upCardIndexArr, callback, thisObj) {
        MyClient.inst.rpc(["remoteBattle/battle", upCardIndexArr], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    var report = msg[2];
                    var dropMapT = msg[3];
                    var dropMap = msg[4];
                    callback.call(thisObj, report, dropMapT, dropMap);
                    break;
                case -1:
                    TipsViewSystem.show("上阵卡牌索引数组错误");
                    break;
                case -2:
                    TipsViewSystem.show("重复上阵");
                    break;
                case -3:
                    TipsViewSystem.show("上阵索引数组转上阵卡牌数组");
                    break;
                case -4:
                    TipsViewSystem.show("上阵人数为0");
                    break;
                case -5:
                    TipsViewSystem.show("上阵英雄等级不足");
                    break;
                case -6:
                    TipsViewSystem.show("已通过所有关卡");
                    break;
                case -7:
                    TipsViewSystem.show("请搜索新对手");
                    break;
                case -8:
                    TipsViewSystem.show("上阵英雄血量为0");
                    break;
            }
        }, this);
    }
    net.findEnemyBattle = findEnemyBattle;
    /**
     * 远征获取通关进度奖励
     * battleIndex				//关卡数，对应expeditionProgressPrize.xlsx中passNum
     */
    function getPassReward(battleIndex, callback, thisObj) {
        MyClient.inst.rpc(["remoteBattle/getPassReward", battleIndex], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("未通关");
                    break;
                case -2:
                    TipsViewSystem.show("没有此奖励");
                    break;
                case -3:
                    TipsViewSystem.show("已领取此奖励");
                    break;
            }
        }, this);
    }
    net.getPassReward = getPassReward;
    /**
     * 使用物品
     * itemIndex				物品索引
     * itemCount				物品数量
     */
    function itemUse(itemIndex, itemCount, callback, thisObj) {
        MyClient.inst.rpc(["bag/itemUse", itemIndex, itemCount], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("没有此道具");
                    break;
                case -2:
                    TipsViewSystem.show("道具不足");
                    break;
                case -3:
                    TipsViewSystem.show("道具类型错误");
                    break;
                case -4:
                    TipsViewSystem.show("没有此道具");
                    break;
            }
        }, this);
    }
    net.itemUse = itemUse;
    /**
     * 远征商店购买
     * buyID				商品ID，对应shopExpedition.xlsx中id
     */
    function remoteBattleBuy(buyID, callback, thisObj) {
        MyClient.inst.rpc(["remoteBattle/buy", buyID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("没有此商品");
                    break;
                case -2:
                    TipsViewSystem.show("远征军声望不足");
                    break;
            }
        }, this);
    }
    net.remoteBattleBuy = remoteBattleBuy;
    /**
     * 竞技场商店购买
     * buyID				商品ID，对应shopArena.xlsx中id
     */
    function unionBuy(buyID, callback, thisObj) {
        MyClient.inst.rpc(["union/buy", buyID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("没有此商品");
                    break;
                case -2:
                    TipsViewSystem.show("荣誉点不足");
                    break;
            }
        }, this);
    }
    net.unionBuy = unionBuy;
    /**
     * 每日商店购买
     * buyID				商品ID，对应rechargeShopDaily中id
     */
    function dailyShopBuy(buyID, callback, thisObj) {
        MyClient.inst.rpc(["dailyShop/buy", buyID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("vip等级不足");
                    break;
                case -2:
                    TipsViewSystem.show("已达到最大限购次数");
                    break;
                case -3:
                    TipsViewSystem.show("钻石不足");
                    break;
            }
        }, this);
    }
    net.dailyShopBuy = dailyShopBuy;
    /**
     * 今日累充领取奖励
     */
    function dailyRechargeReward(callback, thisObj) {
        MyClient.inst.rpc(["recharge/dailyRechargeReward"], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("已领今日取累充奖励");
                    break;
                case -2:
                    TipsViewSystem.show("累充金额不足");
                    break;
            }
        }, this);
    }
    net.dailyRechargeReward = dailyRechargeReward;
    /**
     * 特权礼包购买
     * rightID			特权礼包ID，对应rechargeRight.xlsx中id
     */
    function rightPackageBuy(rightID, callback, thisObj) {
        MyClient.inst.rpc(["rightPackage/buy", rightID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("没有此礼包");
                    break;
                case -2:
                    TipsViewSystem.show("请rmb购买");
                    break;
                case -3:
                    TipsViewSystem.show("此特权礼包已购买");
                    break;
                case -4:
                    TipsViewSystem.show("钻石不足");
                    break;
            }
        }, this);
    }
    net.rightPackageBuy = rightPackageBuy;
    /**
     * 福利礼包购买
     * giftID			福利礼包ID，对应rechargeGift.xlsx中id
     */
    function welfarePackage(giftID, callback, thisObj) {
        MyClient.inst.rpc(["welfarePackage/buy", giftID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("没有此礼包");
                    break;
                case -2:
                    TipsViewSystem.show("请rmb购买");
                    break;
                case -3:
                    TipsViewSystem.show("此特权礼包已购买");
                    break;
                case -4:
                    TipsViewSystem.show("vip等级不足");
                    break;
            }
        }, this);
    }
    net.welfarePackage = welfarePackage;
    /**
     * 创角7天活动获取进度奖励
     * prizeID			任务ID，对应activitySevenDayPrize.xlsx中id
     */
    function createUser7Day(prizeID, callback, thisObj) {
        MyClient.inst.rpc(["createUser7Day/progressReward", prizeID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("没有此进度奖励");
                    break;
                case -2:
                    TipsViewSystem.show("任务未完成");
                    break;
                case -3:
                    TipsViewSystem.show("已领取进度奖励");
                    break;
            }
        }, this);
    }
    net.createUser7Day = createUser7Day;
    /**
     * 创角7天活动获取每天奖励
     * dayID					任务ID，对应activitySevenDay.xlsx中id
     */
    function createUser7DayReward(dayID, callback, thisObj) {
        MyClient.inst.rpc(["createUser7Day/dayReward", dayID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("没有此进度奖励");
                    break;
                case -2:
                    TipsViewSystem.show("已领取奖励");
                    break;
                case -3:
                    TipsViewSystem.show("vip等级不足");
                    break;
                case -4:
                    TipsViewSystem.show("活动已到期");
                    break;
                case -5:
                    TipsViewSystem.show("条件未满足");
                    break;
            }
        }, this);
    }
    net.createUser7DayReward = createUser7DayReward;
    /**
     * VIP礼包购买
     * vipID					VIP礼包ID，对应vip.xlsx中lv
     */
    function vipPackageBuy(vipID, callback, thisObj) {
        MyClient.inst.rpc(["vipPackage/buy", vipID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("没有此礼包");
                    break;
                case -2:
                    TipsViewSystem.show("vip等级不足");
                    break;
                case -3:
                    TipsViewSystem.show("vip礼包已购买");
                    break;
                case -4:
                    TipsViewSystem.show("钻石不足");
                    break;
            }
        }, this);
    }
    net.vipPackageBuy = vipPackageBuy;
    /**
     * 限时活动_首周活动-开服冲级
     * id					//兑换id，对应activity1.xlsx中id
     */
    function activityType1(id, callback, thisObj) {
        MyClient.inst.rpc(["limitActivity/exchange_type1", id], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("限时活动未开启");
                    break;
                case -2:
                    TipsViewSystem.show("已兑换奖励");
                    break;
                case -3:
                    TipsViewSystem.show("等级未达到");
                    break;
            }
        }, this);
    }
    net.activityType1 = activityType1;
    /**
     * 限时活动_首周活动-限时兑换
     * id					//兑换id，对应activity3.xlsx中id
     */
    function activityType3(id, callback, thisObj) {
        MyClient.inst.rpc(["limitActivity/exchange_type3", id], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("限时活动未开启");
                    break;
                case -2:
                    TipsViewSystem.show("已达到限购数量");
                    break;
                case -3:
                    var activity3Tab = ak.JsonTableMgr.get("activity3");
                    var row = activity3Tab.getRowFromColName("id", "" + id);
                    var itemCost = row.getValFromColName("itemCost"); //消耗物品
                    var name_14 = Common.getResourceItemName(itemCost, 1);
                    TipsViewSystem.show(name_14 + "不足");
                    break;
            }
        }, this);
    }
    net.activityType3 = activityType3;
    /**
     * 限时活动_首周活动-积天返利
     * id					//兑换id，对应activity4.xlsx中id
     */
    function activityType4(id, callback, thisObj) {
        MyClient.inst.rpc(["limitActivity/exchange_type4", id], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("限时活动未开启");
                    break;
                case -2:
                    TipsViewSystem.show("积天返利未达成");
                    break;
                case -3:
                    TipsViewSystem.show("已领取奖励");
                    break;
            }
        }, this);
    }
    net.activityType4 = activityType4;
    /**
     * 限时活动_首周活动-累计充值
     * id					//兑换id，对应activity6.xlsx中id
     */
    function activityType6(id, callback, thisObj) {
        MyClient.inst.rpc(["limitActivity/exchange_type6", id], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("限时活动未开启");
                    break;
                case -2:
                    TipsViewSystem.show("累充RMB不足");
                    break;
                case -3:
                    TipsViewSystem.show("已领取奖励");
                    break;
            }
        }, this);
    }
    net.activityType6 = activityType6;
    /**
     * //限时活动兑换_类型1_获取全服限购信息
     */
    function get_type1(callback, thisObj) {
        MyClient.inst.rpc(["limitActivity/get_type1"], function (msg) {
            MyData.limitActivity_type1 = msg[1];
            callback.call(thisObj, msg);
        }, this);
    }
    net.get_type1 = get_type1;
    /**
     * 等级基金领奖
     * id					id对应activityPlayerLevel.xlsx中id
     */
    function levelFundGetReward(id, callback, thisObj) {
        MyClient.inst.rpc(["levelFund/getReward", id], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("等级基金不存在");
                    break;
                case -2:
                    TipsViewSystem.show("等级不足");
                    break;
                case -3:
                    TipsViewSystem.show("已领取奖励");
                    break;
                case -4:
                    TipsViewSystem.show("已领取奖励");
                    break;
            }
        }, this);
    }
    net.levelFundGetReward = levelFundGetReward;
    /**
     * 英雄招募（创角活动）
     * type	= 1-4				对应activityCreateRoleHero.xlsx中4种奖励
     */
    function getHeroActivityReward(type, callback, thisObj) {
        MyClient.inst.rpc(["getHeroActivity/reward", type], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("领取条件未满足");
                    break;
                case -2:
                    TipsViewSystem.show("奖励已领取");
                    break;
                case -3:
                    TipsViewSystem.show("奖励已领取");
                    break;
            }
        }, this);
    }
    net.getHeroActivityReward = getHeroActivityReward;
    /**
     * 完成神器任务
     * godWID				对应godWeaponTask.xlsx中id
     */
    function godWeaponTask(godWID, callback, thisObj) {
        MyClient.inst.rpc(["godWeapon/task", godWID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("成就任务ID错误");
                    break;
                case -2:
                    TipsViewSystem.show("成就条件未满足");
                    break;
                case -3:
                    TipsViewSystem.show("奖励已领取");
                    break;
                case -4:
                    TipsViewSystem.show("参数错误");
                    break;
            }
        }, this);
    }
    net.godWeaponTask = godWeaponTask;
    /**
     * 神器技能升级
     * godWID				对应godWeaponSkillLevel.xlsx中id
     */
    function godWeaponUpSkill(godWID, callback, thisObj) {
        MyClient.inst.rpc(["godWeapon/upSkill", godWID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("未激活全部神器");
                    break;
                case -2:
                    TipsViewSystem.show("神器不存在");
                    break;
                case -3:
                    TipsViewSystem.show("神器等级不足");
                    break;
                case -4:
                    TipsViewSystem.show("技能已达到最大等级");
                    break;
                case -5:
                    TipsViewSystem.show("金币不足");
                    break;
                case -6:
                    TipsViewSystem.show("物品不足");
                    break;
            }
        }, this);
    }
    net.godWeaponUpSkill = godWeaponUpSkill;
    /**
     * 神器等级升级
     * godWID				对应godWeaponLevel.xlsx中id
     */
    function godWeaponUpLevel(godWID, callback, thisObj) {
        MyClient.inst.rpc(["godWeapon/up", godWID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("未激活全部神器");
                    break;
                case -2:
                    TipsViewSystem.show("神器不存在");
                    break;
                case -3:
                    TipsViewSystem.show("神器已达到最大等级");
                    break;
                case -4:
                    TipsViewSystem.show("金币不足");
                    break;
                case -5:
                    TipsViewSystem.show("物品不足");
                    break;
            }
        }, this);
    }
    net.godWeaponUpLevel = godWeaponUpLevel;
    /**
     * 神器重铸
     * godWID
     */
    function godWeaponReset(godWID, callback, thisObj) {
        MyClient.inst.rpc(["godWeapon/reset", godWID], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                    TipsViewSystem.show("未激活全部神器");
                    break;
                case -2:
                    TipsViewSystem.show("神器不存在");
                    break;
                case -3:
                    TipsViewSystem.show("神器不能重铸");
                    break;
            }
        }, this);
    }
    net.godWeaponReset = godWeaponReset;
    /**
     * 使用CDKEY
     * sn					序列号
     */
    function cdkey(sn, callback, thisObj) {
        MyClient.inst.rpc(["cdkey/cdkey", sn], function (msg) {
            var result = msg[1];
            switch (result) {
                case 1:
                    callback.call(thisObj, msg);
                    break;
                case -1:
                case -4:
                    TipsViewSystem.show("序列号错误");
                    break;
                case -2:
                case -3:
                    TipsViewSystem.show("序列号已使用");
                    break;
            }
        }, this);
    }
    net.cdkey = cdkey;
})(net || (net = {}));
var CPSDK = (function () {
    function CPSDK() {
        this.firstInit = true;
        this.isCreateRole = false; //创角标记
        this.toPlayerInfoFinish = false;
    }
    //初始化
    CPSDK.prototype.initAppSdk = function (callback, thisObj) {
        egret.ExternalInterface.addCallback("SdkToJs", function (msg) {
            CPSDK.inst.SDKtips(msg);
        });
    };
    //初始化
    CPSDK.prototype.initQuickSdk = function (callback, thisObj) {
        egret.ExternalInterface.call("QuickSDK_Init", "");
        egret.ExternalInterface.addCallback("SdkToJs_init", function (msg) {
            callback.call(thisObj);
        });
    };
    //打开登录
    CPSDK.prototype.login = function (callback, thisObj) {
        egret.ExternalInterface.call("QuickSdk_Login", "");
        egret.ExternalInterface.addCallback("SdkToJs_login", function (msg) {
            console.log("收到数据sdk数据回调:", msg);
            if (!msg) {
                return;
            }
            var jsonObject = JSON.parse(msg);
            // if(jsonObject.msgType == "login"){
            MyData.Tokenid = jsonObject.Token;
            MyData.uid = jsonObject.UserID;
            callback.call(thisObj);
            // }
        });
    };
    //获取用户信息
    CPSDK.prototype.getUser = function () {
        return this.Quicksdk.userInfo;
    };
    //发起支付
    CPSDK.prototype.pay = function (orderNum, //CP订单号
        rmb, //金额（单位：分）
        title, //商品名称
        desc) {
        //let payCallbackUrl="http://"+MyData.serverDomain+"/sdk/quickGame/callback.php";
        var payCallbackUrl = "http://" + MyData.serverDomain + "/sdk/" + window["sdkName"] + "/callback.php";
        payCallbackUrl = ""; //去除非必填选项Liufc
        console.log(payCallbackUrl);
        //
        var orderInfo = new Object();
        orderInfo["uid"] = MyData.uid; //用户ID
        orderInfo["userRoleId"] = MyData.user.id; //角色id
        orderInfo["userRoleName"] = MyData.user.nickname; //角色名称
        orderInfo["serverId"] = MyData.serverID; //区服编号
        orderInfo["userServer"] = MyData.serverName; //区服名称
        orderInfo["userLevel"] = MyData.user.level; //角色等级
        orderInfo["userVip"] = MyData.user.vip; //角色vip
        orderInfo["diamond"] = MyData.user.diamond; //角色现有砖石
        orderInfo["roleCreateTime"] = MyData.user.genTime;
        orderInfo["goodsId"] = "1"; //物品id（QUICK的技术说这里填1，然后支付界面才显示得出来）
        orderInfo["goodsName"] = "钻石"; //物品id（QUICK的技术说这里填1，然后支付界面才显示得出来）
        orderInfo["cpOrderNo"] = orderNum; //CP方的订单号
        orderInfo["amount"] = rmb / 100; //金额
        orderInfo["count"] = rmb / 10; //数量
        orderInfo["subject"] = title; //购买项目
        orderInfo["desc"] = desc; //描述
        orderInfo["extrasParams"] = ""; //htmlspecialchars(payCallbackUrl);//额外参数,请使用htmlspecialchars格式化
        orderInfo["callbackUrl"] = payCallbackUrl; //使用此项时，请将quick后台的回调地址置空，否则此项不生效
        orderInfo["quantifier"] = "个"; //单位
        // this.Quicksdk.pay(orderInfo);
        egret.ExternalInterface.call("QuickSdk_Pay", JSON.stringify(orderInfo));
    };
    //上传角色信息
    CPSDK.prototype.uploadRoleInfo = function () {
        //数据分布在多个地方获取，只要有一个数据未获取，就不发送
        if (MyData.serverID == null ||
            MyData.serverName == null ||
            MyData.user.nickname == null ||
            MyData.user.diamond == null ||
            MyData.user.level == null) {
            return;
        }
        if (this.toPlayerInfoFinish) {
            return;
        }
        this.toPlayerInfoFinish = true;
        var roleInfo = new Object();
        if (this.isCreateRole == false) {
            roleInfo["isCreateRole"] = false;
        }
        else {
            roleInfo["isCreateRole"] = true;
        }
        roleInfo["uid"] = MyData.uid;
        roleInfo["username"] = MyData.uid;
        roleInfo["serverId"] = MyData.serverID;
        roleInfo["serverName"] = MyData.serverName;
        roleInfo["userRoleName"] = MyData.user.nickname;
        roleInfo["userRoleId"] = MyData.user.id;
        roleInfo["userRoleBalance"] = MyData.user.diamond + MyData.user.diamond2;
        roleInfo["vipLevel"] = MyData.user.vip;
        roleInfo["userRoleLevel"] = MyData.user.level;
        roleInfo["partyId"] = MyData.user.unionID;
        roleInfo["roleCreateTime"] = ak.strtotime(MyData.user.genTime);
        roleInfo["partyName"] = '行会名称';
        roleInfo["gameRoleGender"] = '男';
        roleInfo["gameRolePower"] = 100;
        roleInfo["partyRoleId"] = 1;
        roleInfo["partyRoleName"] = MyData.user.nickname;
        roleInfo["professionId"] = '1';
        roleInfo["profession"] = '武士';
        roleInfo["friendlist"] = '';
        egret.ExternalInterface.call("QuickSdk_SetUserInfo", JSON.stringify(roleInfo));
    };
    CPSDK.prototype.SDKtips = function (msg) {
        if (!msg) {
            return;
        }
        if (msg == "Tips_suc") {
            TipsViewSystem.show("充值成功");
        }
        else if (msg == "Tips_fail") {
            TipsViewSystem.show("充值取消");
        }
        else if (msg == "Tips3_exit") {
            TipsViewSystem.show("充值失败");
        }
        else if (msg == "ExitAccount") {
            console.log("sdk== 退出账号", msg);
            // ak.FairyGUI.open(["ChooseServerView"]);
        }
        else if (msg == "SwitchAccount") {
            console.log("sdk== 切换账号", msg);
            ak.FairyGUI.open(["ChooseServerView"]);
        }
    };
    /*SDK — H5 ********************************************************** */
    //初始化
    CPSDK.prototype.initH5Sdk = function (callback, thisObj) {
        this.Quicksdk = window["QuickSDK"];
        // var productCode = '99420857532374842938030610865994';        //QuickSDK后台自动分配 
        // var productKey = '83781357';        //QuickSDK后台自动分配 
        // this.Quicksdk.init(productCode, productKey, true, function(){
        //     ak.log("init success");
        //     callback.call(thisObj);
        // })
    };
    CPSDK.prototype.Login_h5 = function (callback, thisObj) {
        console.log("sdkclass = ", this.Quicksdk);
        this.Quicksdk.login(function (callbackData) {
            console.log("login result = ", callbackData);
            var message;
            if (callbackData.status) {
                ak.log(callbackData);
                ak.log('GameDemo:QuickSDK登录成功: uid=>' + callbackData.data.uid);
                MyData.Tokenid = callbackData.data.token;
                MyData.uid = callbackData.data.uid;
                callback.call(thisObj);
            }
            else {
                ak.log('GameDemo:QuickSDK登录失败:' + callbackData.message);
                MyData.Tokenid = callbackData.data.token;
                MyData.uid = callbackData.data.uid;
                callback.call(thisObj);
            }
        });
    };
    CPSDK.inst = new CPSDK();
    return CPSDK;
}());
__reflect(CPSDK.prototype, "CPSDK");
var SensitiveWordFilter = (function () {
    function SensitiveWordFilter() {
    }
    SensitiveWordFilter.prototype.init = function () {
        var _this = this;
        this.sensitiveWordMap = new SensitiveWord();
        RES.getResByUrl("sensitive_word.json", function (res) {
            _this.sensitiveWordMap.initSensitiveWordToHashMap(res);
        });
    };
    SensitiveWordFilter.prototype.isContaintSensitiveWord = function (txt, matchType) {
        if (matchType === void 0) { matchType = 1; }
        var flag = false;
        for (var i = 0; i < txt.length; i++) {
            var matchFlag = this.checkSensitiveWord(txt, i, matchType);
            if (matchFlag > 0) {
                flag = true;
            }
        }
        return flag;
    };
    SensitiveWordFilter.prototype.getSensitiveWord = function (txt, matchType) {
        if (matchType === void 0) { matchType = 1; }
        var sensitiveWordList = [];
        for (var i = 0; i < txt.length; i++) {
            var length_1 = this.checkSensitiveWord(txt, i, matchType);
            if (length_1 > 0) {
                sensitiveWordList.push(txt.substring(i, i + length_1));
                i = i + length_1 - 1;
            }
        }
        return sensitiveWordList;
    };
    SensitiveWordFilter.prototype.checkSensitiveWord = function (txt, beginIndex, matchType) {
        if (matchType === void 0) { matchType = 1; }
        var flag = false, matchFlag = 0, word = 0;
        var nowMap = this.sensitiveWordMap.getSensitiveWordMap();
        for (var i = beginIndex; i < txt.length; i++) {
            word = txt[i];
            nowMap = nowMap[word];
            if (nowMap) {
                matchFlag++;
                if (nowMap.isEnd) {
                    console.log("不合法字的=", word);
                    flag = true;
                    if (SensitiveWordFilter.MIN_MATCH_TYPE == matchType) {
                        break;
                    }
                }
            }
            else {
                break;
            }
        }
        if (matchFlag < 1 || !flag) {
            matchFlag = 0;
        }
        return matchFlag;
    };
    /**屏蔽且替换文本 */
    SensitiveWordFilter.prototype.replaceSensitiveWord = function (txt, matchType, replaceChar) {
        if (matchType === void 0) { matchType = 1; }
        if (replaceChar === void 0) { replaceChar = "*"; }
        var resultTxt = txt, set = this.getSensitiveWord(txt, matchType), word = null, replaceString = null;
        while (set.length) {
            word = set.shift();
            replaceString = this.getReplaceChars(replaceChar, word.length);
            resultTxt = resultTxt.replace(new RegExp(word, "g"), replaceString);
        }
        return resultTxt;
    };
    SensitiveWordFilter.prototype.getReplaceChars = function (replaceChar, length) {
        var resultReplace = replaceChar;
        for (var i = 1; i < length; i++) {
            resultReplace += replaceChar;
        }
        return resultReplace;
    };
    SensitiveWordFilter.inst = new SensitiveWordFilter();
    SensitiveWordFilter.MIN_MATCH_TYPE = 1;
    SensitiveWordFilter.MAX_MATCH_TYPE = 2;
    return SensitiveWordFilter;
}());
__reflect(SensitiveWordFilter.prototype, "SensitiveWordFilter");
var SensitiveWord = (function () {
    function SensitiveWord(keyWordSet) {
        this._sensitiveWordMap = null;
        this.initSensitiveWordToHashMap(keyWordSet);
    }
    SensitiveWord.prototype.getSensitiveWordMap = function () {
        return this._sensitiveWordMap;
    };
    SensitiveWord.prototype.initSensitiveWordToHashMap = function (keyWordSet) {
        if (keyWordSet) {
            this._sensitiveWordMap = {};
            var key = void 0, nowMap = void 0, newWorMap = null;
            for (var j = 0; j < keyWordSet.length; j++) {
                key = keyWordSet[j];
                nowMap = this._sensitiveWordMap;
                for (var i = 0; i < key.length; i++) {
                    var keyChar = key[i], wordMap = nowMap[keyChar];
                    if (wordMap) {
                        nowMap = wordMap;
                    }
                    else {
                        newWorMap = {};
                        newWorMap.isEnd = 0;
                        nowMap[keyChar] = newWorMap;
                        nowMap = newWorMap;
                    }
                    if (i == key.length - 1) {
                        nowMap.isEnd = 1;
                    }
                }
            }
        }
    };
    return SensitiveWord;
}());
__reflect(SensitiveWord.prototype, "SensitiveWord");
//主界面系统
var MainUISystem = (function (_super) {
    __extends(MainUISystem, _super);
    function MainUISystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MainUISystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("MainUI");
    };
    MainUISystem.inst = new MainUISystem("MainUI");
    return MainUISystem;
}(ak.FairyGUI));
__reflect(MainUISystem.prototype, "MainUISystem");
/**
 * 主界面
 */
var MainUI = (function (_super) {
    __extends(MainUI, _super);
    function MainUI() {
        var _this = _super.call(this, MainUISystem.inst, MyGame.inst.mainCityLayer) || this;
        _this.itembaselist = []; //itembase奖励数组
        //系统开放检查
        _this.systemOpenBtn = { 1: "worldTreeBtn", 2: "wishBtn", 4: "arenaBtn", 8: "towerBtn", 9: "trialBtn", 12: "barBtn", 7: "expeditionBtn" };
        MusicMgr.playMainCityMusic();
        return _this;
    }
    //销毁回调
    MainUI.prototype.onDestroy = function () {
        //清理
    };
    //初始化回调
    MainUI.prototype.onInit = function () {
        var _this = this;
        //注册掉落事件
        this.on("netmsg://dropDataResult", function (e) {
            ak.log("掉落数据返回");
            var msg = e.params;
            var dropMap = msg[1];
            _this.onDrop(dropMap);
        }, this);
        this.on("netmsg://worldChat", this.onFlushChatRedPoint, this);
        this.on(GameEvent.chatRedPoint, this.onFlushChatRedPoint, this);
        this.on("netmsg://worshipDataResult", this.onFlushWorshipRedPoint, this);
        this.on("netmsg://mail/getMailArrResult", this.onFlushMailRedPoint, this);
        this.on("netmsg://friend/getFriendResult", this.onFlushFriendRedPoint, this);
        this.on("netmsg://achievementTaskDataResult", this.onFlushTaskRedPoint, this);
        this.on("netmsg://dailyTaskDataResult", this.onFlushTaskRedPoint, this);
        //注册升级事件
        this.on("netmsg://userResult", this.updateView, this);
        this.on("netmsg://userResult", this.onFlushWorshipRedPoint, this);
        this.on("netmsg://resourceResult", this.updateView, this);
        this.on("netmsg://rechargeDataResult", this.updateView, this);
        this.on(GameEvent.systemOpen_update, this.updateView, this);
        //更新活动列表
        this.on("netmsg://dropDataResult", this.updateListInfo, this);
        this.on("netmsg://userResult", this.updateListInfo, this);
        this.on("netmsg://limitPackageDataResult", this.updateListInfo, this);
        this.on("netmsg://recharge/dailyRechargeRewardResult", this.updateListInfo, this);
        this.on("netmsg://recharge/firstRechargeRewardResult", this.updateListInfo, this);
        this.on("netmsg://createUser7Day/dayRewardResult", this.updateListRedDot, this);
        this.on("netmsg://createUser7Day/progressRewardResult", this.updateListRedDot, this);
        this.on("netmsg://welfarePackage/buyResult", this.updateListRedDot, this);
        this.on("netmsg://dailyShop/buyResult", this.updateListRedDot, this);
        this.on("netmsg://rightPackage/buyResult", this.updateListRedDot, this);
        this.on("netmsg://online/signInResult", this.updateListRedDot, this);
        this.on("netmsg://limitActivity/exchange_type1Result", this.updateListRedDot, this);
        this.on("netmsg://limitActivity/exchange_type4Result", this.updateListRedDot, this);
        this.on("netmsg://limitActivity/exchange_type6Result", this.updateListRedDot, this);
        this.on("netmsg://rechargeDataResult", this.updateListRedDot, this);
        this.on("netmsg://online/onlineRewardResult", this.SetNewHandReaward, this);
        this.on("netmsg://userResult", this.godWeaponRedPoint, this);
        this.on("netmsg://godWeapon/taskResult", this.godWeaponRedPoint, this);
        this.on("netmsg://godWeaponSysDataResult", this.godWeaponRedPoint, this);
        this.on(GameEvent.changeMainCity2, this.godWeaponRedPoint, this);
        this.mainUI = this.create("MainUI", "MainUI2");
        this.uiMap = this.mainUI.getChild("map").asCom;
        DownViewSystem.show();
        //新手奖励
        this.item = this.mainUI.getChild("newHandBtn").asButton; //获取新手奖励按钮组件
        this.icon = this.item.getChild("n1").asCom; //获取框框
        this.itemBase = new ItemBase(this.icon, this, 1); //初始化itembase
        //设置初始滚动位置
        this.uiMap.scrollPane.posX = this.uiMap.getChild("back").width / 3;
        var land1 = this.uiMap.getChild("land1").asGroup;
        var land2 = this.uiMap.getChild("land2").asGroup;
        var landx1 = land1.x;
        var landx2 = land2.x;
        var minPosX = 100;
        var maxPosX = this.uiMap.getChild("back").width - 200 - this.stage.stageWidth;
        var isTouchEnd = true;
        //滚动事件
        this.onEgretEvent(this.uiMap.scrollPane, fairygui.ScrollPane.SCROLL, function () {
            land1.x = landx1 - _this.uiMap.scrollPane.percX * 200;
            //land2.x = landx2 - this.uiMap.scrollPane.percX * 100;
        }, this);
        this.onEgretEvent(this.uiMap.scrollPane, fairygui.ScrollPane.SCROLL_END, function () {
            if (isTouchEnd) {
                if (_this.uiMap.scrollPane.posX > maxPosX + 100) {
                    egret.Tween.get(_this.uiMap.scrollPane).to({ posX: maxPosX }, 1000, egret.Ease.quartOut);
                }
                else if (_this.uiMap.scrollPane.posX < minPosX) {
                    egret.Tween.get(_this.uiMap.scrollPane).to({ posX: minPosX }, 1000, egret.Ease.quartOut);
                }
            }
        }, this);
        this.onEgretEvent(this, egret.TouchEvent.TOUCH_BEGIN, function () {
            isTouchEnd = false;
            egret.Tween.removeTweens(_this.uiMap.scrollPane);
        }, this, true);
        this.onEgretEvent(this, egret.TouchEvent.TOUCH_END, function () {
            isTouchEnd = true;
            if (_this.uiMap.scrollPane.posX > maxPosX) {
                egret.Tween.get(_this.uiMap.scrollPane).to({ posX: maxPosX }, 1000, egret.Ease.quartOut);
            }
            else if (_this.uiMap.scrollPane.posX < minPosX) {
                egret.Tween.get(_this.uiMap.scrollPane).to({ posX: minPosX }, 1000, egret.Ease.quartOut);
            }
        }, this);
        //功能按钮
        this.addClickListener(this.uiMap.getChild("summonBtn").asCom, function () {
            ak.FairyGUI.open(["SummonView"]);
        }, this);
        this.addClickListener(this.uiMap.getChild("worldTreeBtn").asCom, function () {
            if (GameSystem.isSysOpen(1, true)) {
                ak.FairyGUI.open(["CardSubstitutionView"]);
            }
        }, this);
        this.addClickListener(this.uiMap.getChild("openCardDegreeView").asCom, function () {
            ak.FairyGUI.open(["CardDegreeView"]);
        }, this);
        this.addClickListener(this.uiMap.getChild("openCardDisintegrateView").asCom, function () {
            ak.FairyGUI.open(["CardDisintegrateView"]);
        }, this);
        this.addClickListener(this.uiMap.getChild("SmithyView").asCom, function () {
            ak.FairyGUI.open(["SmithyView"]);
        }, this);
        this.addClickListener(this.uiMap.getChild("towerBtn").asCom, function () {
            if (GameSystem.isSysOpen(8, true)) {
                ak.FairyGUI.open(["TowerView"]);
            }
        }, this);
        this.addClickListener(this.mainUI.getChild("taskBtn").asCom, function () {
            ak.FairyGUI.open(["DailytaskView"]);
        }, this);
        this.addClickListener(this.mainUI.getChild("godWeaponBtn").asCom, function () {
            var godWeaponSys = MyData.user.json.godWeaponSys;
            var godWeaponTab = GodWeaponData.inst().getGodWeaponCfgList();
            if (godWeaponSys.activeCount == godWeaponTab.size()) {
                ak.FairyGUI.open(["GodWeaponSkillInfoView"]);
            }
            else if (godWeaponSys.activeCount > 0 && godWeaponSys.activeCount < 5) {
                ak.FairyGUI.open(["GodWeaponTaskView", godWeaponSys.activeCount + 1]);
            }
            else {
                ak.FairyGUI.open(["GodWeaponView"]);
            }
        }, this);
        this.addClickListener(this.uiMap.getChild("barBtn").asButton, function () {
            if (GameSystem.isSysOpen(12, true)) {
                ak.FairyGUI.open(["TavernView"]);
            }
        }, this);
        this.addClickListener(this.uiMap.getChild("trialBtn").asButton, function () {
            if (GameSystem.isSysOpen(9, true)) {
                ak.FairyGUI.open(["TrialView"]);
            }
        }, this);
        this.addClickListener(this.uiMap.getChild("wishBtn").asButton, function () {
            if (GameSystem.isSysOpen(2, true)) {
                ak.FairyGUI.open(["WishingwellView"]);
            }
        }, this);
        this.addClickListener(this.uiMap.getChild("marketBtn").asButton, function () {
            ak.FairyGUI.open(["MarketplaceView"]);
        }, this);
        this.addClickListener(this.uiMap.getChild("arenaBtn").asButton, function () {
            if (GameSystem.isSysOpen(4, true)) {
                ak.FairyGUI.open(["ArenaView"]);
            }
            //ak.FairyGUI.open(["SecretAreaView"]);
        }, this);
        this.addClickListener(this.uiMap.getChild("expeditionBtn").asButton, function () {
            if (GameSystem.isSysOpen(7, true)) {
                ak.FairyGUI.open(["ExpeditionView"]);
            }
        }, this);
        this.addClickListener(this.mainUI.getChild("mailBtn").asCom, function () {
            ak.FairyGUI.open(["MailView"]); //邮件
        }, this);
        this.addClickListener(this.mainUI.getChild("friendBtn").asButton, function () {
            ak.FairyGUI.open(["FriendView"]); //好友
        }, this);
        this.addClickListener(this.mainUI.getChild("chatBtn").asCom, function () {
            ak.FairyGUI.open(["ChatView"]); //聊天
        }, this);
        this.addClickListener(this.mainUI.getChild("rankBtn").asCom, function () {
            ak.FairyGUI.open(["RankAllView"]); //排行榜
        }, this);
        this.addClickListener(this.mainUI.getChild("newHandBtn").asButton, function () {
            ak.FairyGUI.open(["NewHandRewardView"]); //新手奖励
        }, this);
        // this.addClickListener(this.mainUI.getChild("n28").asButton, () => {
        // ak.FairyGUI.open(["ChooseServerView"]);//暂时这么写着
        // }, this);
        this.onFairyguiEvent(this.mainUI.getChild("activity2").asList, fairygui.ItemEvent.CLICK, this.itemonclick, this);
        this.onFairyguiEvent(this.mainUI.getChild("activity").asList, fairygui.ItemEvent.CLICK, this.itemonclick1, this);
        //功能图标缓动
        egret.Tween.get(this.uiMap.getChild("summonBtn"), { loop: true }).to({ y: this.uiMap.getChild("summonBtn").y + 10 }, 2000)
            .to({ y: this.uiMap.getChild("summonBtn").y }, 2000);
        egret.Tween.get(this.uiMap.getChild("towerBtn"), { loop: true }).to({ y: this.uiMap.getChild("towerBtn").y + 5 }, 1500)
            .to({ y: this.uiMap.getChild("towerBtn").y }, 1500);
        egret.Tween.get(this.uiMap.getChild("barBtn"), { loop: true }).to({ y: this.uiMap.getChild("barBtn").y + 5 }, 1500)
            .to({ y: this.uiMap.getChild("barBtn").y }, 1000);
        //登录
        net.cnnlogin();
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.onFlushFriendTreasureRedPoint, this); //一直鉴听好友探宝
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.timedown, this);
        this.SetNewHandReaward();
        // if(this.item.visible != false)
        // this.onEgretEvent(this,egret.Event.ENTER_FRAME,this.SetNewHandReaward,this);
        //this.updateList();
        var activity = this.mainUI.getChild("activity").asList;
        var activity2 = this.mainUI.getChild("activity2").asList;
        activity.removeChildrenToPool();
        activity2.removeChildrenToPool();
        //this.mapMC();	
    };
    /**主场景动画 */
    MainUI.prototype.mapMC = function () {
        //旗子
        var graph1 = this.uiMap.getChild("trialBtn").asButton.getChild("graph1").asGraph;
        graph1.setNativeObject(new ak.MovieClip("flag_json", "flag_png", "flag"));
        var graph2 = this.uiMap.getChild("trialBtn").asButton.getChild("graph2").asGraph;
        graph2.setNativeObject(new ak.MovieClip("flag_json", "flag_png", "flag"));
        var graph3 = this.uiMap.getChild("trialBtn").asButton.getChild("graph3").asGraph;
        graph3.setNativeObject(new ak.MovieClip("flag_json", "flag_png", "flag"));
        var graph4 = this.uiMap.getChild("trialBtn").asButton.getChild("graph4").asGraph;
        graph4.setNativeObject(new ak.MovieClip("flag_json", "flag_png", "flag"));
        //鸟
        this.niao1 = this.uiMap.getChild("niao1").asGraph;
        this.niao1.setNativeObject(new ak.MovieClip("niao_json", "niao_png", "niao"));
        this.niao2 = this.uiMap.getChild("niao2").asGraph;
        this.niao2.setNativeObject(new ak.MovieClip("niao_json", "niao_png", "niao"));
        this.niaoMC1();
        this.niaoMC2();
        //火
        var huo_graph1 = this.uiMap.getChild("expeditionBtn").asButton.getChild("graph1").asGraph;
        var huo_graph1mc = new ak.MovieClip("huo_json", "huo_png", "huo");
        huo_graph1mc.scaleX = 0.6;
        huo_graph1mc.scaleY = 0.6;
        huo_graph1.setNativeObject(huo_graph1mc);
        var huo_graph2 = this.uiMap.getChild("expeditionBtn").asButton.getChild("graph2").asGraph;
        var huo_graph2mc = new ak.MovieClip("huo_json", "huo_png", "huo");
        huo_graph2mc.scaleX = 0.6;
        huo_graph2mc.scaleY = 0.6;
        huo_graph2.setNativeObject(huo_graph2mc);
    };
    MainUI.prototype.niaoMC1 = function () {
        var _this = this;
        egret.Tween.get(this.niao1).to({ x: 1750, y: 1136 }, 9000).call(function () {
            _this.niao1.x = -144;
            _this.niao1.y = -72;
            _this.niaoMC1();
        });
    };
    MainUI.prototype.niaoMC2 = function () {
        var _this = this;
        egret.Tween.get(this.niao2).to({ x: 1750, y: 1036 }, 9000).call(function () {
            _this.niao2.x = -72;
            _this.niao2.y = -72;
            _this.niaoMC2();
        });
    };
    /**更新活动列表和红点 */
    MainUI.prototype.updateListInfo = function () {
        this.updateList();
        this.updateListRedDot();
    };
    /**更新活动列表 */
    MainUI.prototype.updateList = function () {
        var activity = this.mainUI.getChild("activity").asList;
        var activity2 = this.mainUI.getChild("activity2").asList;
        activity.removeChildrenToPool();
        if (MyConfig.openActivity) {
            var activity1Info = ActivityData.inst().getMainUIactivityData("0").reverse();
            for (var i = 0; i < activity1Info.length; i++) {
                var jump = activity1Info[i].getValFromColName("jump");
                var id = activity1Info[i].getValFromColName("id");
                var red = activity1Info[i].getValFromColName("red");
                var com = activity1Info[i].getValFromColName("com");
                var item = activity.addItemFromPool(com).asCom;
                item.data = { jump: jump, id: id, red: red };
            }
        }
        activity2.removeChildrenToPool();
        if (MyConfig.openActivity) {
            var activity2Info = ActivityData.inst().getMainUIactivityData("1");
            for (var i = 0; i < activity2Info.length; i++) {
                var jump = activity2Info[i].getValFromColName("jump");
                var id = activity2Info[i].getValFromColName("id");
                var red = activity2Info[i].getValFromColName("red");
                var com = activity2Info[i].getValFromColName("com");
                var item = activity2.addItemFromPool(com).asCom;
                item.data = { jump: jump, id: id, red: red };
            }
        }
    };
    /**更新活动列表红点 */
    MainUI.prototype.updateListRedDot = function () {
        var activity = this.mainUI.getChild("activity").asList;
        var activity2 = this.mainUI.getChild("activity2").asList;
        for (var i = 0; i < activity.numItems; i++) {
            var item = activity.getChildAt(i).asCom;
            var id = item.data.id;
            if (id == 4) {
                if (RedDotMgr.sevenDayActivityRedDot() == 1) {
                    var c1 = item.getController("c1").selectedIndex = 1;
                }
                else {
                    var c1 = item.getController("c1").selectedIndex = 0;
                }
            }
            if (id == 1) {
                if (RedDotMgr.rechargeRedDot() == 1) {
                    var c1 = item.getController("c1").selectedIndex = 1;
                }
                else {
                    var c1 = item.getController("c1").selectedIndex = 0;
                }
            }
            if (id == 2) {
                if (RedDotMgr.sginRedDot() == 1) {
                    var c1 = item.getController("c1").selectedIndex = 1;
                }
                else {
                    var c1 = item.getController("c1").selectedIndex = 0;
                }
            }
            if (id == 3) {
                if (RedDotMgr.activityTimeRedDot() == 1) {
                    var c1 = item.getController("c1").selectedIndex = 1;
                }
                else {
                    var c1 = item.getController("c1").selectedIndex = 0;
                }
            }
        }
        for (var i = 0; i < activity2.numItems; i++) {
            var item = activity2.getChildAt(i).asCom;
            var id = item.data.id;
            if (id == 5) {
                if (RedDotMgr.everydayRechargeRedDot() == 1) {
                    var c1 = item.getController("c1").selectedIndex = 1;
                }
                else {
                    var c1 = item.getController("c1").selectedIndex = 0;
                }
            }
            if (id == 6) {
                if (RedDotMgr.fristRechargeRedDot() == 1) {
                    var c1 = item.getController("c1").selectedIndex = 1;
                }
                else {
                    var c1 = item.getController("c1").selectedIndex = 0;
                }
            }
        }
    };
    //新手奖励图标
    MainUI.prototype.SetNewHandReaward = function () {
        if (this.onlinePrize != null) {
            this.item.visible = true;
            var count = this.onlinePrize.size();
            if (MyData.user.json.onlineReward.idMap[count] != null) {
                this.item.visible = false;
                return;
            }
            for (var i = 0; i < count; i++) {
                var onlinePrizeInfo = this.onlinePrize.getRow(i);
                var onlinePrizeID = onlinePrizeInfo.getValFromColName("id"); //物品ID
                var onlinePrizeDrop = onlinePrizeInfo.getValFromColName("drop"); //物品掉落组
                var arr = ItemMgr.getDropGroupByID(onlinePrizeDrop);
                var typeS = arr[0][1];
                var itemIDS = arr[0][2];
                var countS = arr[0][3];
                if (!MyData.user.json.onlineReward.idMap[i + 1]) {
                    this.itemBase.clear2();
                    this.itemBase.setItemType(typeS);
                    this.itemBase.setItemData(Number(itemIDS));
                    this.itemBase.setNumber(countS, true);
                    this.itembaselist[i] = this.itemBase;
                    return;
                }
            }
        }
        else {
            this.item.visible = false;
        }
    };
    //新手奖励倒计时
    MainUI.prototype.timedown = function () {
        //限时礼包倒计时
        var activity2 = this.mainUI.getChild("activity2").asList;
        for (var i = 0; i < activity2.numItems; i++) {
            var item = activity2.getChildAt(i);
            if (item.data.id == 8) {
                var timetxt = item.getChild("time").asTextField;
                if (timetxt) {
                    var times = ActivityData.inst().activityLimitTime();
                    if (times > 0) {
                        timetxt.text = "" + DateUtils.getFormatBySecond(times, DateUtils.TIME_FORMAT_12);
                    }
                    else {
                        this.updateList();
                        this.updateListRedDot();
                        return;
                    }
                }
            }
        }
        if (this.onlinePrize != null) {
            this.item.visible = true;
            var count = this.onlinePrize.size();
            var timer = this.item.getChild("n5").asTextField; //获取文字
            var itemController = this.item.getController("c1");
            var cd = 0;
            if (MyData.user.json.onlineReward.idMap[count] != null) {
                this.item.visible = false;
                return;
            }
            for (var i = 0; i < count; i++) {
                var onlinePrizeInfo = this.onlinePrize.getRow(i);
                var onlineTime = onlinePrizeInfo.getValFromColName("cd"); //等待时间
                cd = cd + onlineTime;
                if ((Common.getOnlieSceond() + MyData.user.onlineSeconds) <= cd && !MyData.user.json.onlineReward.idMap[i + 1]) {
                    timer.visible = true;
                    var text = DateUtils.getFormatBySecond(cd - (Common.getOnlieSceond() + MyData.user.onlineSeconds), DateUtils.TIME_FORMAT_12);
                    timer.text = text;
                    if (this.itembaselist[i] != null) {
                        this.itembaselist[i].isshowLight(false);
                        itemController.selectedIndex = RedDotMgr.onlineRedDot();
                    }
                    break;
                }
                else if ((Common.getOnlieSceond() + MyData.user.onlineSeconds) > cd && MyData.user.json.onlineReward.idMap[i + 1] == null) {
                    timer.visible = false;
                    if (this.itembaselist[i] != null) {
                        this.itembaselist[i].isshowLight(true);
                        itemController.selectedIndex = RedDotMgr.onlineRedDot();
                    }
                    break;
                }
            }
        }
        else {
            this.item.visible = false;
        }
    };
    //掉落事件
    MainUI.prototype.onDrop = function (dropMap) {
        //弹出物品掉落界面
        ak.FairyGUI.open(["GainitemView", dropMap]);
    };
    //竖排活动点击处理
    MainUI.prototype.itemonclick = function (e) {
        var data = e.itemObject.data;
        var viewName = data.jump[0];
        if (viewName == "SuperFundView" || viewName == "ActivityLimitGiftView") {
            ak.FairyGUI.open(["ActivityCommonView", viewName]);
        }
        else {
            ak.FairyGUI.open(data.jump);
        }
    };
    //横排活动点击处理
    MainUI.prototype.itemonclick1 = function (e) {
        var data = e.itemObject.data;
        ActivityData.inst().setActivityID(data.id);
        ak.FairyGUI.open(data.jump);
    };
    MainUI.prototype.updateView = function () {
        if (GameSystem.isSysOpen(1, false)) {
            this.uiMap.getChild("worldTreeBtn").asCom.getController("c1").selectedIndex = (1);
        }
        if (GameSystem.isSysOpen(2, false)) {
            this.uiMap.getChild("wishBtn").asCom.getController("c1").selectedIndex = (1);
        }
        if (GameSystem.isSysOpen(4, false)) {
            this.uiMap.getChild("arenaBtn").asCom.getController("c1").selectedIndex = (1);
        }
        if (GameSystem.isSysOpen(8, false)) {
            this.uiMap.getChild("towerBtn").asCom.getController("c1").selectedIndex = (1);
        }
        if (GameSystem.isSysOpen(9, false)) {
            this.uiMap.getChild("trialBtn").asCom.getController("c1").selectedIndex = (1);
        }
        if (GameSystem.isSysOpen(12, false)) {
            this.uiMap.getChild("barBtn").asCom.getController("c1").selectedIndex = (1);
        }
        if (GameSystem.isSysOpen(7, false)) {
            this.uiMap.getChild("expeditionBtn").asCom.getController("c1").selectedIndex = (1);
        }
        if (GameSystem.isSysOpen(13, false)) {
            this.mainUI.getChild("godWeaponBtn").asCom.visible = true;
        }
        else {
            this.mainUI.getChild("godWeaponBtn").asCom.visible = false;
        }
        this.onlinePrize = ak.JsonTableMgr.get("onlinePrize"); //新手奖励获取表 操作
        this.SetNewHandReaward(); //新手奖励头像
        //判断开启哪个提示
        if (this.systemOpenBtn[this.isnoopenID()]) {
            this.uiMap.getChild(this.systemOpenBtn[this.isnoopenID()]).asCom.getController("c1").selectedIndex = (2);
        }
    };
    //判断打开第几个提示系统开放
    MainUI.prototype.isnoopenID = function () {
        var level = MyData.user.level;
        var id = 0;
        var systemOpenTab = ak.JsonTableMgr.get("systemOpen");
        var newSystemOpenTab = [];
        for (var i = 0; i < systemOpenTab.size(); i++) {
            newSystemOpenTab.push(systemOpenTab.getRow(i));
        }
        newSystemOpenTab.sort(this.GroupSort);
        for (var j = 0; j < newSystemOpenTab.length; j++) {
            var jlevel = newSystemOpenTab[j].getValFromColName("openLv");
            var jid = newSystemOpenTab[j].getValFromColName("id");
            if (level < jlevel) {
                id = jid;
                return id;
            }
        }
        return id;
    };
    MainUI.prototype.GroupSort = function (a, b) {
        var alv = a.getValFromColName("openLv");
        var blv = b.getValFromColName("openLv");
        if (alv > blv)
            return 1;
        if (alv < blv)
            return -1;
        if (alv == blv) {
            var aid = a.getValFromColName("id");
            var bid = b.getValFromColName("id");
            if (aid > bid)
                return 1;
            if (aid < bid)
                return -1;
        }
        return 0;
    };
    //红点聊天刷新显示
    MainUI.prototype.onFlushChatRedPoint = function () {
        var chatPoint = RedDotMgr.getChatRedDot();
        if (ak.FairyGUI.getOpenUI("ChatView").length > 0) {
            chatPoint = false;
        }
        this.mainUI.getChild("chatBtn").asCom.getController("c1").selectedIndex = chatPoint ? 1 : 0;
    };
    //红点邮件刷新显示
    MainUI.prototype.onFlushMailRedPoint = function () {
        var mailPoint = RedDotMgr.getMailRedDot();
        this.mainUI.getChild("mailBtn").asCom.getController("c1").selectedIndex = mailPoint ? 1 : 0;
    };
    //排行榜红点刷新显示
    MainUI.prototype.onFlushWorshipRedPoint = function () {
        var rankPoint = RedDotMgr.getWorshipRedDot();
        this.mainUI.getChild("rankBtn").asCom.getController("c1").selectedIndex = rankPoint ? 1 : 0;
        this.onFlushTaskRedPoint();
    };
    //好友红点刷新显示(红心)
    MainUI.prototype.onFlushFriendRedPoint = function () {
        var redHeartPoint = RedDotMgr.getFriendRedDot() || RedDotMgr.getFriendTreasureRedDot();
        this.mainUI.getChild("friendBtn").asCom.getController("c1").selectedIndex = redHeartPoint ? 1 : 0;
    };
    //好友红点刷新显示(探宝)
    MainUI.prototype.onFlushFriendTreasureRedPoint = function () {
        if (RedDotMgr.getFriendRedDot() == false) {
            var treasurePoint = RedDotMgr.getFriendTreasureRedDot();
            this.mainUI.getChild("friendBtn").asCom.getController("c1").selectedIndex = treasurePoint ? 1 : 0;
        }
    };
    //任务红点刷新显示
    MainUI.prototype.onFlushTaskRedPoint = function () {
        var taskPoint = RedDotMgr.getTaskRedDot() || RedDotMgr.getTaskRedDot2();
        this.mainUI.getChild("taskBtn").asCom.getController("c1").selectedIndex = taskPoint ? 1 : 0;
    };
    //神器红点刷新显示
    MainUI.prototype.godWeaponRedPoint = function () {
        var RedDot = RedDotMgr.allGodWeaponTaskCompleteRedDot();
        this.mainUI.getChild("godWeaponBtn").asCom.getController("c1").selectedIndex = RedDot ? 1 : 0;
    };
    return MainUI;
}(ak.EasyUI));
__reflect(MainUI.prototype, "MainUI");
//预加载界面系统
var PreloadSystem = (function (_super) {
    __extends(PreloadSystem, _super);
    function PreloadSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PreloadSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("LoadingUI");
    };
    //显示小加载界面
    PreloadSystem.prototype.showSmallLoading = function (showSign) {
        if (showSign) {
            if (ak.FairyGUI.getOpenUI("SmallLoadingUI").length == 0) {
                ak.FairyGUI.open(["SmallLoadingUI"]);
            }
        }
        else {
            var uiArr = ak.FairyGUI.getOpenUI("SmallLoadingUI");
            if (uiArr.length > 0) {
                var ui = uiArr[0];
                ui.close();
            }
        }
    };
    //显示大加载界面
    PreloadSystem.prototype.showBigLoading = function (showSign) {
        if (showSign) {
            if (ak.FairyGUI.getOpenUI("BigLoadingUI").length == 0) {
                ak.FairyGUI.open(["BigLoadingUI"]);
            }
        }
        else {
            var uiArr = ak.FairyGUI.getOpenUI("BigLoadingUI");
            if (uiArr.length > 0) {
                var ui = uiArr[0];
                ui.close();
            }
        }
    };
    PreloadSystem.inst = new PreloadSystem("preload");
    return PreloadSystem;
}(ak.FairyGUI));
__reflect(PreloadSystem.prototype, "PreloadSystem");
//小加载界面
var SmallLoadingUI = (function (_super) {
    __extends(SmallLoadingUI, _super);
    function SmallLoadingUI() {
        var _this = _super.call(this, PreloadSystem.inst, MyGame.inst.loadingLayer) || this;
        var bg = new egret.Shape();
        bg.graphics.beginFill(0xffffff, 0);
        bg.graphics.drawRect(0, 0, fairygui.GRoot.inst.width, fairygui.GRoot.inst.height);
        bg.graphics.endFill();
        bg.touchEnabled = true;
        _this.addChild(bg);
        _this.bg = bg;
        return _this;
    }
    //初始化回调
    SmallLoadingUI.prototype.onInit = function () {
        this.removeChild(this.bg);
        this.bg = null;
        this.alpha = 0;
        var ui = this.create("LoadingUI", "SmallLoadingUI");
        this.timer = new egret.Timer(3000, 1);
        this.onEgretEvent(this.timer, egret.TimerEvent.TIMER_COMPLETE, this.onTimerComplete, this);
        this.timer.start();
    };
    SmallLoadingUI.prototype.onTimerComplete = function () {
        this.alpha = 1;
    };
    //销毁回调
    SmallLoadingUI.prototype.onDestroy = function () {
        if (this.timer) {
            this.timer.stop();
        }
    };
    return SmallLoadingUI;
}(ak.EasyUI));
__reflect(SmallLoadingUI.prototype, "SmallLoadingUI");
//大加载界面
var BigLoadingUI = (function (_super) {
    __extends(BigLoadingUI, _super);
    function BigLoadingUI() {
        var _this = _super.call(this, PreloadSystem.inst, MyGame.inst.loadingLayer) || this;
        var bg = new egret.Shape();
        bg.graphics.beginFill(0x0, 255);
        bg.graphics.drawRect(0, 0, fairygui.GRoot.inst.width, fairygui.GRoot.inst.height);
        bg.graphics.endFill();
        bg.touchEnabled = true;
        _this.addChild(bg);
        _this.bg = bg;
        _this.txt = new egret.TextField();
        _this.addChild(_this.txt);
        _this.txt.text = "connecting to the server,please wait...";
        _this.txt.y = 1136 / 2 - 10;
        _this.txt.width = 640;
        _this.txt.height = 50;
        _this.txt.textAlign = "center";
        return _this;
    }
    //初始化回调
    BigLoadingUI.prototype.onInit = function () {
        // this.removeChild(this.bg);
        // this.bg=null;
        var ui = this.create("LoadingUI", "BigLoadingUI");
        this.bg2 = ui.getChild("bg").asLoader;
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.onEnterFrame, this);
        //进度
        this.progress = ui.getChild("progress").asProgress;
        this.progress.max = 100;
        this.progress.value = 0;
        egret.Tween.get(this.progress).to({ "value": 100 }, 3000);
    };
    BigLoadingUI.prototype.onEnterFrame = function () {
        if (this.isGLoaderComplete(this.bg2)) {
            this.offEgretEvent(this, egret.Event.ENTER_FRAME, this.onEnterFrame, this);
            this.removeChild(this.bg);
            this.removeChild(this.txt);
            this.bg = null;
            this.txt = null;
        }
    };
    //销毁回调
    BigLoadingUI.prototype.onDestroy = function () {
        if (this.progress) {
            egret.Tween.removeTweens(this.progress);
        }
    };
    return BigLoadingUI;
}(ak.EasyUI));
__reflect(BigLoadingUI.prototype, "BigLoadingUI");
//网络异常界面
var NetErrorUI = (function (_super) {
    __extends(NetErrorUI, _super);
    function NetErrorUI() {
        return _super.call(this, PreloadSystem.inst, MyGame.inst.loadingLayer) || this;
    }
    //初始化回调
    NetErrorUI.prototype.onInit = function () {
        var _this = this;
        var ui = this.create("LoadingUI", "NetErrorUI");
        this.addClickListener(ui, function () {
            _this.close();
            PreloadSystem.inst.showBigLoading(true);
            net.cnnlogin();
        }, this);
    };
    return NetErrorUI;
}(ak.EasyUI));
__reflect(NetErrorUI.prototype, "NetErrorUI");
//网络异常界面
var LoginOut = (function (_super) {
    __extends(LoginOut, _super);
    function LoginOut() {
        return _super.call(this, PreloadSystem.inst, MyGame.inst.loadingLayer) || this;
    }
    //初始化回调
    LoginOut.prototype.onInit = function () {
        var _this = this;
        var ui = this.create("LoadingUI", "BigLoadingUI");
        CPSDK.inst.initAppSdk(function (userInfo) { }, this);
        CPSDK.inst.login(function () {
            MyClient.inst.closeConnectServer();
            _this.close();
            PreloadSystem.inst.showBigLoading(true);
            net.cnnlogin();
        });
        // this.addClickListener(ui,()=>{
        // 	this.close();
        // 	PreloadSystem.inst.showBigLoading(true);
        // 	net.cnnlogin();
        // },this);
    };
    return LoginOut;
}(ak.EasyUI));
__reflect(LoginOut.prototype, "LoginOut");
//商店通用    限购 与 不限购
var ShopData = (function () {
    function ShopData() {
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    ShopData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new ShopData();
        }
        return Class._instance;
    };
    //style 什么类型的商店
    //0 限购且表格内容全部显示    英雄 公会
    //1 限购且表格内容部分显示    许愿池 
    //2 不限购且表格内容全部显示    远征 竞技场 
    //参数分别为 1.this 2.类型 3.list 组件 4.表格 5.表格 6.购买MAP 7.剩余东西(余额)      //图标(1英雄 2公会 3许愿池 4远征 5竞技场) iconresID:any=null
    ShopData.prototype.setShopView = function (ui, style, list, shoptempTab, shopTab, buyCountMap, myscore) {
        if (shopTab === void 0) { shopTab = null; }
        if (buyCountMap === void 0) { buyCountMap = null; }
        list.removeChildrenToPool();
        var count; //fairygui中 商品以每3个一组
        var listsize; //表的大小
        var itemArr; //表格内容部分显示
        if (style != 1) {
            shopTab = shoptempTab;
            count = shopTab.size();
            listsize = shopTab.size();
            count = Math.ceil(count / 3);
        }
        else {
            itemArr = shoptempTab;
            listsize = itemArr.length;
            count = Math.ceil(itemArr.length / 3);
        }
        for (var i = 0; i < count; i++) {
            var shopFrame = list.addItemFromPool().asCom;
            for (var j = 0; j < 3; j++) {
                var item0 = shopFrame.getChild("n1" + (j + 1)).asCom; //获取一行中每个元素
                var item1 = item0.getChild("n2").asCom; //获取元素中的物品栏
                // let icon = item0.getChild("icon").asLoader;
                // if(iconresID==1){
                // 	ui.setLoaderUrl(icon,'ui://common/token_lhs');
                // }else if(iconresID==2){
                // 	ui.setLoaderUrl(icon,'ui://common/token_ghgx');
                // }else if(iconresID==3){
                // 	ui.setLoaderUrl(icon,'ui://common/token_xyjf');
                // }else if(iconresID==4){
                // 	ui.setLoaderUrl(icon,'ui://common/token_yzjsw');
                // }else if(iconresID==5){
                // 	ui.setLoaderUrl(icon,'ui://common/token_ryd');
                // }
                var item_bg = item0.getChild("n15").asLoader; //获取元素中的背景图
                if (i * 3 + j < listsize) {
                    var index = style != 1 ? i * 3 + j : itemArr[i * 3 + j] - 1;
                    var shopInfo = shopTab.getRow(index);
                    var shopItem = shopInfo.getValFromColName("item"); //商品ID
                    var shopItemnum = shopInfo.getValFromColName("num"); //数量
                    var shopItemcostItem = shopInfo.getValFromColName("costItem"); //消耗的物品ID
                    var shopItemcostNum = shopInfo.getValFromColName("costNum"); //购买需要花费的数量
                    var itemBase = new ItemBase(item1, ui, 1); //商品类型
                    itemBase.setItemData(shopItem); //商品ID
                    itemBase.setNumber(shopItemnum, true); //商品数量
                    var MapIndex = style != 1 ? i * 3 + j + 1 : i * 3 + j;
                    var item0_list = []; //购买所需的数据
                    item0_list["index"] = MapIndex;
                    item0_list["CostNum"] = shopItemcostNum;
                    item0_list["CostItem"] = shopItemcostItem;
                    var item1_list = []; //物品详情所需数据
                    item1_list["id"] = shopItem;
                    item1_list["num"] = shopItemnum;
                    item1.data = item1_list;
                    if (style == 0 || style == 1) {
                        var shopLimit = Number(shopInfo.getValFromColName("limit")); //限购次数
                        item0_list["limit"] = shopLimit;
                        var item2 = item0.getChild("n10").asTextField; //获取元素中的限购文字
                        var itemLimimtBuyCount = buyCountMap[MapIndex];
                        item2.text = "限购" + (itemLimimtBuyCount == null ? shopLimit : (shopLimit - itemLimimtBuyCount));
                        item0.getController("wan").selectedIndex = (shopLimit - itemLimimtBuyCount) == 0 ? 1 : 0;
                    }
                    item0.data = item0_list;
                    Common.labelIsOverLenght(item0.getChild("n8").asTextField, shopItemcostNum);
                    var number2 = myscore.getChild("number").asTextField;
                    number2.text = "" + SummonData.inst().GetItemnumByid(shopItemcostItem);
                    Common.labelIsOverLenght(number2, number2.text);
                }
                else {
                    item0.visible = false;
                }
            }
        }
    };
    return ShopData;
}());
__reflect(ShopData.prototype, "ShopData");
//数据
var ActivityLimitGiftData = (function () {
    function ActivityLimitGiftData() {
        this.activitygiftTab = ak.JsonTableMgr.get("activityLimitGift");
    }
    ActivityLimitGiftData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new ActivityLimitGiftData();
        }
        return Class._instance;
    };
    ActivityLimitGiftData.prototype.getViewType = function () {
        return this.viewType;
    };
    ActivityLimitGiftData.prototype.setViewType = function (type) {
        this.viewType = type;
    };
    ActivityLimitGiftData.prototype.getTime = function () {
        var type = this.getViewType();
        var Info = this.activitygiftTab.getRow(type - 1);
        if (MyData.user.json.limitPackage.buyMap[type] != null) {
            var time = Info.getValFromColName("time");
            var count = ak.time() + MyData.timeBase - (MyData.user.json.limitPackage.buyMap[type].bt + time);
            return count;
        }
        else {
            return 0;
        }
    };
    ActivityLimitGiftData.prototype.getIndex = function (type) {
        var Info = this.activitygiftTab.getRow(type - 1);
        var time = Info.getValFromColName("time");
        if (MyData.user.json.limitPackage.buyMap[type] != null) {
            var count = ak.time() + MyData.timeBase - (MyData.user.json.limitPackage.buyMap[type].bt + time);
            if (count < 0) {
                return true;
            }
            else {
                return false;
            }
        }
        else {
            return false;
        }
    };
    ActivityLimitGiftData.prototype.getArray = function () {
        var arr = Object.keys(MyData.user.json.limitPackage.buyMap);
        var arrCount = arr.length;
        var newArr = arr.map(Number);
        var arr_1 = new Array();
        for (var i = 0; i < arrCount; i++) {
            if (this.getIndex(newArr[i])) {
                arr_1[i] = arr[i];
            }
            else {
                arr_1[i] = 0;
            }
        }
        var newArr_1 = arr_1.map(Number);
        return newArr_1;
    };
    ActivityLimitGiftData.geticonarry = function () {
        var arr = Object.keys(MyData.user.json.limitPackage.buyMap);
        var arrCount = arr.length;
        var newArr = arr.map(Number);
        var arr1 = new Array();
        for (var i = 0; i < arrCount; i++) {
            var activitygiftTab = ak.JsonTableMgr.get("activityLimitGift");
            var Info = activitygiftTab.getRow(newArr[i] - 1);
            var time = Info.getValFromColName("time");
            var count = ak.time() + MyData.timeBase - (MyData.user.json.limitPackage.buyMap[newArr[i]].bt + time);
            arr1 = count > 0 ? newArr[i] : 0;
        }
        return arr1;
    };
    return ActivityLimitGiftData;
}());
__reflect(ActivityLimitGiftData.prototype, "ActivityLimitGiftData");
//限时礼包
var ActivityLimitGiftSystem = (function (_super) {
    __extends(ActivityLimitGiftSystem, _super);
    function ActivityLimitGiftSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    ActivityLimitGiftSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ActivityLimitGift");
    };
    ActivityLimitGiftSystem.inst = new ActivityLimitGiftSystem("ActivityLimitGift");
    return ActivityLimitGiftSystem;
}(ak.FairyGUI));
__reflect(ActivityLimitGiftSystem.prototype, "ActivityLimitGiftSystem");
var ActivityLimitGiftView = (function (_super) {
    __extends(ActivityLimitGiftView, _super);
    function ActivityLimitGiftView(stackView) {
        return _super.call(this, ActivityLimitGiftSystem.inst, stackView) || this;
    }
    ActivityLimitGiftView.prototype.onInit = function () {
        var ui = this.create("ActivityLimitGift", "ActivityLimitGiftView");
        this.rewardItem = ui.getChild("rewardItem").asCom;
        this.rewardlist = this.rewardItem.getChild("n1").asList;
        this.buyBtn = this.rewardItem.getChild("n4").asButton;
        this.timetext = ui.getChild("time").asTextField;
        this.leveltext = ui.getChild("leveltext").asTextField;
        this.activitygiftTab = ak.JsonTableMgr.get("activityLimitGift");
        // this.on("netmsg://limitPackageDataResult",this.isLimitPackage,this);
        this.on("netmsg://limitPackageDataResult", this.showView, this);
        //this.showView();
        this.showView();
        this.clickAdd();
    };
    ActivityLimitGiftView.prototype.clickAdd = function () {
        this.onFairyguiEvent(this.rewardlist, fairygui.ItemEvent.CLICK, this.showdetails, this);
        this.addClickListener(this.buyBtn, this.onClick, this);
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.timedown, this);
        this.on(GameEvent.changeLimitGiftView, this.showView, this);
    };
    ActivityLimitGiftView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.buyBtn:
                var Info = this.activitygiftTab.getRow(e.target.data.index - 1);
                var payID = Info.getValFromColName("pay");
                net.genPayOrder(payID);
        }
    };
    ActivityLimitGiftView.prototype.timedown = function () {
        var count = ActivityLimitGiftData.inst().getTime();
        if (count > 0) {
            this.istimeOver = true;
            this.timetext.visible = false;
            // this.showView();
            return;
        }
        else {
            this.istimeOver = false;
            this.timetext.visible = true;
            var text = DateUtils.getFormatBySecond(Math.abs(count), DateUtils.TIME_FORMAT_12);
            this.timetext.text = "剩余：" + text;
        }
    };
    ActivityLimitGiftView.prototype.showView = function () {
        var rewardList = this.rewardItem.getChild("n1").asList;
        var overcount = this.rewardItem.getChild("n3").asTextField;
        var Type = ActivityLimitGiftData.inst().getViewType();
        if (!this.istimeOver) {
            if (Type <= 6) {
                this.ui.getController("c1").selectedIndex = Type - 1;
                this.showLonggu(52013);
            }
            else {
                this.ui.getController("c1").selectedIndex = 6;
                this.showLonggu(22036);
            }
        }
        rewardList.removeChildrenToPool();
        var Info = this.activitygiftTab.getRow(Type - 1);
        var payID = Info.getValFromColName("pay");
        var Item = Info.getValFromColName("item");
        var Limit = Info.getValFromColName("limit");
        var drop = Info.getValFromColName("drop");
        var playerLevel = Info.getValFromColName("playerLevel");
        if (this.ui.getController("c1").selectedIndex == 6) {
            this.leveltext.text = playerLevel;
        }
        var item_Cfg01 = ItemMgr.getDropGroupByID(Number(drop));
        for (var j = 0; j < item_Cfg01.length; j++) {
            var recharge = rewardList.addItemFromPool().asCom;
            var item_type = item_Cfg01[j][1];
            var item_id = item_Cfg01[j][2];
            var item_count = item_Cfg01[j][3];
            var itemBase0 = new ItemBase(recharge, this, item_type);
            itemBase0.setItemData(Number(item_id));
            itemBase0.setNumber(item_count, true);
            var item0_list = []; //物品详情
            item0_list["type"] = item_type;
            item0_list["id"] = item_id;
            item0_list["num"] = item_count;
            recharge.data = item0_list;
        }
        var btntext = this.buyBtn.getChild("title").asTextField;
        btntext.text = (Common.getMoneyByPayID(payID)).toString() + '元';
        var btn_data = [];
        btn_data["index"] = Type;
        this.buyBtn.data = btn_data;
        if (!this.istimeOver) {
            if (MyData.user.json.limitPackage.buyMap[Type] != null) {
                if (Limit - MyData.user.json.limitPackage.buyMap[Type].buyCount > 0) {
                    this.buyBtn.enabled = true;
                    overcount.text = "剩余：" + (Limit - MyData.user.json.limitPackage.buyMap[Type].buyCount).toString();
                }
            }
            else {
                this.buyBtn.enabled = false;
                overcount.text = "剩余：" + "0";
            }
        }
        else {
            this.buyBtn.enabled = false;
            overcount.text = "剩余：" + (Limit - MyData.user.json.limitPackage.buyMap[Type].buyCount).toString();
        }
    };
    ActivityLimitGiftView.prototype.showLonggu = function (heroID) {
        if (!this.heroNode) {
            this.heroNode = new egret.DisplayObjectContainer();
            this.ui.getChild("longgu").asGraph.setNativeObject(this.heroNode);
        }
        this.heroNode.removeChildren();
        // let tt=new egret.DisplayObjectContainer();
        var temp = this.ui.getChild("longgu").asGraph;
        temp.setNativeObject(this.heroNode);
        var hero = new Hero(heroID).addToParent(this.heroNode);
        // tt.scaleX=1;
    };
    //显示物品详情 
    ActivityLimitGiftView.prototype.showdetails = function (obj) {
        var item = obj.itemObject;
        if (this.hitTestPointWithFairyGUIComponent(item, obj.stageX, obj.stageY)) {
            if (item.data.type != 3)
                ak.FairyGUI.open(["WeaponTipsView", item.data.id, item.data.num, 1]);
            else
                ak.FairyGUI.open(["ResourceTipsView", item.data.id, item.data.num]);
        }
    };
    return ActivityLimitGiftView;
}(ak.EasyUI));
__reflect(ActivityLimitGiftView.prototype, "ActivityLimitGiftView");
var ActivityOpenserverBoxShowViewSystem = (function (_super) {
    __extends(ActivityOpenserverBoxShowViewSystem, _super);
    function ActivityOpenserverBoxShowViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    ActivityOpenserverBoxShowViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ActivityOpenserverView");
    };
    ActivityOpenserverBoxShowViewSystem.inst = new ActivityOpenserverBoxShowViewSystem("ActivityOpenserverView");
    return ActivityOpenserverBoxShowViewSystem;
}(ak.FairyGUI));
__reflect(ActivityOpenserverBoxShowViewSystem.prototype, "ActivityOpenserverBoxShowViewSystem");
/**
 * 7天活动预览界面
 */
var ActivityOpenserverBoxShowView = (function (_super) {
    __extends(ActivityOpenserverBoxShowView, _super);
    function ActivityOpenserverBoxShowView(index) {
        var _this = _super.call(this, RewardShowViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.index = 0;
        _this.index = index;
        return _this;
    }
    /**回调 */
    ActivityOpenserverBoxShowView.prototype.onInit = function () {
        var ui = this.create("ActivityOpenserverView", "RewardShowView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.closebtn = ui.getChild("closebtn").asButton;
        this.list = ui.getChild("list").asList;
        this.ClickAdd();
        this.updateList();
    };
    ActivityOpenserverBoxShowView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.closebtn, this.onClick, this);
        this.onFairyguiEvent(this.list, fairygui.ItemEvent.CLICK, this.itemonclick, this);
    };
    ActivityOpenserverBoxShowView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.closebtn:
                this.close();
                break;
        }
    };
    ActivityOpenserverBoxShowView.prototype.updateList = function () {
        this.list.removeChildrenToPool();
        var info = ActivityOpenserverData.inst().getboxInfobyIndex(this.index);
        var itemArr = [];
        itemArr = ItemMgr.getDropGroupByID(info.drop);
        for (var i = 0; i < itemArr.length; i++) {
            var item = this.list.addItemFromPool().asCom;
            var items = new ItemBase(item, this, itemArr[i][1]);
            items.setItemData(Number(itemArr[i][2]));
            items.setNumber(itemArr[i][3], true);
            item.data = { itemID: Number(itemArr[i][2]), num: itemArr[i][3], type: itemArr[i][1] };
        }
    };
    ActivityOpenserverBoxShowView.prototype.itemonclick = function (e) {
        if (e.itemObject.data.type != 3) {
            var bagtype = ak.JsonTableMgr.get("item").getRowFromColName("id", "" + e.itemObject.data.itemID).getValFromColName("bagtype");
            ak.FairyGUI.open(["WeaponTipsView", e.itemObject.data.itemID, e.itemObject.data.num, bagtype - 1, 0, true]);
        }
        else {
            ak.FairyGUI.open(["ResourceTipsView", e.itemObject.data.itemID, e.itemObject.data.num]);
        }
    };
    return ActivityOpenserverBoxShowView;
}(ak.EasyUI));
__reflect(ActivityOpenserverBoxShowView.prototype, "ActivityOpenserverBoxShowView");
/**
 * 开服活动数据
 */
var ActivityOpenserverData = (function () {
    function ActivityOpenserverData() {
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    ActivityOpenserverData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new ActivityOpenserverData();
        }
        return Class._instance;
    };
    /**根据日期和页码获得活动数据 */
    ActivityOpenserverData.prototype.getInfobyDayandType = function (day, page) {
        var activitySevenDayTab = ak.JsonTableMgr.get("activitySevenDay");
        var infoarr = [];
        var dayactivity = activitySevenDayTab.getRowsFromColName("day", "" + day);
        for (var i = 0; i < dayactivity.length; i++) {
            var page0 = dayactivity[i].getValFromColName("page");
            if (page0 == page) {
                var name_15 = dayactivity[i].getValFromColName("name");
                var value = dayactivity[i].getValFromColName("value");
                var value2 = dayactivity[i].getValFromColName("value2");
                var type = dayactivity[i].getValFromColName("type");
                var zs = dayactivity[i].getValFromColName("zs");
                var sales = dayactivity[i].getValFromColName("sales");
                var id = dayactivity[i].getValFromColName("id");
                var vip = dayactivity[i].getValFromColName("vip");
                var drop = dayactivity[i].getValFromColName("drop");
                var info = { id: id, name: name_15, value: value, value2: value2, type: type, zs: zs, sales: sales, vip: vip, drop: drop };
                infoarr.push(info);
            }
        }
        return infoarr;
    };
    /**根据日期获得活动数据 */
    ActivityOpenserverData.prototype.getInfobyDay = function (day) {
        var activitySevenDayTab = ak.JsonTableMgr.get("activitySevenDay");
        var infoarr = [];
        var dayactivity = activitySevenDayTab.getRowsFromColName("day", "" + day);
        for (var i = 0; i < dayactivity.length; i++) {
            var name_16 = dayactivity[i].getValFromColName("name");
            var value = dayactivity[i].getValFromColName("value");
            var value2 = dayactivity[i].getValFromColName("value2");
            var type = dayactivity[i].getValFromColName("type");
            var zs = dayactivity[i].getValFromColName("zs");
            var sales = dayactivity[i].getValFromColName("sales");
            var id = dayactivity[i].getValFromColName("id");
            var vip = dayactivity[i].getValFromColName("vip");
            var drop = dayactivity[i].getValFromColName("drop");
            var info = { id: id, name: name_16, value: value, value2: value2, type: type, zs: zs, sales: sales, vip: vip, drop: drop };
            infoarr.push(info);
        }
        return infoarr;
    };
    /**根据index获得箱子的信息 */
    ActivityOpenserverData.prototype.getboxInfobyIndex = function (index) {
        var activitySevenDayPrizeTab = ak.JsonTableMgr.get("activitySevenDayPrize");
        var activitySevenDayPrizeInfo = activitySevenDayPrizeTab.getRowFromColName("id", "" + (index + 1));
        var num = activitySevenDayPrizeInfo.getValFromColName("num");
        var drop = activitySevenDayPrizeInfo.getValFromColName("drop");
        var info = { num: num, drop: drop };
        return info;
    };
    /**返回完成任务的个数 */
    ActivityOpenserverData.prototype.getCompleteTaskNum = function () {
        var recvMap = MyData.user.json.createUser7Day.recvMap;
        var num = Object.keys(recvMap).length;
        return num;
    };
    /**获得任务进度的当前值和最大值*/
    ActivityOpenserverData.prototype.getTaskProgress = function (taskID) {
        var nowvalue = 0;
        var maxvalue = 0;
        var iscomplete = false;
        var activitySevenDayTab = ak.JsonTableMgr.get("activitySevenDay");
        var activitySevenDayInfo = activitySevenDayTab.getRowFromColName("id", "" + taskID);
        var type = activitySevenDayInfo.getValFromColName("type");
        var value = activitySevenDayInfo.getValFromColName("value");
        var value2 = activitySevenDayInfo.getValFromColName("value2");
        var day = activitySevenDayInfo.getValFromColName("day");
        maxvalue = value;
        //类型条件的判断
        if (type == 1) {
            if (MyData.user.json.createUser7Day.loginMap[day]) {
                nowvalue = 1;
                iscomplete = true;
            }
            else {
                nowvalue = 0;
                iscomplete = false;
            }
            ;
        }
        if (type == 2) {
            if (MyData.user.rmb > value) {
                nowvalue = MyData.user.rmb;
                iscomplete = true;
            }
            else {
                nowvalue = MyData.user.rmb;
                iscomplete = false;
            }
        }
        if (type == 3) {
            var info_2 = { nowvalue: 1, maxvalue: maxvalue, iscomplete: true };
            return info_2;
        }
        if (type == 11) {
            if (MyData.user.barrierID - 1 >= value) {
                nowvalue = MyData.user.barrierID - 1;
                iscomplete = true;
            }
            else {
                nowvalue = MyData.user.barrierID - 1;
                iscomplete = false;
            }
        }
        if (type == 12) {
            if (MyData.user.json.createUser7Day.friendGiveHeartCount >= value) {
                nowvalue = MyData.user.json.createUser7Day.friendGiveHeartCount;
                iscomplete = true;
            }
            else {
                nowvalue = MyData.user.json.createUser7Day.friendGiveHeartCount;
                iscomplete = false;
            }
        }
        if (type == 13) {
            if (MyData.user.towerID - 1 >= value) {
                nowvalue = MyData.user.towerID - 1;
                iscomplete = true;
            }
            else {
                nowvalue = MyData.user.towerID - 1;
                iscomplete = false;
            }
        }
        if (type == 14) {
            if (MyData.user.json.createUser7Day.topGetCardCount >= value) {
                nowvalue = MyData.user.json.createUser7Day.topGetCardCount;
                iscomplete = true;
            }
            else {
                nowvalue = MyData.user.json.createUser7Day.topGetCardCount;
                iscomplete = false;
            }
        }
        if (type == 15) {
            if (MyData.user.json.achievementTask.stageScore >= value) {
                nowvalue = MyData.user.json.achievementTask.stageScore;
                iscomplete = true;
            }
            else {
                nowvalue = MyData.user.json.achievementTask.stageScore;
                iscomplete = false;
            }
        }
        if (type == 16) {
            var cardarr = [];
            for (var i = 0; i < HeroBagData.cardArr().length; i++) {
                if (HeroBagData.cardArr()[i][1].level >= value2) {
                    cardarr.push(HeroBagData.cardArr()[i]);
                }
            }
            if (cardarr.length >= value) {
                nowvalue = cardarr.length;
                iscomplete = true;
            }
            else {
                nowvalue = cardarr.length;
                iscomplete = false;
            }
        }
        if (type == 17) {
            if (MyData.user.json.createUser7Day.pubTaskColorMap[value2]) {
                if (MyData.user.json.createUser7Day.pubTaskColorMap[value2] >= value) {
                    nowvalue = MyData.user.json.createUser7Day.pubTaskColorMap[value2];
                    iscomplete = true;
                }
                else {
                    nowvalue = MyData.user.json.createUser7Day.pubTaskColorMap[value2];
                    iscomplete = false;
                }
            }
            else {
                nowvalue = 0;
                iscomplete = false;
            }
        }
        if (type == 18) {
            if (MyData.user.json.createUser7Day.pubFlushCount >= value) {
                nowvalue = MyData.user.json.createUser7Day.pubFlushCount;
                iscomplete = true;
            }
            else {
                nowvalue = MyData.user.json.createUser7Day.pubFlushCount;
                iscomplete = false;
            }
        }
        if (type == 19) {
            if (MyData.user.json.remoteBattle.battleMaxCount >= value) {
                nowvalue = MyData.user.json.remoteBattle.battleMaxCount;
                iscomplete = true;
            }
            else {
                nowvalue = MyData.user.json.remoteBattle.battleMaxCount;
                iscomplete = false;
            }
        }
        if (type == 20) {
            if (MyData.user.json.createUser7Day.cardStarMap[value2]) {
                if (MyData.user.json.createUser7Day.cardStarMap[value2] >= value) {
                    nowvalue = MyData.user.json.createUser7Day.cardStarMap[value2];
                    iscomplete = true;
                }
                else {
                    nowvalue = MyData.user.json.createUser7Day.cardStarMap[value2];
                    iscomplete = false;
                }
            }
            else {
                nowvalue = 0;
                iscomplete = false;
            }
        }
        if (type == 21) {
            var cardarr = [];
            var stoneTab = ak.JsonTableMgr.get("stone");
            for (var i = 0; i < HeroBagData.cardArr().length; i++) {
                if (HeroBagData.cardArr()[i][1].gemLevel > 0) {
                    var stoneInfo = stoneTab.getRowFromColName("level", "" + HeroBagData.cardArr()[i][1].gemLevel);
                    var star = stoneInfo.getValFromColName("star");
                    if (star >= value2) {
                        cardarr.push(HeroBagData.cardArr()[i]);
                    }
                }
            }
            if (cardarr.length >= value) {
                nowvalue = cardarr.length;
                iscomplete = true;
            }
            else {
                nowvalue = cardarr.length;
                iscomplete = false;
            }
        }
        if (type == 22) {
            if (MyData.user.json.createUser7Day.wishPoolCount >= value) {
                nowvalue = MyData.user.json.createUser7Day.wishPoolCount;
                iscomplete = true;
            }
            else {
                nowvalue = MyData.user.json.createUser7Day.wishPoolCount;
                iscomplete = false;
            }
        }
        if (type == 23) {
            if (MyData.user.json.createUser7Day.cardComposeStarMap[value2]) {
                if (MyData.user.json.createUser7Day.cardComposeStarMap[value2] >= value) {
                    nowvalue = MyData.user.json.createUser7Day.cardComposeStarMap[value2];
                    iscomplete = true;
                }
                else {
                    nowvalue = MyData.user.json.createUser7Day.cardComposeStarMap[value2];
                    iscomplete = false;
                }
            }
            else {
                nowvalue = 0;
                iscomplete = false;
            }
        }
        if (type == 24) {
            if (MyData.user.level >= value) {
                nowvalue = MyData.user.level;
                iscomplete = true;
            }
            else {
                nowvalue = MyData.user.level;
                iscomplete = false;
            }
        }
        var info = { nowvalue: nowvalue, maxvalue: maxvalue, iscomplete: iscomplete };
        return info;
    };
    return ActivityOpenserverData;
}());
__reflect(ActivityOpenserverData.prototype, "ActivityOpenserverData");
var ActivityOpenserverViewSystem = (function (_super) {
    __extends(ActivityOpenserverViewSystem, _super);
    function ActivityOpenserverViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    ActivityOpenserverViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ActivityOpenserverView");
    };
    ActivityOpenserverViewSystem.inst = new ActivityOpenserverViewSystem("ActivityOpenserverView");
    return ActivityOpenserverViewSystem;
}(ak.FairyGUI));
__reflect(ActivityOpenserverViewSystem.prototype, "ActivityOpenserverViewSystem");
/**
 * 限时活动主界面
 */
var ActivityOpenserverView = (function (_super) {
    __extends(ActivityOpenserverView, _super);
    function ActivityOpenserverView() {
        var _this = _super.call(this, ActivityOpenserverViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.day = 1;
        _this.page = 1;
        _this.infoarr = [];
        return _this;
    }
    /**回调 */
    ActivityOpenserverView.prototype.onInit = function () {
        var ui = this.create("ActivityOpenserverView", "ActivityOpenserverView");
        this.closebtn = ui.getChild("closebtn").asButton;
        this.list = ui.getChild("list").asList;
        this.timetxt = ui.getChild("timetxt").asTextField;
        this.numtxt = ui.getChild("numtxt").asTextField;
        this.day1btn = ui.getChild("day1btn").asButton;
        this.day2btn = ui.getChild("day2btn").asButton;
        this.day3btn = ui.getChild("day3btn").asButton;
        this.day4btn = ui.getChild("day4btn").asButton;
        this.day5btn = ui.getChild("day5btn").asButton;
        this.day6btn = ui.getChild("day6btn").asButton;
        this.day7btn = ui.getChild("day7btn").asLoader;
        this.btn0 = ui.getChild("btn0").asButton;
        this.btn1 = ui.getChild("btn1").asButton;
        this.btn2 = ui.getChild("btn2").asButton;
        this.btn3 = ui.getChild("btn3").asButton;
        this.box0 = ui.getChild("box0").asCom;
        this.box1 = ui.getChild("box1").asCom;
        this.box2 = ui.getChild("box2").asCom;
        this.box3 = ui.getChild("box3").asCom;
        this.box4 = ui.getChild("box4").asCom;
        this.box5 = ui.getChild("box5").asCom;
        this.bar = ui.getChild("bar").asProgress;
        this.item_00num = ui.getChild("item_00num").asCom;
        this.item_01num = ui.getChild("item_01num").asCom;
        this.addbtn0 = ui.getChild("addbtn0").asButton;
        this.addbtn1 = ui.getChild("addbtn1").asButton;
        this.control_c2 = ui.getController("c2");
        this.reddot7 = ui.getChild("reddot7").asImage;
        this.staticdaynum();
        this.ClickAdd();
        this.updateListInfo();
        this.updatedaybtn();
        this.updatebox();
        this.updateTxT();
    };
    ActivityOpenserverView.prototype.ClickAdd = function () {
        this.addClickListener(this.closebtn, this.onClick, this);
        this.addClickListener(this.day1btn, this.onClick, this);
        this.addClickListener(this.day2btn, this.onClick, this);
        this.addClickListener(this.day3btn, this.onClick, this);
        this.addClickListener(this.day4btn, this.onClick, this);
        this.addClickListener(this.day5btn, this.onClick, this);
        this.addClickListener(this.day6btn, this.onClick, this);
        this.addClickListener(this.day7btn, this.onClick, this);
        this.addClickListener(this.btn0, this.onClick, this);
        this.addClickListener(this.btn1, this.onClick, this);
        this.addClickListener(this.btn2, this.onClick, this);
        this.addClickListener(this.btn3, this.onClick, this);
        this.addClickListener(this.box0, this.onClick, this);
        this.addClickListener(this.box1, this.onClick, this);
        this.addClickListener(this.box2, this.onClick, this);
        this.addClickListener(this.box3, this.onClick, this);
        this.addClickListener(this.box4, this.onClick, this);
        this.addClickListener(this.box5, this.onClick, this);
        this.addClickListener(this.addbtn0, this.onClick, this);
        this.addClickListener(this.addbtn1, this.onClick, this);
        this.onFairyguiEvent(this.list, fairygui.ItemEvent.CLICK, this.itemonclick1, this);
    };
    ActivityOpenserverView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.closebtn:
                this.close();
                break;
            case this.day1btn:
                this.day = 1;
                this.updateListInfo();
                break;
            case this.day2btn:
                this.day = 2;
                this.updateListInfo();
                break;
            case this.day3btn:
                this.day = 3;
                this.updateListInfo();
                break;
            case this.day4btn:
                this.day = 4;
                this.updateListInfo();
                break;
            case this.day5btn:
                this.day = 5;
                this.updateListInfo();
                break;
            case this.day6btn:
                this.day = 6;
                this.updateListInfo();
                break;
            case this.day7btn:
                this.day = 7;
                this.updateListInfo();
                break;
            case this.btn0:
                this.page = 1;
                this.updateListInfo();
                break;
            case this.btn1:
                this.page = 2;
                this.updateListInfo();
                break;
            case this.btn2:
                this.page = 3;
                this.updateListInfo();
                break;
            case this.btn3:
                this.page = 4;
                this.updateListInfo();
                break;
            case this.box0:
                this.boxHandle(0);
                break;
            case this.box1:
                this.boxHandle(1);
                break;
            case this.box2:
                this.boxHandle(2);
                break;
            case this.box3:
                this.boxHandle(3);
                break;
            case this.box4:
                this.boxHandle(4);
                break;
            case this.box5:
                this.boxHandle(5);
                break;
            case this.addbtn0:
                ak.FairyGUI.open(["MoneyView"]);
                break;
            case this.addbtn1:
                ak.FairyGUI.open(["RechargeView"]);
                break;
        }
    };
    ActivityOpenserverView.prototype.itemonclick1 = function (obj) {
        var _this = this;
        var item = obj.itemObject;
        var id = item.data.id;
        var vip = item.data.vip;
        /**领取奖励 */
        if (this.hitTestPointWithFairyGUIComponent(item.getChild("btn0").asButton, obj.stageX, obj.stageY)) {
            if (item.getChild("btn0").asButton.touchable == false)
                return;
            //rpc
            if (MyData.user.vip < vip) {
                TipsViewSystem.show("贵族等级不足");
            }
            else {
                net.createUser7DayReward(id, function () {
                    _this.updateListInfo();
                    _this.updateTxT();
                    _this.updatebox();
                }, this);
            }
        }
        /**领取奖励 */
        if (this.hitTestPointWithFairyGUIComponent(item.getChild("btn1").asButton, obj.stageX, obj.stageY)) {
            if (item.getChild("btn1").asButton.touchable == false)
                return;
            //rpc
            if (MyData.user.vip < vip) {
                TipsViewSystem.show("贵族等级不足");
            }
            else {
                net.createUser7DayReward(id, function () {
                    _this.updateListInfo();
                    _this.updateTxT();
                    _this.updatebox();
                }, this);
            }
        }
    };
    ActivityOpenserverView.prototype.updateListInfo = function () {
        //根据day和type去获取列表的数据
        this.infoarr = [];
        this.infoarr = ActivityOpenserverData.inst().getInfobyDayandType(this.day, this.page);
        this.updateList();
        this.redDotshow();
    };
    //点击物品框
    ActivityOpenserverView.prototype.onClickItem = function (e) {
        var item = e.itemObject.data.item;
        if (item[1] == 3)
            ak.FairyGUI.open(["ResourceTipsView", item[2], item[3]]);
        else
            ak.FairyGUI.open(["WeaponTipsView", item[2], item[3], item[1]]);
    };
    ActivityOpenserverView.prototype.updateList = function () {
        this.list.removeChildrenToPool();
        for (var i = 0; i < this.infoarr.length; i++) {
            var item = this.list.addItemFromPool().asCom;
            var title = item.getChild("title").asTextField;
            var list = item.getChild("list").asList;
            var btn0 = item.getChild("btn0").asButton;
            var img = item.getChild("img").asImage;
            var zsnum = item.getChild("zsnum").asTextField;
            var btn1 = item.getChild("btn1").asButton;
            var control_c1 = item.getController("c1");
            var itemarr = ItemMgr.getDropGroupByID(this.infoarr[i].drop);
            list.removeChildrenToPool();
            for (var j = 0; j < itemarr.length; j++) {
                var item_1 = list.addItemFromPool().asCom;
                var items = item_1.getChild("n1").asCom;
                var items0 = new ItemBase(items, this, itemarr[j][1]);
                items0.setItemData(itemarr[j][2]);
                items0.setNumber(itemarr[j][3], true);
                item_1.data = {
                    item: itemarr[j]
                };
            }
            this.onFairyguiEvent(list, fairygui.ItemEvent.CLICK, this.onClickItem, this);
            title.text = "" + this.infoarr[i].name;
            img.visible = false;
            item.data = { id: this.infoarr[i].id, vip: this.infoarr[i].vip };
            //判断类型条件
            if (this.infoarr[i].zs != 0) {
                control_c1.selectedIndex = 1;
                zsnum.text = "" + this.infoarr[i].zs;
                var num = btn1.getChild("num").asTextField;
                num.text = "" + (this.infoarr[i].zs * this.infoarr[i].sales / 10);
            }
            else {
                control_c1.selectedIndex = 0;
            }
            //判断文本条件
            var nowvalue = ActivityOpenserverData.inst().getTaskProgress(this.infoarr[i].id).nowvalue;
            var maxvalue = ActivityOpenserverData.inst().getTaskProgress(this.infoarr[i].id).maxvalue;
            var iscomplete = ActivityOpenserverData.inst().getTaskProgress(this.infoarr[i].id).iscomplete;
            if (this.infoarr[i].type == 2) {
                title.text = "" + this.infoarr[i].name + "(" + nowvalue / 100 + "/" + maxvalue / 100 + ")";
            }
            else {
                title.text = "" + this.infoarr[i].name + "(" + nowvalue + "/" + maxvalue + ")";
            }
            //判断按钮
            if (this.day > Common.getCreateUserDays()) {
                btn0.enabled = false;
                btn1.enabled = false;
                btn0.touchable = false;
                btn1.touchable = false;
                btn0.visible = true;
                btn1.enabled = true;
            }
            else {
                if (iscomplete == true) {
                    btn0.enabled = true;
                    btn1.enabled = true;
                    btn0.touchable = true;
                    btn1.touchable = true;
                }
                else {
                    btn0.enabled = false;
                    btn1.enabled = true;
                    btn0.touchable = false;
                    btn1.touchable = true;
                }
                if (MyData.user.json.createUser7Day.recvMap[this.infoarr[i].id]) {
                    btn0.visible = false;
                    btn1.enabled = false;
                    btn1.touchable = false;
                    img.visible = true;
                }
                else {
                    btn0.visible = true;
                    btn1.enabled = true;
                    btn1.touchable = true;
                    img.visible = false;
                }
            }
        }
    };
    ActivityOpenserverView.prototype.updatedaybtn = function () {
        var loader1 = this.day1btn.getChild("icon").asLoader;
        var loader2 = this.day2btn.getChild("icon").asLoader;
        var loader3 = this.day3btn.getChild("icon").asLoader;
        var loader4 = this.day4btn.getChild("icon").asLoader;
        var loader5 = this.day5btn.getChild("icon").asLoader;
        var loader6 = this.day6btn.getChild("icon").asLoader;
        this.setLoaderUrl(loader1, "ui://ActivityOpenserverView/img_carnival_day1");
        this.setLoaderUrl(loader2, "ui://ActivityOpenserverView/img_carnival_day2");
        this.setLoaderUrl(loader3, "ui://ActivityOpenserverView/img_carnival_day3");
        this.setLoaderUrl(loader4, "ui://ActivityOpenserverView/img_carnival_day4");
        this.setLoaderUrl(loader5, "ui://ActivityOpenserverView/img_carnival_day5");
        this.setLoaderUrl(loader6, "ui://ActivityOpenserverView/img_carnival_day6");
    };
    /**更新箱子状态和进度条 */
    ActivityOpenserverView.prototype.updatebox = function () {
        var progressRecvMap = MyData.user.json.createUser7Day.progressRecvMap;
        this.bar.getChild("title").asTextField.visible = false;
        for (var i = 0; i < 6; i++) {
            var id = i + 1;
            var num = this["box" + i].getChild("num").asTextField;
            var control_c1 = this["box" + i].getController("c1");
            num.text = "" + ActivityOpenserverData.inst().getboxInfobyIndex(i).num;
            this["box" + i].data = { id: id };
            if (i == 0 || i == 1) {
                if (progressRecvMap[id]) {
                    control_c1.selectedIndex = 1;
                }
                else {
                    control_c1.selectedIndex = 0;
                }
            }
            if (i == 2 || i == 3) {
                if (progressRecvMap[id]) {
                    control_c1.selectedIndex = 3;
                }
                else {
                    control_c1.selectedIndex = 2;
                }
            }
            if (i == 4 || i == 5) {
                if (progressRecvMap[id]) {
                    control_c1.selectedIndex = 5;
                }
                else {
                    control_c1.selectedIndex = 4;
                }
            }
        }
        this.bar.value = ActivityOpenserverData.inst().getCompleteTaskNum();
        this.bar.max = ActivityOpenserverData.inst().getboxInfobyIndex(5).num;
    };
    /**更新文本 */
    ActivityOpenserverView.prototype.updateTxT = function () {
        this.timetxt.text = "还有" + (7 - Common.getCreateUserDays()) + "天";
        this.numtxt.text = "" + ActivityOpenserverData.inst().getCompleteTaskNum();
        var icon0 = this.item_00num.getChild("icon").asLoader;
        var number0 = this.item_00num.getChild("number").asTextField;
        var icon1 = this.item_01num.getChild("icon").asLoader;
        var number1 = this.item_01num.getChild("number").asTextField;
        this.setLoaderUrl(icon0, "ui://common/token_jb");
        Common.labelIsOverLenght(number0, MyData.user.money);
        Common.labelIsOverLenght(number1, MyData.user.diamond + MyData.user.diamond2);
    };
    /**箱子的点击 */
    ActivityOpenserverView.prototype.boxHandle = function (index) {
        var _this = this;
        var progressRecvMap = MyData.user.json.createUser7Day.progressRecvMap;
        if (progressRecvMap[index + 1]) {
            ak.FairyGUI.open(["ActivityOpenserverBoxShowView", index]);
        }
        else {
            var nowNum = ActivityOpenserverData.inst().getCompleteTaskNum();
            var boxneedNum = ActivityOpenserverData.inst().getboxInfobyIndex(index).num;
            if (nowNum > boxneedNum) {
                net.createUser7Day(index + 1, function () {
                    _this.updatebox();
                }, this);
            }
            else {
                ak.FairyGUI.open(["ActivityOpenserverBoxShowView", index]);
            }
        }
    };
    /**第一次进系统时候的天数初始化 */
    ActivityOpenserverView.prototype.staticdaynum = function () {
        this.day = 1;
        if ((7 - Common.getCreateUserDays()) >= 0) {
            this.day = Common.getCreateUserDays();
            this.control_c2.selectedIndex = Common.getCreateUserDays() - 1;
        }
    };
    /**内部红点 */
    ActivityOpenserverView.prototype.redDotshow = function () {
        for (var i = 0; i < 7; i++) {
            if (i == 6) {
                this.reddot7.visible = RedDotMgr.sevenDayActivityDaybtnRedDot(i + 1) == 1 ? true : false;
            }
            else {
                this["day" + (i + 1) + "btn"].getController("c1").selectedIndex = RedDotMgr.sevenDayActivityDaybtnRedDot(i + 1);
            }
        }
        for (var i = 0; i < 4; i++) {
            this["btn" + i].getController("red").selectedIndex = RedDotMgr.sevenDayActivityTypebtnRedDot(this.day, i + 1);
        }
    };
    return ActivityOpenserverView;
}(ak.EasyUI));
__reflect(ActivityOpenserverView.prototype, "ActivityOpenserverView");
/**
 * 活动数据
 */
var ActivityData = (function () {
    function ActivityData() {
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    ActivityData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new ActivityData();
        }
        return Class._instance;
    };
    /**根据配表图标位置 获取活动列表数据 */
    ActivityData.prototype.getMainUIactivityData = function (pos) {
        var activityBtnab = ak.JsonTableMgr.get("activityBtn");
        var activity1 = activityBtnab.getRowsFromColName("position", pos);
        //判断该活动是否开启
        var activity2 = [];
        for (var i = 0; i < activity1.length; i++) {
            var id = activity1[i].getValFromColName("id");
            if (this.isOpenView(id)) {
                activity2.push(activity1[i]);
            }
        }
        return activity2.sort(this.GroupSort);
    };
    ActivityData.prototype.GroupSort = function (a, b) {
        var aorder = a.getValFromColName("order");
        var border = b.getValFromColName("order");
        if (aorder > border)
            return 1;
        if (aorder < border)
            return -1;
        return 0;
    };
    /**判断是否开启该活动 */
    ActivityData.prototype.isOpenView = function (id) {
        //7日活动
        if (id == 4) {
            if (Common.getCreateUserDays() > 7) {
                return false;
            }
            else {
                return true;
            }
        }
        //首冲
        if (id == 6) {
            var keys = Object.keys(MyData.user.json.recharge.loginMap);
            var finallength = 0;
            for (var i = 0; i < keys.length; i++) {
                var key = Object.keys(MyData.user.json.recharge.loginMap[keys[i]].rewardMap);
                finallength += key.length;
            }
            if (finallength < 6) {
                return true;
            }
            else {
                return false;
            }
        }
        //每日首冲
        if (id == 5) {
            if (MyData.user.json.recharge.dailyPayReward == 1) {
                return false;
            }
            else {
                return true;
            }
        }
        //限时礼包
        if (id == 8) {
            if (Object.keys(MyData.user.json.limitPackage.buyMap).length == 0) {
                return false;
            }
            else {
                var activityLimitGifttab = ak.JsonTableMgr.get("activityLimitGift");
                for (var i = 0; i < Object.keys(MyData.user.json.limitPackage.buyMap).length; i++) {
                    if (Object.keys(MyData.user.json.limitPackage.buyMap)[i] != null) {
                        var fristKey = Object.keys(MyData.user.json.limitPackage.buyMap)[i];
                        var fristReward = MyData.user.json.limitPackage.buyMap[fristKey];
                        var Rewardtime = fristReward.bt;
                        var activityLimitGiftInfo = activityLimitGifttab.getRowFromColName("id", "" + fristKey);
                        var tabtme = activityLimitGiftInfo.getValFromColName("time");
                        var tablimit = activityLimitGiftInfo.getValFromColName("limit");
                        var time = (new Date().getTime() / 1000) - Rewardtime + MyData.timeBase;
                        // ak.log(time,"这是time");
                        if (time >= tabtme) {
                            if (i == Object.keys(MyData.user.json.limitPackage.buyMap).length - 1) {
                                return false;
                            }
                            else {
                                continue;
                            }
                        }
                        else {
                            //let times = tabtme-time;
                            return true;
                        }
                    }
                }
                /*
                let activityLimitGifttab = ak.JsonTableMgr.get("activityLimitGift");
                let fristKey = Object.keys(MyData.user.json.limitPackage.buyMap)[0];
                let fristReward = MyData.user.json.limitPackage.buyMap[fristKey];
                let Rewardtime = fristReward.bt;
                let activityLimitGiftInfo = activityLimitGifttab.getRowFromColName("id",""+fristKey);
                let tabtme: number = activityLimitGiftInfo.getValFromColName("time");
                let time:number = (new Date().getTime() / 1000) - Rewardtime + MyData.timeBase;
                if(time >= tabtme) {
                    return false;
                } else {
                    ak.log(tabtme-time);
                    return true;
                }*/
            }
        }
        if (id > 100) {
            var infoarr = this.getActivityTimeInfoArr(id);
            for (var i = 0; i < infoarr.length; i++) {
                var startTime = infoarr[i].startTime;
                var endTime = infoarr[i].endTime;
                var type = infoarr[i].type;
                if (startTime.length == 3) {
                    var day = Common.getBeginDays();
                    if (day < startTime[0]) {
                        if (i == infoarr.length - 1) {
                            return false;
                        }
                        else {
                            continue;
                        }
                    }
                    if (day > endTime[0]) {
                        if (i == infoarr.length - 1) {
                            return false;
                        }
                        else {
                            continue;
                        }
                    }
                    if (day == startTime[0]) {
                        var date = new Date(new Date().getTime());
                        var hours = date.getHours();
                        var minute = date.getMinutes();
                        if (hours < startTime[1]) {
                            if (i == infoarr.length - 1) {
                                return false;
                            }
                            else {
                                continue;
                            }
                        }
                        if (hours == startTime[1]) {
                            if (minute < startTime[2]) {
                                if (i == infoarr.length - 1) {
                                    return false;
                                }
                                else {
                                    continue;
                                }
                            }
                        }
                    }
                    if (day == endTime[0]) {
                        var date = new Date(new Date().getTime());
                        var hours = date.getHours();
                        var minute = date.getMinutes();
                        if (hours > endTime[1]) {
                            if (i == infoarr.length - 1) {
                                return false;
                            }
                            else {
                                continue;
                            }
                        }
                        if (hours == endTime[1]) {
                            if (minute > startTime[2]) {
                                if (i == infoarr.length - 1) {
                                    return false;
                                }
                                else {
                                    continue;
                                }
                            }
                        }
                    }
                }
                //0,合服天数,时,分
                if (startTime.length == 4) {
                    var day = Common.getJoinDays();
                    if (day < startTime[1]) {
                        if (i == infoarr.length - 1) {
                            return false;
                        }
                        else {
                            continue;
                        }
                    }
                    if (day > endTime[1]) {
                        if (i == infoarr.length - 1) {
                            return false;
                        }
                        else {
                            continue;
                        }
                    }
                    if (day == startTime[1]) {
                        var date = new Date(new Date().getTime());
                        var hours = date.getHours();
                        var minute = date.getMinutes();
                        if (hours < startTime[2]) {
                            if (i == infoarr.length - 1) {
                                return false;
                            }
                            else {
                                continue;
                            }
                        }
                        if (hours == startTime[2]) {
                            if (minute < startTime[3]) {
                                if (i == infoarr.length - 1) {
                                    return false;
                                }
                                else {
                                    continue;
                                }
                            }
                        }
                    }
                    if (day == endTime[1]) {
                        var date = new Date(new Date().getTime());
                        var hours = date.getHours();
                        var minute = date.getMinutes();
                        if (hours > endTime[2]) {
                            if (i == infoarr.length - 1) {
                                return false;
                            }
                            else {
                                continue;
                            }
                        }
                        if (hours == endTime[2]) {
                            if (minute > startTime[3]) {
                                if (i == infoarr.length - 1) {
                                    return false;
                                }
                                else {
                                    continue;
                                }
                            }
                        }
                    }
                }
                //年,月,日,时,分
                if (startTime.length == 5) {
                    var date = new Date(new Date().getTime());
                    var years = date.getFullYear();
                    var month = date.getMonth();
                    var day = date.getDate();
                    var hours = date.getHours();
                    var minute = date.getMinutes();
                    var datearr = [years, month, day, hours, minute];
                    for (var i_2 = 0; i_2 < datearr.length; i_2++) {
                        if (datearr[i_2] < startTime[i_2]) {
                            if (i_2 == infoarr.length - 1) {
                                return false;
                            }
                            else {
                                break;
                            }
                        }
                    }
                    for (var i_3 = 0; i_3 < datearr.length; i_3++) {
                        if (datearr[i_3] > endTime[i_3]) {
                            if (i_3 == infoarr.length - 1) {
                                return false;
                            }
                            else {
                                break;
                            }
                        }
                    }
                }
                return true;
            }
        }
        return true;
    };
    /**根据id获取活动时间内容 */
    ActivityData.prototype.getActivityTimeInfo = function (id) {
        var activityTimetab = ak.JsonTableMgr.get("activityTime");
        var activityTimeinfo = activityTimetab.getRowFromColName("id", "" + id);
        var startTime = activityTimeinfo.getValFromColName("startTime");
        var endTime = activityTimeinfo.getValFromColName("endTime");
        var type = activityTimeinfo.getValFromColName("type");
        var info = { startTime: startTime, endTime: endTime, type: type };
        return info;
    };
    /**根据id获取活动时间内容组 */
    ActivityData.prototype.getActivityTimeInfoArr = function (id) {
        var infoarr = [];
        var activityTimetab = ak.JsonTableMgr.get("activityTime");
        var activityTimeinfoarr = activityTimetab.getRowsFromColName("id", "" + id);
        for (var i = 0; i < activityTimeinfoarr.length; i++) {
            var startTime = activityTimeinfoarr[i].getValFromColName("startTime");
            var endTime = activityTimeinfoarr[i].getValFromColName("endTime");
            var type = activityTimeinfoarr[i].getValFromColName("type");
            var info = { startTime: startTime, endTime: endTime, type: type };
            infoarr.push(info);
        }
        return infoarr;
    };
    /**限时奖励da */
    ActivityData.prototype.activityLimitTime = function () {
        if (Object.keys(MyData.user.json.limitPackage.buyMap).length == 0)
            return 0;
        var activityLimitGifttab = ak.JsonTableMgr.get("activityLimitGift");
        for (var i = 0; i < Object.keys(MyData.user.json.limitPackage.buyMap).length; i++) {
            var fristKey = Object.keys(MyData.user.json.limitPackage.buyMap)[i];
            var fristReward = MyData.user.json.limitPackage.buyMap[fristKey];
            var Rewardtime = fristReward.bt;
            var activityLimitGiftInfo = activityLimitGifttab.getRowFromColName("id", "" + fristKey);
            var tabtme = activityLimitGiftInfo.getValFromColName("time");
            var time = (new Date().getTime() / 1000) - Rewardtime + MyData.timeBase;
            if (time >= tabtme) {
                if (i == Object.keys(MyData.user.json.limitPackage.buyMap).length - 1) {
                    return 0;
                }
                else {
                    continue;
                }
            }
            else {
                var times = tabtme - time;
                return times;
            }
        }
    };
    /**设置活动ID */
    ActivityData.prototype.setActivityID = function (id) {
        this.activityID = id;
    };
    /**获取活动ID */
    ActivityData.prototype.getActivityID = function () {
        return this.activityID;
    };
    return ActivityData;
}());
__reflect(ActivityData.prototype, "ActivityData");
var ActivityCommonViewSystem = (function (_super) {
    __extends(ActivityCommonViewSystem, _super);
    function ActivityCommonViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    ActivityCommonViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ActivityCommonView");
    };
    ActivityCommonViewSystem.inst = new ActivityCommonViewSystem("ActivityCommonView");
    return ActivityCommonViewSystem;
}(ak.FairyGUI));
__reflect(ActivityCommonViewSystem.prototype, "ActivityCommonViewSystem");
/**
 * 限时活动主界面
 */
var ActivityCommonView = (function (_super) {
    __extends(ActivityCommonView, _super);
    function ActivityCommonView(viewName) {
        var _this = _super.call(this, ActivityCommonViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.LimitGiftInfo = []; //限时礼包长度
        _this.ActivityTypeView = []; //活动类型View
        _this.viewName = viewName;
        return _this;
    }
    /**回调 */
    ActivityCommonView.prototype.onInit = function () {
        this.ActivityTypeView[1] = "SuperFundView"; //超级基金
        this.ActivityTypeView[2] = "ActivityLimitGiftView"; //限时礼包
        var ui = this.create("ActivityCommonView", "ActivityCommonView");
        this.closebtn = ui.getChild("closebtn").asButton;
        var zsBar = ui.getChild("zsBar").asCom;
        this.item_00num = zsBar.getChild("item_00num").asCom;
        this.item_01num = zsBar.getChild("item_01num").asCom;
        this.addbtn0 = zsBar.getChild("addbtn0").asButton;
        this.addbtn1 = zsBar.getChild("addbtn1").asButton;
        this.titlelist = ui.getChild("titlelist").asList;
        this.ViewStack = this.ui.getChild("ViewStack").asGraph;
        this.superFundTab = ak.JsonTableMgr.get("superFund");
        this.activitygiftTab = ak.JsonTableMgr.get("activityLimitGift");
        // this.ViewStack.touchable = false
        this.ClickAdd();
        this.updateList();
        this.staticView();
    };
    ActivityCommonView.prototype.ClickAdd = function () {
        this.addClickListener(this.closebtn, this.onClick, this);
        this.addClickListener(this.addbtn0, this.onClick, this);
        this.addClickListener(this.addbtn1, this.onClick, this);
        this.onFairyguiEvent(this.titlelist, fairygui.ItemEvent.CLICK, this.itemonclick, this);
        this.on("netmsg://rechargeDataResult", this.updateNum, this);
    };
    ActivityCommonView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.closebtn:
                this.close();
                break;
            case this.addbtn0:
                ak.FairyGUI.open(["MoneyView"]);
                break;
            case this.addbtn1:
                ak.FairyGUI.open(["RechargeView"]);
                break;
        }
    };
    ActivityCommonView.prototype.itemonclick = function (e) {
        var btn = e.itemObject;
        if (this.viewName == this.ActivityTypeView[1]) {
            SuperFundData.inst().setViewType(btn.data.id);
            ak.EventMgr.dispatch(GameEvent.changeSuperFundView);
        }
        else if (this.viewName == this.ActivityTypeView[2]) {
            ActivityLimitGiftData.inst().setViewType(btn.data.index);
            ak.EventMgr.dispatch(GameEvent.changeLimitGiftView);
        }
        else {
            ak.FairyGUI.open([this.viewName, this.ViewStack]);
        }
    };
    ActivityCommonView.prototype.staticView = function () {
        //打开第一个界面
        this.openFristView();
        //更新文本
        this.updateNum();
    };
    /**更新文本 */
    ActivityCommonView.prototype.updateNum = function () {
        var icon0 = this.item_00num.getChild("icon").asLoader;
        var number0 = this.item_00num.getChild("number").asTextField;
        var number1 = this.item_01num.getChild("number").asTextField;
        this.setLoaderUrl(icon0, "ui://common/token_jb");
        Common.labelIsOverLenght(number0, MyData.user.money);
        Common.labelIsOverLenght(number1, MyData.user.diamond + MyData.user.diamond2);
    };
    /**打开第一个界面 */
    ActivityCommonView.prototype.openFristView = function () {
        if (this.LimitGiftInfo.length <= 0 && this.viewName == this.ActivityTypeView[2])
            return;
        var item = this.titlelist.getChildAt(0);
        item.selected = true;
        ActivityLimitGiftData.inst().setViewType(item.data.index);
        ak.FairyGUI.open([this.viewName, this.ViewStack]);
    };
    /**更新列表 */
    ActivityCommonView.prototype.updateList = function () {
        this.titlelist.removeChildrenToPool();
        if (this.viewName == this.ActivityTypeView[1]) {
            for (var i = 0; i < this.superFundTab.size(); i++) {
                var btn = this.titlelist.addItemFromPool().asCom;
                var superFundInfo = this.superFundTab.getRow(i);
                var id = superFundInfo.getValFromColName("id");
                var title = superFundInfo.getValFromColName("title");
                btn.data = { id: id };
                var iconUrl = ["ui://ActivityCommonView/ico_128jijin", "ui://ActivityCommonView/ico_328jijin"];
                btn.getChild("itemname").asTextField.text = title;
                this.setLoaderUrl(btn.getChild("icon").asLoader, iconUrl[i]);
            }
        }
        else if (this.viewName == this.ActivityTypeView[2]) {
            if (MyData.user.json.limitPackage.buyMap != null) {
                var index = new Array();
                var arr = ActivityLimitGiftData.inst().getArray();
                var arrCount = arr.length;
                for (var i = 0; i < arrCount; i++) {
                    index = arr[i];
                    if (index != 0) {
                        this.LimitGiftInfo[i] = i;
                        var Info = this.activitygiftTab.getRow(index - 1);
                        var iconres = Info.getValFromColName("icon");
                        var text = Info.getValFromColName("name");
                        var btn = this.titlelist.addItemFromPool().asCom;
                        var icon = btn.getChild("icon").asLoader;
                        var icontext = btn.getChild("itemname").asTextField;
                        var btn_list = [];
                        btn_list["index"] = index;
                        btn.data = btn_list;
                        iconres = 'ui://ActivityCommonView/' + iconres;
                        this.setLoaderUrl(icon, iconres);
                        icontext.text = text;
                    }
                }
            }
        }
    };
    return ActivityCommonView;
}(ak.EasyUI));
__reflect(ActivityCommonView.prototype, "ActivityCommonView");
//限时召唤系统
var ActivityLimitTimeSummonViewSystem = (function (_super) {
    __extends(ActivityLimitTimeSummonViewSystem, _super);
    function ActivityLimitTimeSummonViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    ActivityLimitTimeSummonViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ActivityLimitTimeSummonView");
    };
    ActivityLimitTimeSummonViewSystem.inst = new ActivityLimitTimeSummonViewSystem("ActivityLimitTimeSummonView");
    return ActivityLimitTimeSummonViewSystem;
}(ak.FairyGUI));
__reflect(ActivityLimitTimeSummonViewSystem.prototype, "ActivityLimitTimeSummonViewSystem");
//限时召唤界面
var ActivityLimitTimeSummonView = (function (_super) {
    __extends(ActivityLimitTimeSummonView, _super);
    function ActivityLimitTimeSummonView() {
        var _this = _super.call(this, ActivityLimitTimeSummonViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.heroCom = [];
        return _this;
    }
    /**回调 */
    ActivityLimitTimeSummonView.prototype.onInit = function () {
        this.create("ActivityLimitTimeSummonView", "ActivityLimitTimeSummonView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.heroGraph = this.ui.getChild("heroLongGu").asGraph;
        this.timeText = this.ui.getChild("timeText").asTextField;
        this.btn_lingqu = this.ui.getChild("btn_lingqu").asButton;
        this.limitSummonInfo = ak.JsonTableMgr.get("activityCreateRoleHero").getRow(0);
        var heroStarLevel = this.ui.getChild("heroStarLevel").asCom;
        this.gotoMonthCard = this.ui.getChild("gotoMonthCard").asCom;
        heroStarLevel.getController("star").selectedIndex = 5;
        for (var i = 0; i < 3; i++) {
            this.heroCom[i] = this.ui.getChild("heroCom" + i).asCom;
        }
        this.ClickAdd();
        this.updateView();
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.timeDown, this);
    };
    ActivityLimitTimeSummonView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        for (var i = 0; i < this.heroCom.length; i++) {
            var itemCom = this.heroCom[i].getChild("hero").asCom;
            this.addClickListener(itemCom, this.onClickHeroCom, this);
        }
        this.addClickListener(this.gotoMonthCard, this.onClick, this);
        this.addClickListener(this.btn_lingqu, this.onClick, this);
    };
    ActivityLimitTimeSummonView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.btn_lingqu:
                net.getHeroActivityReward(4, this.close, this);
                break;
            case this.gotoMonthCard:
                ActivityWonderfulCommonData.inst().setOpenFristView(1);
                ak.FairyGUI.open(["ActivityWonderfulView"]);
                break;
        }
    };
    ActivityLimitTimeSummonView.prototype.onClickHeroCom = function (e) {
        var HeroActivity = MyData.user.json.getHeroActivity;
        var itemData = e.target.data;
        if (HeroActivity["reward" + itemData.type] == 0 && HeroActivity["sign" + itemData.type] == 1) {
            net.getHeroActivityReward(e.target.data.type, this.updateView, this);
        }
        else if (HeroActivity["sign" + itemData.type] == 0) {
            TipsViewSystem.show("领取条件未满足");
        }
        else {
            TipsViewSystem.show("奖励已领取");
        }
    };
    ActivityLimitTimeSummonView.prototype.updateView = function () {
        var heroId = this.limitSummonInfo.getValFromColName("heroID");
        this.showLonggu(heroId);
        var HeroActivity = MyData.user.json.getHeroActivity;
        for (var i = 1; i <= this.heroCom.length; i++) {
            var heroID = this.limitSummonInfo.getValFromColName("heroID" + i);
            var con = this.limitSummonInfo.getValFromColName("con" + i);
            var heroCom = this.heroCom[i - 1];
            var itemCom = heroCom.getChild("hero").asCom;
            this.flushHeroCom(itemCom, heroID);
            itemCom.data = { type: i };
            var sign = HeroActivity["sign" + i];
            var reward = HeroActivity["reward" + i];
            var str = "";
            if (i == 1) {
                var color = sign > 0 ? Color.green : Color.white;
                str = sign > 0 ? "[color=" + color + "]\u5DF2\u8FBE\u6210[/color]" : "[color=" + color + "]\u901A\u5173" + MyData.user.barrierID + "/" + con + "\u5173[/color]";
            }
            else if (i == 2) {
                var color = sign > 0 ? Color.green : Color.white;
                str = sign > 0 ? "[color=" + color + "]\u5DF2\u8FBE\u6210[/color]" : "[color=" + color + "]\u767B\u9646" + MyData.user.loginDays + "/" + con + "\u5929[/color]";
            }
            else if (i == 3) {
                var color = sign > 0 ? Color.green : Color.white;
                str = sign > 0 ? "[color=" + color + "]\u5DF2\u8FBE\u6210[/color]" : "[color=" + color + "]\u6FC0\u6D3B\u81F3\u5C0A\u6708\u5361[/color]";
            }
            heroCom.getChild("text").asTextField.text = str;
            heroCom.getChild("red_point").asImage.visible = sign > 0 && reward != 1;
            heroCom.getController("isBuy").selectedIndex = reward;
        }
        this.ui.getController("c1").selectedIndex = HeroActivity.reward1 == 1 && HeroActivity.reward2 == 1 && HeroActivity.reward3 == 1 && HeroActivity.reward4 == 0 ? 1 : 0;
    };
    //龙骨显示
    ActivityLimitTimeSummonView.prototype.showLonggu = function (heroID) {
        var objectContainer = new egret.DisplayObjectContainer(); //显示对象容器
        this.heroGraph.setNativeObject(objectContainer);
        var hero = new Hero(heroID).addToParent(objectContainer);
        hero.touchEnabled = true;
        this.onEgretEvent(hero, egret.TouchEvent.TOUCH_TAP, function () {
            hero.setAction("atk");
        }, this);
        hero.x = 150;
        hero.y = 370;
    };
    ActivityLimitTimeSummonView.prototype.flushHeroCom = function (heroCom, heroID) {
        var itemBase = new ItemBase(heroCom, this, 2);
        itemBase.setItemData(heroID, HeroBagData.inst().GetRaceById(heroID), HeroBagData.inst().GetStarById(heroID));
    };
    ActivityLimitTimeSummonView.prototype.timeDown = function () {
        var createRoleTime = DateUtils.formatStrTimeToS(MyData.user.genTime) / 1000;
        var activityTime = createRoleTime + this.limitSummonInfo.getValFromColName("time");
        var now = ak.time() + MyData.timeBase;
        var residueTime = activityTime - now;
        if (residueTime <= 0) {
            this.timeText.text = "";
            return;
        }
        else {
            this.timeText.text = "\u6D3B\u52A8\u5012\u8BA1\u65F6: " + DateUtils.getFormatBySecond(residueTime, DateUtils.TIME_FORMAT_1);
        }
    };
    return ActivityLimitTimeSummonView;
}(ak.EasyUI));
__reflect(ActivityLimitTimeSummonView.prototype, "ActivityLimitTimeSummonView");
var ActivityTimeViewSystem = (function (_super) {
    __extends(ActivityTimeViewSystem, _super);
    function ActivityTimeViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    ActivityTimeViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ActivityTimeView");
    };
    ActivityTimeViewSystem.inst = new ActivityTimeViewSystem("ActivityTimeView");
    return ActivityTimeViewSystem;
}(ak.FairyGUI));
__reflect(ActivityTimeViewSystem.prototype, "ActivityTimeViewSystem");
/**
 * 限时活动主界面
 */
var ActivityTimeView = (function (_super) {
    __extends(ActivityTimeView, _super);
    function ActivityTimeView() {
        var _this = _super.call(this, ActivityTimeViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.activityInfo = [];
        return _this;
    }
    /**回调 */
    ActivityTimeView.prototype.onInit = function () {
        var ui = this.create("ActivityTimeView", "ActivityTimeView");
        this.closebtn = ui.getChild("closebtn").asButton;
        var zsBar = ui.getChild("zsBar").asCom;
        this.item_00num = zsBar.getChild("item_00num").asCom;
        this.item_01num = zsBar.getChild("item_01num").asCom;
        var icon0 = this.item_00num.getChild("icon").asLoader;
        this.number0 = this.item_00num.getChild("number").asTextField;
        this.number1 = this.item_01num.getChild("number").asTextField;
        this.addbtn0 = zsBar.getChild("addbtn0").asButton;
        this.addbtn1 = zsBar.getChild("addbtn1").asButton;
        this.setLoaderUrl(icon0, "ui://common/token_jb");
        this.titlelist = ui.getChild("titlelist").asList;
        this.ViewStack = this.ui.getChild("ViewStack").asGraph;
        this.ClickAdd();
        this.updateListInfo();
        this.staticView();
    };
    ActivityTimeView.prototype.ClickAdd = function () {
        this.addClickListener(this.closebtn, this.onClick, this);
        this.addClickListener(this.addbtn0, this.onClick, this);
        this.addClickListener(this.addbtn1, this.onClick, this);
        this.on(GameEvent.flushLimitActMoneyZs, this.updateNum, this);
        this.on(GameEvent.flushLimitActRedPoint, this.updateList, this);
        this.on("netmsg://rechargeDataResult", this.updateNum, this);
        this.onFairyguiEvent(this.titlelist, fairygui.ItemEvent.CLICK, this.itemonclick, this);
    };
    ActivityTimeView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.closebtn:
                this.close();
                break;
            case this.addbtn0:
                ak.FairyGUI.open(["MoneyView"]);
                break;
            case this.addbtn1:
                ak.FairyGUI.open(["RechargeView"]);
                break;
        }
    };
    ActivityTimeView.prototype.itemonclick = function (e) {
        var viewData = e.itemObject.data;
        if (viewData.jump[0] == "ActivityMonthcardView") {
            ActivityMonthcardData.inst().setViewType(viewData.jump[1]);
        }
        ActivityWonderfulCommonData.inst().setViewTypeAndID(viewData.jump[1], viewData.id);
        if (ak.FairyGUI.getOpenUI(viewData.jump[0]).length > 0) {
            ak.EventMgr.dispatch(GameEvent.changeWonderfulView);
        }
        else {
            ak.FairyGUI.open([viewData.jump[0], this.ViewStack]);
        }
    };
    ActivityTimeView.prototype.staticView = function () {
        this.updateNum();
        //打开第一个界面
        this.openFristView();
    };
    /**更新文本 */
    ActivityTimeView.prototype.updateNum = function () {
        Common.labelIsOverLenght(this.number0, MyData.user.money);
        Common.labelIsOverLenght(this.number1, MyData.user.diamond + MyData.user.diamond2);
    };
    /**打开第一个界面 */
    ActivityTimeView.prototype.openFristView = function () {
        if (this.activityInfo.length > 0) {
            var item = this.titlelist.getChildAt(0);
            var jump = item.data.jump;
            item.selected = true;
            ActivityWonderfulCommonData.inst().setViewTypeAndID(jump[1], item.data.id);
            ak.FairyGUI.open([jump[0], this.ViewStack]);
        }
    };
    ActivityTimeView.prototype.updateListInfo = function () {
        this.activityInfo = ActivityData.inst().getMainUIactivityData("2");
        this.updateList();
    };
    /**更新列表 */
    ActivityTimeView.prototype.updateList = function () {
        this.titlelist.removeChildrenToPool();
        for (var i = 0; i < this.activityInfo.length; i++) {
            if (i != 1) {
                var jump = this.activityInfo[i].getValFromColName("jump");
                var id = this.activityInfo[i].getValFromColName("id");
                var red = this.activityInfo[i].getValFromColName("red");
                var com = this.activityInfo[i].getValFromColName("com");
                var name_17 = this.activityInfo[i].getValFromColName("name");
                var position = this.activityInfo[i].getValFromColName("position");
                var item = this.titlelist.addItemFromPool().asCom;
                item.getChild("itemname").asTextField.text = name_17;
                this.setLoaderUrl(item.getChild("icon").asLoader, com);
                item.data = { jump: jump, id: id, red: red, position: position };
                item.getController("red").selectedIndex = RedDotMgr.activityListBtnTimeRedDot(jump[1], id) ? 1 : 0;
            }
        }
    };
    return ActivityTimeView;
}(ak.EasyUI));
__reflect(ActivityTimeView.prototype, "ActivityTimeView");
//数据
var ActivityMonthcardData = (function () {
    function ActivityMonthcardData() {
    }
    ActivityMonthcardData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new ActivityMonthcardData();
        }
        return Class._instance;
    };
    ActivityMonthcardData.prototype.getViewType = function () {
        return this.viewType;
    };
    ActivityMonthcardData.prototype.setViewType = function (type) {
        this.viewType = type;
    };
    ActivityMonthcardData.prototype.isSmallTimerOver = function () {
        var timerOver = false;
        if (MyData.user.json.monthCard.smallCardBeginDate != '') {
            var time = ak.time() + MyData.timeBase; //获取当前时间
            var smallCardtime = MyData.user.json.monthCard.smallCardBeginDate; //小月卡开始日期
            if (time - (DateUtils.formatStrTimeToYMD(smallCardtime) / 1000) > 2592000) {
                timerOver = true;
            }
            else {
                timerOver = false;
            }
        }
        return timerOver;
    };
    ActivityMonthcardData.prototype.isBigTimerOver = function () {
        var timerOver = false;
        if (MyData.user.json.monthCard.bigCardBeginDate != '') {
            var time = ak.time() + MyData.timeBase; //获取当前时间
            var bigCardtime = MyData.user.json.monthCard.bigCardBeginDate; //大月卡开始日期
            if (time - (DateUtils.formatStrTimeToYMD(bigCardtime) / 1000) > 2592000) {
                timerOver = true;
            }
            else {
                timerOver = false;
            }
        }
        return timerOver;
    };
    return ActivityMonthcardData;
}());
__reflect(ActivityMonthcardData.prototype, "ActivityMonthcardData");
//月卡
var ActivityMonthcardSystem = (function (_super) {
    __extends(ActivityMonthcardSystem, _super);
    function ActivityMonthcardSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    ActivityMonthcardSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ActivityMonthcard");
    };
    ActivityMonthcardSystem.inst = new ActivityMonthcardSystem("ActivityMonthcard");
    return ActivityMonthcardSystem;
}(ak.FairyGUI));
__reflect(ActivityMonthcardSystem.prototype, "ActivityMonthcardSystem");
var ActivityMonthcardView = (function (_super) {
    __extends(ActivityMonthcardView, _super);
    function ActivityMonthcardView(stackView) {
        var _this = _super.call(this, ActivityMonthcardSystem.inst, stackView) || this;
        _this.residueDay = 0; //限时活动剩余活动天数
        return _this;
    }
    ;
    ActivityMonthcardView.prototype.onInit = function () {
        var ui = this.create("ActivityMonthcard", "ActivityMonthcardView");
        this.recharge = ui.getChild("recharge").asButton;
        this.bar = ui.getChild("n4").asProgress;
        this.monthcardTab = ak.JsonTableMgr.get("activityMonthCard");
        this.desText = this.ui.getChild("desText").asTextField;
        this.timeText = this.ui.getChild("timeText").asTextField;
        this.on("netmsg://rechargeDataResult", this.updateView, this);
        this.on(GameEvent.changeWonderfulView, this.updateView, this);
        this.clickAdd();
        this.updateView();
    };
    ActivityMonthcardView.prototype.clickAdd = function () {
        this.on(GameEvent.changeWonderfulView, this.updateView, this);
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.timeDown, this);
        this.addClickListener(this.recharge, this.onClick, this);
    };
    ActivityMonthcardView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.recharge:
                ak.FairyGUI.open(["RechargeView"]);
                break;
        }
    };
    ActivityMonthcardView.prototype.updateView = function () {
        var Type = ActivityMonthcardData.inst().getViewType(); //月卡类型:0:超值月卡 1：至尊月卡 2：限时掉落 
        this.ui.getController("c1").selectedIndex = Type;
        if (Type == 0 || Type == 1) {
            var Info = this.monthcardTab.getRow(Type);
            var Money = Info.getValFromColName("money");
            var ZS = Info.getValFromColName("zs"); //钻石
            this.bar.max = Money / 100;
            if (Type == 0) {
                this.bar.value = MyData.user.json.monthCard.smallCardRMBTotal / 100;
                this.isTimeOver = ActivityMonthcardData.inst().isSmallTimerOver();
                this.recharge.visible = MyData.user.json.monthCard.smallCardBeginDate != '' && !this.isTimeOver ? false : true;
                if (!this.recharge.visible) {
                    this.bar.value = this.bar.max;
                }
                ;
                if (this.recharge.visible == true) {
                    this.desText.text = "任意累计充值到达" + Money / 100 + "元 即可激活";
                }
                else {
                    this.desText.text = "已激活超值月卡," + "剩余" + (30 - MyData.user.json.monthCard.smallCardGetCount) + "天";
                }
                //每日领取钻石
                this.ui.getChild("n18").asTextField.text = "" + ZS;
                //共返还钻石
                this.ui.getChild("n17").asTextField.text = "" + (ZS * 30);
            }
            else {
                this.bar.value = MyData.user.json.monthCard.bigCardRMBTotal / 100;
                this.isTimeOver = ActivityMonthcardData.inst().isBigTimerOver();
                this.recharge.visible = MyData.user.json.monthCard.bigCardBeginDate != '' && !this.isTimeOver ? false : true;
                if (!this.recharge.visible) {
                    this.bar.value = this.bar.max;
                }
                ;
                if (this.recharge.visible == true) {
                    this.desText.text = "任意累计充值到达" + Money / 100 + "元 即可激活";
                }
                else {
                    this.desText.text = "已激活至尊月卡," + "剩余" + (30 - MyData.user.json.monthCard.bigCardGetCount) + "天";
                }
                //每日领取钻石
                this.ui.getChild("n20").asTextField.text = "" + ZS;
                //共返还钻石
                this.ui.getChild("n19").asTextField.text = "" + (ZS * 30);
            }
        }
        else {
            var actId = ActivityWonderfulCommonData.inst().getViewTypeAndID(Type);
            var actTab = ActivityWonderfulCommonData.inst().getConfigByActId(actId);
            var actInfo = actTab.getRow(0);
            var item = actInfo.getValFromColName("item");
            var itemCount = Common.overLength(SummonData.inst().GetItemnumByid(item));
            this.desText.text = "拥有数量：" + itemCount;
            var info = ActivityData.inst().getActivityTimeInfo(actId);
            var endTime = info.endTime;
            var startTime = info.startTime;
            var totalOpenDay = endTime[0] - startTime[0];
            this.residueDay = totalOpenDay - Common.getBeginDays();
            ; //活动剩余天数 = 活动开启天数 - 开服天数
        }
    };
    ActivityMonthcardView.prototype.timeDown = function () {
        var viewtype = ActivityMonthcardData.inst().getViewType(); //界面类型
        if (viewtype == 2) {
            if (this.residueDay > 0) {
                this.timeText.text = this.residueDay + "\u5929";
            }
            else if (this.residueDay == 0) {
                var passTime = DateUtils.getTodayPassedSecond(); //经过时间
                var residueTime = (86400 - passTime) + MyData.timeBase;
                this.timeText.text = residueTime > 0 ? "" + DateUtils.getFormatBySecond(residueTime, DateUtils.TIME_FORMAT_1) : "";
            }
            else {
                this.timeText.text = "";
                return;
            }
        }
        else {
            this.timeText.text = "";
            return;
        }
    };
    return ActivityMonthcardView;
}(ak.EasyUI));
__reflect(ActivityMonthcardView.prototype, "ActivityMonthcardView");
//签到
var ActivitySginSystem = (function (_super) {
    __extends(ActivitySginSystem, _super);
    function ActivitySginSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    ActivitySginSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ActivitySignView");
    };
    ActivitySginSystem.inst = new ActivitySginSystem("ActivitySignView");
    return ActivitySginSystem;
}(ak.FairyGUI));
__reflect(ActivitySginSystem.prototype, "ActivitySginSystem");
var ActivitySignView = (function (_super) {
    __extends(ActivitySignView, _super);
    function ActivitySignView(ViewStack) {
        return _super.call(this, ActivitySginSystem.inst, ViewStack) || this;
    }
    ActivitySignView.prototype.onInit = function () {
        var ui = this.create("ActivitySignView", "ActivitySignView");
        this.signBtn = this.ui.getChild("n4").asButton;
        this.signday = this.ui.getChild("n5").asTextField;
        this.signlist = this.ui.getChild("n6").asList;
        this.clickAdd();
        this.showlist();
    };
    ActivitySignView.prototype.clickAdd = function () {
        this.addClickListener(this.signBtn, this.Onclick, this);
        this.onFairyguiEvent(this.signlist, fairygui.ItemEvent.CLICK, this.showdetails, this);
    };
    ActivitySignView.prototype.Onclick = function (e) {
        switch (e.target) {
            case this.signBtn:
                this.issignIn();
                break;
        }
    };
    //列表内容
    ActivitySignView.prototype.showlist = function () {
        this.ui.getController("c1").selectedIndex = RedDotMgr.sginRedDot();
        var signin = MyData.user.json.signIn; //获取签到列表
        var itemArr = signin.resArr; //表内容赋予
        var count = itemArr.length;
        this.signlist.removeChildrenToPool();
        this.showLonggu(34014);
        var loginDay = MyData.user.loginDays;
        var signday = MyData.user.json.signIn.signInCount;
        var bigmooth = 0; //大于一个月的登录天数
        if ((loginDay - signday) > (30 - (signday % 30))) {
            bigmooth = loginDay - signday;
        }
        for (var i = 0; i < count; i++) {
            var info = itemArr[i];
            var itemID = info.id;
            var itemNum = info.num;
            var itemType = info.type;
            var signinFrame = this.signlist.addItemFromPool().asCom;
            var item0 = signinFrame.getChild("n0").asCom;
            var item0_list = []; //物品详情所需数据
            item0_list["index"] = itemID;
            item0_list["num"] = itemNum;
            item0_list["itemtype"] = itemType;
            item0.data = item0_list;
            var itemBase = new ItemBase(item0, this, itemType);
            itemBase.setItemData(Number(itemID));
            itemBase.setNumber(itemNum, true);
            itemBase.setGou(false);
            itemBase.isshowLight(false);
            signinFrame.getController("isSgin").selectedIndex = 0;
            this.signBtn.enabled = MyData.user.loginDays > MyData.user.json.signIn.signInCount;
            if (loginDay > 30 || signday > 30 || signday % 30 == 0) {
                signday = signday % count;
            }
            if (loginDay % count == 0 && loginDay >= 30) {
                loginDay = 30;
            }
            else {
                loginDay = loginDay % count;
            }
            if (signday - 1 >= i) {
                itemBase.setGou(true);
                signinFrame.getController("isSgin").selectedIndex = 0;
            }
            var value = bigmooth > 0 ? (bigmooth + signday) : loginDay;
            if (this.signBtn.enabled == true && i < value && i > signday - 1) {
                signinFrame.getController("isSgin").selectedIndex = 1;
                itemBase.isshowLight(true);
            }
        }
        this.signday.text = '累计登陆：' + signday + '/' + count;
        this.signBtn.getChild("title").asTextField.text = "签到";
    };
    ActivitySignView.prototype.showdetails = function (obj) {
        var item = obj.itemObject;
        var itemCom = item.getChild("n0").asCom;
        if (this.hitTestPointWithFairyGUIComponent(itemCom, obj.stageX, obj.stageY)) {
            if (itemCom.data.itemtype != 3)
                ak.FairyGUI.open(["WeaponTipsView", itemCom.data.index, itemCom.data.num, 1]);
            else
                ak.FairyGUI.open(["ResourceTipsView", itemCom.data.index, itemCom.data.num]);
        }
    };
    ActivitySignView.prototype.issignIn = function () {
        net.signIn(this.showlist, this); //签到
    };
    ActivitySignView.prototype.showLonggu = function (heroID) {
        var tt = new egret.DisplayObjectContainer();
        var temp = this.ui.getChild("longgu").asGraph;
        temp.setNativeObject(tt);
        var hero = new Hero(heroID).addToParent(tt);
        hero.x = 110;
        hero.y = 170;
        hero.scaleSkin(0.8, 0.8);
    };
    return ActivitySignView;
}(ak.EasyUI));
__reflect(ActivitySignView.prototype, "ActivitySignView");
//数据
var ActivityWonderfulCommonData = (function () {
    function ActivityWonderfulCommonData() {
        this.viewTypeActivityID = []; //存储
        this.viewIndex = 0;
    }
    ActivityWonderfulCommonData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new ActivityWonderfulCommonData();
        }
        return Class._instance;
    };
    ActivityWonderfulCommonData.prototype.getViewType = function () {
        return this.viewType;
    };
    //设置活动类型和ID
    ActivityWonderfulCommonData.prototype.setViewTypeAndID = function (type, activityId) {
        this.viewType = type;
        this.viewTypeActivityID[type] = activityId;
    };
    //根据类型获取活动ID
    ActivityWonderfulCommonData.prototype.getViewTypeAndID = function (type) {
        return this.viewTypeActivityID[type];
    };
    //根据活动ID获取活动配置
    ActivityWonderfulCommonData.prototype.getConfigByActId = function (activityid) {
        var activityTimeTab = ak.JsonTableMgr.get("activityTime");
        var activityTimeInfo = activityTimeTab.getRowFromColName("id", activityid);
        var activityType = activityTimeInfo.getValFromColName("type");
        var activityTypeTab = ak.JsonTableMgr.get("activity" + activityType);
        return activityTypeTab;
    };
    //获取首次打开活动界面index
    ActivityWonderfulCommonData.prototype.getOpenFristView = function () {
        return this.viewIndex;
    };
    //获取首次打开活动界面index
    ActivityWonderfulCommonData.prototype.setOpenFristView = function (viewIndex) {
        this.viewIndex = viewIndex;
    };
    return ActivityWonderfulCommonData;
}());
__reflect(ActivityWonderfulCommonData.prototype, "ActivityWonderfulCommonData");
//精彩活动 通用界面
var ActivityWonderfulCommonViewSystem = (function (_super) {
    __extends(ActivityWonderfulCommonViewSystem, _super);
    function ActivityWonderfulCommonViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    ActivityWonderfulCommonViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ActivityWonderfulCommonView");
    };
    ActivityWonderfulCommonViewSystem.inst = new ActivityWonderfulCommonViewSystem("ActivityWonderfulCommonView");
    return ActivityWonderfulCommonViewSystem;
}(ak.FairyGUI));
__reflect(ActivityWonderfulCommonViewSystem.prototype, "ActivityWonderfulCommonViewSystem");
var ActivityWonderfulCommonView = (function (_super) {
    __extends(ActivityWonderfulCommonView, _super);
    function ActivityWonderfulCommonView(stackView) {
        var _this = _super.call(this, ActivityWonderfulCommonViewSystem.inst, stackView) || this;
        _this.actClientCfg = [
            /*0等级礼包*/ { longGuId: 31085, loadItemIndex: [], text: "" },
            /*1每周福利*/ { longGuId: 45013, loadItemIndex: [], text: "" },
            /*2每月福利*/ { longGuId: 22025, loadItemIndex: [], text: "" },
            /*3限时兑换*/ { longGuId: 43023, loadItemIndex: [], text: "开服7天，探险挂机将限时掉落马戏团奖券，可以兑换丰厚奖励哦，别错过哦！" },
            /*4积天返利*/ { longGuId: 21014, loadItemIndex: [], text: "在活动时间段内，连续充值（单笔最低6元以上才算累计1天，0点重置）天数达到以下条件即可领取超值大礼，机不可失哟！" },
            /*5超值礼包*/ { longGuId: 21046, loadItemIndex: [], text: "活动期间超值折扣道具限量出售，任意充值都可获得对应的档位的VIP积分" },
            /*6累计充值*/ { longGuId: 31045, loadItemIndex: [], text: "开服豪礼，今日累计充值达到指定额度即可领取超值奖励，大量古书残页，超神英雄任你选！（购买任意礼包均可累计充值额度）" },
            /*7远征统帅*/ { longGuId: 31076, loadItemIndex: [], text: "" },
            /*8赏金奇兵*/ { longGuId: 11085, loadItemIndex: [], text: "" },
            /*9开服冲级*/ { longGuId: 11085, loadItemIndex: [], text: "活动期间，玩家等级达到对应的档次，即可领取对应的奖励。" },
            /*10单笔充值*/ { longGuId: 11085, loadItemIndex: [], text: "" },
            /*11登录领奖*/ { longGuId: 11085, loadItemIndex: [], text: "" },
            /*12累计消费*/ { longGuId: 11085, loadItemIndex: [], text: "" },
            /*13探险先锋*/ { longGuId: 11085, loadItemIndex: [], text: "" },
            /*14累充豪礼*/ { longGuId: 11085, loadItemIndex: [], text: "" },
            /*15英雄升星*/ { longGuId: 11085, loadItemIndex: [], text: "" }
        ];
        return _this;
    }
    ActivityWonderfulCommonView.prototype.onInit = function () {
        var ui = this.create("ActivityWonderfulCommonView", "ActivityWonderfulCommonView");
        this.commonlist = ui.getChild("commonlist").asList;
        this.levelBtn = ui.getChild("levelBtn").asButton;
        this.activityBenefitWeekTab = ak.JsonTableMgr.get("activityBenefitWeek");
        this.activityBenefitMonthTab = ak.JsonTableMgr.get("activityBenefitMonth");
        this.activityPlayerLevelTab = ak.JsonTableMgr.get("activityPlayerLevel");
        this.activityPlayerLevelConfigTab = ak.JsonTableMgr.get("activityPlayerLevelConfig");
        this.actText = ui.getChild("actText").asTextField;
        this.itemNum = ui.getChild("itemNum").asTextField;
        this.timeText = ui.getChild("timeText").asTextField;
        this.longgu = ui.getChild("longgu").asGraph;
        this.iconLoader = ui.getChild("iconLoader").asLoader;
        this.c1Controller = ui.getController("c1");
        this.on("netmsg://rechargeDataResult", this.updateView, this);
        this.on(GameEvent.changeWonderfulView, this.updateView, this);
        this.onFairyguiEvent(this.commonlist, fairygui.ItemEvent.CLICK, this.itemonclick, this);
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.timeDown, this);
        this.ClickAdd();
        this.updateView();
    };
    ActivityWonderfulCommonView.prototype.onDestroy = function () {
        this.actClientCfg = null;
    };
    ActivityWonderfulCommonView.prototype.ClickAdd = function () {
        this.addClickListener(this.levelBtn, this.onClick, this);
    };
    ActivityWonderfulCommonView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.levelBtn:
                var info = this.activityPlayerLevelConfigTab.getRow(0);
                var payID = info.getValFromColName("pay");
                net.genPayOrder(payID);
        }
    };
    ActivityWonderfulCommonView.prototype.itemonclick = function (e) {
        var _this = this;
        var Item = e.itemObject;
        var btnConvert = Item.getChild("btnConvert").asButton;
        var lingquBtn = Item.getChild("lingquBtn").asButton;
        if (this.hitTestPointWithFairyGUIComponent(btnConvert, e.stageX, e.stageY)) {
            net.activityType3(btnConvert.data.id, function () {
                ak.EventMgr.dispatch(GameEvent.flushLimitActMoneyZs);
                _this.updateView();
            }, this);
        }
        else if (this.hitTestPointWithFairyGUIComponent(lingquBtn, e.stageX, e.stageY)) {
            var viewtype = ActivityWonderfulCommonData.inst().getViewType();
            if (viewtype == 9 && lingquBtn.enabled == true) {
                net.activityType1(lingquBtn.data.id, function () {
                    net.get_type1(_this.updateView, _this);
                    ak.EventMgr.dispatch(GameEvent.flushLimitActRedPoint);
                    ak.EventMgr.dispatch(GameEvent.flushLimitActMoneyZs);
                }, this);
            }
            else if (viewtype == 0 && lingquBtn.enabled == true) {
                net.levelFundGetReward(lingquBtn.data.id, this.updateView, this); //等级基金领奖
            }
            else if (viewtype == 1 && lingquBtn.enabled == true) {
                net.genPayOrder(lingquBtn.data.pay);
            }
            else if (viewtype == 2 && lingquBtn.enabled == true) {
                net.genPayOrder(lingquBtn.data.pay);
            }
            else if (viewtype == 4 && lingquBtn.enabled == true) {
                net.activityType4(lingquBtn.data.id, function () {
                    ak.EventMgr.dispatch(GameEvent.flushLimitActRedPoint);
                    ak.EventMgr.dispatch(GameEvent.flushLimitActMoneyZs);
                    _this.updateView();
                }, this);
            }
            else if (viewtype == 5) {
                if (lingquBtn.data.buyCount > 0) {
                    net.genPayOrder(lingquBtn.data.pay);
                }
                else {
                    TipsViewSystem.show("剩余购买次数不足");
                }
            }
            else if (viewtype == 6 && lingquBtn.enabled == true) {
                net.activityType6(lingquBtn.data.id, function () {
                    ak.EventMgr.dispatch(GameEvent.flushLimitActRedPoint);
                    ak.EventMgr.dispatch(GameEvent.flushLimitActMoneyZs);
                    _this.updateView();
                }, this);
            }
        }
    };
    //参数1.表格 2.列表 3.this
    ActivityWonderfulCommonView.prototype.showlist = function (Tab, list_parm, map) {
        if (map === void 0) { map = null; }
        list_parm.removeChildrenToPool();
        var viewtype = ActivityWonderfulCommonData.inst().getViewType();
        var count = Tab.size();
        for (var i = 0; i < count; i++) {
            var list = list_parm.addItemFromPool().asCom;
            var list_award = list.getChild("award").asList;
            var title = list.getChild("title").asTextField;
            var zhetext = list.getChild("zhetext").asTextField;
            var cishu = list.getChild("cishu").asTextField;
            var itembutton = list.getChild("lingquBtn").asButton;
            var jindutiao = list.getChild("n15").asProgress;
            var buttontext = itembutton.getChild("title").asTextField;
            var Info = Tab.getRow(i);
            var btnTypeController = list.getController("btnType");
            var redController = list.getController("red");
            redController.selectedIndex = 0;
            btnTypeController.selectedIndex = 0;
            if (viewtype == 0) {
                var activityPlayerLevelConfigTab = ak.JsonTableMgr.get("activityPlayerLevelConfig");
                var activityPlayerLevelConfigRow = activityPlayerLevelConfigTab.getRow(0);
                //显示领取多少钻石
                this.ui.getChild("n25").asTextField.text = "" + activityPlayerLevelConfigRow.getValFromColName("diamond");
                //显示百分之多少返利
                this.ui.getChild("n26").asTextField.text = "" + activityPlayerLevelConfigRow.getValFromColName("percent");
                title.visible = true;
                list.getController("zhe").selectedIndex = 0;
                list.getController("c2").selectedIndex = 1;
                var id = Info.getValFromColName("id");
                var level = Info.getValFromColName("level");
                title.text = "等级达到" + level + "级";
                buttontext.text = "领取";
                jindutiao.value = MyData.user.level;
                jindutiao.max = level;
                redController.selectedIndex = RedDotMgr.levelRedDot(jindutiao.value, jindutiao.max);
                if (MyData.user.json.recharge.levelFundBuySign != 1) {
                    itembutton.enabled = false;
                }
                else {
                    itembutton.enabled = MyData.user.level >= level ? true : false;
                    // btnTypeController.selectedIndex = itembutton.enabled ? 0:1;
                }
                var isChoose = MyData.user.json.recharge.levelFundMap[id] || 0;
                if (isChoose > 0) {
                    itembutton.enabled = false;
                    btnTypeController.selectedIndex = 1;
                    redController.selectedIndex = 0;
                }
                list_award.removeChildrenToPool();
                var itemCom = list_award.addItemFromPool().asCom;
                var item_id = 3;
                var item_count = Info.getValFromColName("zs");
                var item_type = 3;
                this.flushtem(itemCom, 3, item_count, item_type);
                var item1_list = [];
                item1_list["id"] = id;
                itembutton.data = item1_list;
            }
            else {
                title.visible = false;
                list.getController("zhe").selectedIndex = 1;
                list.getController("c2").selectedIndex = 0;
                var id = Info.getValFromColName("id");
                var payid = Info.getValFromColName("pay");
                var drop = Info.getValFromColName("drop");
                var limit = Info.getValFromColName("limit");
                var sales = Info.getValFromColName("sales");
                var buyCount = map[id] || 0;
                buttontext.text = (Common.getMoneyByPayID(payid)).toString() + '元';
                zhetext.text = sales + "折";
                cishu.text = "剩余：" + (limit - buyCount);
                itembutton.enabled = limit - buyCount > 0 ? true : false;
                cishu.visible = limit - buyCount > 0 ? true : false;
                btnTypeController.selectedIndex = itembutton.enabled ? 0 : 2;
                list_award.removeChildrenToPool();
                var item_Cfg01 = ItemMgr.getDropGroupByID(Number(drop));
                this.flushListItem(item_Cfg01, list_award);
                var item1_list = [];
                item1_list["pay"] = payid;
                itembutton.data = item1_list;
            }
        }
    };
    ActivityWonderfulCommonView.prototype.updateView = function () {
        this.flushTime();
        var actTypeId = ActivityData.inst().getActivityID(); //活动类型ID：2：精彩活动 3：限时活动
        var viewtype = ActivityWonderfulCommonData.inst().getViewType(); //界面类型
        this.c1Controller.selectedIndex = viewtype + 1;
        this.showLonggu(this.actClientCfg[viewtype].longGuId);
        if (actTypeId == 2) {
            if (viewtype == 0) {
                if (MyData.user.json.recharge.levelFundBuySign != 0) {
                    this.levelBtn.visible = false;
                }
                this.showlist(this.activityPlayerLevelTab, this.commonlist);
            }
            else if (viewtype == 1) {
                this.showlist(this.activityBenefitWeekTab, this.commonlist, MyData.user.json.welfare.weekMap);
                var day = Common.getWeekDays();
                this.timeText.text = "还有" + day + "天";
            }
            else if (viewtype == 2) {
                this.showlist(this.activityBenefitMonthTab, this.commonlist, MyData.user.json.welfare.monthMap);
                var day = Common.getMonthDay();
                this.timeText.text = "还有" + day + "天";
            }
        }
        else if (actTypeId == 3) {
            this.actText.text = this.actClientCfg[viewtype].text;
            var actId = ActivityWonderfulCommonData.inst().getViewTypeAndID(viewtype);
            var actTab = ActivityWonderfulCommonData.inst().getConfigByActId(actId);
            this.commonlist.removeChildrenToPool();
            var actTabLength = actTab.size();
            var limitActivity = MyData.user.json.limitActivity;
            if (viewtype == 3) {
                var actInfo = actTab.getRow(0);
                var itemCost = actInfo.getValFromColName("itemCost");
                var itemCount = Common.overLength(SummonData.inst().GetItemnumByid(itemCost));
                this.itemNum.text = itemCount.toString();
            }
            if (viewtype == 6) {
                for (var i = 0; i < actTabLength; i++) {
                    var actInfo = actTab.getRow(i);
                    if (actInfo.getValFromColName("activityID") == actId) {
                        var Item = this.commonlist.addItemFromPool().asCom;
                        var lingquBtn = Item.getChild("lingquBtn").asButton;
                        var title = Item.getChild("title").asTextField;
                        var btnTitle = lingquBtn.getChild("title").asTextField;
                        var cishu = Item.getChild("cishu").asTextField;
                        var btnTypeController = Item.getController("btnType");
                        var money = actInfo.getValFromColName("money") / 100;
                        var exchangeMap = limitActivity.map_type6[actId] != null ? limitActivity.map_type6[actId].exchangeMap : [];
                        var rmb = limitActivity.map_type6[actId] != null ? limitActivity.map_type6[actId].rmb / 100 : 0;
                        btnTitle.text = "领取";
                        var color = rmb >= money ? Color.green : Color.red;
                        title.text = "[color=" + color + "]\u7D2F\u8BA1\u5145\u503C" + money + "\u5143(" + rmb + "/" + money + ")[/color]";
                        ;
                        cishu.text = "";
                        var id = actInfo.getValFromColName("id");
                        lingquBtn.data = { id: id };
                        lingquBtn.enabled = rmb >= money;
                        btnTypeController.selectedIndex = exchangeMap[id] != null ? 1 : 0;
                        Item.getController("red").selectedIndex = (rmb >= money && exchangeMap[id] == null) ? 1 : 0;
                        var drop = actInfo.getValFromColName("drop");
                        var item_Cfg = ItemMgr.getDropGroupByID(drop);
                        this.flushListItem(item_Cfg, Item.getChild("award").asList);
                    }
                }
            }
            else {
                for (var i = 0; i < actTabLength; i++) {
                    var actInfo = actTab.getRow(i);
                    if (actId != actInfo.getValFromColName("activityID")) {
                        continue;
                    }
                    var Item = this.commonlist.addItemFromPool().asCom;
                    var title = Item.getChild("title").asTextField;
                    var lingquBtn = Item.getChild("lingquBtn").asButton;
                    var cishu = Item.getChild("cishu").asTextField;
                    var btnTitle = lingquBtn.getChild("title").asTextField;
                    var zheController = Item.getController("zhe");
                    var itemTypeController = Item.getController("itemType");
                    var btnTypeController = Item.getController("btnType");
                    zheController.selectedIndex = 0;
                    itemTypeController.selectedIndex = 0;
                    btnTypeController.selectedIndex = 0;
                    Item.getController("red").selectedIndex = 0;
                    lingquBtn.enabled = true;
                    var btnConvert = Item.getChild("btnConvert").asButton;
                    if (viewtype == 3) {
                        itemTypeController.selectedIndex = 1;
                        var id = actInfo.getValFromColName("id");
                        var limit = actInfo.getValFromColName("limit");
                        var numCost = actInfo.getValFromColName("numCost");
                        var itemCost = actInfo.getValFromColName("itemCost");
                        var consumeItem = Item.getChild("consumeItem").asCom;
                        var convertItem = Item.getChild("convertItem").asCom;
                        var exchangeMap = limitActivity.map_type3[actId] != null ? limitActivity.map_type3[actId].exchangeMap : [];
                        Item.getChild("residueText").asTextField.text = "剩余: " + (limit - (exchangeMap[id] || 0));
                        var drop = actInfo.getValFromColName("drop");
                        var item_Cfg = ItemMgr.getDropGroupByID(drop);
                        var item_type = item_Cfg[0][1];
                        var item_id = item_Cfg[0][2];
                        var item_count = item_Cfg[0][3];
                        this.flushtem(convertItem, item_id, item_count, item_type);
                        this.flushtem(consumeItem, itemCost, numCost, 1);
                        btnConvert.getChild("title").asTextField.text = "兑换";
                        btnConvert.data = { id: id };
                        this.setLoaderUrl(this.iconLoader, "item_" + itemCost + "_png");
                    }
                    else if (viewtype == 4) {
                        var payMap = limitActivity.map_type4[actId] != null ? limitActivity.map_type4[actId].payMap : [];
                        var exchangeMap = limitActivity.map_type4[actId] != null ? limitActivity.map_type4[actId].exchangeMap : [];
                        var rechargeday = Object.keys(payMap).length;
                        var id = actInfo.getValFromColName("id");
                        var day = actInfo.getValFromColName("day");
                        var color = rechargeday >= day ? Color.green : Color.red;
                        title.text = "[color=" + color + "]\u7D2F\u8BA1\u5145\u503C" + day + "\u5929(" + rechargeday + "/" + day + ")[/color]";
                        cishu.text = "";
                        btnTitle.text = "领取";
                        lingquBtn.data = { id: id };
                        btnTypeController.selectedIndex = exchangeMap[id] != null ? 1 : 0;
                        lingquBtn.enabled = (rechargeday >= day && exchangeMap[id] == null);
                        Item.getController("red").selectedIndex = (rechargeday >= day && exchangeMap[id] == null) ? 1 : 0;
                    }
                    else if (viewtype == 5) {
                        zheController.selectedIndex = 1;
                        var pay = actInfo.getValFromColName("pay");
                        var id = actInfo.getValFromColName("id");
                        var limit = actInfo.getValFromColName("limit");
                        var sales = actInfo.getValFromColName("sales");
                        Item.getChild("zhetext").asTextField.text = sales + "折";
                        btnTitle.text = Common.getMoneyByPayID(pay) + "元";
                        var exchangeMap = limitActivity.map_type5[actId] != null ? limitActivity.map_type5[actId].exchangeMap : [];
                        var buyCount = limit - (exchangeMap[id] || 0);
                        cishu.text = "[color=" + Color.red + "]\u9650\u8D2D" + buyCount + "\u6B21[/color]";
                        lingquBtn.data = { pay: pay, buyCount: buyCount };
                    }
                    else if (viewtype == 9) {
                        var id = actInfo.getValFromColName("id");
                        var lv = actInfo.getValFromColName("lv");
                        var limit = actInfo.getValFromColName("limit");
                        var color = MyData.user.level >= lv ? Color.green : Color.red;
                        title.text = "[color=" + color + "]\u8FBE\u5230" + lv + "\u7EA7(" + MyData.user.level + "/" + lv + ")[/color]";
                        lingquBtn.data = { id: id };
                        lingquBtn.enabled = MyData.user.level >= lv;
                        btnTitle.text = "领取";
                        var buyMap = (MyData.limitActivity_type1.map[actId] != null) ? MyData.limitActivity_type1.map[actId].buyMap : [];
                        var residueCount = limit - (buyMap[id] || 0);
                        cishu.text = "\u8FD8\u5269" + residueCount + "\u4EFD";
                        var exchangeMap = limitActivity.map_type1[actId] != null ? limitActivity.map_type1[actId].exchangeMap : [];
                        btnTypeController.selectedIndex = exchangeMap[id] != null ? 1 : 0;
                        Item.getController("red").selectedIndex = (MyData.user.level >= lv && residueCount > 0 && exchangeMap[id] == null) ? 1 : 0;
                    }
                    if (viewtype != 3) {
                        var drop = actInfo.getValFromColName("drop");
                        var item_Cfg = ItemMgr.getDropGroupByID(drop);
                        this.flushListItem(item_Cfg, Item.getChild("award").asList);
                    }
                }
            }
        }
    };
    //刷新列表道具物品
    ActivityWonderfulCommonView.prototype.flushListItem = function (itemlist_cfg, ListItem) {
        ListItem.removeChildrenToPool();
        for (var j = 0; j < itemlist_cfg.length; j++) {
            var item_type = itemlist_cfg[j][1];
            var item_id = itemlist_cfg[j][2];
            var item_count = itemlist_cfg[j][3];
            this.flushtem(ListItem.addItemFromPool().asCom, item_id, item_count, item_type);
        }
        this.onFairyguiEvent(ListItem, fairygui.ItemEvent.CLICK, this.onClickItem, this);
    };
    //刷新道具物品
    ActivityWonderfulCommonView.prototype.flushtem = function (itemCom, item_id, item_count, item_type) {
        var itemBase = new ItemBase(itemCom, this, item_type);
        itemBase.clear2();
        itemBase = new ItemBase(itemCom, this, item_type);
        itemBase.setItemData(Number(item_id));
        itemBase.setNumber(item_count, true);
        itemCom.data = { item_id: item_id, item_count: item_count, item_type: item_type };
    };
    //点击物品框
    ActivityWonderfulCommonView.prototype.onClickItem = function (e) {
        var itemData = e.itemObject.data;
        if (itemData.item_type == 3)
            ak.FairyGUI.open(["ResourceTipsView", itemData.item_id, itemData.item_count]);
        else
            ak.FairyGUI.open(["WeaponTipsView", itemData.item_id, itemData.item_count, itemData.item_type]);
    };
    //显示龙骨
    ActivityWonderfulCommonView.prototype.showLonggu = function (heroID) {
        if (!this.heroNode) {
            this.heroNode = new egret.DisplayObjectContainer();
            this.ui.getChild("longgu").asGraph.setNativeObject(this.heroNode);
        }
        this.heroNode.removeChildren();
        // let tt = new egret.DisplayObjectContainer();
        // this.longgu.setNativeObject(this.heroNode);
        var hero = new Hero(heroID).addToParent(this.heroNode);
        hero.x = 110;
        hero.y = 170;
    };
    ActivityWonderfulCommonView.prototype.flushTime = function () {
        var viewtype = ActivityWonderfulCommonData.inst().getViewType(); //界面类型
        var actId = ActivityWonderfulCommonData.inst().getViewTypeAndID(viewtype);
        var limitActivity = MyData.user.json.limitActivity;
        if (viewtype == 9 || viewtype == 3 || viewtype == 4 || viewtype == 5 || viewtype == 6) {
            var info = ActivityData.inst().getActivityTimeInfo(actId);
            var endTime = info.endTime;
            var startTime = info.startTime;
            this.totalOpenDay = endTime[0] - startTime[0];
        }
        else {
            this.timeText.text = "";
            return;
        }
    };
    ActivityWonderfulCommonView.prototype.timeDown = function () {
        if (this.totalOpenDay == null) {
            return;
        }
        var day = Common.getBeginDays();
        var viewtype = ActivityWonderfulCommonData.inst().getViewType(); //界面类型
        var residueDay = viewtype == 6 ? 0 : this.totalOpenDay - day;
        if (residueDay > 0) {
            this.timeText.text = "\u8FD8\u6709" + residueDay + "\u5929";
        }
        else if (residueDay == 0) {
            var passTime = DateUtils.getTodayPassedSecond(); //经过时间
            var residueTime = (86400 - passTime) + MyData.timeBase;
            this.timeText.text = residueTime > 0 ? "\u7ED3\u675F:" + DateUtils.getFormatBySecond(residueTime, DateUtils.TIME_FORMAT_1) : "";
        }
        else {
            this.timeText.text = "";
            return;
        }
    };
    return ActivityWonderfulCommonView;
}(ak.EasyUI));
__reflect(ActivityWonderfulCommonView.prototype, "ActivityWonderfulCommonView");
var ActivityWonderfulViewSystem = (function (_super) {
    __extends(ActivityWonderfulViewSystem, _super);
    function ActivityWonderfulViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    ActivityWonderfulViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ActivityWonderfulView");
    };
    ActivityWonderfulViewSystem.inst = new ActivityWonderfulViewSystem("ActivityWonderfulView");
    return ActivityWonderfulViewSystem;
}(ak.FairyGUI));
__reflect(ActivityWonderfulViewSystem.prototype, "ActivityWonderfulViewSystem");
/**
 * 限时活动主界面
 */
var ActivityWonderfulView = (function (_super) {
    __extends(ActivityWonderfulView, _super);
    function ActivityWonderfulView() {
        return _super.call(this, ActivityWonderfulViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
    }
    /**回调 */
    ActivityWonderfulView.prototype.onInit = function () {
        var _this = this;
        var ui = this.create("ActivityWonderfulView", "ActivityWonderfulView");
        this.closebtn = ui.getChild("closebtn").asButton;
        var zsBar = ui.getChild("zsBar").asCom;
        this.item_00num = zsBar.getChild("item_00num").asCom;
        this.item_01num = zsBar.getChild("item_01num").asCom;
        this.addbtn0 = zsBar.getChild("addbtn0").asButton;
        this.addbtn1 = zsBar.getChild("addbtn1").asButton;
        this.titlelist = ui.getChild("titlelist").asList;
        this.ViewStack = this.ui.getChild("ViewStack").asGraph;
        this.ViewStack2 = this.ui.getChild("ViewStack2").asGraph;
        this.ViewStack3 = this.ui.getChild("ViewStack3").asGraph;
        var icon0 = this.item_00num.getChild("icon").asLoader;
        this.number0 = this.item_00num.getChild("number").asTextField;
        var icon1 = this.item_01num.getChild("icon").asLoader;
        this.number1 = this.item_01num.getChild("number").asTextField;
        this.setLoaderUrl(icon0, "ui://common/token_jb");
        this.on("netmsg://signInDataResult", this.openFristView, this);
        //资源数据返回
        this.on("netmsg://resourceResult", function () {
            var param = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                param[_i] = arguments[_i];
            }
            _this.updateNum();
        }, this);
        this.ClickAdd();
        this.updateList();
        this.staticView();
    };
    ActivityWonderfulView.prototype.ClickAdd = function () {
        this.addClickListener(this.closebtn, this.onClick, this);
        this.addClickListener(this.addbtn0, this.onClick, this);
        this.addClickListener(this.addbtn1, this.onClick, this);
        this.onFairyguiEvent(this.titlelist, fairygui.ItemEvent.CLICK, this.itemonclick, this);
    };
    ActivityWonderfulView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.closebtn:
                this.close();
                break;
            case this.addbtn0:
                ak.FairyGUI.open(["MoneyView"]);
                break;
            case this.addbtn1:
                ak.FairyGUI.open(["RechargeView"]);
                break;
        }
    };
    ActivityWonderfulView.prototype.itemonclick = function (e) {
        this.ViewStack.visible = false;
        this.ViewStack2.visible = false;
        this.ViewStack3.visible = false;
        var itemData = e.itemObject.data;
        if (itemData.index == 0) {
            this.ViewStack3.visible = true;
            ak.FairyGUI.open(["ActivitySignView", this.ViewStack3]);
        }
        else if (itemData.index <= 2 && itemData.index > 0) {
            ActivityMonthcardData.inst().setViewType(itemData.viewType);
            this.ViewStack2.visible = true;
            if (ak.FairyGUI.getOpenUI("ActivityMonthcardView").length > 0) {
                ak.EventMgr.dispatch(GameEvent.changeWonderfulView);
            }
            else {
                ak.FairyGUI.open(["ActivityMonthcardView", this.ViewStack2]);
            }
        }
        else if (itemData.index > 2) {
            this.ViewStack.visible = true;
            ActivityWonderfulCommonData.inst().setViewTypeAndID(itemData.viewType, null);
            if (ak.FairyGUI.getOpenUI("ActivityWonderfulCommonView").length > 0) {
                ak.EventMgr.dispatch(GameEvent.changeWonderfulView);
            }
            else {
                ak.FairyGUI.open(["ActivityWonderfulCommonView", this.ViewStack]);
            }
        }
    };
    ActivityWonderfulView.prototype.staticView = function () {
        //打开第一个界面
        this.openFristView();
        //更新文本
        this.updateNum();
    };
    /**更新文本 */
    ActivityWonderfulView.prototype.updateNum = function () {
        Common.labelIsOverLenght(this.number0, MyData.user.money);
        Common.labelIsOverLenght(this.number1, MyData.user.diamond + MyData.user.diamond2);
    };
    /**打开第一个界面 */
    ActivityWonderfulView.prototype.openFristView = function () {
        this.ViewStack2.visible = false;
        var index = ActivityWonderfulCommonData.inst().getOpenFristView();
        var item = this.titlelist.getChildAt(index);
        item.selected = true;
        if (index != 0) {
            var oneitem = this.titlelist.getChildAt(0);
            oneitem.getController("red").selectedIndex = RedDotMgr.sginRedDot();
        }
        else {
            item.getController("red").selectedIndex = RedDotMgr.sginRedDot();
        }
        if (index == 0) {
            this.ViewStack3.visible = true;
            ak.FairyGUI.open(["ActivitySignView", this.ViewStack3]);
        }
        else if (index <= 2 && index > 0) {
            this.ViewStack2.visible = true;
            ak.FairyGUI.open(["ActivityMonthcardView", this.ViewStack2]);
            ActivityMonthcardData.inst().setViewType(item.data.viewType);
        }
        else if (index > 2) {
            this.ViewStack.visible = true;
            ActivityWonderfulCommonData.inst().setViewTypeAndID(item.data.viewType, null);
            ak.FairyGUI.open(["ActivityWonderfulCommonView", this.ViewStack]);
        }
    };
    /**更新列表 */
    ActivityWonderfulView.prototype.updateList = function () {
        this.titlelist.removeChildrenToPool();
        var actBtnCfg = [
            /*0*/ { iconUrl: 'ico_event_sign', btnText: "登录奖励", viewType: null },
            /*1*/ { iconUrl: 'ico_event_card1', btnText: "超值月卡", viewType: 0 },
            /*2*/ { iconUrl: 'ico_event_card2', btnText: "至尊月卡", viewType: 1 },
            /*3*/ { iconUrl: 'ico_event_lvfund', btnText: "等级基金", viewType: 0 },
            /*4*/ { iconUrl: 'ico_event_weekgift', btnText: "每周福利", viewType: 1 },
            /*5*/ { iconUrl: 'ico_event_monthgift', btnText: "每月福利", viewType: 2 }
        ];
        for (var i = 0; i < 6; i++) {
            var item = this.titlelist.addItemFromPool().asCom;
            var itemicon = item.getChild("icon").asLoader;
            var itemtext = item.getChild("itemname").asTextField;
            this.setLoaderUrl(itemicon, 'ui://ActivityWonderfulView/' + actBtnCfg[i].iconUrl);
            itemtext.text = actBtnCfg[i].btnText;
            item.data = { index: i, viewType: actBtnCfg[i].viewType };
        }
    };
    return ActivityWonderfulView;
}(ak.EasyUI));
__reflect(ActivityWonderfulView.prototype, "ActivityWonderfulView");
var Arena1ViewSystem = (function (_super) {
    __extends(Arena1ViewSystem, _super);
    function Arena1ViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    Arena1ViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ArenaView");
    };
    Arena1ViewSystem.inst = new Arena1ViewSystem("ArenaView");
    return Arena1ViewSystem;
}(ak.FairyGUI));
__reflect(Arena1ViewSystem.prototype, "Arena1ViewSystem");
/**
 * 竞技场自由竞技场界面
 */
var Arena1View = (function (_super) {
    __extends(Arena1View, _super);
    function Arena1View() {
        var _this = _super.call(this, Arena1ViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
        _this.box_list = [];
        return _this;
    }
    /**回调 */
    Arena1View.prototype.onInit = function () {
        var ui = this.create("ArenaView", "Arena1View");
        this.closebtn = ui.getChild("closebtn").asButton;
        this.leftbtn = ui.getChild("tab").asCom.getChild("leftbtn").asButton;
        this.rightbtn = ui.getChild("tab").asCom.getChild("rightbtn").asButton;
        this.updatebtn = ui.getChild("updatebtn").asButton;
        this.tipbtn = ui.getChild("tipbtn").asButton;
        this.addbtn = ui.getChild("addbtn").asButton;
        this.jingjibtn = ui.getChild("jingjibtn").asButton;
        this.jilvbtn = ui.getChild("jilvbtn").asButton;
        this.fangshoubtn = ui.getChild("fangshoubtn").asButton;
        this.rank = ui.getChild("rank").asTextField;
        this.jifen = ui.getChild("jifen").asTextField;
        this.itemnum = ui.getChild("itemnum").asTextField;
        this.timetxt = ui.getChild("timetxt").asTextField;
        this.changenum = ui.getChild("changenum").asTextField;
        this.power = ui.getChild("power").asTextField;
        for (var i = 0; i <= 6; i++) {
            this.box_list.push(ui.getChild("box" + i).asCom);
        }
        this.itemCom = ui.getChild("itemCom").asCom;
        this.list = ui.getChild("list").asList;
        this.list2 = ui.getChild("list2").asList;
        this.control_c1 = ui.getController("c1");
        this.progress = ui.getChild("n32").asProgress;
        this.progress.getChild("title").asTextField.visible = false;
        this.arenaConfigInfo = ak.JsonTableMgr.get("arenaConfig").getRow(0);
        this.Arena_ItemID = this.arenaConfigInfo.getValFromColName("item");
        this.arenaPrizeWeekTab = ak.JsonTableMgr.get("arenaPrizeWeek");
        this.on("netmsg://playerDataResult", this.onFlushRolePower, this);
        this.on(GameEvent.arenaBuyTicket, this.onFlushTicketCount, this);
        this.on(GameEvent.fightRpcComplete, this.updateList, this);
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.timeDown, this);
        this.ClickAdd();
        this.staticView();
        this.updateList();
    };
    //销毁回调
    Arena1View.prototype.onDestroy = function () {
        this.loadBtnUpFlush = null;
    };
    Arena1View.prototype.ClickAdd = function () {
        this.addClickListener(this.closebtn, this.onClick, this);
        this.addClickListener(this.leftbtn, this.onClick, this);
        this.addClickListener(this.rightbtn, this.onClick, this);
        this.addClickListener(this.updatebtn, this.onClick, this);
        this.addClickListener(this.tipbtn, this.onClick, this);
        this.addClickListener(this.addbtn, this.onClick, this);
        this.addClickListener(this.jingjibtn, this.onClick, this);
        this.addClickListener(this.jilvbtn, this.onClick, this);
        this.addClickListener(this.fangshoubtn, this.onClick, this);
        for (var i = 0; i < this.box_list.length; i++) {
            this.addClickListener(this.box_list[i], this.boxClick, this);
        }
        this.onFairyguiEvent(this.list, fairygui.ItemEvent.CLICK, this.onClickItem, this);
        this.onFairyguiEvent(this.list2, fairygui.ItemEvent.CLICK, this.onClickItem, this);
    };
    Arena1View.prototype.onClick = function (e) {
        switch (e.target) {
            case this.closebtn:
                this.close();
                break;
            case this.leftbtn:
                this.control_c1.selectedIndex = 0;
                net.randomEnemy(this.onFlushList1, this);
                break;
            case this.rightbtn:
                this.control_c1.selectedIndex = 1;
                net.stageRank(this.updateList2, this);
                break;
            case this.updatebtn:
                net.randomEnemy(this.onFlushList1, this);
                this.delay_time = new Date().getTime() + 3000;
                if (this.loadBtnUpFlush == null) {
                    this.loadBtnUpFlush = true;
                    this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.flushBtntimeDown, this);
                }
                break;
            case this.tipbtn:
                ak.FairyGUI.open(["HelpTipsView", 7]);
                break;
            case this.addbtn:
                var item_id = BagData.inst().GetIconById(this.Arena_ItemID);
                var item_color = BagData.inst().GetColorById(this.Arena_ItemID);
                var item_name = BagData.inst().GetNameById(this.Arena_ItemID);
                var item_consume_price = this.arenaConfigInfo.getValFromColName("zs");
                ak.FairyGUI.open(["BuyTipsView", item_id, item_color, item_name, item_consume_price, 2]);
                break;
            case this.jingjibtn:
                ak.FairyGUI.open(["RewardView"]);
                break;
            case this.jilvbtn:
                ak.FairyGUI.open(["FightRecordView"]);
                break;
            case this.fangshoubtn:
                ak.FairyGUI.open(["FightReadyView", 5]);
                break;
        }
    };
    Arena1View.prototype.boxClick = function (e) {
        var _this = this;
        var btn_data = e.target.data;
        if (MyData.user.json.stage.battleCountWeek >= btn_data.battleCount && btn_data.is_lingqu == false)
            net.getBattleCountReward(btn_data.battleCount, function () { _this.onFlushBattleCountBox(); }, this);
        else
            ak.FairyGUI.open(["RewardShowView", btn_data.item_drop]);
    };
    Arena1View.prototype.staticView = function () {
        this.leftbtn.getChild("title").asTextField.text = "自由竞技场";
        this.rightbtn.getChild("title").asTextField.text = "排行榜";
        this.onFlushHeadItem(this.itemCom, MyData.user.head, MyData.user.level);
    };
    //刷新角色战力
    Arena1View.prototype.onFlushRolePower = function () {
        this.power.text = MyData.user.battlePower;
    };
    //刷新挑战券数量
    Arena1View.prototype.onFlushTicketCount = function () {
        this.itemnum.text = "" + SummonData.inst().GetItemnumByid(this.Arena_ItemID);
    };
    //刷新个人竞技数据回调
    Arena1View.prototype.onFlushSingeArenaData = function (role_arena_data) {
        this.rank.text = role_arena_data[1][0];
        this.jifen.text = role_arena_data[1][1];
        net.randomEnemy(this.onFlushList1, this);
    };
    //刷新头像
    Arena1View.prototype.onFlushHeadItem = function (headIconCom, head_id, role_lv) {
        var items = new ItemBase(headIconCom, this, 2);
        items.setIcons2("hero" + head_id);
        items.setNumber(role_lv.toString(), true);
    };
    //刷新竞技场对手
    Arena1View.prototype.onFlushList1 = function (player_list) {
        this.list.removeChildrenToPool();
        for (var i = 0; i < player_list[1].length; i++) {
            var rank_item = this.list.addItemFromPool().asCom;
            var player_data = player_list[1][i];
            this.onFlushHeadItem(rank_item.getChild("itemCom").asCom, player_data.head, player_data.level);
            var fightbtn = rank_item.getChild("fightbtn").asButton;
            var battleCountToday = MyData.user.json.stage.battleCountToday;
            var need_item_count = (this.arenaConfigInfo.getValFromColName("free") - battleCountToday > 0) ? 0 : this.arenaConfigInfo.getValFromColName("num"); //挑战卷数量
            fightbtn.getChild("number").asTextField.text = need_item_count;
            fightbtn.getChild("number").asTextField.color = SummonData.inst().GetItemnumByid(this.Arena_ItemID) >= need_item_count ? Color.white : Color.red;
            rank_item.getChild("username").asTextField.text = player_data.nickname;
            rank_item.getChild("power").asTextField.text = player_data.battlePower;
            rank_item.getChild("jifen").asTextField.text = player_data.score;
            rank_item.data = player_data;
        }
    };
    //刷新挑战次数宝箱
    Arena1View.prototype.onFlushBattleCountBox = function () {
        var battleCountRewardMap = MyData.user.json.stage.battleCountRewardMap;
        var battleCountWeek = MyData.user.json.stage.battleCountWeek;
        for (var i = 0; i < this.box_list.length; i++) {
            var arenaPrizeWeekInfo = this.arenaPrizeWeekTab.getRow(i);
            var battle_count = arenaPrizeWeekInfo.getValFromColName("num");
            this.box_list[i].getChild("num").asTextField.text = battle_count;
            if (i <= 1)
                this.box_list[i].getController("c1").selectedIndex = battleCountRewardMap[battle_count] ? 1 : 0;
            else if (i <= 3 && i >= 2)
                this.box_list[i].getController("c1").selectedIndex = battleCountRewardMap[battle_count] ? 3 : 2;
            else if (i < this.box_list.length && i >= 4)
                this.box_list[i].getController("c1").selectedIndex = battleCountRewardMap[battle_count] ? 5 : 4;
            if (battleCountWeek >= battle_count && battleCountRewardMap[battle_count] != 1)
                this.box_list[i].getTransition("t3").play(function () { }, 0, 0, -1);
            else {
                this.box_list[i].getTransition("t3").stop();
            }
            this.box_list[i].getController("c2").selectedIndex = battleCountRewardMap[battle_count] ? 1 : 0;
            var data_list = [];
            data_list["item_drop"] = ItemMgr.getDropGroupByID(Number(arenaPrizeWeekInfo.getValFromColName("drop")));
            data_list["battleCount"] = battle_count;
            data_list["is_lingqu"] = battleCountRewardMap[battle_count] == 1;
            this.box_list[i].data = data_list;
        }
        this.changenum.text = "(挑战" + battleCountWeek + "次)";
        var max_value = this.arenaPrizeWeekTab.getRow(this.arenaPrizeWeekTab.size() - 1).getValFromColName("num");
        this.progress.max = max_value;
        var list1 = [0, 10, 20, 35, 50, 70, 90, 120];
        var list2 = [0, 5, 25, 45, 60, 80, 100, 120];
        var value = battleCountWeek >= max_value ? max_value : ak.shaping001(battleCountWeek, list1, list2);
        this.progress.value = value;
    };
    //刷新自由竞技场
    Arena1View.prototype.updateList = function () {
        this.onFlushRolePower();
        this.onFlushTicketCount();
        net.getMyStageInfo(this.onFlushSingeArenaData, this);
        this.onFlushBattleCountBox();
    };
    //刷新排行榜
    Arena1View.prototype.updateList2 = function (msg) {
        this.list2.removeChildrenToPool();
        var rank_list = msg[1];
        for (var i = 0; i < rank_list.arr.length; i++) {
            var rank_item = this.list2.addItemFromPool().asCom;
            var ranknum = rank_item.getChild("ranknum").asTextField;
            var rankloader = rank_item.getChild("rankloader").asLoader;
            if (i < 3) {
                this.setLoaderUrl(rankloader, "ui://common/img_paihangbang_" + (i + 1));
                rankloader.visible = true;
                ranknum.visible = false;
            }
            else {
                rankloader.visible = false;
                ranknum.visible = true;
                ranknum.text = (i + 1).toString();
            }
            var role_id = rank_list.arr[i][0];
            var role_jifen = rank_list.arr[i][1];
            var userInfoMap = rank_list.userInfoMap[role_id];
            var role_data = [];
            role_data["userID"] = role_id;
            rank_item.data = role_data;
            this.onFlushHeadItem(rank_item.getChild("itemCom").asCom, userInfoMap[0], userInfoMap[1]);
            rank_item.getChild("username").asTextField.text = userInfoMap[2];
            rank_item.getChild("power").asTextField.text = userInfoMap[4];
            rank_item.getChild("roundnum").asTextField.text = role_jifen;
        }
    };
    Arena1View.prototype.onClickItem = function (obj) {
        var item = obj.itemObject;
        var itemCom = item.getChild("itemCom").asCom;
        if (this.hitTestPointWithFairyGUIComponent(itemCom, obj.stageX, obj.stageY)) {
            net.getRoleBaseInfo(item.data.userID, function (msg) {
                ak.FairyGUI.open(["LookupInfoView", item.data.userID, msg]);
            }, this);
        }
        else {
            if (item.getChild("fightbtn") != null && (this.hitTestPointWithFairyGUIComponent(item.getChild("fightbtn").asButton, obj.stageX, obj.stageY))) {
                ak.FairyGUI.open(["FightReadyView", 7, item.data.userID]);
            }
        }
    };
    /**倒计时 */
    Arena1View.prototype.timeDown = function () {
        this.timetxt.text = "" + DateUtils.getFormatBySecond(DateUtils.getWeekLastDay(), DateUtils.TIME_FORMAT_12);
    };
    //刷新按钮倒计时
    Arena1View.prototype.flushBtntimeDown = function () {
        var timer = new Date().getTime();
        if (timer < this.delay_time) {
            timer = this.delay_time - timer;
            var date = new Date(timer);
            this.updatebtn.text = date.getSeconds() + "s";
            this.updatebtn.enabled = false;
        }
        else {
            this.updatebtn.enabled = true;
            this.updatebtn.text = "刷新";
        }
    };
    return Arena1View;
}(ak.EasyUI));
__reflect(Arena1View.prototype, "Arena1View");
//竞技场商店
var ArenaShopSystem = (function (_super) {
    __extends(ArenaShopSystem, _super);
    function ArenaShopSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    ArenaShopSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ArenaView");
    };
    ArenaShopSystem.inst = new ArenaShopSystem("ArenaView");
    return ArenaShopSystem;
}(ak.FairyGUI));
__reflect(ArenaShopSystem.prototype, "ArenaShopSystem");
var ArenaShopView = (function (_super) {
    __extends(ArenaShopView, _super);
    function ArenaShopView() {
        return _super.call(this, ArenaShopSystem.inst, MyGame.inst.uiLayer2_1) || this;
    }
    ArenaShopView.prototype.onInit = function () {
        var ui = this.create("ArenaView", "ArenaShopView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.myarenascore = this.ui.getChild("n11").asCom;
        this.arenashoplist = this.ui.getChild("n39").asList;
        this.arenashopTab = ak.JsonTableMgr.get("shopArena");
        this.clickAdd();
        this.setstaticView();
    };
    ArenaShopView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this); //关闭界面
        this.onFairyguiEvent(this.arenashoplist, fairygui.ItemEvent.CLICK, this.buyMarket, this);
    };
    ArenaShopView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
        }
    };
    ArenaShopView.prototype.updateView = function () {
        var number2 = this.myarenascore.getChild("number").asTextField;
        var Info = this.arenashopTab.getRow(0);
        number2.text = "" + SummonData.inst().GetItemnumByid(Info.getValFromColName("costItem"));
        Common.labelIsOverLenght(number2, number2.text);
    };
    ArenaShopView.prototype.buyMarket = function (obj) {
        var item = obj.itemObject;
        for (var i = 0; i < 3; i++) {
            var itemCom = item.getChild("n1" + (i + 1)).asCom;
            var item1 = itemCom.getChild("n2").asCom; //获取元素中的物品栏
            if (this.hitTestPointWithFairyGUIComponent(itemCom, obj.stageX, obj.stageY)) {
                if (this.hitTestPointWithFairyGUIComponent(item1, obj.stageX, obj.stageY)) {
                    ak.FairyGUI.open(["WeaponTipsView", item1.data.id, item1.data.num, 1]);
                }
                else {
                    if (SummonData.inst().GetItemnumByid(itemCom.data.CostItem) >= itemCom.data.CostNum) {
                        ak.FairyGUI.open(["ChooseTipsView", 8, '确定购买当前商品？', this.updateView.bind(this), itemCom.data.index]);
                    }
                    else {
                        TipsViewSystem.show("荣誉点不够");
                        return;
                    }
                }
            }
        }
    };
    ArenaShopView.prototype.setstaticView = function () {
        ShopData.inst().setShopView(this, 2, this.arenashoplist, this.arenashopTab, '', '', this.myarenascore);
        var photo_url_path = 'ui://common/token_ryd';
        //我的积分
        var icon2 = this.myarenascore.getChild("icon").asLoader;
        var number2 = this.myarenascore.getChild("number").asTextField;
        this.setLoaderUrl(icon2, photo_url_path);
        var Info = this.arenashopTab.getRow(0);
        number2.text = "" + SummonData.inst().GetItemnumByid(Info.getValFromColName("costItem"));
        Common.labelIsOverLenght(number2, number2.text);
    };
    return ArenaShopView;
}(ak.EasyUI));
__reflect(ArenaShopView.prototype, "ArenaShopView");
var ArenaViewSystem = (function (_super) {
    __extends(ArenaViewSystem, _super);
    function ArenaViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    ArenaViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ArenaView");
    };
    ArenaViewSystem.inst = new ArenaViewSystem("ArenaView");
    return ArenaViewSystem;
}(ak.FairyGUI));
__reflect(ArenaViewSystem.prototype, "ArenaViewSystem");
/**
 * 竞技场主界面
 */
var ArenaView = (function (_super) {
    __extends(ArenaView, _super);
    function ArenaView() {
        return _super.call(this, ArenaViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
    }
    /**回调 */
    ArenaView.prototype.onInit = function () {
        var ui = this.create("ArenaView", "ArenaView");
        this.closebtn = ui.getChild("closebtn").asButton;
        this.ziyoubtn = ui.getChild("ziyoubtn").asButton;
        this.guanjunbtn = ui.getChild("guanjunbtn").asButton;
        this.timename1 = this.ziyoubtn.getChild("timename").asTextField;
        this.timename2 = this.guanjunbtn.getChild("timename").asTextField;
        this.timetxt1 = this.ziyoubtn.getChild("timetxt").asTextField;
        this.timetxt2 = this.guanjunbtn.getChild("timetxt").asTextField;
        this.arenashop = this.ui.getChild("shop").asButton;
        this.ClickAdd();
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.timeDown1, this);
    };
    ArenaView.prototype.ClickAdd = function () {
        this.addClickListener(this.closebtn, this.onClick, this);
        this.addClickListener(this.ziyoubtn, this.onClick, this);
        this.addClickListener(this.guanjunbtn, this.onClick, this);
        this.addClickListener(this.arenashop, this.onClick, this);
    };
    ArenaView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.closebtn:
                this.close();
                break;
            case this.ziyoubtn:
                var upCardIDArr = MyData.user.json.stage.upCardIDArr;
                var isNull = 0;
                for (var i = 0; i < upCardIDArr.length - 1; i++) {
                    if (upCardIDArr[i] == -1) {
                        isNull++;
                    }
                }
                if (upCardIDArr.length == 0 || isNull == upCardIDArr.length - 1) {
                    ak.FairyGUI.open(["FightReadyView", 5]);
                }
                else {
                    ak.FairyGUI.open(["Arena1View"]);
                }
                break;
            case this.guanjunbtn:
                TipsViewSystem.show("暂未开放");
                break;
            case this.arenashop:
                ak.FairyGUI.open(["ArenaShopView"]);
                break;
        }
    };
    /**倒计时 */
    ArenaView.prototype.timeDown1 = function () {
        this.timetxt1.text = "" + DateUtils.getFormatBySecond(DateUtils.getWeekLastDay(), DateUtils.TIME_FORMAT_12);
    };
    return ArenaView;
}(ak.EasyUI));
__reflect(ArenaView.prototype, "ArenaView");
var FightRecordViewSystem = (function (_super) {
    __extends(FightRecordViewSystem, _super);
    function FightRecordViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    FightRecordViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ArenaView");
    };
    FightRecordViewSystem.inst = new FightRecordViewSystem("ArenaView");
    return FightRecordViewSystem;
}(ak.FairyGUI));
__reflect(FightRecordViewSystem.prototype, "FightRecordViewSystem");
/**
 * 竞技场战斗记录界面
 */
var FightRecordView = (function (_super) {
    __extends(FightRecordView, _super);
    function FightRecordView() {
        return _super.call(this, FightRecordViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
    }
    /**回调 */
    FightRecordView.prototype.onInit = function () {
        var ui = this.create("ArenaView", "FightRecordView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.record_list = ui.getChild("list").asList;
        this.ClickAdd();
        net.getStageBattleReport(this.onFlushRecordList, this);
    };
    FightRecordView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.onFairyguiEvent(this.record_list, fairygui.ItemEvent.CLICK, this.onClickItem, this);
    };
    FightRecordView.prototype.onClickItem = function (obj) {
        var item = obj.itemObject;
        var itemCom = item.getChild("icon_item").asCom;
        if (this.hitTestPointWithFairyGUIComponent(itemCom, obj.stageX, obj.stageY)) {
            net.getRoleBaseInfo(itemCom.data.userID, function (msg) {
                ak.FairyGUI.open(["LookupInfoView", itemCom.data.userID, msg]);
            }, this);
        }
    };
    FightRecordView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
        }
    };
    //刷新战斗记录
    FightRecordView.prototype.onFlushRecordList = function (msg) {
        this.record_list.removeChildrenToPool();
        var msg_list = msg[1];
        for (var i = 0; i < msg_list.length; i++) {
            var report_list = msg_list[i].report;
            var record_item = this.record_list.addItemFromPool().asCom;
            var is_win = report_list.eventArr[report_list.eventArr.length - 1][1];
            record_item.getController("c1").selectedIndex = (is_win - 1);
            record_item.getChild("role_name").asTextField.text = report_list.team2.nickname;
            var itemCom = record_item.getChild("icon_item").asCom;
            var icon_item = new ItemBase(itemCom, this, 2);
            icon_item.setIcons2("hero" + report_list.team2.head);
            icon_item.setNumber(report_list.team2.level, true);
            var role_data = [];
            role_data["userID"] = report_list.team2.userID;
            itemCom.data = role_data;
            record_item.getChild("time").asTextField.text = "" + Common.passTime(msg_list[i].time);
            record_item.getChild("ji_fen").asTextField.text = msg_list[i].score;
            var record_btn = record_item.getChild("btn_record_vide").asButton;
            record_btn.data = report_list;
            this.addClickListener(record_btn, this.onClickRecordVide, this);
        }
    };
    //点击查看战斗记录
    FightRecordView.prototype.onClickRecordVide = function (e) {
        ak.FairyGUI.open(["FightView", e.target.data, []]);
    };
    return FightRecordView;
}(ak.EasyUI));
__reflect(FightRecordView.prototype, "FightRecordView");
var RewardShowViewSystem = (function (_super) {
    __extends(RewardShowViewSystem, _super);
    function RewardShowViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    RewardShowViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ArenaView");
    };
    RewardShowViewSystem.inst = new RewardShowViewSystem("ArenaView");
    return RewardShowViewSystem;
}(ak.FairyGUI));
__reflect(RewardShowViewSystem.prototype, "RewardShowViewSystem");
/**
 * 竞技场奖励预览界面
 */
var RewardShowView = (function (_super) {
    __extends(RewardShowView, _super);
    function RewardShowView(itemdata) {
        var _this = _super.call(this, RewardShowViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
        _this.itemdata = [];
        ak.log(_this.itemdata, itemdata);
        _this.itemdata = itemdata;
        return _this;
    }
    /**回调 */
    RewardShowView.prototype.onInit = function () {
        var ui = this.create("ArenaView", "RewardShowView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.closebtn = ui.getChild("closebtn").asButton;
        this.itemCom = ui.getChild("itemCom").asCom;
        this.ClickAdd();
        this.flushItem();
    };
    RewardShowView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.closebtn, this.onClick, this);
    };
    RewardShowView.prototype.flushItem = function () {
        for (var j = 0; j < this.itemdata.length; j++) {
            var item_type = this.itemdata[j][1];
            var item_id = this.itemdata[j][2];
            var item_count = this.itemdata[j][3];
            var itemBase = new ItemBase(this.itemCom, this, item_type);
            itemBase.setItemData(Number(item_id));
            itemBase.setNumber(item_count, true);
        }
    };
    RewardShowView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.closebtn:
                this.close();
                break;
        }
    };
    return RewardShowView;
}(ak.EasyUI));
__reflect(RewardShowView.prototype, "RewardShowView");
var RewardViewSystem = (function (_super) {
    __extends(RewardViewSystem, _super);
    function RewardViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    RewardViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ArenaView");
    };
    RewardViewSystem.inst = new RewardViewSystem("ArenaView");
    return RewardViewSystem;
}(ak.FairyGUI));
__reflect(RewardViewSystem.prototype, "RewardViewSystem");
/**
 * 竞技场奖励界面
 */
var RewardView = (function (_super) {
    __extends(RewardView, _super);
    function RewardView() {
        var _this = _super.call(this, RewardViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
        _this.is_loadlist1 = null;
        _this.is_loadlist2 = null;
        return _this;
    }
    /**回调 */
    RewardView.prototype.onInit = function () {
        var _this = this;
        var ui = this.create("ArenaView", "RewardView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.list1 = ui.getChild("list1").asList;
        this.list2 = ui.getChild("list2").asList;
        this.rank = ui.getChild("rank").asTextField;
        this.c1_control = this.ui.getController("c1");
        this.leftbtn = ui.getChild("tab").asCom.getChild("leftbtn").asButton;
        this.rightbtn = ui.getChild("tab").asCom.getChild("rightbtn").asButton;
        this.rankRewardTab = ak.JsonTableMgr.get("arenaRank");
        this.weekRewardTab = ak.JsonTableMgr.get("arenaRankWeek");
        this.issue_reward_text = ui.getChild("n8").asTextField;
        this.arenaConfigInfo = ak.JsonTableMgr.get("arenaConfig").getRow(0);
        net.getMyStageInfo(function (role_arena_data) { _this.rank.text = role_arena_data[1][0]; }, this);
        this.staticView();
        this.ClickAdd();
        this.UpdateList1();
    };
    RewardView.prototype.onDestroy = function () {
        this.is_loadlist1 = null;
        this.is_loadlist2 = null;
    };
    RewardView.prototype.staticView = function () {
        var title1 = this.leftbtn.getChild("title").asTextField;
        var title2 = this.rightbtn.getChild("title").asTextField;
        title1.text = "排名奖励";
        title2.text = "赛季奖励";
    };
    RewardView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.leftbtn, this.onClick, this);
        this.addClickListener(this.rightbtn, this.onClick, this);
    };
    RewardView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.leftbtn:
                this.c1_control.selectedIndex = (0);
                this.UpdateList1();
                break;
            case this.rightbtn:
                this.c1_control.selectedIndex = (1);
                this.UpdateList2();
                break;
        }
    };
    RewardView.prototype.UpdateList1 = function () {
        this.UpdateList(1, this.list1, this.rankRewardTab);
    };
    RewardView.prototype.UpdateList2 = function () {
        this.UpdateList(2, this.list2, this.weekRewardTab);
    };
    //刷新列表视图
    RewardView.prototype.UpdateList = function (is_load, list_view, list_config) {
        if (this.is_loadlist1 == is_load || this.is_loadlist2 == is_load)
            return;
        list_view.removeChildrenToPool();
        for (var i = 1; i < list_config.size(); i++) {
            var listRowInfo = list_config.getRow(i);
            var Item = list_view.addItemFromPool().asCom;
            var rankloader = Item.getChild("rankloader").asLoader;
            var ranknum = Item.getChild("ranknum").asTextField;
            if (i <= 3) {
                this.setLoaderUrl(rankloader, "ui://common/img_paihangbang_" + i);
                rankloader.visible = true;
                ranknum.visible = false;
            }
            else {
                rankloader.visible = false;
                ranknum.visible = true;
                var rankmin = listRowInfo.getValFromColName("rankMin");
                var rankmax = listRowInfo.getValFromColName("rankMax");
                ranknum.text = rankmin + "-" + rankmax;
            }
            var item_Cfg = ItemMgr.getDropGroupByID(Number(listRowInfo.getValFromColName("drop")));
            this.flushItem(item_Cfg, Item.getChild("itemlist").asList);
        }
        if (is_load == 1) {
            this.is_loadlist1 = is_load;
            this.issue_reward_text.text = "每天" + this.arenaConfigInfo.getValFromColName("dailyTime") + "点发放排名奖励";
        }
        else {
            this.is_loadlist2 = is_load;
        }
    };
    //刷新道具物品
    RewardView.prototype.flushItem = function (itemlist_cfg, ListItem) {
        ListItem.removeChildrenToPool();
        for (var j = 0; j < itemlist_cfg.length; j++) {
            var itemCom = ListItem.addItemFromPool().asCom;
            var item_type = itemlist_cfg[j][1];
            var item_id = itemlist_cfg[j][2];
            var item_count = itemlist_cfg[j][3];
            var itemBase = new ItemBase(itemCom, this, item_type);
            itemBase.setItemData(Number(item_id));
            itemBase.setNumber(item_count, true);
            itemCom.data = { item_id: item_id, item_count: item_count, item_type: item_type };
        }
        this.onFairyguiEvent(ListItem, fairygui.ItemEvent.CLICK, this.onClickItem, this);
    };
    //点击物品框
    RewardView.prototype.onClickItem = function (e) {
        var itemData = e.itemObject.data;
        if (itemData.item_type == 3)
            ak.FairyGUI.open(["ResourceTipsView", itemData.item_id, itemData.item_count]);
        else
            ak.FairyGUI.open(["WeaponTipsView", itemData.item_id, itemData.item_count, itemData.item_type]);
    };
    return RewardView;
}(ak.EasyUI));
__reflect(RewardView.prototype, "RewardView");
/**
 * 背包数据
 */
var BagData = (function () {
    function BagData() {
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    BagData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new BagData();
        }
        return Class._instance;
    };
    /**根据index,paginalIndex返回英雄数组 */
    BagData.prototype.GetItemGroupInfoByIndex = function (index, paginalIndex) {
        var itemGroups = [];
        var itemGroups2 = this.GetItemByType(paginalIndex + 1);
        var itemTab = ak.JsonTableMgr.get("item");
        switch (index) {
            case 0:
                itemGroups = itemGroups2;
                break;
            case 1:
            case 2:
            case 3:
            case 4:
            case 5:
            case 6:
                for (var i = 0; i < itemGroups2.length; i++) {
                    var itemInfo = itemTab.getRowFromColName("id", "" + itemGroups2[i][1].itemID);
                    var color = itemInfo.getValFromColName("color");
                    if ((index - 1) == color) {
                        itemGroups.push(itemGroups2[i]);
                    }
                }
                break;
        }
        itemGroups.sort(this.GroupSort);
        return itemGroups;
    };
    /**根据道具的类型返回道具列表 */
    BagData.prototype.GetItemByType = function (type) {
        var itemArr = MyData.user.json.itemArr;
        var itemTab = ak.JsonTableMgr.get("item");
        var itemGroup = [];
        for (var i = 0; i < itemArr.length; i++) {
            var itemInfo = itemTab.getRowFromColName("id", "" + MyData.user.json.itemArr[i].itemID);
            if (itemInfo) {
                var types = itemInfo.getValFromColName("bagtype");
                if (type == types) {
                    itemGroup.push([i, MyData.user.json.itemArr[i]]);
                }
            }
        }
        return itemGroup;
    };
    /**
     * 英雄数组排序
     * { 1级为品阶 }
     */
    BagData.prototype.GroupSort = function (a, b) {
        var itemTab = ak.JsonTableMgr.get("item");
        var aitemInfo = itemTab.getRowFromColName("id", "" + a[1].itemID);
        var acolor = aitemInfo.getValFromColName("color");
        var bitemInfo = itemTab.getRowFromColName("id", "" + b[1].itemID);
        var bcolor = aitemInfo.getValFromColName("color");
        if (acolor > bcolor)
            return -1;
        if (acolor < bcolor)
            return 1;
        return 0;
    };
    BagData.prototype.GetStarById = function (itemID) {
        var itemTab = ak.JsonTableMgr.get("item");
        var itemInfo = itemTab.getRowFromColName("id", "" + itemID);
        var bagtype = itemInfo.getValFromColName("bagtype");
        var tab = bagtype == 1 ? ak.JsonTableMgr.get("itemEquip") : ak.JsonTableMgr.get("itemPiece");
        if (bagtype == 4)
            tab = ak.JsonTableMgr.get("itemShipin");
        var itemInfo2 = tab.getRowFromColName("id", "" + itemID);
        var stars = itemInfo2.getValFromColName("star");
        var star = stars;
        return star;
    };
    BagData.prototype.GetPieceMaxNum = function (itemID) {
        var tab = ak.JsonTableMgr.get("itemPiece");
        var itemInfo2 = tab.getRowFromColName("id", "" + itemID);
        var heroCostNum = itemInfo2.getValFromColName("heroCostNum");
        return heroCostNum;
    };
    /**
     * 判断碎片是否是唯一的种族碎片
     * 0为不唯一，其他为唯一
     */
    BagData.prototype.isOnlyRacePiece = function (itemID) {
        var tab = ak.JsonTableMgr.get("itemPiece");
        var itemInfo2 = tab.getRowFromColName("id", "" + itemID);
        var race = itemInfo2.getValFromColName("race");
        return race;
    };
    /**根据item的id获取道具的背包类型 */
    BagData.prototype.GetBagtypeById = function (itemID) {
        var itemTab = ak.JsonTableMgr.get("item");
        var itemInfo = itemTab.getRowFromColName("id", "" + itemID);
        var bagtype = itemInfo.getValFromColName("bagtype");
        return bagtype;
    };
    BagData.prototype.GetTaozhuangIdById = function (itemID) {
        var itemEquipTab = ak.JsonTableMgr.get("itemEquip");
        var itemInfo = itemEquipTab.getRowFromColName("id", "" + itemID);
        var tzID = itemInfo.getValFromColName("tzID");
        return tzID;
    };
    /**根据套装id获取套装信息 */
    BagData.prototype.GetTaozhuangInfoByTzID = function (tzID) {
        var itemEquipSuitTab = ak.JsonTableMgr.get("itemEquipSuit");
        var itemEquipSuitInfo = itemEquipSuitTab.getRowFromColName("id", "" + tzID);
        var name = itemEquipSuitInfo.getValFromColName("name");
        var hpRate2 = itemEquipSuitInfo.getValFromColName("hpRate2");
        var atkRate3 = itemEquipSuitInfo.getValFromColName("atkRate3");
        var hpRate4 = itemEquipSuitInfo.getValFromColName("hpRate4");
        var info = { name: name, hpRate2: String(hpRate2 / 100) + "%生命", atkRate3: String(atkRate3 / 100) + "%攻击", hpRate4: String(hpRate4 / 100) + "%生命" };
        return info;
    };
    /**获取道具售出单价 */
    BagData.prototype.GetitemMoneyById = function (itemID) {
        var itemTab = ak.JsonTableMgr.get("item");
        var itemInfo = itemTab.getRowFromColName("id", "" + itemID);
        var sales = itemInfo.getValFromColName("sales");
        return sales;
    };
    /**获取道具颜色 */
    BagData.prototype.GetColorById = function (itemID) {
        var itemTab = ak.JsonTableMgr.get("item");
        var itemInfo = itemTab.getRowFromColName("id", "" + itemID);
        var color = itemInfo.getValFromColName("color");
        return color;
    };
    /**获取道具名字 */
    BagData.prototype.GetNameById = function (itemID) {
        var itemTab = ak.JsonTableMgr.get("item");
        var itemInfo = itemTab.getRowFromColName("id", "" + itemID);
        var name = itemInfo.getValFromColName("name");
        return name;
    };
    /**获取道具icon */
    BagData.prototype.GetIconById = function (itemID) {
        var itemTab = ak.JsonTableMgr.get("item");
        var itemInfo = itemTab.getRowFromColName("id", "" + itemID);
        var img = itemInfo.getValFromColName("img");
        return img;
    };
    /**获取资源的icon */
    BagData.prototype.GetResourceIcon = function (id) {
        var itemTab = ak.JsonTableMgr.get("Resource");
        var itemInfo = itemTab.getRowFromColName("id", "" + id);
        var icon = itemInfo.getValFromColName("icon");
        return icon;
    };
    /**获取资源的品阶 */
    BagData.prototype.GetResourceColor = function (id) {
        var itemTab = ak.JsonTableMgr.get("Resource");
        var itemInfo = itemTab.getRowFromColName("id", "" + id);
        var color = itemInfo.getValFromColName("color");
        return color;
    };
    /**获取资源的描述 */
    BagData.prototype.GetResourceText = function (id) {
        var itemTab = ak.JsonTableMgr.get("Resource");
        var itemInfo = itemTab.getRowFromColName("id", "" + id);
        var text = itemInfo.getValFromColName("text");
        return text;
    };
    /**获取资源的名字 */
    BagData.prototype.GetResourceName = function (id) {
        var itemTab = ak.JsonTableMgr.get("Resource");
        var itemInfo = itemTab.getRowFromColName("id", "" + id);
        var name = itemInfo.getValFromColName("name");
        return name;
    };
    /**获得名字 */
    BagData.prototype.GetNameByTYPEandID = function (type, id) {
        var name = "";
        if (type == 3) {
            name = this.GetResourceName(id);
        }
        else if (type == 1) {
            name = this.GetNameById(id);
        }
        else {
        }
        return name;
    };
    /**
     * 背包类型（1装备，2=道具栏，3=碎片栏，4=饰品）
     */
    BagData.BAGTYPE = [1, 2, 3, 4];
    BagData.BAGNAME = ["装备", "道具", "碎片", "饰品"];
    return BagData;
}());
__reflect(BagData.prototype, "BagData");
/**
 * 背包系统
 */
var BagViewSystem = (function (_super) {
    __extends(BagViewSystem, _super);
    function BagViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    BagViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("BagView");
    };
    BagViewSystem.inst = new BagViewSystem("BagView");
    return BagViewSystem;
}(ak.FairyGUI));
__reflect(BagViewSystem.prototype, "BagViewSystem");
/**
 * 背包界面
 */
var BagView = (function (_super) {
    __extends(BagView, _super);
    function BagView() {
        var _this = _super.call(this, BagViewSystem.inst, MyGame.inst.uiLayer) || this;
        /**大页数 */
        _this.paginalIndex = 0;
        /**小页数 */
        _this.index = 0;
        /**英雄数组数据 */
        _this.itemGroups = [];
        return _this;
    }
    /**回调 */
    BagView.prototype.onInit = function () {
        var ui = this.create("BagView", "BagView");
        this.on("netmsg://bag/itemSellResult", this.updateInfo2, this);
        this.on("netmsg://bag/cardComposeResult", this.updateInfo2, this);
        this.on("netmsg://bag/itemComposeResult", this.updateInfo2, this);
        this.on("netmsg://bag/itemUseResult", this.updateInfo2, this);
        this.on("netmsg://bag/itemComposeResult", this.redDotHandle, this);
        this.on("netmsg://bag/cardComposeResult", this.redDotHandle, this);
        this.on("netmsg://dropDataResult", this.redDotHandle, this);
        this.on("netmsg://userResult", this.redDotHandle, this);
        this.zhuangbeibtn = ui.getChild("zhuangbeibtn").asButton;
        this.daojubtn = ui.getChild("daojubtn").asButton;
        this.suipianbtn = ui.getChild("suipianbtn").asButton;
        this.shipinbtn = ui.getChild("shipinbtn").asButton;
        this.itemlist = ui.getChild("itemlist").asCom;
        this.list = ui.getChild("list").asList;
        this.btn0 = this.itemlist.getChild("btn0").asButton;
        this.btn1 = this.itemlist.getChild("btn1").asButton;
        this.btn2 = this.itemlist.getChild("btn2").asButton;
        this.btn3 = this.itemlist.getChild("btn3").asButton;
        this.btn4 = this.itemlist.getChild("btn4").asButton;
        this.btn5 = this.itemlist.getChild("btn5").asButton;
        this.btn6 = this.itemlist.getChild("btn6").asButton;
        this.redDot2 = ui.getChild("redDot2").asImage;
        this.index = 0;
        this.paginalIndex = 0;
        this.ClickAdd();
        this.setHeroGroupInfo();
        this.updateList();
        this.redDotHandle();
    };
    BagView.prototype.ClickAdd = function () {
        this.addClickListener(this.zhuangbeibtn, this.onClick, this);
        this.addClickListener(this.daojubtn, this.onClick, this);
        this.addClickListener(this.suipianbtn, this.onClick, this);
        this.addClickListener(this.shipinbtn, this.onClick, this);
        this.addClickListener(this.btn0, this.onClick, this);
        this.addClickListener(this.btn1, this.onClick, this);
        this.addClickListener(this.btn2, this.onClick, this);
        this.addClickListener(this.btn3, this.onClick, this);
        this.addClickListener(this.btn4, this.onClick, this);
        this.addClickListener(this.btn5, this.onClick, this);
        this.addClickListener(this.btn6, this.onClick, this);
        this.onFairyguiEvent(this.list, fairygui.ItemEvent.CLICK, this.itemonclick, this);
    };
    BagView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.zhuangbeibtn:
                this.paginalIndex = 0;
                this.updateBtn();
                this.updateInfo(0);
                break;
            case this.daojubtn:
                this.paginalIndex = 1;
                this.updateBtn();
                this.updateInfo(0);
                break;
            case this.suipianbtn:
                this.paginalIndex = 2;
                this.updateBtn();
                this.updateInfo(0);
                break;
            case this.shipinbtn:
                this.paginalIndex = 3;
                this.updateBtn();
                this.updateInfo(0);
                break;
            case this.btn0:
                this.updateInfo(0);
                break;
            case this.btn1:
                this.updateInfo(1);
                break;
            case this.btn2:
                this.updateInfo(2);
                break;
            case this.btn3:
                this.updateInfo(3);
                break;
            case this.btn4:
                this.updateInfo(4);
                break;
            case this.btn5:
                this.updateInfo(5);
                break;
            case this.btn6:
                this.updateInfo(6);
                break;
        }
    };
    BagView.prototype.updateInfo = function (index) {
        this.index = index;
        this.setHeroGroupInfo();
        this.updateList();
    };
    BagView.prototype.updateInfo2 = function () {
        this.setHeroGroupInfo();
        this.updateList();
    };
    BagView.prototype.updateList = function () {
        this.list.setVirtual();
        this.list.itemRenderer = this.listItemRenderer.bind(this);
        this.list.callbackThisObj = this;
        this.list.numItems = this.itemGroups.length;
        /*
        this.list.removeChildrenToPool();
        for(let i=0 ; i < this.itemGroups.length ;i++) {
            let item:fairygui.GComponent = this.list.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
            //道具索引
            let itemindex = 0;
            item.data = {itemID:this.itemGroups[i][1].itemID,count:this.itemGroups[i][1].count,itemindex:this.itemGroups[i][0]};
            let items = new ItemBase(item,this,1);
            items.setItemData(this.itemGroups[i][1].itemID);
            if(this.paginalIndex != 1) {
                items.setStar2(BagData.inst().GetStarById(this.itemGroups[i][1].itemID));
            } else {
                items.setStar2(0);
            }

            //碎片特殊处理
            if(this.paginalIndex == 2) {
                items.setNumber("",true);
                items.isShowProgressBar(true);
                items.isShowPiece(true);
                items.setProgressInfo(this.itemGroups[i][1].count,BagData.inst().GetPieceMaxNum(this.itemGroups[i][1].itemID));
                let race:number = BagData.inst().isOnlyRacePiece(this.itemGroups[i][1].itemID);
                items.setType(race);
            } else {
                items.setNumber(this.itemGroups[i][1].count,true);
                items.isShowProgressBar(false);
                items.isShowPiece(false);
                items.setType(0);
            }
        }*/
        this.list.lineGap = this.paginalIndex == 2 ? 30 : 12;
    };
    BagView.prototype.listItemRenderer = function (i, item) {
        var itemindex = 0;
        item.data = { itemID: this.itemGroups[i][1].itemID, count: this.itemGroups[i][1].count, itemindex: this.itemGroups[i][0] };
        var items = new ItemBase(item.asCom, this, 1);
        items.setItemData(this.itemGroups[i][1].itemID);
        if (this.paginalIndex != 1) {
            items.setStar2(BagData.inst().GetStarById(this.itemGroups[i][1].itemID));
        }
        else {
            items.setStar2(0);
        }
        //碎片特殊处理
        if (this.paginalIndex == 2) {
            items.setNumber2("", true);
            items.isShowProgressBar(true);
            items.isShowPiece(true);
            items.setProgressInfo(this.itemGroups[i][1].count, BagData.inst().GetPieceMaxNum(this.itemGroups[i][1].itemID));
            var race = BagData.inst().isOnlyRacePiece(this.itemGroups[i][1].itemID);
            items.setType(race);
        }
        else {
            items.setNumber(this.itemGroups[i][1].count, true);
            items.isShowProgressBar(false);
            items.isShowPiece(false);
            items.setType(0);
        }
    };
    /**
     * 设置英雄数据
     * 根据index来设置不同英雄的数据
     */
    BagView.prototype.setHeroGroupInfo = function () {
        this.itemGroups = [];
        this.itemGroups = BagData.inst().GetItemGroupInfoByIndex(this.index, this.paginalIndex);
    };
    /**重置按钮状态 */
    BagView.prototype.updateBtn = function () {
        this.itemlist.getController("qiehuan").selectedIndex = (0);
    };
    /**每个道具的点击事件 */
    BagView.prototype.itemonclick = function (e) {
        if (this.paginalIndex == 3) {
            ak.FairyGUI.open(["ShipinTipsView", e.itemObject.data.itemID, e.itemObject.data.count, e.itemObject.data.itemindex]);
        }
        else {
            ak.FairyGUI.open(["WeaponTipsView", e.itemObject.data.itemID, e.itemObject.data.count, this.paginalIndex, e.itemObject.data.itemindex]);
        }
    };
    BagView.prototype.redDotHandle = function () {
        this.redDot2.visible = RedDotMgr.bagPieceRedDot() ? true : false;
    };
    return BagView;
}(ak.EasyUI));
__reflect(BagView.prototype, "BagView");
//卡牌合成
var CardDegreeViewSystem = (function (_super) {
    __extends(CardDegreeViewSystem, _super);
    function CardDegreeViewSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CardDegreeViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("CardDegree");
    };
    CardDegreeViewSystem.inst = new CardDegreeViewSystem("CardDegree");
    return CardDegreeViewSystem;
}(ak.FairyGUI));
__reflect(CardDegreeViewSystem.prototype, "CardDegreeViewSystem");
//主界面
var CardDegreeView = (function (_super) {
    __extends(CardDegreeView, _super);
    function CardDegreeView() {
        var _this = _super.call(this, CardDegreeViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
        _this.xuanxiangkaRace = 0; //选项卡种族
        //更新种族红点
        _this.redNameArr = ["n66", "n67", "n68", "n69", "n70", "n71", "n72"];
        //点击英雄列表
        _this.showHeroIDStar = 0;
        _this.needHeroIndexArr = []; //合成新英雄所需卡牌英雄下标
        _this.needHeroIndexArrFiltrate = []; //合成新英雄所需卡牌英雄下标筛选
        _this.needHeroIDArr = []; //所需英雄ID数组
        _this.needHeroIDCountArr = []; //所需英雄ID数量数组
        _this.hero0Arr = []; //所需英雄材料0
        _this.hero1Arr = []; //所需英雄材料1
        _this.hero2Arr = []; //所需英雄材料2
        _this.hero3Arr = []; //所需英雄材料3
        _this.moveItemArr = [];
        return _this;
    }
    //初始化回调
    CardDegreeView.prototype.onInit = function () {
        DownViewSystem.hide();
        this.ui = this.create("CardDegree", "CardDegreeView");
        this.hechengBtn = this.ui.getChild("hechengBtn").asCom;
        this.xuanxiangka = this.ui.getChild("n19").asCom;
        this.closebtn = this.ui.getChild("closeBtn").asButton;
        this.heroData = this.ui.getChild("n50").asButton;
        this.help = this.ui.getChild("n31").asButton;
        this.xuanzeUI = this.ui.getChild("n63").asCom;
        this.xuanze = this.ui.getChild("n63").asCom.getChild("n4").asButton;
        this.itemList = this.ui.getChild("n12").asList;
        this.kexuanHeroList = this.ui.getChild("n63").asCom.getChild("n5").asList;
        this.heroTab = ak.JsonTableMgr.get("hero");
        this.heroComposeTab = ak.JsonTableMgr.get("heroCompose");
        this.heroGrowTab = ak.JsonTableMgr.get("heroGrow");
        this.heroPromotionTab = ak.JsonTableMgr.get("heroPromotion");
        this.composeNum = this.heroComposeTab.size(); //英雄合成个数
        this.bgclose = this.xuanzeUI.getChild("bgclose").asLoader;
        this.hechengBtn.enabled = false;
        this.clickAdd();
        this.updateList();
        this.showLonggu(this.selectHeroID);
    };
    CardDegreeView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this); //关闭界面
        this.addClickListener(this.hechengBtn, this.onClick, this); //合成
        this.addClickListener(this.closebtn, this.onClick, this); //关闭界面
        this.addClickListener(this.xuanxiangka, this.onClick, this); //选项卡
        this.addClickListener(this.xuanze, this.onClick, this); //选中合成英雄
        this.addClickListener(this.help, this.onClick, this); //帮助
        this.addClickListener(this.heroData, this.onClick, this); //帮助
    };
    CardDegreeView.prototype.onClick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.closebtn:
                this.close();
                DownViewSystem.show();
                break;
            case this.heroData:
                ak.FairyGUI.open(["HeroDataView", this.selectHeroID]);
                break;
            case this.bgclose:
                this.xuanzhongQuery();
                break;
            case this.hechengBtn:
                net.cardCompose(this.selectHeroID, this.needHeroIndexArr, function () {
                    TipsViewSystem.show("合成成功");
                    var heroInfo = _this.heroTab.getRowFromColName("id", "" + _this.showHeroIDStar);
                    var star = heroInfo.getValFromColName("star"); //星级
                    if (star >= 6) {
                        ak.FairyGUI.open(["ChooseTipsView", 9, star + "星英雄养成礼包（限时）已激活，是否去购买", function () {
                                _this.close();
                                ak.FairyGUI.open(["ActivityCommonView", "ActivityLimitGiftView"]);
                            }]);
                    }
                    _this.selectXuanxiangka();
                }, this);
                break;
            case this.xuanxiangka:
                this.selectXuanxiangka();
                break;
            case this.xuanze:
                this.xuanzhongQuery();
                break;
            case this.help:
                ak.FairyGUI.open(["HelpTipsView", 1]);
                break;
        }
    };
    CardDegreeView.prototype.updateList = function () {
        this.hechengBtn.enabled = false;
        var num = 0;
        this.heroIndex = 0;
        this.itemList.removeChildrenToPool();
        var pass = true;
        this.raceRedMap = {};
        for (var i = 0; i < this.composeNum; i++) {
            var heroComposeInfo = this.heroComposeTab.getRow(i);
            var heroID = Number(heroComposeInfo.getValFromColName("heroID"));
            var typeS = Number(heroComposeInfo.getValFromColName("type"));
            if (typeS) {
                var heroInfo = this.heroTab.getRowFromColName("id", "" + heroID);
                var race = Number(heroInfo.getValFromColName("race"));
                var star = Number(heroInfo.getValFromColName("star"));
                //选项卡红点
                var red = CardMgr.isCardCompose(heroID);
                if (!this.raceRedMap[race]) {
                    if (red) {
                        this.raceRedMap[0] = true;
                        this.raceRedMap[race] = red;
                    }
                }
                if (this.xuanxiangkaRace == 0) {
                    if (pass) {
                        this.selectRace = race; //选定种族
                        pass = false;
                    }
                    var item = this.itemList.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
                    var itemBase = new ItemBase(item, this, 2);
                    itemBase.setItemData(heroID, race, star);
                    item.data = heroID;
                    item._id = num + "";
                    item.name = race + "";
                    if (num) {
                        itemBase.setGou(false);
                    }
                    else {
                        this.selectHeroID = heroID;
                        itemBase.setGou(true);
                    }
                    itemBase.isshowreddot(red);
                    this.onEgretEvent(item, egret.TouchEvent.TOUCH_TAP, this.editItem, this);
                    num++;
                }
                else {
                    if (this.xuanxiangkaRace == race) {
                        this.selectRace = race; //选定种族
                        var item = this.itemList.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
                        var itemBase = new ItemBase(item, this, 2);
                        itemBase.setItemData(heroID, race, star);
                        item.data = heroID;
                        item._id = num + "";
                        item.name = race + "";
                        if (num) {
                            itemBase.setGou(false);
                        }
                        else {
                            this.selectHeroID = heroID;
                            itemBase.setGou(true);
                        }
                        itemBase.isshowreddot(red);
                        this.onEgretEvent(item, egret.TouchEvent.TOUCH_TAP, this.editItem, this, true);
                        num++;
                    }
                }
            }
        }
        this.needHero();
        this.showLonggu(this.selectHeroID);
        this.updateRaceRed();
    };
    CardDegreeView.prototype.updateRaceRed = function () {
        for (var i = 0; i < this.redNameArr.length; i++) {
            var pass = this.raceRedMap[i];
            if (pass) {
                this.ui.getChild(this.redNameArr[i]).asCom.getController("red").selectedIndex = (1);
            }
            else {
                this.ui.getChild(this.redNameArr[i]).asCom.getController("red").selectedIndex = (0);
            }
        }
    };
    CardDegreeView.prototype.editItem = function (obj) {
        this.hechengBtn.enabled = false;
        var heroID = obj.target.data;
        var index = obj.target._id;
        var race = obj.target.name;
        var itemBase = new ItemBase(obj.target, this, 2);
        if (this.selectHeroID != heroID && this.selectHeroID != 0) {
            //去掉已√英雄
            var oldSelectItem = this.itemList.getChildAt(this.heroIndex).asCom;
            var oldItemBase = new ItemBase(oldSelectItem, this, 2);
            oldItemBase.setGou(false);
            //√选新英雄
            itemBase.setGou(true);
            this.heroIndex = index;
        }
        this.selectRace = race; //选定种族
        this.selectHeroID = heroID; //选定合成英雄ID
        this.needHero();
        this.showLonggu(heroID);
    };
    //龙骨显示
    CardDegreeView.prototype.showLonggu = function (heroID) {
        if (!this.heroNode) {
            this.heroNode = new egret.DisplayObjectContainer();
            this.ui.getChild("longgu").asGraph.setNativeObject(this.heroNode);
        }
        this.heroNode.removeChildren();
        var hero = new Hero(heroID).addToParent(this.heroNode);
        hero.touchEnabled = true;
        this.onEgretEvent(hero, egret.TouchEvent.TOUCH_TAP, function () {
            hero.setAction("atk");
        }, this);
        this.showHeroIDStar = heroID;
    };
    //需要合成的英雄
    CardDegreeView.prototype.needHero = function () {
        this.needHeroIndexArr = [];
        this.needHeroIDArr = [];
        this.needHeroIDCountArr = [];
        this.hero0Arr = [];
        this.hero1Arr = [];
        this.hero2Arr = [];
        this.hero3Arr = [];
        var heroComposeInfo = this.heroComposeTab.getRowFromColName("heroID", "" + this.selectHeroID); //选中的英雄
        var mainHero = Number(heroComposeInfo.getValFromColName("mainHero")); //主英雄
        var mainHeroNum = Number(heroComposeInfo.getValFromColName("mainHeroNum")); //主英雄数量
        var delHero1 = Number(heroComposeInfo.getValFromColName("delHero1")); //副英雄1（负数为同种族对应星级，比如-3为同种族3星）
        var delHeroNum1 = Number(heroComposeInfo.getValFromColName("delHeroNum1")); //副英雄数量1
        var delHero2 = Number(heroComposeInfo.getValFromColName("delHero2")); //副英雄2
        var delHeroNum2 = Number(heroComposeInfo.getValFromColName("delHeroNum2")); //副英雄数量2
        var delHero3 = Number(heroComposeInfo.getValFromColName("delHero3")); //副英雄3
        var delHeroNum3 = Number(heroComposeInfo.getValFromColName("delHeroNum3")); //副英雄数量3
        this.needHeroIDArr.push(mainHero, delHero1, delHero2, delHero3);
        this.needHeroIDCountArr.push(mainHeroNum, delHeroNum1, delHeroNum2, delHeroNum3);
        this.moveItemArr = ["n32", "n33", "n34", "n35"];
        for (var i = 0; i < this.moveItemArr.length; i++) {
            var heroIDS = this.needHeroIDArr[i];
            var countS = this.needHeroIDCountArr[i];
            var item = this.ui.getChild(this.moveItemArr[i]).asCom;
            this.ui.getChild(this.moveItemArr[i]).asCom.getController("isNumberOut").selectedIndex = (1);
            item.data = heroIDS;
            item._id = i + "";
            var itemBase = new ItemBase(item, this, 2);
            if (heroIDS == -3 || heroIDS == -4 || heroIDS == -5) {
                itemBase.setGlobalImg(this.selectRace, Math.abs(heroIDS));
                itemBase.setColor2(Math.abs(heroIDS) - 1);
            }
            else {
                var heroTabInfo = this.heroTab.getRowFromColName("id", "" + heroIDS);
                var star = heroTabInfo.getValFromColName("star"); //星级
                itemBase.setItemData(heroIDS, this.selectRace, star);
            }
            itemBase.seticonGray(false);
            itemBase.setnumberOut("0/" + countS);
            var red = CardMgr.isCardOneCompose(Math.abs(heroIDS), this.selectRace, countS, 0, this.needHeroIndexArr);
            itemBase.isshowreddot(red);
            this.onEgretEvent(item, egret.TouchEvent.TOUCH_TAP, this.addHero, this);
        }
        this.updateHeroType();
    };
    //更新英雄属性
    CardDegreeView.prototype.updateHeroType = function () {
        var heroInfo = this.heroTab.getRowFromColName("id", "" + this.selectHeroID);
        var star = heroInfo.getValFromColName("star"); //星级
        var heroPromotionInfo = this.heroPromotionTab.getRowFromColName("star", "" + star);
        var maxlv = heroPromotionInfo.getValFromColName("maxlv"); //最高可升级
        var hpPro = heroPromotionInfo.getValFromColName("hpPro"); //生命属性系数（万分比）
        var atkPro = heroPromotionInfo.getValFromColName("atkPro"); //攻击属性系数
        var defPro = heroPromotionInfo.getValFromColName("defPro"); //防御属性系数
        var speedPro = heroPromotionInfo.getValFromColName("speedPro"); //速度属性系数
        var heroComposeInfo = this.heroGrowTab.getRowFromColName("heroID", "" + this.selectHeroID);
        var hp = heroComposeInfo.getValFromColName("hp"); //生命
        var atk = heroComposeInfo.getValFromColName("atk"); //攻击
        var def = heroComposeInfo.getValFromColName("def"); //防御
        var speed = heroComposeInfo.getValFromColName("speed"); //速度
        var hpGrow = heroComposeInfo.getValFromColName("hpGrow"); //生命成长
        var atkGrow = heroComposeInfo.getValFromColName("atkGrow"); //攻击成长
        var defGrow = heroComposeInfo.getValFromColName("defGrow"); //防御成长
        var speedGrow = heroComposeInfo.getValFromColName("speedGrow"); //速度成长
        //初始+成长*最高等级*属性系数/10000
        var allHp = Number(hp) + hpGrow * maxlv * hpPro / 10000;
        var allHtk = Number(atk) + atkGrow * maxlv * atkPro / 10000;
        var allDef = Number(def) + defGrow * maxlv * defPro / 10000;
        var allSpeed = Number(speed) + speedGrow * maxlv * speedPro / 10000;
        this.ui.getChild("n40").text = "等级：" + maxlv + ""; //等级
        this.ui.getChild("n42").text = Math.floor(allHtk) + ""; //攻击
        this.ui.getChild("n43").text = Math.floor(allDef) + ""; //防御
        this.ui.getChild("n44").text = Math.floor(allHp) + ""; //血量
        this.ui.getChild("n45").text = Math.floor(allSpeed) + ""; //速度
    };
    //装上英雄
    CardDegreeView.prototype.addHero = function (evt) {
        this.ui.getController("c1").selectedIndex = (1);
        var addHeroID = evt.target.data; //heroID或种类星级（-3，-4，-5）
        this.moveItemArrIndex = evt.target._id; //选定数组位置
        this.kexuanHeroList.removeChildrenToPool();
        var cardArr = MyData.user.json.cardArr;
        for (var i = 0; i < cardArr.length; i++) {
            var checkHeroID = cardArr[i].heroID;
            var checkRace = cardArr[i].race; //种族
            var checkStar = cardArr[i].starMax; //星级
            var checkLock = cardArr[i].lock; //锁定
            var checkBattle = cardArr[i].battle; //锁定
            var checkLevel = cardArr[i].level; //等级
            if (this.selectRace == checkRace) {
                if (addHeroID == checkHeroID) {
                    for (var j = 0; j < 4; j++) {
                        var a = this["hero" + ("" + j) + "Arr"].indexOf(i);
                        if (this.moveItemArrIndex == j && a != -1) {
                            var num = this.needHeroIndexArrFiltrate.indexOf(i);
                            this.needHeroIndexArrFiltrate.splice(num, 1);
                        }
                    }
                    var pass = this.needHeroIndexArrFiltrate.indexOf(i);
                    if (pass == -1) {
                        this.needHeroIndexArrFiltrate.push(i);
                        var item = this.kexuanHeroList.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
                        var itemBase = new ItemBase(item, this, 2);
                        itemBase.setItemData(checkHeroID, checkRace, checkStar);
                        itemBase.setNumber(checkLevel);
                        item.data = i;
                        var arrIndex = this["hero" + ("" + this.moveItemArrIndex) + "Arr"].indexOf(i);
                        if (arrIndex == -1) {
                            itemBase.setGou(false);
                        }
                        else {
                            itemBase.setGou(true);
                        }
                        if (checkLock == 1 || checkBattle == 1) {
                            itemBase.isshowLock(true);
                        }
                        else {
                            itemBase.isshowLock(false);
                        }
                        this.onEgretEvent(item, egret.TouchEvent.TOUCH_TAP, this.xuandingcaozuo, this);
                    }
                }
                else {
                    var star = Math.abs(addHeroID);
                    if (star == checkStar) {
                        var passUse = true;
                        for (var k = 0; k < 4; k++) {
                            var a = this["hero" + ("" + k) + "Arr"].indexOf(i);
                            if (this.moveItemArrIndex != k && a != -1) {
                                passUse = false;
                            }
                        }
                        if (passUse) {
                            var item = this.kexuanHeroList.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
                            var itemBase = new ItemBase(item, this, 2);
                            itemBase.setItemData(checkHeroID, checkRace, checkStar);
                            itemBase.setNumber(checkLevel);
                            item.data = i;
                            var arrIndex = this["hero" + ("" + this.moveItemArrIndex) + "Arr"].indexOf(i);
                            if (arrIndex == -1) {
                                itemBase.setGou(false);
                            }
                            else {
                                itemBase.setGou(true);
                            }
                            if (checkLock == 1 || checkBattle == 1) {
                                itemBase.isshowLock(true);
                            }
                            else {
                                itemBase.isshowLock(false);
                            }
                            this.onEgretEvent(item, egret.TouchEvent.TOUCH_TAP, this.xuandingcaozuo, this);
                        }
                    }
                }
            }
        }
    };
    //选择材料英雄
    CardDegreeView.prototype.xuandingcaozuo = function (obj) {
        var heroIndex = obj.target.data; //卡牌数组下标
        var cardArr = MyData.user.json.cardArr;
        var checkLock = cardArr[heroIndex].lock;
        var checkBattle = cardArr[heroIndex].battle;
        if (checkLock == 1 || checkBattle == 1) {
            TipsViewSystem.show("不能合成已锁定或防守阵容的英雄");
            return false;
        }
        var itemBase = new ItemBase(obj.target, this, 2);
        var arrIndex = this["hero" + ("" + this.moveItemArrIndex) + "Arr"].indexOf(heroIndex);
        if (arrIndex == -1) {
            var needCount = this.needHeroIDCountArr[this.moveItemArrIndex];
            var count = this["hero" + ("" + this.moveItemArrIndex) + "Arr"].length;
            if (count < needCount) {
                itemBase.setGou(true);
                this["hero" + ("" + this.moveItemArrIndex) + "Arr"].push(heroIndex);
            }
        }
        else {
            itemBase.setGou(false);
            this["hero" + ("" + this.moveItemArrIndex) + "Arr"].splice(arrIndex, 1);
        }
    };
    //选中确认
    CardDegreeView.prototype.xuanzhongQuery = function () {
        this.needHeroIndexArrFiltrate = [];
        this.ui.getController("c1").selectedIndex = (0);
        for (var i = 0; i < 4; i++) {
            var count_1 = this["hero" + ("" + i) + "Arr"].length;
            for (var j = 0; j < count_1; j++) {
                this.needHeroIndexArrFiltrate.push(this["hero" + ("" + i) + "Arr"][j]);
            }
        }
        var item = this.ui.getChild(this.moveItemArr[this.moveItemArrIndex]).asCom;
        var itemBase = new ItemBase(item, this, 2);
        var count = this["hero" + ("" + this.moveItemArrIndex) + "Arr"].length;
        var needCount = this.needHeroIDCountArr[this.moveItemArrIndex];
        itemBase.setnumberOut(count + "/" + needCount);
        if (count == needCount) {
            itemBase.seticonGray(true);
        }
        else {
            itemBase.seticonGray(false);
        }
        this.satisfy();
    };
    //判断是否已满足合成条件
    CardDegreeView.prototype.satisfy = function () {
        this.needHeroIndexArr = [];
        var num = this.needHeroIDCountArr.length;
        var pass = true;
        for (var i = 0; i < num; i++) {
            var heroCount = this["hero" + ("" + i) + "Arr"].length;
            var count = this.needHeroIDCountArr[i];
            if (heroCount != count) {
                //ak.log("卡牌英雄不足");
                this.hechengBtn.enabled = false;
                pass = false;
            }
            for (var j = 0; j < heroCount; j++) {
                this.needHeroIndexArr.push(this["hero" + ("" + i) + "Arr"][j]);
            }
        }
        if (pass) {
            this.hechengBtn.enabled = true;
        }
        //更新红点
        for (var k = 0; k < num; k++) {
            var usedHeroCount = this["hero" + ("" + k) + "Arr"].length;
            var item = this.ui.getChild(this.moveItemArr[k]).asCom;
            var itemBase = new ItemBase(item, this, 2);
            var count = this.needHeroIDCountArr[k];
            var red = CardMgr.isCardOneCompose(Math.abs(this.needHeroIDArr[k]), this.selectRace, count, usedHeroCount, this.needHeroIndexArr);
            itemBase.isshowreddot(red);
        }
    };
    //选中现象卡
    CardDegreeView.prototype.selectXuanxiangka = function () {
        this.xuanxiangkaRace = this.ui.getChild("n19").asCom.getController("qiehuan").selectedIndex;
        this.updateList();
    };
    return CardDegreeView;
}(ak.EasyUI));
__reflect(CardDegreeView.prototype, "CardDegreeView");
/**
 * 卡牌分解数据
 */
var AcquisitionData = (function () {
    function AcquisitionData() {
        this.heroPromotionTab = ak.JsonTableMgr.get("heroPromotion");
        this.heroLvTab = ak.JsonTableMgr.get("heroLv");
        this.heroRecycleTab = ak.JsonTableMgr.get("heroRecycle");
        this.stoneTab = ak.JsonTableMgr.get("stone");
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    AcquisitionData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new AcquisitionData();
        }
        return Class._instance;
    };
    /**根据cardIndex返回道具数组 */
    AcquisitionData.prototype.GetCardAllItemData = function (cardIndex) {
        this.heroInfo = MyData.user.json.cardArr[cardIndex];
        this.itemObj = {};
        this.resourceObj = { "money": 0, "cardExp": 0 };
        this.equ();
        this.upStar();
        this.upLevel();
        this.baoshi();
        this.cardBasics();
        var dataObj = {};
        dataObj["itemObj"] = this.itemObj;
        dataObj["resourceObj"] = this.resourceObj;
        return dataObj;
    };
    /**归还5种物品*/
    AcquisitionData.prototype.equ = function () {
        var arr = ["arm", "head", "ring", "clothes", "looking"];
        for (var i = 0; i < arr.length; i++) {
            var equID = this.heroInfo[arr[i]];
            if (equID) {
                if (this.itemObj[equID]) {
                    this.itemObj[equID] += 1;
                }
                else {
                    this.itemObj[equID] = 1;
                }
            }
        }
    };
    /**归还升星材料（item 金币） */
    AcquisitionData.prototype.upStar = function () {
        var money = 0;
        var star = this.heroInfo.star - 1;
        for (var i = 0; i < star; i++) {
            var row = this.heroPromotionTab.getRow(i);
            money += Number(row.getValFromColName("gold"));
            var itemID = Number(row.getValFromColName("item"));
            var itemCount = Number(row.getValFromColName("cost"));
            if (this.itemObj[itemID]) {
                this.itemObj[itemID] += itemCount;
            }
            else {
                this.itemObj[itemID] = itemCount;
            }
        }
        if (money > 0) {
            this.resourceObj["money"] += money;
        }
    };
    /**归还升级材料（英雄经验 金币） */
    AcquisitionData.prototype.upLevel = function () {
        var money = 0;
        var heroExp = 0;
        var level = this.heroInfo.level - 1;
        for (var i = 1; i <= level; i++) {
            var row = this.heroLvTab.getRowFromColName("lv", "" + i);
            money += Number(row.getValFromColName("gold"));
            heroExp += Number(row.getValFromColName("heroExp"));
        }
        if (money > 0) {
            this.resourceObj["money"] += money;
        }
        if (heroExp > 0) {
            this.resourceObj["cardExp"] += heroExp;
        }
    };
    /**归还宝石材料item */
    AcquisitionData.prototype.baoshi = function () {
        var money = 0;
        var gemLevel = this.heroInfo.gemLevel - 1;
        for (var i = 0; i < gemLevel; i++) {
            var row = this.stoneTab.getRow(i);
            money += Number(row.getValFromColName("levelGold"));
            var itemID = Number(row.getValFromColName("levelItemID"));
            var levelNum = Number(row.getValFromColName("levelNum"));
            if (this.itemObj[itemID]) {
                this.itemObj[itemID] += levelNum;
            }
            else {
                this.itemObj[itemID] = levelNum;
            }
        }
        if (money > 0) {
            this.resourceObj["money"] += money;
        }
    };
    /**归还卡牌基础资源 */
    AcquisitionData.prototype.cardBasics = function () {
        var starMax = this.heroInfo.starMax;
        var info = this.heroRecycleTab.getRowFromColName("star", starMax);
        var heroExp = Number(info.getValFromColName("heroExp"));
        //归还卡牌升级经验
        this.resourceObj["cardExp"] += heroExp;
        //归还物品
        var itemStr = info.getValFromColName("item");
        var arr = itemStr;
        var num = arr.length;
        for (var i = 0; i < num; i += 2) {
            var itemID = arr[i];
            var itemCount = arr[i + 1];
            if (this.itemObj[itemID]) {
                this.itemObj[itemID] += Number(itemCount);
            }
            else {
                this.itemObj[itemID] = Number(itemCount);
            }
        }
    };
    return AcquisitionData;
}());
__reflect(AcquisitionData.prototype, "AcquisitionData");
//分解预览界面
var AcquisitionView = (function (_super) {
    __extends(AcquisitionView, _super);
    function AcquisitionView(cardIndexArr) {
        var _this = _super.call(this, CardDisintegrateViewSystem.inst, MyGame.inst.mainCityLayer) || this;
        _this.cardIndexArr = [];
        _this.cardIndexArr = cardIndexArr;
        return _this;
    }
    //初始化回调
    AcquisitionView.prototype.onInit = function () {
        this.ui = this.create("CardDisintegrate", "AcquisitionView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.btnClose = this.ui.getChild("n66").asButton;
        this.itemList = this.ui.getChild("n65").asList;
        this.itemTab = ak.JsonTableMgr.get("item");
        this.itemEquipTab = ak.JsonTableMgr.get("itemEquip");
        this.itemShipinTab = ak.JsonTableMgr.get("itemShipin");
        this.clickAdd();
        this.getlistData();
    };
    AcquisitionView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this); //关闭界面
        this.addClickListener(this.btnClose, this.onClick, this); //关闭界面
    };
    AcquisitionView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
            case this.btnClose:
                this.close();
                break;
        }
    };
    //列表数据
    AcquisitionView.prototype.getlistData = function () {
        this.itemObj = {};
        this.resourceObj = {};
        for (var i = 0; i < this.cardIndexArr.length; i++) {
            var obj = AcquisitionData.inst().GetCardAllItemData(this.cardIndexArr[i]);
            for (var i_4 in obj) {
                if (i_4 == "itemObj") {
                    for (var j in obj[i_4]) {
                        if (this.itemObj[j]) {
                            this.itemObj[j] += obj[i_4][j];
                        }
                        else {
                            this.itemObj[j] = obj[i_4][j];
                        }
                    }
                }
                else if (i_4 == "resourceObj") {
                    for (var k in obj[i_4]) {
                        if (this.resourceObj[k]) {
                            this.resourceObj[k] += obj[i_4][k];
                        }
                        else {
                            this.resourceObj[k] = obj[i_4][k];
                        }
                    }
                }
            }
        }
        //ak.log(this.itemObj,this.resourceObj);
        this.showList();
    };
    //显示列表
    AcquisitionView.prototype.showList = function () {
        this.itemList.removeChildrenToPool(); //清空列表
        for (var itemID in this.itemObj) {
            var item = this.itemList.addItemFromPool().asCom;
            var itemBase = new ItemBase(item, this, 1);
            var count = this.itemObj[itemID];
            var itemData = this.itemTab.getRowFromColName("id", "" + itemID);
            var usetype = Number(itemData.getValFromColName("usetype")); //使用类型（1=可使用道具，2=不可使用道具，3=饰品碎片，4=卡牌碎片，5=装备，6=饰品）
            var race = 0;
            var star = 0;
            if (usetype == 5) {
                var itemData_1 = this.itemEquipTab.getRowFromColName("id", "" + itemID);
                star = Number(itemData_1.getValFromColName("star"));
            }
            else if (usetype == 6) {
                var itemData_2 = this.itemShipinTab.getRowFromColName("id", "" + itemID);
                star = Number(itemData_2.getValFromColName("star"));
                race = Number(itemData_2.getValFromColName("race"));
            }
            itemBase.setItemData(Number(itemID));
            itemBase.setStar2(star);
            itemBase.setNumber(count, true);
        }
        for (var id in this.resourceObj) {
            if (this.resourceObj[id]) {
                var item = this.itemList.addItemFromPool().asCom;
                var itemBase = new ItemBase(item, this, 3);
                if (id == "money") {
                    itemBase.setItemData(2);
                    itemBase.setNumber(this.resourceObj[id], true);
                }
                else if (id == "cardExp") {
                    itemBase.setItemData(4);
                    itemBase.setNumber(this.resourceObj[id], true);
                }
            }
        }
    };
    return AcquisitionView;
}(ak.EasyUI));
__reflect(AcquisitionView.prototype, "AcquisitionView");
//卡牌分解
var CardDisintegrateViewSystem = (function (_super) {
    __extends(CardDisintegrateViewSystem, _super);
    function CardDisintegrateViewSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CardDisintegrateViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("CardDisintegrate");
    };
    CardDisintegrateViewSystem.inst = new CardDisintegrateViewSystem("CardDisintegrate");
    return CardDisintegrateViewSystem;
}(ak.FairyGUI));
__reflect(CardDisintegrateViewSystem.prototype, "CardDisintegrateViewSystem");
//主界面
var CardDisintegrateView = (function (_super) {
    __extends(CardDisintegrateView, _super);
    function CardDisintegrateView() {
        var _this = _super.call(this, CardDisintegrateViewSystem.inst, MyGame.inst.mainCityLayer) || this;
        _this.selectHeroArr = [];
        return _this;
    }
    //初始化回调
    CardDisintegrateView.prototype.onInit = function () {
        DownViewSystem.hide();
        this.ui = this.create("CardDisintegrate", "CardDisintegrateView");
        this.closebtn = this.ui.getChild("closeBtn").asButton;
        this.fangru = this.ui.getChild("n35").asButton;
        this.fenjie = this.ui.getChild("n37").asButton;
        this.yulan = this.ui.getChild("n32").asButton;
        this.help = this.ui.getChild("n39").asButton;
        this.xuanxiangka = this.ui.getChild("n47").asCom;
        this.itemList = this.ui.getChild("n24").asList;
        this.heroCount = this.ui.getChild("n28").asTextField;
        this.item2004 = this.ui.getChild("n56").asTextField;
        this.cardExp = this.ui.getChild("n57").asTextField;
        this.heroshop = this.ui.getChild("n40").asButton;
        this.queren = this.ui.getChild("n65").asButton;
        this.quxiao = this.ui.getChild("n66").asButton;
        this.heroTab = ak.JsonTableMgr.get("hero");
        this.clickAdd();
        this.showViewStack();
    };
    CardDisintegrateView.prototype.clickAdd = function () {
        this.addClickListener(this.closebtn, this.onClick, this); //关闭界面
        this.addClickListener(this.xuanxiangka, this.onClick, this); //选项卡
        this.addClickListener(this.fenjie, this.onClick, this); //分解
        this.addClickListener(this.fangru, this.onClick, this); //放入
        this.addClickListener(this.help, this.onClick, this); //帮助
        this.addClickListener(this.yulan, this.onClick, this); //预览
        this.addClickListener(this.heroshop, this.onClick, this); //英雄商店
        this.addClickListener(this.queren, this.onClick, this); //确认分解
        this.addClickListener(this.quxiao, this.onClick, this); //取消分解
    };
    CardDisintegrateView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.closebtn:
                this.close();
                DownViewSystem.show();
                break;
            case this.xuanxiangka:
                this.showViewStack();
                break;
            case this.yulan:
                if (this.selectHeroArr.length == 0) {
                    TipsViewSystem.show("请放入需要分解的英雄");
                }
                else {
                    ak.FairyGUI.open(["AcquisitionView", this.selectHeroArr]);
                }
                break;
            case this.fenjie:
                var count = this.selectHeroArr.length;
                if (count == 0) {
                    TipsViewSystem.show("请放入需要分解的英雄");
                }
                else {
                    var cardArr = MyData.user.json.cardArr;
                    var pass = 1;
                    for (var i = 0; i < count; i++) {
                        var heroIndex = this.selectHeroArr[i];
                        var heroInfo = cardArr[heroIndex];
                        var starMax = heroInfo.starMax;
                        if (starMax >= 4) {
                            pass = 0;
                        }
                    }
                    if (pass) {
                        this.querenNet();
                    }
                    else {
                        this.ui.getController("querenUI").selectedIndex = 1;
                    }
                }
                break;
            case this.fangru:
                this.oneKeyHero();
                break;
            case this.help:
                ak.FairyGUI.open(["HelpTipsView", 0]);
                break;
            case this.heroshop:
                ak.FairyGUI.open(["HeroDecomposeShopView"]);
                break;
            case this.queren:
                if (this.selectHeroArr.length == 0) {
                    TipsViewSystem.show("请放入需要分解的英雄");
                }
                else {
                    this.querenNet();
                }
                break;
            case this.quxiao:
                this.ui.getController("querenUI").selectedIndex = 0;
                break;
        }
    };
    CardDisintegrateView.prototype.querenNet = function () {
        var _this = this;
        net.cardDecompose(this.selectHeroArr, function () {
            _this.ui.getController("querenUI").selectedIndex = 0;
            _this.selectHeroArr = [];
            _this.ui.getChild("n41").asTextField.text = "已放入英雄数量：0/10";
            _this.showViewStack();
        }, this);
    };
    //一键放入
    CardDisintegrateView.prototype.oneKeyHero = function () {
        var count = this.cardArr.length;
        var num = this.selectHeroArr.length;
        for (var i = 0; i < count; i++) {
            var race = this.cardArr[i][1].race;
            var lock = this.cardArr[i][1].lock;
            var battle = this.cardArr[i][1].battle;
            var cardIndex = this.cardArr[i][0];
            if (num < 10 && lock == 0 && battle == 0) {
                if (this.n19Index == 0) {
                    var arrIndex = this.selectHeroArr.indexOf(cardIndex);
                    if (arrIndex == -1) {
                        var listCount = this.itemList.numChildren;
                        for (var k = 0; k < listCount; k++) {
                            var item = this.itemList.getChildAt(k).asCom;
                            var index = item.data;
                            if (index == cardIndex) {
                                var itemBase = new ItemBase(item, this, 2);
                                itemBase.setGou(true);
                            }
                        }
                        this.selectHeroArr.push(cardIndex);
                        num++;
                    }
                }
                else {
                    if (this.n19Index == race) {
                        var arrIndex = this.selectHeroArr.indexOf(cardIndex);
                        if (arrIndex == -1) {
                            var listCount = this.itemList.numChildren;
                            for (var k = 0; k < listCount; k++) {
                                var item = this.itemList.getChildAt(k).asCom;
                                var index = item.data;
                                if (index == cardIndex) {
                                    var itemBase = new ItemBase(item, this, 2);
                                    itemBase.setGou(true);
                                }
                            }
                            this.selectHeroArr.push(cardIndex);
                            num++;
                        }
                    }
                }
            }
        }
        this.ui.getChild("n41").asTextField.text = "已放入英雄数量：" + num + "/10";
    };
    CardDisintegrateView.prototype.showViewStack = function () {
        //this.itemList.removeChildrenToPool();//清空列表
        this.cardArr = HeroBagData.cardArr();
        this.n19Index = this.ui.getChild("n47").asCom.getController("qiehuan").selectedIndex;
        var count = this.cardArr.length;
        this.heroCount.text = "英雄数量：" + count + "/" + CardMgr.getCardMaxCount();
        this.cardExp.text = Common.overLength(MyData.user.cardExp);
        var itemArr = MyData.user.json.itemArr;
        for (var j = 0; j < itemArr.length; j++) {
            var itemID = itemArr[j].itemID;
            if (itemID == 2004) {
                this.item2004.text = itemArr[j].count;
            }
        }
        this.cardArr.sort(this.cardArrStarSort);
        this.cardArr.sort(this.cardArrLockSort);
        this.showCardArr = [];
        for (var i = 0; i < count; i++) {
            if (this.n19Index) {
                var race = this.cardArr[i][1].race;
                if (this.n19Index == race) {
                    this.showCardArr.push(this.cardArr[i]);
                }
            }
            else {
                this.showCardArr.push(this.cardArr[i]);
            }
        }
        this.itemList.setVirtual();
        this.itemList.itemRenderer = this.updateList.bind(this);
        this.itemList.callbackThisObj = this;
        this.itemList.numItems = this.showCardArr.length;
    };
    //列表item数据
    CardDisintegrateView.prototype.updateList = function (i, item) {
        var heroID = this.showCardArr[i][1].heroID;
        var lock = this.showCardArr[i][1].lock;
        var race = this.showCardArr[i][1].race;
        var battle = this.showCardArr[i][1].battle;
        var starMax = this.showCardArr[i][1].starMax;
        var level = this.showCardArr[i][1].level;
        var cardIndex = this.showCardArr[i][0];
        if (this.n19Index == 0) {
            item.data = cardIndex;
            var itemBase = new ItemBase(item, this, 2);
            itemBase.setItemData(heroID, race, starMax);
            itemBase.setNumber(level);
            var arrIndex = this.selectHeroArr.indexOf(cardIndex);
            if (arrIndex != -1) {
                itemBase.setGou(true);
            }
            else {
                itemBase.setGou(false);
            }
            if (lock == 1 || battle == 1) {
                itemBase.isshowLock(true);
            }
            else {
                itemBase.isshowLock(false);
            }
            this.onEgretEvent(item, egret.TouchEvent.TOUCH_TAP, this.editItem, this);
        }
        else {
            if (this.n19Index == race) {
                item.data = cardIndex;
                var itemBase = new ItemBase(item, this, 2);
                itemBase.setItemData(heroID, race, starMax);
                itemBase.setNumber(level);
                var arrIndex = this.selectHeroArr.indexOf(cardIndex);
                if (arrIndex != -1) {
                    itemBase.setGou(true);
                }
                else {
                    itemBase.setGou(false);
                }
                if (lock == 1 || battle == 1) {
                    itemBase.isshowLock(true);
                }
                else {
                    itemBase.isshowLock(false);
                }
                this.onEgretEvent(item, egret.TouchEvent.TOUCH_TAP, this.editItem, this);
            }
        }
    };
    //点击英雄列表
    CardDisintegrateView.prototype.editItem = function (obj) {
        var heroIndex = obj.target.data;
        var lock = MyData.user.json.cardArr[heroIndex].lock;
        var battle = MyData.user.json.cardArr[heroIndex].battle;
        if (lock == 1 || battle == 1) {
            TipsViewSystem.show("不能分解已锁定或防守阵容的英雄");
            return false;
        }
        var itemBase = new ItemBase(obj.target, this, 2);
        var arrIndex = this.selectHeroArr.indexOf(heroIndex);
        if (arrIndex == -1) {
            var num = this.selectHeroArr.length;
            if (num < 10) {
                this.selectHeroArr.push(heroIndex);
                itemBase.setGou(true);
            }
            else {
                TipsViewSystem.show("放入英雄已超过限制");
            }
        }
        else {
            this.selectHeroArr.splice(arrIndex, 1);
            itemBase.setGou(false);
        }
        var heroNum = this.selectHeroArr.length;
        this.ui.getChild("n41").asTextField.text = "已放入英雄数量：" + heroNum + "/10";
    };
    /**
     * 星级排序
     */
    CardDisintegrateView.prototype.cardArrStarSort = function (a, b) {
        var astarMax = a[1].starMax;
        var bstarMax = b[1].starMax;
        var aheroID = a[1].heroID;
        var bheroID = b[1].heroID;
        if (astarMax < bstarMax)
            return -1;
        if (astarMax > bstarMax)
            return 1;
        if (astarMax == bstarMax) {
            if (aheroID < bheroID)
                return -1;
            if (aheroID > bheroID)
                return 1;
        }
        return 0;
    };
    /**
     * 锁定
     */
    CardDisintegrateView.prototype.cardArrLockSort = function (a, b) {
        var alock = a[1].lock;
        var block = b[1].lock;
        var astarMax = a[1].starMax;
        var bstarMax = b[1].starMax;
        var abattle = a[1].battle;
        var bbattle = b[1].battle;
        if (alock < block || abattle < bbattle)
            return -1;
        if (alock > block || abattle > bbattle)
            return 1;
        if (alock == block || abattle == bbattle) {
            if (astarMax < bstarMax)
                return -1;
            if (astarMax > bstarMax)
                return 1;
            var aheroID = a[1].heroID;
            var bheroID = b[1].heroID;
            if (astarMax == bstarMax) {
                if (aheroID < bheroID)
                    return -1;
                if (aheroID > bheroID)
                    return 1;
            }
        }
        return 0;
    };
    return CardDisintegrateView;
}(ak.EasyUI));
__reflect(CardDisintegrateView.prototype, "CardDisintegrateView");
//英雄分解商店界面
var HeroDecomposeShopSystem = (function (_super) {
    __extends(HeroDecomposeShopSystem, _super);
    function HeroDecomposeShopSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HeroDecomposeShopSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("CardDisintegrate");
    };
    HeroDecomposeShopSystem.inst = new HeroDecomposeShopSystem("CardDisintegrate");
    return HeroDecomposeShopSystem;
}(ak.FairyGUI));
__reflect(HeroDecomposeShopSystem.prototype, "HeroDecomposeShopSystem");
var HeroDecomposeShopView = (function (_super) {
    __extends(HeroDecomposeShopView, _super);
    function HeroDecomposeShopView() {
        return _super.call(this, HeroDecomposeShopSystem.inst, MyGame.inst.uiLayer2_1) || this;
    }
    //初始化
    HeroDecomposeShopView.prototype.onInit = function () {
        var ui = this.create("CardDisintegrate", "HeroDecomposeShopView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.hero_list = this.ui.getChild("n39").asList;
        this.reset_button = this.ui.getChild("n12").asButton;
        this.my_soul_stone = this.ui.getChild("n11").asCom;
        this.shopheroTab = ak.JsonTableMgr.get("shopHero");
        this.shopheroConfigTab = ak.JsonTableMgr.get("shopHeroConfig");
        this.clickAdd();
        this.setstaticView(); //设置重置按钮、我的灵魂石 数据
        this.showshopList(); //展示英雄商店内容
    };
    //事件监听添加
    HeroDecomposeShopView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this); //关闭界面
        this.addClickListener(this.reset_button, this.onClick, this); //重置按钮
        this.onFairyguiEvent(this.hero_list, fairygui.ItemEvent.CLICK, this.buyMarket, this);
    };
    //触发什么事件
    HeroDecomposeShopView.prototype.onClick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.reset_button://重置按钮事件
                net.shopHeroFlush(function () { _this.showshopList(); }, this); //英雄商店刷新
                break;
        }
    };
    //显示英雄商店内容
    HeroDecomposeShopView.prototype.showshopList = function () {
        ShopData.inst().setShopView(this, 0, this.hero_list, this.shopheroTab, '', MyData.user.json.heroShop.buyIDCountMap, this.my_soul_stone);
    };
    HeroDecomposeShopView.prototype.buyMarket = function (obj) {
        var item = obj.itemObject;
        for (var i = 0; i < 3; i++) {
            var itemCom = item.getChild("n1" + (i + 1)).asCom;
            var item1 = itemCom.getChild("n2").asCom; //获取元素中的物品栏
            if (this.hitTestPointWithFairyGUIComponent(itemCom, obj.stageX, obj.stageY)) {
                if (this.hitTestPointWithFairyGUIComponent(item1, obj.stageX, obj.stageY)) {
                    ak.FairyGUI.open(["WeaponTipsView", item1.data.id, item1.data.num, 1]);
                }
                else {
                    if (itemCom.data.limit - MyData.user.json.heroShop.buyIDCountMap[itemCom.data.index] != 0) {
                        if (SummonData.inst().GetItemnumByid(itemCom.data.CostItem) >= itemCom.data.CostNum) {
                            ak.FairyGUI.open(["ChooseTipsView", 3, '确定购买当前商品？', this.showshopList.bind(this), itemCom.data.index]);
                        }
                        else {
                            TipsViewSystem.show("灵魂石不够");
                            return;
                        }
                    }
                    else {
                        TipsViewSystem.show("当天购买次数已达到上限");
                        return;
                    }
                }
            }
        }
    };
    //重置按钮 我的灵魂石
    HeroDecomposeShopView.prototype.setstaticView = function () {
        var user = MyData.user;
        var photo_url_path = 'ui://common/token_lhs';
        //重置按钮
        var icon1 = this.reset_button.getChild("icon").asLoader;
        var number1 = this.reset_button.getChild("number").asTextField;
        var res_text = this.reset_button.getChild("title").asTextField;
        //我的灵魂石
        var icon2 = this.my_soul_stone.getChild("icon").asLoader;
        var number2 = this.my_soul_stone.getChild("number").asTextField;
        this.setLoaderUrl(icon1, photo_url_path);
        this.setLoaderUrl(icon2, photo_url_path);
        var shopheroConfigInfo = this.shopheroConfigTab.getRow(0);
        number1.text = shopheroConfigInfo.getValFromColName("freshNum");
        res_text.text = "重置";
        //我的灵魂石默认为0
        number2.text = "" + SummonData.inst().GetItemnumByid(shopheroConfigInfo.getValFromColName("freshCost"));
        Common.labelIsOverLenght(number2, number2.text);
    };
    return HeroDecomposeShopView;
}(ak.EasyUI));
__reflect(HeroDecomposeShopView.prototype, "HeroDecomposeShopView");
/**
 * 世界树系统 (0)
 */
var CardSubDoorViewSystem = (function (_super) {
    __extends(CardSubDoorViewSystem, _super);
    function CardSubDoorViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    CardSubDoorViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("CarSubDoorView");
    };
    CardSubDoorViewSystem.inst = new CardSubDoorViewSystem("CarSubDoorView");
    return CardSubDoorViewSystem;
}(ak.FairyGUI));
__reflect(CardSubDoorViewSystem.prototype, "CardSubDoorViewSystem");
/**
 * 世界树系统界面 (0)
 */
var CardSubDoorView = (function (_super) {
    __extends(CardSubDoorView, _super);
    function CardSubDoorView(stackView) {
        var _this = _super.call(this, CardSubDoorViewSystem.inst, stackView) || this;
        _this.itemAlpha = [1, 0.7, 0.5, 0.5, 0.7];
        _this.itemScale = [1, 0.8, 0.6, 0.6, 0.8];
        _this.itemX = [190, 17, 145, 342, 436];
        _this.itemY = [613, 556, 397, 385, 556];
        _this.index = 0;
        _this.raceGroup = [1, 2, 3, 4, 5];
        return _this;
    }
    //初始化回调
    CardSubDoorView.prototype.onInit = function () {
        var ui = this.create("CarSubDoorView", "CarSubDoorView");
        this.itemarr = [];
        this.index = 0;
        for (var i = 0; i < 5; i++) {
            var item = ui.getChild("item" + i).asCom;
            this.itemarr.push(item);
        }
        this.leftbtn = ui.getChild("leftbtn").asButton;
        this.rightbtn = ui.getChild("rightbtn").asButton;
        this.doorname = ui.getChild("doorname").asCom;
        this.img = this.doorname.getChild("img").asLoader;
        this.summonbtn1 = ui.getChild("summonbtn1").asButton;
        this.showtipsbtn = ui.getChild("showtipsbtn").asButton;
        this.addName();
        this.ClickAdd();
        this.setstaicView();
    };
    CardSubDoorView.prototype.ClickAdd = function () {
        this.addClickListener(this.leftbtn, this.onClick, this);
        this.addClickListener(this.rightbtn, this.onClick, this);
        this.addClickListener(this.summonbtn1, this.onClick, this);
        this.addClickListener(this.showtipsbtn, this.onClick, this);
    };
    CardSubDoorView.prototype.addName = function () {
        this.setLoaderUrl(this.img, "ui://CarSubDoorView/wz_sjs_" + (this.index + 1));
    };
    CardSubDoorView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.leftbtn:
                if (this.index == 0) {
                    this.index = 4;
                }
                else {
                    this.index -= 1;
                }
                this.itemHandle();
                break;
            case this.rightbtn:
                if (this.index == 4) {
                    this.index = 0;
                }
                else {
                    this.index += 1;
                }
                this.itemHandle();
                break;
            case this.summonbtn1:
                this.sendSummonHandle();
                break;
            case this.showtipsbtn:
                ak.FairyGUI.open(["RewardPreview", (this.index + 1)]);
                break;
        }
    };
    CardSubDoorView.prototype.itemHandle = function () {
        var _this = this;
        /**
         * 新增动画
         */
        var itemlist = [];
        var nums = [];
        var s = 0;
        var indexs = this.index;
        for (var r = 0; r < 5; r++) {
            if (indexs >= 0 && indexs + r < 5) {
                var numz = indexs + r;
                itemlist.push(this.itemarr[numz]);
                nums.push(indexs + r);
            }
            else {
                itemlist.push(this.itemarr[s]);
                nums.push(s);
                s++;
            }
        }
        this.leftbtn.touchable = false;
        this.rightbtn.touchable = false;
        this.showtipsbtn.visible = false;
        var _loop_6 = function (i) {
            egret.Tween.get(itemlist[i]).to({ x: this_5.itemX[i], y: this_5.itemY[i], scaleX: this_5.itemScale[i],
                scaleY: this_5.itemScale[i], alpha: this_5.itemAlpha[i] }, 300).call(function () {
                egret.Tween.removeTweens(itemlist[i]);
                _this.leftbtn.touchable = true;
                _this.rightbtn.touchable = true;
                _this.showtipsbtn.visible = true;
            });
        };
        var this_5 = this;
        for (var i = 0; i < 5; i++) {
            _loop_6(i);
        }
        this.doorname.alpha = 0;
        this.addName();
        egret.Tween.get(this.doorname).to({ alpha: 1 }, 600).call(function () {
            egret.Tween.removeTweens(_this.doorname);
        });
    };
    CardSubDoorView.prototype.setstaicView = function () {
        var icon = this.summonbtn1.getChild("icon").asLoader;
        var number = this.summonbtn1.getChild("number").asTextField;
        this.setLoaderUrl(icon, "ui://common/token_gs");
        number.text = "1";
    };
    CardSubDoorView.prototype.sendSummonHandle = function () {
        net.worldTreeRandomCard(this.raceGroup[this.index], function () {
        }, this);
    };
    return CardSubDoorView;
}(ak.EasyUI));
__reflect(CardSubDoorView.prototype, "CardSubDoorView");
var CardSubheroData = (function () {
    function CardSubheroData() {
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    CardSubheroData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new CardSubheroData();
        }
        return Class._instance;
    };
    /**
     * 根据index获取英雄数组
     *
     */
    CardSubheroData.prototype.GetItemGroupInfo = function (index) {
        var heroGroups = [];
        var heroTab = ak.JsonTableMgr.get("hero");
        switch (index) {
            case 0:
                for (var i = 0; i < HeroBagData.cardArr().length; i++) {
                    var heroInfo = heroTab.getRowFromColName("id", "" + HeroBagData.cardArr()[i][1].heroID);
                    var type = heroInfo.getValFromColName("race");
                    if (type != 5 && type != 6 && HeroBagData.cardArr()[i][1].starMax < 6 && HeroBagData.cardArr()[i][1].starMax >= 4) {
                        heroGroups.push(HeroBagData.cardArr()[i]);
                    }
                }
                heroGroups.sort(HeroBagData.inst().GroupSort1);
                break;
            case 1:
            case 2:
            case 3:
            case 4:
                for (var i = 0; i < HeroBagData.cardArr().length; i++) {
                    var heroInfo = heroTab.getRowFromColName("id", "" + HeroBagData.cardArr()[i][1].heroID);
                    var type = heroInfo.getValFromColName("race");
                    if (type == index && HeroBagData.cardArr()[i][1].starMax < 6 && HeroBagData.cardArr()[i][1].starMax >= 4) {
                        heroGroups.push(HeroBagData.cardArr()[i]);
                    }
                }
                heroGroups.sort(HeroBagData.inst().GroupSort1);
                break;
        }
        return heroGroups;
    };
    return CardSubheroData;
}());
__reflect(CardSubheroData.prototype, "CardSubheroData");
/**
 * 世界树系统
 */
var CardSubstitutionViewSystem = (function (_super) {
    __extends(CardSubstitutionViewSystem, _super);
    function CardSubstitutionViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    CardSubstitutionViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("CardSubstitutionView");
    };
    CardSubstitutionViewSystem.inst = new CardSubstitutionViewSystem("CardSubstitutionView");
    return CardSubstitutionViewSystem;
}(ak.FairyGUI));
__reflect(CardSubstitutionViewSystem.prototype, "CardSubstitutionViewSystem");
/**
 * 世界树系统界面
 */
var CardSubstitutionView = (function (_super) {
    __extends(CardSubstitutionView, _super);
    function CardSubstitutionView() {
        var _this = _super.call(this, CardSubstitutionViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
        _this.index = 0;
        return _this;
    }
    //初始化回调
    CardSubstitutionView.prototype.onInit = function () {
        var ui = this.create("CardSubstitutionView", "CardSubstitutionView");
        this.on("netmsg://worldTree/randomCardResult", this.setstaicView, this);
        this.on("netmsg://worldTree/cardSwapResult", this.setstaicView, this);
        this.ViewStack1 = this.ui.getChild("ViewStack1").asGraph;
        this.ViewStack2 = this.ui.getChild("ViewStack2").asGraph;
        this.closebtn = this.ui.getChild("closebtn").asButton;
        this.tipsbtn = this.ui.getChild("tipsbtn").asButton;
        this.leftbtn = this.ui.getChild("tab").asCom.getChild("leftbtn").asButton;
        this.rightbtn = this.ui.getChild("tab").asCom.getChild("rightbtn").asButton;
        this.itemnum1 = this.ui.getChild("itemnum1").asCom;
        this.itemnum2 = this.ui.getChild("itemnum2").asCom;
        this.index = 0;
        this.ClickAdd();
        this.showViewStack();
        this.setstaicView();
    };
    CardSubstitutionView.prototype.ClickAdd = function () {
        this.addClickListener(this.closebtn, this.onClick, this);
        this.addClickListener(this.leftbtn, this.onClick, this);
        this.addClickListener(this.rightbtn, this.onClick, this);
        this.addClickListener(this.tipsbtn, this.onClick, this);
    };
    CardSubstitutionView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.closebtn:
                this.close();
                break;
            case this.leftbtn:
                this.index = 0;
                this.showViewStack();
                break;
            case this.rightbtn:
                this.index = 1;
                this.showViewStack();
                break;
            case this.tipsbtn:
                ak.FairyGUI.open(["HelpTipsView", 3]);
                break;
        }
    };
    /**根据index切换子页面 */
    CardSubstitutionView.prototype.showViewStack = function () {
        this.ViewStack2.visible = this.index == 0;
        this.ViewStack2.visible = this.index != 0;
        if (this.index == 0) {
            ak.FairyGUI.open(["CardSubDoorView", this.ViewStack1]);
        }
        else {
            ak.FairyGUI.open(["CardSubheroView", this.ViewStack2]);
        }
    };
    CardSubstitutionView.prototype.setstaicView = function () {
        var icon1 = this.itemnum1.getChild("icon").asLoader;
        var number1 = this.itemnum1.getChild("number").asTextField;
        var icon2 = this.itemnum2.getChild("icon").asLoader;
        var number2 = this.itemnum2.getChild("number").asTextField;
        this.setLoaderUrl(icon1, "ui://common/token_gs");
        this.setLoaderUrl(icon2, "ui://common/token_jh");
        number1.text = "" + SummonData.inst().GetItemnumByid(2011);
        number2.text = "" + SummonData.inst().GetItemnumByid(2012);
        this.leftbtn.getChild("title").asTextField.text = "世界树";
        this.rightbtn.getChild("title").asTextField.text = "英雄置换";
    };
    return CardSubstitutionView;
}(ak.EasyUI));
__reflect(CardSubstitutionView.prototype, "CardSubstitutionView");
/**
 * 世界树系统 (子系统)
 */
var CardSubheroViewSystem = (function (_super) {
    __extends(CardSubheroViewSystem, _super);
    function CardSubheroViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    CardSubheroViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("CarSubheroView");
    };
    CardSubheroViewSystem.inst = new CardSubheroViewSystem("CarSubheroView");
    return CardSubheroViewSystem;
}(ak.FairyGUI));
__reflect(CardSubheroViewSystem.prototype, "CardSubheroViewSystem");
/**
 * 世界树系统界面 (子系统)
 * 世界聚焦于你
 */
var CardSubheroView = (function (_super) {
    __extends(CardSubheroView, _super);
    function CardSubheroView(stackView) {
        var _this = _super.call(this, CardSubheroViewSystem.inst, stackView) || this;
        _this.index = 0;
        _this.itemGroups = [];
        _this.nowheroIndex = 0;
        return _this;
    }
    //初始化回调
    CardSubheroView.prototype.onInit = function () {
        var ui = this.create("CarSubheroView", "CarSubheroView");
        this.btnList = [];
        this.substitutionbtn = ui.getChild("substitutionbtn").asButton;
        this.surebtn = ui.getChild("surebtn").asButton;
        this.cancelbtn = ui.getChild("cancelbtn").asButton;
        this.list = ui.getChild("list").asList;
        this.itemlist = ui.getChild("itemlist").asCom;
        this.unknownimg = ui.getChild("unknownimg").asImage;
        this.btn0 = this.itemlist.getChild("btn0").asButton;
        this.btn1 = this.itemlist.getChild("btn1").asButton;
        this.btn2 = this.itemlist.getChild("btn2").asButton;
        this.btn3 = this.itemlist.getChild("btn3").asButton;
        this.btn4 = this.itemlist.getChild("btn4").asButton;
        this.btn5 = this.itemlist.getChild("btn5").asButton;
        this.btn6 = this.itemlist.getChild("btn6").asButton;
        this.hero1 = this.ui.getChild("hero1").asGraph;
        this.hero2 = this.ui.getChild("hero2").asGraph;
        this.itemlistGroup = this.ui.getChild("itemlistGroup").asGroup;
        this.name1 = this.ui.getChild("name1").asTextField;
        this.name2 = this.ui.getChild("name2").asTextField;
        this.lv1 = this.ui.getChild("lv1").asTextField;
        this.lv2 = this.ui.getChild("lv2").asTextField;
        this.star1 = this.ui.getChild("star1").asCom;
        this.star2 = this.ui.getChild("star2").asCom;
        this.race1 = this.ui.getChild("race1").asLoader;
        this.race2 = this.ui.getChild("race2").asLoader;
        this._iconY = this.unknownimg.y;
        this._iconMoveY = this.unknownimg.y - 10;
        this.isFrist = true;
        this.ClickAdd();
        this.itemHandle();
        this.setstaicView();
        this.updateListInfo();
    };
    CardSubheroView.prototype.ClickAdd = function () {
        this.addClickListener(this.substitutionbtn, this.onClick, this);
        this.addClickListener(this.surebtn, this.onClick, this);
        this.addClickListener(this.cancelbtn, this.onClick, this);
        this.addClickListener(this.btn0, this.onClick, this);
        this.addClickListener(this.btn1, this.onClick, this);
        this.addClickListener(this.btn2, this.onClick, this);
        this.addClickListener(this.btn3, this.onClick, this);
        this.addClickListener(this.btn4, this.onClick, this);
        this.onFairyguiEvent(this.list, fairygui.ItemEvent.CLICK, this.itemonclick, this);
    };
    CardSubheroView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.substitutionbtn:
                this.substitution();
                break;
            case this.surebtn:
                this.sure();
                break;
            case this.cancelbtn:
                this.cancel();
                break;
            case this.btn0:
                this.index = 0;
                this.updateListInfo();
                break;
            case this.btn1:
                this.index = 1;
                this.updateListInfo();
                break;
            case this.btn2:
                this.index = 2;
                this.updateListInfo();
                break;
            case this.btn3:
                this.index = 3;
                this.updateListInfo();
                break;
            case this.btn4:
                this.index = 4;
                this.updateListInfo();
                break;
        }
    };
    CardSubheroView.prototype.itemonclick = function (e) {
        for (var i = 0; i < this.list.numItems; i++) {
            if (this.list.getChildAt(i).data.index == e.itemObject.data.index) {
                var item = this.list.getChildAt(i).asCom;
                var items = new ItemBase(item, this, 2);
                items.setItemData(this.itemGroups[i][1].heroID, this.itemGroups[i][1].race, this.itemGroups[i][1].starMax);
                items.setNumber(this.itemGroups[i][1].level);
                items.setGou(true);
                this.updatehero1(this.itemGroups[i][1].heroID);
                this.updateheroInfo1(this.itemGroups[i]);
                this.updateBtnNum(this.itemGroups[i][1].starMax);
            }
            else {
                var item = this.list.getChildAt(i).asCom;
                var items = new ItemBase(item, this, 2);
                items.setItemData(this.itemGroups[i][1].heroID, this.itemGroups[i][1].race, this.itemGroups[i][1].starMax);
                items.setNumber(this.itemGroups[i][1].level);
                items.setGou(false);
            }
        }
        this.nowheroIndex = e.itemObject.data.index;
    };
    CardSubheroView.prototype.itemHandle = function () {
        this.unknownimg.visible = true;
        egret.Tween.removeTweens(this.unknownimg);
        egret.Tween.get(this.unknownimg, { loop: true }).to({ y: this._iconMoveY }, 1000).to({ y: this._iconY }, 1000);
    };
    CardSubheroView.prototype.setstaicView = function () {
        var icon = this.substitutionbtn.getChild("icon").asLoader;
        var number = this.substitutionbtn.getChild("number").asTextField;
        this.setLoaderUrl(icon, "ui://common/token_jh");
        number.text = "100";
        this.btn5.visible = false;
        this.btn6.visible = false;
        this.surebtn.visible = false;
        this.cancelbtn.visible = false;
        this.itemlistGroup.visible = true;
    };
    CardSubheroView.prototype.updateListInfo = function () {
        this.itemGroups = CardSubheroData.inst().GetItemGroupInfo(this.index);
        this.list.removeChildrenToPool();
        for (var i = 0; i < this.itemGroups.length; i++) {
            var item = this.list.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
            item.data = { index: this.itemGroups[i][0] };
            var items = new ItemBase(item, this, 2);
            items.setItemData(this.itemGroups[i][1].heroID, this.itemGroups[i][1].race, this.itemGroups[i][1].starMax);
            items.setNumber(this.itemGroups[i][1].level);
        }
        this.onceChosse();
    };
    /**设置第一个位为选中 */
    CardSubheroView.prototype.onceChosse = function () {
        for (var i = 0; i < this.list.numItems; i++) {
            var item = this.list.getChildAt(i).asCom;
            var items = new ItemBase(item, this, 2);
            items.setItemData(this.itemGroups[i][1].heroID, this.itemGroups[i][1].race, this.itemGroups[i][1].starMax);
            items.setNumber(this.itemGroups[i][1].level);
            items.setGou(false);
            if (i == 0) {
                items.setGou(true);
                this.nowheroIndex = item.data.index;
                this.updatehero1(this.itemGroups[i][1].heroID);
                this.updateheroInfo1(this.itemGroups[i]);
                this.updateBtnNum(this.itemGroups[i][1].starMax);
                this.updatehero2(0);
            }
        }
    };
    /**更新第一个hero */
    CardSubheroView.prototype.updatehero1 = function (id) {
        if (!this.heroNode1) {
            this.heroNode1 = new egret.DisplayObjectContainer();
            this.hero1.setNativeObject(this.heroNode1);
        }
        this.heroNode1.removeChildren();
        var hero = new Hero(id).addToParent(this.heroNode1);
        hero.x = 150;
        hero.y = 370;
    };
    /**更新第二个hero */
    CardSubheroView.prototype.updatehero2 = function (id) {
        if (id == 0) {
            this.hero2.visible = false;
            return;
        }
        else {
            this.hero2.visible = true;
        }
        if (!this.heroNode2) {
            this.heroNode2 = new egret.DisplayObjectContainer();
            this.hero2.setNativeObject(this.heroNode2);
        }
        this.heroNode2.removeChildren();
        // let tt = new egret.DisplayObjectContainer();
        // this.hero2.asGraph.setNativeObject(tt);
        var hero = new Hero(id).addToParent(this.heroNode2);
        hero.x = 150;
        hero.y = 370;
    };
    /**更新第一个hero的信息 */
    CardSubheroView.prototype.updateheroInfo1 = function (hero) {
        this.name1.text = HeroBagData.inst().GetNameById(hero[1].heroID);
        this.lv1.text = "" + hero[1].level;
        this.lv2.text = "" + hero[1].level;
        this.star1.getController("star").selectedIndex = hero[1].starMax;
        this.star2.getController("star").selectedIndex = hero[1].starMax;
        this.setLoaderUrl(this.race1, "ui://common/ico_zz" + (hero[1].race + 1));
        this.setLoaderUrl(this.race2, "ui://common/ico_zz" + (hero[1].race + 1));
    };
    /**更新第二个hero的信息 */
    CardSubheroView.prototype.updateheroInfo2 = function (heroID) {
        this.name2.text = HeroBagData.inst().GetNameById(heroID);
    };
    /**发送置换请求 */
    CardSubheroView.prototype.substitution = function () {
        var _this = this;
        var number = this.substitutionbtn.getChild("number").asTextField;
        var num = Number(number.text);
        var mynum = SummonData.inst().GetItemnumByid(2012);
        if (mynum < num) {
            TipsViewSystem.show("道具不足");
            return;
        }
        net.worldTreeCardSwap(this.nowheroIndex, function () {
            _this.isFrist = false;
            _this.unknownimg.visible = false;
            _this.substitutionbtn.visible = false;
            _this.surebtn.visible = true;
            _this.cancelbtn.visible = true;
            _this.itemlistGroup.visible = false;
            _this.updatehero2(MyData.user.json.worldTree.swapTargetHeroID);
            _this.updateheroInfo2(MyData.user.json.worldTree.swapTargetHeroID);
        }, this);
    };
    CardSubheroView.prototype.sure = function () {
        var _this = this;
        net.worldTreeCardSwapYes(this.nowheroIndex, function () {
            _this.isFrist = true;
            _this.unknownimg.visible = true;
            _this.substitutionbtn.visible = true;
            _this.surebtn.visible = false;
            _this.cancelbtn.visible = false;
            _this.updateListInfo();
            _this.updatehero2(0);
            _this.itemlistGroup.visible = true;
            _this.name2.text = "????";
        }, this);
    };
    CardSubheroView.prototype.cancel = function () {
        this.isFrist = true;
        this.unknownimg.visible = true;
        this.substitutionbtn.visible = true;
        this.surebtn.visible = false;
        this.cancelbtn.visible = false;
        this.updateListInfo();
        this.updatehero2(0);
        this.itemlistGroup.visible = true;
        this.name2.text = "????";
    };
    CardSubheroView.prototype.updateBtnNum = function (star) {
        var btnnum = star == 5 ? 100 : 20;
        var number = this.substitutionbtn.getChild("number").asTextField;
        number.text = "" + btnnum;
    };
    return CardSubheroView;
}(ak.EasyUI));
__reflect(CardSubheroView.prototype, "CardSubheroView");
var RewardPreviewSystem = (function (_super) {
    __extends(RewardPreviewSystem, _super);
    function RewardPreviewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    RewardPreviewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("RewardPreview");
    };
    RewardPreviewSystem.inst = new RewardPreviewSystem("RewardPreview");
    return RewardPreviewSystem;
}(ak.FairyGUI));
__reflect(RewardPreviewSystem.prototype, "RewardPreviewSystem");
/**
 * 世界树系统界面 (0)
 */
var RewardPreview = (function (_super) {
    __extends(RewardPreview, _super);
    function RewardPreview(indexID) {
        var _this = _super.call(this, RewardPreviewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.indexID = 1;
        _this.indexID = indexID;
        return _this;
    }
    //初始化回调
    RewardPreview.prototype.onInit = function () {
        var ui = this.create("RewardPreview", "RewardPreview");
        this.list = ui.getChild("list").asList;
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.ClickAdd();
        this.updatelistInfo();
    };
    RewardPreview.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
    };
    RewardPreview.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
        }
    };
    RewardPreview.prototype.updatelistInfo = function () {
        this.list.removeChildrenToPool();
        for (var i = 0; i < 2; i++) {
            var item = this.list.addItemFromPool().asCom;
            var title = item.getChild("title").asTextField;
            title.text = i == 0 ? RewardPreview.TITLE_0 : RewardPreview.TITLE_1;
            var itemlist = item.getChild("list").asList;
            itemlist.removeChildrenToPool();
            var itemGroup = [];
            itemGroup = i == 0 ? this.GetItem1() : this.GetItem2();
            for (var j = 0; j < itemGroup.length; j++) {
                var itemer = itemlist.addItemFromPool().asCom;
                var itemers = new ItemBase(itemer, this, 1);
                itemers.setItemData(itemGroup[j][0]);
                itemers.setNumber(itemGroup[j][1], true);
                itemers.setStar2(HeroBagData.inst().GetStarById2(itemGroup[j][0]));
                itemers.setType(HeroBagData.inst().GetRaceById2(itemGroup[j][0]));
            }
        }
        this.list.lineGap = (this.GetItem1().length / 4 - 2) * 100 + 30;
    };
    RewardPreview.prototype.GetItem1 = function () {
        var tab = ak.JsonTableMgr.get("heroWorldTreeConfig");
        var itemInfo = tab.getRowFromColName("id", "" + this.indexID);
        var item1 = itemInfo.getValFromColName("item1");
        var item1Group = [];
        var item1Group2 = item1;
        for (var i = 0; i < item1Group2.length; i += 2) {
            item1Group.push([Number(item1Group2[i]), Number(item1Group2[i + 1])]);
        }
        return item1Group;
    };
    RewardPreview.prototype.GetItem2 = function () {
        var tab = ak.JsonTableMgr.get("heroWorldTreeConfig");
        var itemInfo = tab.getRowFromColName("id", "" + this.indexID);
        var item2 = itemInfo.getValFromColName("item2");
        var item2Group = [];
        var item2Group2 = item2;
        for (var i = 0; i < item2Group2.length; i += 2) {
            item2Group.push([Number(item2Group2[i]), Number(item2Group2[i + 1])]);
        }
        return item2Group;
    };
    RewardPreview.TITLE_0 = "5星英雄（整卡掉率13%，碎片掉率12%）";
    RewardPreview.TITLE_1 = "4星英雄（整卡掉率65%，碎片掉率10%）";
    return RewardPreview;
}(ak.EasyUI));
__reflect(RewardPreview.prototype, "RewardPreview");
/**
 * 聊天系统
 */
var ChatViewSystem = (function (_super) {
    __extends(ChatViewSystem, _super);
    function ChatViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    ChatViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ChatView");
    };
    ChatViewSystem.inst = new ChatViewSystem("ChatView");
    return ChatViewSystem;
}(ak.FairyGUI));
__reflect(ChatViewSystem.prototype, "ChatViewSystem");
/**
 * 聊天界面
 */
var ChatView = (function (_super) {
    __extends(ChatView, _super);
    function ChatView() {
        return _super.call(this, ChatViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
    }
    /**回调 */
    ChatView.prototype.onInit = function () {
        var ui = this.create("ChatView", "ChatView");
        this.c1Controller = ui.getController("c1");
        this.c1Controller.selectedIndex = 1;
        //////////////世界聊天//////////////////////
        this.cross_serverbtn = ui.getChild("btn01").asButton;
        this.cross_serverbtn.visible = false;
        this.world_btn = ui.getChild("btn02").asButton;
        this.guild_btn = ui.getChild("btn03").asButton;
        this.recruit_btn = ui.getChild("btn04").asButton;
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.send_btn = ui.getChild("send_btn").asButton;
        this.input_text = ui.getChild("input_text").asTextField;
        this.msg_list = ui.getChild("msg_list").asList;
        this.msg_list.setVirtual();
        this.msg_list.itemRenderer = this.MsgListItemRender.bind(this);
        this.msg_list.itemProvider = this.getListItemResource;
        this.msg_list.callbackThisObj = this;
        ///////////////////公会聊天//////////////////////////
        this.guildMsgList = ui.getChild("guildMsgList").asList;
        this.guildMsgList.setVirtual();
        this.guildMsgList.itemRenderer = this.MsgListItemRender.bind(this);
        this.guildMsgList.itemProvider = this.getListItemResource;
        this.guildMsgList.callbackThisObj = this;
        ///////////////////公会招募//////////////////////////
        this.recruitList = ui.getChild("recruitList").asList;
        this.imgNoneTip = ui.getChild("imgNoneTip").asImage;
        this.on("netmsg://worldChat", this.updateView, this); //注册角色聊天事件
        this.ClickAdd();
        this.updateView();
        RedDotMgr.setChatRedDot(0);
        ak.EventMgr.dispatch(GameEvent.chatRedPoint);
    };
    ChatView.prototype.ClickAdd = function () {
        this.addClickListener(this.cross_serverbtn, this.onClick, this);
        this.addClickListener(this.world_btn, this.onClick, this);
        this.addClickListener(this.guild_btn, this.onClick, this);
        this.addClickListener(this.recruit_btn, this.onClick, this);
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.send_btn, this.onClickSendMsg, this);
        this.onFairyguiEvent(this.msg_list, fairygui.ItemEvent.CLICK, this.onClickItem, this);
        this.onFairyguiEvent(this.guildMsgList, fairygui.ItemEvent.CLICK, this.onClickItem, this);
        this.onFairyguiEvent(this.recruitList, fairygui.ItemEvent.CLICK, this.onClickRecruitItem, this);
    };
    //点击世界聊天头像
    ChatView.prototype.onClickItem = function (obj) {
        var item = obj.itemObject;
        var itemCom = item.getChild("itemCom").asCom;
        if (this.hitTestPointWithFairyGUIComponent(itemCom, obj.stageX, obj.stageY)) {
            net.getRoleBaseInfo(itemCom.data, function (msg) {
                ak.FairyGUI.open(["LookupInfoView", itemCom.data, msg]);
            }, this);
        }
    };
    //刷新头像
    ChatView.prototype.onFlushHeadItem = function (headIconCom, head_id, role_lv) {
        var items = new ItemBase(headIconCom, this, 2);
        items.setIcons2("hero" + head_id);
        items.setNumber(role_lv.toString(), true);
    };
    //刷新聊天list
    ChatView.prototype.updateView = function () {
        if (this.c1Controller.selectedIndex == 1) {
            var length_2 = MyData.worldChatArr.length;
            this.imgNoneTip.visible = length_2 == 0;
            this.msg_list.numItems = length_2;
            this.msg_list.scrollToView(length_2 - 1);
        }
        else if (this.c1Controller.selectedIndex == 2) {
            var length_3 = MyData.unionChatArr.length;
            this.imgNoneTip.visible = length_3 == 0;
            this.guildMsgList.numItems = length_3;
            this.guildMsgList.scrollToView(length_3 - 1);
        }
    };
    //根据索引的不同，返回不同的资源URL
    ChatView.prototype.getListItemResource = function (index) {
        var user_msg_data = [];
        if (this.c1Controller.selectedIndex == 1)
            user_msg_data = MyData.worldChatArr[index];
        else if (this.c1Controller.selectedIndex == 2)
            user_msg_data = MyData.unionChatArr[index];
        if (user_msg_data[0] == MyData.user.id)
            return "ui://ChatView/roleChatItem";
        else
            return "ui://ChatView/playerChatItem";
    };
    //角色聊天消息Item
    ChatView.prototype.MsgListItemRender = function (index, obj) {
        var user_msg_data = [];
        if (this.c1Controller.selectedIndex == 1)
            user_msg_data = MyData.worldChatArr[index];
        else if (this.c1Controller.selectedIndex == 2)
            user_msg_data = MyData.unionChatArr[index];
        var roleId = user_msg_data[0];
        var roleHead = user_msg_data[1];
        var roleName = user_msg_data[2];
        var roleLevel = user_msg_data[3];
        var roleVip = user_msg_data[4];
        var roleMsg = user_msg_data[5];
        var chatType = user_msg_data[6]; //聊天类型: 0 普通聊天 1 英雄分享信息 2 招募
        var channel = user_msg_data[7]; // 频道0 世界频道 1 招募频道 // 2 公会频道
        var guildId = user_msg_data[8]; //公会ID
        var chatTime = user_msg_data[9]; //聊天时间
        obj.asCom.getChild("role_name").asTextField.text = roleName;
        var itemCom = obj.asCom.getChild("itemCom").asCom;
        itemCom.data = roleId;
        this.onFlushHeadItem(itemCom, roleHead, roleLevel);
        var role_msg = obj.asCom.getChild("role_msg").asRichTextField;
        var msg = "";
        if (chatType == 0) {
            msg = Common.stringlinefeed(roleMsg, 20);
        }
        else if (chatType == 1) {
            var hero_data = JSON.parse(roleMsg);
            var heroTab = ak.JsonTableMgr.get("hero");
            var heroInfo = heroTab.getRowFromColName("id", "" + hero_data.heroID);
            var name_18 = "[" + heroInfo.getValFromColName("name") + "]"; //名称
            msg = "[color=" + Color.orange + "]" + name_18 + "[/color]";
            var clickTextCom = obj.asCom.getChild("clickTextCom").asCom;
            if (clickTextCom.hasClickListener() == false)
                this.addClickListener(clickTextCom, this.onClickLink, this);
            clickTextCom.data = hero_data;
        }
        role_msg.text = msg;
        obj.asCom.getChild("chat_time").asTextField.text = "[" + chatTime.slice(5, 16) + "]";
    };
    //点击文本
    ChatView.prototype.onClickLink = function (e) {
        var heroData = e.target.data;
        ak.FairyGUI.open(["HeroDataView", heroData.heroID, heroData]);
    };
    //点击发送消息
    ChatView.prototype.onClickSendMsg = function () {
        // console.log("玩家等级 ",MyData.user.level)
        if (MyData.user.level < 50 || MyData.user.vip < 17) {
            // if (MyData.user.level < 40) {
            TipsViewSystem.show("聊天需要达到50级且达到Vip17开放");
            return;
        }
        var msg_str = this.input_text.text;
        msg_str = SensitiveWordFilter.inst.replaceSensitiveWord(msg_str);
        if (msg_str == "") {
            TipsViewSystem.show("请输入聊天内容");
            return;
        }
        else {
            if (this.c1Controller.selectedIndex == 1) {
                net.sendWorldChat(msg_str, 0);
                this.input_text.text = "";
            }
            else if (this.c1Controller.selectedIndex == 2) {
                if (MyData.user.unionID != 0) {
                    net.sendUnionChat(msg_str, 0);
                    this.input_text.text = "";
                }
                else {
                    TipsViewSystem.show("未加入公会");
                    return;
                }
            }
        }
    };
    ChatView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.cross_serverbtn:
                this.c1Controller.selectedIndex = 0;
                this.input_text.text = "";
                break;
            case this.world_btn:
                this.c1Controller.selectedIndex = 1;
                this.input_text.text = "";
                this.updateView();
                break;
            case this.guild_btn:
                this.c1Controller.selectedIndex = 2;
                this.input_text.text = "";
                this.updateView();
                break;
            case this.recruit_btn:
                this.c1Controller.selectedIndex = 3;
                this.input_text.text = "";
                this.updateRecruitList();
                break;
            case this.bgclose:
                this.close();
                break;
        }
    };
    //刷新招募List
    ChatView.prototype.updateRecruitList = function () {
        var recruitChatArr = MyData.recruitChatArr;
        this.recruitList.removeChildrenToPool();
        this.imgNoneTip.visible = recruitChatArr.length == 0;
        for (var i = 0; i < recruitChatArr.length; i++) {
            var roleId = recruitChatArr[i][0];
            var roleHead = recruitChatArr[i][1];
            var roleName = recruitChatArr[i][2];
            var roleLevel = recruitChatArr[i][3];
            var roleVip = recruitChatArr[i][4];
            var roleMsg = recruitChatArr[i][5];
            var chatType = recruitChatArr[i][6]; //聊天类型: 0 普通聊天 1 英雄分享信息 2 招募
            var channel = recruitChatArr[i][7]; // 频道0 世界频道 1 招募频道 // 2 公会频道
            var guildID = recruitChatArr[i][8]; //公会ID
            var chatTime = recruitChatArr[i][9]; //聊天时间
            var item = this.recruitList.addItemFromPool().asCom;
            item.getChild("role_name").asTextField.text = roleName;
            var itemCom = item.getChild("itemCom").asCom;
            itemCom.data = roleId;
            this.onFlushHeadItem(itemCom, roleHead, roleLevel);
            var recruitMsg = item.getChild("recruitMsg").asRichTextField;
            recruitMsg.text = roleMsg;
            var btnApplyJoin = item.getChild("btnApplyJoin").asButton;
            btnApplyJoin.data = guildID;
            item.getChild("chat_time").asTextField.text = "[" + chatTime.slice(5, 16) + "]";
        }
        if (recruitChatArr.length != 0) {
            this.recruitList.scrollToView(recruitChatArr.length - 1);
        }
    };
    //点击世界聊天头像
    ChatView.prototype.onClickRecruitItem = function (obj) {
        var item = obj.itemObject;
        var itemCom = item.getChild("itemCom").asCom;
        var btnApplyJoin = item.getChild("btnApplyJoin").asButton;
        if (this.hitTestPointWithFairyGUIComponent(itemCom, obj.stageX, obj.stageY)) {
            net.getRoleBaseInfo(itemCom.data, function (msg) {
                ak.FairyGUI.open(["LookupInfoView", itemCom.data, msg]);
            }, this);
        }
        else {
            if (this.hitTestPointWithFairyGUIComponent(btnApplyJoin, obj.stageX, obj.stageY)) {
                net.reqUnion(btnApplyJoin.data, function () { }, this);
            }
        }
    };
    return ChatView;
}(ak.EasyUI));
__reflect(ChatView.prototype, "ChatView");
//选服数据
var ChooseData = (function () {
    function ChooseData() {
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    ChooseData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new ChooseData();
        }
        return Class._instance;
    };
    ChooseData.prototype.getchoose = function () {
        return this.choose;
    };
    ChooseData.prototype.getchooseuid = function () {
        console.log("选区setchoose=2222：", this.choose, this.chooseUid);
        return this.chooseUid;
    };
    ChooseData.prototype.setchoose = function (type, uid) {
        this.choose = type;
        this.chooseUid = uid;
        console.log("选区setchoose=：", this.choose, this.chooseUid);
    };
    return ChooseData;
}());
__reflect(ChooseData.prototype, "ChooseData");
//选服界面
var ChooseServerSystem = (function (_super) {
    __extends(ChooseServerSystem, _super);
    function ChooseServerSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ChooseServerSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ChooseServer");
    };
    ChooseServerSystem.inst = new ChooseServerSystem("ChooseServer");
    return ChooseServerSystem;
}(ak.FairyGUI));
__reflect(ChooseServerSystem.prototype, "ChooseServerSystem");
var ChooseServerView = (function (_super) {
    __extends(ChooseServerView, _super);
    function ChooseServerView() {
        return _super.call(this, ChooseServerSystem.inst, MyGame.inst.uiLayer2_2) || this;
    }
    ChooseServerView.prototype.onInit = function () {
        var ui = this.create("ChooseServer", "ChooseServerView");
        // console.log("=====ui:",ui)
        this.startgame = ui.getChild("startgame").asButton;
        this.chooserver = ui.getChild("chooserver").asButton;
        this.gonggao = ui.getChild("gonggao").asButton;
        this.tubiaoController = this.chooserver.getController("c1");
        this.plateNumber = ui.getChild("n20").asTextField;
        this.plateNumber2 = ui.getChild("n2101").asTextField;
        this.expbar = ui.getChild("expbar").asProgress;
        this.expbarText = ui.getChild("bartitle").asTextField;
        this.barDesc = ui.getChild("barDesc").asTextField;
        // this.exchangenum = ui.getChild("exchangenum").asTextInput;
        // this.exchangebtn = ui.getChild("exchangebtn").asButton;
        // this.startgame.x = 300
        // this.startgame.y = 0
        this.chooserver.visible = false;
        this.startgame.visible = false;
        this.expbar.visible = false;
        this.expbarText.visible = false;
        this.barDesc.visible = false;
        this.on(GameEvent.chooseServerView, this.updateView1, this);
        this.on(GameEvent.openChooseServerView, this.showLogin, this);
        this.on(GameEvent.openHotUpdateView, this.showHotUpdate, this);
        this.on(GameEvent.UpdatehotUpdateBar, this.hotUpdateBar, this);
        this.on(GameEvent.StopHotUpdateBar, this.StophotUpdateBar, this);
        this.on(GameEvent.StopHotUpdateDesc, this.hotUpdatedesc, this);
        MusicMgr.playSelectServerMusic();
        this.clickAdd();
        // this.updateView();
        if (MyConfig.loginType == 0) {
            this.plateNumber.visible = false;
            this.plateNumber2.visible = false;
        }
        // if(window["logo"]!="")
        // {
        //     this.setLoaderUrl(ui.getChild("logo").asLoader, window["logo"]);
        // }
        // this.addClickListener(this.exchangebtn,()=>{
        // 	let sn=this.exchangenum.text;
        // },this);
        // ak.FairyGUI.open(["LoginNotice"]);
    };
    ChooseServerView.prototype.clickAdd = function () {
        this.addClickListener(this.startgame, this.onClick, this);
        this.addClickListener(this.chooserver, this.onClick, this);
        this.addClickListener(this.gonggao, this.onClick, this);
    };
    ChooseServerView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.gonggao:
                break;
            case this.chooserver:
                ak.FairyGUI.open(["ChooseServerView1"]);
                break;
            case this.startgame://开始游戏
                if (MyData.serverList.length > 0) {
                    if (!this.isServerOpen) {
                        TipsViewSystem.show("当前服务器正在维护或者未开通");
                    }
                    else {
                        this.close();
                        this.saveLoginServerID();
                        this.saveLoginServerUserId();
                        MyGame.inst.enterGame();
                    }
                }
                break;
        }
    };
    ChooseServerView.prototype.stateGame = function () {
        if (MyData.serverList.length > 0) {
            if (!this.isServerOpen) {
                TipsViewSystem.show("当前服务器正在维护或者未开通");
            }
            else {
                this.close();
                this.saveLoginServerID();
                this.saveLoginServerUserId();
                MyGame.inst.enterGame();
            }
        }
    };
    //保存登录serverID
    ChooseServerView.prototype.saveLoginServerID = function () {
        var str = GameLocalStorage.loadByUid(GameLocalStorage.chooseServer);
        var arr;
        if (str) {
            arr = ak.json_decode(str);
        }
        else {
            arr = [];
        }
        var index = arr.indexOf(MyData.serverID);
        if (index >= 0) {
            arr.splice(index, 1);
        }
        arr.push(MyData.serverID);
        str = ak.json_encode(arr);
        GameLocalStorage.saveByUid(GameLocalStorage.chooseServer, str);
    };
    ChooseServerView.prototype.saveLoginServerUserId = function () {
        if (!MyData.account) {
            var str = GameLocalStorage.loadByUid(GameLocalStorage.chooseServerUid + MyData.serverID);
            if (str && str != undefined && str != "undefined" && str != "" && str != "0") {
                MyData.account = str;
            }
            else {
                if (MyData.accountList) {
                    for (var k = 0; k < MyData.accountList.length; k++) {
                        if (MyData.serverID == MyData.accountList[k].serverId) {
                            MyData.account = MyData.accountList[k].id;
                        }
                    }
                }
            }
        }
        GameLocalStorage.saveByUid(GameLocalStorage.chooseServerUid + MyData.serverID, MyData.account);
    };
    //获取登录serverID数组
    ChooseServerView.prototype.getLoginServerIDArr = function () {
        var str = GameLocalStorage.loadByUid(GameLocalStorage.chooseServer);
        var arr;
        if (str) {
            arr = ak.json_decode(str);
        }
        else {
            arr = [];
        }
        return arr;
    };
    ChooseServerView.prototype.updateView = function () {
        if (MyData.serverList.length == 0)
            return;
        this.tubiaoController.selectedIndex = 2;
        var btnText = this.chooserver.getChild("text").asTextField;
        var arr = this.getLoginServerIDArr();
        var count;
        if (arr.length == 0) {
            count = MyData.serverList.length;
            btnText.text = MyData.serverList[count - 1].name;
            this.tubiaoController.selectedIndex = Number(MyData.serverList[count - 1].status);
            if (MyData.serverList[count - 1].status == "3" || MyData.serverList[count - 1].status == "0") {
                this.isServerOpen = false;
                return;
            }
            this.isServerOpen = true;
            MyData.serverDomain = MyData.serverList[count - 1].domain;
            MyData.serverPort = MyData.serverList[count - 1].port;
            MyData.serverID = MyData.serverList[count - 1].id;
            //  this.exchangenum.text = MyData.serverID + ""
        }
        else {
            var id = arr[arr.length - 1];
            for (var i = 0; i < MyData.serverList.length; i++) {
                if (MyData.serverList[i].id == id) {
                    btnText.text = MyData.serverList[i].name;
                    this.tubiaoController.selectedIndex = Number(MyData.serverList[i].status);
                    if (MyData.serverList[i].status == "3" || MyData.serverList[i].status == "0") {
                        this.isServerOpen = false;
                        return;
                    }
                    this.isServerOpen = true;
                    MyData.serverDomain = MyData.serverList[i].domain;
                    MyData.serverPort = MyData.serverList[i].port;
                    MyData.serverID = MyData.serverList[i].id;
                    // this.exchangenum.text = MyData.serverID + ""
                    //  ak.log(),"这是状态")
                    break;
                }
            }
        }
    };
    ChooseServerView.prototype.updateView1 = function () {
        var index = ChooseData.inst().getchoose();
        var btnText = this.chooserver.getChild("text").asTextField;
        btnText.text = MyData.serverList[index].name;
        this.tubiaoController.selectedIndex = Number(MyData.serverList[index].status);
        if (MyData.serverList[index].status == "3" || MyData.serverList[index].status == "0") {
            this.isServerOpen = false;
            return;
        }
        this.isServerOpen = true;
        MyData.serverDomain = MyData.serverList[index].domain;
        MyData.serverPort = MyData.serverList[index].port;
        MyData.serverID = MyData.serverList[index].id;
        MyData.account = ChooseData.inst().getchooseuid();
        //  this.exchangenum.text = MyData.serverID + ""
    };
    /**显示登录 */
    ChooseServerView.prototype.showLogin = function () {
        this.chooserver.visible = true;
        this.startgame.visible = true;
        this.expbar.visible = false;
        this.expbarText.visible = false;
        this.barDesc.visible = false;
        this.updateView();
    };
    /**显示热更 */
    ChooseServerView.prototype.showHotUpdate = function () {
        this.chooserver.visible = false;
        this.startgame.visible = false;
        this.expbar.visible = true;
        this.expbarText.visible = true;
        this.barDesc.visible = true;
    };
    ChooseServerView.prototype.hotUpdateBar = function () {
        var _this = this;
        egret.Tween.removeTweens(this.expbar);
        egret.Tween.get(this.expbar, { loop: true }).to({}, 500).call(function () {
            _this.expbar.max = HotUpdate.inst.maxfileSize;
            _this.expbar.value = HotUpdate.inst.curfileSize;
            if (HotUpdate.inst.curHotUpState == "unZip") {
                _this.expbarText.text = "解压 " + Math.round(HotUpdate.inst.curfileSize / 1024 * 10) / 10 + "/" + Math.round(HotUpdate.inst.maxfileSize / 1024 * 10) / 10 + " M";
            }
            else {
                _this.expbarText.text = "下载 " + Math.round(HotUpdate.inst.curfileSize / 1024 * 10) / 10 + "/" + Math.round(HotUpdate.inst.maxfileSize / 1024 * 10) / 10 + " M";
            }
        });
    };
    ChooseServerView.prototype.hotUpdatedesc = function () {
        var stepData = HotUpdate.inst.curstepData;
        if (stepData) {
            var desc = "";
            desc = stepData.resName == "resource" ? "更新资源" : desc;
            desc = stepData.resName == "js" ? "更新ui" : desc;
            desc = stepData.resName == "ui" ? "更新脚本" : desc;
            desc = stepData.resName == "AppVersion" ? "版本更新" : desc;
            this.barDesc.text = desc;
        }
    };
    ChooseServerView.prototype.StophotUpdateBar = function () {
        this.off(GameEvent.chooseServerView, this.updateView1, this);
        this.off(GameEvent.openChooseServerView, this.showLogin, this);
        this.off(GameEvent.openHotUpdateView, this.showHotUpdate, this);
        this.off(GameEvent.UpdatehotUpdateBar, this.hotUpdateBar, this);
        this.off(GameEvent.StopHotUpdateBar, this.StophotUpdateBar, this);
        this.off(GameEvent.StopHotUpdateDesc, this.hotUpdatedesc, this);
        egret.Tween.removeTweens(this.expbar);
        this.close();
    };
    return ChooseServerView;
}(ak.EasyUI));
__reflect(ChooseServerView.prototype, "ChooseServerView");
//选服界面1
var ChooseServer1System = (function (_super) {
    __extends(ChooseServer1System, _super);
    function ChooseServer1System() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ChooseServer1System.prototype.init = function () {
        fairygui.UIPackage.addPackage("ChooseServer");
    };
    ChooseServer1System.inst = new ChooseServer1System("ChooseServer");
    return ChooseServer1System;
}(ak.FairyGUI));
__reflect(ChooseServer1System.prototype, "ChooseServer1System");
var ChooseServerView1 = (function (_super) {
    __extends(ChooseServerView1, _super);
    // private tubiaoController:fairygui.Controller;//图标控制器
    function ChooseServerView1() {
        var _this = _super.call(this, ChooseServer1System.inst, MyGame.inst.uiLayer2_2) || this;
        // private serverController:fairygui.Controller;
        _this.countPerPage = 10; //每页10条
        return _this;
    }
    ChooseServerView1.prototype.onInit = function () {
        var ui = this.create("ChooseServer", "ChooseServerView1");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.myserver = ui.getChild("myserver").asButton;
        this.serverlist0 = ui.getChild("serverlist0").asList;
        this.serverlist1 = ui.getChild("serverlist1").asList;
        this.clickAdd();
        this.updateList0();
        if (this.getLoginServerIDArr().length == 0 && this.totalPages() > 0) {
            this.updateList1(this.totalPages() - 1);
            this.myserver.selected = false;
            this.serverlist0.getChildAt(0).asButton.selected = true;
        }
        else {
            this.updateMyserver();
            this.myserver.selected = true;
        }
    };
    ChooseServerView1.prototype.totalPages = function () {
        var arr = MyData.serverList;
        var c = arr.length;
        return Math.ceil(c / this.countPerPage);
    };
    ChooseServerView1.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this); //关闭界面
        this.addClickListener(this.myserver, this.onClick, this);
        this.onFairyguiEvent(this.serverlist0, fairygui.ItemEvent.CLICK, this.onTouchserverlist0, this);
        this.onFairyguiEvent(this.serverlist1, fairygui.ItemEvent.CLICK, this.onTouchserverlist1, this);
    };
    ChooseServerView1.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.myserver:
                this.updateList0();
                this.updateMyserver();
                break;
        }
    };
    //更新左侧
    ChooseServerView1.prototype.updateList0 = function () {
        this.serverlist0.removeChildrenToPool();
        var count = Math.ceil(MyData.serverList.length / this.countPerPage);
        for (var i = count - 1; i >= 0; i--) {
            var info = this.serverlist0.addItemFromPool().asCom;
            var itemText = info.getChild("n4").asTextField;
            var b = i * this.countPerPage + 1;
            var e = b + ((i == (count - 1)) ? MyData.serverList.length % this.countPerPage : this.countPerPage) - 1;
            itemText.text = "" + b + "-" + e + "区";
            info.data = { index: i };
        }
    };
    //更新我的服务器
    ChooseServerView1.prototype.updateMyserver = function () {
        this.serverlist1.removeChildrenToPool();
        var arr_1 = this.getLoginServerIDArr(); //数组
        var count = arr_1.length;
        if (count > 0) {
            for (var i = (count - 1); i >= 0; i--) {
                for (var j = 0; j < MyData.serverList.length; j++) {
                    if (MyData.serverList[j].id == arr_1[i]) {
                        var myAcServer = this.checkMyServer(MyData.serverList[j].id);
                        if (myAcServer.length > 0) {
                            for (var f = 0; f < myAcServer.length; f++) {
                                var info = this.serverlist1.addItemFromPool().asCom;
                                var tubiaoController = info.getController("c1");
                                var itemText = info.getChild("servername").asTextField;
                                // let c1Controller = info.getController("c1");
                                // c1Controller.selectedIndex = 1;
                                var status_1 = MyData.serverList[j].status;
                                var statusText = info.getChild("statetext").asTextField;
                                if (status_1 == "0") {
                                    statusText.text = "[color=" + Color.white + "]\u672A\u5F00[/color]";
                                    tubiaoController.selectedIndex = 0;
                                }
                                else if (status_1 == "1") {
                                    statusText.text = "[color=" + Color.green + "]\u65B0\u670D[/color]";
                                    tubiaoController.selectedIndex = 1;
                                }
                                else if (status_1 == "2") {
                                    statusText.text = "[color=" + Color.red + "]\u706B\u7206[/color]";
                                    tubiaoController.selectedIndex = 2;
                                }
                                else {
                                    statusText.text = "[color=" + Color.white + "]\u7EF4\u62A4[/color]";
                                    tubiaoController.selectedIndex = 3;
                                }
                                itemText.text = MyData.serverList[j].name;
                                info.data = { index: j, myServer: myAcServer[f] };
                                statusText.text = "[color=" + Color.blue + "]" + (myAcServer[f].level + "级") + "[/color]";
                            }
                        }
                        else {
                            var info = this.serverlist1.addItemFromPool().asCom;
                            var tubiaoController = info.getController("c1");
                            var itemText = info.getChild("servername").asTextField;
                            // let c1Controller = info.getController("c1");
                            // c1Controller.selectedIndex = 1;
                            var status_2 = MyData.serverList[j].status;
                            var statusText = info.getChild("statetext").asTextField;
                            if (status_2 == "0") {
                                statusText.text = "[color=" + Color.white + "]\u672A\u5F00[/color]";
                                tubiaoController.selectedIndex = 0;
                            }
                            else if (status_2 == "1") {
                                statusText.text = "[color=" + Color.green + "]\u65B0\u670D[/color]";
                                tubiaoController.selectedIndex = 1;
                            }
                            else if (status_2 == "2") {
                                statusText.text = "[color=" + Color.red + "]\u706B\u7206[/color]";
                                tubiaoController.selectedIndex = 2;
                            }
                            else {
                                statusText.text = "[color=" + Color.white + "]\u7EF4\u62A4[/color]";
                                tubiaoController.selectedIndex = 3;
                            }
                            itemText.text = MyData.serverList[j].name;
                            info.data = { index: j };
                        }
                    }
                }
            }
        }
    };
    ChooseServerView1.prototype.checkMyServer = function (serverId) {
        var myAcServer = [];
        if (MyData.accountList) {
            for (var k = 0; k < MyData.accountList.length; k++) {
                if (serverId == MyData.accountList[k].serverId) {
                    myAcServer.push(MyData.accountList[k]);
                }
            }
        }
        return myAcServer;
    };
    //更新右侧
    ChooseServerView1.prototype.updateList1 = function (page) {
        this.serverlist1.removeChildrenToPool();
        var arr = MyData.serverList;
        var count = (page == this.totalPages() - 1) ? arr.length % this.countPerPage : this.countPerPage;
        var begin = page * this.countPerPage;
        for (var i = 0; i < count; i++) {
            var serverInfo = MyData.serverList[begin + i];
            var myAcServer = this.checkMyServer(serverInfo.id);
            if (myAcServer.length > 0) {
                console.log("aaaaaaaaaaaaa111", myAcServer.length);
                for (var f = 0; f < myAcServer.length; f++) {
                    var Item = this.serverlist1.addItemFromPool().asCom;
                    var tubiaoController = Item.getController("c1");
                    var itemText = Item.getChild("servername").asTextField;
                    var status_3 = serverInfo.status;
                    var statusText = Item.getChild("statetext").asTextField;
                    if (status_3 == "0") {
                        statusText.text = "[color=" + Color.blue + "]\u672A\u5F00[/color]";
                        tubiaoController.selectedIndex = 0;
                    }
                    else if (status_3 == "1") {
                        statusText.text = "[color=" + Color.green + "]\u65B0\u670D[/color]";
                        tubiaoController.selectedIndex = 1;
                    }
                    else if (status_3 == "2") {
                        statusText.text = "[color=" + Color.red + "]\u706B\u7206[/color]";
                        tubiaoController.selectedIndex = 2;
                    }
                    else {
                        statusText.text = "[color=" + Color.white + "]\u7EF4\u62A4[/color]";
                        tubiaoController.selectedIndex = 3;
                    }
                    statusText.text = "[color=" + Color.blue + "]" + (myAcServer[f].level + "级") + "[/color]";
                    var text = serverInfo.name;
                    itemText.text = text;
                    Item.data = { index: begin + i, myServer: myAcServer[f] };
                }
            }
            else {
                console.log("aaaaaaaaaaaaa222", myAcServer.length);
                var Item = this.serverlist1.addItemFromPool().asCom;
                var tubiaoController = Item.getController("c1");
                var itemText = Item.getChild("servername").asTextField;
                var status_4 = serverInfo.status;
                var statusText = Item.getChild("statetext").asTextField;
                if (status_4 == "0") {
                    statusText.text = "[color=" + Color.blue + "]\u672A\u5F00[/color]";
                    tubiaoController.selectedIndex = 0;
                }
                else if (status_4 == "1") {
                    statusText.text = "[color=" + Color.green + "]\u65B0\u670D[/color]";
                    tubiaoController.selectedIndex = 1;
                }
                else if (status_4 == "2") {
                    statusText.text = "[color=" + Color.red + "]\u706B\u7206[/color]";
                    tubiaoController.selectedIndex = 2;
                }
                else {
                    statusText.text = "[color=" + Color.white + "]\u7EF4\u62A4[/color]";
                    tubiaoController.selectedIndex = 3;
                }
                var text = serverInfo.name;
                itemText.text = text;
                Item.data = { index: begin + i };
            }
        }
    };
    //获取登录serverID数组
    ChooseServerView1.prototype.getLoginServerIDArr = function () {
        var str = GameLocalStorage.loadByUid(GameLocalStorage.chooseServer);
        var arr;
        if (str) {
            arr = ak.json_decode(str);
        }
        else {
            arr = [];
        }
        return arr;
    };
    //点击服务器列表 左侧
    ChooseServerView1.prototype.onTouchserverlist0 = function (obj) {
        this.myserver.selected = false;
        var item = obj.itemObject;
        this.updateList1(item.data.index);
    };
    //点击服务器列表 右侧
    ChooseServerView1.prototype.onTouchserverlist1 = function (obj) {
        var item = obj.itemObject;
        if (MyData.serverList[item.data.index].status != "3" || MyData.serverList[item.data.index].status != "0") {
            if (item.data.myServer) {
                ChooseData.inst().setchoose(item.data.index, item.data.myServer.id);
            }
            else {
                ChooseData.inst().setchoose(item.data.index, item.data.myServer);
            }
        }
        else {
            TipsViewSystem.show("当前服务器正在维护");
        }
        if (item.data.index == null) {
            this.close();
        }
        ak.EventMgr.dispatch(GameEvent.chooseServerView);
        this.close();
    };
    return ChooseServerView1;
}(ak.EasyUI));
__reflect(ChooseServerView1.prototype, "ChooseServerView1");
//选服界面1
var LoginNoticeSystem = (function (_super) {
    __extends(LoginNoticeSystem, _super);
    function LoginNoticeSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    LoginNoticeSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("LoginNotice");
    };
    LoginNoticeSystem.inst = new LoginNoticeSystem("ChooseServer");
    return LoginNoticeSystem;
}(ak.FairyGUI));
__reflect(LoginNoticeSystem.prototype, "LoginNoticeSystem");
var LoginNotice = (function (_super) {
    __extends(LoginNotice, _super);
    function LoginNotice() {
        var _this = _super.call(this, LoginNoticeSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.countPerPage = 10; //每页10条
        return _this;
    }
    LoginNotice.prototype.onInit = function () {
        var ui = this.create("ChooseServer", "LoginNotice");
        // this.bgclose = ui.getChild("bgclose").asLoader;
        // this.myserver = ui.getChild("myserver").asButton;
        // this.serverlist0 = ui.getChild("serverlist0").asList;
        // this.serverlist1 = ui.getChild("serverlist1").asList;
    };
    return LoginNotice;
}(ak.EasyUI));
__reflect(LoginNotice.prototype, "LoginNotice");
var ChooseTipsViewSystem = (function (_super) {
    __extends(ChooseTipsViewSystem, _super);
    function ChooseTipsViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    ChooseTipsViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ChooseTipsView");
    };
    ChooseTipsViewSystem.inst = new ChooseTipsViewSystem("ChooseTipsView");
    return ChooseTipsViewSystem;
}(ak.FairyGUI));
__reflect(ChooseTipsViewSystem.prototype, "ChooseTipsViewSystem");
/**
 * 选择提示框
 */
var ChooseTipsView = (function (_super) {
    __extends(ChooseTipsView, _super);
    /**
     * style 提示框发生rpc的类型
     * describe 提示框的文本
     */
    function ChooseTipsView(style, describes, callback, id) {
        var _this = _super.call(this, ChooseTipsViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.style = 0;
        _this.describes = "";
        _this.id = 0;
        _this.style = style;
        _this.describes = describes;
        _this.callback = callback;
        _this.id = id;
        return _this;
    }
    /**回调 */
    ChooseTipsView.prototype.onInit = function () {
        var ui = this.create("ChooseTipsView", "ChooseTipsView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.returnbtn = ui.getChild("returnbtn").asButton;
        this.surebtn = ui.getChild("surebtn").asButton;
        this.describe = ui.getChild("describe").asTextField;
        this.ClickAdd();
        this.SetText();
    };
    ChooseTipsView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onclick, this);
        this.addClickListener(this.returnbtn, this.onclick, this);
        this.addClickListener(this.surebtn, this.onclick, this);
    };
    ChooseTipsView.prototype.onclick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.returnbtn:
                this.close();
                break;
            case this.surebtn:
                this.onSure();
                break;
        }
    };
    ChooseTipsView.prototype.SetText = function () {
        this.describe.text = this.describes;
    };
    ChooseTipsView.prototype.onSure = function () {
        var _this = this;
        if (this.style == 0)
            net.upgradeCardMaxCount(function () {
                _this.close();
            }, this);
        if (this.style == 1) {
            this.close();
            if (this.callback) {
                this.callback();
            }
            ak.EventMgr.dispatch(GameEvent.selectMap);
        }
        if (this.style == 2) {
            net.removeFriend(this.id, function () {
                _this.close();
                if (_this.callback) {
                    _this.callback();
                }
            }, this);
        }
        if (this.style == 3) {
            net.shopHeroBuy(this.id, function () {
                _this.close();
                if (_this.callback) {
                    _this.callback();
                }
            }, this);
        }
        if (this.style == 4) {
            net.wishPoolShopBuy(this.id, function () {
                _this.close();
                if (_this.callback) {
                    _this.callback();
                }
            }, this);
        }
        if (this.style == 5) {
            net.quitUnion(function () {
                _this.close();
                if (_this.callback) {
                    _this.callback();
                }
            }, this);
        }
        if (this.style == 6) {
            net.unionShopBuy(this.id, function () {
                _this.close();
                if (_this.callback) {
                    _this.callback();
                }
            }, this);
        }
        if (this.style == 7) {
            net.remoteBattleBuy(this.id, function () {
                _this.close();
                if (_this.callback) {
                    _this.callback();
                }
            }, this);
        }
        if (this.style == 8) {
            net.unionBuy(this.id, function () {
                _this.close();
                if (_this.callback) {
                    _this.callback();
                }
            }, this);
        }
        if (this.style == 9) {
            this.close();
            if (this.callback) {
                this.callback();
            }
        }
        if (this.style == 10) {
            this.close();
            net.godWeaponReset(this.id, function () {
                if (_this.callback) {
                    _this.callback();
                }
            }, this);
        }
    };
    return ChooseTipsView;
}(ak.EasyUI));
__reflect(ChooseTipsView.prototype, "ChooseTipsView");
//顶部信息栏
var AdditionViewSystem = (function (_super) {
    __extends(AdditionViewSystem, _super);
    function AdditionViewSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    AdditionViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("common");
    };
    AdditionViewSystem.inst = new AdditionViewSystem("common");
    return AdditionViewSystem;
}(ak.FairyGUI));
__reflect(AdditionViewSystem.prototype, "AdditionViewSystem");
//界面
var AdditionView = (function (_super) {
    __extends(AdditionView, _super);
    function AdditionView(cardIndex) {
        var _this = _super.call(this, AdditionViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.cardIndex = cardIndex;
        return _this;
    }
    //初始化回调
    AdditionView.prototype.onInit = function () {
        this.ui = this.create("common", "AdditionView");
        this.bgClose = this.ui.getChild("bgclose").asLoader;
        this.clickAdd();
        this.showData();
    };
    AdditionView.prototype.clickAdd = function () {
        this.addClickListener(this.bgClose, this.onClick, this); //关闭界面
    };
    AdditionView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgClose:
                this.close();
                break;
        }
    };
    //显示数据
    AdditionView.prototype.showData = function () {
        var cardArr = MyData.user.json.cardArr;
        var info = cardArr[this.cardIndex];
        this.ui.getChild("textData1").asTextField.text = (info.c1 * 100).toFixed(1) + "%";
        this.ui.getChild("textData2").asTextField.text = (info.c2 * 100).toFixed(1) + "%";
        this.ui.getChild("textData3").asTextField.text = (info.c3 * 100).toFixed(1) + "%";
        this.ui.getChild("textData4").asTextField.text = (info.c4 * 100).toFixed(1) + "%";
        this.ui.getChild("textData5").asTextField.text = (info.c5 * 100).toFixed(1) + "%";
        this.ui.getChild("textData6").asTextField.text = (info.c6 * 100).toFixed(1) + "%";
        this.ui.getChild("textData7").asTextField.text = (info.c7 * 100).toFixed(1) + "%";
        this.ui.getChild("textData8").asTextField.text = (info.c8 * 100).toFixed(1) + "%";
        this.ui.getChild("textData9").asTextField.text = (info.c9 * 100).toFixed(1) + "%";
    };
    return AdditionView;
}(ak.EasyUI));
__reflect(AdditionView.prototype, "AdditionView");
//底部信息栏
var DownViewSystem = (function (_super) {
    __extends(DownViewSystem, _super);
    function DownViewSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    DownViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("common");
    };
    DownViewSystem.show = function () {
        var ui;
        var uiArr = ak.FairyGUI.getOpenUI("DownView");
        if (uiArr.length > 0) {
            ui = uiArr[0];
        }
        else {
            ak.FairyGUI.open(["DownView"]);
            uiArr = ak.FairyGUI.getOpenUI("DownView");
            ui = uiArr[0];
        }
        ui.visible = true;
    };
    DownViewSystem.hide = function () {
        var ui;
        var uiArr = ak.FairyGUI.getOpenUI("DownView");
        if (uiArr.length > 0) {
            ui = uiArr[0];
            ui.visible = false;
        }
    };
    DownViewSystem.inst = new DownViewSystem("common");
    return DownViewSystem;
}(ak.FairyGUI));
__reflect(DownViewSystem.prototype, "DownViewSystem");
//界面
var DownView = (function (_super) {
    __extends(DownView, _super);
    function DownView() {
        var _this = _super.call(this, DownViewSystem.inst, MyGame.inst.uiLayer4) || this;
        //角色数据返回
        _this.on("netmsg://userResult", _this.onRedDotHandle, _this);
        _this.on("netmsg://hook/getResQuickResult", _this.onRedDotHandle, _this);
        _this.on("netmsg://bag/cardComposeResult", _this.onRedDotHandle, _this);
        _this.on("netmsg://dropDataResult", _this.onRedDotHandle, _this);
        //获取主城红点
        _this.on("netmsg://mail/getMailArrResult", _this.onFlushMailRedPoint, _this);
        _this.on("netmsg://worshipDataResult", _this.onFlushWorshipRedPoint, _this);
        _this.on("netmsg://userResult", _this.onFlushWorshipRedPoint, _this);
        _this.on("netmsg://dailyTaskDataResult", _this.onFlushTaskRedPoint1, _this);
        _this.on("netmsg://achievementTaskDataResult", _this.onFlushTaskRedPoint2, _this);
        //活动列表红点
        _this.on("netmsg://createUser7Day/dayRewardResult", _this.updateListRedDot, _this);
        _this.on("netmsg://createUser7Day/progressRewardResult", _this.updateListRedDot, _this);
        _this.on("netmsg://welfarePackage/buyResult", _this.updateListRedDot, _this);
        _this.on("netmsg://dailyShop/buyResult", _this.updateListRedDot, _this);
        _this.on("netmsg://rightPackage/buyResult", _this.updateListRedDot, _this);
        _this.on("netmsg://online/signInResult", _this.updateListRedDot, _this);
        _this.on("netmsg://limitActivity/exchange_type1Result", _this.updateListRedDot, _this);
        _this.on("netmsg://limitActivity/exchange_type4Result", _this.updateListRedDot, _this);
        _this.on("netmsg://limitActivity/exchange_type6Result", _this.updateListRedDot, _this);
        _this.on("netmsg://recharge/firstRechargeReward", _this.updateListRedDot, _this);
        _this.on("netmsg://recharge/dailyRechargeRewardResult", _this.updateListRedDot, _this);
        _this.on("netmsg://recharge/firstRechargeRewardResult", _this.updateListRedDot, _this);
        //探险红点
        _this.on("netmsg://hook/getResFromAchievementResult", _this.onRedtanxian, _this);
        return _this;
    }
    //初始化回调
    DownView.prototype.onInit = function () {
        this.downView = this.create("common", "downView");
        this.cityBtn = this.downView.getChild("citybtn").asCom;
        this.on(GameEvent.fightRpcComplete, this.onRedtanxian, this);
        this.on(GameEvent.mainUIDownTab, this.updateTad, this);
        this.on(GameEvent.changeMainCity, this.changeMainCity, this);
        this.on(GameEvent.changeHeroBag, this.changeHeroBag, this);
        this.on(GameEvent.changeGuild, this.changeGuild, this);
        this.onEgretEvent(this.downView.getController("c1"), fairygui.StateChangeEvent.CHANGED, this.changeTab, this);
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.onFlushFriendTreasureRedPoint, this); //一直鉴听好友探宝
    };
    /**更新活动列表红点 */
    DownView.prototype.updateListRedDot = function () {
        var pass = false;
        if (RedDotMgr.rechargeRedDot() || RedDotMgr.sginRedDot() || RedDotMgr.activityTimeRedDot() || RedDotMgr.sevenDayActivityRedDot() || RedDotMgr.everydayRechargeRedDot() || RedDotMgr.fristRechargeRedDot()) {
            pass = true;
        }
        this.cityRed7 = pass;
        this.cityRed();
    };
    DownView.prototype.onFlushMailRedPoint = function () { this.cityRed3 = RedDotMgr.getMailRedDot(); this.cityRed(); }; //邮件
    DownView.prototype.onFlushWorshipRedPoint = function () { this.cityRed4 = RedDotMgr.getWorshipRedDot(); this.cityRed(); }; //排行榜
    DownView.prototype.onFlushTaskRedPoint1 = function () { this.cityRed5 = RedDotMgr.getTaskRedDot2(); this.cityRed(); }; //任务
    DownView.prototype.onFlushTaskRedPoint2 = function () { this.cityRed6 = RedDotMgr.getTaskRedDot(); this.cityRed(); }; //成就
    //好友红点刷新显示(探宝)
    DownView.prototype.onFlushFriendTreasureRedPoint = function () {
        if (MyData.user) {
            this.cityRed1 = RedDotMgr.onlineRedDot(); //在线奖励红点
        }
        if (RedDotMgr.getFriendRedDot() == false) {
            this.cityRed2 = RedDotMgr.getFriendTreasureRedDot();
        }
        this.cityRed();
    };
    //切换主城
    DownView.prototype.changeMainCity = function () {
        this.ui.getController("c1").selectedIndex = 0;
        ak.EventMgr.dispatch(GameEvent.changeMainCity2);
    };
    //更新选项卡
    DownView.prototype.updateTad = function () {
        this.ui.getController("c1").selectedIndex = 2;
    };
    //切换英雄背包
    DownView.prototype.changeHeroBag = function () {
        this.ui.getController("c1").selectedIndex = 1;
    };
    //切换公会
    DownView.prototype.changeGuild = function () {
        this.ui.getController("c1").selectedIndex = 4;
    };
    //显示属性或装备界面
    DownView.prototype.changeTab = function () {
        //MyGame.inst.uiLayer.removeChildren();
        if (MyGame.inst.uiLayer.numChildren > 0) {
            var ui_1 = MyGame.inst.uiLayer.getChildAt(MyGame.inst.uiLayer.numChildren - 1);
            egret.Tween.get(ui_1).wait(50).call(function () {
                if (ui_1 && ui_1.parent)
                    ui_1.parent.removeChild(ui_1);
            }, this);
        }
        var index = this.ui.getController("c1").selectedIndex;
        if (index == 0) {
            TopViewSystem.show();
            ak.EventMgr.dispatch(GameEvent.changeMainCity2);
        }
        else if (index == 1) {
            TopViewSystem.show();
            ak.FairyGUI.open(["HeroBagView"]);
        }
        else if (index == 2) {
            TopViewSystem.hide();
            ak.FairyGUI.open(["ExplorationView"]);
        }
        else if (index == 3) {
            TopViewSystem.show();
            ak.FairyGUI.open(["BagView"]);
        }
        else if (index == 4) {
            if (GameSystem.isSysOpen(10, true)) {
                TopViewSystem.show();
                if (MyData.user.unionID != null && MyData.user.unionID != 0) {
                    ak.FairyGUI.open(["GuildView"]);
                }
                else {
                    ak.FairyGUI.open(["GuildCreateView"]);
                }
            }
            else {
                this.changeMainCity();
            }
        }
    };
    DownView.prototype.onRedDotHandle = function () {
        this.onRedtanxian();
        this.onFlushTaskRedPoint1();
        this.onFlushTaskRedPoint2();
        //背包红点
        var bagbtn = this.downView.getChild("bagbtn").asCom;
        var control_c1_2 = bagbtn.getController("c1");
        control_c1_2.selectedIndex = RedDotMgr.bagPieceRedDot();
    };
    DownView.prototype.onRedtanxian = function () {
        //探险红点
        var explorationbtn = this.downView.getChild("explorationbtn").asCom;
        var control_c1 = explorationbtn.getController("c1");
        if (RedDotMgr.explorationBossAwardRedDot() || RedDotMgr.speedExplorationRedDot()) {
            control_c1.selectedIndex = 1;
        }
        else {
            control_c1.selectedIndex = 0;
        }
    };
    //主城红点
    DownView.prototype.cityRed = function () {
        var pass = false;
        if (this.cityRed1 || this.cityRed2 || this.cityRed3 || this.cityRed4 || this.cityRed5 || this.cityRed6 || this.cityRed7) {
            pass = true;
        }
        this.cityBtn.getController("red").selectedIndex = pass ? 1 : 0;
    };
    return DownView;
}(ak.EasyUI));
__reflect(DownView.prototype, "DownView");
//GM命令
var GMorderViewSystem = (function (_super) {
    __extends(GMorderViewSystem, _super);
    function GMorderViewSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    GMorderViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("GMorder");
    };
    GMorderViewSystem.inst = new GMorderViewSystem("GMorder");
    return GMorderViewSystem;
}(ak.FairyGUI));
__reflect(GMorderViewSystem.prototype, "GMorderViewSystem");
//主界面
var GMorderView = (function (_super) {
    __extends(GMorderView, _super);
    function GMorderView() {
        return _super.call(this, GMorderViewSystem.inst, MyGame.inst.tipLayer) || this;
    }
    //初始化回调
    GMorderView.prototype.onInit = function () {
        // DownViewSystem.hide();
        this.ui = this.create("GMorder", "GMorderView");
        this.closebtn = this.ui.getChild("closeBtn").asButton;
        this.btn = this.ui.getChild("n57").asButton;
        this.clickAdd();
    };
    GMorderView.prototype.clickAdd = function () {
        this.addClickListener(this.closebtn, this.onClick, this); //关闭界面
        this.addClickListener(this.btn, this.onClick, this); //确定
    };
    GMorderView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.closebtn:
                this.close();
                // DownViewSystem.show();
                break;
            case this.btn:
                var text = this.ui.getChild("n59").text;
                net.GM(text);
                break;
        }
    };
    return GMorderView;
}(ak.EasyUI));
__reflect(GMorderView.prototype, "GMorderView");
/**
 * 道具基础类
 * 特殊道具框先继承此基础类
 * by kk
 */
var ItemBase = (function () {
    /**
     * itemType 道具类型 （1-道具,2-hero,3-资源）
     * com 道具控件
     * ui 道具控件的界面
     */
    function ItemBase(com, ui, itemType) {
        /**道具id */
        this.itemID = 0;
        this.ui = ui;
        this.com = com;
        this.itemType = itemType;
        this.init();
    }
    ItemBase.prototype.init = function () {
        this.control_color = this.com.getController("color");
        this.control_gou = this.com.getController("gou");
        this.control_type = this.com.getController("type");
        this.control_star = this.com.getController("star");
        this.control_dark = this.com.getController("dark");
        this.control_progressBar = this.com.getController("progressBar");
        this.control_piece = this.com.getController("piece");
        this.control_lock = this.com.getController("lock");
        this.control_red = this.com.getController("red");
        this.control_light = this.com.getController("light");
        this.icon = this.com.getChild("icon").asLoader;
        this.itemnumber = this.com.getChild("number").asTextField;
        this.itemnumberDown = this.com.getChild("numberDown").asTextField;
        this.numberOut = this.com.getChild("numberOut").asTextField;
        this.progress = this.com.getChild("progress").asProgress;
    };
    /**
     * itemID:道具id（必传）
     * race:卡牌种族,是英雄卡牌（需传）
     * stars:卡牌星数,是英雄卡牌（需传）
     */
    ItemBase.prototype.setItemData = function (itemID, race, star) {
        this.itemID = itemID;
        this.setItemInfo();
        this.setIcons();
        this.setColor();
        if (this.itemType == 1)
            this.showPiece();
        if (this.itemType == 1)
            this.setRaceandStar();
        if (this.itemType == 2 && race)
            this.setType(race);
        if (this.itemType == 2 && star)
            this.setStar(star);
        if (this.itemType == 3) {
            this.setStar2(0);
            this.setType(0);
        }
    };
    //根据type
    ItemBase.prototype.setItemType = function (itemType) {
        this.itemType = itemType;
    };
    ItemBase.prototype.setItemInfo = function () {
        var heroTab = ak.JsonTableMgr.get("hero");
        var itemTab = ak.JsonTableMgr.get("item");
        var ResourceTab = ak.JsonTableMgr.get("Resource");
        if (this.itemType == 1) {
            this.itemInfo = itemTab.getRowFromColName("id", "" + this.itemID);
            // console.log("ffffffff 111", this.itemID)
        }
        else if (this.itemType == 2) {
            this.itemInfo = heroTab.getRowFromColName("id", "" + this.itemID);
            // console.log("ffffffff 222", this.itemID)
        }
        else {
            this.itemInfo = ResourceTab.getRowFromColName("id", "" + this.itemID);
            // console.log("ffffffff 333", this.itemID)
        }
    };
    /**
     * 宝石图标
     * itemType为5
     */
    ItemBase.prototype.setGemData = function (level) {
        this.ui.setLoaderUrl(this.icon, "baoshi_" + level + "_png");
    };
    ItemBase.prototype.setIcons = function () {
        if (this.itemType == 2) {
            var head = this.itemInfo.getValFromColName("head");
            this.ui.setLoaderUrl(this.icon, "hero" + head + "_png");
        }
        else {
            if (this.itemType == 1) {
                var img = this.itemInfo.getValFromColName("img");
                this.ui.setLoaderUrl(this.icon, img + "_png");
            }
            else {
                var icon = this.itemInfo.getValFromColName("icon");
                this.ui.setLoaderUrl(this.icon, icon + "_png");
            }
        }
    };
    /**外部调用设置图片 */
    ItemBase.prototype.setIcons2 = function (img) {
        this.ui.setLoaderUrl(this.icon, img + "_png");
    };
    ItemBase.prototype.setColor = function () {
        var color = this.itemInfo.getValFromColName("color");
        this.control_color.selectedIndex = (color);
    };
    /**外部调用设置颜色 */
    ItemBase.prototype.setColor2 = function (color) {
        this.control_color.selectedIndex = (color);
    };
    ItemBase.prototype.setGou = function (isshow) {
        var index = isshow ? 1 : 0;
        this.control_gou.selectedIndex = (index);
    };
    ItemBase.prototype.setType = function (race) {
        var type;
        if (race) {
            type = race;
        }
        else {
            type = this.itemInfo.getValFromColName("race");
        }
        this.control_type.selectedIndex = (type);
    };
    ItemBase.prototype.setStar = function (star) {
        var stars;
        if (star) {
            stars = star;
        }
        else {
            stars = this.itemInfo.getValFromColName("star");
        }
        this.control_star.selectedIndex = (stars);
    };
    /**
     * 外部调用设置星数
     * 后面可以补充优化
     * */
    ItemBase.prototype.setStar2 = function (star) {
        this.control_star.selectedIndex = (star);
    };
    /**道具数量显示 */
    ItemBase.prototype.setNumber = function (num, down) {
        if (down === void 0) { down = false; }
        if (down) {
            this.itemnumberDown.visible = true;
            this.itemnumber.visible = false;
            //this.itemnumberDown.text = num;
            Common.labelIsOverLenght(this.itemnumberDown, Number(num));
        }
        else {
            this.itemnumber.visible = true;
            this.itemnumberDown.visible = false;
            this.itemnumber.text = num;
        }
    };
    /**道具数量显示 */
    ItemBase.prototype.setNumber2 = function (num, down) {
        if (down === void 0) { down = false; }
        if (down) {
            this.itemnumberDown.visible = true;
            this.itemnumber.visible = false;
            this.itemnumberDown.text = num;
        }
        else {
            this.itemnumber.visible = true;
            this.itemnumberDown.visible = false;
            this.itemnumber.text = num;
        }
    };
    /**将道具设为通用背景（碎片） */
    ItemBase.prototype.setGlobalImg = function (race, star) {
        var starS = Math.abs(star);
        if (starS > 100) {
            starS -= 100;
            this.ui.setLoaderUrl(this.icon, "hero_6_png");
        }
        else {
            this.ui.setLoaderUrl(this.icon, "hero_" + starS + "_png");
        }
        this.control_type.selectedIndex = (race);
        this.control_star.selectedIndex = (starS);
    };
    /**设置是否打开阴影遮罩 */
    ItemBase.prototype.setDark = function (isshow) {
        var show = isshow ? 1 : 0;
        this.control_dark.selectedIndex = (show);
    };
    /**设置是否显示进度条 */
    ItemBase.prototype.isShowProgressBar = function (ishow) {
        var show = ishow ? 1 : 0;
        this.control_progressBar.selectedIndex = (show);
    };
    ItemBase.prototype.showPiece = function () {
        var itemTab = ak.JsonTableMgr.get("item");
        var itemInfo = itemTab.getRowFromColName("id", "" + this.itemID);
        if (itemInfo) {
            var bagtype = this.itemInfo.getValFromColName("bagtype");
            if (bagtype == 3) {
                this.isShowPiece(true);
            }
            else {
                this.isShowPiece(false);
            }
        }
    };
    /**设置是否显示碎片图片 */
    ItemBase.prototype.isShowPiece = function (ishow) {
        var show = ishow ? 1 : 0;
        this.control_piece.selectedIndex = (show);
    };
    /**设置进度条内容 */
    ItemBase.prototype.setProgressInfo = function (value, max) {
        this.progress.value = value;
        this.progress.max = max;
    };
    /**设置是否显示锁 */
    ItemBase.prototype.isshowLock = function (isshow) {
        var show = isshow ? 1 : 0;
        this.control_lock.selectedIndex = (show);
    };
    /**设置是否显示红点 */
    ItemBase.prototype.isshowreddot = function (isshow) {
        var show = isshow ? 1 : 0;
        this.control_red.selectedIndex = (show);
    };
    /**设置是否显示光特效 */
    ItemBase.prototype.isshowLight = function (isshow) {
        var show = isshow ? 1 : 0;
        this.control_light.selectedIndex = (show);
    };
    /**设置numberOut的值 */
    ItemBase.prototype.setnumberOut = function (str) {
        this.numberOut.text = str;
    };
    /**设置是否把icon变灰色 */
    ItemBase.prototype.seticonGray = function (isshow) {
        var show = isshow;
        this.icon.enabled = show;
    };
    /**道具设置种族和星数 */
    ItemBase.prototype.setRaceandStar = function () {
        var bagtyp = BagData.inst().GetBagtypeById(this.itemID);
        switch (bagtyp) {
            case 1:
                var itemTab0 = ak.JsonTableMgr.get("itemEquip");
                var itemInfo0 = itemTab0.getRowFromColName("id", "" + this.itemID);
                var star0 = itemInfo0.getValFromColName("star");
                var race0 = 0;
                this.setStar2(star0);
                this.setType(race0);
                break;
            case 2:
                this.setStar2(0);
                this.setType(0);
                break;
            case 3:
                this.setStar2(HeroBagData.inst().GetStarById2(this.itemID));
                this.setType(HeroBagData.inst().GetRaceById2(this.itemID));
                break;
            case 4:
                var itemTab = ak.JsonTableMgr.get("itemShipin");
                var itemInfo = itemTab.getRowFromColName("id", "" + this.itemID);
                var star = itemInfo.getValFromColName("star");
                var race = 0;
                this.setStar2(star);
                this.setType(race);
                break;
        }
    };
    /**
     * 清除格子数据
     */
    ItemBase.prototype.clear = function () {
        this.itemID = 0;
        this.itemType = 0;
        this.itemInfo = null;
        this.itemnumber.text = "";
        this.itemnumberDown.text = "";
        this.numberOut.text = "";
        this.ui.setLoaderUrl(this.icon, "");
        this.control_color.selectedIndex = (0);
        this.control_gou.selectedIndex = (0);
        this.control_type.selectedIndex = (0);
        this.control_star.selectedIndex = (0);
        this.control_dark.selectedIndex = (0);
        this.control_progressBar.selectedIndex = (0);
        this.control_piece.selectedIndex = (0);
        this.control_lock.selectedIndex = (0);
    };
    /**
     * 外部调用清除格子数据
     */
    ItemBase.prototype.clear2 = function () {
        this.clear();
    };
    ItemBase.prototype.destruct = function () {
        this.com.removeEventListener(egret.TouchEvent.TOUCH_END, this.onClick, this);
    };
    /**展现该道具或者英雄的信息弹出框 */
    ItemBase.prototype.onClick = function () {
    };
    /**宝石url */
    ItemBase.BAOSHIURL = "resource/icon/baoshiico/baoshi_";
    /**装备url*/
    ItemBase.ZHUNGBEIURL = "resource/icon/baoshiico/equipico";
    /**装备类型 */
    ItemBase.ZBLEIXINGURL = ["", "jiezhi_", "toukui_", "wuqi_", "xiongjia_"];
    /**BOSSurl */
    ItemBase.GHBOSSURL = "resource/icon/baoshiico/ghbossico";
    /**商品url */
    ItemBase.SHIPURL = "resource/icon/baoshiico/shipinico";
    /**技能url*/
    ItemBase.SKILLURL = "resource/icon/baoshiico/skillico";
    /**英雄url*/
    ItemBase.HEROURL = "resource/icon/itemico/hero";
    return ItemBase;
}());
__reflect(ItemBase.prototype, "ItemBase");
//提示框
var TipsViewSystem = (function (_super) {
    __extends(TipsViewSystem, _super);
    function TipsViewSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TipsViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("common");
    };
    TipsViewSystem.show = function (text) {
        if (ak.FairyGUI.getOpenUI("TipsView").length == 0) {
            ak.FairyGUI.open(["TipsView", text]);
        }
    };
    TipsViewSystem.inst = new TipsViewSystem("common");
    return TipsViewSystem;
}(ak.FairyGUI));
__reflect(TipsViewSystem.prototype, "TipsViewSystem");
//主界面
var TipsView = (function (_super) {
    __extends(TipsView, _super);
    function TipsView(tipsStr) {
        var _this = _super.call(this, TipsViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.tipsStr = tipsStr;
        return _this;
    }
    //初始化回调
    TipsView.prototype.onInit = function () {
        var _this = this;
        this.tipsView = this.create("common", "TipsView");
        this.tipsView.getChild("text").text = this.tipsStr;
        var tran = this.tipsView.getTransition("t0");
        tran.play();
        tran.timeScale = 2;
        tran.setHook("end", function () {
            _this.close();
        }, this);
    };
    return TipsView;
}(ak.EasyUI));
__reflect(TipsView.prototype, "TipsView");
//顶部信息栏
var TopViewSystem = (function (_super) {
    __extends(TopViewSystem, _super);
    function TopViewSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TopViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("common");
    };
    TopViewSystem.show = function () {
        if (!this.topViewUI) {
            this.topViewUI = new TopView();
        }
        else {
            this.topViewUI.visible = true;
        }
    };
    TopViewSystem.hide = function () {
        this.topViewUI.visible = false;
    };
    TopViewSystem.inst = new TopViewSystem("common");
    return TopViewSystem;
}(ak.FairyGUI));
__reflect(TopViewSystem.prototype, "TopViewSystem");
//界面
var TopView = (function (_super) {
    __extends(TopView, _super);
    function TopView() {
        var _this = _super.call(this, TopViewSystem.inst, MyGame.inst.uiLayer2) || this;
        //角色数据返回
        _this.on("netmsg://userResult", function () {
            var param = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                param[_i] = arguments[_i];
            }
            _this.updateView();
        }, _this);
        //资源数据返回
        _this.on("netmsg://resourceResult", function () {
            var param = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                param[_i] = arguments[_i];
            }
            _this.updateView();
        }, _this);
        _this.on(GameEvent.changeHead, _this.updateView, _this);
        _this.on(GameEvent.changeName, _this.updateView, _this);
        return _this;
    }
    TopView.prototype.updateView = function () {
        var user = MyData.user;
        this.topView.getChild("playerLevel").asTextField.text = user.level + "";
        this.topView.getChild("playerName").asTextField.text = user.nickname;
        Common.labelIsOverLenght(this.topView.getChild("playerGold").asTextField, user.money);
        Common.labelIsOverLenght(this.topView.getChild("playerZs").asTextField, (user.diamond + user.diamond2));
        Common.labelIsOverLenght(this.topView.getChild("playerYxExp").asTextField, user.cardExp);
        this.topView.getChild("ghgx").asTextField.text = "" + SummonData.inst().GetItemnumByid(2003);
        Common.labelIsOverLenght(this.topView.getChild("ghgx").asTextField, this.topView.getChild("ghgx").asTextField.text);
        this.setLoaderUrl(this.player.getChild("playerHead").asLoader, "hero" + MyData.user.head + "_png");
    };
    TopView.prototype.kongzhiqi = function (type) {
        this.topView.getController("c1").selectedIndex = type;
    };
    //初始化回调
    TopView.prototype.onInit = function () {
        this.topView = this.create("common", "TopView");
        this.player = this.topView.getChild("player").asCom;
        this.player.getChild("playerHead").asLoader.addClickListener(function () {
            ak.FairyGUI.open(["SetupView"]);
        }, this);
        this.topView.getChild("goldBtn").asButton.addClickListener(function () {
            ak.FairyGUI.open(["MoneyView"]);
        }, this);
        this.topView.getChild("zsBtn").asButton.addClickListener(function () {
            ak.FairyGUI.open(["RechargeView"]);
        }, this);
        this.topView.getChild("zsBtn").asButton.visible = MyConfig.openBuyDiamond;
        this.topView.getChild("goldBtn").asButton.visible = MyConfig.openBuyMoney;
    };
    return TopView;
}(ak.EasyUI));
__reflect(TopView.prototype, "TopView");
//卡牌合成
var CreateRoleSystem = (function (_super) {
    __extends(CreateRoleSystem, _super);
    function CreateRoleSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    CreateRoleSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("CreateRole");
    };
    CreateRoleSystem.inst = new CreateRoleSystem("CreateRole");
    return CreateRoleSystem;
}(ak.FairyGUI));
__reflect(CreateRoleSystem.prototype, "CreateRoleSystem");
//主界面
var CreateRole = (function (_super) {
    __extends(CreateRole, _super);
    function CreateRole() {
        var _this = _super.call(this, CreateRoleSystem.inst, MyGame.inst.uiLayer2_2) || this;
        CreateRoleSystem.createRoleUI = _this;
        return _this;
    }
    //初始化回调
    CreateRole.prototype.onInit = function () {
        var _this = this;
        this.ui = this.create("CreateRole", "CreateRole");
        this.name1Tab = ak.JsonTableMgr.get("name1");
        this.name2Tab = ak.JsonTableMgr.get("name2");
        this.getName();
        //确认
        this.addClickListener(this.ui.getChild("n3").asCom, function () {
            var nickname = _this.ui.getChild("n1").asCom.getChild("n2").text;
            // nickname = SensitiveWordFilter.inst.replaceSensitiveWord(nickname)
            var count = nickname.length;
            if (count < 2 || count > 6) {
                TipsViewSystem.show("昵称限定2-6个字符");
                return;
            }
            if (nickname == "") {
                TipsViewSystem.show("昵称不合法");
                return;
            }
            var blank = nickname.indexOf(" ");
            if (blank != -1) {
                TipsViewSystem.show("昵称不合法");
                return;
            }
            var blank2 = nickname.indexOf("*");
            if (blank2 != -1) {
                TipsViewSystem.show("昵称不合法");
                return;
            }
            net.register(nickname);
        }, this);
        //随机名字
        this.addClickListener(this.ui.getChild("n4").asCom, function () {
            _this.getName();
        }, this);
    };
    CreateRole.prototype.getName = function () {
        var row1 = this.name1Tab.getRow(Math.floor(Math.random() * this.name1Tab.size()));
        var row2 = this.name2Tab.getRow(Math.floor(Math.random() * this.name2Tab.size()));
        var name = row1.getValFromColName("name1") + row2.getValFromColName("name2");
        this.ui.getChild("n1").asCom.getChild("n2").text = name;
    };
    return CreateRole;
}(ak.EasyUI));
__reflect(CreateRole.prototype, "CreateRole");
var DailytaskViewSystem = (function (_super) {
    __extends(DailytaskViewSystem, _super);
    function DailytaskViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    DailytaskViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("DailytaskView");
    };
    DailytaskViewSystem.inst = new DailytaskViewSystem("DailytaskView");
    return DailytaskViewSystem;
}(ak.FairyGUI));
__reflect(DailytaskViewSystem.prototype, "DailytaskViewSystem");
/**
 * 0日常任务
 * 1成就任务
 */
var DailytaskView = (function (_super) {
    __extends(DailytaskView, _super);
    function DailytaskView() {
        var _this = _super.call(this, DailytaskViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.index = 0;
        _this.timer = new ak.Timer();
        return _this;
    }
    /**回调 */
    DailytaskView.prototype.onInit = function () {
        this.ui = this.create("DailytaskView", "DailytaskView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.list = this.ui.getChild("list").asList;
        this.lingqu = this.ui.getChild("lingqu").asButton;
        this.taskTab = ak.JsonTableMgr.get("task");
        this.taskTypeTab = ak.JsonTableMgr.get("taskType");
        this.taskDailyTab = ak.JsonTableMgr.get("taskDaily");
        this.onEgretEvent(this.ui.getController("c1"), fairygui.StateChangeEvent.CHANGED, this.updateList, this);
        this.ClickAdd();
        this.updateList();
        this.showTime();
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.onEnterFrame, this);
    };
    DailytaskView.prototype.onEnterFrame = function () {
        if (this.timer.getTime() >= 1000) {
            this.timer.reset();
            this.showTime();
        }
    };
    DailytaskView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this); //关闭界面
        this.addClickListener(this.lingqu, this.onClick, this); //领取
    };
    DailytaskView.prototype.onClick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.lingqu:
                net.finishDailyTask(1, function () {
                    _this.updateList();
                }, this);
                break;
        }
    };
    DailytaskView.prototype.updateList = function () {
        this.showRedTab();
        this.list.removeChildrenToPool();
        this.index = this.ui.getController("c1").selectedIndex;
        if (this.index == 0) {
            this.taskDailyList(); //日常任务列表
        }
        else {
            this.achievementTaskList(); //成就任务列表
        }
        this.onFairyguiEvent(this.list, fairygui.ItemEvent.CLICK, this.intoOrGet, this);
    };
    //显示选项卡红点
    DailytaskView.prototype.showRedTab = function () {
        var getTaskRedDot2 = RedDotMgr.getTaskRedDot2(); //日常任务
        var getTaskRedDot = RedDotMgr.getTaskRedDot(); //成就
        var arrName = ["taskbtn", "achievementbtn"];
        var arrRed = [getTaskRedDot2, getTaskRedDot];
        for (var i = 0; i < arrName.length; i++) {
            this.ui.getChild(arrName[i]).asButton.getController("red").selectedIndex = arrRed[i] ? 1 : 0;
        }
    };
    //成就：任务列表
    DailytaskView.prototype.achievementTaskList = function () {
        var countTask = this.taskTab.size();
        var countType = this.taskTypeTab.size();
        var achievementTask = MyData.user.json.achievementTask;
        var idMap = achievementTask.idMap;
        var newArr = [];
        var arr = Object.keys(idMap);
        var arrCount = arr.length;
        if (arrCount) {
            newArr = arr.map(Number);
        }
        this.chengjiuPaixu();
        for (var i = 0; i < countType; i++) {
            var taskTypeID = this.idArrChengJiu[i];
            var rowType = this.taskTypeTab.getRowFromColName("type", "" + taskTypeID);
            var type = rowType.getValFromColName("type"); //任务类型
            var textT = rowType.getValFromColName("text"); //描述
            var taskId = 0;
            var pass = 1;
            var finish = 0;
            for (var j = 0; j < countTask; j++) {
                var rowT = this.taskTab.getRow(j);
                var id = rowT.getValFromColName("id"); //成就任务ID
                var next = rowT.getValFromColName("next"); //下一个任务
                var typeTask = rowT.getValFromColName("type"); //任务类型
                var passRace = newArr.indexOf(id);
                if (passRace == -1 && typeTask == type && pass) {
                    taskId = id;
                    pass = 0;
                }
                if (next == 0 && typeTask == type && pass) {
                    taskId = id;
                    pass = 0;
                    finish = 1;
                }
            }
            if (taskId) {
                var rowT = this.taskTab.getRowFromColName("id", "" + taskId);
                var num = rowT.getValFromColName("num"); //所需数量
                var drop = rowT.getValFromColName("drop"); //奖励
                var taskitem = this.list.addItemFromPool().asCom;
                taskitem.getChild("receivebtn").data = taskId;
                var taskItemList = taskitem.getChild("list").asList;
                var arrItem = ItemMgr.getDropGroupByID(drop);
                taskItemList.removeChildrenToPool();
                for (var j = 0; j < arrItem.length; j++) {
                    var type_1 = arrItem[j][1];
                    var itemID = arrItem[j][2];
                    var count_2 = arrItem[j][3];
                    var minItem = taskItemList.addItemFromPool().asCom;
                    var item = minItem.getChild("n1").asCom;
                    minItem.data = { itemID: itemID, count: count_2, type: type_1 };
                    var itemBase = new ItemBase(item, this, type_1);
                    itemBase.setItemData(Number(itemID));
                    itemBase.setNumber(count_2, true);
                }
                taskitem.getChild("title").asTextField.text = "" + ak.strFormat(textT, num);
                this.onFairyguiEvent(taskItemList, fairygui.ItemEvent.CLICK, this.showItemInfo, this);
                var count = 0;
                if (type == 101) {
                    count = MyData.user.level;
                }
                else if (type == 102) {
                    count = achievementTask.heroStar4Count; //获得%0个4星英雄
                }
                else if (type == 103) {
                    count = achievementTask.heroStar5Count; //获得%0个5星英雄
                }
                else if (type == 104) {
                    count = achievementTask.heroStar6Count; //获得%0个6星英雄
                }
                else if (type == 105) {
                    count = achievementTask.heroStar9Count; //获得%0个9星英雄
                }
                else if (type == 106) {
                    count = achievementTask.heroDecomposeCount; //分解%0个英雄
                }
                else if (type == 107) {
                    count = achievementTask.equColor3Count; //获得%0件紫色装备
                }
                else if (type == 108) {
                    count = achievementTask.equColor4Count; //获得%0件橙色装备
                }
                else if (type == 109) {
                    count = achievementTask.equColor5Count; //获得%0件红色装备
                }
                else if (type == 110) {
                    count = achievementTask.stageWinCount; //自由竞技场胜%0次
                }
                else if (type == 111) {
                    count = achievementTask.stageScore; //自由竞技场达到%0分
                }
                else if (type == 112) {
                    count = achievementTask.pubTaskColor2Count; //完成蓝色悬赏任务%0次
                }
                else if (type == 113) {
                    count = achievementTask.pubTaskColor3Count; //完成紫色悬赏%0次
                }
                else if (type == 114) {
                    count = achievementTask.pubTaskColor4Count; //完成橙色悬赏任务%0次
                }
                else if (type == 115) {
                    count = achievementTask.pubTaskColor5Count; //完成红色悬赏任务%0次
                }
                else if (type == 116) {
                    count = achievementTask.friendSearchCount; //好友搜寻%0次敌人
                }
                else if (type == 117) {
                    // count=0;//十字军通过第%0关
                    var remoteBattle = MyData.user.json.remoteBattle;
                    count = remoteBattle.battleMaxCount;
                }
                else if (type == 118) {
                    count = achievementTask.wishPoolGetHeroStar5Count; //许愿获得%0次5星英雄
                }
                else if (type == 119) {
                    count = achievementTask.worldTreeRandomCardCount; //在世界树召唤%0次
                }
                else if (type == 120) {
                    count = achievementTask.heroStar10Count; //获得%0个10星英雄
                }
                taskitem.getChild("bars").asProgress.max = num;
                taskitem.getChild("bars").asProgress.value = count;
                taskitem.getController("c1").selectedIndex = 1;
                if (count >= num) {
                    taskitem.getChild("receivebtn").enabled = true;
                }
                else {
                    taskitem.getChild("receivebtn").enabled = false;
                }
                taskitem.getController("c2").selectedIndex = finish;
            }
        }
    };
    //日常：时间状态
    DailytaskView.prototype.showTime = function () {
        var passTime = DateUtils.getTodayPassedSecond(); //经过时间
        var residueTime = 86400 - passTime; //倒计时
        this.ui.getChild("time").asTextField.text = "倒计时 " + DateUtils.getFormatBySecond(residueTime, DateUtils.TIME_FORMAT_12);
    };
    //日常：前往Or领取
    DailytaskView.prototype.intoOrGet = function (obj) {
        var _this = this;
        var item = obj.itemObject;
        //前往
        if (this.hitTestPointWithFairyGUIComponent(item.getChild("gobtn").asButton, obj.stageX, obj.stageY)) {
            var id = item.getChild("gobtn").data; //前往ID
            if (id == 2) {
                ak.FairyGUI.open(["SummonView"]); //普通祭祀
            }
            else if (id == 3) {
                ak.FairyGUI.open(["SummonView"]); //高级祭祀
            }
            else if (id == 4) {
                ak.EventMgr.dispatch(GameEvent.mainUIDownTab); //探险收益
            }
            else if (id == 5) {
                ak.FairyGUI.open(["MoneyView"]); //点金
            }
            else if (id == 6) {
                ak.FairyGUI.open(["FriendView"]); //赠送好友友情印记
            }
            else if (id == 7) {
                ak.FairyGUI.open(["WishingwellView"]); //普通许愿池
            }
            else if (id == 8) {
                ak.FairyGUI.open(["SmithyView"]); //装备
            }
            else if (id == 9) {
                ak.FairyGUI.open(["TavernView"]); //悬赏
            }
            else if (id == 10) {
                ak.FairyGUI.open(["ArenaView"]); //挑战自由竞技场
            }
            else if (id == 11) {
                ak.FairyGUI.open(["TrialView"]); //挑战每日试炼
            }
            this.close();
        }
        //领取
        if (this.hitTestPointWithFairyGUIComponent(item.getChild("receivebtn").asButton, obj.stageX, obj.stageY)) {
            var taskID = item.getChild("receivebtn").data; //领取ID
            if (this.index) {
                net.finishAchievementTask(taskID, function () {
                    _this.updateList();
                }, this);
            }
            else {
                net.finishDailyTask(taskID, function () {
                    _this.updateList();
                }, this);
            }
        }
    };
    //道具信息
    DailytaskView.prototype.showItemInfo = function (obj) {
        var item = obj.itemObject;
        var data = item.data;
        if (this.hitTestPointWithFairyGUIComponent(item, obj.stageX, obj.stageY)) {
            if (data.type != 3) {
                var bagtype = ak.JsonTableMgr.get("item").getRowFromColName("id", "" + data.itemID).getValFromColName("bagtype");
                ak.FairyGUI.open(["WeaponTipsView", data.itemID, data.count, bagtype - 1, 0, true]);
            }
            else {
                ak.FairyGUI.open(["ResourceTipsView", data.itemID, data.count]);
            }
        }
    };
    //日常：任务列表
    DailytaskView.prototype.taskDailyList = function () {
        var dailyTask = MyData.user.json.dailyTask;
        var row = this.taskDailyTab.getRowFromColName("id", "" + 1);
        var num = row.getValFromColName("num"); //所需数量
        var text = row.getValFromColName("text"); //描述
        var drop = row.getValFromColName("drop"); //奖励
        var idMap = dailyTask.idMap;
        var arr = Object.keys(idMap);
        var arrCount = arr.length;
        this.ui.getChild("bar").asProgress.max = num;
        this.ui.getChild("bar").asProgress.value = arrCount;
        var arrItem = ItemMgr.getDropGroupByID(drop);
        var type = arrItem[0][1];
        var itemID = arrItem[0][2];
        var count = arrItem[0][3];
        var item = this.ui.getChild("item").asCom;
        var itemBase = new ItemBase(item, this, type);
        itemBase.setItemData(Number(itemID));
        itemBase.setNumber(count, true);
        if (arrCount == 10) {
            this.ui.getChild("lingqu").enabled = true;
        }
        else {
            this.ui.getChild("lingqu").enabled = false;
        }
        this.richangPaixu();
        var paixuCount = this.idArrRiChang.length;
        for (var i = 0; i < paixuCount; i++) {
            var taskID = this.idArrRiChang[i];
            var taskitem = this.list.addItemFromPool().asCom;
            var row_4 = this.taskDailyTab.getRowFromColName("id", "" + taskID);
            var num_1 = row_4.getValFromColName("num"); //所需数量
            var text_1 = row_4.getValFromColName("text"); //描述
            var drop_1 = row_4.getValFromColName("drop"); //奖励
            var taskItemList = taskitem.getChild("list").asList;
            var arrItem_1 = ItemMgr.getDropGroupByID(drop_1);
            taskItemList.removeChildrenToPool();
            for (var j = 0; j < arrItem_1.length; j++) {
                var type_2 = arrItem_1[j][1];
                var itemID_1 = arrItem_1[j][2];
                var count_3 = arrItem_1[j][3];
                var minItem = taskItemList.addItemFromPool().asCom;
                minItem.data = { itemID: itemID_1, count: count_3, type: type_2 };
                var item_2 = minItem.getChild("n1").asCom;
                var itemBase_1 = new ItemBase(item_2, this, type_2);
                itemBase_1.setItemData(Number(itemID_1));
                itemBase_1.setNumber(count_3, true);
            }
            this.onFairyguiEvent(taskItemList, fairygui.ItemEvent.CLICK, this.showItemInfo, this);
            taskitem.getChild("title").asTextField.text = "" + ak.strFormat(text_1, num_1);
            taskitem.getChild("gobtn").data = taskID;
            taskitem.getChild("receivebtn").data = taskID;
            var count_4 = 0;
            if (taskID == 2) {
                count_4 = dailyTask.randomCardNormalCount; //完成%0次普通祭祀
            }
            else if (taskID == 3) {
                count_4 = dailyTask.randomCardTopCount; //完成%0次高级祭祀
            }
            else if (taskID == 4) {
                count_4 = dailyTask.hookCount; //获取%0次探险收益
            }
            else if (taskID == 5) {
                count_4 = dailyTask.getGoldCount; //完成%0次点金
            }
            else if (taskID == 6) {
                count_4 = dailyTask.friendGiveHeartCount; //赠送好友%0次友情印记
            }
            else if (taskID == 7) {
                count_4 = dailyTask.wishNormalCount; //抽取%0次普通许愿池
            }
            else if (taskID == 8) {
                count_4 = dailyTask.equComposeCount; //合成%0件装备
            }
            else if (taskID == 9) {
                count_4 = dailyTask.pubTaskCount; //完成%0个悬赏
            }
            else if (taskID == 10) {
                count_4 = dailyTask.stageReqBattleCount; //挑战%0次自由竞技场
            }
            else if (taskID == 11) {
                count_4 = dailyTask.testCount; //挑战%0次每日试炼
            }
            taskitem.getChild("bars").asProgress.max = num_1;
            taskitem.getChild("bars").asProgress.value = count_4;
            if (count_4 >= num_1) {
                taskitem.getController("c1").selectedIndex = 1;
                if (idMap[taskID]) {
                    taskitem.getChild("receivebtn").enabled = false;
                }
                else {
                    taskitem.getChild("receivebtn").enabled = true;
                }
            }
            else {
                taskitem.getController("c1").selectedIndex = 0;
            }
            taskitem.getController("c2").selectedIndex = 0;
        }
    };
    DailytaskView.prototype.richangPaixu = function () {
        this.idArrRiChang = [];
        var dailyTask = MyData.user.json.dailyTask;
        var idMap = dailyTask.idMap;
        var upArr = [];
        var centerArr = [];
        for (var i = 2; i < 12; i++) {
            var row = this.taskDailyTab.getRowFromColName("id", "" + i);
            var num = row.getValFromColName("num"); //所需数量
            var count = 0;
            if (i == 2) {
                count = dailyTask.randomCardNormalCount; //完成%0次普通祭祀
            }
            else if (i == 3) {
                count = dailyTask.randomCardTopCount; //完成%0次高级祭祀
            }
            else if (i == 4) {
                count = dailyTask.hookCount; //获取%0次探险收益
            }
            else if (i == 5) {
                count = dailyTask.getGoldCount; //完成%0次点金
            }
            else if (i == 6) {
                count = dailyTask.friendGiveHeartCount; //赠送好友%0次友情印记
            }
            else if (i == 7) {
                count = dailyTask.wishNormalCount; //抽取%0次普通许愿池
            }
            else if (i == 8) {
                count = dailyTask.equComposeCount; //合成%0件装备
            }
            else if (i == 9) {
                count = dailyTask.pubTaskCount; //完成%0个悬赏
            }
            else if (i == 10) {
                count = dailyTask.stageReqBattleCount; //挑战%0次自由竞技场
            }
            else if (i == 11) {
                count = dailyTask.testCount; //挑战%0次每日试炼
            }
            if (count >= num) {
                if (!idMap.hasOwnProperty(i)) {
                    upArr.push(i);
                }
            }
            else {
                centerArr.push(i);
            }
        }
        //顶部待领取
        var countA = upArr.length;
        for (var a = 0; a < countA; a++) {
            this.idArrRiChang.push(upArr[a]);
        }
        //中部前往
        var countB = centerArr.length;
        for (var b = 0; b < countB; b++) {
            this.idArrRiChang.push(centerArr[b]);
        }
        //底部已领取
        var arr = Object.keys(idMap);
        var arrCount = arr.length;
        for (var j = 0; j < arrCount; j++) {
            this.idArrRiChang.push(arr[j]);
        }
    };
    DailytaskView.prototype.chengjiuPaixu = function () {
        this.idArrChengJiu = [];
        var upArr = [];
        var centerArrUp = [];
        var centerArrDown = [];
        var achievementTask = MyData.user.json.achievementTask;
        var idMap = achievementTask.idMap;
        var newArr = [];
        var arr = Object.keys(idMap);
        var arrCount = arr.length;
        if (arrCount) {
            newArr = arr.map(Number);
        }
        var countTask = this.taskTab.size();
        var countType = this.taskTypeTab.size();
        for (var i = 0; i < countType; i++) {
            var rowType = this.taskTypeTab.getRow(i);
            var type = rowType.getValFromColName("type"); //任务类型
            var textT = rowType.getValFromColName("text"); //描述
            var taskId = 0;
            var pass = 1;
            var finish = 0;
            for (var j = 0; j < countTask; j++) {
                var rowT = this.taskTab.getRow(j);
                var id = rowT.getValFromColName("id"); //成就任务ID
                var next = rowT.getValFromColName("next"); //下一个任务
                var typeTask = rowT.getValFromColName("type"); //任务类型
                var passRace = newArr.indexOf(id);
                if (passRace == -1 && typeTask == type && pass) {
                    taskId = id;
                    pass = 0;
                }
                if (next == 0 && typeTask == type && pass) {
                    taskId = id;
                    pass = 0;
                    finish = 1;
                }
            }
            if (taskId) {
                var rowT = this.taskTab.getRowFromColName("id", "" + taskId);
                var num = rowT.getValFromColName("num"); //所需数量
                var count = 0;
                if (type == 101) {
                    count = MyData.user.level;
                }
                else if (type == 102) {
                    count = achievementTask.heroStar4Count; //获得%0个4星英雄
                }
                else if (type == 103) {
                    count = achievementTask.heroStar5Count; //获得%0个5星英雄
                }
                else if (type == 104) {
                    count = achievementTask.heroStar6Count; //获得%0个6星英雄
                }
                else if (type == 105) {
                    count = achievementTask.heroStar9Count; //获得%0个9星英雄
                }
                else if (type == 106) {
                    count = achievementTask.heroDecomposeCount; //分解%0个英雄
                }
                else if (type == 107) {
                    count = achievementTask.equColor3Count; //获得%0件紫色装备
                }
                else if (type == 108) {
                    count = achievementTask.equColor4Count; //获得%0件橙色装备
                }
                else if (type == 109) {
                    count = achievementTask.equColor5Count; //获得%0件红色装备
                }
                else if (type == 110) {
                    count = achievementTask.stageWinCount; //自由竞技场胜%0次
                }
                else if (type == 111) {
                    count = achievementTask.stageScore; //自由竞技场达到%0分
                }
                else if (type == 112) {
                    count = achievementTask.pubTaskColor2Count; //完成蓝色悬赏任务%0次
                }
                else if (type == 113) {
                    count = achievementTask.pubTaskColor3Count; //完成紫色悬赏%0次
                }
                else if (type == 114) {
                    count = achievementTask.pubTaskColor4Count; //完成橙色悬赏任务%0次
                }
                else if (type == 115) {
                    count = achievementTask.pubTaskColor5Count; //完成红色悬赏任务%0次
                }
                else if (type == 116) {
                    count = achievementTask.friendSearchCount; //好友搜寻%0次敌人
                }
                else if (type == 117) {
                    // count=0;//十字军通过第%0关
                    var remoteBattle = MyData.user.json.remoteBattle;
                    count = remoteBattle.battleMaxCount;
                }
                else if (type == 118) {
                    count = achievementTask.wishPoolGetHeroStar5Count; //许愿获得%0次5星英雄
                }
                else if (type == 119) {
                    count = achievementTask.worldTreeRandomCardCount; //在世界树召唤%0次
                }
                else if (type == 120) {
                    count = achievementTask.heroStar10Count; //获得%0个10星英雄
                }
                if (count >= num) {
                    if (!idMap.hasOwnProperty(taskId)) {
                        upArr.push(type);
                    }
                }
                else {
                    if (count) {
                        centerArrUp.push(type);
                    }
                    else {
                        centerArrDown.push(type);
                    }
                }
            }
        }
        //顶部待领取
        var countA = upArr.length;
        for (var a = 0; a < countA; a++) {
            this.idArrChengJiu.push(upArr[a]);
        }
        //中部上无领取
        var countB = centerArrUp.length;
        for (var b = 0; b < countB; b++) {
            this.idArrChengJiu.push(centerArrUp[b]);
        }
        //中部下无领取
        var countC = centerArrDown.length;
        for (var c = 0; c < countC; c++) {
            this.idArrChengJiu.push(centerArrDown[c]);
        }
        //底部已领取
        for (var j = 0; j < countType; j++) {
            var rowType = this.taskTypeTab.getRow(j);
            var type = rowType.getValFromColName("type"); //任务类型
            var pass = this.idArrChengJiu.indexOf(type);
            if (pass == -1) {
                this.idArrChengJiu.push(type);
            }
        }
    };
    return DailytaskView;
}(ak.EasyUI));
__reflect(DailytaskView.prototype, "DailytaskView");
//每日首冲
var EverydayRechargeSystem = (function (_super) {
    __extends(EverydayRechargeSystem, _super);
    function EverydayRechargeSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    EverydayRechargeSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("EverydayRecharge");
    };
    EverydayRechargeSystem.inst = new EverydayRechargeSystem("EverydayRecharge");
    return EverydayRechargeSystem;
}(ak.FairyGUI));
__reflect(EverydayRechargeSystem.prototype, "EverydayRechargeSystem");
var EverydayRechargeView = (function (_super) {
    __extends(EverydayRechargeView, _super);
    function EverydayRechargeView() {
        return _super.call(this, EverydayRechargeSystem.inst, MyGame.inst.uiLayer2_1) || this;
    }
    //初始化
    EverydayRechargeView.prototype.onInit = function () {
        var ui = this.create("EverydayRecharge", "EverydayRechargeView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.rechargeBtn = this.ui.getChild("recharge").asButton;
        this.getrewardBtn = this.ui.getChild("getaward").asButton;
        this.rewardlist = this.ui.getChild("rewardlist").asList;
        this.rechargetext = this.ui.getChild("number").asTextField;
        this.everydayTab = ak.JsonTableMgr.get("fristRechargeDaily");
        this.clickAdd();
        this.showView();
    };
    EverydayRechargeView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this); //关闭界面
        this.addClickListener(this.rechargeBtn, this.onClick, this); //充值
        this.addClickListener(this.getrewardBtn, this.onClick, this); //领取
        this.onFairyguiEvent(this.rewardlist, fairygui.ItemEvent.CLICK, this.showdetails, this);
    };
    EverydayRechargeView.prototype.onClick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.rechargeBtn:
                ak.FairyGUI.open(["RechargeView"]);
                this.close();
                break;
            case this.getrewardBtn:
                net.dailyRechargeReward(function () {
                    _this.showView();
                }, this); //今日累充领取奖励
                break;
        }
    };
    EverydayRechargeView.prototype.showView = function () {
        var money = MyData.user.json.recharge.dailyPay;
        //money=money*0.01;
        this.rewardlist.removeChildrenToPool();
        var count = this.everydayTab.size();
        var ItemInfo = this.everydayTab.getRow(0);
        var pay = ItemInfo.getValFromColName("pay");
        var drop = ItemInfo.getValFromColName("drop");
        var item_Cfg01 = ItemMgr.getDropGroupByID(Number(drop));
        for (var i = 0; i < item_Cfg01.length; i++) {
            var everyday_recharge = this.rewardlist.addItemFromPool().asCom;
            var item0 = everyday_recharge.getChild("n0").asCom;
            var item_type = item_Cfg01[i][1];
            var item_id = item_Cfg01[i][2];
            var item_count = item_Cfg01[i][3];
            var item0_list = []; //物品详情所需数据
            item0_list["index"] = item_id;
            item0_list["num"] = item_count;
            item0_list["itemtype"] = item_type;
            item0.data = item0_list;
            var itemBase0 = new ItemBase(item0, this, item_type);
            itemBase0.setItemData(Number(item_id));
            itemBase0.setNumber(item_count, true);
            if (MyData.user.json.recharge.dailyPayReward != 1) {
                item0.getController("light").selectedIndex = 1;
                everyday_recharge.getController("ispick").selectedIndex = 0;
                this.ui.getController("c1").selectedIndex = money >= pay ? 1 : 0;
            }
            else {
                item0.getController("light").selectedIndex = 0;
                everyday_recharge.getController("ispick").selectedIndex = 1;
                this.ui.getController("c1").selectedIndex = 2;
            }
        }
        if (pay - money >= 0) {
            var rechargeConfigTab = ak.JsonTableMgr.get("rechargeConfig");
            var rechargeConfigRow = rechargeConfigTab.getRow(0);
            var scale = rechargeConfigRow.getValFromColName("scale"); //充值比例
            this.rechargetext.text = ((pay - money) / 100 * scale).toString();
        }
        else {
            this.rechargetext.text = "0";
        }
    };
    EverydayRechargeView.prototype.showdetails = function (obj) {
        var item = obj.itemObject;
        var itemCom = item.getChild("n0").asCom;
        if (this.hitTestPointWithFairyGUIComponent(itemCom, obj.stageX, obj.stageY)) {
            if (itemCom.data.itemtype != 3)
                ak.FairyGUI.open(["WeaponTipsView", itemCom.data.index, itemCom.data.num, 1]);
            else
                ak.FairyGUI.open(["ResourceTipsView", itemCom.data.index, itemCom.data.num]);
        }
    };
    return EverydayRechargeView;
}(ak.EasyUI));
__reflect(EverydayRechargeView.prototype, "EverydayRechargeView");
var EnemyInfoViewSystem = (function (_super) {
    __extends(EnemyInfoViewSystem, _super);
    function EnemyInfoViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    EnemyInfoViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ExpeditionView");
    };
    EnemyInfoViewSystem.inst = new EnemyInfoViewSystem("ExpeditionView");
    return EnemyInfoViewSystem;
}(ak.FairyGUI));
__reflect(EnemyInfoViewSystem.prototype, "EnemyInfoViewSystem");
/**
 * 远征-敌方信息
 */
var EnemyInfoView = (function (_super) {
    __extends(EnemyInfoView, _super);
    function EnemyInfoView(index) {
        var _this = _super.call(this, EnemyInfoViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
        _this.index = 0;
        _this.enemyInfo = {};
        _this.index = index;
        _this.enemyInfo = MyData.user.json.remoteBattle.enemyArr[index];
        return _this;
    }
    /**回调 */
    EnemyInfoView.prototype.onInit = function () {
        var ui = this.create("ExpeditionView", "EnemyInfoView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.enemyitem = ui.getChild("enemyitem").asCom;
        this.enemyname = ui.getChild("enemyname").asTextField;
        this.enemypower = ui.getChild("enemypower").asTextField;
        this.enemyArea = ui.getChild("enemyArea").asTextField;
        this.enemylist = ui.getChild("enemylist").asList;
        this.rewardlist = ui.getChild("rewardlist").asList;
        this.fightbtn = ui.getChild("fightbtn").asButton;
        this.ClickAdd();
        this.staticView();
        this.updateEnemylist();
        this.updateRewardlist();
    };
    EnemyInfoView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.fightbtn, this.onClick, this);
    };
    EnemyInfoView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.fightbtn:
                this.close();
                ak.FairyGUI.open(["FightReady2View", 1]);
                break;
        }
    };
    EnemyInfoView.prototype.updateEnemylist = function () {
        var nowindex = MyData.user.json.remoteBattle.battleIndex;
        this.enemylist.removeChildrenToPool();
        var cardArr = this.enemyInfo.cardArr;
        if (this.enemyInfo.monsterGroupID != 0) {
            var monsterInfo = this.enemyInfo.monsterInfo[0];
            for (var i = 0; i < monsterInfo.length; i++) {
                if (monsterInfo[i]) {
                    var com = this.enemylist.addItemFromPool().asCom;
                    var item = com.getChild("item").asCom;
                    var bar = com.getChild("bar").asProgress;
                    var heroID = monsterInfo[i][0].heroID;
                    var items = new ItemBase(item, this, 2);
                    items.setItemData(heroID, HeroBagData.inst().GetRaceById(heroID), HeroBagData.inst().GetStarById(heroID));
                    items.setNumber(monsterInfo[i][0].level);
                    bar.max = monsterInfo[i][0].hp * monsterInfo[i][1];
                    bar.value = MyData.user.json.remoteBattle.hpArr[i];
                    if (this.index != nowindex) {
                        items.setDark(true);
                        bar.value = 0;
                    }
                    else {
                        if (bar.value == 0) {
                            items.setDark(true);
                        }
                        else {
                            items.setDark(false);
                        }
                    }
                }
            }
        }
        else {
            for (var i = 0; i < cardArr.length; i++) {
                if (i < 6) {
                    if (cardArr[i] && cardArr[i].heroID != 0) {
                        var com = this.enemylist.addItemFromPool().asCom;
                        var item = com.getChild("item").asCom;
                        var bar = com.getChild("bar").asProgress;
                        var heroID = cardArr[i].heroID;
                        var items = new ItemBase(item, this, 2);
                        items.setItemData(heroID, HeroBagData.inst().GetRaceById(heroID), HeroBagData.inst().GetStarById(heroID));
                        items.setNumber(cardArr[i].level);
                        bar.max = cardArr[i].hp;
                        bar.value = MyData.user.json.remoteBattle.hpArr[i];
                        if (this.index != nowindex) {
                            items.setDark(true);
                            bar.value = 0;
                        }
                        else {
                            if (bar.value == 0) {
                                items.setDark(true);
                            }
                            else {
                                items.setDark(false);
                            }
                        }
                    }
                }
            }
        }
    };
    EnemyInfoView.prototype.updateRewardlist = function () {
        this.rewardlist.removeChildrenToPool();
        var info = ExpeditionViewData.inst().getFightInfo(this.index);
        var itemArr = [];
        itemArr.push({ itemID: 2, num: info.gold, type: 3 });
        itemArr.push({ itemID: info.item, num: info.num, type: 1 });
        for (var i = 0; i < 2; i++) {
            var item = this.rewardlist.addItemFromPool().asCom;
            var items = new ItemBase(item, this, itemArr[i].type);
            items.setItemData(Number(itemArr[i].itemID));
            items.setNumber(itemArr[i].num, true);
        }
    };
    EnemyInfoView.prototype.staticView = function () {
        var nowindex = MyData.user.json.remoteBattle.battleIndex;
        this.fightbtn.visible = true;
        if (this.index == nowindex) {
            this.fightbtn.visible = true;
        }
        if (this.index < nowindex) {
            this.fightbtn.visible = false;
        }
        this.enemyname.text = "" + this.enemyInfo.nickname;
        if (this.enemyInfo.monsterGroupID == 0) {
            this.enemypower.text = "" + this.enemyInfo.battlePower;
        }
        else {
            this.enemypower.text = "" + ExpeditionViewData.inst().getNPCpower(this.enemyInfo);
        }
        this.enemyArea.text = "" + this.enemyInfo.serverName;
        var items = new ItemBase(this.enemyitem, this, 1);
        items.setIcons2("hero" + this.enemyInfo.head);
        items.setNumber(this.enemyInfo.level, true);
    };
    /**打开敌方信息界面 */
    EnemyInfoView.openEnemyInfoView = function (index) {
        //判断是否需要请求
        if (MyData.user.json.remoteBattle.enemyArr[index]) {
            ak.FairyGUI.open(["EnemyInfoView", index]);
        }
        else {
            net.findEnemy(function () {
                ak.FairyGUI.open(["EnemyInfoView", index]);
            }, this);
        }
    };
    return EnemyInfoView;
}(ak.EasyUI));
__reflect(EnemyInfoView.prototype, "EnemyInfoView");
//远征商店
var ExpeditionShopSystem = (function (_super) {
    __extends(ExpeditionShopSystem, _super);
    function ExpeditionShopSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ExpeditionShopSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ExpeditionView");
    };
    ExpeditionShopSystem.inst = new ExpeditionShopSystem("ExpeditionView");
    return ExpeditionShopSystem;
}(ak.FairyGUI));
__reflect(ExpeditionShopSystem.prototype, "ExpeditionShopSystem");
var ExpeditionShopView = (function (_super) {
    __extends(ExpeditionShopView, _super);
    function ExpeditionShopView() {
        return _super.call(this, ExpeditionShopSystem.inst, MyGame.inst.uiLayer2_1) || this;
    }
    ExpeditionShopView.prototype.onInit = function () {
        var ui = this.create("ExpeditionView", "ExpeditionShopView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.myExpeditionscore = this.ui.getChild("n11").asCom;
        this.expeditionlist = this.ui.getChild("n39").asList;
        this.expeditionshopTab = ak.JsonTableMgr.get("shopExpedition");
        this.clickAdd();
        this.setstaticView();
    };
    ExpeditionShopView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this); //关闭界面
        this.onFairyguiEvent(this.expeditionlist, fairygui.ItemEvent.CLICK, this.buyMarket, this);
    };
    ExpeditionShopView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
        }
    };
    ExpeditionShopView.prototype.updateView = function () {
        var number2 = this.myExpeditionscore.getChild("number").asTextField;
        var Info = this.expeditionshopTab.getRow(0);
        number2.text = "" + SummonData.inst().GetItemnumByid(Info.getValFromColName("costItem"));
        Common.labelIsOverLenght(number2, number2.text);
    };
    ExpeditionShopView.prototype.buyMarket = function (obj) {
        var item = obj.itemObject;
        for (var i = 0; i < 3; i++) {
            var itemCom = item.getChild("n1" + (i + 1)).asCom;
            var item1 = itemCom.getChild("n2").asCom; //获取元素中的物品栏
            if (this.hitTestPointWithFairyGUIComponent(itemCom, obj.stageX, obj.stageY)) {
                if (this.hitTestPointWithFairyGUIComponent(item1, obj.stageX, obj.stageY)) {
                    ak.FairyGUI.open(["WeaponTipsView", item1.data.id, item1.data.num, 1]);
                }
                else {
                    if (SummonData.inst().GetItemnumByid(itemCom.data.CostItem) >= itemCom.data.CostNum) {
                        ak.FairyGUI.open(["ChooseTipsView", 7, '确定购买当前商品？', this.updateView.bind(this), itemCom.data.index]);
                    }
                    else {
                        TipsViewSystem.show("远征军声望不够");
                        return;
                    }
                }
            }
        }
    };
    ExpeditionShopView.prototype.setstaticView = function () {
        ShopData.inst().setShopView(this, 2, this.expeditionlist, this.expeditionshopTab, '', '', this.myExpeditionscore);
        var photo_url_path = 'ui://common/token_yzjsw';
        //我的积分
        var icon2 = this.myExpeditionscore.getChild("icon").asLoader;
        var number2 = this.myExpeditionscore.getChild("number").asTextField;
        this.setLoaderUrl(icon2, photo_url_path);
        var Info = this.expeditionshopTab.getRow(0);
        number2.text = "" + SummonData.inst().GetItemnumByid(Info.getValFromColName("costItem"));
        Common.labelIsOverLenght(number2, number2.text);
    };
    return ExpeditionShopView;
}(ak.EasyUI));
__reflect(ExpeditionShopView.prototype, "ExpeditionShopView");
var ExpeditionViewSystem = (function (_super) {
    __extends(ExpeditionViewSystem, _super);
    function ExpeditionViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    ExpeditionViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ExpeditionView");
    };
    ExpeditionViewSystem.inst = new ExpeditionViewSystem("ExpeditionView");
    return ExpeditionViewSystem;
}(ak.FairyGUI));
__reflect(ExpeditionViewSystem.prototype, "ExpeditionViewSystem");
/**
 * 远征
 */
var ExpeditionView = (function (_super) {
    __extends(ExpeditionView, _super);
    function ExpeditionView() {
        var _this = _super.call(this, ExpeditionViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
        _this._iconY = 0;
        _this._iconMoveY = 0;
        _this.tweenGroup = [0, 0, 0, 66.7, 132, 198, 360, 460, 510, 510, 510, 475, 350, 198, 210];
        return _this;
    }
    /**回调 */
    ExpeditionView.prototype.onInit = function () {
        var ui = this.create("ExpeditionView", "ExpeditionView");
        this.on(GameEvent.fightRpcComplete, this.updateView, this);
        this.closebtn = ui.getChild("closebtn").asButton;
        this.houjingCom = ui.getChild("houjingCom").asCom;
        this.shopbtn = ui.getChild("shopbtn").asButton;
        this.tipsbtn = ui.getChild("tipsbtn").asButton;
        this.mysign = this.houjingCom.getChild("mysign").asCom;
        this.control_c1 = this.houjingCom.getController("c1");
        this.signGroup = [];
        this.boxGroup = [];
        for (var i = 0; i < 15; i++) {
            var sign = this.houjingCom.getChild("sign" + i).asCom;
            sign.data = { index: i };
            this.signGroup.push(sign);
        }
        for (var j = 0; j < 5; j++) {
            var box = this.houjingCom.getChild("box" + j).asCom;
            this.boxGroup.push(box);
        }
        this.ClickAdd();
        this.updateView();
    };
    ExpeditionView.prototype.ClickAdd = function () {
        this.addClickListener(this.closebtn, this.onClick, this);
        this.addClickListener(this.shopbtn, this.onClick, this);
        this.addClickListener(this.tipsbtn, this.onClick, this);
        this.addClickListener(this.mysign, this.onClick, this);
        for (var i = 0; i < 15; i++) {
            this.addClickListener(this.signGroup[i], this.signClick, this);
        }
        for (var j = 0; j < 5; j++) {
            this.addClickListener(this.boxGroup[j], this.boxClick, this);
        }
    };
    ExpeditionView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.closebtn:
                this.close();
                break;
            case this.shopbtn:
                ak.FairyGUI.open(["ExpeditionShopView"]);
                break;
            case this.tipsbtn:
                ak.FairyGUI.open(["HelpTipsView", 11]);
                break;
            case this.mysign:
                //开始战斗
                var index = MyData.user.json.remoteBattle.battleIndex;
                EnemyInfoView.openEnemyInfoView(index);
                break;
        }
    };
    ExpeditionView.prototype.signClick = function (e) {
        var signindex = e.target.data.index;
        var index = MyData.user.json.remoteBattle.battleIndex;
        if (index == signindex) {
            //战斗
            EnemyInfoView.openEnemyInfoView(signindex);
        }
        if (signindex < index) {
            EnemyInfoView.openEnemyInfoView(signindex);
        }
        if (signindex > index) {
            TipsViewSystem.show("请通关上一关卡");
        }
    };
    ExpeditionView.prototype.boxClick = function (e) {
        var _this = this;
        var index = e.target.data.index;
        var passRewardArr = [3, 6, 9, 12, 15];
        var battleIndex = passRewardArr[index];
        if (this.isCanReceive(index)) {
            //领取奖励rpc
            net.getPassReward(battleIndex, function () {
                _this.updateView();
            }, this);
        }
        else {
            ak.FairyGUI.open(["RewardShow2View", index]);
        }
    };
    ExpeditionView.prototype.updateView = function () {
        this.control_c1.selectedIndex = 1;
        this.signshow();
        this.boxshow();
    };
    /**图标显示 */
    ExpeditionView.prototype.signshow = function () {
        var index = MyData.user.json.remoteBattle.battleIndex;
        if (index > 14)
            index = 14;
        var landsign = this.signGroup[index];
        this.mysign.x = landsign.x;
        this.mysign.y = landsign.y - landsign.height * 2;
        var number = this.mysign.getChild("number").asTextField;
        number.text = String(index + 1);
        this._iconY = this.mysign.y;
        this._iconMoveY = this.mysign.y - 10;
        this.signTween();
        this.beijingTween();
    };
    ExpeditionView.prototype.signTween = function () {
        egret.Tween.removeTweens(this.mysign);
        egret.Tween.get(this.mysign, { loop: true }).to({ y: this._iconMoveY }, 1000).to({ y: this._iconY }, 1000);
    };
    ExpeditionView.prototype.beijingTween = function () {
        var _this = this;
        var index = MyData.user.json.remoteBattle.battleIndex;
        if (index > 14)
            index = 14;
        if (this.houjingCom.scrollPane.posX == this.tweenGroup[index]) {
            this.isCloseTouchable(true);
        }
        else {
            this.isCloseTouchable(false);
            egret.Tween.removeTweens(this.houjingCom.scrollPane);
            egret.Tween.get(this.houjingCom.scrollPane, { loop: false }).to({ posX: this.houjingCom.scrollPane.posX }, 600).to({ posX: this.tweenGroup[index] }, 600).call(function () {
                _this.isCloseTouchable(true);
            });
        }
    };
    ExpeditionView.prototype.isCloseTouchable = function (isclose) {
        for (var i = 0; i < 15; i++) {
            this.signGroup[i].touchable = isclose;
        }
        this.closebtn.touchable = isclose;
        this.shopbtn.touchable = isclose;
        this.tipsbtn.touchable = isclose;
        this.mysign.touchable = isclose;
    };
    /**宝箱的展示 */
    ExpeditionView.prototype.boxshow = function () {
        //this.boxGroup
        var passRewardArr = [3, 6, 9, 12, 15];
        for (var i = 0; i < this.boxGroup.length; i++) {
            var box = this.boxGroup[i];
            var c1 = box.getController("c1");
            //判断
            var map = MyData.user.json.remoteBattle.passRewardMap;
            if (map[passRewardArr[i]]) {
                c1.selectedIndex = 2;
            }
            else {
                c1.selectedIndex = 1;
            }
            box.data = { index: i };
            if (this.isCanReceive(i)) {
                box.getTransition("t0").play();
            }
        }
    };
    /**判断宝箱是否可以领取 */
    ExpeditionView.prototype.isCanReceive = function (index) {
        var passRewardArr = [3, 6, 9, 12, 15];
        var num = MyData.user.json.remoteBattle.battleIndex + 1;
        var map = MyData.user.json.remoteBattle.passRewardMap;
        if (num > passRewardArr[index]) {
            if (map[passRewardArr[index]]) {
                return false;
            }
            else {
                return true;
            }
        }
        return false;
    };
    return ExpeditionView;
}(ak.EasyUI));
__reflect(ExpeditionView.prototype, "ExpeditionView");
/**
 * 远征数据
 */
var ExpeditionViewData = (function () {
    function ExpeditionViewData() {
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    ExpeditionViewData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new ExpeditionViewData();
        }
        return Class._instance;
    };
    /**
     * 获得箱子的数据
     */
    ExpeditionViewData.prototype.getBoxInfo = function (index) {
        var expeditionProgressPrizeTab = ak.JsonTableMgr.get("expeditionProgressPrize");
        var expeditionProgressPrizeInfo = expeditionProgressPrizeTab.getRow(index);
        var passNum = expeditionProgressPrizeInfo.getValFromColName("passNum");
        var gold = expeditionProgressPrizeInfo.getValFromColName("gold");
        var item = expeditionProgressPrizeInfo.getValFromColName("item");
        var num = expeditionProgressPrizeInfo.getValFromColName("num");
        var info = { passNum: passNum, gold: gold, item: item, num: num };
        return info;
    };
    /**
     * 获得战斗奖励信息
     */
    ExpeditionViewData.prototype.getFightInfo = function (index) {
        var expeditionPassPrizeTab = ak.JsonTableMgr.get("expeditionPassPrize");
        var expeditionPassPrizeInfo = expeditionPassPrizeTab.getRow(index);
        var id = expeditionPassPrizeInfo.getValFromColName("id");
        var gold = expeditionPassPrizeInfo.getValFromColName("gold");
        var item = expeditionPassPrizeInfo.getValFromColName("item");
        var num = expeditionPassPrizeInfo.getValFromColName("num");
        var info = { id: id, gold: gold, item: item, num: num };
        return info;
    };
    /**
     * 获得npc的战斗力
     */
    ExpeditionViewData.prototype.getNPCpower = function (enemyInfo) {
        var power = 0;
        if (enemyInfo.monsterGroupID != 0) {
            for (var i = 0; i < enemyInfo.monsterInfo[0].length; i++) {
                if (enemyInfo.monsterInfo[0][i]) {
                    power += enemyInfo.monsterInfo[0][i][0].battlePower;
                }
            }
        }
        return power;
    };
    /**
     * 判断
     */
    ExpeditionViewData.prototype.heroIsDead = function (index) {
        return true;
    };
    return ExpeditionViewData;
}());
__reflect(ExpeditionViewData.prototype, "ExpeditionViewData");
var RewardShow2ViewSystem = (function (_super) {
    __extends(RewardShow2ViewSystem, _super);
    function RewardShow2ViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    RewardShow2ViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ExpeditionView");
    };
    RewardShow2ViewSystem.inst = new RewardShow2ViewSystem("ExpeditionView");
    return RewardShow2ViewSystem;
}(ak.FairyGUI));
__reflect(RewardShow2ViewSystem.prototype, "RewardShow2ViewSystem");
/**
 * 远征奖励预览界面
 */
var RewardShow2View = (function (_super) {
    __extends(RewardShow2View, _super);
    function RewardShow2View(index) {
        var _this = _super.call(this, RewardShowViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
        _this.index = 0;
        _this.index = index;
        return _this;
    }
    /**回调 */
    RewardShow2View.prototype.onInit = function () {
        var ui = this.create("ExpeditionView", "RewardShowView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.closebtn = ui.getChild("closebtn").asButton;
        this.list = ui.getChild("list").asList;
        this.ClickAdd();
        this.updateList();
    };
    RewardShow2View.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.closebtn, this.onClick, this);
    };
    RewardShow2View.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.closebtn:
                this.close();
                break;
        }
    };
    RewardShow2View.prototype.updateList = function () {
        this.list.removeChildrenToPool();
        var info = ExpeditionViewData.inst().getBoxInfo(this.index);
        var itemArr = [];
        itemArr.push({ itemID: 2, num: info.gold, type: 3 });
        itemArr.push({ itemID: info.item, num: info.num, type: 1 });
        for (var i = 0; i < 2; i++) {
            var item = this.list.addItemFromPool().asCom;
            var items = new ItemBase(item, this, itemArr[i].type);
            items.setItemData(Number(itemArr[i].itemID));
            items.setNumber(itemArr[i].num, true);
        }
    };
    return RewardShow2View;
}(ak.EasyUI));
__reflect(RewardShow2View.prototype, "RewardShow2View");
var ExplorationAwardViewSystem = (function (_super) {
    __extends(ExplorationAwardViewSystem, _super);
    function ExplorationAwardViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    ExplorationAwardViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ExplorationView");
    };
    ExplorationAwardViewSystem.inst = new ExplorationAwardViewSystem("ExplorationView");
    return ExplorationAwardViewSystem;
}(ak.FairyGUI));
__reflect(ExplorationAwardViewSystem.prototype, "ExplorationAwardViewSystem");
/**
 * 挂机奖励
 */
var ExplorationAwardView = (function (_super) {
    __extends(ExplorationAwardView, _super);
    function ExplorationAwardView(type, id) {
        var _this = _super.call(this, ExplorationAwardViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.type = 0;
        _this.id = 0;
        _this.type = type;
        _this.id = id;
        return _this;
    }
    /**回调 */
    ExplorationAwardView.prototype.onInit = function () {
        var ui = this.create("ExplorationView", "ExplorationAwardView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.guajibtn = ui.getChild("guajibtn").asButton;
        this.list = ui.getChild("list").asList;
        this.txt0 = ui.getChild("txt0").asTextField;
        this.txt1 = ui.getChild("txt1").asTextField;
        this.txt2 = ui.getChild("txt2").asTextField;
        this.txt3 = ui.getChild("txt3").asTextField;
        this.control_c1 = ui.getController("c1");
        this.ClickAdd();
        this.setControl();
        this.updateList();
        this.updateTxt();
    };
    ExplorationAwardView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.guajibtn, this.onClick, this);
    };
    ExplorationAwardView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.guajibtn:
                this.setHookSelectPlace();
                break;
        }
    };
    ExplorationAwardView.prototype.setControl = function () {
        this.control_c1.selectedIndex = this.type;
    };
    ExplorationAwardView.prototype.updateList = function () {
        this.list.removeChildrenToPool();
        var dropID = Number(ExplorationData.inst().GetInfoById(this.id).dropGroup);
        var itemGroup = ItemMgr.getDropGroupByID(dropID);
        for (var i = 0; i < itemGroup.length; i++) {
            var item = this.list.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
            var type = 0;
            var items = new ItemBase(item, this, itemGroup[i][1]);
            items.setItemData(itemGroup[i][2]);
        }
    };
    ExplorationAwardView.prototype.updateTxt = function () {
        this.txt0.text = ExplorationData.inst().GetInfoById(this.id).heroExpPer + "/m";
        this.txt1.text = ExplorationData.inst().GetInfoById(this.id).goldPer + "/m";
        this.txt2.text = ExplorationData.inst().GetInfoById(this.id).expPer + "/m";
        this.txt3.text = ExplorationData.inst().GetInfoById(this.id).jifenPer + "/m";
    };
    ExplorationAwardView.prototype.setHookSelectPlace = function () {
        var _this = this;
        net.hookSelectPlace(this.id, function () {
            ak.EventMgr.dispatch(GameEvent.hookSelectPlace);
            if (MyConfig.openGuide) {
                ak.EventMgr.dispatch(GameEvent.guide_barrierIDchange);
            }
            _this.close();
        }, this);
    };
    return ExplorationAwardView;
}(ak.EasyUI));
__reflect(ExplorationAwardView.prototype, "ExplorationAwardView");
var ExplorationBossAwardViewSystem = (function (_super) {
    __extends(ExplorationBossAwardViewSystem, _super);
    function ExplorationBossAwardViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    ExplorationBossAwardViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ExplorationView");
    };
    ExplorationBossAwardViewSystem.inst = new ExplorationBossAwardViewSystem("ExplorationView");
    return ExplorationBossAwardViewSystem;
}(ak.FairyGUI));
__reflect(ExplorationBossAwardViewSystem.prototype, "ExplorationBossAwardViewSystem");
/**
 * 通关奖励
 */
var ExplorationBossAwardView = (function (_super) {
    __extends(ExplorationBossAwardView, _super);
    function ExplorationBossAwardView() {
        var _this = _super.call(this, ExplorationBossAwardViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.idGroup = [];
        return _this;
    }
    /**回调 */
    ExplorationBossAwardView.prototype.onInit = function () {
        var ui = this.create("ExplorationView", "ExplorationBossAwardView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.list = ui.getChild("list").asList;
        this.n3 = ui.getChild("n3").asTextField;
        this.ClickAdd();
        this.updateIdGroup();
        this.updateList();
    };
    ExplorationBossAwardView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.n3, this.onClick, this);
        this.onFairyguiEvent(this.list, fairygui.ItemEvent.CLICK, this.itemClick, this);
    };
    ExplorationBossAwardView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.n3:
                this.close();
                break;
        }
    };
    ExplorationBossAwardView.prototype.itemClick = function (e) {
        var _this = this;
        var item = e.itemObject;
        if (this.hitTestPointWithFairyGUIComponent(item.getChild("surebtn").asButton, e.stageX, e.stageY)) {
            net.getResFromHookAchievement(e.itemObject.data[3], function () {
                _this.updateIdGroup();
                _this.updateList();
            }, this);
        }
    };
    ExplorationBossAwardView.prototype.updateIdGroup = function () {
        this.idGroup = ExplorationData.inst().GetAwardlistInfo();
    };
    ExplorationBossAwardView.prototype.updateList = function () {
        this.list.removeChildrenToPool();
        for (var i = 0; i < this.idGroup.length; i++) {
            var item = this.list.addItemFromPool().asCom;
            var title = item.getChild("title").asTextField;
            var surebtn = item.getChild("surebtn").asButton;
            var list = item.getChild("list").asList;
            var imgs = item.getChild("imgs").asImage;
            item.data = this.idGroup[i];
            title.text = "\u901A\u5173\u7B2C" + this.idGroup[i][0] + "\u5173\u5361(" + (MyData.user.barrierID - 1) + "/" + this.idGroup[i][0] + ")";
            list.removeChildrenToPool();
            for (var j = 0; j < this.idGroup[i][1].length; j++) {
                var items = list.addItemFromPool().asCom;
                var items0 = items.getChild("item").asCom;
                var items2 = new ItemBase(items0, this, this.idGroup[i][1][j][1]);
                items2.setItemData(this.idGroup[i][1][j][2]);
                items2.setNumber(this.idGroup[i][1][j][3], true);
            }
            if (this.idGroup[i][2] == 0) {
                surebtn.visible = false;
                imgs.visible = false;
            }
            else if (this.idGroup[i][2] == 1) {
                surebtn.visible = true;
                imgs.visible = false;
            }
            else if (this.idGroup[i][2] == 2) {
                surebtn.visible = false;
                imgs.visible = true;
            }
        }
    };
    return ExplorationBossAwardView;
}(ak.EasyUI));
__reflect(ExplorationBossAwardView.prototype, "ExplorationBossAwardView");
/**
 * 探险数据
 */
var ExplorationData = (function () {
    function ExplorationData() {
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    ExplorationData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new ExplorationData();
        }
        return Class._instance;
    };
    /**获取信息 */
    ExplorationData.prototype.GetInfoById = function (id) {
        var itemTab = ak.JsonTableMgr.get("barrier");
        var itemInfo = itemTab.getRowFromColName("id", "" + id);
        var name = itemInfo.getValFromColName("name");
        var heroExpPer = itemInfo.getValFromColName("heroExpPer");
        var goldPer = itemInfo.getValFromColName("goldPer");
        var expPer = itemInfo.getValFromColName("expPer");
        var jifenPer = itemInfo.getValFromColName("jifenPer");
        var dropGroup = itemInfo.getValFromColName("dropGroup");
        var needLv = itemInfo.getValFromColName("needLv");
        var info = { name: name, heroExpPer: heroExpPer, goldPer: goldPer, expPer: expPer, jifenPer: jifenPer, dropGroup: dropGroup, needLv: needLv };
        return info;
    };
    /**获取挂机时间 */
    ExplorationData.prototype.GetTime = function () {
        var time = (new Date().getTime() / 1000) + MyData.timeBase - MyData.user.hookTime;
        return time;
    };
    /**获得最大挂机时间 */
    ExplorationData.prototype.GetMaxTime = function () {
        var barrierConfigTab = ak.JsonTableMgr.get("barrierConfig");
        var barrierConfigInfo = barrierConfigTab.getRow(0);
        var maxHookTime = barrierConfigInfo.getValFromColName("maxHookTime");
        maxHookTime += Vip.getRight(107) * 60 * 60;
        return maxHookTime;
    };
    /**获取探险次数 */
    ExplorationData.prototype.GetSpeedNum = function () {
        var barrierConfigTab = ak.JsonTableMgr.get("barrierConfig");
        var barrierConfigInfo = barrierConfigTab.getRow(0);
        var freeNum = barrierConfigInfo.getValFromColName("freeNum");
        var maxBuyNum = barrierConfigInfo.getValFromColName("maxBuyNum");
        var buyCost = barrierConfigInfo.getValFromColName("buyCost");
        var info = { freeNum: freeNum, maxBuyNum: maxBuyNum, buyCost: buyCost };
        return info;
    };
    /**获取列表数据
     * sign(0 - 未领取, 1 - 可领取, 2 - 已领取)
     */
    ExplorationData.prototype.GetAwardlistInfo = function () {
        var infolist = [];
        var barrierAchievementTab = ak.JsonTableMgr.get("barrierAchievement");
        var barrierAchievementSize = barrierAchievementTab.size();
        var achivementMap = MyData.user.json.hook.achivementMap;
        var awardedGroup = [];
        var awardGroup = [];
        for (var i = 0; i < barrierAchievementSize; i++) {
            var barrierAchievementInfo = barrierAchievementTab.getRowFromColName("id", "" + (i + 1));
            var barrier = barrierAchievementInfo.getValFromColName("barrier");
            var drop = barrierAchievementInfo.getValFromColName("drop");
            var dropGroup = ItemMgr.getDropGroupByID(drop);
            if (achivementMap[i + 1]) {
                awardedGroup.push([barrier, dropGroup, 2, i + 1]);
            }
            else {
                if (MyData.user.barrierID > barrier) {
                    awardGroup.push([barrier, dropGroup, 1, i + 1]);
                }
                else {
                    awardGroup.push([barrier, dropGroup, 0, i + 1]);
                }
            }
        }
        for (var t = 0; t < awardGroup.length; t++) {
            infolist.push(awardGroup[t]);
        }
        for (var k = 0; k < awardedGroup.length; k++) {
            infolist.push(awardedGroup[k]);
        }
        return infolist;
    };
    /**获得悬赏积分最大值 */
    ExplorationData.prototype.getjifenMax = function () {
        var barrierConfigTab = ak.JsonTableMgr.get("barrierConfig");
        var barrierConfigInfo = barrierConfigTab.getRow(0);
        var maxScroe = barrierConfigInfo.getValFromColName("maxScroe");
        return maxScroe;
    };
    return ExplorationData;
}());
__reflect(ExplorationData.prototype, "ExplorationData");
/**
 * 探险系统
 */
var ExplorationViewSystem = (function (_super) {
    __extends(ExplorationViewSystem, _super);
    function ExplorationViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    ExplorationViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ExplorationView");
    };
    ExplorationViewSystem.inst = new ExplorationViewSystem("ExplorationView");
    return ExplorationViewSystem;
}(ak.FairyGUI));
__reflect(ExplorationViewSystem.prototype, "ExplorationViewSystem");
/**
 * 探险界面
 */
var ExplorationView = (function (_super) {
    __extends(ExplorationView, _super);
    function ExplorationView() {
        var _this = _super.call(this, ExplorationViewSystem.inst, MyGame.inst.uiLayer) || this;
        _this._iconY = 0;
        _this._iconMoveY = 0;
        _this.nowminID = 0;
        /**是否可以请求 */
        _this.isrpcTime = false;
        /**箱子的动作 */
        _this.boxstr = "baixiang_jingzhi";
        _this.tweenGroup = [0, 0, 0, 66.7, 132, 198, 264, 330, 399, 399];
        /**刷新时间和道具数量 */
        _this.startime = 0;
        _this.isfirst = true;
        _this.isplay = true;
        /**悬赏积分处理 */
        _this.shp = new egret.Shape();
        return _this;
    }
    /**回调 */
    ExplorationView.prototype.onInit = function () {
        var ui = this.create("ExplorationView", "ExplorationView");
        this.on(GameEvent.selectMap, this.worldMapChange, this);
        this.on(GameEvent.hookSelectPlace, this.updataViewInfo, this);
        this.on(GameEvent.fightRpcComplete, this.updataViewInfo, this);
        this.on(GameEvent.fightRpcComplete, this.redDotHandle, this);
        this.on("netmsg://pub/beginTaskResult", this.updatejifen, this);
        this.on("netmsg://hook/getResResult", this.updatejifen, this);
        this.on("netmsg://hook/getResQuickResult", this.redDotHandle, this);
        this.on("netmsg://hook/getResFromAchievementResult", this.redDotHandle, this);
        this.on("netmsg://achievementTaskDataResult", this.redDotHandle, this);
        this.on("netmsg://dailyTaskDataResult", this.redDotHandle, this);
        this.on("netmsg://godWeapon/taskResult", this.redDotHandle, this);
        this.on("netmsg://godWeaponSysDataResult", this.redDotHandle, this);
        this.on(GameEvent.systemOpen_update, this.updataViewInfo, this);
        this.names = ui.getChild("names").asTextField;
        this.now0 = ui.getChild("now0").asTextField;
        this.now1 = ui.getChild("now1").asTextField;
        this.now2 = ui.getChild("now2").asTextField;
        this.now3 = ui.getChild("now3").asTextField;
        this.nowtime = ui.getChild("nowtime").asTextField;
        this.nownum0 = ui.getChild("nownum0").asTextField;
        this.nownum1 = ui.getChild("nownum1").asTextField;
        this.nownum2 = ui.getChild("nownum2").asTextField;
        this.nownum3 = ui.getChild("nownum3").asTextField;
        this.jifen = ui.getChild("jifen").asTextField;
        this.worldmapbtn = ui.getChild("worldmapbtn").asButton;
        this.tongguanbtn = ui.getChild("tongguanbtn").asButton;
        this.rankingbtn = ui.getChild("rankingbtn").asButton;
        this.bestrongbtn = ui.getChild("bestrongbtn").asButton;
        this.speedbtn = ui.getChild("speedbtn").asButton;
        this.nextbtn = ui.getChild("nextbtn").asButton;
        this.bossbtn = ui.getChild("bossbtn").asButton;
        this.worldmapbtn0 = ui.getChild("worldmapbtn0").asButton;
        this.lvbtn = ui.getChild("lvbtn").asButton;
        this.mapInfobtn = ui.getChild("mapInfobtn").asButton;
        this.jifenbtn = ui.getChild("jifenbtn").asLoader;
        this.qianjing1 = ui.getChild("qianjing1").asLoader;
        this.qingjing2 = ui.getChild("qianjing2").asLoader;
        this.boxbtn = ui.getChild("boxbtn").asLoader;
        this.taskBtn = ui.getChild("taskBtn").asButton;
        this.godBtn = ui.getChild("godBtn").asButton;
        this.moneyStack = ui.getChild("moneyStack").asCom;
        this.control_c1 = ui.getChild("beijing").asCom.getController("c1");
        this.control_c2 = ui.getController("c2");
        this.mysign = ui.getChild("beijing").asCom.getChild("mysign").asCom;
        this.beijing = ui.getChild("beijing").asCom;
        this.redDot = ui.getChild("redDot").asImage;
        this.redDot2 = ui.getChild("redDot2").asImage;
        this.jindupic = ui.getChild("jindupic").asLoader;
        this.signGroup = [];
        for (var i = 0; i < 10; i++) {
            var sign = ui.getChild("beijing").asCom.getChild("sign" + i).asCom;
            this.signGroup.push(sign);
        }
        this.ClickAdd();
        this.staticView();
        this.heroShow();
        this.isfirst = true;
        this.updataViewInfo();
        this.redDotHandle();
        this.moneyStackHandle();
    };
    ExplorationView.prototype.ClickAdd = function () {
        this.addClickListener(this.worldmapbtn, this.onClick, this);
        this.addClickListener(this.tongguanbtn, this.onClick, this);
        this.addClickListener(this.rankingbtn, this.onClick, this);
        this.addClickListener(this.bestrongbtn, this.onClick, this);
        this.addClickListener(this.speedbtn, this.onClick, this);
        this.addClickListener(this.nextbtn, this.onClick, this);
        this.addClickListener(this.bossbtn, this.onClick, this);
        this.addClickListener(this.worldmapbtn0, this.onClick, this);
        this.addClickListener(this.jifenbtn, this.onClick, this);
        this.addClickListener(this.mapInfobtn, this.onClick, this);
        this.addClickListener(this.boxbtn, this.onClick, this);
        this.addClickListener(this.taskBtn, this.onClick, this);
        this.addClickListener(this.godBtn, this.onClick, this);
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.timeDown, this);
        for (var i = 0; i < 10; i++) {
            this.addClickListener(this.signGroup[i], this.signClick, this);
        }
    };
    ExplorationView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.worldmapbtn:
                ak.FairyGUI.open(["WorldMapView"]);
                break;
            case this.tongguanbtn:
                ak.FairyGUI.open(["ExplorationBossAwardView"]);
                break;
            case this.rankingbtn:
                ak.FairyGUI.open(["RankView", 1, "关卡"]);
                break;
            case this.bestrongbtn:
                ak.FairyGUI.open(["GrowupView"]);
                break;
            case this.nextbtn:
                this.nextbarrier();
                break;
            case this.speedbtn:
                ak.FairyGUI.open(["SpeedExplorationView"]);
                break;
            case this.bossbtn:
                this.bosschallenge();
                break;
            case this.boxbtn:
                this.receiveHookTime();
                break;
            case this.worldmapbtn0:
                ak.FairyGUI.open(["WorldMapView"]);
                break;
            case this.jifenbtn:
                ak.FairyGUI.open(["TavernView"]);
                break;
            case this.mapInfobtn:
                ak.FairyGUI.open(["ExplorationAwardView", 0, MyData.user.getResBarrierID]);
                break;
            case this.taskBtn:
                ak.FairyGUI.open(["DailytaskView"]);
                break;
            case this.godBtn:
                var godWeaponSys = MyData.user.json.godWeaponSys;
                var godWeaponTab = GodWeaponData.inst().getGodWeaponCfgList();
                if (godWeaponSys.activeCount == godWeaponTab.size()) {
                    ak.FairyGUI.open(["GodWeaponSkillInfoView"]);
                }
                else if (godWeaponSys.activeCount > 0) {
                    ak.FairyGUI.open(["GodWeaponTaskView", godWeaponSys.activeCount + 1]);
                }
                else {
                    ak.FairyGUI.open(["GodWeaponView"]);
                }
                break;
        }
    };
    ExplorationView.prototype.signClick = function (e) {
        var id = e.target.data.id;
        if (id > MyData.user.barrierID) {
            TipsViewSystem.show("请通关上一关卡");
        }
        else {
            var info = ExplorationData.inst().GetInfoById(MyData.user.getResBarrierID);
            if (MyData.user.level < info.needLv) {
                TipsViewSystem.show("Lv" + info.needLv + "开启");
            }
            else {
                if (id == MyData.user.getResBarrierID) {
                    ak.FairyGUI.open(["ExplorationAwardView", 0, id]);
                }
                else {
                    ak.FairyGUI.open(["ExplorationAwardView", 1, id]);
                }
            }
        }
    };
    ExplorationView.prototype.staticView = function () {
        var icon0 = this.worldmapbtn.getChild("img").asLoader;
        this.setLoaderUrl(icon0, "ui://ExplorationView/ico_tanxian_sjdt");
        var icon1 = this.tongguanbtn.getChild("img").asLoader;
        this.setLoaderUrl(icon1, "ui://ExplorationView/ico_tanxian_tgjl");
        var icon2 = this.rankingbtn.getChild("img").asLoader;
        this.setLoaderUrl(icon2, "ui://ExplorationView/ico_tanxian_ph");
        var icon3 = this.bestrongbtn.getChild("img").asLoader;
        this.setLoaderUrl(icon3, "ui://ExplorationView/ico_woyaobianqiang");
    };
    /**更新界面信息 */
    ExplorationView.prototype.updataViewInfo = function () {
        var info = ExplorationData.inst().GetInfoById(MyData.user.getResBarrierID);
        this.names.text = info.name;
        this.now0.text = info.heroExpPer * 12 + "/m";
        this.now1.text = info.goldPer * 12 + "/m";
        this.now2.text = info.expPer * 12 + "/m";
        this.now3.text = info.jifenPer * 12 + "/m";
        this.lvbtn.touchable = false;
        if (MyData.user.level < info.needLv) {
            this.nextbtn.visible = false;
            this.bossbtn.visible = false;
            this.worldmapbtn0.visible = false;
            this.lvbtn.visible = true;
            this.lvbtn.text = "Lv" + info.needLv + "开启";
        }
        else {
            this.lvbtn.visible = false;
            if (MyData.user.getResBarrierID != MyData.user.barrierID) {
                this.nextbtn.visible = true;
                this.bossbtn.visible = false;
                this.worldmapbtn0.visible = false;
            }
            else {
                this.nextbtn.visible = false;
                this.bossbtn.visible = true;
                this.worldmapbtn0.visible = false;
            }
            var nowsignID = (Math.floor((MyData.user.getResBarrierID - 1) / 10)) * 10 + 10;
            if (this.isShowWorldMap()) {
                this.nextbtn.visible = false;
                this.bossbtn.visible = false;
                this.worldmapbtn0.visible = true;
            }
            else {
                this.worldmapbtn0.visible = false;
            }
        }
        if (GameSystem.isSysOpen(13, false)) {
            this.godBtn.visible = true;
        }
        else {
            this.godBtn.visible = false;
        }
        this.setMap();
        this.signshow();
        this.updatejifen();
    };
    /**展示英雄 */
    ExplorationView.prototype.heroShow = function () {
        var tt = new egret.DisplayObjectContainer();
        var obj = this.ui.getChild("hookScene").asGraph;
        obj.touchable = false;
        obj.setNativeObject(tt);
        new HookScene().addToParent(tt);
        var tt2 = new egret.DisplayObjectContainer();
        var obj2 = this.ui.getChild("hookScene2").asGraph;
        obj2.touchable = false;
        obj2.setNativeObject(tt2);
        this.box = new ak.Dragonbones("xiangzi_ske_json", "xiangzi_tex_json", "xiangzi_tex_png", "armatureName");
        this.box.addToParent(tt2);
        this.box.x = 300;
        this.box.y = 50;
        this.boxstr = "baoxiang_daiji";
        this.box.setAction(this.boxstr, 0);
        this.box.touchEnabled = true;
        this.box.on(egret.TouchEvent.TOUCH_TAP, this.onClick, this);
    };
    /**图标显示 */
    ExplorationView.prototype.signshow = function () {
        var id = MyData.user.getResBarrierID % 10;
        if (id == 0)
            id = 10;
        var landsign = this.signGroup[id - 1];
        this.mysign.x = landsign.x;
        this.mysign.y = landsign.y - landsign.height / 2;
        var icon = this.mysign.getChild("icon").asLoader;
        this.setLoaderUrl(icon, "hero" + MyData.user.head + "_png");
        this._iconY = this.mysign.y;
        this._iconMoveY = this.mysign.y - 10;
        this.signTween();
        this.beijingTween();
        this.signGroupshow();
    };
    ExplorationView.prototype.signTween = function () {
        egret.Tween.removeTweens(this.mysign);
        egret.Tween.get(this.mysign, { loop: true }).to({ y: this._iconMoveY }, 1000).to({ y: this._iconY }, 1000);
    };
    ExplorationView.prototype.beijingTween = function () {
        var _this = this;
        var id = MyData.user.getResBarrierID % 10;
        if (id == 0)
            id = 10;
        if (this.beijing.scrollPane.posX == this.tweenGroup[id - 1]) {
            this.isCloseTouchable(true);
        }
        else {
            this.isCloseTouchable(false);
            egret.Tween.removeTweens(this.beijing.scrollPane);
            egret.Tween.get(this.beijing.scrollPane, { loop: false }).to({ posX: this.beijing.scrollPane.posX }, 300).to({ posX: this.tweenGroup[id - 1] }, 300).call(function () {
                _this.isCloseTouchable(true);
            });
        }
    };
    ExplorationView.prototype.isCloseTouchable = function (isclose) {
        for (var i = 0; i < 10; i++) {
            this.signGroup[i].touchable = isclose;
        }
        this.nextbtn.touchable = isclose;
        this.bossbtn.touchable = isclose;
        this.worldmapbtn0.touchable = isclose;
    };
    /**下面10个地标的展示 */
    ExplorationView.prototype.signGroupshow = function () {
        var nowsignID = (Math.floor((MyData.user.getResBarrierID - 1) / 10)) * 10;
        for (var i = 0; i < 10; i++) {
            this.signGroup[i].data = { id: nowsignID + (i + 1) };
            if (this.signGroup[i].data.id <= MyData.user.barrierID) {
                this.signGroup[i].enabled = true;
            }
            else {
                this.signGroup[i].enabled = false;
                this.signGroup[i].touchable = true;
            }
        }
    };
    /**挑战领主 */
    ExplorationView.prototype.bosschallenge = function () {
        ak.FairyGUI.open(["FightReadyView", 1]);
    };
    /**领取挂机奖励 */
    ExplorationView.prototype.receiveHookTime = function () {
        var _this = this;
        if (!this.isrpcTime) {
            TipsViewSystem.show("没有可以领取的挂机奖励");
        }
        else {
            net.hookGetRes(function () {
                _this.isrpcTime = false;
                _this.startime = 0;
                _this.box.setAction("baixiang_jingzhi", 0);
                _this.updateText();
                _this.moneyStackHandle();
            }, this);
        }
    };
    /**下一关操作 */
    ExplorationView.prototype.nextbarrier = function () {
        var _this = this;
        var nextgetResBarrierID = MyData.user.getResBarrierID + 1;
        net.hookSelectPlace(nextgetResBarrierID, function () {
            _this.updataViewInfo();
            if (MyConfig.openGuide) {
                ak.EventMgr.dispatch(GameEvent.guide_barrierIDchange);
            }
        }, this);
    };
    ExplorationView.prototype.setHookSelectPlace = function (id) {
        var _this = this;
        net.hookSelectPlace(id, function () {
            _this.updataViewInfo();
            if (MyConfig.openGuide) {
                ak.EventMgr.dispatch(GameEvent.guide_barrierIDchange);
            }
        }, this);
    };
    ExplorationView.prototype.timeDown = function () {
        var time = ExplorationData.inst().GetTime();
        if (time >= 5)
            this.isrpcTime = true;
        if (time > 0) {
            var downtime = time;
            var Maxtime = ExplorationData.inst().GetMaxTime();
            if (downtime > Maxtime)
                downtime = Maxtime;
            this.nowtime.text = "\u6302\u673A\u65F6\u957F " + DateUtils.getFormatBySecond(downtime, DateUtils.TIME_FORMAT_12);
            if (this.isfirst) {
                this.startime = time;
                this.isfirst = false;
                this.updateText0(time);
            }
            else {
                if (Math.floor(time - this.startime) >= 5) {
                    this.startime = time;
                    if (!this.isrpcTime)
                        this.isrpcTime = true;
                    this.updateText0(time);
                    if (this.boxstr != "baoxiang_daiji") {
                        this.boxstr = "baoxiang_daiji";
                        this.box.setAction(this.boxstr, 0);
                    }
                }
                else {
                    if (this.boxstr != "baixiang_jingzhi" && this.isrpcTime == false) {
                        this.boxstr = "baixiang_jingzhi";
                        this.box.setAction(this.boxstr, 0);
                    }
                }
            }
        }
    };
    ExplorationView.prototype.updateText0 = function (time) {
        var info = ExplorationData.inst().GetInfoById(MyData.user.getResBarrierID);
        var nowMultiple = time / 5;
        this.nownum0.text = "" + Math.floor(info.heroExpPer * nowMultiple);
        this.nownum1.text = "" + Math.floor(info.goldPer * nowMultiple);
        this.nownum2.text = "" + Math.floor(info.expPer * nowMultiple);
        this.nownum3.text = "" + Math.floor(info.jifenPer * nowMultiple);
    };
    ExplorationView.prototype.updateText = function () {
        this.nowtime.text = "\u6302\u673A\u65F6\u957F " + DateUtils.getFormatBySecond(0, DateUtils.TIME_FORMAT_12);
        this.nownum0.text = "" + 0;
        this.nownum1.text = "" + 0;
        this.nownum2.text = "" + 0;
        this.nownum3.text = "" + 0;
    };
    /**判断是否显示世界地图 */
    ExplorationView.prototype.isShowWorldMap = function () {
        var nowsignID = (Math.floor((MyData.user.barrierID - 1) / 10)) * 10;
        if (MyData.user.getResBarrierID < (nowsignID + 1) && MyData.user.getResBarrierID % 10 == 0) {
            return true;
        }
        return false;
    };
    ExplorationView.prototype.worldMapChange = function () {
        //回调后
        //如果为最大的map,设置最大值为挂机点
        if (ExplorationView.difficulty == WorldMapData.inst().GetMaxdifficulty() && ExplorationView.map == WorldMapData.inst().GetMaxMap()) {
            this.setHookSelectPlace(MyData.user.barrierID);
        }
        else {
            var id = ExplorationView.difficulty * 80 + (ExplorationView.map + 1) * 10;
            this.setHookSelectPlace(id);
        }
    };
    /**设置地图 */
    ExplorationView.prototype.setMap = function () {
        var nowResBarrierID = MyData.user.getResBarrierID;
        var nowPicId = Math.floor(((nowResBarrierID - 1) - (Math.floor((nowResBarrierID - 1) / 80) * 80)) / 10);
        this.control_c1.selectedIndex = (nowPicId + 1);
        this.control_c2.selectedIndex = (nowPicId + 1);
    };
    /**更新积分信息 */
    ExplorationView.prototype.updatejifen = function () {
        this.jifen.text = "" + MyData.user.offerScore;
        this.jifenHandle();
    };
    /**金币堆的显示 */
    ExplorationView.prototype.moneyStackHandle = function () {
        var time = ExplorationData.inst().GetTime();
        var control = this.moneyStack.getController("c1");
        if (time > 300 && time < 1800) {
            control.selectedIndex = 1;
        }
        else if (time > 1800 && time < 3600) {
            control.selectedIndex = 2;
        }
        else if (time > 3600) {
            control.selectedIndex = 3;
        }
        else {
            control.selectedIndex = 0;
        }
    };
    //销毁回调
    ExplorationView.prototype.onDestroy = function () {
        //清理
        this.removeEventListener(egret.Event.ENTER_FRAME, this.timeDown, this);
    };
    ExplorationView.prototype.redDotHandle = function () {
        this.redDot.visible = RedDotMgr.speedExplorationRedDot() ? true : false;
        this.redDot2.visible = RedDotMgr.explorationBossAwardRedDot() ? true : false;
        var taskPoint = RedDotMgr.getTaskRedDot() || RedDotMgr.getTaskRedDot2();
        this.taskBtn.getController("c1").selectedIndex = taskPoint ? 1 : 0;
        var RedDot = RedDotMgr.allGodWeaponTaskCompleteRedDot();
        this.godBtn.getController("c1").selectedIndex = RedDot ? 1 : 0;
    };
    ExplorationView.prototype.jifenHandle = function () {
        var jifenMax = ExplorationData.inst().getjifenMax();
        var offerScore = MyData.user.offerScore;
        var diasnum = jifenMax - offerScore;
        var zhanfen = 0;
        if (offerScore >= jifenMax) {
            diasnum = 0;
            zhanfen = 0;
            offerScore = 1;
        }
        else {
            offerScore = offerScore / jifenMax;
        }
        var x = this.jindupic.x + this.jindupic.width / 2;
        var y = this.jindupic.y + this.jindupic.height / 2;
        this.addChild(this.shp);
        this.shp.x = x;
        this.shp.y = y;
        this.jindupic.displayObject.mask = this.drawCir(this.shp, this.jindupic.width / 2, offerScore);
    };
    /**画扇形 */
    ExplorationView.prototype.drawCir = function (shape, radius, percent) {
        if (shape == null) {
            shape = new egret.Shape();
        }
        function changeGraphics() {
            shape.graphics.clear();
            shape.graphics.beginFill(0x00ffff, 1);
            shape.graphics.moveTo(0, 0);
            shape.graphics.lineTo(0, -radius);
            var b = 270 * Math.PI / 180;
            var e = b + percent * 2 * Math.PI;
            shape.graphics.drawArc(0, 0, radius, b, e, false);
            shape.graphics.lineTo(0, 0);
            shape.graphics.endFill();
        }
        changeGraphics();
        return shape;
    };
    /**
     * 世界地图切换操作
     * 改变挂机点1（如果为最大关卡的地图时,设置当前全地图最大关卡为挂机点）
     * 改变挂机点2（如果为不是最大关卡的地图时,设置当前地图最大关卡为挂机点）
     * 改变地图
     */
    ExplorationView.difficulty = -1;
    ExplorationView.map = -1;
    return ExplorationView;
}(ak.EasyUI));
__reflect(ExplorationView.prototype, "ExplorationView");
var SpeedExplorationViewSystem = (function (_super) {
    __extends(SpeedExplorationViewSystem, _super);
    function SpeedExplorationViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    SpeedExplorationViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ExplorationView");
    };
    SpeedExplorationViewSystem.inst = new SpeedExplorationViewSystem("ExplorationView");
    return SpeedExplorationViewSystem;
}(ak.FairyGUI));
__reflect(SpeedExplorationViewSystem.prototype, "SpeedExplorationViewSystem");
/**
 * 快速挂机
 */
var SpeedExplorationView = (function (_super) {
    __extends(SpeedExplorationView, _super);
    function SpeedExplorationView() {
        return _super.call(this, SpeedExplorationViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
    }
    /**回调 */
    SpeedExplorationView.prototype.onInit = function () {
        var ui = this.create("ExplorationView", "SpeedExplorationView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.explorationNum = ui.getChild("explorationNum").asTextField;
        this.num0 = ui.getChild("num0").asTextField;
        this.num1 = ui.getChild("num1").asTextField;
        this.num2 = ui.getChild("num2").asTextField;
        this.speedbtn = ui.getChild("speedbtn").asButton;
        this.control_c1 = ui.getController("c1");
        this.control_c2 = ui.getController("c2");
        this.mianGroup = ui.getChild("mianGroup").asGroup;
        this.clock = ui.getChild("clock").asCom;
        this.ClickAdd();
        this.updateNum();
    };
    SpeedExplorationView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.speedbtn, this.onClick, this);
    };
    SpeedExplorationView.prototype.onClick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.speedbtn:
                net.getResQuick(function (dropMap) {
                    _this.updateNum();
                    _this.mianGroup.visible = false;
                    _this.clock.visible = true;
                    _this.bgclose.touchable = false;
                    _this.clock.getTransition("t0").play(function () {
                        _this.bgclose.touchable = true;
                        _this.close();
                        ak.FairyGUI.open(["GainitemView", dropMap]);
                    }, _this);
                }, this);
                break;
        }
    };
    SpeedExplorationView.prototype.updateNum = function () {
        var speednum = 0;
        if (Vip.getRight(201) == 1) {
            this.control_c2.selectedIndex = 1;
            if (MyData.user.json.hook.getResFreeCountQuick > 3) {
                this.control_c1.selectedIndex = 1;
            }
            else {
                this.control_c1.selectedIndex = 0;
            }
            this.explorationNum.text = "" + (3 - MyData.user.json.hook.getResFreeCountQuick);
            speednum = 11 - MyData.user.json.hook.getResCountQuick;
        }
        else {
            this.control_c2.selectedIndex = 0;
            if (MyData.user.json.hook.getResFreeCountQuick > 0) {
                this.control_c1.selectedIndex = 1;
            }
            else {
                this.control_c1.selectedIndex = 0;
            }
            this.explorationNum.text = "" + 1;
            speednum = ExplorationData.inst().GetSpeedNum().maxBuyNum - MyData.user.json.hook.getResCountQuick;
        }
        this.clock.visible = false;
        this.num0.text = "" + speednum;
        this.num1.text = "" + ExplorationData.inst().GetSpeedNum().buyCost[MyData.user.json.hook.getResCountQuick];
        this.num2.text = "(已拥有" + Number(MyData.user.diamond + MyData.user.diamond2) + ")";
    };
    return SpeedExplorationView;
}(ak.EasyUI));
__reflect(SpeedExplorationView.prototype, "SpeedExplorationView");
var WorldMapData = (function () {
    function WorldMapData() {
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    WorldMapData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new WorldMapData();
        }
        return Class._instance;
    };
    /**
     * 获取最大难度点
     */
    WorldMapData.prototype.GetMaxdifficulty = function () {
        var maxbarrierID = MyData.user.barrierID;
        var maxdifficulty = Math.floor(maxbarrierID / 80);
        return maxdifficulty;
    };
    WorldMapData.prototype.GetMaxMap = function () {
        var nowResBarrierID = MyData.user.barrierID;
        var nowPicId = Math.floor(((nowResBarrierID - 1) - (Math.floor((nowResBarrierID - 1) / 80) * 80)) / 10);
        return nowPicId;
    };
    WorldMapData.prototype.GetNowMaxMap = function () {
        var nowResBarrierID = MyData.user.getResBarrierID;
        var nowPicId = Math.floor(((nowResBarrierID - 1) - (Math.floor((nowResBarrierID - 1) / 80) * 80)) / 10);
        return nowPicId;
    };
    /**
     * 获得挂机的难度
     */
    WorldMapData.prototype.Getguajidiandifficulty = function () {
        var barrierID = MyData.user.getResBarrierID;
        var difficulty = Math.floor(barrierID / 80);
        if (difficulty > 4)
            difficulty = 4;
        return difficulty;
    };
    /**
     * 获得挂机点的地图
     */
    WorldMapData.prototype.GetguajidiandMap = function () {
        var nowResBarrierID = MyData.user.getResBarrierID;
        var nowPicId = Math.floor(((nowResBarrierID - 1) - (Math.floor((nowResBarrierID - 1) / 80) * 80)) / 10);
        return nowPicId;
    };
    return WorldMapData;
}());
__reflect(WorldMapData.prototype, "WorldMapData");
var WorldMapViewSystem = (function (_super) {
    __extends(WorldMapViewSystem, _super);
    function WorldMapViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    WorldMapViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("ExplorationView");
    };
    WorldMapViewSystem.inst = new WorldMapViewSystem("ExplorationView");
    return WorldMapViewSystem;
}(ak.FairyGUI));
__reflect(WorldMapViewSystem.prototype, "WorldMapViewSystem");
/**
 * 世界地图
 */
var WorldMapView = (function (_super) {
    __extends(WorldMapView, _super);
    function WorldMapView() {
        var _this = _super.call(this, WorldMapViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.difficulty = 0;
        _this.map = 0;
        /**彩色操作 */
        _this.chooseTipsViewInfo = "你确定要前往该区域进行战斗？";
        return _this;
    }
    /**回调 */
    WorldMapView.prototype.onInit = function () {
        var ui = this.create("ExplorationView", "WorldMapView");
        this.closebtn = ui.getChild("closebtn").asButton;
        this.mapimg = ui.getChild("mapimg").asLoader;
        this.btn0 = ui.getChild("btn0").asButton;
        this.btn1 = ui.getChild("btn1").asButton;
        this.btn2 = ui.getChild("btn2").asButton;
        this.btn3 = ui.getChild("btn3").asButton;
        this.btn4 = ui.getChild("btn4").asButton;
        this.map_0_0 = ui.getChild("map_0_0").asLoader;
        this.map_0_1 = ui.getChild("map_0_1").asLoader;
        this.map_1_0 = ui.getChild("map_1_0").asLoader;
        this.map_1_1 = ui.getChild("map_1_1").asLoader;
        this.map_2_0 = ui.getChild("map_2_0").asLoader;
        this.map_2_1 = ui.getChild("map_2_1").asLoader;
        this.map_3_0 = ui.getChild("map_3_0").asLoader;
        this.map_3_1 = ui.getChild("map_3_1").asLoader;
        this.map_4_0 = ui.getChild("map_4_0").asLoader;
        this.map_4_1 = ui.getChild("map_4_1").asLoader;
        this.map_5_0 = ui.getChild("map_5_0").asLoader;
        this.map_5_1 = ui.getChild("map_5_1").asLoader;
        this.map_6_0 = ui.getChild("map_6_0").asLoader;
        this.map_6_1 = ui.getChild("map_6_1").asLoader;
        this.map_7_0 = ui.getChild("map_7_0").asLoader;
        this.map_7_1 = ui.getChild("map_7_1").asLoader;
        this.finger = ui.getChild("finger").asCom;
        this.finger.visible = false;
        this.control_c1 = ui.getController("c1");
        this.ClickAdd();
        this.setNumber1(WorldMapData.inst().Getguajidiandifficulty());
        this.setNumber2(WorldMapData.inst().GetNowMaxMap());
        this.updateMapInfo();
    };
    WorldMapView.prototype.ClickAdd = function () {
        this.addClickListener(this.closebtn, this.onClick, this);
        this.addClickListener(this.btn0, this.onClick, this);
        this.addClickListener(this.btn1, this.onClick, this);
        this.addClickListener(this.btn2, this.onClick, this);
        this.addClickListener(this.btn3, this.onClick, this);
        this.addClickListener(this.btn4, this.onClick, this);
        for (var i = 0; i < 8; i++) {
            var map = this["map_" + i + "_1"];
            map.data = { map: i };
            this.addClickListener(map, this.map1Click, this);
        }
        for (var j = 0; j < 8; j++) {
            var map = this["map_" + j + "_0"];
            this.addClickListener(map, this.map0Click, this);
        }
    };
    WorldMapView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.closebtn:
                this.close();
                break;
            case this.btn0:
                this.setNumber1(0);
                this.updateMapInfo();
                break;
            case this.btn1:
                this.setNumber1(1);
                this.updateMapInfo();
                break;
            case this.btn2:
                this.setNumber1(2);
                this.updateMapInfo();
                break;
            case this.btn3:
                this.setNumber1(3);
                this.updateMapInfo();
                break;
            case this.btn4:
                this.setNumber1(4);
                this.updateMapInfo();
                break;
        }
    };
    /**灰色操作 */
    WorldMapView.prototype.map0Click = function (e) {
        TipsViewSystem.show("当前区域尚未解锁，请通关前置关卡");
    };
    WorldMapView.prototype.map1Click = function (e) {
        var _this = this;
        if (e.target.data.map == this.map && ExplorationView.difficulty == this.difficulty) {
            TipsViewSystem.show("已处在当前区域");
            return;
        }
        var map = e.target.data.map;
        ak.FairyGUI.open(["ChooseTipsView", 1, this.chooseTipsViewInfo, function () {
                ExplorationView.difficulty = _this.difficulty;
                ExplorationView.map = map;
                ak.log(ExplorationView.difficulty, ExplorationView.map);
                _this.close();
            }]);
    };
    /**
     * 设置难度
     */
    WorldMapView.prototype.setNumber1 = function (difficulty) {
        if (difficulty === void 0) { difficulty = -1; }
        //如果difficulty为-1，进来默认为最大难度
        if (difficulty == -1) {
            var maxbarrierID = MyData.user.barrierID;
            var difficulty0 = Math.floor(maxbarrierID / 80);
            this.difficulty = difficulty0;
        }
        else {
            this.difficulty = difficulty;
        }
    };
    /**
     * 设置地图
     */
    WorldMapView.prototype.setNumber2 = function (map) {
        if (map === void 0) { map = -1; }
        //map为-1，进来默认为最大地图
        if (map == -1) {
            var nowResBarrierID = MyData.user.barrierID;
            var nowPicId = Math.floor(((nowResBarrierID - 1) - (Math.floor((nowResBarrierID - 1) / 80) * 80)) / 10);
            this.map = nowPicId;
        }
        else {
            this.map = map;
        }
    };
    WorldMapView.prototype.updateMapInfo = function () {
        this.control_c1.selectedIndex = (this.difficulty + 1);
        for (var i = 0; i < 5; i++) {
            if (i <= WorldMapData.inst().GetMaxdifficulty()) {
                this["btn" + i].enabled = true;
            }
            else {
                this["btn" + i].enabled = false;
            }
        }
        if (this.difficulty == WorldMapData.inst().GetMaxdifficulty()) {
            for (var i = 0; i < 8; i++) {
                var map = this["map_" + i + "_1"];
                if (i <= WorldMapData.inst().GetMaxMap()) {
                    map.visible = true;
                }
                else {
                    map.visible = false;
                }
            }
            for (var j = 0; j < 8; j++) {
                var map = this["map_" + j + "_0"];
                if (j <= this.map) {
                    map.visible = false;
                }
                else {
                    map.visible = true;
                }
            }
        }
        else {
            for (var i = 0; i < 8; i++) {
                var map = this["map_" + i + "_1"];
                map.visible = true;
            }
            for (var j = 0; j < 8; j++) {
                var map = this["map_" + j + "_0"];
                map.visible = false;
            }
        }
        this.fingerHanle();
    };
    /**手指操作 */
    WorldMapView.prototype.fingerHanle = function () {
        if (this.difficulty == WorldMapData.inst().GetMaxdifficulty()) {
            if (WorldMapData.inst().GetguajidiandMap() != WorldMapData.inst().GetMaxMap()) {
                this.finger.visible = true;
                var num = WorldMapData.inst().GetMaxMap();
                var item = this["map_" + num + "_1"];
                this.finger.x = item.x + item.width / 2 - this.finger.width / 2;
                this.finger.y = item.y + item.height / 2 - this.finger.height / 2;
            }
            else {
                this.finger.visible = false;
            }
        }
    };
    return WorldMapView;
}(ak.EasyUI));
__reflect(WorldMapView.prototype, "WorldMapView");
var ChooseShenqiViewSystem = (function (_super) {
    __extends(ChooseShenqiViewSystem, _super);
    function ChooseShenqiViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    ChooseShenqiViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("RaceHelpView");
    };
    ChooseShenqiViewSystem.inst = new ChooseShenqiViewSystem("RaceHelpView");
    return ChooseShenqiViewSystem;
}(ak.FairyGUI));
__reflect(ChooseShenqiViewSystem.prototype, "ChooseShenqiViewSystem");
/**
 * 神器选择界面
 */
var ChooseShenqiView = (function (_super) {
    __extends(ChooseShenqiView, _super);
    function ChooseShenqiView(fightType) {
        var _this = _super.call(this, ChooseShenqiViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.chooseID = -1;
        _this.fightType = 0;
        _this.fightType = fightType;
        return _this;
    }
    /**回调 */
    ChooseShenqiView.prototype.onInit = function () {
        var ui = this.create("RaceHelpView", "ChooseShenqiView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.list = ui.getChild("list").asList;
        this.ClickAdd();
        this.chooseIDHandle();
        this.updateList();
    };
    ChooseShenqiView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.onFairyguiEvent(this.list, fairygui.ItemEvent.CLICK, this.itemonclick, this);
    };
    ChooseShenqiView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
        }
    };
    ChooseShenqiView.prototype.itemonclick = function (obj) {
        var item = obj.itemObject;
        if (this.hitTestPointWithFairyGUIComponent(item.getChild("usebtn").asButton, obj.stageX, obj.stageY)) {
            if (item.getChild("usebtn").asButton.visible == false)
                return;
            this.chooseID = item.data.id;
            FightReadyView.chooseID = this.chooseID;
            //
            this.saveHandle();
            this.close();
            //this.once(egret.Event.ENTER_FRAME,()=>{
            //	this.updateList();
            //},this);
        }
        if (this.hitTestPointWithFairyGUIComponent(item.getChild("unusebtn").asButton, obj.stageX, obj.stageY)) {
            if (item.getChild("unusebtn").asButton.visible == false)
                return;
            this.chooseID = -1;
            FightReadyView.chooseID = -1;
            this.saveHandle();
            this.close();
            //
            //this.once(egret.Event.ENTER_FRAME,()=>{
            //	this.updateList();
            //},this);
        }
    };
    ChooseShenqiView.prototype.updateList = function () {
        var activeCount = MyData.user.json.godWeaponSys.activeCount;
        this.list.removeChildrenToPool();
        for (var i = 0; i < 5; i++) {
            var item = this.list.addItemFromPool().asCom;
            var bg = item.getChild("bg").asLoader;
            var bg2 = item.getChild("bg2").asLoader;
            var usebtn = item.getChild("usebtn").asButton;
            var unusebtn = item.getChild("unusebtn").asButton;
            item.data = { id: i + 1 };
            if (activeCount >= i + 1) {
                this.setLoaderUrl(bg, "ui://RaceHelpView/shenbing_diban" + (i + 1));
                if (this.chooseID == i + 1) {
                    usebtn.visible = false;
                    unusebtn.visible = true;
                }
                else {
                    usebtn.visible = true;
                    unusebtn.visible = false;
                }
            }
            else {
                this.setLoaderUrl(bg, "ui://RaceHelpView/shenbing_diban_hui");
                usebtn.visible = false;
                unusebtn.visible = false;
            }
            this.setLoaderUrl(bg2, "ui://RaceHelpView/shenbing_wq_0" + (i + 1));
        }
    };
    ChooseShenqiView.prototype.chooseIDHandle = function () {
        var key2 = "";
        if (this.fightType == 1) {
            key2 = GameLocalStorage.explorationFightWeaponID;
        }
        else if (this.fightType == 2) {
            key2 = GameLocalStorage.testFightWeaponID;
        }
        else if (this.fightType == 3) {
            key2 = GameLocalStorage.towerFightWeaponID;
        }
        else if (this.fightType == 4) {
            key2 = GameLocalStorage.friendBossFightWeaponID;
        }
        else if (this.fightType == 6) {
            key2 = GameLocalStorage.friendPKFightWeaponID;
        }
        else if (this.fightType == 7) {
            key2 = GameLocalStorage.arenaChallengeRivalFightWeaponID;
        }
        else if (this.fightType == 8) {
            key2 = GameLocalStorage.guildbossFightWeaponID;
        }
        else if (this.fightType == 9) {
            key2 = GameLocalStorage.expeditionFightWeaponID;
        }
        else if (this.fightType == 5) {
            if (MyData.user.json.stage.upCardIDArr.length != 0) {
                this.chooseID = MyData.user.json.stage.upCardIDArr[6];
                return;
            }
        }
        ak.log(GameLocalStorage.load(key2));
        this.chooseID = Number(GameLocalStorage.load(key2));
    };
    ChooseShenqiView.prototype.saveHandle = function () {
        if (this.fightType == 1) {
            GameLocalStorage.save(GameLocalStorage.explorationFightWeaponID, "" + FightReadyView.chooseID);
        }
        else if (this.fightType == 2) {
            GameLocalStorage.save(GameLocalStorage.testFightWeaponID, "" + FightReadyView.chooseID);
        }
        else if (this.fightType == 3) {
            GameLocalStorage.save(GameLocalStorage.towerFightWeaponID, "" + FightReadyView.chooseID);
        }
        else if (this.fightType == 4) {
            GameLocalStorage.save(GameLocalStorage.friendBossFightWeaponID, "" + FightReadyView.chooseID);
        }
        else if (this.fightType == 6) {
            GameLocalStorage.save(GameLocalStorage.friendPKFightWeaponID, "" + FightReadyView.chooseID);
        }
        else if (this.fightType == 7) {
            GameLocalStorage.save(GameLocalStorage.arenaChallengeRivalFightWeaponID, "" + FightReadyView.chooseID);
        }
        else if (this.fightType == 8) {
            GameLocalStorage.save(GameLocalStorage.guildbossFightWeaponID, "" + FightReadyView.chooseID);
        }
    };
    return ChooseShenqiView;
}(ak.EasyUI));
__reflect(ChooseShenqiView.prototype, "ChooseShenqiView");
var FightReady2ViewSystem = (function (_super) {
    __extends(FightReady2ViewSystem, _super);
    function FightReady2ViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    FightReady2ViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("RaceHelpView");
    };
    FightReady2ViewSystem.inst = new FightReady2ViewSystem("RaceHelpView");
    return FightReady2ViewSystem;
}(ak.FairyGUI));
__reflect(FightReady2ViewSystem.prototype, "FightReady2ViewSystem");
/**
 * 英雄选择界面
 */
var FightReady2View = (function (_super) {
    __extends(FightReady2View, _super);
    /**
     * fighttype为战斗类型
     * 根据fighttype分别往本地存储不同的上阵数据
     * 1-为挂机战斗
     * 2-为每日试炼
     * 3-为爬塔战斗
     * 4-为好友boss战斗
     * 5-为竞技场防守阵容
     * 6-为和好友pk
     * 7-竞技场挑战对手
     */
    function FightReady2View(fighttype, id, num) {
        var _this = _super.call(this, RaceHelpViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.heroGroups = [];
        _this.fightGroups = [];
        _this.localStorage = [];
        _this.fightIndexGroups = [-1, -1, -1, -1, -1, -1];
        _this.fightGroupsxy = [{ x: 48, y: 796 }, { x: 138, y: 796 }, { x: 245, y: 796 }, { x: 335, y: 796 }, { x: 425, y: 796 }, { x: 515, y: 796 }];
        _this.index = 0;
        /**战斗类型 */
        _this.fighttype = 0;
        /**存进来的id */
        _this.id = 0;
        /**存进来的次数 */
        _this.num = 1;
        _this.fighttype = fighttype;
        if (id)
            _this.id = id;
        if (num)
            _this.num = num;
        return _this;
    }
    /**回调 */
    FightReady2View.prototype.onInit = function () {
        var ui = this.create("RaceHelpView", "FightReady2View");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.list = ui.getChild("list").asList;
        this.itemlist = ui.getChild("itemlist").asCom;
        this.typeCom = ui.getChild("typeCom").asCom;
        this.power = ui.getChild("power").asTextField;
        this.artifactbtn = ui.getChild("artifactbtn").asButton;
        this.fightbtn = ui.getChild("fightbtn").asButton;
        this.btn0 = this.itemlist.getChild("btn0").asButton;
        this.btn1 = this.itemlist.getChild("btn1").asButton;
        this.btn2 = this.itemlist.getChild("btn2").asButton;
        this.btn3 = this.itemlist.getChild("btn3").asButton;
        this.btn4 = this.itemlist.getChild("btn4").asButton;
        this.btn5 = this.itemlist.getChild("btn5").asButton;
        this.btn6 = this.itemlist.getChild("btn6").asButton;
        this.item0_1 = ui.getChild("item0_1").asCom;
        this.item1_1 = ui.getChild("item1_1").asCom;
        this.item2_1 = ui.getChild("item2_1").asCom;
        this.item3_1 = ui.getChild("item3_1").asCom;
        this.item4_1 = ui.getChild("item4_1").asCom;
        this.item5_1 = ui.getChild("item5_1").asCom;
        this.item6_1 = ui.getChild("item6_1").asCom;
        this.index = 0;
        this.fightGroups = [];
        this.fightIndexGroups = [-1, -1, -1, -1, -1, -1];
        this.GetLocalStorage_Group();
        this.static6itemInfo();
        this.updateInfo(0);
        this.updatezhenfaIcon();
        this.ClickAdd();
    };
    FightReady2View.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.artifactbtn, this.onClick, this);
        this.addClickListener(this.fightbtn, this.onClick, this);
        this.addClickListener(this.btn0, this.onClick, this);
        this.addClickListener(this.btn1, this.onClick, this);
        this.addClickListener(this.btn2, this.onClick, this);
        this.addClickListener(this.btn3, this.onClick, this);
        this.addClickListener(this.btn4, this.onClick, this);
        this.addClickListener(this.btn5, this.onClick, this);
        this.addClickListener(this.btn6, this.onClick, this);
        this.addClickListener(this.typeCom, this.onClick, this);
        this.onFairyguiEvent(this.list, fairygui.ItemEvent.CLICK, this.itemonclick, this);
        for (var i = 0; i < 6; i++) {
            this.onEgretEvent(this["item" + i + "_1"], egret.TouchEvent.TOUCH_TAP, this.onComClick0, this);
            this.onEgretEvent(this["item" + i + "_1"], egret.TouchEvent.TOUCH_BEGIN, this.onComClick1, this);
        }
        this.onEgretEvent(this.ui, egret.TouchEvent.TOUCH_MOVE, this.onComClick2, this);
        this.onEgretEvent(this.ui, egret.TouchEvent.TOUCH_END, this.onComClick3, this);
    };
    FightReady2View.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.artifactbtn:
                ak.FairyGUI.open(["ChooseShenqiView", 9]);
                break;
            case this.fightbtn:
                this.fighthandle();
                break;
            case this.btn0:
                this.updateInfo(0);
                break;
            case this.btn1:
                this.updateInfo(1);
                break;
            case this.btn2:
                this.updateInfo(2);
                break;
            case this.btn3:
                this.updateInfo(3);
                break;
            case this.btn4:
                this.updateInfo(4);
                break;
            case this.btn5:
                this.updateInfo(5);
                break;
            case this.btn6:
                this.updateInfo(6);
                break;
            case this.typeCom:
                ak.FairyGUI.open(["RaceHelpView"]);
                break;
        }
    };
    /**英雄点击事件 */
    FightReady2View.prototype.itemonclick = function (e) {
        var _this = this;
        if (e.itemObject.data.isChoose == true) {
            var item = (e.itemObject);
            var items = new ItemBase(item.getChild("item").asCom, this, 2);
            var bar = item.getChild("bar").asProgress;
            //bar.max = 100;
            //bar.value = 10;
            items.setGou(false);
            for (var i = 0; i < this.fightGroups.length; i++) {
                if (this.fightGroups[i].index == e.itemObject.data.index) {
                    this.fightGroups.splice(i, 1);
                    e.itemObject.data.isChoose = false;
                    var _loop_7 = function (i_5) {
                        if (this_6.fightIndexGroups[i_5] == e.itemObject.data.index) {
                            this_6.fightIndexGroups[i_5] = -1;
                            var start_x = e.itemObject.localToGlobal().x;
                            var start_y = e.itemObject.localToGlobal().y;
                            this_6["item" + i_5 + "_1"].visible = true;
                            this_6["item" + i_5 + "_1"].scaleX = 1;
                            this_6["item" + i_5 + "_1"].scaleY = 1;
                            this_6["item" + i_5 + "_1"].x = this_6.fightGroupsxy[i_5].x;
                            this_6["item" + i_5 + "_1"].y = this_6.fightGroupsxy[i_5].y;
                            this_6["item" + i_5 + "_1"].data = {};
                            this_6["item" + i_5 + "_1"].enabled = false;
                            egret.Tween.removeTweens(this_6["item" + i_5 + "_1"]);
                            egret.Tween.get(this_6["item" + i_5 + "_1"], { loop: false }).
                                to({ x: start_x, y: start_y, scaleX: 1.2, scaleY: 1.2 }, 200).call(function () {
                                _this["item" + i_5 + "_1"].visible = false;
                                _this["item" + i_5 + "_1"].enabled = true;
                                _this["item" + i_5 + "_1"].width = 100;
                                _this["item" + i_5 + "_1"].height = 100;
                                _this["item" + i_5 + "_1"].scaleX = 0.8;
                                _this["item" + i_5 + "_1"].scaleY = 0.8;
                            });
                        }
                    };
                    var this_6 = this;
                    //判断从哪个位置回去
                    for (var i_5 = 0; i_5 < this.fightIndexGroups.length; i_5++) {
                        _loop_7(i_5);
                    }
                }
            }
        }
        else {
            if (this.fightGroups.length >= 6) {
                TipsViewSystem.show("当前选择英雄已满");
            }
            else {
                var isfirst = true;
                var item = (e.itemObject);
                var items = new ItemBase(item.getChild("item").asCom, this, 2);
                var bar = item.getChild("bar").asProgress;
                //bar.max = 100;
                //bar.value = 10;
                items.setGou(true);
                e.itemObject.data.isChoose = true;
                this.fightGroups.push(e.itemObject.data);
                var _loop_8 = function (i) {
                    if (this_7.fightIndexGroups[i] == -1 && isfirst) {
                        isfirst = false;
                        this_7.fightIndexGroups[i] = e.itemObject.data.index;
                        var start_x = e.itemObject.localToGlobal().x;
                        var start_y = e.itemObject.localToGlobal().y;
                        var items2 = new ItemBase(this_7["item" + i + "_1"].getChild("item").asCom, this_7, 2);
                        var bar_1 = this_7["item" + i + "_1"].getChild("bar").asProgress;
                        //bar.max = 100;
                        //bar.value = 10;
                        if (MyData.user.json.remoteBattle.battleCardMap[e.itemObject.data.info.id] != null) {
                            bar_1.max = e.itemObject.data.info.hp;
                            bar_1.value = MyData.user.json.remoteBattle.battleCardMap[e.itemObject.data.info.id];
                        }
                        else {
                            bar_1.max = 100;
                            bar_1.value = 100;
                        }
                        items2.setItemData(e.itemObject.data.info.heroID, e.itemObject.data.info.race, e.itemObject.data.info.starMax);
                        items2.setNumber(e.itemObject.data.info.level);
                        this_7["item" + i + "_1"].visible = true;
                        this_7["item" + i + "_1"].scaleX = 1.2;
                        this_7["item" + i + "_1"].scaleY = 1.2;
                        this_7["item" + i + "_1"].x = start_x;
                        this_7["item" + i + "_1"].y = start_y;
                        this_7["item" + i + "_1"].data = { index: e.itemObject.data.index, info: e.itemObject.data.info };
                        this_7["item" + i + "_1"].enabled = false;
                        egret.Tween.removeTweens(this_7["item" + i + "_1"]);
                        egret.Tween.get(this_7["item" + i + "_1"], { loop: false }).
                            to({ x: this_7.fightGroupsxy[i].x, y: this_7.fightGroupsxy[i].y, scaleX: 0.8, scaleY: 0.8 }, 200).call(function () {
                            _this["item" + i + "_1"].enabled = true;
                            _this["item" + i + "_1"].width = 100;
                            _this["item" + i + "_1"].height = 100;
                            _this["item" + i + "_1"].scaleX = 0.8;
                            _this["item" + i + "_1"].scaleY = 0.8;
                        });
                    }
                };
                var this_7 = this;
                //判断放到哪个位置去
                for (var i = 0; i < this.fightIndexGroups.length; i++) {
                    _loop_8(i);
                }
            }
        }
        this.updatezhenfaIcon();
        this.updatePower();
    };
    /**6个英雄的事件 */
    FightReady2View.prototype.onComClick0 = function (evt) {
        var itemCom = evt.target;
        var final_x = 0;
        var final_y = 0;
        var isInFight = false;
        for (var i = 0; i < this.heroGroups.length; i++) {
            var item = this.list.getChildAt(i).asCom;
            if (item.data.index == itemCom.data.index) {
                final_x = item.localToGlobal().x;
                final_y = item.localToGlobal().y;
                isInFight = true;
                var items = new ItemBase(item.getChild("item").asCom, this, 2);
                item.data.isChoose = false;
                items.setGou(false);
            }
            else {
                if (isInFight == false) {
                    final_x = 300;
                    final_y = 350;
                }
            }
        }
        for (var j = 0; j < this.fightIndexGroups.length; j++) {
            if (this.fightIndexGroups[j] == itemCom.data.index) {
                this.fightIndexGroups[j] = -1;
            }
        }
        for (var k = 0; k < this.fightGroups.length; k++) {
            if (this.fightGroups[k].index == itemCom.data.index) {
                this.fightGroups.splice(k, 1);
            }
        }
        egret.Tween.removeTweens(itemCom);
        egret.Tween.get(itemCom, { loop: false }).
            to({ x: final_x, y: final_y, scaleX: 1.2, scaleY: 1.2 }, 200).call(function () {
            itemCom.visible = false;
            itemCom.width = 100;
            itemCom.height = 100;
            itemCom.scaleX = 0.8;
            itemCom.scaleY = 0.8;
        });
        this.updatezhenfaIcon();
        this.updatePower();
    };
    FightReady2View.prototype.onComClick1 = function (evt) {
        this.touchCom = evt.target;
        if (!this.isIn6place(this.touchCom))
            return;
        this.item6_1.x = evt.target.x;
        this.item6_1.y = evt.target.y;
        this.item6_1.visible = false;
        var items2 = new ItemBase(this.item6_1.getChild("item").asCom, this, 2);
        var bar = this.item6_1.getChild("bar").asProgress;
        //bar.max = 100;
        //bar.value = 10;
        if (MyData.user.json.remoteBattle.battleCardMap[evt.target.data.info.id] != null) {
            bar.max = evt.target.data.info.hp;
            bar.value = MyData.user.json.remoteBattle.battleCardMap[evt.target.data.info.id];
        }
        else {
            bar.max = 100;
            bar.value = 100;
        }
        items2.setItemData(evt.target.data.info.heroID, evt.target.data.info.race, evt.target.data.info.starMax);
        items2.setNumber(evt.target.data.info.level);
        this.item6_1.data = evt.target.data;
    };
    FightReady2View.prototype.onComClick2 = function (evt) {
        if (!(this.touchCom && this.touchCom.enabled == true))
            return;
        if (!this.isIn6place(this.touchCom))
            return;
        if (this.item6_1.data == null)
            return;
        if (this.touchCom && this.touchCom.enabled == true)
            this.touchCom.visible = false;
        this.item6_1.visible = true;
        this.item6_1.x = evt.stageX - 40;
        this.item6_1.y = evt.stageY - 40;
    };
    FightReady2View.prototype.onComClick3 = function (evt) {
        if (!(this.touchCom && this.touchCom.enabled == true))
            return;
        if (this.item6_1.data == null)
            return;
        var itemCom = this.touchCom;
        if (this.testItemxy(this.item6_1.x, this.item6_1.y) == -1) {
            this.item6_1.visible = false;
            this.item6_1.data = null;
            if (this.touchCom)
                this.touchCom.visible = true;
        }
        else {
            var Groupindex = -1;
            for (var i = 0; i < this.fightIndexGroups.length; i++) {
                if (itemCom.data.index == this.fightIndexGroups[i]) {
                    Groupindex = i;
                }
            }
            this.ishaveItem(Groupindex, this.testItemxy(this.item6_1.x, this.item6_1.y));
            this.item6_1.visible = false;
            this.item6_1.data = null;
        }
        this.updatezhenfaIcon();
    };
    /**判断该组件是否在6个位置上面 */
    FightReady2View.prototype.isIn6place = function (com) {
        for (var i = 0; i < this.fightGroupsxy.length; i++) {
            if (com.x == this.fightGroupsxy[i].x && com.y == this.fightGroupsxy[i].y) {
                return true;
            }
        }
        return false;
    };
    /**
     * 测试该物品拖动时是否在拖到其他地方上面
     * 1:如果在，判断该位置是否已经有卡牌，
     * （1）如果有，则两张卡牌交替位置（2）如果没有，则直接放入
     * 2:如果不在，直接回到原来的位置
     */
    FightReady2View.prototype.testItemxy = function (x, y) {
        var item0_place = { x: 48, y: 796 };
        var item1_place = { x: 138, y: 796 };
        var item2_place = { x: 245, y: 796 };
        var item3_place = { x: 335, y: 796 };
        var item4_place = { x: 425, y: 796 };
        var item5_place = { x: 515, y: 796 };
        var itemplaceGroup = [item0_place, item1_place, item2_place, item3_place, item4_place, item5_place];
        for (var i = 0; i < 6; i++) {
            if (Math.abs(x - itemplaceGroup[i].x) < 80 / 2 + 80 / 2 && Math.abs(y - itemplaceGroup[i].y) < 80 / 2 + 80 / 2) {
                return i;
            }
        }
        return -1;
    };
    FightReady2View.prototype.ishaveItem = function (starindex, finalindex) {
        if (this.fightIndexGroups[finalindex] == -1) {
            this.fightIndexGroups[finalindex] = this.fightIndexGroups[starindex];
            var items2 = new ItemBase(this["item" + finalindex + "_1"].getChild("item").asCom, this, 2);
            var bar = this["item" + finalindex + "_1"].getChild("bar").asProgress;
            //bar.max = 100;
            //bar.value = 10;
            if (MyData.user.json.remoteBattle.battleCardMap[this["item" + starindex + "_1"].data.info.id] != null) {
                bar.max = this["item" + starindex + "_1"].data.info.hp;
                bar.value = MyData.user.json.remoteBattle.battleCardMap[this["item" + starindex + "_1"].data.info.id];
            }
            else {
                bar.max = 100;
                bar.value = 100;
            }
            items2.setItemData(this["item" + starindex + "_1"].data.info.heroID, this["item" + starindex + "_1"].data.info.race, this["item" + starindex + "_1"].data.info.starMax);
            items2.setNumber(this["item" + starindex + "_1"].data.info.level);
            this["item" + finalindex + "_1"].visible = true;
            this["item" + finalindex + "_1"].data = this["item" + starindex + "_1"].data;
            this["item" + starindex + "_1"].data = {};
            this["item" + starindex + "_1"].visible = false;
            this["item" + starindex + "_1"].x = this.fightGroupsxy[starindex].x;
            this["item" + starindex + "_1"].y = this.fightGroupsxy[starindex].y;
            this["item" + finalindex + "_1"].x = this.fightGroupsxy[finalindex].x;
            this["item" + finalindex + "_1"].y = this.fightGroupsxy[finalindex].y;
            this.fightIndexGroups[starindex] = -1;
        }
        else {
            var star = this.fightIndexGroups[starindex];
            this.fightIndexGroups[starindex] = this.fightIndexGroups[finalindex];
            this.fightIndexGroups[finalindex] = star;
            var data = this["item" + starindex + "_1"].data;
            this["item" + starindex + "_1"].data = this["item" + finalindex + "_1"].data;
            this["item" + finalindex + "_1"].data = data;
            var items2 = new ItemBase(this["item" + finalindex + "_1"].getChild("item").asCom, this, 2);
            var bar = this["item" + finalindex + "_1"].getChild("bar").asProgress;
            //bar.max = 100;
            //bar.value = 10;
            if (MyData.user.json.remoteBattle.battleCardMap[this["item" + finalindex + "_1"].data.info.id] != null) {
                bar.max = this["item" + finalindex + "_1"].data.info.hp;
                bar.value = MyData.user.json.remoteBattle.battleCardMap[this["item" + finalindex + "_1"].data.info.id];
            }
            else {
                bar.max = 100;
                bar.value = 100;
            }
            items2.setItemData(this["item" + finalindex + "_1"].data.info.heroID, this["item" + finalindex + "_1"].data.info.race, this["item" + finalindex + "_1"].data.info.starMax);
            items2.setNumber(this["item" + finalindex + "_1"].data.info.level);
            var items3 = new ItemBase(this["item" + starindex + "_1"].getChild("item").asCom, this, 2);
            var bar2 = this["item" + starindex + "_1"].getChild("bar").asProgress;
            //bar2.max = 100;
            //bar2.value = 10;
            if (MyData.user.json.remoteBattle.battleCardMap[this["item" + starindex + "_1"].data.info.id] != null) {
                bar2.max = this["item" + starindex + "_1"].data.info.hp;
                bar2.value = MyData.user.json.remoteBattle.battleCardMap[this["item" + starindex + "_1"].data.info.id];
            }
            else {
                bar2.max = 100;
                bar2.value = 100;
            }
            items3.setItemData(this["item" + starindex + "_1"].data.info.heroID, this["item" + starindex + "_1"].data.info.race, this["item" + starindex + "_1"].data.info.starMax);
            items3.setNumber(this["item" + starindex + "_1"].data.info.level);
            //数据更新
            this["item" + starindex + "_1"].x = this.fightGroupsxy[starindex].x;
            this["item" + starindex + "_1"].y = this.fightGroupsxy[starindex].y;
            this["item" + finalindex + "_1"].x = this.fightGroupsxy[finalindex].x;
            this["item" + finalindex + "_1"].y = this.fightGroupsxy[finalindex].y;
            this["item" + starindex + "_1"].visible = true;
            this["item" + finalindex + "_1"].visible = true;
        }
        this.updatePower();
    };
    FightReady2View.prototype.updateInfo = function (index) {
        this.index = index;
        this.setHeroGroupInfo();
        this.updateList();
    };
    /**
     * 设置英雄数据
     * 根据index来设置不同英雄的数据
     */
    FightReady2View.prototype.setHeroGroupInfo = function () {
        this.heroGroups = [];
        //改数组
        this.heroGroups = HeroBagData.inst().GetHeroGroupInfoByIndex2(this.index, 0);
    };
    FightReady2View.prototype.updateList = function () {
        this.list.removeChildrenToPool();
        for (var i = 0; i < this.heroGroups.length; i++) {
            var item = this.list.addItemFromPool().asCom;
            var items = new ItemBase(item.getChild("item").asCom, this, 2);
            var bar = item.getChild("bar").asProgress;
            if (MyData.user.json.remoteBattle.battleCardMap[this.heroGroups[i][1].id] != null) {
                bar.max = this.heroGroups[i][1].hp;
                bar.value = MyData.user.json.remoteBattle.battleCardMap[this.heroGroups[i][1].id];
                //判读是否为0
                if (bar.value == 0) {
                    items.setDark(true);
                    item.touchable = false;
                }
                else {
                    items.setDark(false);
                    item.touchable = true;
                }
            }
            else {
                bar.max = 100;
                bar.value = 100;
            }
            items.setItemData(this.heroGroups[i][1].heroID, this.heroGroups[i][1].race, this.heroGroups[i][1].starMax);
            items.setNumber(this.heroGroups[i][1].level);
            var isInFight = false;
            for (var j = 0; j < this.fightGroups.length; j++) {
                if (this.fightGroups[j].index == this.heroGroups[i][0]) {
                    items.setGou(true);
                    isInFight = true;
                    item.data = { index: this.heroGroups[i][0], info: this.heroGroups[i][1], isChoose: true };
                }
                else {
                    if (isInFight == false) {
                        items.setGou(false);
                        item.data = { index: this.heroGroups[i][0], info: this.heroGroups[i][1], isChoose: false };
                    }
                }
            }
            if (this.fightGroups.length == 0) {
                item.data = { index: this.heroGroups[i][0], info: this.heroGroups[i][1], isChoose: false };
            }
        }
    };
    FightReady2View.prototype.updatezhenfaIcon = function () {
        var icon = this.typeCom.getChild("icon").asLoader;
        var txt = this.typeCom.getChild("txt").asTextField;
        var fightIDGroup = [];
        for (var i = 0; i < this.fightGroups.length; i++) {
            fightIDGroup.push(this.fightGroups[i].info.heroID);
        }
        var id = FightData.inst().Getzhenfa(fightIDGroup);
        if (id == 0) {
            txt.visible = true;
        }
        else {
            txt.visible = false;
        }
        this.setLoaderUrl(icon, "ui://RaceHelpView/" + FightData.inst().GetzhenfaImg(id));
    };
    FightReady2View.prototype.fighthandle = function () {
        var _this = this;
        ak.log(this.fighttype);
        var nowfightIndexGroups = [];
        for (var i = 0; i < this.fightIndexGroups.length; i++) {
            nowfightIndexGroups.push(this.fightIndexGroups[i]);
        }
        if (FightReadyView.chooseID != -1) {
            nowfightIndexGroups.push(FightReadyView.chooseID);
        }
        if (this.fighttype == 1) {
            net.findEnemyBattle(nowfightIndexGroups, function (report, dropMapT, dropMap) {
                _this.close();
                _this.localStorage_Group();
                ak.EventMgr.dispatch(GameEvent.fightRpcComplete);
                ak.FairyGUI.open(["FightView", report, dropMap, 3, dropMapT]);
            }, this);
        }
    };
    /**存储本地数据 */
    FightReady2View.prototype.localStorage_Group = function () {
        this.localStorage = [];
        for (var i = 0; i < this.fightIndexGroups.length; i++) {
            var isfirst = true;
            for (var j = 0; j < this.fightGroups.length; j++) {
                if (this.fightIndexGroups[i] == this.fightGroups[j].index) {
                    if (isfirst)
                        this.localStorage.push(this.fightGroups[j].info.id);
                    isfirst = false;
                }
            }
            if (isfirst)
                this.localStorage.push(-1);
        }
        if (this.fighttype == 1) {
            GameLocalStorage.save(GameLocalStorage.expeditionFightGroup, this.localStorage.join(','));
            GameLocalStorage.save(GameLocalStorage.expeditionFightWeaponID, "" + FightReadyView.chooseID);
        }
    };
    /**获得本地存储 */
    FightReady2View.prototype.GetLocalStorage_Group = function () {
        var fightGroup = [];
        var key = "";
        var key2 = "";
        if (this.fighttype == 1) {
            key = GameLocalStorage.expeditionFightGroup;
            key2 = GameLocalStorage.expeditionFightWeaponID;
        }
        FightReadyView.chooseID = Number(GameLocalStorage.load(key2));
        var str = GameLocalStorage.load(key);
        if (str != "" && str != null) {
            fightGroup = str.split(',');
            this.fightGroups = [];
            this.fightIndexGroups = [];
        }
        for (var i = 0; i < fightGroup.length; i++) {
            var index = HeroBagData.inst().GetIndexByid(fightGroup[i]);
            var ispush = true;
            //判断血量（如果少于0，不能上阵）
            if (index != -1) {
                var info = HeroBagData.inst().GetcardByIndex(index)[1];
                if (MyData.user.json.remoteBattle.battleCardMap[info.id] != null) {
                    if (MyData.user.json.remoteBattle.battleCardMap[info.id] == 0) {
                        ispush = false;
                    }
                    else {
                        this.fightGroups.push({ index: index, info: info, isChoose: true });
                    }
                }
                else {
                    this.fightGroups.push({ index: index, info: info, isChoose: true });
                }
            }
            if (ispush) {
                this.fightIndexGroups.push(index);
            }
            else {
                this.fightIndexGroups.push(-1);
            }
        }
        this.updatePower();
    };
    FightReady2View.prototype.static6itemInfo = function () {
        for (var i = 0; i < this.fightIndexGroups.length; i++) {
            if (this.fightIndexGroups[i] != -1) {
                var info = {};
                for (var j = 0; j < this.fightGroups.length; j++) {
                    if (this.fightIndexGroups[i] == this.fightGroups[j].index) {
                        info = this.fightGroups[j].info;
                    }
                }
                var items2 = new ItemBase(this["item" + i + "_1"].getChild("item").asCom, this, 2);
                var bar = this["item" + i + "_1"].getChild("bar").asProgress;
                if (MyData.user.json.remoteBattle.battleCardMap[info.id] != null) {
                    bar.max = info.hp;
                    bar.value = MyData.user.json.remoteBattle.battleCardMap[info.id];
                }
                else {
                    bar.max = 100;
                    bar.value = 100;
                }
                items2.setItemData(info.heroID, info.race, info.starMax);
                items2.setNumber(info.level);
                this["item" + i + "_1"].visible = true;
                this["item" + i + "_1"].data = { index: this.fightIndexGroups[i], info: info };
            }
            else {
                this["item" + i + "_1"].visible = false;
            }
        }
    };
    /**更新战斗力 */
    FightReady2View.prototype.updatePower = function () {
        var allpower = 0;
        for (var i = 0; i < this.fightIndexGroups.length; i++) {
            if (this.fightIndexGroups[i] != -1) {
                allpower += Formula.getCardIndexPower(this.fightIndexGroups[i]);
            }
        }
        this.power.text = "" + allpower;
    };
    /**交换位置
     * (新手引导添加)
     */
    FightReady2View.prototype.changeIndex = function (star, finaly) {
        if (this.fightIndexGroups[star] == -1 || this.fightIndexGroups[finaly] == -1) {
            return;
        }
        else {
            this.ishaveItem(star, finaly);
        }
    };
    return FightReady2View;
}(ak.EasyUI));
__reflect(FightReady2View.prototype, "FightReady2View");
var FightReadyData = (function () {
    function FightReadyData() {
    }
    return FightReadyData;
}());
__reflect(FightReadyData.prototype, "FightReadyData");
var LoadingUI = (function (_super) {
    __extends(LoadingUI, _super);
    function LoadingUI() {
        var _this = _super.call(this) || this;
        _this.textField = new egret.TextField();
        _this.createView();
        return _this;
    }
    LoadingUI.prototype.createView = function () {
        this.addChild(this.textField);
        // this.textField.text="connecting to the server,please wait...";
        this.textField.y = 1136 / 2 - 10;
        this.textField.width = 640;
        this.textField.height = 50;
        this.textField.textAlign = "center";
    };
    LoadingUI.prototype.onProgress = function (current, total) {
        //this.textField.text = `Loading...${current}/${total}`;
    };
    return LoadingUI;
}(egret.Sprite));
__reflect(LoadingUI.prototype, "LoadingUI", ["RES.PromiseTaskReporter"]);
var BonusViewSystem = (function (_super) {
    __extends(BonusViewSystem, _super);
    function BonusViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    BonusViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("FightView");
    };
    BonusViewSystem.inst = new BonusViewSystem("FightView");
    return BonusViewSystem;
}(ak.FairyGUI));
__reflect(BonusViewSystem.prototype, "BonusViewSystem");
/**
 * 选择提示框
 */
var BonusView = (function (_super) {
    __extends(BonusView, _super);
    function BonusView(info) {
        var _this = _super.call(this, BonusViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.index = 0;
        _this.info = {};
        _this.info = info;
        return _this;
    }
    /**回调 */
    BonusView.prototype.onInit = function () {
        var ui = this.create("FightView", "BonusView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.item0 = ui.getChild("item0").asCom;
        this.item1 = ui.getChild("item1").asCom;
        this.item2 = ui.getChild("item2").asCom;
        this.gift0 = ui.getChild("gift0").asCom;
        this.gift1 = ui.getChild("gift1").asCom;
        this.gift2 = ui.getChild("gift2").asCom;
        this.ClickAdd();
        this.staticView();
    };
    BonusView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onclick, this);
        this.addClickListener(this.item0, this.onclick, this);
        this.addClickListener(this.item1, this.onclick, this);
        this.addClickListener(this.item2, this.onclick, this);
        this.addClickListener(this.gift0, this.onclick, this);
        this.addClickListener(this.gift1, this.onclick, this);
        this.addClickListener(this.gift2, this.onclick, this);
    };
    BonusView.prototype.onclick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.gift0:
                this.index = 0;
                this.giftTouchHandle();
                break;
            case this.gift1:
                this.index = 1;
                this.giftTouchHandle();
                break;
            case this.gift2:
                this.index = 2;
                this.giftTouchHandle();
                break;
        }
    };
    BonusView.prototype.giftTouchHandle = function () {
        var _this = this;
        this["gift" + this.index].visible = false;
        this["item" + this.index].visible = true;
        //给3个物品框添加数据
        for (var j = 0; j < 3; j++) {
            var droupInfo = {};
            var item = this["item" + j];
            if (j == this.index) {
                droupInfo = this.info.dropMap;
                var type = Number(Object.keys(droupInfo)[0]);
                var id = Number(Object.keys(droupInfo[String(type)])[0]);
                var num = droupInfo[String(type)][String(id)];
                var items = new ItemBase(item, this, type);
                items.setItemData(id);
                items.setNumber(num, true);
                items.setDark(false);
            }
            else {
                droupInfo = FightData.inst().getRandomDroup(this.info.drop);
                var items = new ItemBase(item, this, Number(droupInfo[1]));
                items.setItemData(droupInfo[2]);
                items.setNumber(droupInfo[3], true);
                items.setDark(true);
            }
        }
        var timeOut = setTimeout(function () {
            clearTimeout(timeOut);
            for (var i = 0; i < 3; i++) {
                if (i != _this.index) {
                    _this["gift" + i].visible = false;
                    _this["item" + i].visible = true;
                }
            }
            _this.bgclose.enabled = true;
        }, 300);
    };
    BonusView.prototype.staticView = function () {
        this.item0.visible = false;
        this.item1.visible = false;
        this.item2.visible = false;
        this.gift0.visible = true;
        this.gift1.visible = true;
        this.gift2.visible = true;
        this.bgclose.enabled = false;
    };
    return BonusView;
}(ak.EasyUI));
__reflect(BonusView.prototype, "BonusView");
var DamageCountViewSystem = (function (_super) {
    __extends(DamageCountViewSystem, _super);
    function DamageCountViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    DamageCountViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("FightView");
    };
    DamageCountViewSystem.inst = new DamageCountViewSystem("FightView");
    return DamageCountViewSystem;
}(ak.FairyGUI));
__reflect(DamageCountViewSystem.prototype, "DamageCountViewSystem");
/**
 * 输出治疗统计界面
 */
var DamageCountView = (function (_super) {
    __extends(DamageCountView, _super);
    function DamageCountView(report) {
        var _this = _super.call(this, DamageCountViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.report = {};
        _this.nowinfo1 = {};
        _this.nowinfo2 = {};
        _this.type = 0;
        _this.report = report;
        return _this;
    }
    /**回调 */
    DamageCountView.prototype.onInit = function () {
        var ui = this.create("FightView", "DamageCountView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.list1 = ui.getChild("list1").asList;
        this.list2 = ui.getChild("list2").asList;
        this.btn1 = ui.getChild("btn1").asButton;
        this.btn2 = ui.getChild("btn2").asButton;
        this.ClickAdd();
        this.updateListInfo();
    };
    DamageCountView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onclick, this);
        this.addClickListener(this.btn1, this.onclick, this);
        this.addClickListener(this.btn2, this.onclick, this);
    };
    DamageCountView.prototype.onclick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.btn1:
                this.type = 0;
                this.updateListInfo();
                break;
            case this.btn2:
                this.type = 1;
                this.updateListInfo();
                break;
        }
    };
    DamageCountView.prototype.updateListInfo = function () {
        if (this.type == 0) {
            this.nowinfo1 = this.report.hurtMap1;
            this.nowinfo2 = this.report.hurtMap2;
        }
        else {
            this.nowinfo1 = this.report.addHPMap1;
            this.nowinfo2 = this.report.addHPMap2;
        }
        this.updateList();
    };
    DamageCountView.prototype.updateList = function () {
        this.list1.removeChildrenToPool();
        var roleArr1 = [];
        for (var x = 0; x < this.report.roleArr1.length; x++) {
            if (x < 6) {
                roleArr1.push(this.report.roleArr1[x]);
            }
        }
        for (var i = 0; i < roleArr1.length; i++) {
            var com = this.list1.addItemFromPool().asCom;
            var item = com.getChild("item").asCom;
            var num = com.getChild("num").asTextField;
            var bar = com.getChild("bar").asProgress;
            var items = new ItemBase(item, this, 2);
            items.setItemData(roleArr1[i].heroID, roleArr1[i].race, HeroBagData.inst().GetStarById(roleArr1[i].heroID));
            items.setNumber(roleArr1[i].level, true);
            var value = ak.idMapGetCount(this.nowinfo1, i);
            bar.max = this.getMapMax(this.nowinfo1);
            bar.value = value;
            num.text = "" + value;
            bar.getChild("title").asTextField.visible = false;
        }
        this.list2.removeChildrenToPool();
        var roleArr2 = [];
        for (var s = 0; s < this.report.roleArr2.length; s++) {
            if (s < 6) {
                roleArr2.push(this.report.roleArr2[s]);
            }
        }
        for (var j = 0; j < roleArr2.length; j++) {
            var com = this.list2.addItemFromPool().asCom;
            var item = com.getChild("item").asCom;
            var num = com.getChild("num").asTextField;
            var bar = com.getChild("bar").asProgress;
            var items = new ItemBase(item, this, 2);
            items.setItemData(roleArr2[j].heroID, roleArr2[j].race, HeroBagData.inst().GetStarById(roleArr2[j].heroID));
            items.setNumber(roleArr2[j].level, true);
            var value = ak.idMapGetCount(this.nowinfo2, j);
            bar.max = this.getMapMax(this.nowinfo2);
            bar.value = value;
            num.text = "" + value;
            bar.getChild("title").asTextField.visible = false;
        }
    };
    /**
     * 返回map里面的最大值
     */
    DamageCountView.prototype.getMapMax = function (map) {
        var max = 0;
        for (var i in map) {
            if (map[i] > max) {
                max = map[i];
            }
        }
        return max;
    };
    return DamageCountView;
}(ak.EasyUI));
__reflect(DamageCountView.prototype, "DamageCountView");
var FailViewSystem = (function (_super) {
    __extends(FailViewSystem, _super);
    function FailViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    FailViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("FightView");
    };
    FailViewSystem.inst = new FailViewSystem("FightView");
    return FailViewSystem;
}(ak.FairyGUI));
__reflect(FailViewSystem.prototype, "FailViewSystem");
/**
 * 失败界面
 */
var FailView = (function (_super) {
    __extends(FailView, _super);
    function FailView(report, dropMap, type, info) {
        var _this = _super.call(this, FailViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.itemattr = [];
        _this.heroattr = [];
        _this.resourceattr = [];
        _this.type = 0;
        _this.info = {};
        _this.report = report;
        _this.dropMap = dropMap;
        if (type)
            _this.type = type;
        if (info)
            _this.info = info;
        return _this;
    }
    /**回调 */
    FailView.prototype.onInit = function () {
        var ui = this.create("FightView", "FailView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.gobtn = ui.getChild("gobtn").asButton;
        this.scorenum = ui.getChild("scorenum").asTextField;
        this.hurtnum = ui.getChild("hurtnum").asTextField;
        this.name0 = ui.getChild("name0").asTextField;
        this.name1 = ui.getChild("name1").asTextField;
        this.head0 = ui.getChild("head0").asCom;
        this.head1 = ui.getChild("head1").asCom;
        this.jifen0 = ui.getChild("jifen0").asTextField;
        this.jifen1 = ui.getChild("jifen1").asTextField;
        this.list = ui.getChild("list").asList;
        this.control_c1 = ui.getController("c1");
        this.tipsbtn = ui.getChild("tipsbtn").asButton;
        this.qizi1 = ui.getChild("qizi1").asGraph;
        this.qizi2 = ui.getChild("qizi2").asGraph;
        this.ClickAdd();
        this.newStaticView();
        this.playMusic();
        this.mcHandle();
    };
    FailView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onclick, this);
        this.addClickListener(this.gobtn, this.onclick, this);
        this.addClickListener(this.tipsbtn, this.onclick, this);
        this.onFairyguiEvent(this.list, fairygui.ItemEvent.CLICK, this.itemonclick, this);
    };
    FailView.prototype.onclick = function (e) {
        switch (e.target) {
            case this.bgclose:
                ak.EventMgr.dispatch(GameEvent.fightCloseUI);
                this.close();
                break;
            case this.gobtn:
                ak.EventMgr.dispatch(GameEvent.fightCloseUI);
                this.close();
                ak.FairyGUI.open(["GrowupView"]);
                break;
            case this.tipsbtn:
                ak.FairyGUI.open(["DamageCountView", this.report]);
                break;
        }
    };
    FailView.prototype.newStaticView = function () {
        var _this = this;
        this.bgclose.enabled = true;
        if (this.type == 0) {
            this.control_c1.selectedIndex = 0;
        }
        else if (this.type == 1) {
            this.control_c1.selectedIndex = 1;
            this.bgclose.enabled = false;
            this.scorenum.text = "" + Math.floor(Number(this.info.consumeHp));
            this.hurtnum.text = "" + Math.floor(Number(this.info.jifen));
            var drop = FriendData.inst().getDropGroupID(this.type);
            var info_3 = { dropMap: this.dropMap, drop: drop };
            var timeOut_1 = setTimeout(function () {
                clearTimeout(timeOut_1);
                _this.bgclose.enabled = true;
                ak.FairyGUI.open(["BonusView", info_3]);
            }, 500);
        }
        else if (this.type == 2) {
            this.control_c1.selectedIndex = 2;
            this.name0.text = "" + this.info.team1_nickname;
            this.name1.text = "" + this.info.team2_nickname;
            this.bgclose.enabled = false;
            var item0 = new ItemBase(this.head0, this, 2);
            item0.setIcons2("hero" + this.info.team1_head);
            item0.setNumber(this.info.team1_level, true);
            var item1 = new ItemBase(this.head1, this, 2);
            item1.setIcons2("hero" + this.info.team2_head);
            item1.setNumber(this.info.team2_level, true);
            this.jifen0.text = "" + this.info.team1_jifen;
            this.jifen1.text = "" + this.info.team2_jifen;
            var drop = FriendData.inst().getDropGroupID(this.type);
            var info_4 = { dropMap: this.dropMap, drop: drop };
            var timeOut_2 = setTimeout(function () {
                clearTimeout(timeOut_2);
                _this.bgclose.enabled = true;
                ak.FairyGUI.open(["BonusView", info_4]);
            }, 500);
        }
        else if (this.type == 3) {
            this.control_c1.selectedIndex = 0;
        }
        else if (this.type == 4) {
            this.control_c1.selectedIndex = 0;
            this.updateData();
            this.updatelistInfo();
        }
    };
    FailView.prototype.updateData = function () {
        if (this.dropMap.constructor == Array) {
            for (var i = 0; i < this.dropMap.length; i++) {
                if (Number(this.dropMap[i].type) == 1) {
                    this.itemattr.push({ id: this.dropMap[i].id, num: this.dropMap[i].num });
                }
                if (Number(this.dropMap[i].type) == 2) {
                    this.heroattr.push({ id: this.dropMap[i].id, num: this.dropMap[i].num });
                }
                if (Number(this.dropMap[i].type) == 3) {
                    this.resourceattr.push({ id: this.dropMap[i].id, num: this.dropMap[i].num });
                }
            }
            return;
        }
        for (var i in this.dropMap) {
            for (var k in this.dropMap[i]) {
                if (Number(i) == 1) {
                    this.itemattr.push({ id: k, num: this.dropMap[i][k] });
                }
                if (Number(i) == 2) {
                    this.heroattr.push({ id: k, num: this.dropMap[i][k] });
                }
                if (Number(i) == 3) {
                    this.resourceattr.push({ id: k, num: this.dropMap[i][k] });
                }
            }
        }
    };
    FailView.prototype.updatelistInfo = function () {
        this.list.removeChildrenToPool();
        for (var i = 0; i < this.heroattr.length; i++) {
            for (var j = 0; j < this.heroattr[i].num; j++) {
                var item = this.list.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
                var items = new ItemBase(item, this, 2);
                item.data = { itemID: this.heroattr[i].id, num: 0, type: 2 };
                items.setItemData(this.heroattr[i].id, HeroBagData.inst().GetRaceById(this.heroattr[i].id), HeroBagData.inst().GetStarById(this.heroattr[i].id));
            }
        }
        for (var i = 0; i < this.itemattr.length; i++) {
            var item = this.list.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
            var items = new ItemBase(item, this, 1);
            items.setItemData(this.itemattr[i].id);
            items.setNumber(this.itemattr[i].num, true);
            item.data = { itemID: this.itemattr[i].id, num: this.itemattr[i].num, type: 1 };
            if (BagData.inst().GetBagtypeById(this.itemattr[i].id) == 3) {
                var race = BagData.inst().isOnlyRacePiece(this.itemattr[i].id);
                items.setType(race);
            }
            else {
                items.setType(0);
            }
            if (BagData.inst().GetBagtypeById(this.itemattr[i].id) != 2) {
                items.setStar2(BagData.inst().GetStarById(this.itemattr[i].id));
            }
        }
        for (var i = 0; i < this.resourceattr.length; i++) {
            var item = this.list.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
            var items = new ItemBase(item, this, 3);
            items.setItemData(this.resourceattr[i].id);
            items.setNumber(this.resourceattr[i].num, true);
            item.data = { itemID: this.resourceattr[i].id, num: this.resourceattr[i].num, type: 3 };
        }
    };
    FailView.prototype.itemonclick = function (e) {
        if (e.itemObject.data.type != 3) {
            var bagtype = ak.JsonTableMgr.get("item").getRowFromColName("id", "" + e.itemObject.data.itemID).getValFromColName("bagtype");
            ak.FairyGUI.open(["WeaponTipsView", e.itemObject.data.itemID, e.itemObject.data.num, bagtype - 1, 0, true]);
        }
        else {
            ak.FairyGUI.open(["ResourceTipsView", e.itemObject.data.itemID, e.itemObject.data.num]);
        }
    };
    //播放音乐
    FailView.prototype.playMusic = function () {
        ak.SoundMgr.inst.playSound("resource/sound/battlelose.mp3");
    };
    //mc
    FailView.prototype.mcHandle = function () {
        var qizi11mc = new ak.MovieClip("shibaiqizi_json", "shibaiqizi_png", "shibaiqizi");
        qizi11mc.scaleX = -1;
        qizi11mc.frameRate = 8;
        this.qizi1.setNativeObject(qizi11mc);
        var qizi12mc = new ak.MovieClip("shibaiqizi_json", "shibaiqizi_png", "shibaiqizi");
        qizi12mc.frameRate = 8;
        this.qizi2.setNativeObject(qizi12mc);
    };
    return FailView;
}(ak.EasyUI));
__reflect(FailView.prototype, "FailView");
/**
 * 战斗数据
 */
var FightData = (function () {
    function FightData() {
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    FightData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new FightData();
        }
        return Class._instance;
    };
    /**判断是哪个阵法 */
    FightData.prototype.Getzhenfa = function (heroGroup) {
        if (heroGroup.length < 6)
            return 0;
        var heroRaceinfo = {};
        for (var j = 0; j < heroGroup.length; j++) {
            var race = HeroBagData.inst().GetRaceById(heroGroup[j]);
            if (heroRaceinfo[race]) {
                heroRaceinfo[race] += 1;
            }
            else {
                heroRaceinfo[race] = 1;
            }
        }
        var lineupTab = ak.JsonTableMgr.get("lineup");
        for (var i = 0; i < lineupTab.size(); i++) {
            var lineupInfo = lineupTab.getRowFromColName("id", "" + (i + 1));
            var raceinfo = {};
            var imgGroups = [];
            var race1 = Number(lineupInfo.getValFromColName("race1"));
            var race2 = Number(lineupInfo.getValFromColName("race2"));
            var race3 = Number(lineupInfo.getValFromColName("race3"));
            var race4 = Number(lineupInfo.getValFromColName("race4"));
            var race5 = Number(lineupInfo.getValFromColName("race5"));
            var race6 = Number(lineupInfo.getValFromColName("race6"));
            var raceGroup = [race1, race2, race3, race4, race5, race6];
            for (var i_6 = 0; i_6 < raceGroup.length; i_6++) {
                for (var j = 0; j < raceGroup[i_6]; j++) {
                    imgGroups.push(i_6 + 1);
                }
            }
            for (var s = 0; s < imgGroups.length; s++) {
                if (raceinfo[imgGroups[s]]) {
                    raceinfo[imgGroups[s]] += 1;
                }
                else {
                    raceinfo[imgGroups[s]] = 1;
                }
            }
            if (this.isEqual(heroRaceinfo, raceinfo))
                return i + 1;
        }
        return 0;
    };
    FightData.prototype.isEqual = function (obj1, obj2) {
        if (Object.keys(obj1).length === Object.keys(obj2).length) {
            for (var k in obj1) {
                if (obj1[k] != obj2[k]) {
                    return false;
                }
            }
            return true;
        }
        return false;
    };
    /**根据id返回图片 */
    FightData.prototype.GetzhenfaImg = function (id) {
        if (id == 0)
            return "zhenfa_0";
        var lineupTab = ak.JsonTableMgr.get("lineup");
        var lineupInfo = lineupTab.getRowFromColName("id", "" + id);
        var img = lineupInfo.getValFromColName("icon");
        return img;
    };
    /**随机一个掉落返回 */
    FightData.prototype.getRandomDroup = function (dropID) {
        var dropGroup = ItemMgr.getDropGroupByID(dropID);
        var num = dropGroup.length - 1;
        var randomNum = Math.floor(Math.random() * num);
        return dropGroup[randomNum];
    };
    return FightData;
}());
__reflect(FightData.prototype, "FightData");
var FightViewSystem = (function (_super) {
    __extends(FightViewSystem, _super);
    function FightViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    FightViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("FightView");
    };
    FightViewSystem.inst = new FightViewSystem("FightView");
    return FightViewSystem;
}(ak.FairyGUI));
__reflect(FightViewSystem.prototype, "FightViewSystem");
/**
 * 战斗界面
 */
var FightView = (function (_super) {
    __extends(FightView, _super);
    /**
     * report:战报
     * dropMap：掉落组
     * type：类型（0-挂机(或者)，1-好友boss，2-竞技场,3-远征,4-公会boss,5-每日试炼）
     * info:特殊数据
     */
    function FightView(report, dropMap, type, info) {
        var _this = _super.call(this, FightViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.type = 0;
        _this.info = {};
        _this.report = report;
        _this.dropMap = dropMap;
        if (type) {
            _this.type = type;
        }
        if (info) {
            _this.info = info;
        }
        return _this;
    }
    /**回调 */
    FightView.prototype.onInit = function () {
        var _this = this;
        var ui = this.create("FightView", "FightView");
        this.on(GameEvent.fightRoundupdate, function (num) {
            _this.updateRound(num.params);
        }, this);
        this.on(GameEvent.fightComplete, this.fightCompleteHanlde, this);
        this.on(GameEvent.fightCloseUI, this.fightCloseUIHandle, this);
        this.on(GameEvent.godWeaponPower, this.updateBar, this);
        this.grouh1 = ui.getChild("grouh1").asGraph;
        this.closebtn = ui.getChild("closebtn").asButton;
        this.btnCom = ui.getChild("btnCom").asCom;
        this.leftbtn = ui.getChild("btnCom").asCom.getChild("leftbtn").asButton;
        this.rightbtn = ui.getChild("btnCom").asCom.getChild("rightbtn").asButton;
        this.endbtn = ui.getChild("endbtn").asButton;
        this.mynametxt = ui.getChild("mynametxt").asTextField;
        this.enemynametxt = ui.getChild("enemynametxt").asTextField;
        this.mylevel = ui.getChild("mylevel").asTextField;
        this.enemyevel = ui.getChild("enemyevel").asTextField;
        this.roundtxt = ui.getChild("roundtxt").asTextField;
        this.myheadLoader = ui.getChild("myheadLoader").asLoader;
        this.enemyLoader = ui.getChild("enemyLoader").asLoader;
        this.myzhenfa = ui.getChild("myzhenfa").asLoader;
        this.enemyzhenfa = ui.getChild("enemyzhenfa").asLoader;
        this.bar1 = ui.getChild("bar1").asProgress;
        this.bar2 = ui.getChild("bar2").asProgress;
        this.ClickAdd();
        this.updateView();
        this.closebtn.visible = false;
        BattleScene.sceneArr[0].timeScale = this.gettimeScale();
        this.leftbtn.selected = BattleScene.sceneArr[0].timeScale == 1 ? true : false;
        this.rightbtn.selected = BattleScene.sceneArr[0].timeScale == 1 ? false : true;
    };
    FightView.prototype.ClickAdd = function () {
        this.addClickListener(this.closebtn, this.onclick, this);
        this.addClickListener(this.leftbtn, this.onclick, this);
        this.addClickListener(this.rightbtn, this.onclick, this);
        this.addClickListener(this.endbtn, this.onclick, this);
    };
    FightView.prototype.updateView = function () {
        var tt2 = new egret.DisplayObjectContainer();
        var obj2 = this.grouh1;
        obj2.touchable = false;
        obj2.setNativeObject(tt2);
        new BattleScene().addToParent(tt2).start(this.report);
        this.mynametxt.text = "" + this.report.team1.nickname;
        this.enemynametxt.text = "" + this.report.team2.nickname;
        this.mylevel.text = "" + this.report.team1.level;
        this.enemyevel.text = "" + this.report.team2.level;
        this.setLoaderUrl(this.myheadLoader, "hero" + this.report.team1.head + "_png");
        this.setLoaderUrl(this.enemyLoader, "hero" + this.report.team2.head + "_png");
        var myHeroIdGroup = [];
        var enemyHeroIdGroup = [];
        for (var k = 0; k < this.report.roleArr1.length; k++) {
            if (k < 6) {
                myHeroIdGroup.push(this.report.roleArr1[k].heroID);
            }
        }
        for (var j = 0; j < this.report.roleArr2.length; j++) {
            if (j < 6) {
                enemyHeroIdGroup.push(this.report.roleArr2[j].heroID);
            }
        }
        this.setLoaderUrl(this.myzhenfa, "ui://RaceHelpView/" + FightData.inst().GetzhenfaImg(FightData.inst().Getzhenfa(myHeroIdGroup)));
        this.setLoaderUrl(this.enemyzhenfa, "ui://RaceHelpView/" + FightData.inst().GetzhenfaImg(FightData.inst().Getzhenfa(enemyHeroIdGroup)));
        if (this.type != 0) {
            this.endbtn.visible = true;
        }
        else {
            this.endbtn.visible = false;
        }
        this.bar1.visible = false;
        this.bar2.visible = false;
        for (var j = 0; j < this.report.roleArr1.length; j++) {
            if (this.report.roleArr1[j].pos == 6) {
                this.bar1.visible = true;
            }
        }
        for (var x = 0; x < this.report.roleArr2.length; x++) {
            if (this.report.roleArr2[x].pos == 6) {
                this.bar2.visible = true;
            }
        }
    };
    FightView.prototype.onclick = function (e) {
        switch (e.target) {
            case this.closebtn:
                this.close();
                break;
            case this.leftbtn:
                BattleScene.sceneArr[0].timeScale = 1;
                this.settimeScale(1);
                break;
            case this.rightbtn:
                if (MyData.user.vip > 16) {
                    BattleScene.sceneArr[0].timeScale = 2;
                    this.settimeScale(2);
                }
                else {
                    TipsViewSystem.show("vip" + 17 + "开启战斗2倍速度");
                    this.btnCom.getController("c1").selectedIndex = 0;
                    this.settimeScale(1);
                }
                break;
            case this.endbtn:
                if (MyData.user.vip > 16) {
                    var scene0 = BattleScene.sceneArr[0];
                    scene0.end();
                }
                else {
                    TipsViewSystem.show("vip" + 17 + "开启跳过战斗");
                }
                break;
        }
    };
    FightView.prototype.gettimeScale = function () {
        var str = GameLocalStorage.loadByUid(GameLocalStorage.fightTimeSpeed);
        var speed = str != null && str != "" ? str : 1;
        return Number(speed);
    };
    FightView.prototype.settimeScale = function (time) {
        GameLocalStorage.saveByUid(GameLocalStorage.fightTimeSpeed, time);
    };
    /**战斗结束回调 */
    FightView.prototype.fightCompleteHanlde = function () {
        ak.log("战斗已结束");
        if (this.report.winTeamID == 1) {
            this.WinViewShow();
        }
        else {
            this.FailViewShow();
        }
    };
    FightView.prototype.WinViewShow = function () {
        ak.FairyGUI.open(["WinView", this.report, this.dropMap, this.type, this.info]);
    };
    FightView.prototype.FailViewShow = function () {
        ak.FairyGUI.open(["FailView", this.report, this.dropMap, this.type, this.info]);
    };
    FightView.prototype.updateRound = function (round) {
        this.roundtxt.text = "\u7B2C" + round + "\u56DE\u5408";
    };
    FightView.prototype.updateBar = function (msg) {
        this.bar1.max = 100;
        this.bar2.max = 100;
        var params = msg.params;
        if (params[0] == 1) {
            this.bar1.tweenValue(params[1], 0.5);
        }
        if (params[0] == 2) {
            this.bar2.tweenValue(params[1], 0.5);
        }
    };
    FightView.prototype.fightCloseUIHandle = function () {
        this.close();
        if (ak.FairyGUI.getOpenUI("ExplorationView").length != 0 && GainitemView.isLevelup) {
            if (Guide.isInGuide() == false) {
                //重置标记
                GainitemView.isLevelup = false;
                ak.FairyGUI.open(["UpgradeTipsView"]);
            }
        }
    };
    FightView.ROUNDNUM = 1;
    return FightView;
}(ak.EasyUI));
__reflect(FightView.prototype, "FightView");
var WinViewSystem = (function (_super) {
    __extends(WinViewSystem, _super);
    function WinViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    WinViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("FightView");
    };
    WinViewSystem.inst = new WinViewSystem("FightView");
    return WinViewSystem;
}(ak.FairyGUI));
__reflect(WinViewSystem.prototype, "WinViewSystem");
/**
 * 胜利界面
 */
var WinView = (function (_super) {
    __extends(WinView, _super);
    function WinView(report, dropMap, type, info) {
        var _this = _super.call(this, WinViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.itemattr = [];
        _this.heroattr = [];
        _this.resourceattr = [];
        _this.type = 0;
        _this.info = {};
        _this.report = report;
        _this.dropMap = dropMap;
        if (type)
            _this.type = type;
        if (info)
            _this.info = info;
        return _this;
    }
    /**回调 */
    WinView.prototype.onInit = function () {
        var ui = this.create("FightView", "WinView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.list = ui.getChild("list").asList;
        this.n10 = ui.getChild("n10").asCom;
        this.friendbosstxt1 = ui.getChild("friendbosstxt1").asTextField;
        this.friendbosstxt2 = ui.getChild("friendbosstxt2").asTextField;
        this.name0 = ui.getChild("name0").asTextField;
        this.name1 = ui.getChild("name1").asTextField;
        this.head0 = ui.getChild("head0").asCom;
        this.head1 = ui.getChild("head1").asCom;
        this.jifen0 = ui.getChild("jifen0").asTextField;
        this.jifen1 = ui.getChild("jifen1").asTextField;
        this.control_c1 = ui.getController("c1");
        this.tipsbtn = ui.getChild("tipsbtn").asButton;
        this.chibang1 = ui.getChild("chibang1").asGraph;
        this.chibang2 = ui.getChild("chibang2").asGraph;
        this.lizi = ui.getChild("lizi").asGraph;
        this.qizi1 = ui.getChild("qizi1").asGraph;
        this.qizi2 = ui.getChild("qizi2").asGraph;
        this.yumao1 = ui.getChild("yumao1").asGraph;
        this.yumao2 = ui.getChild("yumao2").asGraph;
        this.ClickAdd();
        this.updateData();
        this.newStaticView();
        this.updatelistInfo();
        this.playMusic();
        this.mcHandle();
    };
    WinView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onclick, this);
        this.addClickListener(this.n10, this.onclick, this);
        this.addClickListener(this.tipsbtn, this.onclick, this);
        this.onFairyguiEvent(this.list, fairygui.ItemEvent.CLICK, this.itemonclick, this);
    };
    WinView.prototype.onclick = function (e) {
        switch (e.target) {
            case this.bgclose:
                ak.EventMgr.dispatch(GameEvent.fightCloseUI);
                this.close();
                break;
            case this.n10:
                ak.EventMgr.dispatch(GameEvent.fightCloseUI);
                this.close();
                break;
            case this.tipsbtn:
                ak.FairyGUI.open(["DamageCountView", this.report]);
                break;
        }
    };
    WinView.prototype.updateData = function () {
        if (this.dropMap.constructor == Array) {
            for (var i = 0; i < this.dropMap.length; i++) {
                if (Number(this.dropMap[i].type) == 1) {
                    this.itemattr.push({ id: this.dropMap[i].id, num: this.dropMap[i].num });
                }
                if (Number(this.dropMap[i].type) == 2) {
                    this.heroattr.push({ id: this.dropMap[i].id, num: this.dropMap[i].num });
                }
                if (Number(this.dropMap[i].type) == 3) {
                    this.resourceattr.push({ id: this.dropMap[i].id, num: this.dropMap[i].num });
                }
            }
            return;
        }
        for (var i in this.dropMap) {
            for (var k in this.dropMap[i]) {
                if (Number(i) == 1) {
                    this.itemattr.push({ id: k, num: this.dropMap[i][k] });
                }
                if (Number(i) == 2) {
                    this.heroattr.push({ id: k, num: this.dropMap[i][k] });
                }
                if (Number(i) == 3) {
                    this.resourceattr.push({ id: k, num: this.dropMap[i][k] });
                }
            }
        }
    };
    WinView.prototype.updatelistInfo = function () {
        this.list.removeChildrenToPool();
        for (var i = 0; i < this.heroattr.length; i++) {
            for (var j = 0; j < this.heroattr[i].num; j++) {
                var item = this.list.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
                var items = new ItemBase(item, this, 2);
                item.data = { itemID: this.heroattr[i].id, num: 0, type: 2 };
                items.setItemData(this.heroattr[i].id, HeroBagData.inst().GetRaceById(this.heroattr[i].id), HeroBagData.inst().GetStarById(this.heroattr[i].id));
            }
        }
        for (var i = 0; i < this.itemattr.length; i++) {
            var item = this.list.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
            var items = new ItemBase(item, this, 1);
            items.setItemData(this.itemattr[i].id);
            items.setNumber(this.itemattr[i].num, true);
            item.data = { itemID: this.itemattr[i].id, num: this.itemattr[i].num, type: 1 };
            if (BagData.inst().GetBagtypeById(this.itemattr[i].id) == 3) {
                var race = BagData.inst().isOnlyRacePiece(this.itemattr[i].id);
                items.setType(race);
            }
            else {
                items.setType(0);
            }
            if (BagData.inst().GetBagtypeById(this.itemattr[i].id) != 2) {
                items.setStar2(BagData.inst().GetStarById(this.itemattr[i].id));
            }
        }
        for (var i = 0; i < this.resourceattr.length; i++) {
            var item = this.list.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
            var items = new ItemBase(item, this, 3);
            items.setItemData(this.resourceattr[i].id);
            items.setNumber(this.resourceattr[i].num, true);
            item.data = { itemID: this.resourceattr[i].id, num: this.resourceattr[i].num, type: 3 };
        }
    };
    WinView.prototype.itemonclick = function (e) {
        if (e.itemObject.data.type != 3) {
            var bagtype = ak.JsonTableMgr.get("item").getRowFromColName("id", "" + e.itemObject.data.itemID).getValFromColName("bagtype");
            ak.FairyGUI.open(["WeaponTipsView", e.itemObject.data.itemID, e.itemObject.data.num, bagtype - 1, 0, true]);
        }
        else {
            ak.FairyGUI.open(["ResourceTipsView", e.itemObject.data.itemID, e.itemObject.data.num]);
        }
    };
    WinView.prototype.newStaticView = function () {
        var _this = this;
        this.bgclose.enabled = true;
        if (this.type == 0) {
            this.control_c1.selectedIndex = 0;
        }
        else if (this.type == 1) {
            this.control_c1.selectedIndex = 2;
            this.bgclose.enabled = false;
            this.friendbosstxt1.text = "伤害：" + Math.floor(Number(this.info.consumeHp));
            this.friendbosstxt2.text = "积分：" + Math.floor(Number(this.info.jifen));
            var drop = FriendData.inst().getDropGroupID(this.type);
            var info_5 = { dropMap: this.dropMap, drop: drop };
            var timeOut_3 = setTimeout(function () {
                clearTimeout(timeOut_3);
                _this.bgclose.enabled = true;
                ak.FairyGUI.open(["BonusView", info_5]);
            }, 500);
        }
        else if (this.type == 2) {
            this.control_c1.selectedIndex = 1;
            this.name0.text = "" + this.info.team1_nickname;
            this.name1.text = "" + this.info.team2_nickname;
            this.bgclose.enabled = false;
            var item0 = new ItemBase(this.head0, this, 2);
            item0.setIcons2("hero" + this.info.team1_head);
            item0.setNumber(this.info.team1_level, true);
            var item1 = new ItemBase(this.head1, this, 2);
            item1.setIcons2("hero" + this.info.team2_head);
            item1.setNumber(this.info.team2_level, true);
            this.jifen0.text = "" + this.info.team1_jifen;
            this.jifen1.text = "" + this.info.team2_jifen;
            var drop = FriendData.inst().getDropGroupID(this.type);
            var info_6 = { dropMap: this.dropMap, drop: drop };
            var timeOut_4 = setTimeout(function () {
                clearTimeout(timeOut_4);
                _this.bgclose.enabled = true;
                ak.FairyGUI.open(["BonusView", info_6]);
            }, 500);
        }
        else if (this.type == 3) {
            this.control_c1.selectedIndex = 0;
            var drop = FriendData.inst().getDropGroupID(this.type);
            var info_7 = { dropMap: this.info, drop: drop };
            var timeOut_5 = setTimeout(function () {
                clearTimeout(timeOut_5);
                _this.bgclose.enabled = true;
                ak.FairyGUI.open(["BonusView", info_7]);
            }, 500);
        }
    };
    //播放音乐
    WinView.prototype.playMusic = function () {
        ak.SoundMgr.inst.playSound("resource/sound/battlewin.mp3");
    };
    //mc
    WinView.prototype.mcHandle = function () {
        var chibang1mc = new ak.MovieClip("shenglichibang_json", "shenglichibang_png", "shenglichibang");
        this.chibang1.setNativeObject(chibang1mc);
        var chibang2mc = new ak.MovieClip("shenglichibang_json", "shenglichibang_png", "shenglichibang");
        chibang2mc.scaleX = -1;
        this.chibang2.setNativeObject(chibang2mc);
        var lizimc = new ak.MovieClip("shenglilizi_json", "shenglilizi_png", "shenglilizi", 1);
        this.lizi.setNativeObject(lizimc);
        var qizi1mc = new ak.MovieClip("shengliqizi_json", "shengliqizi_png", "shengliqizi", 1);
        qizi1mc.frameRate = 8;
        this.qizi1.setNativeObject(qizi1mc);
        var qizi2mc = new ak.MovieClip("shengliqizi_json", "shengliqizi_png", "shengliqizi", 1);
        qizi1mc.frameRate = 8;
        qizi2mc.scaleX = -1;
        this.qizi2.setNativeObject(qizi2mc);
        var yumao1mc = new ak.MovieClip("shengliyumao_json", "shengliyumao_png", "shengliyumao", 1);
        this.yumao1.setNativeObject(yumao1mc);
        var yumao2mc = new ak.MovieClip("shengliyumao_json", "shengliyumao_png", "shengliyumao", 1);
        yumao2mc.scaleX = -1;
        this.yumao2.setNativeObject(yumao2mc);
    };
    return WinView;
}(ak.EasyUI));
__reflect(WinView.prototype, "WinView");
//首冲界面
var FirstRechargeSystem = (function (_super) {
    __extends(FirstRechargeSystem, _super);
    function FirstRechargeSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    FirstRechargeSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("FirstRecharge");
    };
    FirstRechargeSystem.inst = new FirstRechargeSystem("FirstRecharge");
    return FirstRechargeSystem;
}(ak.FairyGUI));
__reflect(FirstRechargeSystem.prototype, "FirstRechargeSystem");
var FirstRechargeView = (function (_super) {
    __extends(FirstRechargeView, _super);
    function FirstRechargeView() {
        var _this = _super.call(this, FirstRechargeSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.selectIndex = 0; //切换奖励界面的索引
        return _this;
    }
    FirstRechargeView.prototype.onInit = function () {
        var ui = this.create("FirstRecharge", "FirstRechargeView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.recharge = ui.getChild("n10").asButton;
        this.getawardBtn = ui.getChild("n11").asButton;
        this.rechargedmoney = ui.getChild("n37").asTextField;
        this.awardlist = ui.getChild("n30").asList;
        this.haohua = ui.getChild("n29").asButton;
        this.chaoji = ui.getChild("n28").asButton;
        this.heropropetry = ui.getChild("n68").asCom;
        this.heroTab = ak.JsonTableMgr.get("hero");
        this.heroGrowTab = ak.JsonTableMgr.get("heroGrow");
        this.heroPromotionTab = ak.JsonTableMgr.get("heroPromotion");
        this.firstRecharge = ak.JsonTableMgr.get("fristRecharge");
        this.clickAdd();
        this.showView();
    };
    FirstRechargeView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.recharge, this.onClick, this);
        this.addClickListener(this.haohua, this.onClick, this);
        this.addClickListener(this.chaoji, this.onClick, this);
        this.addClickListener(this.getawardBtn, this.Award, this);
        this.onFairyguiEvent(this.awardlist, fairygui.ItemEvent.CLICK, this.showdetails, this);
    };
    FirstRechargeView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.recharge:
                ak.FairyGUI.open(["RechargeView"]);
                this.close();
                break;
            case this.haohua:
                this.selectIndex = 0;
                this.showView();
                break;
            case this.chaoji:
                this.selectIndex = 1;
                this.showView();
                break;
        }
    };
    FirstRechargeView.prototype.showView = function () {
        //已充值的钱 数量
        var user = MyData.user;
        var money = user.rmb;
        money = money * 0.01;
        this.rechargedmoney.text = money + '元';
        //显示英雄属性
        var heroInfo = this.heroTab.getRowFromColName("id", "61026");
        var star = heroInfo.getValFromColName("star"); //星级
        var heroPromotionInfo = this.heroPromotionTab.getRowFromColName("star", "" + star);
        var maxlv = heroPromotionInfo.getValFromColName("maxlv"); //最高可升级
        var hpPro = heroPromotionInfo.getValFromColName("hpPro"); //生命属性系数（万分比）
        var atkPro = heroPromotionInfo.getValFromColName("atkPro"); //攻击属性系数
        var defPro = heroPromotionInfo.getValFromColName("defPro"); //防御属性系数
        var speedPro = heroPromotionInfo.getValFromColName("speedPro"); //速度属性系数
        var heroComposeInfo = this.heroGrowTab.getRowFromColName("heroID", "61026");
        var hp = heroComposeInfo.getValFromColName("hp"); //生命
        var atk = heroComposeInfo.getValFromColName("atk"); //攻击
        var def = heroComposeInfo.getValFromColName("def"); //防御
        var speed = heroComposeInfo.getValFromColName("speed"); //速度
        var hpGrow = heroComposeInfo.getValFromColName("hpGrow"); //生命成长
        var atkGrow = heroComposeInfo.getValFromColName("atkGrow"); //攻击成长
        var defGrow = heroComposeInfo.getValFromColName("defGrow"); //防御成长
        var speedGrow = heroComposeInfo.getValFromColName("speedGrow"); //速度成长
        var allHp = Number(hp) + hpGrow * maxlv * hpPro / 10000;
        var allHtk = Number(atk) + atkGrow * maxlv * atkPro / 10000;
        var allDef = Number(def) + defGrow * maxlv * defPro / 10000;
        var allSpeed = Number(speed) + speedGrow * maxlv * speedPro / 10000;
        this.heropropetry.getChild("n1").asTextField.text = "等级：" + maxlv + ""; //等级
        this.heropropetry.getChild("n2").text = Math.floor(allHtk) + ""; //攻击
        this.heropropetry.getChild("n3").text = Math.floor(allDef) + ""; //防御
        this.heropropetry.getChild("n4").text = Math.floor(allHp) + ""; //血量
        this.heropropetry.getChild("n5").text = Math.floor(allSpeed) + ""; //速度
        //显示奖励
        this.awardlist.removeChildrenToPool();
        var count = this.firstRecharge.size();
        var temp = MyData.user.json.recharge.loginMap;
        for (var i = 0; i < 3; i++) {
            var FirstCharge = this.awardlist.addItemFromPool().asCom;
            //let item0 = shopFrame.getChild("recharge_award").asCom;
            var award_text = FirstCharge.getChild("title").asTextField;
            award_text.text = "第" + (i + 1) + "天免费领取";
            var shouchong = this.firstRecharge.getRow(this.selectIndex);
            var shouchongid = shouchong.getValFromColName("id");
            var shouchongpay = shouchong.getValFromColName("pay");
            var shouchongDropStr = shouchong.getValFromColName("drop");
            var shouchongIndex = shouchongDropStr[i];
            var itemlist = [];
            itemlist["id"] = shouchongid;
            itemlist["day"] = i + 1;
            this.getawardBtn.data = itemlist;
            var item_Cfg01 = ItemMgr.getDropGroupByID(Number(shouchongDropStr[i]));
            for (var j = 0; j < item_Cfg01.length; j++) {
                var item0 = FirstCharge.getChild("n" + (7 + j)).asCom;
                var item_type = item_Cfg01[j][1];
                var item_id = item_Cfg01[j][2];
                var item_count = item_Cfg01[j][3];
                var item0_list = []; //物品详情所需数据
                item0_list["index"] = item_id;
                item0_list["num"] = item_count;
                item0.data = item0_list;
                var itemBase0 = new ItemBase(item0, this, item_type);
                itemBase0.setItemData(Number(item_id));
                itemBase0.setNumber(item_count, true);
            }
            if (this.selectIndex == 0) {
                this.showLonggu(61026);
            }
            else {
                this.showLonggu(11076);
            }
            this.ui.getController("c2").selectedIndex = user.rmb >= shouchongpay ? 1 : 0;
            var ischoose = null; //奖励
            if (temp[this.selectIndex + 1] != null) {
                ischoose = temp[this.selectIndex + 1].rewardMap[i + 1];
            }
            FirstCharge.getController("c1").selectedIndex = ischoose != null ? 1 : 0;
        }
        if (temp[this.selectIndex + 1] == null) {
            this.ui.getController("c2").selectedIndex = 0;
        }
        else {
            var day = temp[this.selectIndex + 1].loginDays;
            var index = 0;
            for (var i = 1; i < 4; i++) {
                var it = temp[this.selectIndex + 1].rewardMap[i];
                if (it != null)
                    index++;
            }
            if ((temp[this.selectIndex + 1].rewardMap[day] == null && day <= 3) || (index < 3 && day > 3)) {
                this.ui.getController("c2").selectedIndex = 1;
            }
            else
                this.ui.getController("c2").selectedIndex = 2;
        }
    };
    //显示物品详情 
    FirstRechargeView.prototype.showdetails = function (obj) {
        var item = obj.itemObject;
        for (var i = 0; i < 2; i++) {
            var itemCom = item.getChild("n" + (7 + i)).asCom;
            if (this.hitTestPointWithFairyGUIComponent(itemCom, obj.stageX, obj.stageY)) {
                ak.FairyGUI.open(["WeaponTipsView", itemCom.data.index, itemCom.data.num, 1]);
            }
        }
    };
    FirstRechargeView.prototype.Award = function (e) {
        var _this = this;
        var temp = MyData.user.json.recharge.loginMap;
        var day = temp[this.selectIndex + 1].loginDays;
        for (var i = 1; i < 4; i++) {
            if (temp[this.selectIndex + 1].rewardMap == null || (temp[this.selectIndex + 1].rewardMap[i] == null && i <= day)) {
                net.firstRechargeReward(e.target.data.id, i, function () {
                    _this.showView();
                }, this);
                return;
            }
        }
    };
    FirstRechargeView.prototype.showLonggu = function (heroID) {
        if (!this.heroNode) {
            this.heroNode = new egret.DisplayObjectContainer();
            this.ui.getChild("longgu").asGraph.setNativeObject(this.heroNode);
        }
        // let tt=new egret.DisplayObjectContainer();
        // let temp =	this.ui.getChild("longgu").asGraph;
        // temp.setNativeObject(this.heroNode);
        this.heroNode.removeChildren();
        var hero = new Hero(heroID).addToParent(this.heroNode);
        this.heroNode.scaleX = -1;
    };
    return FirstRechargeView;
}(ak.EasyUI));
__reflect(FirstRechargeView.prototype, "FirstRechargeView");
var FriendBossInfoSystem = (function (_super) {
    __extends(FriendBossInfoSystem, _super);
    function FriendBossInfoSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    FriendBossInfoSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("FriendView");
    };
    FriendBossInfoSystem.inst = new FriendBossInfoSystem("FriendView");
    return FriendBossInfoSystem;
}(ak.FairyGUI));
__reflect(FriendBossInfoSystem.prototype, "FriendBossInfoSystem");
/**
 * 查看好友boss信息
 */
var FriendBossInfo = (function (_super) {
    __extends(FriendBossInfo, _super);
    function FriendBossInfo(id, msg) {
        var _this = _super.call(this, FriendBossInfoSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.id = 0;
        _this.msg = null;
        _this.id = id;
        _this.msg = msg;
        return _this;
    }
    /**回调 */
    FriendBossInfo.prototype.onInit = function () {
        var ui = this.create("FriendView", "FriendBossInfo");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.sweepbtn = ui.getChild("sweepbtn").asButton;
        this.fightbtn = ui.getChild("fightbtn").asButton;
        this.bossinfo = ui.getChild("bossinfo").asCom;
        this.num2 = ui.getChild("num2").asTextField;
        this.ClickAdd();
        this.updateView();
    };
    FriendBossInfo.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.sweepbtn, this.onClick, this);
        this.addClickListener(this.fightbtn, this.onClick, this);
    };
    FriendBossInfo.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.sweepbtn:
                if (FriendData.inst().GetBossMP() < 1) {
                    TipsViewSystem.show("体力不足");
                    return;
                }
                this.close();
                ak.FairyGUI.open(["FriendBossSweepView", this.id]);
                break;
            case this.fightbtn:
                if (FriendData.inst().GetBossMP() < 1) {
                    TipsViewSystem.show("体力不足");
                    return;
                }
                this.close();
                ak.FairyGUI.open(["FightReadyView", 4, this.id]);
                break;
        }
    };
    FriendBossInfo.prototype.updateView = function () {
        var item = this.bossinfo;
        var bossitem = item.getChild("bossitem").asCom;
        var username = item.getChild("username").asTextField;
        var bossname = item.getChild("bossname").asTextField;
        var progress = item.getChild("progress").asProgress;
        var heroID = FriendData.inst().GetBossInfo(this.msg[2].monsterGroupID).heroID;
        var items = new ItemBase(bossitem, this, 2);
        items.setItemData(heroID, HeroBagData.inst().GetRaceById(heroID), HeroBagData.inst().GetStarById(heroID));
        items.setNumber(FriendData.inst().GetBossInfo(this.msg[2].monsterGroupID).lv);
        username.text = MyData.user.nickname;
        bossname.text = HeroBagData.inst().GetNameById(heroID);
        progress.max = this.msg[2].hpMax;
        progress.value = this.msg[2].hp;
        this.num2.text = "" + FriendData.inst().GetBossMP();
    };
    /**查看对方Boss信息界面 */
    FriendBossInfo.GetPlayerInfo = function (id) {
        net.getBoss(id, function (msg) {
            ak.FairyGUI.open(["FriendBossInfo", id, msg]);
        }, this);
    };
    return FriendBossInfo;
}(ak.EasyUI));
__reflect(FriendBossInfo.prototype, "FriendBossInfo");
var FriendBossRecordViewSystem = (function (_super) {
    __extends(FriendBossRecordViewSystem, _super);
    function FriendBossRecordViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    FriendBossRecordViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("FriendView");
    };
    FriendBossRecordViewSystem.inst = new FriendBossRecordViewSystem("FriendView");
    return FriendBossRecordViewSystem;
}(ak.FairyGUI));
__reflect(FriendBossRecordViewSystem.prototype, "FriendBossRecordViewSystem");
/**
 * 排行榜
 * 单个
 */
var FriendBossRecordView = (function (_super) {
    __extends(FriendBossRecordView, _super);
    function FriendBossRecordView() {
        return _super.call(this, FriendBossRecordViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
    }
    /**回调 */
    FriendBossRecordView.prototype.onInit = function () {
        var ui = this.create("FriendView", "FriendBossRecordView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.list1 = ui.getChild("list1").asList;
        this.ClickAdd();
        this.updatList();
    };
    FriendBossRecordView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
    };
    FriendBossRecordView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
        }
    };
    /**更新列表 */
    FriendBossRecordView.prototype.updatList = function () {
        this.list1.removeChildrenToPool();
        for (var i = 0; i < FriendData.inst().GetBossrecordSize(); i++) {
            var item = this.list1.addItemFromPool().asCom;
            var rankloader = item.getChild("rankloader").asLoader;
            var ranknum = item.getChild("ranknum").asTextField;
            var itemlist = item.getChild("itemlist").asList;
            var info = FriendData.inst().GetBossrecordInfoByID(i + 1);
            if (i == 0) {
                ranknum.visible = false;
                rankloader.visible = true;
                this.setLoaderUrl(rankloader, "ui://common/img_paihangbang_1");
            }
            else if (i == 1) {
                ranknum.visible = false;
                rankloader.visible = true;
                this.setLoaderUrl(rankloader, "ui://common/img_paihangbang_2");
            }
            else if (i == 2) {
                ranknum.visible = false;
                rankloader.visible = true;
                this.setLoaderUrl(rankloader, "ui://common/img_paihangbang_3");
            }
            else {
                ranknum.visible = true;
                rankloader.visible = false;
                ranknum.text = info.rankMin + "-" + info.rankMax;
            }
            itemlist.removeChildrenToPool();
            var itemGroup = ItemMgr.getDropGroupByID(info.drop);
            for (var j = 0; j < itemGroup.length; j++) {
                var item_3 = itemlist.addItemFromPool().asCom;
                var items = new ItemBase(item_3, this, itemGroup[j][1]);
                items.setItemData(itemGroup[j][2]);
                items.setNumber(itemGroup[j][3], true);
            }
        }
    };
    return FriendBossRecordView;
}(ak.EasyUI));
__reflect(FriendBossRecordView.prototype, "FriendBossRecordView");
var FriendBossSweepViewSystem = (function (_super) {
    __extends(FriendBossSweepViewSystem, _super);
    function FriendBossSweepViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    FriendBossSweepViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("FriendView");
    };
    FriendBossSweepViewSystem.inst = new FriendBossSweepViewSystem("FriendView");
    return FriendBossSweepViewSystem;
}(ak.FairyGUI));
__reflect(FriendBossSweepViewSystem.prototype, "FriendBossSweepViewSystem");
/**
 * 扫荡界面
 */
var FriendBossSweepView = (function (_super) {
    __extends(FriendBossSweepView, _super);
    function FriendBossSweepView(id) {
        var _this = _super.call(this, FriendBossSweepViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.id = 0;
        _this.nowSellcount = 0;
        _this.id = id;
        return _this;
    }
    /**回调 */
    FriendBossSweepView.prototype.onInit = function () {
        var ui = this.create("FriendView", "FriendBossSweepView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.numleftbtn = ui.getChild("numleftbtn").asButton;
        this.numrightbtn = ui.getChild("numrightbtn").asButton;
        this.nownum = ui.getChild("nownum").asTextField;
        this.nowmoney = ui.getChild("nowmoney").asTextField;
        this.buybtn2 = ui.getChild("buybtn2").asButton;
        this.ClickAdd();
        this.nowSellcount = FriendData.inst().GetBossMP();
        this.nownum.text = "" + this.nowSellcount;
        this.nowmoney.text = "" + this.nowSellcount;
    };
    FriendBossSweepView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.buybtn2, this.onClick, this);
        this.addClickListener(this.numleftbtn, this.onClick, this);
        this.addClickListener(this.numrightbtn, this.onClick, this);
    };
    FriendBossSweepView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.numleftbtn:
                this.Setleftnum();
                break;
            case this.numrightbtn:
                this.Setrightnum();
                break;
            case this.buybtn2:
                this.buyItemHandle2();
                break;
        }
    };
    FriendBossSweepView.prototype.Setleftnum = function () {
        if (this.nowSellcount >= 2) {
            this.nowSellcount--;
            this.nownum.text = String(this.nowSellcount);
        }
        else {
            TipsViewSystem.show("已经是最小值了");
        }
        this.nowmoney.text = "" + this.nowSellcount;
    };
    FriendBossSweepView.prototype.Setrightnum = function () {
        if (FriendData.inst().GetBossMP() > this.nowSellcount) {
            this.nowSellcount++;
            this.nownum.text = String(this.nowSellcount);
        }
        else {
            TipsViewSystem.show("已经是最大值了");
        }
        this.nowmoney.text = "" + this.nowSellcount;
    };
    FriendBossSweepView.prototype.buyItemHandle2 = function () {
        this.close();
        ak.FairyGUI.open(["FightReadyView", 4, this.id, this.nowSellcount]);
    };
    return FriendBossSweepView;
}(ak.EasyUI));
__reflect(FriendBossSweepView.prototype, "FriendBossSweepView");
var FriendData = (function () {
    function FriendData() {
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    FriendData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new FriendData();
        }
        return Class._instance;
    };
    /**返回第一个倒计时 */
    FriendData.prototype.GetTime = function () {
        var friendTab = ak.JsonTableMgr.get("friend");
        var freeTime1 = friendTab.getRow(0).getValFromColName("treasureTime");
        var dt1 = (new Date().getTime() / 1000) - MyData.user.json.friendSys.searchTreasureTime + MyData.timeBase;
        if (dt1 >= freeTime1) {
            return 0;
        }
        else {
            var spareTime = freeTime1 - dt1;
            return spareTime;
        }
    };
    /**获得boss的信息 */
    FriendData.prototype.GetBossInfo = function (id) {
        var monsterTab = ak.JsonTableMgr.get("monster");
        var monsterInfo = monsterTab.getRowFromColName("group", "" + id);
        var lv = monsterInfo.getValFromColName("lv");
        var promotion = monsterInfo.getValFromColName("promotion");
        var heroID = monsterInfo.getValFromColName("heroID");
        var info = { heroID: heroID, lv: lv, promotion: promotion };
        return info;
    };
    /**获得奖励表的长度 */
    FriendData.prototype.GetBossrecordSize = function () {
        var friendWeekPrizeTab = ak.JsonTableMgr.get("friendWeekPrize");
        var size = friendWeekPrizeTab.size();
        return size;
    };
    FriendData.prototype.GetBossrecordInfoByID = function (id) {
        var friendWeekPrizeTab = ak.JsonTableMgr.get("friendWeekPrize");
        var friendWeekPrizeInfo = friendWeekPrizeTab.getRowFromColName("id", "" + id);
        var rankMin = friendWeekPrizeInfo.getValFromColName("rankMin");
        var rankMax = friendWeekPrizeInfo.getValFromColName("rankMax");
        var drop = friendWeekPrizeInfo.getValFromColName("drop");
        var info = { rankMin: rankMin, rankMax: rankMax, drop: drop };
        return info;
    };
    /**获得打boss的体力计算 */
    FriendData.prototype.GetBossMP = function () {
        var friendTab = ak.JsonTableMgr.get("friend");
        var cd = friendTab.getRow(0).getValFromColName("cd");
        var allcd = (new Date().getTime() / 1000) - MyData.user.json.friendSys.actionPowerTime + MyData.timeBase;
        var num = Math.floor(allcd / cd);
        if (num > 10)
            num = 10;
        return num;
    };
    /**获得掉落组id
     * id:1为好友，2为竞技场
    */
    FriendData.prototype.getDropGroupID = function (id) {
        if (id == 1) {
            var Tab = ak.JsonTableMgr.get("friendTreasureBoss");
            var drop = Tab.getRow(0).getValFromColName("drop");
            return drop;
        }
        else if (id == 2) {
            var Tab = ak.JsonTableMgr.get("arenaConfig");
            var drop = Tab.getRow(0).getValFromColName("drop");
            return drop;
        }
        else if (id == 3) {
            var Tab = ak.JsonTableMgr.get("expeditionConfig");
            var drop = Tab.getRow(0).getValFromColName("drop");
            return drop;
        }
        return 0;
    };
    return FriendData;
}());
__reflect(FriendData.prototype, "FriendData");
var FriendViewSystem = (function (_super) {
    __extends(FriendViewSystem, _super);
    function FriendViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    FriendViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("FriendView");
    };
    FriendViewSystem.inst = new FriendViewSystem("FriendView");
    return FriendViewSystem;
}(ak.FairyGUI));
__reflect(FriendViewSystem.prototype, "FriendViewSystem");
/**
 * 好友界面
 */
var FriendView = (function (_super) {
    __extends(FriendView, _super);
    function FriendView() {
        var _this = _super.call(this, FriendViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
        _this.friendGroup = [];
        _this.reqFriendGroup = [];
        _this.blackGroup = [];
        _this.bossmsg = null;
        /**获取好友申请列表*/
        _this.reqFriendisfrist = true;
        _this.bosslitisfrist = true;
        return _this;
    }
    /**回调 */
    FriendView.prototype.onInit = function () {
        var ui = this.create("FriendView", "FriendView");
        this.on(GameEvent.defriend, this.GetFriendList, this);
        this.on(GameEvent.fightRpcComplete, this.GetMyBossInfo, this);
        this.on(GameEvent.fightRpcComplete, this.updateitemnum, this);
        this.on(GameEvent.fightRpcComplete, this.rendotHanlde, this);
        this.on("netmsg://friend/recvHeartResult", this.rendotHanlde, this);
        this.on("netmsg://friend/searchTreasureResult", this.rendotHanlde, this);
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.control_c1 = ui.getController("c1");
        this.control_c2 = ui.getController("c2");
        this.btn0 = ui.getChild("btn0").asButton;
        this.btn1 = ui.getChild("btn1").asButton;
        this.btn2 = ui.getChild("btn2").asButton;
        this.btn3 = ui.getChild("btn3").asButton;
        this.num0 = ui.getChild("num0").asTextField;
        this.num1 = ui.getChild("num1").asTextField;
        this.friendnum = ui.getChild("friendnum").asTextField;
        this.sendbtn = ui.getChild("sendbtn").asButton;
        this.friendlist = ui.getChild("friendlist").asList;
        this.leftbtn = ui.getChild("tab").asCom.getChild("leftbtn").asButton;
        this.rightbtn = ui.getChild("tab").asCom.getChild("rightbtn").asButton;
        this.updatebtn0 = ui.getChild("updatebtn0").asButton;
        this.friendtxt = ui.getChild("friendtxt").asTextInput;
        this.findbtn = ui.getChild("findbtn").asButton;
        this.friendlist2 = ui.getChild("friendlist2").asList;
        this.requestnum = ui.getChild("requestnum").asTextField;
        this.removebtn = ui.getChild("removebtn").asButton;
        this.surebtn = ui.getChild("surebtn").asButton;
        this.friendlist3 = ui.getChild("friendlist3").asList;
        this.num2 = ui.getChild("num2").asTextField;
        this.tipsbtn = ui.getChild("tipsbtn").asButton;
        this.rankbtn = ui.getChild("rankbtn").asButton;
        this.rewardbtn = ui.getChild("rewardbtn").asButton;
        this.findbtn2 = ui.getChild("findbtn2").asButton;
        this.fightbtn = ui.getChild("fightbtn").asButton;
        this.fightbtn2 = ui.getChild("fightbtn2").asButton;
        this.bosslist = ui.getChild("bosslist").asList;
        this.bosstime = ui.getChild("bosstime").asTextField;
        this.friendlist4 = ui.getChild("friendlist4").asList;
        this.rendot0 = ui.getChild("rendot0").asImage;
        this.rendot1 = ui.getChild("rendot1").asImage;
        this.ClickAdd();
        this.staticView();
        this.GetFriendList();
        this.rendotHanlde();
    };
    FriendView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.btn0, this.onClick, this);
        this.addClickListener(this.btn1, this.onClick, this);
        this.addClickListener(this.btn2, this.onClick, this);
        this.addClickListener(this.btn3, this.onClick, this);
        this.addClickListener(this.sendbtn, this.onClick, this);
        this.addClickListener(this.leftbtn, this.onClick, this);
        this.addClickListener(this.rightbtn, this.onClick, this);
        this.addClickListener(this.updatebtn0, this.onClick, this);
        this.addClickListener(this.removebtn, this.onClick, this);
        this.addClickListener(this.surebtn, this.onClick, this);
        this.addClickListener(this.tipsbtn, this.onClick, this);
        this.addClickListener(this.rankbtn, this.onClick, this);
        this.addClickListener(this.rewardbtn, this.onClick, this);
        this.addClickListener(this.findbtn2, this.onClick, this);
        this.addClickListener(this.fightbtn, this.onClick, this);
        this.addClickListener(this.fightbtn2, this.onClick, this);
        this.addClickListener(this.findbtn, this.onClick, this);
        this.onFairyguiEvent(this.friendlist, fairygui.ItemEvent.CLICK, this.friendlistHandle, this);
        this.onFairyguiEvent(this.friendlist2, fairygui.ItemEvent.CLICK, this.friendlist2Handle, this);
        this.onFairyguiEvent(this.friendlist3, fairygui.ItemEvent.CLICK, this.friendlist3Handle, this);
        this.onFairyguiEvent(this.friendlist4, fairygui.ItemEvent.CLICK, this.friendlist4Handle, this);
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.timeDown, this);
    };
    FriendView.prototype.onClick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.btn0:
                this.control_c1.selectedIndex = 0;
                break;
            case this.btn1:
                this.control_c1.selectedIndex = 1;
                this.GetAnyFriends();
                break;
            case this.btn2:
                this.control_c1.selectedIndex = 2;
                if (this.reqFriendisfrist) {
                    this.reqFriendisfrist = false;
                    this.GetReqFriendList();
                }
                break;
            case this.btn3:
                this.control_c1.selectedIndex = 3;
                if (this.bosslitisfrist) {
                    this.bosslitisfrist = false;
                    this.GetMyBossInfo();
                }
                break;
            case this.leftbtn:
                this.control_c2.selectedIndex = 0;
                break;
            case this.rightbtn:
                this.control_c2.selectedIndex = 1;
                this.GetBlackList();
                break;
            case this.sendbtn:
                net.oneKeyFriendHeart(function () {
                    TipsViewSystem.show("已收获");
                    _this.GetFriendList();
                    _this.updatenum0Text();
                }, this);
                break;
            case this.findbtn:
                this.addFriendByID();
                break;
            case this.findbtn:
                break;
            case this.updatebtn0:
                break;
            case this.tipsbtn:
                break;
            case this.rankbtn:
                ak.FairyGUI.open(["RankView", 2, "积分"]);
                break;
            case this.rewardbtn:
                ak.FairyGUI.open(["FriendBossRecordView"]);
                break;
            case this.fightbtn:
                if (FriendData.inst().GetBossMP() < 1) {
                    TipsViewSystem.show("体力不足");
                    return;
                }
                ak.FairyGUI.open(["FightReadyView", 4, MyData.user.id]);
                break;
            case this.fightbtn2:
                //扫荡
                if (FriendData.inst().GetBossMP() < 1) {
                    TipsViewSystem.show("体力不足");
                    return;
                }
                ak.FairyGUI.open(["FriendBossSweepView", MyData.user.id]);
                break;
            case this.findbtn2:
                net.searchTreasure(function () {
                    _this.findbtn2.enabled = false;
                    _this.GetMyBossInfo();
                }, this);
                break;
            case this.removebtn:
                if (this.reqFriendGroup.length == 0) {
                    return;
                }
                else {
                    net.handleAllReqFriend(0, function () {
                        _this.GetReqFriendList();
                    }, this);
                }
                break;
            case this.surebtn:
                if (this.reqFriendGroup.length == 0) {
                    return;
                }
                else {
                    net.handleAllReqFriend(1, function () {
                        _this.GetReqFriendList();
                    }, this);
                }
                break;
        }
    };
    /**好友列表操作 */
    FriendView.prototype.friendlistHandle = function (obj) {
        var _this = this;
        var item = obj.itemObject;
        /**送心 */
        if (this.hitTestPointWithFairyGUIComponent(item.getChild("sendbtn").asButton, obj.stageX, obj.stageY)) {
            if (!item.getChild("sendbtn").asButton.enabled)
                return;
            net.giveHeart(item.data.id, function () {
                TipsViewSystem.show("赠送成功");
                for (var i = 0; i < _this.friendlist.numItems; i++) {
                    if (item.data == _this.friendlist.getChildAt(i).data) {
                        _this.friendlist.getChildAt(i).asCom.getChild("sendbtn").asButton.enabled = false;
                    }
                }
            }, this);
        }
        /**收心 */
        if (this.hitTestPointWithFairyGUIComponent(item.getChild("takebtn").asButton, obj.stageX, obj.stageY)) {
            if (!item.getChild("takebtn").asButton.enabled)
                return;
            net.recvHeart(item.data.id, function () {
                TipsViewSystem.show("收获成功");
                for (var i = 0; i < _this.friendlist.numItems; i++) {
                    if (item.data == _this.friendlist.getChildAt(i).data) {
                        _this.friendlist.getChildAt(i).asCom.getChild("takebtn").asButton.visible = false;
                    }
                }
                _this.updatenum0Text();
            }, this);
        }
        if (this.hitTestPointWithFairyGUIComponent(item.getChild("bossbtn").asButton, obj.stageX, obj.stageY)) {
            if (!item.getChild("bossbtn").asButton.enabled)
                return;
            FriendBossInfo.GetPlayerInfo(item.data.id);
        }
        /**查看信息 */
        if (this.hitTestPointWithFairyGUIComponent(item.getChild("itemCom").asCom, obj.stageX, obj.stageY)) {
            LookupInfoView.GetPlayerInfo(item.data.id);
        }
        /**跟好友pk */
        if (this.hitTestPointWithFairyGUIComponent(item.getChild("fightbtn").asButton, obj.stageX, obj.stageY)) {
            if (!item.getChild("fightbtn").asButton.enabled)
                return;
            ak.FairyGUI.open(["FightReadyView", 6, item.data.id]);
        }
    };
    /**推荐好友列表操作 */
    FriendView.prototype.friendlist2Handle = function (obj) {
        var _this = this;
        var item = obj.itemObject;
        if (this.hitTestPointWithFairyGUIComponent(item.getChild("surebtn").asButton, obj.stageX, obj.stageY)) {
            net.reqFirend(item.data.userID, function () {
                TipsViewSystem.show("申请成功");
                for (var i = 0; i < _this.friendlist2.numItems; i++) {
                    if (item.data.userID == _this.friendlist2.getChildAt(i).data.userID) {
                        _this.friendlist2.removeChildToPoolAt(i);
                    }
                }
                for (var j = 0; j < MyData.friendArr.length; j++) {
                    if (MyData.friendArr[j].userID == item.data.userID) {
                        MyData.friendArr.splice(j, 1);
                    }
                }
            }, this);
        }
    };
    /**申请列表操作 */
    FriendView.prototype.friendlist3Handle = function (obj) {
        var _this = this;
        var item = obj.itemObject;
        if (this.hitTestPointWithFairyGUIComponent(item.getChild("nobtn").asButton, obj.stageX, obj.stageY)) {
            net.agreeReqFriend(item.data[0], 0, function () {
                TipsViewSystem.show("已拒绝");
                for (var i = 0; i < _this.friendlist3.numItems; i++) {
                    if (item.data[0] == _this.friendlist3.getChildAt(i).data[0]) {
                        _this.friendlist3.removeChildToPoolAt(i);
                    }
                }
                _this.requestnum.text = "" + _this.friendlist3.numItems;
            }, this);
        }
        if (this.hitTestPointWithFairyGUIComponent(item.getChild("yesbtn").asButton, obj.stageX, obj.stageY)) {
            net.agreeReqFriend(item.data[0], 1, function () {
                TipsViewSystem.show("已添加");
                _this.GetFriendList();
                for (var i = 0; i < _this.friendlist3.numItems; i++) {
                    if (item.data[0] == _this.friendlist3.getChildAt(i).data[0]) {
                        _this.friendlist3.removeChildToPoolAt(i);
                    }
                }
                _this.requestnum.text = "" + _this.friendlist3.numItems;
            }, this);
        }
    };
    FriendView.prototype.friendlist4Handle = function (obj) {
        var _this = this;
        var item = obj.itemObject;
        if (this.hitTestPointWithFairyGUIComponent(item.getChild("nobtn").asButton, obj.stageX, obj.stageY)) {
            net.removeFriend(item.data.id, function () {
                _this.GetBlackList();
            }, this);
        }
    };
    FriendView.prototype.staticView = function () {
        this.leftbtn.getChild("title").asTextField.text = "推荐列表";
        this.rightbtn.getChild("title").asTextField.text = "黑名单";
    };
    /**所有调用到 */
    FriendView.prototype.updateitemnum = function () {
        this.num0.text = "0";
        this.num1.text = "" + FriendData.inst().GetBossMP();
        this.num2.text = "" + FriendData.inst().GetBossMP();
        this.friendnum.text = "" + this.friendGroup.length + "/30";
        this.requestnum.text = "0";
        this.updatenum0Text();
    };
    FriendView.prototype.updatefriendlist = function () {
        this.friendlist.removeChildrenToPool();
        for (var i = 0; i < this.friendGroup.length; i++) {
            var item = this.friendlist.addItemFromPool().asCom;
            var itemCom = item.getChild("itemCom").asCom.getChild("n1").asCom;
            var name_19 = item.getChild("name").asTextField;
            var time = item.getChild("time").asTextField;
            var bossbtn = item.getChild("bossbtn").asButton;
            var takebtn = item.getChild("takebtn").asButton;
            var sendbtn = item.getChild("sendbtn").asButton;
            var fightbtn = item.getChild("fightbtn").asButton;
            item.data = this.friendGroup[i];
            var info = this.friendGroup[i].info;
            var items = new ItemBase(itemCom, this, 2);
            items.setIcons2("hero" + info.head);
            items.setNumber(info.level, true);
            name_19.text = info.nickname;
            time.text = "" + Common.passTime(Math.floor(DateUtils.formatStrTimeToS(info.loginTime) / 1000));
            if (info.monsterGroupID != 0) {
                bossbtn.visible = true;
            }
            else {
                bossbtn.visible = false;
            }
            if (info.give != 0) {
                sendbtn.enabled = false;
            }
            else {
                sendbtn.enabled = true;
            }
            if (info.recv == 1) {
                takebtn.visible = true;
            }
            else {
                takebtn.visible = false;
            }
        }
    };
    FriendView.prototype.updatefriendlist2 = function () {
        this.friendlist2.removeChildrenToPool();
        for (var i = 0; i < MyData.friendArr.length; i++) {
            var item = this.friendlist2.addItemFromPool().asCom;
            var itemCom = item.getChild("itemCom").asCom.getChild("n1").asCom;
            var name_20 = item.getChild("name").asTextField;
            var power = item.getChild("power").asTextField;
            var time = item.getChild("time").asTextField;
            var surebtn = item.getChild("surebtn").asButton;
            item.data = MyData.friendArr[i];
            var info = MyData.friendArr[i];
            var items = new ItemBase(itemCom, this, 2);
            items.setIcons2("hero" + info.head);
            items.setNumber(info.level, true);
            name_20.text = info.nickname;
            if (info.unionName != "") {
                name_20.text = info.nickname + "(" + info.unionName + ")";
            }
            time.text = "1分钟以内";
            power.text = "" + info.battlePower;
        }
    };
    FriendView.prototype.updatefriendlist3 = function () {
        this.friendlist3.removeChildrenToPool();
        for (var i = 0; i < this.reqFriendGroup.length; i++) {
            var item = this.friendlist3.addItemFromPool().asCom;
            var itemCom = item.getChild("itemCom").asCom.getChild("n1").asCom;
            var name_21 = item.getChild("name").asTextField;
            var yesbtn = item.getChild("yesbtn").asButton;
            var nobtn = item.getChild("nobtn").asButton;
            item.data = this.reqFriendGroup[i].info;
            var info = this.reqFriendGroup[i].info;
            var items = new ItemBase(itemCom, this, 2);
            items.setIcons2("hero" + info[1]);
            items.setNumber(info[2], true);
            name_21.text = info[3];
        }
    };
    FriendView.prototype.updatebosslist = function () {
        this.bosslist.removeChildrenToPool();
        if (this.bossmsg[2].status == 0)
            return;
        if (this.bossmsg[2].monsterGroupID == 0)
            return;
        if (this.bossmsg[2].hp == 0)
            return;
        for (var i = 0; i < 1; i++) {
            var item = this.bosslist.addItemFromPool().asCom;
            var bossitem = item.getChild("bossitem").asCom;
            var username = item.getChild("username").asTextField;
            var bossname = item.getChild("bossname").asTextField;
            var progress = item.getChild("progress").asProgress;
            var heroID = FriendData.inst().GetBossInfo(this.bossmsg[2].monsterGroupID).heroID;
            var items = new ItemBase(bossitem, this, 2);
            items.setItemData(heroID, HeroBagData.inst().GetRaceById(heroID), HeroBagData.inst().GetStarById(heroID));
            items.setNumber(FriendData.inst().GetBossInfo(this.bossmsg[2].monsterGroupID).lv);
            username.text = MyData.user.nickname;
            bossname.text = HeroBagData.inst().GetNameById(heroID);
            progress.max = this.bossmsg[2].hpMax;
            progress.value = this.bossmsg[2].hp;
        }
    };
    FriendView.prototype.updatefriendlist4 = function () {
        this.friendlist4.removeChildrenToPool();
        for (var i = 0; i < this.blackGroup.length; i++) {
            var item = this.friendlist4.addItemFromPool().asCom;
            var itemCom = item.getChild("itemCom").asCom.getChild("n1").asCom;
            var name_22 = item.getChild("name").asTextField;
            var nobtn = item.getChild("nobtn").asButton;
            item.data = this.blackGroup[i];
            var info = this.blackGroup[i].info;
            var items = new ItemBase(itemCom, this, 2);
            items.setIcons2("hero" + info.head);
            items.setNumber(info.level, true);
            name_22.text = info.nickname;
        }
    };
    /**获取好友列表 */
    FriendView.prototype.GetFriendList = function () {
        var _this = this;
        this.friendGroup = [];
        net.getFriend(function (msg) {
            for (var i in msg[1]) {
                _this.friendGroup.push({ id: i, info: msg[1][i] });
            }
            ak.log(_this.friendGroup);
            _this.updatefriendlist();
            _this.updateitemnum();
        }, this);
    };
    /**获得推荐列表 */
    FriendView.prototype.GetAnyFriends = function () {
        var _this = this;
        if (MyData.friendArr) {
            this.updatefriendlist2();
        }
        else {
            net.getAnyFriends(function () {
                _this.updatefriendlist2();
            }, this);
        }
    };
    /**根据id添加好友 */
    FriendView.prototype.addFriendByID = function () {
        var id = Number(this.friendtxt.text);
        net.reqFirend(id, function () {
            TipsViewSystem.show("申请成功");
        }, this);
    };
    FriendView.prototype.GetReqFriendList = function () {
        var _this = this;
        this.reqFriendGroup = [];
        net.getReqFriend(function (msg) {
            if (msg[1] == {}) {
                _this.reqFriendGroup = [];
            }
            else {
                for (var i in msg[1]) {
                    _this.reqFriendGroup.push({ id: i, info: msg[1][i] });
                }
            }
            _this.updatefriendlist3();
            _this.requestnum.text = "" + _this.reqFriendGroup.length;
        }, this);
    };
    /**获取黑名单列表*/
    FriendView.prototype.GetBlackList = function () {
        var _this = this;
        this.blackGroup = [];
        net.getBlack(function (msg) {
            if (msg[1] == {}) {
                _this.blackGroup = [];
            }
            else {
                for (var i in msg[1]) {
                    _this.blackGroup.push({ id: i, info: msg[1][i] });
                }
            }
            ak.log(_this.blackGroup);
            _this.updatefriendlist4();
        }, this);
    };
    FriendView.prototype.GetMyBossInfo = function () {
        var _this = this;
        net.getBoss(MyData.user.id, function (msg) {
            _this.bossmsg = msg;
            _this.updateBossInfo();
        }, this);
    };
    /**同步爱心道具 */
    FriendView.prototype.updatenum0Text = function () {
        this.num0.text = "" + SummonData.inst().GetItemnumByid(2013);
    };
    /**更新boss界面信息 */
    FriendView.prototype.updateBossInfo = function () {
        this.bosstime.text = "";
        if (FriendData.inst().GetTime() != 0) {
            this.findbtn2.enabled = false;
        }
        else {
            this.findbtn2.enabled = true;
        }
        if (this.bossmsg[2].status == 1) {
            this.fightbtn.visible = true;
            this.fightbtn2.visible = true;
            this.findbtn2.visible = false;
            this.bosstime.visible = false;
        }
        else {
            this.fightbtn.visible = false;
            this.fightbtn2.visible = false;
            this.findbtn2.visible = true;
            this.bosstime.visible = true;
        }
        this.updatebosslist();
    };
    /**锁住按钮 */
    FriendView.prototype.closebtnHandle = function () {
    };
    /**开启按钮 */
    FriendView.prototype.openbtnHandle = function () {
    };
    /**红点提示 */
    FriendView.prototype.rendotHanlde = function () {
        this.rendot0.visible = RedDotMgr.getFriendRedDot();
        this.rendot1.visible = RedDotMgr.getFriendTreasureRedDot();
    };
    /**倒计时 */
    FriendView.prototype.timeDown = function () {
        var time = FriendData.inst().GetTime();
        if (time > 0) {
            this.bosstime.text = DateUtils.getFormatBySecond(time, DateUtils.TIME_FORMAT_12) + "\u540E\u5237\u65B0";
            this.findbtn2.enabled = false;
        }
        else {
            this.findbtn2.enabled = true;
        }
    };
    //销毁回调
    FriendView.prototype.onDestroy = function () {
        //清理
        this.removeEventListener(egret.Event.ENTER_FRAME, this.timeDown, this);
    };
    return FriendView;
}(ak.EasyUI));
__reflect(FriendView.prototype, "FriendView");
var SweepOverViewSystem = (function (_super) {
    __extends(SweepOverViewSystem, _super);
    function SweepOverViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    SweepOverViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("FriendView");
    };
    SweepOverViewSystem.inst = new SweepOverViewSystem("FriendView");
    return SweepOverViewSystem;
}(ak.FairyGUI));
__reflect(SweepOverViewSystem.prototype, "SweepOverViewSystem");
/**
 * 扫荡界面
 */
var SweepOverView = (function (_super) {
    __extends(SweepOverView, _super);
    function SweepOverView(dropMap, consumeHp, jifen) {
        var _this = _super.call(this, SweepOverViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.itemattr = [];
        _this.heroattr = [];
        _this.resourceattr = [];
        _this.dropMap = dropMap;
        _this.consumeHp = consumeHp;
        _this.jifen = jifen;
        return _this;
    }
    /**回调 */
    SweepOverView.prototype.onInit = function () {
        var ui = this.create("FriendView", "SweepOverView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.closebtn = ui.getChild("closebtn").asButton;
        this.scorenum = ui.getChild("scorenum").asTextField;
        this.hurtnum = ui.getChild("hurtnum").asTextField;
        this.list = ui.getChild("list").asList;
        this.ClickAdd();
        this.updateView();
    };
    SweepOverView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.closebtn, this.onClick, this);
    };
    SweepOverView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.closebtn:
                this.close();
                break;
        }
    };
    SweepOverView.prototype.updateView = function () {
        this.scorenum.text = "" + Math.floor(this.consumeHp);
        this.hurtnum.text = "" + Math.floor(this.jifen);
        for (var i in this.dropMap) {
            for (var k in this.dropMap[i]) {
                if (Number(i) == 1) {
                    this.itemattr.push({ id: k, num: this.dropMap[i][k] });
                }
                if (Number(i) == 2) {
                    this.heroattr.push({ id: k, num: this.dropMap[i][k] });
                }
                if (Number(i) == 3) {
                    this.resourceattr.push({ id: k, num: this.dropMap[i][k] });
                }
            }
        }
        this.updatelistInfo();
    };
    SweepOverView.prototype.updatelistInfo = function () {
        this.list.removeChildrenToPool();
        for (var i = 0; i < this.heroattr.length; i++) {
            for (var j = 0; j < this.heroattr[i].num; j++) {
                var item = this.list.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
                var items = new ItemBase(item, this, 2);
                item.data = { itemID: this.heroattr[i].id, num: 0, type: 2 };
                items.setItemData(this.heroattr[i].id, HeroBagData.inst().GetRaceById(this.heroattr[i].id), HeroBagData.inst().GetStarById(this.heroattr[i].id));
            }
        }
        for (var i = 0; i < this.itemattr.length; i++) {
            var item = this.list.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
            var items = new ItemBase(item, this, 1);
            items.setItemData(this.itemattr[i].id);
            items.setNumber(this.itemattr[i].num, true);
            item.data = { itemID: this.itemattr[i].id, num: this.itemattr[i].num, type: 1 };
            if (BagData.inst().GetBagtypeById(this.itemattr[i].id) == 3) {
                var race = BagData.inst().isOnlyRacePiece(this.itemattr[i].id);
                items.setType(race);
            }
            else {
                items.setType(0);
            }
            if (BagData.inst().GetBagtypeById(this.itemattr[i].id) != 2) {
                items.setStar2(BagData.inst().GetStarById(this.itemattr[i].id));
            }
        }
        for (var i = 0; i < this.resourceattr.length; i++) {
            var item = this.list.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
            var items = new ItemBase(item, this, 3);
            items.setItemData(this.resourceattr[i].id);
            items.setNumber(this.resourceattr[i].num, true);
            item.data = { itemID: this.resourceattr[i].id, num: this.resourceattr[i].num, type: 3 };
        }
    };
    SweepOverView.prototype.itemonclick = function (e) {
        if (e.itemObject.data.type != 3) {
            var bagtype = ak.JsonTableMgr.get("item").getRowFromColName("id", "" + e.itemObject.data.itemID).getValFromColName("bagtype");
            ak.FairyGUI.open(["WeaponTipsView", e.itemObject.data.itemID, e.itemObject.data.num, bagtype - 1, 0, true]);
        }
        else {
            ak.FairyGUI.open(["ResourceTipsView", e.itemObject.data.itemID, e.itemObject.data.num]);
        }
    };
    return SweepOverView;
}(ak.EasyUI));
__reflect(SweepOverView.prototype, "SweepOverView");
var GainitemViewSystem = (function (_super) {
    __extends(GainitemViewSystem, _super);
    function GainitemViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GainitemViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("GainitemView");
    };
    GainitemViewSystem.inst = new GainitemViewSystem("GainitemView");
    return GainitemViewSystem;
}(ak.FairyGUI));
__reflect(GainitemViewSystem.prototype, "GainitemViewSystem");
/**
 *
 */
var GainitemView = (function (_super) {
    __extends(GainitemView, _super);
    function GainitemView(itemlist) {
        var _this = _super.call(this, GainitemViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.itemattr = [];
        _this.heroattr = [];
        _this.resourceattr = [];
        _this.itemlist = itemlist;
        return _this;
    }
    /**回调 */
    GainitemView.prototype.onInit = function () {
        var ui = this.create("GainitemView", "GainitemView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.list = ui.getChild("list").asList;
        this.n9 = ui.getChild("n9").asCom;
        this.t0 = ui.getTransition("t0");
        this.ClickAdd();
        this.updateData();
        this.updatelistInfo();
        this.t0.play();
        ak.SoundMgr.inst.playSound("resource/sound/lingqujiangli.mp3");
    };
    GainitemView.prototype.ClickAdd = function () {
        var _this = this;
        this.addClickListener(this.bgclose, function () {
            _this.openactivity();
            _this.close();
            ak.EventMgr.dispatch(GameEvent.wishPoolMCupdate);
            /*
            if(this.itemlist[3] && this.itemlist[3][1])  {
                ak.EventMgr.dispatch(GameEvent.guide_Exopen);
            };*/
            if (ak.FairyGUI.getOpenUI("ExplorationView").length != 0 && GainitemView.isLevelup && _this.itemlist[3] && _this.itemlist[3][1]) {
                if (Guide.isInGuide() == false) {
                    //重置标记
                    GainitemView.isLevelup = false;
                    ak.FairyGUI.open(["UpgradeTipsView"]);
                }
            }
        }, this);
        this.addClickListener(this.n9, function () {
            _this.openactivity();
            _this.close();
            ak.EventMgr.dispatch(GameEvent.wishPoolMCupdate);
            /*
            if(this.itemlist[3] && this.itemlist[3][1])  {
                ak.EventMgr.dispatch(GameEvent.guide_Exopen);
            };*/
            if (ak.FairyGUI.getOpenUI("ExplorationView").length != 0 && GainitemView.isLevelup && _this.itemlist[3] && _this.itemlist[3][1]) {
                if (Guide.isInGuide() == false) {
                    //重置标记
                    GainitemView.isLevelup = false;
                    ak.FairyGUI.open(["UpgradeTipsView"]);
                }
            }
        }, this);
        this.onFairyguiEvent(this.list, fairygui.ItemEvent.CLICK, this.itemonclick, this);
    };
    GainitemView.prototype.updateData = function () {
        if (this.itemlist.constructor == Array) {
            for (var i = 0; i < this.itemlist.length; i++) {
                if (Number(this.itemlist[i].type) == 1) {
                    this.itemattr.push({ id: this.itemlist[i].id, num: this.itemlist[i].num });
                }
                if (Number(this.itemlist[i].type) == 2) {
                    this.heroattr.push({ id: this.itemlist[i].id, num: this.itemlist[i].num });
                }
                if (Number(this.itemlist[i].type) == 3) {
                    this.resourceattr.push({ id: this.itemlist[i].id, num: this.itemlist[i].num });
                }
            }
            return;
        }
        for (var i in this.itemlist) {
            for (var k in this.itemlist[i]) {
                if (Number(i) == 1) {
                    this.itemattr.push({ id: k, num: this.itemlist[i][k] });
                }
                if (Number(i) == 2) {
                    this.heroattr.push({ id: k, num: this.itemlist[i][k] });
                }
                if (Number(i) == 3) {
                    this.resourceattr.push({ id: k, num: this.itemlist[i][k] });
                }
            }
        }
    };
    GainitemView.prototype.updatelistInfo = function () {
        this.list.removeChildrenToPool();
        for (var i = 0; i < this.heroattr.length; i++) {
            for (var j = 0; j < this.heroattr[i].num; j++) {
                var item = this.list.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
                var items = new ItemBase(item, this, 2);
                item.data = { itemID: this.heroattr[i].id, num: 0, type: 2 };
                items.setItemData(this.heroattr[i].id, HeroBagData.inst().GetRaceById(this.heroattr[i].id), HeroBagData.inst().GetStarById(this.heroattr[i].id));
            }
        }
        for (var i = 0; i < this.itemattr.length; i++) {
            var item = this.list.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
            var items = new ItemBase(item, this, 1);
            items.setItemData(this.itemattr[i].id);
            items.setNumber(this.itemattr[i].num, true);
            item.data = { itemID: this.itemattr[i].id, num: this.itemattr[i].num, type: 1 };
            if (BagData.inst().GetBagtypeById(this.itemattr[i].id) == 3) {
                var race = BagData.inst().isOnlyRacePiece(this.itemattr[i].id);
                items.setType(race);
            }
            else {
                items.setType(0);
            }
            if (BagData.inst().GetBagtypeById(this.itemattr[i].id) != 2) {
                items.setStar2(BagData.inst().GetStarById(this.itemattr[i].id));
            }
        }
        //重新整理resourceattr
        var newresourceattr = [];
        var zsinfo = { id: 3, num: 0 };
        for (var j = 0; j < this.resourceattr.length; j++) {
            if (this.resourceattr[j].id == "3" || this.resourceattr[j].id == "7") {
                zsinfo.num += this.resourceattr[j].num;
            }
            else {
                newresourceattr.push(this.resourceattr[j]);
            }
        }
        if (zsinfo.num != 0) {
            newresourceattr.push(zsinfo);
        }
        for (var i = 0; i < newresourceattr.length; i++) {
            var item = this.list.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
            var items = new ItemBase(item, this, 3);
            items.setItemData(newresourceattr[i].id);
            items.setNumber(newresourceattr[i].num, true);
            item.data = { itemID: newresourceattr[i].id, num: newresourceattr[i].num, type: 3 };
        }
    };
    GainitemView.prototype.itemonclick = function (e) {
        if (e.itemObject.data.type == 2) {
            return;
        }
        if (e.itemObject.data.type != 3) {
            var bagtype = ak.JsonTableMgr.get("item").getRowFromColName("id", "" + e.itemObject.data.itemID).getValFromColName("bagtype");
            if (bagtype == 4) {
                ak.FairyGUI.open(["ShipinTipsView", e.itemObject.data.itemID, e.itemObject.data.num, 0, 2]);
            }
            else {
                ak.FairyGUI.open(["WeaponTipsView", e.itemObject.data.itemID, e.itemObject.data.num, bagtype - 1, 0, true]);
            }
        }
        else {
            ak.FairyGUI.open(["ResourceTipsView", e.itemObject.data.itemID, e.itemObject.data.num]);
        }
    };
    /**打开活动 */
    GainitemView.prototype.openactivity = function () {
        if (this.isHave5starhero() && !Guide.isInGuide()) {
            egret.setTimeout(function () {
                ak.FairyGUI.open(["ChooseTipsView", 9, "5星英雄养成礼包（限时）已激活，是否去购买", function () {
                        ak.FairyGUI.open(["ActivityCommonView", "ActivityLimitGiftView"]);
                    }]);
            }, this, 500);
        }
    };
    /**判断是否有五星英雄 */
    GainitemView.prototype.isHave5starhero = function () {
        for (var i = 0; i < this.heroattr.length; i++) {
            if (HeroBagData.inst().GetStarById(this.heroattr[i].id) == 5) {
                return true;
            }
        }
        return false;
    };
    /**升级标记 */
    GainitemView.isLevelup = false;
    return GainitemView;
}(ak.EasyUI));
__reflect(GainitemView.prototype, "GainitemView");
var GodWeaponData = (function () {
    function GodWeaponData() {
        this.godWeaponTaskTab = ak.JsonTableMgr.get("godWeaponTask");
        this.godWeaponTab = ak.JsonTableMgr.get("godWeapon");
        this.godWeaponSkillTab = ak.JsonTableMgr.get("godWeaponSkill");
        this.godWeaponAttrTab = ak.JsonTableMgr.get("godWeaponAttr");
        this.godWeaponLevelTab = ak.JsonTableMgr.get("godWeaponLevel");
        this.godWeaponSkillLevelTab = ak.JsonTableMgr.get("godWeaponSkillLevel");
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    GodWeaponData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new GodWeaponData();
        }
        return Class._instance;
    };
    //获取神器配置表
    GodWeaponData.prototype.getGodWeaponCfgList = function () {
        return this.godWeaponTab;
    };
    //获取神器等级配置表
    GodWeaponData.prototype.getGodWeaponLevelCfgList = function () {
        return this.godWeaponLevelTab;
    };
    //获取神器技能等级配置表
    GodWeaponData.prototype.getGodWeaponSkillLevelCfgList = function () {
        return this.godWeaponSkillLevelTab;
    };
    //获取神器技能配置表
    GodWeaponData.prototype.getGodWeaponSkillCfgList = function () {
        return this.godWeaponSkillTab;
    };
    //根据神器ID获取神器任务
    GodWeaponData.prototype.getTaskListByGodWeaponID = function (weaponId) {
        var taskList = [];
        for (var i = 0; i < this.godWeaponTaskTab.size(); i++) {
            var godWeaponTaskInfo = this.godWeaponTaskTab.getRow(i);
            if (godWeaponTaskInfo.getValFromColName("godWeaponID") == weaponId) {
                taskList.push(godWeaponTaskInfo);
            }
        }
        return taskList;
    };
    //根据神器ID获取神器信息
    GodWeaponData.prototype.getDataByGodWeaponID = function (weaponId) {
        var taskList = [];
        for (var i = 0; i < this.godWeaponTab.size(); i++) {
            var godWeaponInfo = this.godWeaponTab.getRow(i);
            if (godWeaponInfo.getValFromColName("id") == weaponId) {
                return godWeaponInfo;
            }
        }
        return null;
    };
    //根据神器ID和等级获取神器技能信息
    GodWeaponData.prototype.getSkillDataByIdAndLevel = function (weaponId, weaponLevel) {
        var taskList = [];
        for (var i = 0; i < this.godWeaponSkillTab.size(); i++) {
            var godWeaponSkillInfo = this.godWeaponSkillTab.getRow(i);
            if (godWeaponSkillInfo.getValFromColName("id") == weaponId && godWeaponSkillInfo.getValFromColName("skillLevel") == weaponLevel) {
                return godWeaponSkillInfo;
            }
        }
        return null;
    };
    //根据神器ID和等级获取神器属性信息
    GodWeaponData.prototype.getAttrDataByIdAndLevel = function (weaponId, weaponLevel) {
        var taskList = [];
        for (var i = 0; i < this.godWeaponAttrTab.size(); i++) {
            var godWeaponAttrInfo = this.godWeaponAttrTab.getRow(i);
            if (godWeaponAttrInfo.getValFromColName("id") == weaponId && godWeaponAttrInfo.getValFromColName("level") == weaponLevel) {
                return godWeaponAttrInfo;
            }
        }
        return null;
    };
    //根据神器等级获取升级所需材料信息
    GodWeaponData.prototype.getUpgradeDataByLevel = function (weaponLevel) {
        var taskList = [];
        for (var i = 0; i < this.godWeaponLevelTab.size(); i++) {
            var godWeaponLevelInfo = this.godWeaponLevelTab.getRow(i);
            if (godWeaponLevelInfo.getValFromColName("level") == weaponLevel) {
                return godWeaponLevelInfo;
            }
        }
        return null;
    };
    //根据神器技能等级获取升级所需材料信息
    GodWeaponData.prototype.getUpgradeDataBySkillLevel = function (skillLevel) {
        var taskList = [];
        for (var i = 0; i < this.godWeaponSkillLevelTab.size(); i++) {
            var godWeaponSkillLevelInfo = this.godWeaponSkillLevelTab.getRow(i);
            if (godWeaponSkillLevelInfo.getValFromColName("skillLevel") == skillLevel) {
                return godWeaponSkillLevelInfo;
            }
        }
        return null;
    };
    return GodWeaponData;
}());
__reflect(GodWeaponData.prototype, "GodWeaponData");
//神器信息界面系统
var GodWeaponInfoTipViewSystem = (function (_super) {
    __extends(GodWeaponInfoTipViewSystem, _super);
    function GodWeaponInfoTipViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GodWeaponInfoTipViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("GodWeapon");
    };
    GodWeaponInfoTipViewSystem.inst = new GodWeaponInfoTipViewSystem("GodWeapon");
    return GodWeaponInfoTipViewSystem;
}(ak.FairyGUI));
__reflect(GodWeaponInfoTipViewSystem.prototype, "GodWeaponInfoTipViewSystem");
/**
 * 神器信息界面
 */
var GodWeaponInfoTipView = (function (_super) {
    __extends(GodWeaponInfoTipView, _super);
    function GodWeaponInfoTipView(weaponId, type) {
        var _this = _super.call(this, GodWeaponInfoTipViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.basicsAttrList = [];
        _this.specialAttrList = [];
        _this.skillTextList = [];
        _this.type = 0;
        _this.infobasicsAttrList = [];
        _this.weaponId = weaponId;
        _this.type = type;
        return _this;
    }
    /**回调 */
    GodWeaponInfoTipView.prototype.onInit = function () {
        this.create("GodWeapon", "GodWeaponInfoTipView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.godWeaponName = this.ui.getChild("godWeaponName").asTextField;
        this.WeaponDesText = this.ui.getChild("WeaponDesText").asTextField;
        this.weaponIconLoader2 = this.ui.getChild("weaponIconLoader2").asLoader;
        this.titleText = this.ui.getChild("titleText").asTextField;
        this.skillText = this.ui.getChild("skillText").asTextField;
        this.weaponIconLoader = this.ui.getChild("weaponIconLoader").asLoader;
        this.ui.getController("c1").selectedIndex = this.type;
        for (var i = 0; i < 3; i++) {
            if (i < 2) {
                this.basicsAttrList[i] = this.ui.getChild("basicsAttr" + i).asTextField;
                this.infobasicsAttrList[i] = this.ui.getChild("infobasicsAttr" + i).asTextField;
            }
            this.specialAttrList[i] = this.ui.getChild("specialAttr" + i).asTextField;
            this.skillTextList[i] = this.ui.getChild("skillText" + i).asTextField;
        }
        this.ClickAdd();
        this.updateView();
    };
    GodWeaponInfoTipView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
    };
    GodWeaponInfoTipView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
        }
    };
    GodWeaponInfoTipView.prototype.updateView = function () {
        var godWeaponInfo = GodWeaponData.inst().getDataByGodWeaponID(this.weaponId);
        var name = godWeaponInfo.getValFromColName("name");
        var icon = godWeaponInfo.getValFromColName("icon");
        if (this.type == 0) {
            this.godWeaponName.text = name;
            var godWeaponSys = MyData.user.json.godWeaponSys;
            var level = godWeaponSys["weapon" + this.weaponId].level;
            var godWeaponSkillInfo = GodWeaponData.inst().getSkillDataByIdAndLevel(this.weaponId, level);
            this.WeaponDesText.text = godWeaponSkillInfo.getValFromColName("des");
            this.setLoaderUrl(this.weaponIconLoader2, icon);
            var godWeaponAttrInfo = GodWeaponData.inst().getAttrDataByIdAndLevel(this.weaponId, level);
            var attrName = [];
            attrName[0] = "全队攻击+" + godWeaponAttrInfo.getValFromColName("atk");
            attrName[1] = "全队生命+" + godWeaponAttrInfo.getValFromColName("hp");
            for (var i = 0; i < 2; i++) {
                this.infobasicsAttrList[i].text = attrName[i];
            }
        }
        else {
            var godWeaponInfo_1 = GodWeaponData.inst().getDataByGodWeaponID(this.weaponId);
            var godWeaponLevelTab = GodWeaponData.inst().getGodWeaponLevelCfgList();
            this.titleText.text = name + "(" + godWeaponLevelTab.size() + "\u7EA7)";
            this.setLoaderUrl(this.weaponIconLoader, icon);
            var godWeaponSkillTab = GodWeaponData.inst().getGodWeaponSkillCfgList();
            var godWeaponSkillInfo = godWeaponSkillTab.getRow(godWeaponSkillTab.size() - 1);
            this.skillText.text = godWeaponSkillInfo.getValFromColName("des");
            var godWeaponAttrInfo = GodWeaponData.inst().getAttrDataByIdAndLevel(this.weaponId, godWeaponLevelTab.size());
            var attrName = [];
            attrName[0] = "全队攻击+" + godWeaponAttrInfo.getValFromColName("atk");
            attrName[1] = "全队生命+" + godWeaponAttrInfo.getValFromColName("hp");
            for (var i = 0; i < 3; i++) {
                if (i < 2) {
                    this.basicsAttrList[i].text = attrName[i];
                }
                var skillData = godWeaponInfo_1.getValFromColName("skill" + ((i + 1) * 8));
                var skillCfg = Common.getSkillNameBySkillId(skillData[0]);
                this.specialAttrList[i].text = "全队" + skillCfg.name + "+" + (skillData[1] / 100) + "%";
                this.skillTextList[i].text = "(技能等级" + ((i + 1) * 8) + "级)";
            }
        }
    };
    return GodWeaponInfoTipView;
}(ak.EasyUI));
__reflect(GodWeaponInfoTipView.prototype, "GodWeaponInfoTipView");
//神器技能系统
var GodWeaponSkillInfoViewSystem = (function (_super) {
    __extends(GodWeaponSkillInfoViewSystem, _super);
    function GodWeaponSkillInfoViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GodWeaponSkillInfoViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("GodWeapon");
    };
    GodWeaponSkillInfoViewSystem.inst = new GodWeaponSkillInfoViewSystem("GodWeapon");
    return GodWeaponSkillInfoViewSystem;
}(ak.FairyGUI));
__reflect(GodWeaponSkillInfoViewSystem.prototype, "GodWeaponSkillInfoViewSystem");
/**
 * 神器技能界面
 */
var GodWeaponSkillInfoView = (function (_super) {
    __extends(GodWeaponSkillInfoView, _super);
    function GodWeaponSkillInfoView() {
        var _this = _super.call(this, GodWeaponSkillInfoViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.skillTextList = [];
        return _this;
    }
    /**回调 */
    GodWeaponSkillInfoView.prototype.onInit = function () {
        this.create("GodWeapon", "GodWeaponSkillInfoView");
        this.closebtn = this.ui.getChild("closebtn").asButton;
        this.btnTitleList = this.ui.getChild("btnTitleList").asList;
        var zsBar = this.ui.getChild("zsBar").asCom;
        this.item_00num = zsBar.getChild("item_00num").asCom;
        this.item_01num = zsBar.getChild("item_01num").asCom;
        this.number0 = this.item_00num.getChild("number").asTextField;
        this.number1 = this.item_01num.getChild("number").asTextField;
        this.addbtn0 = zsBar.getChild("addbtn0").asButton;
        this.addbtn1 = zsBar.getChild("addbtn1").asButton;
        this.setLoaderUrl(this.item_00num.getChild("icon").asLoader, "ui://common/token_jb");
        this.weaponName = this.ui.getChild("weaponName").asTextField;
        this.skillLevel = this.ui.getChild("skillLevel").asTextField;
        this.weaponLevel = this.ui.getChild("weaponLevel").asTextField;
        this.btnUpAttr = this.ui.getChild("btnUpAttr").asButton;
        this.btnUpSkill = this.ui.getChild("btnUpSkill").asButton;
        this.infoTitle = this.ui.getChild("infoTitle").asTextField;
        this.weaponAttr1 = this.ui.getChild("weaponAttr1").asTextField;
        this.weaponAttr2 = this.ui.getChild("weaponAttr2").asTextField;
        this.moneyText = this.ui.getChild("moneyText").asTextField;
        this.propText = this.ui.getChild("propText").asTextField;
        this.btnUpgrade = this.ui.getChild("btnUpgrade").asButton;
        this.weaponSkillText = this.ui.getChild("weaponSkillText").asTextField;
        this.skillUpIcon = this.ui.getChild("skillUpIcon").asLoader;
        this.c1Controller = this.ui.getController("c1");
        this.isMaxLevel = this.ui.getController("isMaxLevel");
        this.longgu = this.ui.getChild("longgu").asGraph;
        this.btn_chongzhu = this.ui.getChild("btn_chongzhu").asButton;
        this.c1Controller.selectedIndex = 0;
        for (var i = 0; i < 3; i++) {
            this.skillTextList[i] = this.ui.getChild("skillText" + i).asTextField;
        }
        this.ClickAdd();
        this.updateList();
        this.staticView();
    };
    GodWeaponSkillInfoView.prototype.ClickAdd = function () {
        this.addClickListener(this.closebtn, this.onClick, this);
        this.addClickListener(this.addbtn0, this.onClick, this);
        this.addClickListener(this.addbtn1, this.onClick, this);
        this.addClickListener(this.btn_chongzhu, this.onClick, this);
        this.addClickListener(this.btnUpAttr, this.onClickChangeAttr, this);
        this.addClickListener(this.btnUpSkill, this.onClickChangeSkill, this);
        this.addClickListener(this.btnUpgrade, this.onClickUpgrade, this);
        this.onFairyguiEvent(this.btnTitleList, fairygui.ItemEvent.CLICK, this.itemonclick, this);
    };
    //点击强化
    GodWeaponSkillInfoView.prototype.onClickUpgrade = function () {
        if (this.c1Controller.selectedIndex == 0) {
            net.godWeaponUpLevel(this.weaponData.id, this.updateView, this);
        }
        else {
            net.godWeaponUpSkill(this.weaponData.id, this.updateView, this);
        }
    };
    //点击切换属性界面
    GodWeaponSkillInfoView.prototype.onClickChangeAttr = function () {
        this.c1Controller.selectedIndex = 0;
        this.infoTitle.text = "基础属性";
        var godWeaponSys = MyData.user.json.godWeaponSys;
        var level = godWeaponSys["weapon" + this.weaponData.id].level;
        var godWeaponAttrInfo = GodWeaponData.inst().getAttrDataByIdAndLevel(this.weaponData.id, level);
        this.weaponAttr1.text = "全队攻击+" + godWeaponAttrInfo.getValFromColName("atk");
        this.weaponAttr2.text = "全队生命+" + godWeaponAttrInfo.getValFromColName("hp");
        var godWeaponLevelTab = GodWeaponData.inst().getGodWeaponLevelCfgList();
        this.isMaxLevel.selectedIndex = 0;
        if (level == godWeaponLevelTab.size()) {
            this.isMaxLevel.selectedIndex = 1;
            this.btnUpgrade.enabled = false;
            this.btnUpgrade.getChild("title").asTextField.text = "已满级";
            return;
        }
        else {
            var godWeaponLevelInfo = GodWeaponData.inst().getUpgradeDataByLevel(level);
            var item = godWeaponLevelInfo.getValFromColName("item");
            var gold = godWeaponLevelInfo.getValFromColName("gold");
            var num = godWeaponLevelInfo.getValFromColName("num");
            var item_count = SummonData.inst().GetItemnumByid(item);
            var moneyColor = MyData.user.money >= gold ? Color.green : Color.red;
            var propColor = item_count >= num ? Color.green : Color.red;
            this.moneyText.text = "[color=" + moneyColor + "]" + (Common.overLength(gold) + "/" + Common.overLength(MyData.user.money)) + "[/color]";
            this.propText.text = "[color=" + propColor + "]" + (Common.overLength(num) + "/" + Common.overLength(item_count)) + "[/color]";
            this.btnUpgrade.enabled = true;
            this.btnUpgrade.getChild("title").asTextField.text = "强化";
        }
    };
    //点击切换技能界面
    GodWeaponSkillInfoView.prototype.onClickChangeSkill = function () {
        this.c1Controller.selectedIndex = 1;
        var godWeaponSys = MyData.user.json.godWeaponSys;
        var weaponData = godWeaponSys["weapon" + this.weaponData.id];
        this.infoTitle.text = this.weaponData.skillName + "+" + weaponData.skillLevel;
        this.setLoaderUrl(this.skillUpIcon, this.weaponData.skillIcon);
        var godWeaponSkillInfo = GodWeaponData.inst().getSkillDataByIdAndLevel(this.weaponData.id, weaponData.skillLevel);
        this.weaponSkillText.text = godWeaponSkillInfo.getValFromColName("des");
        var godWeaponSkillLevelTab = GodWeaponData.inst().getGodWeaponSkillLevelCfgList();
        this.isMaxLevel.selectedIndex = 0;
        if (weaponData.skillLevel == (godWeaponSkillLevelTab.size() - 1)) {
            this.isMaxLevel.selectedIndex = 1;
            this.btnUpgrade.getChild("title").asTextField.text = "已满级";
            this.btnUpgrade.enabled = false;
            return;
        }
        else {
            var godWeaponSkillLevelInfo = GodWeaponData.inst().getUpgradeDataBySkillLevel(weaponData.skillLevel);
            var weaponlevel = godWeaponSkillLevelInfo.getValFromColName("level");
            var gold = godWeaponSkillLevelInfo.getValFromColName("gold");
            var item = godWeaponSkillLevelInfo.getValFromColName("item");
            var num = godWeaponSkillLevelInfo.getValFromColName("num");
            var item_count = SummonData.inst().GetItemnumByid(item);
            var moneyColor = MyData.user.money >= gold ? Color.green : Color.red;
            var propColor = item_count >= num ? Color.green : Color.red;
            this.moneyText.text = "[color=" + moneyColor + "]" + (Common.overLength(gold) + "/" + Common.overLength(MyData.user.money)) + "[/color]";
            this.propText.text = "[color=" + propColor + "]" + (Common.overLength(num) + "/" + Common.overLength(item_count)) + "[/color]";
            this.btnUpgrade.enabled = weaponData.level >= weaponlevel;
            this.btnUpgrade.getChild("title").asTextField.text = weaponData.level >= weaponlevel ? "强化" : "属性" + weaponlevel + "级";
        }
    };
    GodWeaponSkillInfoView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.closebtn:
                this.close();
                break;
            case this.addbtn0:
                ak.FairyGUI.open(["MoneyView"]);
                break;
            case this.addbtn1:
                ak.FairyGUI.open(["RechargeView"]);
                break;
            case this.btn_chongzhu:
                var godWeaponSys = MyData.user.json.godWeaponSys;
                var weaponSysData = godWeaponSys["weapon" + this.weaponData.id];
                if (weaponSysData.level == 1 && weaponSysData.skillLevel == 0) {
                    TipsViewSystem.show("神器等级为1级,无需重铸");
                }
                else {
                    ak.FairyGUI.open(["ChooseTipsView", 10, "重铸后神器将回到初始状态,并返还除金币外所有资源，是否重铸?", this.updateView.bind(this), this.weaponData.id]);
                }
                break;
        }
    };
    GodWeaponSkillInfoView.prototype.staticView = function () {
        //打开第一个界面
        this.openFristView();
    };
    /**打开第一个界面 */
    GodWeaponSkillInfoView.prototype.openFristView = function () {
        var item = this.btnTitleList.getChildAt(0);
        this.weaponData = item.data;
        item.selected = true;
        this.updateView();
    };
    GodWeaponSkillInfoView.prototype.updateView = function () {
        Common.labelIsOverLenght(this.number0, MyData.user.money);
        Common.labelIsOverLenght(this.number1, MyData.user.diamond + MyData.user.diamond2);
        this.showLonggu(this.weaponData.heroID);
        var godWeaponSys = MyData.user.json.godWeaponSys;
        var weaponSysData = godWeaponSys["weapon" + this.weaponData.id];
        this.weaponName.text = this.weaponData.name;
        this.skillLevel.text = "+" + weaponSysData.skillLevel;
        this.weaponLevel.text = "等级" + weaponSysData.level;
        for (var i = 0; i < this.skillTextList.length; i++) {
            var index = i + 1;
            var skillData = this.weaponData["skill" + index];
            var skillCfg = Common.getSkillNameBySkillId(skillData[0]);
            var color = weaponSysData.skillLevel >= (index * 8) ? Color.green : Color.white;
            this.skillTextList[i].text = "[color=" + color + "]\u6280\u80FD+ " + (index * 8) + " : " + skillCfg.name + " + " + (skillData[1] / 100) + "%[/color]";
        }
        if (this.c1Controller.selectedIndex == 0) {
            this.onClickChangeAttr();
        }
        else {
            this.onClickChangeSkill();
        }
    };
    GodWeaponSkillInfoView.prototype.itemonclick = function (e) {
        this.weaponData = e.itemObject.data;
        this.updateView();
    };
    /**更新列表 */
    GodWeaponSkillInfoView.prototype.updateList = function () {
        this.btnTitleList.removeChildrenToPool();
        var godWeaponTab = GodWeaponData.inst().getGodWeaponCfgList();
        for (var i = 0; i < godWeaponTab.size(); i++) {
            var godWeaponInfo = godWeaponTab.getRow(i);
            var id = godWeaponInfo.getValFromColName("id");
            var heroID = godWeaponInfo.getValFromColName("heroID");
            var name_23 = godWeaponInfo.getValFromColName("name");
            var skillName = godWeaponInfo.getValFromColName("skillName");
            var skillIcon = godWeaponInfo.getValFromColName("skillIcon");
            var icon = godWeaponInfo.getValFromColName("icon");
            var skill8 = godWeaponInfo.getValFromColName("skill8");
            var skill16 = godWeaponInfo.getValFromColName("skill16");
            var skill24 = godWeaponInfo.getValFromColName("skill24");
            var item = this.btnTitleList.addItemFromPool().asCom;
            item.getChild("itemname").asTextField.text = name_23;
            this.setLoaderUrl(item.getChild("icon").asLoader, icon);
            item.data = { id: id, heroID: heroID, name: name_23, skillName: skillName, skillIcon: skillIcon, skill1: skill8, skill2: skill16, skill3: skill24 };
        }
    };
    //龙骨显示
    GodWeaponSkillInfoView.prototype.showLonggu = function (heroID) {
        var objectContainer = new egret.DisplayObjectContainer(); //显示对象容器
        this.longgu.setNativeObject(objectContainer);
        var hero = new Hero(heroID).addToParent(objectContainer);
        hero.touchEnabled = true;
        this.onEgretEvent(hero, egret.TouchEvent.TOUCH_TAP, this.openView, this);
    };
    GodWeaponSkillInfoView.prototype.openView = function () {
        ak.FairyGUI.open(["GodWeaponInfoTipView", this.weaponData.id, 1]);
    };
    return GodWeaponSkillInfoView;
}(ak.EasyUI));
__reflect(GodWeaponSkillInfoView.prototype, "GodWeaponSkillInfoView");
//神器任务系统
var GodWeaponTaskViewSystem = (function (_super) {
    __extends(GodWeaponTaskViewSystem, _super);
    function GodWeaponTaskViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GodWeaponTaskViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("GodWeapon");
    };
    GodWeaponTaskViewSystem.inst = new GodWeaponTaskViewSystem("GodWeapon");
    return GodWeaponTaskViewSystem;
}(ak.FairyGUI));
__reflect(GodWeaponTaskViewSystem.prototype, "GodWeaponTaskViewSystem");
/**
 * 神器任务界面
 */
var GodWeaponTaskView = (function (_super) {
    __extends(GodWeaponTaskView, _super);
    function GodWeaponTaskView(weaponId) {
        var _this = _super.call(this, GodWeaponTaskViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
        _this.weaponId = 0;
        _this.weaponId = weaponId;
        return _this;
    }
    /**回调 */
    GodWeaponTaskView.prototype.onInit = function () {
        this.create("GodWeapon", "GodWeaponTaskView");
        this.closebtn = this.ui.getChild("closebtn").asButton;
        this.btnTuLongZhiLu = this.ui.getChild("btnTuLongZhiLu").asButton;
        this.btn_gotoAdventure = this.ui.getChild("btn_gotoAdventure").asButton;
        this.skillIconLoad = this.ui.getChild("skillIconLoad").asLoader;
        this.skillText = this.ui.getChild("skillText").asTextField;
        this.skillName = this.ui.getChild("skillName").asTextField;
        this.weaponName = this.ui.getChild("weaponName").asTextField;
        this.weaponTypeCtroller = this.ui.getController("weaponType");
        this.progressBar = this.ui.getChild("progressBar").asProgress;
        this.taskList = this.ui.getChild("taskList").asList;
        this.longgu = this.ui.getChild("longgu").asGraph;
        this.ClickAdd();
        TopViewSystem.show();
        this.updateWeaponInfo();
        this.updateView();
    };
    GodWeaponTaskView.prototype.ClickAdd = function () {
        this.addClickListener(this.closebtn, this.onClick, this);
        this.addClickListener(this.btnTuLongZhiLu, this.onClick, this);
        this.addClickListener(this.btn_gotoAdventure, this.onClick, this);
        this.onFairyguiEvent(this.taskList, fairygui.ItemEvent.CLICK, this.onClickItem, this);
    };
    GodWeaponTaskView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.closebtn:
                this.close();
                break;
            case this.btnTuLongZhiLu:
                ak.FairyGUI.open(["GodWeaponView"]);
                this.close();
            case this.btn_gotoAdventure:
                ak.EventMgr.dispatch(GameEvent.mainUIDownTab);
                this.close();
                break;
        }
    };
    //刷新神器信息
    GodWeaponTaskView.prototype.updateWeaponInfo = function () {
        var godWeaponInfo = GodWeaponData.inst().getDataByGodWeaponID(this.weaponId);
        this.setLoaderUrl(this.skillIconLoad, godWeaponInfo.getValFromColName("skillIcon"));
        this.skillName.text = godWeaponInfo.getValFromColName("skillName");
        this.weaponName.text = godWeaponInfo.getValFromColName("name");
        var godWeaponSys = MyData.user.json.godWeaponSys;
        this.showLonggu(godWeaponInfo.getValFromColName("heroID"));
        var skillLevel = godWeaponSys["weapon" + this.weaponId].skillLevel;
        var skillData = GodWeaponData.inst().getSkillDataByIdAndLevel(this.weaponId, skillLevel);
        this.skillText.text = skillData.getValFromColName("des");
    };
    //刷新任务列表
    GodWeaponTaskView.prototype.updateView = function () {
        this.weaponTypeCtroller.selectedIndex = this.weaponId - 1;
        var godWeaponSys = MyData.user.json.godWeaponSys;
        this.ui.getController("c1").selectedIndex = 0;
        var taskData = GodWeaponData.inst().getTaskListByGodWeaponID(this.weaponId);
        var count = 0;
        //=================冒险==================
        for (var i = 0; i < taskData.length; i++) {
            var id = taskData[i].getValFromColName("id");
            if (godWeaponSys.idMap[id] == 1) {
                count++;
            }
        }
        this.progressBar.max = taskData.length;
        this.progressBar.value = count;
        if (taskData.length == count) {
            this.ui.getController("c1").selectedIndex = 1;
            this.progressBar.getChild("title").asTextField.text = "已激活";
            var level = godWeaponSys["weapon" + this.weaponId].level;
            var godWeaponAttrInfo = GodWeaponData.inst().getAttrDataByIdAndLevel(this.weaponId, level + 1);
            this.ui.getChild("attr1").asTextField.text = "全队攻击+" + godWeaponAttrInfo.getValFromColName("atk");
            this.ui.getChild("attr2").asTextField.text = "全队生命+" + godWeaponAttrInfo.getValFromColName("hp");
            return;
        }
        //=================任务列表==================
        this.taskList.removeChildrenToPool();
        var achievementTask = MyData.user.json.achievementTask;
        var taskTypeList = [];
        taskTypeList[101] = MyData.user.level;
        taskTypeList[102] = achievementTask.heroStar4Count; //获得%0个4星英雄
        taskTypeList[103] = achievementTask.heroStar5Count; //获得%0个5星英雄
        taskTypeList[104] = achievementTask.heroStar6Count; //获得%0个6星英雄
        taskTypeList[105] = achievementTask.heroStar9Count; //获得%0个9星英雄
        taskTypeList[106] = achievementTask.heroDecomposeCount; //分解%0个英雄
        taskTypeList[107] = achievementTask.equColor3Count; //获得%0件紫色装备
        taskTypeList[108] = achievementTask.equColor4Count; //获得%0件橙色装备
        taskTypeList[109] = achievementTask.equColor5Count; //获得%0件红色装备
        taskTypeList[110] = achievementTask.stageWinCount; //自由竞技场胜%0次
        taskTypeList[111] = achievementTask.stageScore; //自由竞技场达到%0分
        taskTypeList[112] = achievementTask.pubTaskColor2Count; //完成蓝色悬赏任务%0次
        taskTypeList[113] = achievementTask.pubTaskColor3Count; //完成紫色悬赏%0次
        taskTypeList[114] = achievementTask.pubTaskColor4Count; //完成橙色悬赏任务%0次
        taskTypeList[115] = achievementTask.pubTaskColor5Count; //完成红色悬赏任务%0次
        taskTypeList[116] = achievementTask.friendSearchCount; //好友搜寻%0次敌人
        taskTypeList[117] = MyData.user.json.remoteBattle.battleMaxCount; //十字军通过第%0关
        taskTypeList[118] = achievementTask.wishPoolGetHeroStar5Count; //许愿获得%0次5星英雄
        taskTypeList[119] = achievementTask.worldTreeRandomCardCount; //在世界树召唤%0次
        taskTypeList[120] = achievementTask.heroStar10Count; //获得%0个10星英雄
        taskTypeList[121] = MyData.user.barrierID; //冒险通关层数
        taskTypeList[123] = achievementTask.dailyTaskCompleteCount; //完成日常任务次数
        taskTypeList[124] = achievementTask.hookGetResQuickCount; //进行快速探险次数
        taskTypeList[125] = achievementTask.stageReqBattleCount; //挑战自由竞技场次数
        taskTypeList[126] = achievementTask.wishNormalCount; //进行普通许愿次数
        taskTypeList[127] = achievementTask.joinOrCreateUnionCount; //加入或创建公会次数
        taskTypeList[128] = achievementTask.testCount; //挑战每日试炼次数
        taskTypeList[129] = achievementTask.marketBuyCount; //市场购买次数
        taskTypeList[130] = achievementTask.randomCardTopCount; //完成高级祭祀次数
        taskTypeList[131] = MyData.user.towerID; //爬塔通关层数
        taskTypeList[132] = achievementTask.pubTaskCount; //完成悬赏任务次数
        taskTypeList[133] = achievementTask.cardComposeCountByStar5OrStar6; //通过合成法阵合成一个5星或6星英雄次数
        for (var i = 0; i < taskData.length; i++) {
            var Item = this.taskList.addItemFromPool().asCom;
            var id = taskData[i].getValFromColName("id");
            var type = taskData[i].getValFromColName("type");
            var num = taskData[i].getValFromColName("num");
            var drop = taskData[i].getValFromColName("drop");
            var jump = taskData[i].getValFromColName("jump");
            var taskInfo = Common.getTaskDataByTaskId(type);
            var itemlist_cfg = ItemMgr.getDropGroupByID(Number(drop));
            for (var j = 0; j < itemlist_cfg.length; j++) {
                var item_type = itemlist_cfg[j][1];
                var item_id = itemlist_cfg[j][2];
                var item_count = itemlist_cfg[j][3];
                this.flushtem(Item.getChild("itemCom").asCom, item_id, item_count, item_type);
            }
            Item.getChild("taskDes").asTextField.text = ak.strFormat(taskInfo.text, num);
            var c1Controller = Item.getController("c1");
            if (type == 122) {
                c1Controller.selectedIndex = godWeaponSys.idMap[id] != 1 ? 0 : 1;
                ;
                if (godWeaponSys.idMap[id] != 1) {
                    var cardArr = MyData.user.json.cardArr;
                    for (var i_7 = 0; i_7 < cardArr.length; i_7++) {
                        if (cardArr[i_7].level >= num) {
                            c1Controller.selectedIndex = 1;
                            break;
                        }
                    }
                }
            }
            else if (type == 121) {
                c1Controller.selectedIndex = (taskTypeList[type] || 0) > num ? 1 : 0;
            }
            else {
                c1Controller.selectedIndex = (taskTypeList[type] || 0) >= num ? 1 : 0;
            }
            var btn_lingqu = Item.getChild("btn_lingqu").asButton;
            btn_lingqu.data = { id: id };
            Item.getChild("btn_goto").asButton.data = { open: jump.open };
            if (godWeaponSys.idMap[id] > 0) {
                btn_lingqu.enabled = false;
                Item.getChild("redPoint").asImage.visible = false;
            }
        }
    };
    //刷新道具物品
    GodWeaponTaskView.prototype.flushtem = function (itemCom, item_id, item_count, item_type) {
        var itemBase = new ItemBase(itemCom, this, item_type);
        itemBase.setItemData(Number(item_id));
        itemBase.setNumber(item_count, true);
        itemCom.data = { item_id: item_id, item_count: item_count, item_type: item_type };
    };
    //点击物品框
    GodWeaponTaskView.prototype.onClickItem = function (obj) {
        var Item = obj.itemObject;
        var itemCom = Item.getChild("itemCom").asCom;
        var btn_lingqu = Item.getChild("btn_lingqu").asButton;
        var btn_goto = Item.getChild("btn_goto").asButton;
        if (this.hitTestPointWithFairyGUIComponent(itemCom, obj.stageX, obj.stageY)) {
            var itemData = itemCom.data;
            if (itemData.item_type == 3)
                ak.FairyGUI.open(["ResourceTipsView", itemData.item_id, itemData.item_count]);
            else
                ak.FairyGUI.open(["WeaponTipsView", itemData.item_id, itemData.item_count, itemData.item_type]);
        }
        else if (this.hitTestPointWithFairyGUIComponent(btn_lingqu, obj.stageX, obj.stageY)) {
            net.godWeaponTask(btn_lingqu.data.id, this.updateView, this);
        }
        else if (this.hitTestPointWithFairyGUIComponent(btn_goto, obj.stageX, obj.stageY)) {
            var data = btn_goto.data;
            this.close();
            if (data.open[0] == "ExplorationView") {
                ak.EventMgr.dispatch(GameEvent.mainUIDownTab);
            }
            else if (data.open[0] == "GuildView") {
                ak.EventMgr.dispatch(GameEvent.changeGuild);
            }
            else if (data.open[0] == "HeroBagView") {
                ak.EventMgr.dispatch(GameEvent.changeHeroBag);
            }
            else {
                ak.FairyGUI.open(data.open);
            }
        }
    };
    //龙骨显示
    GodWeaponTaskView.prototype.showLonggu = function (heroID) {
        var objectContainer = new egret.DisplayObjectContainer(); //显示对象容器
        this.longgu.setNativeObject(objectContainer);
        var hero = new Hero(heroID).addToParent(objectContainer);
        hero.touchEnabled = true;
        this.onEgretEvent(hero, egret.TouchEvent.TOUCH_TAP, this.openView, this);
    };
    GodWeaponTaskView.prototype.openView = function () {
        ak.FairyGUI.open(["GodWeaponInfoTipView", this.weaponId, 0]);
    };
    return GodWeaponTaskView;
}(ak.EasyUI));
__reflect(GodWeaponTaskView.prototype, "GodWeaponTaskView");
//神器界面系统
var GodWeaponViewSystem = (function (_super) {
    __extends(GodWeaponViewSystem, _super);
    function GodWeaponViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GodWeaponViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("GodWeapon");
    };
    GodWeaponViewSystem.inst = new GodWeaponViewSystem("GodWeapon");
    return GodWeaponViewSystem;
}(ak.FairyGUI));
__reflect(GodWeaponViewSystem.prototype, "GodWeaponViewSystem");
/**
 * 神器界面
 */
var GodWeaponView = (function (_super) {
    __extends(GodWeaponView, _super);
    function GodWeaponView() {
        var _this = _super.call(this, GodWeaponViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.GodWeaponItemList = [];
        return _this;
    }
    /**回调 */
    GodWeaponView.prototype.onInit = function () {
        this.create("GodWeapon", "GodWeaponView");
        this.closebtn = this.ui.getChild("closebtn").asButton;
        var godWeaponSys = MyData.user.json.godWeaponSys;
        for (var i = 0; i < 5; i++) {
            this.GodWeaponItemList[i] = this.ui.getChild("GodWeaponItem" + i).asCom;
            this.GodWeaponItemList[i].getController("c1").selectedIndex = i;
            this.addClickListener(this.GodWeaponItemList[i], this.onClickGodWeaponItem, this);
        }
        this.ClickAdd();
        this.updateView();
    };
    GodWeaponView.prototype.ClickAdd = function () {
        this.addClickListener(this.closebtn, this.onClick, this);
    };
    GodWeaponView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.closebtn:
                this.close();
                break;
        }
    };
    //点击神器
    GodWeaponView.prototype.onClickGodWeaponItem = function (e) {
        ak.FairyGUI.open(["GodWeaponTaskView", e.target.data.id]);
        this.close();
    };
    GodWeaponView.prototype.updateView = function () {
        var godWeaponSys = MyData.user.json.godWeaponSys;
        var godWeaponTab = GodWeaponData.inst().getGodWeaponCfgList();
        for (var i = 0; i < this.GodWeaponItemList.length; i++) {
            var godWeaponInfo = godWeaponTab.getRow(i);
            var id = godWeaponInfo.getValFromColName("id");
            var is_act = i == 0 || godWeaponSys.activeCount >= i;
            this.GodWeaponItemList[i].enabled = is_act;
            this.GodWeaponItemList[i].data = { id: id };
            var red_visiable = false;
            if (is_act == true) {
                red_visiable = RedDotMgr.singGodWeaponTaskCompleteRedDot(id);
            }
            this.GodWeaponItemList[i].getChild("redPoint").asImage.visible = red_visiable;
        }
    };
    return GodWeaponView;
}(ak.EasyUI));
__reflect(GodWeaponView.prototype, "GodWeaponView");
/**
 * 我要变强数据
 */
var GrowupData = (function () {
    function GrowupData() {
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    GrowupData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new GrowupData();
        }
        return Class._instance;
    };
    /**
     * 获得类型列表数据
     */
    GrowupData.prototype.getStringTypeInfo = function () {
        var strongTypeTab = ak.JsonTableMgr.get("strongType");
        var infoarr = [];
        for (var i = 0; i < strongTypeTab.size(); i++) {
            var strongTypeInfo = strongTypeTab.getRow(i);
            var id = strongTypeInfo.getValFromColName("id");
            var name_24 = strongTypeInfo.getValFromColName("name");
            var info = [id, name_24];
            infoarr.push(info);
        }
        return infoarr;
    };
    /**根据类型获得该类型全部信息 */
    GrowupData.prototype.getStrongTypeInfo = function (type) {
        var strongTab = ak.JsonTableMgr.get("strong");
        var infoarr = [];
        var returninfoarr = [];
        infoarr = strongTab.getRowsFromColName("type", String(type));
        for (var i = 0; i < infoarr.length; i++) {
            var id = infoarr[i].getValFromColName("id");
            var name_25 = infoarr[i].getValFromColName("name");
            var jump = infoarr[i].getValFromColName("jump");
            var systemID = infoarr[i].getValFromColName("systemID");
            returninfoarr.push([id, name_25, jump, systemID]);
        }
        return returninfoarr;
    };
    return GrowupData;
}());
__reflect(GrowupData.prototype, "GrowupData");
var GrowupViewSystem = (function (_super) {
    __extends(GrowupViewSystem, _super);
    function GrowupViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GrowupViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("GrowupView");
    };
    GrowupViewSystem.inst = new GrowupViewSystem("GrowupView");
    return GrowupViewSystem;
}(ak.FairyGUI));
__reflect(GrowupViewSystem.prototype, "GrowupViewSystem");
/**
 * 我要变强
 * 界面
 */
var GrowupView = (function (_super) {
    __extends(GrowupView, _super);
    function GrowupView() {
        var _this = _super.call(this, GrowupViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.nowID = 1;
        return _this;
    }
    /**回调 */
    GrowupView.prototype.onInit = function () {
        var ui = this.create("GrowupView", "GrowupView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.list = ui.getChild("list").asList;
        this.titlelist = ui.getChild("titlelist").asList;
        this.nowID = 1;
        this.ClickAdd();
        this.updatetitleList();
        this.updateList();
    };
    GrowupView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.onFairyguiEvent(this.list, fairygui.ItemEvent.CLICK, this.listTouchHandle, this);
        this.onFairyguiEvent(this.titlelist, fairygui.ItemEvent.CLICK, this.titlelistTouchHandle, this);
    };
    GrowupView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
        }
    };
    GrowupView.prototype.listTouchHandle = function (obj) {
        var item = obj.itemObject;
        /**前往 */
        if (this.hitTestPointWithFairyGUIComponent(item.getChild("gobtn").asButton, obj.stageX, obj.stageY)) {
            //跳转操作
            //等级判断
            if (item.data.systemID == 0 || GameSystem.isSysOpen(item.data.systemID, true)) {
                this.close();
                var info_8 = WeaponTipsData.inst().GetWayInfoyByWayId(item.data.jump);
                if (info_8.type == 0) {
                    //判断是否在主界面上面
                    if (info_8.isMainUI == 1) {
                        if (MyGame.inst.uiLayer.numChildren > 0) {
                            var ui_2 = MyGame.inst.uiLayer.getChildAt(MyGame.inst.uiLayer.numChildren - 1);
                            egret.Tween.get(ui_2).wait(50).call(function () {
                                ui_2.parent.removeChild(ui_2);
                                ak.FairyGUI.getOpenUI("DownView")[0].ui.getController("c1").selectedIndex = 0;
                                ak.FairyGUI.open(info_8.jump["open"]);
                            }, this);
                        }
                        else {
                            ak.FairyGUI.getOpenUI("DownView")[0].ui.getController("c1").selectedIndex = 0;
                            ak.FairyGUI.open(info_8.jump["open"]);
                        }
                    }
                    else {
                        ak.FairyGUI.open(info_8.jump["open"]);
                    }
                }
                else {
                    if (item.data.systemID == 10) {
                        if (MyGame.inst.uiLayer.numChildren > 0) {
                            var ui_3 = MyGame.inst.uiLayer.getChildAt(MyGame.inst.uiLayer.numChildren - 1);
                            egret.Tween.get(ui_3).wait(50).call(function () {
                                ui_3.parent.removeChild(ui_3);
                                ak.FairyGUI.getOpenUI("DownView")[0].ui.getController("c1").selectedIndex = info_8.type;
                                if (MyData.user.unionID != null && MyData.user.unionID != 0) {
                                    ak.FairyGUI.open(["GuildView"]);
                                }
                                else {
                                    ak.FairyGUI.open(["GuildCreateView"]);
                                }
                            }, this);
                        }
                        else {
                            ak.FairyGUI.getOpenUI("DownView")[0].ui.getController("c1").selectedIndex = info_8.type;
                            if (MyData.user.unionID != null && MyData.user.unionID != 0) {
                                ak.FairyGUI.open(["GuildView"]);
                            }
                            else {
                                ak.FairyGUI.open(["GuildCreateView"]);
                            }
                        }
                    }
                    else {
                        if (MyGame.inst.uiLayer.numChildren > 0) {
                            var ui_4 = MyGame.inst.uiLayer.getChildAt(MyGame.inst.uiLayer.numChildren - 1);
                            egret.Tween.get(ui_4).wait(50).call(function () {
                                ui_4.parent.removeChild(ui_4);
                                ak.FairyGUI.getOpenUI("DownView")[0].ui.getController("c1").selectedIndex = info_8.type;
                                ak.FairyGUI.open(info_8.jump["open"]);
                            }, this);
                        }
                        else {
                            ak.FairyGUI.getOpenUI("DownView")[0].ui.getController("c1").selectedIndex = info_8.type;
                            ak.FairyGUI.open(info_8.jump["open"]);
                        }
                    }
                }
            }
        }
    };
    GrowupView.prototype.titlelistTouchHandle = function (obj) {
        var item = obj.itemObject;
        this.nowID = item.data.id;
        for (var i = 0; i < this.titlelist.numItems; i++) {
            if (item.data.id == this.titlelist.getChildAt(i).data.id) {
                this.titlelist.getChildAt(i).asCom.getController("button").selectedIndex = 1;
            }
            else {
                this.titlelist.getChildAt(i).asCom.getController("button").selectedIndex = 0;
            }
        }
        this.updateList();
    };
    GrowupView.prototype.updateList = function () {
        this.list.removeChildrenToPool();
        var infoarr = GrowupData.inst().getStrongTypeInfo(this.nowID);
        for (var i = 0; i < infoarr.length; i++) {
            var item = this.list.addItemFromPool().asCom;
            var titletxt = item.getChild("titletxt").asTextField;
            var gobtn = item.getChild("gobtn").asButton;
            titletxt.text = "" + infoarr[i][1];
            item.data = { id: infoarr[i][0], jump: infoarr[i][2], systemID: infoarr[i][3] };
            if (infoarr[i][2] == 0) {
                gobtn.visible = false;
            }
            else {
                gobtn.visible = true;
            }
        }
    };
    GrowupView.prototype.updatetitleList = function () {
        this.titlelist.removeChildrenToPool();
        var infoarr = GrowupData.inst().getStringTypeInfo();
        for (var i = 0; i < infoarr.length; i++) {
            var item = this.titlelist.addItemFromPool().asCom;
            var title = item.getChild("title").asTextField;
            title.text = "" + infoarr[i][1];
            item.data = { id: infoarr[i][0] };
        }
        this.titlelist.getChildAt(0).asCom.getController("button").selectedIndex = 1;
    };
    return GrowupView;
}(ak.EasyUI));
__reflect(GrowupView.prototype, "GrowupView");
//公会boss挑战排行榜
var AdventureRankingSystem = (function (_super) {
    __extends(AdventureRankingSystem, _super);
    function AdventureRankingSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    AdventureRankingSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guild");
    };
    AdventureRankingSystem.inst = new AdventureRankingSystem("Guild");
    return AdventureRankingSystem;
}(ak.FairyGUI));
__reflect(AdventureRankingSystem.prototype, "AdventureRankingSystem");
var AdventureRanking = (function (_super) {
    __extends(AdventureRanking, _super);
    function AdventureRanking(bossID, bossheadID, index, bg) {
        var _this = _super.call(this, AdventureRankingSystem.inst, MyGame.inst.uiLayer2_1) || this;
        //private userID:any[]=[];//bossID数组
        _this.bossID = 0;
        _this.bossheadID = 0;
        _this.bossID = bossID;
        _this.bossheadID = bossheadID;
        _this.index = index;
        _this.bossbg = bg;
        return _this;
    }
    AdventureRanking.prototype.onInit = function () {
        this.ui = this.create("Guild", "AdventureRanking");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.challengeBtn = this.ui.getChild("challengeBtn").asButton;
        this.bloodbar = this.ui.getChild("bloodbar").asProgress;
        this.revivetime = this.ui.getChild("time").asTextField;
        this.list0 = this.ui.getChild("n10").asList;
        this.list1 = this.ui.getChild("n24").asList;
        this.myranking = this.ui.getChild("myranking").asTextField;
        this.mydamage = this.ui.getChild("mydamage").asTextField;
        this.myrankingtext = this.ui.getChild("ranktext").asTextField;
        this.mydamagetext = this.ui.getChild("damagetext").asTextField;
        this.bosshead = this.ui.getChild("role").asCom;
        this.helpTip = this.ui.getChild("helpBtn").asButton;
        this.titlelabel = this.ui.getChild("titlelabel").asLabel;
        this.guildBossTab = ak.JsonTableMgr.get("guildBoss");
        this.isnull = this.ui.getController("c2");
        this.guildConfig = ak.JsonTableMgr.get("guildConfig");
        var guildInfo = this.guildConfig.getRow(0);
        this.bossMax = guildInfo.getValFromColName("bossMax");
        this.zs = guildInfo.getValFromColName("zs");
        this.ui.getController("c1").selectedIndex = this.index;
        this.updateview1();
        this.clickAdd();
    };
    //请求
    AdventureRanking.prototype.updateview1 = function () {
        net.myUnionInfo(this.updateview, this);
    };
    AdventureRanking.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.challengeBtn, this.onClick, this);
        this.addClickListener(this.helpTip, this.onClick, this);
        if (this.index != 1 && MyData.user.json.unionInfo.hitBossMap[MyData.myUnionInfo.json.bossID] > 0)
            this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.timedown, this);
        this.onFairyguiEvent(this.list0, fairygui.ItemEvent.CLICK, this.onClickItem, this);
        this.onFairyguiEvent(this.list1, fairygui.ItemEvent.CLICK, this.onClickItem, this);
    };
    AdventureRanking.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.challengeBtn:
                ak.FairyGUI.open(["FightReadyView", 8, this.bossID]);
                this.close();
                break;
            case this.helpTip:
                ak.FairyGUI.open(["AdventureRankingAwardView", this.bossID]);
                break;
        }
    };
    AdventureRanking.prototype.timedown = function () {
        var time = DateUtils.getWeeHours12Time() - ak.time();
        var text = DateUtils.getFormatBySecond(time, DateUtils.TIME_FORMAT_12);
        this.revivetime.text = "\u590D\u6D3B\u5012\u8BA1\u65F6\uFF1A" + ("[color=" + Color.green + "]" + text + "[/color]");
        if (time == 0) {
            this.revivetime.text = '';
        }
    };
    //头像点击事件
    AdventureRanking.prototype.onClickItem = function (obj) {
        var item = obj.itemObject;
        var itemCom = item.getChild("useritem").asCom;
        if (this.hitTestPointWithFairyGUIComponent(itemCom, obj.stageX, obj.stageY)) {
            net.getRoleBaseInfo(item.data.userID, function (msg) {
                ak.FairyGUI.open(["LookupInfoView", item.data.userID, msg]);
            }, this);
        }
    };
    //资源点击事件
    AdventureRanking.prototype.itemonclick = function (e) {
        var awarditem = e.itemObject.data;
        if (awarditem.type == 3)
            ak.FairyGUI.open(["ResourceTipsView", awarditem.id, awarditem.num]);
        else
            ak.FairyGUI.open(["WeaponTipsView", awarditem.id, awarditem.num, awarditem.type]);
    };
    //设置list
    AdventureRanking.prototype.setView = function (list, index, selectedindex) {
        if (selectedindex === void 0) { selectedindex = null; }
        list.removeChildrenToPool();
        var arr = Object.keys(MyData.myUnionInfo.json.bossMap[index].hurtMap);
        var arrCount = arr.length;
        this.isnull.selectedIndex = arrCount > 0 ? 1 : 0;
        var newArr = arr.map(Number);
        var it = MyData.myUnionInfo.json.bossMap[index].hurtMap;
        if (arrCount > 1) {
            for (var i = 0; i < arrCount - 1; i++) {
                for (var j = 0; j < arr.length - 1 - i; j++) {
                    var index1 = newArr[j];
                    var index2 = newArr[j + 1];
                    if (it[index1].hurt < it[index2].hurt) {
                        var temp = newArr[j];
                        newArr[j] = newArr[j + 1];
                        newArr[j + 1] = temp;
                    }
                }
            }
        }
        for (var i = 0; i < arrCount; i++) {
            var Frame = list.addItemFromPool().asCom;
            var BossInfoHp = MyData.myUnionInfo.json.bossMap[index].hpMax;
            var BossHurtUserInfo = MyData.myUnionInfo.json.bossMap[index].hurtMap[newArr[i]];
            var useritem = Frame.getChild("useritem").asCom;
            var username = Frame.getChild("username").asTextField;
            var userdamage = Frame.getChild("damage").asTextField;
            var userranktext = Frame.getChild("ranknum").asTextField;
            var userbloodbar = Frame.getChild("blood").asProgress;
            var guildbossprize = this.guildBossTab.getRow(index - 1);
            var killPrize = guildbossprize.getValFromColName("killPrize");
            var awardlist = Frame.getChild("awardlist").asList;
            for (var j = 0; j < killPrize.length / 2; j++) {
                //判断玩家是否有击杀奖励
                if (i + 1 > killPrize[killPrize.length - 2][1])
                    break;
                else {
                    var killnumber = killPrize[j * 2];
                    if (killnumber[0] == killnumber[1] && i + 1 == killnumber[0]) {
                        //参数 1.item 2.物品id 3.物品类型 4.物品数量
                        //killPrize为二维数组 分为区间 奖励  0金币 1奖励物品ID 2奖励数量 
                        this.setPrizelist(awardlist, killPrize[j * 2 + 1][0], killPrize[j * 2 + 1][1], killPrize[j * 2 + 1][2]);
                    }
                    else {
                        if (i + 1 >= killnumber[0] && i + 1 <= killnumber[1]) {
                            this.setPrizelist(awardlist, killPrize[j * 2 + 1][0], killPrize[j * 2 + 1][1], killPrize[j * 2 + 1][2]);
                        }
                    }
                }
            }
            var bloodController = Frame.getController("c2");
            bloodController.selectedIndex = selectedindex;
            // let	usericon=Frame.getChild("icon").asLoader;
            var userheadID = BossHurtUserInfo.head;
            var role_data = [];
            role_data["userID"] = arr[i];
            Frame.data = role_data;
            username.text = BossHurtUserInfo.nickname;
            if (bloodController.selectedIndex != 1) {
                userdamage.text = BossHurtUserInfo.hurt;
                Common.labelIsOverLenght(userdamage, userdamage.text);
            }
            else {
                userbloodbar.value = BossHurtUserInfo.hurt;
                userbloodbar.max = BossInfoHp;
                var bloodtext = userbloodbar.getChild("title").asTextField;
                bloodtext.text = Common.overLength(userbloodbar.value);
            }
            var itemBase = new ItemBase(useritem, this, 2);
            itemBase.setIcons2("hero" + userheadID);
            if (i == 0 || i == 1 || i == 2) {
                Frame.getController("c1").selectedIndex = i + 1;
            }
            else
                userranktext.text = i + 1 + "";
            if (newArr[i] == MyData.user.id) {
                this.myranking.text = "我 的 排 位：";
                this.myrankingtext.text = (i + 1).toString();
            }
        }
    };
    //击杀奖励列表
    AdventureRanking.prototype.setPrizelist = function (awardlist, killPrize1count, killPrize2ID, killPrize2count) {
        awardlist.removeChildrenToPool();
        for (var i = 0; i < 2; i++) {
            var prizeinfo = awardlist.addItemFromPool().asCom;
            if (i == 0) {
                this.setItemBase(prizeinfo, 2, 3, killPrize1count);
                prizeinfo.data = { id: 2, type: 3, num: killPrize1count };
            }
            else {
                this.setItemBase(prizeinfo, killPrize2ID, 1, killPrize2count);
                prizeinfo.data = { id: killPrize2ID, type: 1, num: killPrize2count };
            }
        }
        this.onFairyguiEvent(awardlist, fairygui.ItemEvent.CLICK, this.itemonclick, this);
    };
    //设置itembase 参数 1.item 2.物品id 3.物品类型 4.物品数量
    AdventureRanking.prototype.setItemBase = function (item, id, type, count) {
        var awardItemBase = new ItemBase(item, this, type);
        awardItemBase.setItemData(id);
        awardItemBase.setNumber(count, true);
    };
    //update更新界面
    AdventureRanking.prototype.updateview = function () {
        this.bosshead.getChild("n2").text = this.bossID.toString();
        var nowbossID = MyData.myUnionInfo.json.bossID; //当前挑战到的 bossID
        var bossMap = MyData.myUnionInfo.json.bossMap[nowbossID]; //获取当前boss map
        var userID = MyData.user.id;
        var titletext = this.titlelabel.getChild("title").asTextField;
        if (this.index != 1) {
            titletext.text = "副本首领";
            if (MyData.user.json.unionInfo.hitBossMap[nowbossID] == null) {
                this.challengeBtn.enabled = true;
                this.challengeBtn.getChild("number").text = this.zs[0];
                this.challengeBtn.getChild("title").text = "挑战";
            }
            else {
                if (MyData.user.json.unionInfo.hitBossMap[nowbossID] < this.bossMax) {
                    this.challengeBtn.enabled = true;
                    this.challengeBtn.getChild("number").text = this.zs[MyData.user.json.unionInfo.hitBossMap[nowbossID]];
                    this.challengeBtn.getChild("title").text = "复活";
                }
                if (MyData.user.json.unionInfo.hitBossMap[nowbossID] == this.bossMax) {
                    this.challengeBtn.getChild("number").text = '';
                    this.challengeBtn.getChild("title").text = "复活";
                    this.challengeBtn.enabled = false;
                }
            }
            //血量计算
            var hp = bossMap.hp; //现有血量
            var hpMax = bossMap.hpMax; //满血
            this.bloodbar.max = hpMax;
            this.bloodbar.value = hp;
            if (hp % hpMax != 0) {
                this.isnull.selectedIndex = 1;
            }
            var bar = (hp / hpMax * 100).toFixed(2);
            this.bloodbar.getChild("title").text = bar.toString() + "%";
            this.setView(this.list0, nowbossID, 0);
        }
        else {
            titletext.text = "伤害排行";
            this.isnull.selectedIndex = 1;
            this.setView(this.list1, this.bossID, 1);
        }
        if (MyData.myUnionInfo.json.bossMap[this.bossID].hurtMap[userID] != null) {
            this.mydamage.text = "我 的 伤 害：";
            this.mydamagetext.text = (MyData.myUnionInfo.json.bossMap[this.bossID].hurtMap[userID].hurt).toString(); //当前boss伤害血量
            Common.labelIsOverLenght(this.mydamagetext, this.mydamagetext.text);
        }
        else {
            this.mydamage.text = "我 的 伤 害：";
            this.mydamagetext.text = "0";
            this.myranking.text = "我 的 排 位：";
            this.myrankingtext.text = "未上榜";
        }
        this.setLoaderUrl(this.bosshead.getChild("icon").asLoader, this.bossheadID + "_png");
        this.setLoaderUrl(this.bosshead.getChild("icon0").asLoader, "zhongzu_" + this.bossbg + "_png");
    };
    return AdventureRanking;
}(ak.EasyUI));
__reflect(AdventureRanking.prototype, "AdventureRanking");
//击杀奖励预览界面
var AdventureRankingAwardViewSystem = (function (_super) {
    __extends(AdventureRankingAwardViewSystem, _super);
    function AdventureRankingAwardViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    AdventureRankingAwardViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guild");
    };
    AdventureRankingAwardViewSystem.inst = new AdventureRankingAwardViewSystem("Guild");
    return AdventureRankingAwardViewSystem;
}(ak.FairyGUI));
__reflect(AdventureRankingAwardViewSystem.prototype, "AdventureRankingAwardViewSystem");
var AdventureRankingAwardView = (function (_super) {
    __extends(AdventureRankingAwardView, _super);
    function AdventureRankingAwardView(boosID) {
        var _this = _super.call(this, AdventureRankingAwardViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
        _this.bossID = boosID;
        return _this;
    }
    AdventureRankingAwardView.prototype.onInit = function () {
        this.ui = this.create("Guild", "AdventureRankingAwardView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.moneyItem = this.ui.getChild("n9").asCom;
        this.gongxianItem = this.ui.getChild("n10").asCom;
        this.overkilllist = this.ui.getChild("n12").asList;
        this.guildBossTab = ak.JsonTableMgr.get("guildBoss");
        this.clickAdd();
        this.updateView();
    };
    AdventureRankingAwardView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.moneyItem, this.onTouchItemEvent, this);
        this.addClickListener(this.gongxianItem, this.onTouchItemEvent, this);
        this.onFairyguiEvent(this.overkilllist, fairygui.ItemEvent.CLICK, this.onClickItem, this);
    };
    AdventureRankingAwardView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
        }
    };
    AdventureRankingAwardView.prototype.updateView = function () {
        var info = this.guildBossTab.getRow(this.bossID - 1);
        var gold = info.getValFromColName("gold");
        var itemID = info.getValFromColName("item");
        var itemnum = info.getValFromColName("num");
        var killPrize = info.getValFromColName("killPrize");
        this.setitembase(this.moneyItem, 3, 2, gold);
        this.moneyItem.data = { id: 2, type: 3, num: gold };
        this.setitembase(this.gongxianItem, 1, itemID, itemnum);
        this.gongxianItem.data = { id: itemID, type: 1, num: itemnum };
        this.overkilllist.removeChildrenToPool();
        var count = killPrize.length / 2;
        for (var i = 0; i < count; i++) {
            var Frame = this.overkilllist.addItemFromPool().asCom;
            var killnumber = killPrize[i * 2];
            var rankprize1 = Frame.getChild("n5").asCom;
            var rankprize2 = Frame.getChild("n6").asCom;
            if (killnumber[0] == killnumber[1]) {
                Frame.getController("c1").selectedIndex = i;
                this.setitembase(rankprize1, 3, 2, killPrize[i * 2 + 1][0]);
                this.setitembase(rankprize2, 1, killPrize[i * 2 + 1][1], killPrize[i * 2 + 1][2]);
            }
            else {
                Frame.getController("c1").selectedIndex = 3;
                var rankText = Frame.getChild("ranknum").asTextField;
                var rank1 = killPrize[i * 2][0];
                var rank2 = killPrize[i * 2][1];
                rankText.text = rank1 + "-" + rank2;
                this.setitembase(rankprize1, 3, 2, killPrize[i * 2 + 1][0]);
                this.setitembase(rankprize2, 1, killPrize[i * 2 + 1][1], killPrize[i * 2 + 1][2]);
            }
            rankprize1.data = { id: 2, type: 3, num: killPrize[i * 2 + 1][0] };
            rankprize2.data = { id: killPrize[i * 2 + 1][1], type: 1, num: killPrize[i * 2 + 1][2] };
        }
    };
    AdventureRankingAwardView.prototype.setitembase = function (item, type, ID, count) {
        var itemBase = new ItemBase(item, this, type);
        itemBase.setItemData(ID);
        itemBase.setNumber(count, true);
    };
    AdventureRankingAwardView.prototype.onClickItem = function (obj) {
        var item = obj.itemObject;
        var moneyCom = item.getChild("n5").asCom;
        var gongxianCom = item.getChild("n6").asCom;
        if (this.hitTestPointWithFairyGUIComponent(moneyCom, obj.stageX, obj.stageY)) {
            if (moneyCom.data.type != 3) {
                ak.FairyGUI.open(["WeaponTipsView", moneyCom.data.id, moneyCom.data.num, 1]);
            }
            else {
                ak.FairyGUI.open(["ResourceTipsView", moneyCom.data.id, moneyCom.data.num]);
            }
        }
        if (this.hitTestPointWithFairyGUIComponent(gongxianCom, obj.stageX, obj.stageY)) {
            if (gongxianCom.data.type != 3) {
                ak.FairyGUI.open(["WeaponTipsView", gongxianCom.data.id, gongxianCom.data.num, 1]);
            }
            else {
                ak.FairyGUI.open(["ResourceTipsView", gongxianCom.data.id, gongxianCom.data.num]);
            }
        }
    };
    AdventureRankingAwardView.prototype.onTouchItemEvent = function (e) {
        if (e.target.data.type != 3)
            ak.FairyGUI.open(["WeaponTipsView", e.target.data.id, e.target.data.num, 1]);
        else
            ak.FairyGUI.open(["ResourceTipsView", e.target.data.id, e.target.data.num]);
    };
    return AdventureRankingAwardView;
}(ak.EasyUI));
__reflect(AdventureRankingAwardView.prototype, "AdventureRankingAwardView");
//公会冒险
var GuildAdventureSystem = (function (_super) {
    __extends(GuildAdventureSystem, _super);
    function GuildAdventureSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GuildAdventureSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guild");
    };
    GuildAdventureSystem.inst = new GuildAdventureSystem("Guild");
    return GuildAdventureSystem;
}(ak.FairyGUI));
__reflect(GuildAdventureSystem.prototype, "GuildAdventureSystem");
var GuildAdventureView = (function (_super) {
    __extends(GuildAdventureView, _super);
    function GuildAdventureView() {
        var _this = _super.call(this, GuildAdventureSystem.inst, MyGame.inst.uiLayer2_1) || this;
        _this.boss_list = []; //boss控件
        _this.boss_loaderlist = []; //点击loader
        _this.bossIDlist = []; //bossID数组
        _this.waitingtime = []; //等待时间数组
        _this.isClear = false; //是否通关当前页boss
        _this.isKill = false; //是否已经开杀
        _this.heroNode = [];
        return _this;
    }
    GuildAdventureView.prototype.onInit = function () {
        var ui = this.create("Guild", "GuildAdventureView");
        this.backBtn = this.ui.getChild("closebtn").asButton;
        this.leftarrow = this.ui.getChild("left").asButton;
        this.rightarrow = this.ui.getChild("right").asButton;
        this.help = this.ui.getChild("help").asButton;
        this.titileLabel = this.ui.getChild("title").asLabel;
        // this.on("netmsg://union/hitUnionBossResult",(netmsg)=>{
        //     if(netmsg.params[2][0]==-4)
        //         this.updateview1();
        // },this);
        this.on(GameEvent.fightRpcComplete, this.updateview1, this);
        for (var i = 1; i <= 5; i++) {
            this.boss_list[i] = ui.getChild("n" + i).asCom;
            this.boss_loaderlist.push(this.boss_list[i].getChild("n3").asLoader);
            this.waitingtime[i] = this.boss_list[i].getChild("n5").asTextField;
        }
        this.guildboss = ak.JsonTableMgr.get("guildBoss");
        this.curPageNum = 1;
        this.maxPage = this.guildboss.size() / 5;
        this.clickAdd();
        this.updateview1();
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.timedown, this);
    };
    GuildAdventureView.prototype.onDestroy = function () {
        this.oneIn = null;
    };
    GuildAdventureView.prototype.updateview1 = function () {
        net.myUnionInfo(this.updateView, this);
    };
    GuildAdventureView.prototype.clickAdd = function () {
        this.addClickListener(this.backBtn, this.onClick, this);
        this.addClickListener(this.help, this.onClick, this);
        this.addClickListener(this.rightarrow, this.onClick, this);
        this.addClickListener(this.leftarrow, this.onClick, this);
        for (var i = 0; i < this.boss_loaderlist.length; i++) {
            this.addClickListener(this.boss_loaderlist[i], this.openview, this);
        }
    };
    GuildAdventureView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.backBtn:
                this.close();
                break;
            case this.help:
                ak.FairyGUI.open(["HelpTipsView", 9]);
                break;
            case this.rightarrow:
                if (this.isClear) {
                    this.Downpage();
                }
                else {
                    TipsViewSystem.show("请先通关前置关卡");
                }
                break;
            case this.leftarrow:
                this.Uppage();
                break;
        }
    };
    GuildAdventureView.prototype.updateView = function () {
        if (this.oneIn == null) {
            this.curPageNum = Math.floor((MyData.myUnionInfo.json.bossID - 1) / 5) + 1;
            this.oneIn = true;
        }
        var itemShowCount = 5;
        var bossID = MyData.myUnionInfo.json.bossID;
        var hitBossMap = MyData.user.json.unionInfo.hitBossMap;
        var bossMap = MyData.myUnionInfo.json.bossMap;
        this.isClear = false;
        for (var i = 0; i < itemShowCount; i++) {
            this.index = (this.curPageNum - 1) * itemShowCount + i;
            var guildbossInfo = this.guildboss.getRow(this.index);
            var guildbossID = guildbossInfo.getValFromColName("id");
            var heroID = guildbossInfo.getValFromColName("heroID");
            this.bossIDlist = heroID;
            this.showboss(i + 1, heroID, guildbossID);
            this.titileLabel.text = "第" + this.curPageNum + "章";
            if (bossMap[guildbossID] != null && bossMap[guildbossID].hp == 0) {
                this.waitingtime[i + 1].visible = false;
                if (i == 4) {
                    this.isClear = true;
                }
            }
            else if ((hitBossMap[guildbossID] != null && bossMap[guildbossID].hp > 0)) {
                this.waitingtime[i + 1].visible = true;
            }
        }
        this.leftarrow.enabled = this.curPageNum == 1 ? false : true;
        this.rightarrow.enabled = this.curPageNum == this.maxPage ? false : true;
    };
    //下一页
    GuildAdventureView.prototype.Downpage = function () {
        if (this.curPageNum != this.maxPage) {
            this.curPageNum++;
            this.updateView();
        }
    };
    //上一页
    GuildAdventureView.prototype.Uppage = function () {
        if (this.curPageNum > 1) {
            this.curPageNum--;
            this.updateView();
        }
    };
    //boss显示
    GuildAdventureView.prototype.showboss = function (index, heroID, bossID) {
        var temp = this.boss_list[index].getChild("longgu").asGraph;
        if (!this.heroNode[index]) {
            this.heroNode[index] = new egret.DisplayObjectContainer();
            temp.setNativeObject(this.heroNode[index]);
        }
        //boss龙骨显示
        this.heroNode[index].removeChildren();
        // let tt=new egret.DisplayObjectContainer();
        // let temp =this.boss_list[index].getChild("longgu").asGraph;
        // temp.setNativeObject(tt);
        var hero = new Hero(heroID).addToParent(this.heroNode[index]);
        this.heroNode[index].scaleX = index % 2 == 0 ? -1 : 1;
        var bossData = MyData.myUnionInfo.json.bossMap[bossID];
        if (bossData != null && bossData.hp == 0) {
            temp.enabled = false;
            hero.timeScale = 0;
        }
        else if ((bossData != null && bossData.hp != 0) || bossData == null) {
            temp.enabled = true;
        }
        //boss关数显示
        var title_temp = this.boss_list[index].getChild("n4").asLabel;
        var bosstitle = title_temp.getChild("title").asTextField;
        bosstitle.text = "第" + bossID + "关";
        this.boss_loaderlist[index - 1].data = { bossID: bossID, heroID: heroID };
    };
    GuildAdventureView.prototype.timedown = function () {
        if (MyData.myUnionInfo != null) {
            var time = DateUtils.getWeeHours12Time() - ak.time();
            var text = DateUtils.getFormatBySecond(time, DateUtils.TIME_FORMAT_12);
            var bossID = MyData.myUnionInfo.json.bossID;
            var bossMap = MyData.myUnionInfo.json.bossMap;
            var index = (bossID % 5) == 0 ? 5 : bossID % 5; //text索引
            var cur_bossID = (this.curPageNum - 1) * 5 + (bossID % 5); //当前BossID
            var hitBossMap = MyData.user.json.unionInfo.hitBossMap;
            this.waitingtime[index].text = time >= 0 && hitBossMap[bossID] != null ? text : "";
        }
    };
    GuildAdventureView.prototype.openview = function (e) {
        var itemData = e.target.data;
        if (itemData != null) {
            var bossMap = MyData.myUnionInfo.json.bossMap;
            var bossData = bossMap[itemData.bossID]; //当前boss map
            if (bossData != null) {
                if (bossData.hp == 0) {
                    ak.FairyGUI.open(["AdventureRanking", itemData.bossID, itemData.heroID, 1, this.curPageNum]);
                }
                else if (bossData.hp != 0 && itemData.bossID != 1) {
                    var frontbossMap = bossMap[itemData.bossID - 1]; //获取上一个boss map
                    var hp = frontbossMap.hp;
                    if (frontbossMap == null || (frontbossMap != null && hp != 0))
                        TipsViewSystem.show("请先通关前置关卡");
                    ak.FairyGUI.open(["AdventureRanking", itemData.bossID, itemData.heroID, 0, this.curPageNum]);
                }
                else if (bossData.hp != 0 && itemData.bossID == 1) {
                    ak.FairyGUI.open(["AdventureRanking", itemData.bossID, itemData.heroID, 0, this.curPageNum]);
                }
            }
            else {
                TipsViewSystem.show("请先通关前置关卡");
            }
        }
    };
    return GuildAdventureView;
}(ak.EasyUI));
__reflect(GuildAdventureView.prototype, "GuildAdventureView");
//公会申请列表系统
var GuildApplySystem = (function (_super) {
    __extends(GuildApplySystem, _super);
    function GuildApplySystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GuildApplySystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guild");
    };
    GuildApplySystem.inst = new GuildApplySystem("Guild");
    return GuildApplySystem;
}(ak.FairyGUI));
__reflect(GuildApplySystem.prototype, "GuildApplySystem");
//公会申请列表界面
var GuildApplyListView = (function (_super) {
    __extends(GuildApplyListView, _super);
    function GuildApplyListView() {
        return _super.call(this, GuildApplySystem.inst, MyGame.inst.uiLayer2_2) || this;
    }
    /**回调 */
    GuildApplyListView.prototype.onInit = function () {
        var ui = this.create("Guild", "GuildApplyListView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.memberApplyList = ui.getChild("memberApplyList").asList;
        this.imgNoneTip = ui.getChild("imgNoneTip").asImage;
        this.ClickAdd();
        net.myUnionInfo(this.updateListView, this);
    };
    GuildApplyListView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.onFairyguiEvent(this.memberApplyList, fairygui.ItemEvent.CLICK, this.onClickItemBtn, this);
    };
    GuildApplyListView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
        }
    };
    GuildApplyListView.prototype.updateListView = function () {
        this.memberApplyList.removeChildrenToPool();
        var reqMap = MyData.myUnionInfo.json.reqMap;
        this.imgNoneTip.visible = true;
        for (var i in reqMap) {
            var item = this.memberApplyList.addItemFromPool().asCom;
            var iconItem = new ItemBase(item.getChild("icon_item").asCom, this, 2);
            iconItem.setIcons2("hero" + reqMap[i].head);
            iconItem.setNumber(reqMap[i].level, true);
            item.getChild("roleName").asTextField.text = reqMap[i].nickname;
            item.data = reqMap[i];
            if (this.imgNoneTip.visible == true)
                this.imgNoneTip.visible = false;
        }
    };
    GuildApplyListView.prototype.onClickItemBtn = function (obj) {
        var _this = this;
        var item = obj.itemObject;
        var btnAgree = item.getChild("btnAgree").asButton;
        var btnRefused = item.getChild("btnRefused").asButton;
        var iconItem = item.getChild("icon_item").asCom;
        if (this.hitTestPointWithFairyGUIComponent(btnAgree, obj.stageX, obj.stageY)) {
            net.agreeReqUnion(item.data.userID, 1, function () {
                net.myUnionInfo(function () {
                    _this.updateListView();
                    ak.EventMgr.dispatch(GameEvent.guildMember);
                }, _this);
            }, this);
        }
        else if (this.hitTestPointWithFairyGUIComponent(btnRefused, obj.stageX, obj.stageY)) {
            net.agreeReqUnion(item.data.userID, 0, function () {
                net.myUnionInfo(function () {
                    _this.updateListView();
                    ak.EventMgr.dispatch(GameEvent.guildMember);
                }, _this);
            }, this);
        }
        else if (this.hitTestPointWithFairyGUIComponent(iconItem, obj.stageX, obj.stageY)) {
            net.getRoleBaseInfo(item.data.userID, function (msg) {
                ak.FairyGUI.open(["LookupInfoView", item.data.userID, msg]);
            }, this);
        }
    };
    return GuildApplyListView;
}(ak.EasyUI));
__reflect(GuildApplyListView.prototype, "GuildApplyListView");
// 公会战  宝箱
var GuildBaoXiangViewSystem = (function (_super) {
    __extends(GuildBaoXiangViewSystem, _super);
    function GuildBaoXiangViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GuildBaoXiangViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guild");
    };
    GuildBaoXiangViewSystem.inst = new GuildBaoXiangViewSystem("Guild");
    return GuildBaoXiangViewSystem;
}(ak.FairyGUI));
__reflect(GuildBaoXiangViewSystem.prototype, "GuildBaoXiangViewSystem");
var GuildBaoXiangView = (function (_super) {
    __extends(GuildBaoXiangView, _super);
    function GuildBaoXiangView() {
        return _super.call(this, GuildBaoXiangViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
    }
    GuildBaoXiangView.prototype.onInit = function () {
        this.ui = this.create("Guild", "GuildBaoXiangView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.chooseCom = this.ui.getChild("n4").asCom;
        this.list = this.ui.getChild("list").asList;
        this.leftButton = this.chooseCom.getChild("leftbtn").asButton;
        this.middleButton = this.chooseCom.getChild("middlebtn").asButton;
        this.rightButton = this.chooseCom.getChild("rightbtn").asButton;
        this.leftButtonText = this.leftButton.getChild("title").asTextField;
        this.middleButtonText = this.middleButton.getChild("title").asTextField;
        this.rightButtonText = this.rightButton.getChild("title").asTextField;
        this.leftButtonText.text = "白银宝箱";
        this.middleButtonText.text = "铂金宝箱";
        this.rightButtonText.text = "黄金宝箱";
        this.clickAdd();
        this.updateView();
    };
    GuildBaoXiangView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.leftButton, this.onClick, this);
        this.addClickListener(this.middleButton, this.onClick, this);
        this.addClickListener(this.rightButton, this.onClick, this);
    };
    GuildBaoXiangView.prototype.itemonclick = function (e) {
        var awarditem = e.itemObject.data;
        ak.log(e.itemObject.data.index);
    };
    GuildBaoXiangView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.leftButton:
                this.updateView();
                break;
            case this.middleButton:
                this.updateView();
                break;
            case this.rightButton:
                this.updateView();
                break;
        }
    };
    //设置列表内容
    GuildBaoXiangView.prototype.setlist = function (Tab) {
        if (Tab === void 0) { Tab = null; }
        this.list.removeChildrenToPool();
        for (var i = 0; i < 24; i++) {
            var info = this.list.addItemFromPool().asCom;
            info.data = { index: i };
        }
    };
    GuildBaoXiangView.prototype.updateView = function () {
        if (this.leftButton.selected == true) {
            this.setlist();
        }
        else if (this.middleButton.selected == true) {
            this.setlist();
        }
        else {
            this.setlist();
        }
        this.onFairyguiEvent(this.list, fairygui.ItemEvent.CLICK, this.itemonclick, this);
        //TipsViewSystem.show("该功能暂未开放");
    };
    return GuildBaoXiangView;
}(ak.EasyUI));
__reflect(GuildBaoXiangView.prototype, "GuildBaoXiangView");
//补领界面
var GuildBossBulingViewSystem = (function (_super) {
    __extends(GuildBossBulingViewSystem, _super);
    function GuildBossBulingViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GuildBossBulingViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guild");
    };
    GuildBossBulingViewSystem.inst = new GuildBossBulingViewSystem("Guild");
    return GuildBossBulingViewSystem;
}(ak.FairyGUI));
__reflect(GuildBossBulingViewSystem.prototype, "GuildBossBulingViewSystem");
var GuildBossBulingView = (function (_super) {
    __extends(GuildBossBulingView, _super);
    function GuildBossBulingView() {
        return _super.call(this, GuildBossBulingViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
    }
    GuildBossBulingView.prototype.onInit = function () {
        this.ui = this.create("Guild", "GuildBossBulingView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.moneyItem = this.ui.getChild("money").asCom;
        this.gongxianItem = this.ui.getChild("gongxian").asCom;
        this.bulingBtn = this.ui.getChild("bulingBtn").asButton;
        this.clickAdd();
        this.updateView();
    };
    GuildBossBulingView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.bulingBtn, this.onClick, this);
        this.addClickListener(this.moneyItem, this.onTouchItemEvent, this);
        this.addClickListener(this.gongxianItem, this.onTouchItemEvent, this);
    };
    GuildBossBulingView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.bulingBtn:
                break;
        }
    };
    GuildBossBulingView.prototype.updateView = function () {
    };
    GuildBossBulingView.prototype.onTouchItemEvent = function (e) {
        if (e.target.data.type != 3)
            ak.FairyGUI.open(["WeaponTipsView", e.target.data.id, e.target.data.num, 1]);
        else
            ak.FairyGUI.open(["ResourceTipsView", e.target.data.id, e.target.data.num]);
    };
    return GuildBossBulingView;
}(ak.EasyUI));
__reflect(GuildBossBulingView.prototype, "GuildBossBulingView");
//公会旗帜选择系统
var GuildChangeNameSystem = (function (_super) {
    __extends(GuildChangeNameSystem, _super);
    function GuildChangeNameSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GuildChangeNameSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guild");
    };
    GuildChangeNameSystem.inst = new GuildChangeNameSystem("Guild");
    return GuildChangeNameSystem;
}(ak.FairyGUI));
__reflect(GuildChangeNameSystem.prototype, "GuildChangeNameSystem");
//公会旗帜选择界面
var GuildChangeNameView = (function (_super) {
    __extends(GuildChangeNameView, _super);
    function GuildChangeNameView() {
        return _super.call(this, GuildChangeNameSystem.inst, MyGame.inst.tipLayer) || this;
    }
    /**回调 */
    GuildChangeNameView.prototype.onInit = function () {
        var ui = this.create("Guild", "GuildChangeNameView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.inputGuildName = ui.getChild("inputGuildName").asTextField;
        this.btnConfirm = ui.getChild("btnConfirm").asButton;
        var guildConfigTab = ak.JsonTableMgr.get("guildConfig");
        var guildFlagInfo = guildConfigTab.getRow(0);
        this.btnConfirm.getChild("number").asTextField.text = guildFlagInfo.getValFromColName("changeNameCost");
        this.ClickAdd();
    };
    GuildChangeNameView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.btnConfirm, this.onClick, this);
    };
    GuildChangeNameView.prototype.onClick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.btnConfirm:
                var nameStr = this.inputGuildName.text;
                if (nameStr == "")
                    TipsViewSystem.show("请输入公会名字");
                else
                    net.changeUnionName(nameStr, function () {
                        _this.inputGuildName.text = null;
                        ak.EventMgr.dispatch(GameEvent.guildChangeName);
                        _this.close();
                    }, this);
                break;
        }
    };
    return GuildChangeNameView;
}(ak.EasyUI));
__reflect(GuildChangeNameView.prototype, "GuildChangeNameView");
//公会创建系统
var GuildCreateSystem = (function (_super) {
    __extends(GuildCreateSystem, _super);
    function GuildCreateSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GuildCreateSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guild");
    };
    GuildCreateSystem.inst = new GuildCreateSystem("Guild");
    return GuildCreateSystem;
}(ak.FairyGUI));
__reflect(GuildCreateSystem.prototype, "GuildCreateSystem");
//公会创建界面
var GuildCreateView = (function (_super) {
    __extends(GuildCreateView, _super);
    function GuildCreateView() {
        var _this = _super.call(this, GuildApplySystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.curPageNum = 1;
        _this.maxPage = 1;
        _this.guild_list = [];
        _this.createCost = 0;
        _this.createCostVip = 0;
        return _this;
    }
    /**回调 */
    GuildCreateView.prototype.onInit = function () {
        var ui = this.create("Guild", "GuildCreateView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.curPage = ui.getChild("curPage").asTextField;
        this.btnHead = ui.getChild("btnHead").asButton;
        this.btnTail = ui.getChild("btnTail").asButton;
        this.btnLeftUpPage = ui.getChild("btnLeftUpPage").asButton;
        this.btnRightDownPage = ui.getChild("btnRightDownPage").asButton;
        this.guildList = ui.getChild("guildList").asList;
        var tab = ui.getChild("tab").asCom;
        this.leftbtn = tab.getChild("leftbtn").asButton;
        this.rightbtn = tab.getChild("rightbtn").asButton;
        this.c1_controller = ui.getController("c1");
        this.btnSelect = ui.getChild("btnSelect").asButton;
        this.btnCreate = ui.getChild("btnCreate").asButton;
        this.inputGuildName = ui.getChild("inputGuildName").asTextField;
        this.iconTypeLoader = ui.getChild("iconTypeLoader").asLoader;
        this.createText = ui.getChild("createText").asTextField;
        var guildConfigTab = ak.JsonTableMgr.get("guildConfig");
        this.createCost = guildConfigTab.getRow(0).getValFromColName("createCost");
        this.createCostVip = guildConfigTab.getRow(0).getValFromColName("createVip");
        this.btnCreate.getChild("number").asTextField.text = this.createCost.toString();
        this.createText.text = "创建条件：vip" + this.createCostVip.toString();
        this.on(GameEvent.guildSelectFlag, this.updateViewGuildCreate, this);
        this.ClickAdd();
        this.updateView();
    };
    GuildCreateView.prototype.ClickAdd = function () {
        this.leftbtn.getChild("title").asTextField.text = "列表";
        this.rightbtn.getChild("title").asTextField.text = "创建";
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.leftbtn, this.onClick, this);
        this.addClickListener(this.rightbtn, this.onClick, this);
        this.addClickListener(this.btnHead, this.onClickHeadPage, this);
        this.addClickListener(this.btnTail, this.onClickTailPage, this);
        this.addClickListener(this.btnRightDownPage, this.onClickDownPage, this);
        this.addClickListener(this.btnLeftUpPage, this.onClickUpPage, this);
        this.addClickListener(this.btnSelect, this.onClick, this);
        this.addClickListener(this.btnCreate, this.onClickCreateGuild, this);
        this.onFairyguiEvent(this.guildList, fairygui.ItemEvent.CLICK, this.onClickListItem, this);
    };
    GuildCreateView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                ak.EventMgr.dispatch(GameEvent.changeMainCity);
                break;
            case this.leftbtn:
                this.c1_controller.selectedIndex = 0;
                this.updateView();
                break;
            case this.rightbtn:
                this.c1_controller.selectedIndex = 1;
                this.updateViewGuildCreate();
                break;
            case this.btnSelect:
                ak.FairyGUI.open(["GuildFlagSelectView"]);
                break;
        }
    };
    GuildCreateView.prototype.updateView = function () {
        var _this = this;
        net.unionList(function (guildListData) {
            _this.guild_list = guildListData[2];
            _this.updateViewGuildList();
        }, this); //获取公会列表
    };
    //更新公会列表
    GuildCreateView.prototype.updateViewGuildList = function () {
        this.guildList.removeChildrenToPool();
        var itemShowCount = 5; //显示5个公会Item
        for (var i = 0; i < itemShowCount; i++) {
            var index = i + (this.curPageNum - 1) * itemShowCount; //当前页数(页数1开始-1) * 显示数量(下标零开始 + 1)
            var guild_data = this.guild_list[index];
            if (guild_data == null)
                break;
            var item = this.guildList.addItemFromPool().asCom;
            item.getChild("ranknum").asTextField.text = (index + 1).toString();
            item.getChild("guildName").asTextField.text = guild_data.name;
            item.getChild("memberCount").asTextField.text = guild_data.memberNum + "/" + guild_data.memberMaxNum;
            item.getChild("LimitLevel").asTextField.text = guild_data.json.joinLevel;
            var flagUrl = guild_data.flag < 10 ? "img_qz_0" + guild_data.flag + "_png" : "img_qz_" + guild_data.flag + "_png";
            this.setLoaderUrl(item.getChild("iconTypeLoader").asLoader, flagUrl);
            item.getChild("btnApply").asButton.data = guild_data;
            var unionInfo = MyData.user.json.unionInfo;
            item.getController("isApply").selectedIndex = unionInfo != null && unionInfo.reqMap[guild_data.id] == 1 ? 1 : 0;
        }
        this.curPage.text = "\u7B2C" + this.curPageNum + "\u9875";
        this.maxPage = Math.ceil(this.guild_list.length / itemShowCount);
        this.btnHead.enabled = this.curPageNum != 1;
        this.btnTail.enabled = this.curPageNum != this.maxPage && this.guild_list.length > itemShowCount;
        this.btnLeftUpPage.enabled = this.curPageNum != 1;
        this.btnRightDownPage.enabled = this.curPageNum != this.maxPage && this.guild_list.length > itemShowCount;
    };
    GuildCreateView.prototype.onClickListItem = function (obj) {
        var _this = this;
        var item = obj.itemObject;
        var btnApply = item.getChild("btnApply").asButton;
        if (this.hitTestPointWithFairyGUIComponent(btnApply, obj.stageX, obj.stageY)) {
            net.reqUnion(btnApply.data.id, function () { _this.updateView(); }, this);
        }
    };
    //点击跳转首页
    GuildCreateView.prototype.onClickHeadPage = function () {
        if (this.curPageNum > 1) {
            this.curPageNum = 1;
            this.updateViewGuildList();
        }
    };
    //点击跳转尾页
    GuildCreateView.prototype.onClickTailPage = function () {
        if (this.curPageNum != this.maxPage) {
            this.curPageNum = this.maxPage;
            this.updateViewGuildList();
        }
    };
    //点击跳转下一页
    GuildCreateView.prototype.onClickDownPage = function () {
        if (this.curPageNum != this.maxPage) {
            this.curPageNum++;
            this.updateViewGuildList();
        }
    };
    //点击跳转上一页
    GuildCreateView.prototype.onClickUpPage = function () {
        if (this.curPageNum > 1) {
            this.curPageNum--;
            this.updateViewGuildList();
        }
    };
    //更新公会创建界面
    GuildCreateView.prototype.updateViewGuildCreate = function () {
        var id = GuildData.inst().getSelectFlagId();
        var flagUrl = id < 10 ? "img_qz_0" + id + "_png" : "img_qz_" + id + "_png";
        this.setLoaderUrl(this.iconTypeLoader, flagUrl);
    };
    //点击创建公会
    GuildCreateView.prototype.onClickCreateGuild = function () {
        var _this = this;
        var guildName = this.inputGuildName.text;
        if (guildName == "") {
            TipsViewSystem.show("请输入公会名字");
        }
        else {
            var id = GuildData.inst().getSelectFlagId();
            if (MyData.user.vip >= this.createCostVip) {
            }
            else {
                TipsViewSystem.show("Vip等级不足" + this.createCostVip);
                return;
            }
            if (SummonData.inst().GetDiamondnum() >= this.createCost) {
                net.createUnion(guildName, id, function () {
                    if (MyData.user.unionID != 0) {
                        ak.FairyGUI.open(["GuildView"]);
                        _this.close();
                    }
                }, this);
            }
            else {
                TipsViewSystem.show("钻石不足");
            }
        }
    };
    return GuildCreateView;
}(ak.EasyUI));
__reflect(GuildCreateView.prototype, "GuildCreateView");
var GuildData = (function () {
    function GuildData() {
        this.selectFlagId = 1;
        this.selectSkillType = 0;
        this.skillTypeList = [];
        this.stoneAttrTypeTab = ak.JsonTableMgr.get("stoneAttrType");
        this.guildLevelTab = ak.JsonTableMgr.get("guildLevel");
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    GuildData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new GuildData();
        }
        return Class._instance;
    };
    //设置选中旗帜ID
    GuildData.prototype.setSelectFlagId = function (flagId) {
        this.selectFlagId = flagId;
    };
    //获取选中旗帜ID
    GuildData.prototype.getSelectFlagId = function () {
        return this.selectFlagId;
    };
    GuildData.prototype.initSkillTypeList = function () {
        var guildSkillTab = ak.JsonTableMgr.get("guildSkill");
        for (var i = 1; i <= 5; i++) {
            var index = 0;
            var skillData = [];
            for (var j = 0; j < guildSkillTab.size(); j++) {
                var guildSkillInfo = guildSkillTab.getRow(j);
                if (guildSkillInfo.getValFromColName("job") == i) {
                    skillData[index] = [];
                    skillData[index]["index"] = index;
                    skillData[index]["id"] = guildSkillInfo.getValFromColName("id");
                    skillData[index]["name"] = guildSkillInfo.getValFromColName("name");
                    skillData[index]["depend"] = guildSkillInfo.getValFromColName("depend");
                    skillData[index]["dependLevel"] = guildSkillInfo.getValFromColName("dependLevel");
                    skillData[index]["pic"] = guildSkillInfo.getValFromColName("pic");
                    skillData[index]["lvMax"] = guildSkillInfo.getValFromColName("lvMax");
                    skillData[index]["attr1"] = guildSkillInfo.getValFromColName("attr1");
                    skillData[index]["attrNum1"] = guildSkillInfo.getValFromColName("attrNum1");
                    skillData[index]["attr2"] = guildSkillInfo.getValFromColName("attr2");
                    skillData[index]["attrNum2"] = guildSkillInfo.getValFromColName("attrNum2");
                    skillData[index]["gold"] = guildSkillInfo.getValFromColName("gold");
                    skillData[index]["goldBase"] = guildSkillInfo.getValFromColName("goldBase");
                    skillData[index]["item"] = guildSkillInfo.getValFromColName("item");
                    skillData[index]["itemNum"] = guildSkillInfo.getValFromColName("itemNum");
                    skillData[index]["itemNumBase"] = guildSkillInfo.getValFromColName("itemNumBase");
                    this.skillTypeList[i] = skillData;
                    index++;
                    if (index == 8) {
                        break;
                    }
                }
            }
        }
    };
    //根据职业获取技能数据
    GuildData.prototype.getSkillTypeList = function (jobType) {
        return this.skillTypeList[jobType];
    };
    //获取属性类型
    GuildData.prototype.getAttrType = function (attrType) {
        var attrInfo = this.stoneAttrTypeTab.getRowFromColName("id", "" + attrType);
        return attrInfo.getValFromColName("name");
    };
    //公会经验转等级
    GuildData.prototype.guildExpConvertLevel = function (guildExp) {
        var length = this.guildLevelTab.size();
        for (var i = length - 1; i >= 0; i--) {
            var guildLevelInfo = this.guildLevelTab.getRow(i);
            var exp = guildLevelInfo.getValFromColName("exp");
            if (guildExp >= exp) {
                return guildLevelInfo.getValFromColName("lv");
            }
        }
        return 0;
    };
    //根据等级获取公会所需经验
    GuildData.prototype.getGuildExp = function (guildLevel) {
        var length = this.guildLevelTab.size();
        for (var i = 0; i < length; i++) {
            var guildLevelInfo = this.guildLevelTab.getRow(i);
            var lv = guildLevelInfo.getValFromColName("lv");
            var maxLevelInfo = this.guildLevelTab.getRow(length - 1);
            var maxLevel = maxLevelInfo.getValFromColName("lv");
            if (guildLevel == lv) {
                return guildLevelInfo.getValFromColName("exp");
            }
            else if (guildLevel > maxLevel) {
                return maxLevelInfo.getValFromColName("exp");
            }
        }
    };
    //设置当前选中技能类型
    GuildData.prototype.setSelectSkillType = function (skillType) {
        this.selectSkillType = skillType;
    };
    //获取当前选中技能类型
    GuildData.prototype.getSelectSkillType = function () {
        return this.selectSkillType;
    };
    //成员列表排序
    GuildData.prototype.sortMemberMap = function (memberMap) {
        var memberMaplist = [];
        var index = 0;
        for (var i = 2; i >= 0; i--) {
            for (var id in memberMap) {
                var memberData = memberMap[id];
                if (memberData.job == i) {
                    var map = { id: id, enterTime: memberData.enterTime, job: memberData.job };
                    if (i == 1) {
                        memberMaplist[0] = map;
                        break;
                    }
                    else {
                        memberMaplist[++index] = map;
                    }
                }
            }
        }
        return memberMaplist;
    };
    return GuildData;
}());
__reflect(GuildData.prototype, "GuildData");
//公会捐献系统
var GuildDonateSystem = (function (_super) {
    __extends(GuildDonateSystem, _super);
    function GuildDonateSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GuildDonateSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guild");
    };
    GuildDonateSystem.inst = new GuildDonateSystem("Guild");
    return GuildDonateSystem;
}(ak.FairyGUI));
__reflect(GuildDonateSystem.prototype, "GuildDonateSystem");
//公会捐献界面
var GuildDonateView = (function (_super) {
    __extends(GuildDonateView, _super);
    function GuildDonateView() {
        var _this = _super.call(this, GuildDonateSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.btnAddClickEventCount = 0;
        return _this;
    }
    /**回调 */
    GuildDonateView.prototype.onInit = function () {
        var ui = this.create("Guild", "GuildDonateView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.levelText = ui.getChild("levelText").asTextField;
        this.donateText = ui.getChild("donateText").asTextField;
        this.progressBar = ui.getChild("progressBar").asProgress;
        this.progressBarText = this.progressBar.getChild("title").asTextField;
        this.donateList = ui.getChild("donateList").asList;
        this.guildDonateTab = ak.JsonTableMgr.get("guildDonate");
        this.ClickAdd();
        this.flushCallback();
    };
    GuildDonateView.prototype.onDestroy = function () {
        this.btnAddClickEventCount = null;
    };
    GuildDonateView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
    };
    GuildDonateView.prototype.flushCallback = function () {
        net.myUnionInfo(this.updateView, this);
    };
    GuildDonateView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
        }
    };
    GuildDonateView.prototype.onClickBtnBuy = function (e) {
        var _this = this;
        if (MyData.user.json.unionInfo.donateID == 0)
            net.unionDonate(e.target.data, function () {
                _this.flushCallback();
                ak.EventMgr.dispatch(GameEvent.flushGuildViewRedPoint);
            }, this);
        else
            TipsViewSystem.show("今天已捐献");
    };
    GuildDonateView.prototype.updateView = function () {
        var guildExp = MyData.myUnionInfo.exp;
        var guildLevel = GuildData.inst().guildExpConvertLevel(guildExp);
        var guildNextLevelExp = GuildData.inst().getGuildExp(guildLevel + 1) - GuildData.inst().getGuildExp(guildLevel);
        guildExp = MyData.myUnionInfo.exp - GuildData.inst().getGuildExp(guildLevel);
        this.levelText.text = "等级" + guildLevel;
        this.donateText.text = "任意一档捐献方式增加的公会经验是相同的";
        this.progressBar.max = guildNextLevelExp;
        this.progressBar.value = guildExp;
        var percent = (guildExp / guildNextLevelExp) * 100;
        var percentText = guildExp >= guildNextLevelExp ? "100% " : percent.toFixed(0) + "%";
        this.progressBarText.text = percentText;
        this.donateList.removeChildrenToPool();
        var donateID = MyData.user.json.unionInfo.donateID;
        for (var i = 0; i < this.guildDonateTab.size(); i++) {
            var guildDonateInfo = this.guildDonateTab.getRow(i);
            var listItem = this.donateList.addItemFromPool().asCom;
            var donateId = guildDonateInfo.getValFromColName("id");
            listItem.getChild("donateTypeNum").asTextField.text = donateId;
            listItem.getChild("itemPrice").asTextField.text = "x" + guildDonateInfo.getValFromColName("num");
            listItem.getController("donate").selectedIndex = i;
            listItem.getController("isBuy").selectedIndex = donateID == donateId ? 1 : 0;
            var btnBuy = listItem.getChild("btnBuy").asButton;
            btnBuy.getChild("title").text = "购买";
            btnBuy.getChild("number").text = i == 0 ? guildDonateInfo.getValFromColName("goldCost") : guildDonateInfo.getValFromColName("zsCost");
            btnBuy.enabled = donateID == 0 ? true : false;
            btnBuy.getChild("icon").asLoader.enabled = true;
            btnBuy.getChild("number").asTextField.enabled = true;
            var itemIconUrl = i == 0 ? "jinbi_png" : "rmbmoney_png";
            this.setLoaderUrl(btnBuy.getChild("icon").asLoader, itemIconUrl);
            btnBuy.data = donateId;
            if (this.btnAddClickEventCount < this.guildDonateTab.size()) {
                this.addClickListener(btnBuy, this.onClickBtnBuy, this);
                this.btnAddClickEventCount++;
            }
        }
    };
    return GuildDonateView;
}(ak.EasyUI));
__reflect(GuildDonateView.prototype, "GuildDonateView");
//公会旗帜选择系统
var GuildFlagSelectSystem = (function (_super) {
    __extends(GuildFlagSelectSystem, _super);
    function GuildFlagSelectSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GuildFlagSelectSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guild");
    };
    GuildFlagSelectSystem.inst = new GuildFlagSelectSystem("Guild");
    return GuildFlagSelectSystem;
}(ak.FairyGUI));
__reflect(GuildFlagSelectSystem.prototype, "GuildFlagSelectSystem");
//公会旗帜选择界面
var GuildFlagSelectView = (function (_super) {
    __extends(GuildFlagSelectView, _super);
    function GuildFlagSelectView() {
        return _super.call(this, GuildFlagSelectSystem.inst, MyGame.inst.tipLayer) || this;
    }
    /**回调 */
    GuildFlagSelectView.prototype.onInit = function () {
        var ui = this.create("Guild", "GuildFlagSelectView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.guildFlagList = ui.getChild("guildFlagList").asList;
        this.guildFlagTab = ak.JsonTableMgr.get("guildFlag");
        this.ClickAdd();
        this.updateView();
    };
    GuildFlagSelectView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.onFairyguiEvent(this.guildFlagList, fairygui.ItemEvent.CLICK, this.onClickFlagItem, this);
    };
    GuildFlagSelectView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
        }
    };
    GuildFlagSelectView.prototype.updateView = function () {
        var selectFlagIndex = GuildData.inst().getSelectFlagId();
        this.guildFlagList.removeChildrenToPool();
        for (var i = 1; i <= this.guildFlagTab.size(); i++) {
            var guildFlagInfo = this.guildFlagTab.getRow(i - 1);
            var flagIconName = guildFlagInfo.getValFromColName("pic");
            var item = this.guildFlagList.addItemFromPool().asCom;
            this.setLoaderUrl(item.getChild("flagLoader").asLoader, flagIconName);
            item.getController("is_select").selectedIndex = (i == selectFlagIndex) ? 1 : 0;
            item.data = Number(guildFlagInfo.getValFromColName("id"));
        }
    };
    //点击旗帜
    GuildFlagSelectView.prototype.onClickFlagItem = function (obj) {
        var item = obj.itemObject;
        GuildData.inst().setSelectFlagId(item.data);
        this.close();
        ak.EventMgr.dispatch(GameEvent.guildSelectFlag);
    };
    return GuildFlagSelectView;
}(ak.EasyUI));
__reflect(GuildFlagSelectView.prototype, "GuildFlagSelectView");
//公会大厅系统
var GuildLobbySystem = (function (_super) {
    __extends(GuildLobbySystem, _super);
    function GuildLobbySystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GuildLobbySystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guild");
    };
    GuildLobbySystem.inst = new GuildLobbySystem("Guild");
    return GuildLobbySystem;
}(ak.FairyGUI));
__reflect(GuildLobbySystem.prototype, "GuildLobbySystem");
//公会大厅界面
var GuildLobbyView = (function (_super) {
    __extends(GuildLobbyView, _super);
    function GuildLobbyView() {
        return _super.call(this, GuildLobbySystem.inst, MyGame.inst.uiLayer2_2) || this;
    }
    /**回调 */
    GuildLobbyView.prototype.onInit = function () {
        var _this = this;
        var ui = this.create("Guild", "GuildLobbyView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.iconTypeLoader = ui.getChild("iconTypeLoader").asLoader;
        this.btnLog = ui.getChild("btnLog").asButton;
        this.btnHomePage = ui.getChild("btnHomePage").asButton;
        this.btnRegulate = ui.getChild("btnRegulate").asButton;
        this.guild_name = ui.getChild("guild_name").asTextField;
        this.serial_number = ui.getChild("serial_number").asTextField;
        this.guild_people = ui.getChild("guild_people").asTextField;
        this.guild_text = ui.getChild("guild_text").asTextField;
        this.guildMemberList = ui.getChild("guildMemberList").asList;
        this.btnApplyList = ui.getChild("btnApplyList").asButton;
        this.btnOutGuild = ui.getChild("btnOutGuild").asButton;
        this.btnHelp = ui.getChild("btnHelp").asButton;
        this.imgNullTip = ui.getChild("imgNullTip").asImage;
        this.guildLogList = ui.getChild("guildLogList").asList;
        this.memberList = ui.getChild("memberList").asList;
        this.btnRecruit = ui.getChild("btnRecruit").asButton;
        this.btnNotice = ui.getChild("btnNotice").asButton;
        this.btnSet = ui.getChild("btnSet").asButton;
        this.on(GameEvent.guildMember, function () { net.myUnionInfo(_this.updateViewHomePage, _this); }, this);
        this.on(GameEvent.guildRecruitMember, function () { net.myUnionInfo(_this.updateManageMember, _this); }, this);
        this.ClickAdd();
        net.myUnionInfo(this.updateViewHomePage, this);
    };
    GuildLobbyView.prototype.ClickAdd = function () {
        this.btnHomePage.getChild("title").asTextField.text = "主\n页";
        this.btnLog.getChild("title").asTextField.text = "日\n志";
        this.btnRegulate.getChild("title").asTextField.text = "管\n理";
        this.addClickListener(this.btnHelp, this.onClick, this);
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.btnLog, this.onClick, this);
        this.addClickListener(this.btnHomePage, this.onClick, this);
        this.addClickListener(this.btnRegulate, this.onClick, this);
        this.addClickListener(this.btnApplyList, this.onClick, this);
        this.addClickListener(this.btnOutGuild, this.onClick, this);
        this.addClickListener(this.btnRecruit, this.onClick, this);
        this.addClickListener(this.btnNotice, this.onClick, this);
        this.addClickListener(this.btnSet, this.onClick, this);
        this.onFairyguiEvent(this.guildMemberList, fairygui.ItemEvent.CLICK, this.onClickMemberItem, this);
        this.onFairyguiEvent(this.memberList, fairygui.ItemEvent.CLICK, this.onClickRegulateMemberItem, this);
    };
    GuildLobbyView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.btnLog:
                this.updateViewLog();
                break;
            case this.btnHomePage:
                net.myUnionInfo(this.updateViewHomePage, this);
                break;
            case this.btnRegulate:
                net.myUnionInfo(this.updateManageMember, this);
                break;
            case this.btnApplyList://申请列表
                ak.FairyGUI.open(["GuildApplyListView"]);
                break;
            case this.btnOutGuild://退出公会
                ak.FairyGUI.open(["ChooseTipsView", 5, "您是否确定退出该公会?", function () { ak.EventMgr.dispatch(GameEvent.changeMainCity); }]);
                break;
            case this.btnHelp://帮助
                ak.FairyGUI.open(["HelpTipsView", 10]);
                break;
            case this.btnRecruit:
                ak.FairyGUI.open(["GuildSetView", 2]);
                break;
            case this.btnNotice:
                ak.FairyGUI.open(["GuildSetView", 1]);
                break;
            case this.btnSet:
                var memberMap = MyData.myUnionInfo.json.memberMap;
                if (memberMap[MyData.user.id].job == 1)
                    ak.FairyGUI.open(["GuildSetView", 0]);
                else
                    TipsViewSystem.show("仅公会会长可以操作");
                break;
        }
    };
    //刷新头像
    GuildLobbyView.prototype.updateViewHeadItem = function (headIconCom, head_id, role_lv) {
        var items = new ItemBase(headIconCom, this, 2);
        items.setIcons2("hero" + head_id);
        items.setNumber(role_lv.toString(), true);
    };
    //普通成员点击列表
    GuildLobbyView.prototype.onClickMemberItem = function (obj) {
        var item = obj.itemObject;
        var itemCom = item.getChild("icon_item").asCom;
        if (this.hitTestPointWithFairyGUIComponent(itemCom, obj.stageX, obj.stageY)) {
            if (item.data != MyData.user.id) {
                net.getRoleBaseInfo(item.data, function (msg) {
                    ak.FairyGUI.open(["LookupInfoView", item.data, msg]);
                }, this);
            }
        }
    };
    //刷新主页
    GuildLobbyView.prototype.updateViewHomePage = function () {
        if (MyData.myUnionInfo == null)
            return;
        var memberMap = MyData.myUnionInfo.json.memberMap;
        this.btnRegulate.visible = memberMap[MyData.user.id].job != 0;
        this.guild_name.text = MyData.myUnionInfo.name;
        this.serial_number.text = MyData.myUnionInfo.id;
        this.guild_people.text = MyData.myUnionInfo.memberNum + "/" + MyData.myUnionInfo.memberMaxNum;
        this.guild_text.text = MyData.myUnionInfo.json.publicMsg;
        var flagUrl = MyData.myUnionInfo.flag < 10 ? "img_qz_0" + MyData.myUnionInfo.flag + "_png" : "img_qz_" + MyData.myUnionInfo.flag + "_png";
        this.setLoaderUrl(this.iconTypeLoader, flagUrl);
        memberMap = GuildData.inst().sortMemberMap(memberMap);
        this.updateMemberList(this.guildMemberList, memberMap);
    };
    //刷新日志
    GuildLobbyView.prototype.updateViewLog = function () {
        var logDataList = MyData.myUnionInfo.json.log;
        this.imgNullTip.visible = logDataList.length == 0;
        this.guildLogList.removeChildrenToPool();
        for (var i = 0; i < logDataList.length; i++) {
            var logItem = this.guildLogList.addItemFromPool().asCom;
            logItem.getChild("dayTime").asTextField.text = "" + DateUtils.getFormatBySecond(logDataList[i].time, DateUtils.TIME_FORMAT_16);
            logItem.getChild("logContent").asTextField.text = logDataList[i].txt;
            logItem.getChild("hourTime").asTextField.text = "" + Common.passTime(logDataList[i].time);
            ;
        }
    };
    //刷新管理成员列表
    GuildLobbyView.prototype.updateManageMember = function () {
        var memberMap = MyData.myUnionInfo.json.memberMap;
        var isChairman = memberMap[MyData.user.id].job != 0;
        this.btnNotice.visible = isChairman;
        this.btnSet.visible = isChairman;
        memberMap = GuildData.inst().sortMemberMap(memberMap);
        this.updateMemberList(this.memberList, memberMap);
    };
    //刷新成员列表
    GuildLobbyView.prototype.updateMemberList = function (listView, memberMap) {
        if (MyData.myUnionInfo == null)
            return;
        var userInfo = MyData.myUnionInfo.userInfo;
        var post = ["普通成员", "会长", "官员"];
        listView.removeChildrenToPool();
        for (var i = 0; i < memberMap.length; i++) {
            var memberData = memberMap[i];
            var member_item = listView.addItemFromPool().asCom;
            var uData = userInfo[memberData.id];
            this.updateViewHeadItem(member_item.getChild("icon_item").asCom, uData.head, uData.level);
            member_item.getChild("role_name").asTextField.text = uData.nickname;
            member_item.getChild("post").asTextField.text = post[memberData.job];
            member_item.getChild("time").asTextField.text = "" + Common.passTime(memberData.enterTime + MyData.timeBase);
            member_item.data = memberData.id;
        }
    };
    //管理成员点击列表
    GuildLobbyView.prototype.onClickRegulateMemberItem = function (obj) {
        var item = obj.itemObject;
        var itemCom = item.getChild("icon_item").asCom;
        if (this.hitTestPointWithFairyGUIComponent(itemCom, obj.stageX, obj.stageY)) {
            if (item.data != MyData.user.id) {
                net.getRoleBaseInfo(item.data, function (msg) {
                    ak.FairyGUI.open(["LookupInfoView", item.data, msg, 1]);
                }, this);
            }
        }
    };
    return GuildLobbyView;
}(ak.EasyUI));
__reflect(GuildLobbyView.prototype, "GuildLobbyView");
//赛区
var GuildSaiquRankingViewSystem = (function (_super) {
    __extends(GuildSaiquRankingViewSystem, _super);
    function GuildSaiquRankingViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GuildSaiquRankingViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guild");
    };
    GuildSaiquRankingViewSystem.inst = new GuildSaiquRankingViewSystem("Guild");
    return GuildSaiquRankingViewSystem;
}(ak.FairyGUI));
__reflect(GuildSaiquRankingViewSystem.prototype, "GuildSaiquRankingViewSystem");
var GuildSaiquRankingView = (function (_super) {
    __extends(GuildSaiquRankingView, _super);
    function GuildSaiquRankingView() {
        return _super.call(this, GuildSaiquRankingViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
    }
    GuildSaiquRankingView.prototype.onInit = function () {
        this.ui = this.create("Guild", "GuildSaiquRankingView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.list = this.ui.getChild("list").asList;
        this.title = this.ui.getChild("title").asLabel;
        this.statetext = this.ui.getChild("state").asTextField;
        this.guildrankingtext = this.ui.getChild("guildranking").asTextField;
        this.clickAdd();
        this.updateView();
    };
    GuildSaiquRankingView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
    };
    GuildSaiquRankingView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
        }
    };
    GuildSaiquRankingView.prototype.updateView = function () {
        this.list.removeChildrenToPool();
        for (var i = 0; i < 3; i++) {
            var info = this.list.addItemFromPool().asCom;
            var infoicon = info.getChild("icon").asLoader; //公会头像
            var infoname = info.getChild("name").asTextField; //公会名
            var infozhanli = info.getChild("zhanlitext").asTextField; //战力
            var infojifen = info.getChild("jifentext").asTextField; //积分
            infoname.text = "疯人院";
            infozhanli.text = "66666666";
            infojifen.text = "666666666";
            this.setLoaderUrl(infoicon, "img_qz_01_png");
            this.statetext.text = "状态：" + "保级区"; //青铜，白银，铂金，黄金 降级区/晋级区/保级区
            this.guildrankingtext.text = "本会排名：" + "5";
        }
    };
    return GuildSaiquRankingView;
}(ak.EasyUI));
__reflect(GuildSaiquRankingView.prototype, "GuildSaiquRankingView");
//公会旗帜选择系统
var GuildSetSystem = (function (_super) {
    __extends(GuildSetSystem, _super);
    function GuildSetSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GuildSetSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guild");
    };
    GuildSetSystem.inst = new GuildSetSystem("Guild");
    return GuildSetSystem;
}(ak.FairyGUI));
__reflect(GuildSetSystem.prototype, "GuildSetSystem");
//公会旗帜选择界面
var GuildSetView = (function (_super) {
    __extends(GuildSetView, _super);
    function GuildSetView(typeIndex) {
        var _this = _super.call(this, GuildSetSystem.inst, MyGame.inst.tipLayer) || this;
        _this.typeIndex = 0;
        _this.typeIndex = typeIndex;
        return _this;
    }
    /**回调 */
    GuildSetView.prototype.onInit = function () {
        var _this = this;
        var ui = this.create("Guild", "GuildSetView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.btnChangeName = ui.getChild("btnChangeName").asButton;
        this.inputLimitLevel = ui.getChild("inputLimitLevel").asTextField;
        this.iconTypeLoader = ui.getChild("iconTypeLoader").asLoader;
        this.btnConfirm = ui.getChild("btnConfirm").asButton;
        this.btnConfirm2 = ui.getChild("btnConfirm2").asButton;
        this.guildName = ui.getChild("guildName").asTextField;
        this.c1_controller = ui.getController("c1");
        this.inputGuildNotice = ui.getChild("inputGuildNotice").asTextField;
        this.inputGuildRecruit = ui.getChild("inputGuildRecruit").asTextField;
        this.title = ui.getChild("title").asCom;
        this.c1_controller.selectedIndex = this.typeIndex;
        this.on(GameEvent.guildChangeName, function () { net.myUnionInfo(_this.updateView, _this); }, this);
        this.ClickAdd();
        net.myUnionInfo(this.updateView, this);
    };
    GuildSetView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.btnChangeName, this.onClick, this);
        this.addClickListener(this.btnConfirm, this.onClick, this);
        this.addClickListener(this.btnConfirm2, this.onClick, this);
    };
    GuildSetView.prototype.onClick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.btnChangeName:
                ak.FairyGUI.open(["GuildChangeNameView"]);
                break;
            case this.btnConfirm:
                if (this.typeIndex == 0) {
                    var level = this.inputLimitLevel.text;
                    net.setUnionJoinLevel(Number(level), this.close, this);
                }
                else if (this.typeIndex == 1) {
                    net.setUnionPublicMsg(this.inputGuildNotice.text, this.close, this);
                }
                else if (this.typeIndex == 2) {
                    var text = this.inputGuildRecruit.text;
                    if (text == "") {
                        TipsViewSystem.show("请输入招募信息");
                    }
                    else {
                        net.sendRecruitChat(text, 2);
                        this.close();
                    }
                }
                break;
            case this.btnConfirm2:
                var skillType = GuildData.inst().getSelectSkillType();
                var skillMap = MyData.user.json.unionInfo.skillMap;
                if (skillMap == null) {
                    TipsViewSystem.show("未升级过技能无需重置");
                }
                else {
                    var jobSkillCount = 8; //单个角色技能数量
                    for (var i = 1; i <= jobSkillCount; i++) {
                        if (skillMap[((skillType - 1) * jobSkillCount) + i] != null) {
                            net.unionSkillReset(skillType, function () {
                                ak.EventMgr.dispatch(GameEvent.guildResetSkill);
                                _this.close();
                            }, this); //公会技能重置
                            return;
                        }
                    }
                    TipsViewSystem.show("未升级过技能无需重置");
                }
                break;
        }
    };
    GuildSetView.prototype.updateView = function () {
        var titleText = this.title.getChild("title").asTextField;
        if (this.typeIndex == 0) {
            var flagUrl = MyData.myUnionInfo.flag < 10 ? "img_qz_0" + MyData.myUnionInfo.flag + "_png" : "img_qz_" + MyData.myUnionInfo.flag + "_png";
            this.setLoaderUrl(this.iconTypeLoader, flagUrl);
            this.guildName.text = MyData.myUnionInfo.name;
            this.inputLimitLevel.text = MyData.myUnionInfo.json.joinLevel;
            titleText.text = "设置";
        }
        else if (this.typeIndex == 1) {
            this.inputGuildNotice.text = MyData.myUnionInfo.json.publicMsg;
            titleText.text = "公告";
        }
        else if (this.typeIndex == 2) {
            titleText.text = "招募";
            this.inputGuildRecruit.text = "\u300A" + MyData.myUnionInfo.name + "\u300B\u516C\u4F1A\u8BDA\u9080\u4F60\u7684\u52A0\u5165";
        }
        else if (this.typeIndex == 3) {
            this.btnConfirm2.getChild("number").asTextField.visible = false;
            var skillType = GuildData.inst().getSelectSkillType();
            var guildConfigTab = ak.JsonTableMgr.get("guildConfig");
            var guildFlagInfo = guildConfigTab.getRow(0);
            var resetCost = guildFlagInfo.getValFromColName("resetCost");
            var resetCount = MyData.user.json.unionInfo.skillResetMap[skillType];
            this.btnConfirm2.getChild("title").asTextField.text = resetCount == null ? "免费" : resetCost;
        }
    };
    return GuildSetView;
}(ak.EasyUI));
__reflect(GuildSetView.prototype, "GuildSetView");
//公会商店系统
var GuildShopSystem = (function (_super) {
    __extends(GuildShopSystem, _super);
    function GuildShopSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    GuildShopSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guild");
    };
    GuildShopSystem.inst = new GuildShopSystem("Guild");
    return GuildShopSystem;
}(ak.FairyGUI));
__reflect(GuildShopSystem.prototype, "GuildShopSystem");
//公会商店界面
var GuildShopView = (function (_super) {
    __extends(GuildShopView, _super);
    function GuildShopView() {
        return _super.call(this, GuildShopSystem.inst, MyGame.inst.uiLayer2_1) || this;
    }
    GuildShopView.prototype.onInit = function () {
        this.ui = this.create("Guild", "GuildShopView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.guildlist = this.ui.getChild("n8").asList;
        this.mygongxian = this.ui.getChild("n6").asCom;
        this.reset = this.ui.getChild("n7").asButton;
        this.guildshopTab = ak.JsonTableMgr.get("shopGuild");
        this.guildshopConfigTab = ak.JsonTableMgr.get("shopGuildConfig");
        this.clickAdd();
        this.setstaticView();
        this.showguildlist();
    };
    GuildShopView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this); //关闭界面
        this.addClickListener(this.reset, this.onClick, this); //重置
        this.onFairyguiEvent(this.guildlist, fairygui.ItemEvent.CLICK, this.buyMarket, this);
    };
    GuildShopView.prototype.onClick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.reset:
                net.unionShopFlush(function () {
                    _this.showguildlist();
                }, this); //刷新
                break;
        }
    };
    GuildShopView.prototype.showguildlist = function () {
        ShopData.inst().setShopView(this, 0, this.guildlist, this.guildshopTab, '', MyData.user.json.unionShop.buyIDCountMap, this.mygongxian);
    };
    GuildShopView.prototype.buyMarket = function (obj) {
        //if()
        var item = obj.itemObject;
        for (var i = 0; i < 3; i++) {
            var itemCom = item.getChild("n1" + (i + 1)).asCom;
            var item1 = itemCom.getChild("n2").asCom; //获取元素中的物品栏
            if (this.hitTestPointWithFairyGUIComponent(itemCom, obj.stageX, obj.stageY)) {
                if (this.hitTestPointWithFairyGUIComponent(item1, obj.stageX, obj.stageY)) {
                    ak.FairyGUI.open(["WeaponTipsView", item1.data.id, item1.data.num, 1]);
                }
                else {
                    if (itemCom.data.limit - MyData.user.json.unionShop.buyIDCountMap[itemCom.data.index] != 0) {
                        if (SummonData.inst().GetItemnumByid(itemCom.data.CostItem) >= itemCom.data.CostNum) {
                            ak.FairyGUI.open(["ChooseTipsView", 6, '确定购买当前商品？', this.showguildlist.bind(this), itemCom.data.index]);
                        }
                        else {
                            TipsViewSystem.show("公会贡献不够");
                            return;
                        }
                    }
                    else {
                        TipsViewSystem.show("当天购买次数已达到上限");
                        return;
                    }
                }
            }
        }
    };
    GuildShopView.prototype.setstaticView = function () {
        var user = MyData.user;
        var photo_url_path = 'ui://common/token_ghgx';
        //重置按钮
        var icon1 = this.reset.getChild("icon").asLoader;
        var number1 = this.reset.getChild("number").asTextField;
        var res_text = this.reset.getChild("title").asTextField;
        //我的贡献
        var icon2 = this.mygongxian.getChild("icon").asLoader;
        var number2 = this.mygongxian.getChild("number").asTextField;
        this.setLoaderUrl(icon1, photo_url_path);
        this.setLoaderUrl(icon2, photo_url_path);
        var shopguildConfigInfo = this.guildshopConfigTab.getRow(0);
        number1.text = shopguildConfigInfo.getValFromColName("freshNum");
        res_text.text = "重置";
        //我的灵魂石默认为0
        number2.text = "" + SummonData.inst().GetItemnumByid(shopguildConfigInfo.getValFromColName("freshCost"));
    };
    return GuildShopView;
}(ak.EasyUI));
__reflect(GuildShopView.prototype, "GuildShopView");
//公会技能系统
var GuildSkillSystem = (function (_super) {
    __extends(GuildSkillSystem, _super);
    function GuildSkillSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GuildSkillSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guild");
    };
    GuildSkillSystem.inst = new GuildSkillSystem("Guild");
    return GuildSkillSystem;
}(ak.FairyGUI));
__reflect(GuildSkillSystem.prototype, "GuildSkillSystem");
//公会技能界面
var GuildSkillView = (function (_super) {
    __extends(GuildSkillView, _super);
    function GuildSkillView() {
        var _this = _super.call(this, GuildSkillSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.skillList = [];
        _this.skillAttrList = [];
        _this.selectSkillIndex = 0; //当前选中的技能index
        _this.curSelectSkillType = 0; //当前选中的技能类型
        _this.selectskillID = 0; //技能ID
        _this.enoughItem = false; //物品是否记录
        _this.enoughMoney = false; //金币是否记录
        _this.isMaxLevel = false; //是否满级
        return _this;
    }
    /**回调 */
    GuildSkillView.prototype.onInit = function () {
        var _this = this;
        var ui = this.create("Guild", "GuildSkillView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.btnZhanShi = ui.getChild("btn01").asButton;
        this.btnFaShi = ui.getChild("btn02").asButton;
        this.btnFuZhu = ui.getChild("btn03").asButton;
        this.btnCiKe = ui.getChild("btn04").asButton;
        this.btnYouXia = ui.getChild("btn05").asButton;
        this.btnReset = ui.getChild("btnReset").asButton;
        for (var i = 0; i < 8; i++) {
            this.skillList[i] = ui.getChild("skill_" + i).asCom;
        }
        this.btnUpLevel = ui.getChild("btnUpLevel").asButton;
        this.skillName = ui.getChild("skillName").asTextField;
        this.skillLevel = ui.getChild("skillLevel").asTextField;
        for (var i = 1; i < 3; i++) {
            this.skillAttrList[i] = [];
            this.skillAttrList[i]["skillAttrText" + i] = ui.getChild("skillAttrText" + i).asTextField;
            this.skillAttrList[i]["skillCurAtrrVal" + i] = ui.getChild("skillCurAtrrVal" + i).asTextField;
            this.skillAttrList[i]["skillNextAtrrVal" + i] = ui.getChild("skillNextAtrrVal" + i).asTextField;
            this.skillAttrList[i]["imgArrows" + i] = ui.getChild("imgArrows" + i).asImage;
            this.skillAttrList[i]["attrType" + i] = ui.getChild("attrType" + i).asGroup;
        }
        this.c1Controller = ui.getController("c1");
        this.moneyNum = ui.getChild("moneyNum").asTextField;
        this.DonateNum = ui.getChild("DonateNum").asTextField;
        this.heroSkill = ui.getChild("heroSkill").asCom;
        this.guildSkillTab = ak.JsonTableMgr.get("guildSkill");
        this.ClickAdd();
        GuildData.inst().initSkillTypeList();
        this.updateView(1);
        this.on(GameEvent.guildResetSkill, function () { _this.updateView(_this.curSelectSkillType); }, this);
    };
    GuildSkillView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.btnZhanShi, this.onClick, this);
        this.addClickListener(this.btnFaShi, this.onClick, this);
        this.addClickListener(this.btnFuZhu, this.onClick, this);
        this.addClickListener(this.btnCiKe, this.onClick, this);
        this.addClickListener(this.btnYouXia, this.onClick, this);
        this.addClickListener(this.btnReset, this.onClick, this);
        this.addClickListener(this.btnUpLevel, this.onClick, this);
        for (var i = 0; i < this.skillList.length; i++) {
            this.addClickListener(this.skillList[i], this.onClickSkillItem, this);
        }
    };
    GuildSkillView.prototype.onClickSkillItem = function (e) {
        this.selectSkillIndex = e.target.data.index;
        this.updateSkillInfoView();
    };
    GuildSkillView.prototype.onClick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.btnZhanShi:
                this.updateView(1);
                break;
            case this.btnFaShi:
                this.updateView(2);
                break;
            case this.btnFuZhu:
                this.updateView(3);
                break;
            case this.btnCiKe:
                this.updateView(4);
                break;
            case this.btnYouXia:
                this.updateView(5);
                break;
            case this.btnReset:
                ak.FairyGUI.open(["GuildSetView", 3]);
                break;
            case this.btnUpLevel:
                if (this.enoughItem == false) {
                    TipsViewSystem.show("道具不足");
                }
                else if (this.enoughMoney == false) {
                    TipsViewSystem.show("金币不足");
                }
                else if (this.isMaxLevel) {
                    TipsViewSystem.show("已达到最大等级");
                }
                else {
                    net.upUnionSkill(this.selectskillID, function () {
                        _this.updateView(_this.curSelectSkillType);
                    }, this);
                }
                break;
        }
    };
    GuildSkillView.prototype.updateView = function (skillType) {
        this.curSelectSkillType = skillType;
        GuildData.inst().setSelectSkillType(skillType);
        var skillTypeInfo = GuildData.inst().getSkillTypeList(skillType);
        var skillMap = MyData.user.json.unionInfo.skillMap;
        for (var i = 0; i < skillTypeInfo.length; i++) {
            this.skillList[i].getChild("skillIndex").asTextField.text = i + 1;
            this.setLoaderUrl(this.skillList[i].getChild("skillIcon").asLoader, skillTypeInfo[i].pic);
            this.skillList[i].getChild("level").asTextField.text = (skillMap[skillTypeInfo[i].id] || 0) + "/" + skillTypeInfo[i].lvMax;
            this.skillList[i].data = skillTypeInfo[i];
            var skillLevel = skillMap[skillTypeInfo[i].depend] || 0;
            this.skillList[i].enabled = skillTypeInfo[i].depend == 0 || skillLevel >= skillTypeInfo[i].dependLevel;
        }
        this.updateSkillInfoView();
    };
    GuildSkillView.prototype.updateSkillInfoView = function () {
        var skillMap = MyData.user.json.unionInfo.skillMap;
        var skillInfo = this.skillList[this.selectSkillIndex].data;
        this.selectskillID = skillInfo.id;
        var skillLevel = skillMap[this.selectskillID] || 0;
        this.setLoaderUrl(this.heroSkill.getChild("skillIcon").asLoader, skillInfo.pic);
        this.heroSkill.getChild("level").asTextField.text = skillLevel + "/" + skillInfo.lvMax;
        this.heroSkill.getChild("indexGroup").asGroup.visible = false;
        this.skillName.text = skillInfo.name;
        this.skillLevel.text = skillLevel + "/" + skillInfo.lvMax;
        var needMoney = skillLevel * skillInfo.gold + skillInfo.goldBase;
        this.enoughMoney = MyData.user.money >= needMoney;
        var color = this.enoughMoney ? Color.white : Color.red;
        var moneyStr = "[color=" + color + "]" + Common.overLength(needMoney) + "[/color]";
        this.moneyNum.text = moneyStr;
        var itemCount = SummonData.inst().GetItemnumByid(skillInfo.item);
        var needItemCount = skillLevel * skillInfo.itemNum + skillInfo.itemNumBase;
        this.enoughItem = itemCount >= needItemCount;
        var color2 = this.enoughItem ? Color.white : Color.red;
        var itemStr = "[color=" + color + "]" + Common.overLength(needItemCount) + "[/color]";
        this.DonateNum.text = itemStr;
        for (var i = 1; i < this.skillAttrList.length; i++) {
            var isNull = skillInfo["attr" + i] != 0;
            this.skillAttrList[i]["attrType" + i].visible = isNull;
            if (isNull) {
                var skillAttrType = skillInfo["attr" + i];
                var attrValue = skillInfo["attrNum" + i];
                var skillName = GuildData.inst().getAttrType(skillAttrType);
                this.skillAttrList[i]["skillAttrText" + i].text = skillName;
                var isShowPercentage = skillAttrType != 1 && skillAttrType != 4 && skillAttrType != 5;
                this.skillAttrList[i]["skillCurAtrrVal" + i].text = isShowPercentage ? ((skillLevel * attrValue) / 100) + "%" : skillLevel * attrValue;
                this.isMaxLevel = skillLevel == skillInfo.lvMax;
                if (this.isMaxLevel) {
                    this.skillAttrList[i]["skillNextAtrrVal" + i].visible = false;
                    this.skillAttrList[i]["imgArrows" + i].visible = false;
                }
                else {
                    this.skillAttrList[i]["skillNextAtrrVal" + i].visible = true;
                    this.skillAttrList[i]["imgArrows" + i].visible = true;
                    this.skillAttrList[i]["skillNextAtrrVal" + i].text = isShowPercentage ? (((skillLevel + 1) * attrValue) / 100) + "%" : (skillLevel + 1) * attrValue;
                }
            }
        }
    };
    return GuildSkillView;
}(ak.EasyUI));
__reflect(GuildSkillView.prototype, "GuildSkillView");
//公会
var GuildSystem = (function (_super) {
    __extends(GuildSystem, _super);
    function GuildSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GuildSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guild");
    };
    GuildSystem.inst = new GuildSystem("Guild");
    return GuildSystem;
}(ak.FairyGUI));
__reflect(GuildSystem.prototype, "GuildSystem");
//主界面
var GuildView = (function (_super) {
    __extends(GuildView, _super);
    function GuildView() {
        return _super.call(this, GuildSystem.inst, MyGame.inst.uiLayer) || this;
    }
    //初始化回调
    GuildView.prototype.onInit = function () {
        this.ui = this.create("Guild", "GuildView");
        this.mailBtn = this.ui.getChild("mailBtn").asButton;
        this.chatBtn = this.ui.getChild("chatBtn").asButton;
        this.dating = this.ui.getChild("n54").asCom;
        this.zhengfeng = this.ui.getChild("n55").asCom;
        this.jineng = this.ui.getChild("n56").asCom;
        this.shangdian = this.ui.getChild("n57").asCom;
        this.maoxian = this.ui.getChild("n58").asCom;
        this.tanbao = this.ui.getChild("n59").asCom;
        this.gongxian = this.ui.getChild("n60").asCom;
        TopViewSystem.topViewUI.kongzhiqi(2);
        this.clickAdd();
        this.updateview1();
    };
    //请求
    GuildView.prototype.updateview1 = function () {
        net.myUnionInfo(this.updateView, this);
    };
    GuildView.prototype.onDestroy = function () {
        TopViewSystem.topViewUI.kongzhiqi(0);
    };
    GuildView.prototype.clickAdd = function () {
        this.addClickListener(this.mailBtn, this.onClick, this);
        this.addClickListener(this.chatBtn, this.onClick, this);
        this.addClickListener(this.dating, this.onClick, this);
        this.addClickListener(this.zhengfeng, this.onClick, this);
        this.addClickListener(this.jineng, this.onClick, this);
        this.addClickListener(this.shangdian, this.onClick, this);
        this.addClickListener(this.maoxian, this.onClick, this);
        this.addClickListener(this.tanbao, this.onClick, this);
        this.addClickListener(this.gongxian, this.onClick, this);
        this.on(GameEvent.flushGuildViewRedPoint, this.flushRedPoint, this);
    };
    GuildView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.mailBtn:
                ak.FairyGUI.open(["MailView"]); //邮件
                break;
            case this.chatBtn:
                ak.FairyGUI.open(["ChatView"]); //聊天
                break;
            case this.dating:
                ak.FairyGUI.open(["GuildLobbyView"]); //大厅
                break;
            case this.zhengfeng:
                ak.FairyGUI.open(["GuildWarView"]); //公会战
                break;
            case this.jineng:
                ak.FairyGUI.open(["GuildSkillView"]); //技能
                break;
            case this.shangdian:
                ak.FairyGUI.open(["GuildShopView"]); //商店 
                break;
            case this.maoxian:
                ak.FairyGUI.open(["GuildAdventureView"]); //冒险
                break;
            case this.tanbao:
                break;
            case this.gongxian:
                ak.FairyGUI.open(["GuildDonateView"]); //捐献
                break;
        }
    };
    GuildView.prototype.updateView = function () {
        //获取label
        var datinglabel = this.dating.getChild("n0").asLabel;
        var zhengfenglabel = this.zhengfeng.getChild("n0").asLabel;
        var jinenglabel = this.jineng.getChild("n0").asLabel;
        var shangdianlabel = this.shangdian.getChild("n0").asLabel;
        var maoxianlabel = this.maoxian.getChild("n0").asLabel;
        var tanbaolabel = this.tanbao.getChild("n0").asLabel;
        var gongxianlabel = this.gongxian.getChild("n0").asLabel;
        //获取标题
        var datinglabeltext = datinglabel.getChild("title").asTextField;
        var zhengfenglabeltext = zhengfenglabel.getChild("title").asTextField;
        var jinenglabeltext = jinenglabel.getChild("title").asTextField;
        var shangdianlabeltext = shangdianlabel.getChild("title").asTextField;
        var maoxianlabeltext = maoxianlabel.getChild("title").asTextField;
        var tanbaolabeltext = tanbaolabel.getChild("title").asTextField;
        var gongxianlabeltext = gongxianlabel.getChild("title").asTextField;
        //文字
        datinglabeltext.text = "大厅";
        zhengfenglabeltext.text = "公会争锋";
        jinenglabeltext.text = "公会技能";
        shangdianlabeltext.text = "公会商店";
        maoxianlabeltext.text = "公会冒险";
        tanbaolabeltext.text = "公会探宝";
        gongxianlabeltext.text = "公会贡献";
        this.flushRedPoint();
    };
    //刷新公会主界面红点
    GuildView.prototype.flushRedPoint = function () {
        this.gongxian.getController("c1").selectedIndex = RedDotMgr.guildDonateRedPoint() ? 1 : 0;
    };
    return GuildView;
}(ak.EasyUI));
__reflect(GuildView.prototype, "GuildView");
//王者
var GuildwangzheViewSystem = (function (_super) {
    __extends(GuildwangzheViewSystem, _super);
    function GuildwangzheViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GuildwangzheViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guild");
    };
    GuildwangzheViewSystem.inst = new GuildwangzheViewSystem("Guild");
    return GuildwangzheViewSystem;
}(ak.FairyGUI));
__reflect(GuildwangzheViewSystem.prototype, "GuildwangzheViewSystem");
var GuildwangzheView = (function (_super) {
    __extends(GuildwangzheView, _super);
    function GuildwangzheView() {
        return _super.call(this, GuildwangzheViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
    }
    GuildwangzheView.prototype.onInit = function () {
        this.ui = this.create("Guild", "GuildwangzheView");
        this.backBtn = this.ui.getChild("closebtn").asButton;
        this.titileLabel = this.ui.getChild("title").asLabel;
        this.leftarrow = this.ui.getChild("left").asButton;
        this.rightarrow = this.ui.getChild("right").asButton;
        this.no1 = this.ui.getChild("n1").asCom;
        this.no2 = this.ui.getChild("n2").asCom;
        this.no3 = this.ui.getChild("n3").asCom;
        this.bg1Controller = this.no1.getController("c1");
        this.bg1Controller.selectedIndex = 0;
        this.bg2Controller = this.no2.getController("c1");
        this.bg2Controller.selectedIndex = 1;
        this.bg3Controller = this.no3.getController("c1");
        this.bg3Controller.selectedIndex = 2;
        this.notext1 = this.no1.getChild("notext").asTextField;
        this.notext2 = this.no2.getChild("notext").asTextField;
        this.notext3 = this.no3.getChild("notext").asTextField;
        this.notext1.text = "1";
        this.notext2.text = "2";
        this.notext3.text = "3";
        this.curPageNum = 1;
        this.maxPage = 16;
        this.clickAdd();
        this.updateView();
    };
    GuildwangzheView.prototype.clickAdd = function () {
        this.addClickListener(this.backBtn, this.onClick, this);
        this.addClickListener(this.rightarrow, this.onClick, this);
        this.addClickListener(this.leftarrow, this.onClick, this);
    };
    GuildwangzheView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.backBtn:
                this.close();
                break;
            case this.rightarrow:
                this.Downpage();
                break;
            case this.leftarrow:
                this.Uppage();
                break;
        }
    };
    //下一页
    GuildwangzheView.prototype.Downpage = function () {
        if (this.curPageNum != this.maxPage) {
            this.curPageNum++;
            this.updateView();
        }
    };
    //上一页
    GuildwangzheView.prototype.Uppage = function () {
        if (this.curPageNum > 1) {
            this.curPageNum--;
            this.updateView();
        }
    };
    GuildwangzheView.prototype.updateView = function () {
        this.titileLabel.text = "S" + this.curPageNum + "赛季";
    };
    return GuildwangzheView;
}(ak.EasyUI));
__reflect(GuildwangzheView.prototype, "GuildwangzheView");
//公会战  排行榜
var GuildWarRankingViewSystem = (function (_super) {
    __extends(GuildWarRankingViewSystem, _super);
    function GuildWarRankingViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GuildWarRankingViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guild");
    };
    GuildWarRankingViewSystem.inst = new GuildWarRankingViewSystem("Guild");
    return GuildWarRankingViewSystem;
}(ak.FairyGUI));
__reflect(GuildWarRankingViewSystem.prototype, "GuildWarRankingViewSystem");
var GuildWarRankingView = (function (_super) {
    __extends(GuildWarRankingView, _super);
    function GuildWarRankingView() {
        return _super.call(this, GuildWarRankingViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
    }
    GuildWarRankingView.prototype.onInit = function () {
        this.ui = this.create("Guild", "GuildWarRankingView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.qiehuan = this.ui.getChild("qiehuan").asCom;
        this.leftbtn = this.qiehuan.getChild("leftbtn").asButton;
        this.rightbtn = this.qiehuan.getChild("rightbtn").asButton;
        this.lefttitle = this.leftbtn.getChild("title").asTextField;
        this.righttitle = this.rightbtn.getChild("title").asTextField;
        this.wangzhelist = this.ui.getChild("wangzhelist").asList;
        this.saijilist = this.ui.getChild("saijilist").asList;
        this.statetext = this.ui.getChild("state").asTextField;
        this.guildrankingtext = this.ui.getChild("guildranking").asTextField;
        this.loader = this.ui.getChild("loader").asLoader;
        this.loaderController = this.ui.getController("isnull");
        this.loaderController.selectedIndex = 0; //为空 什么都没有BG
        this.lefttitle.text = "王者排行";
        this.righttitle.text = "赛季奖励";
        this.rightbtn.selected = true;
        this.listController = this.ui.getController("listController");
        this.listController.selectedIndex = 1; //赛季奖励 列表 为1时显示
        this.clickAdd();
        this.updateView();
        this.updateview1();
    };
    //请求
    GuildWarRankingView.prototype.updateview1 = function () {
        net.myUnionInfo(this.updateView, this);
    };
    GuildWarRankingView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.leftbtn, this.onClick, this);
        this.addClickListener(this.rightbtn, this.onClick, this);
    };
    GuildWarRankingView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.leftbtn:
                this.leftbtn.selected = true;
                this.rightbtn.selected = false;
                this.listController.selectedIndex = 0;
                //这里判断 list里面的内容 为不为空
                this.updateView();
                break;
            case this.rightbtn:
                this.leftbtn.selected = false;
                this.rightbtn.selected = true;
                this.listController.selectedIndex = 1;
                this.loaderController.selectedIndex = 0;
                this.updateView();
                break;
        }
    };
    //点击赛季奖励表详情
    GuildWarRankingView.prototype.itemonclick = function (e) {
        var awarditem = e.itemObject.data;
        if (awarditem.item_type == 3)
            ak.FairyGUI.open(["ResourceTipsView", awarditem.item_id, awarditem.item_count]);
        else
            ak.FairyGUI.open(["WeaponTipsView", awarditem.item_id, awarditem.item_count, awarditem.item_type]);
    };
    GuildWarRankingView.prototype.updateView = function () {
        if (this.rightbtn.selected == true) {
            this.saijilist.removeChildrenToPool();
            for (var i = 0; i < 5; i++) {
                var info = this.saijilist.addItemFromPool().asCom;
                var awardlist = info.getChild("saijilist").asList;
                awardlist.removeChildrenToPool();
                for (var j = 0; j < 4; j++) {
                    var awardinfo = awardlist.addItemFromPool().asCom;
                    var itemBase = new ItemBase(awardinfo, this, 1); //商品类型
                    itemBase.setItemData(2001 + j); //商品ID
                    itemBase.setNumber("5000", true); //商品数量
                    awardinfo.data = { item_id: 2001 + j, item_count: 5000, item_type: 1 };
                }
                this.onFairyguiEvent(awardlist, fairygui.ItemEvent.CLICK, this.itemonclick, this);
            }
        }
        else {
            //  this.loaderController.selectedIndex = 1;//为空 什么都没有BG
            this.wangzhelist.removeChildrenToPool();
            for (var i = 0; i < 5; i++) {
                var info = this.wangzhelist.addItemFromPool().asCom;
                var infohead = info.getChild("icon").asLoader; //公会头像
                var infolevelup = info.getChild("levelup").asLoader; //是否晋级
                var infoname = info.getChild("name").asTextField; //名字
                var infozhanli = info.getChild("zhanlitext").asTextField; //战力
                var infojifen = info.getChild("jifentext").asTextField; //积分
                var inforanknum = info.getChild("ranknum").asTextField; //排名
                if (i == 0 || i == 1 || i == 2) {
                    info.getController("c1").selectedIndex = i + 1;
                }
                else {
                    inforanknum.text = i + 1 + "";
                }
                //   if(MyData.myUnionInfo.id){
                //       this.statetext.text ="状态";
                //       this.guildrankingtext.text ="本会排名" + i;
                //   }
                this.setLoaderUrl(infohead, 'img_qz_02_png');
            }
        }
    };
    return GuildWarRankingView;
}(ak.EasyUI));
__reflect(GuildWarRankingView.prototype, "GuildWarRankingView");
//公会战
var GuildWarViewSystem = (function (_super) {
    __extends(GuildWarViewSystem, _super);
    function GuildWarViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    GuildWarViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guild");
    };
    GuildWarViewSystem.inst = new GuildWarViewSystem("Guild");
    return GuildWarViewSystem;
}(ak.FairyGUI));
__reflect(GuildWarViewSystem.prototype, "GuildWarViewSystem");
var GuildWarView = (function (_super) {
    __extends(GuildWarView, _super);
    function GuildWarView() {
        var _this = _super.call(this, GuildWarViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
        _this.ischallenge = true; //是否有挑战 按钮
        return _this;
    }
    GuildWarView.prototype.onInit = function () {
        DownViewSystem.hide();
        this.ui = this.create("Guild", "GuildWarView");
        this.saijicount = this.ui.getChild("text1").asTextField;
        this.saijiname = this.ui.getChild("text2").asTextField;
        this.backBtn = this.ui.getChild("closebtn").asButton;
        // this.helpBtn
        this.baoxiangBtn = this.ui.getChild("baoxiang").asButton;
        this.rankingBtn = this.ui.getChild("ranking").asButton;
        this.wangzheBtn = this.ui.getChild("wangzhe").asButton;
        this.warmessageBtn = this.ui.getChild("warmessage").asButton;
        this.saiquBtn = this.ui.getChild("saiqu").asButton;
        this.time = this.ui.getChild("time").asTextField;
        this.list = this.ui.getChild("guildwarlist").asList;
        this.duanweiController = this.ui.getController("duanwei");
        this.hongfang = this.ui.getChild("red").asCom;
        this.lanfang = this.ui.getChild("bule").asCom;
        //默认情况 蓝方被选中 红方未选中 1表示未选中，0表示选中
        this.hongfangischoose = this.hongfang.getController("ischoose");
        this.hongfangischoose.selectedIndex = 1;
        this.lanfangischoose = this.lanfang.getController("ischoose");
        this.lanfangischoose.selectedIndex = 0;
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.timedown, this);
        this.clickAdd();
        this.updateView();
    };
    GuildWarView.prototype.clickAdd = function () {
        this.addClickListener(this.backBtn, this.onClick, this);
        this.addClickListener(this.baoxiangBtn, this.onClick, this);
        this.addClickListener(this.rankingBtn, this.onClick, this);
        this.addClickListener(this.wangzheBtn, this.onClick, this);
        this.addClickListener(this.warmessageBtn, this.onClick, this);
        this.addClickListener(this.saiquBtn, this.onClick, this);
        this.addClickListener(this.hongfang, this.onClick, this);
        this.addClickListener(this.lanfang, this.onClick, this);
        this.onFairyguiEvent(this.list, fairygui.ItemEvent.CLICK, this.itemonclick, this);
    };
    GuildWarView.prototype.itemonclick = function (e) {
        var item = e.itemObject;
        var tiaozhanBtn = item.getChild("tiaozhanBtn").asButton;
        if (this.hitTestPointWithFairyGUIComponent(tiaozhanBtn, e.stageX, e.stageY)) {
            ak.log(tiaozhanBtn.data.index);
        }
    };
    GuildWarView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.backBtn:
                this.close();
                DownViewSystem.show();
                break;
            // case this.helpBtn:
            case this.baoxiangBtn:
                ak.FairyGUI.open(["GuildBaoXiangView"]);
                break;
            case this.rankingBtn:
                ak.FairyGUI.open(["GuildWarRankingView"]);
                break;
            case this.wangzheBtn:
                ak.FairyGUI.open(["GuildwangzheView"]);
                break;
            case this.warmessageBtn:
                ak.FairyGUI.open(["WarMssageView"]);
                break;
            case this.saiquBtn:
                ak.FairyGUI.open(["GuildSaiquRankingView"]);
                break;
            case this.hongfang:
                this.hongfangischoose.selectedIndex = 0;
                this.lanfangischoose.selectedIndex = 1;
                this.ischallenge = false;
                this.updateView();
                break;
            case this.lanfang:
                this.hongfangischoose.selectedIndex = 1;
                this.lanfangischoose.selectedIndex = 0;
                this.ischallenge = true;
                this.updateView();
                break;
        }
    };
    //倒计时暂时定成这样
    GuildWarView.prototype.timedown = function () {
        var time = DateUtils.getWeeHours10Time() - ak.time();
        var text = DateUtils.getFormatBySecond(time, DateUtils.TIME_FORMAT_12);
        if (time >= 0)
            this.time.text = text;
    };
    //设置列表内容
    GuildWarView.prototype.setlist = function (Tab) {
        this.list.removeChildrenToPool();
        var arr = Tab; //= Object.keys(MyData.myUnionInfo.json.bossMap[index].hurtMap)
        var arrCount = arr.length;
        // this.isnull.selectedIndex = arrCount>0 ? 1:0;
        var newArr = arr.map(Number);
        if (arrCount > 1) {
            for (var i = 0; i < arrCount - 1; i++) {
                for (var j = 0; j < arr.length - 1 - i; j++) {
                    var index1 = newArr[j];
                    var index2 = newArr[j + 1];
                    // if(it[index1].hurt<it[index2].hurt){
                    // 	let temp=newArr[j];
                    // 	newArr[j]=newArr[j+1];
                    // 	newArr[j+1]=temp;
                    // }
                }
            }
        }
        for (var i = 0; i < arrCount; i++) {
            var info = this.list.addItemFromPool().asCom;
            var infohead = info.getChild("head").asCom; //头像com
            var infoname = info.getChild("name").asTextField; //姓名
            var infofenshu = info.getChild("fentext").asTextField; //分数
            var infozhanli = info.getChild("zhanlitext").asTextField; //战力
            var infobutton = info.getChild("tiaozhanBtn").asButton;
            infobutton.visible = this.ischallenge ? true : false;
            var infozhengrong = info.getChild("list").asList; //阵容
            infozhengrong.removeChildrenToPool();
            for (var i_8 = 0; i_8 < 6; i_8++) {
                var teaminfo = infozhengrong.addItemFromPool().asCom;
            }
            for (var i_9 = 3; i_9 > 0; i_9--) {
                var cishuitem = info.getChild("cishu" + i_9);
                var xinitem = info.getChild("xin" + i_9);
            }
            infobutton.data = { index: i };
            var itemBase = new ItemBase(infohead, this, 2);
            itemBase.setItemData(25023);
        }
    };
    GuildWarView.prototype.updateView = function () {
        this.duanweiController.selectedIndex = 2;
        //暂时这么写
        var arr = [0, 1, 2, 3];
        this.setlist(arr);
        for (var i = 3; i > 0; i--) {
            var hongfangcishuitem = this.hongfang.getChild("n1" + i).asCom;
            // if(<i){
            //     cishuitem.visible = false;
            // }
            // else{
            //     cishuitem.visible = true;
            // }
        }
    };
    return GuildWarView;
}(ak.EasyUI));
__reflect(GuildWarView.prototype, "GuildWarView");
//战斗信息
var WarMssageViewSystem = (function (_super) {
    __extends(WarMssageViewSystem, _super);
    function WarMssageViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    WarMssageViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Guild");
    };
    WarMssageViewSystem.inst = new WarMssageViewSystem("Guild");
    return WarMssageViewSystem;
}(ak.FairyGUI));
__reflect(WarMssageViewSystem.prototype, "WarMssageViewSystem");
var WarMssageView = (function (_super) {
    __extends(WarMssageView, _super);
    function WarMssageView() {
        return _super.call(this, WarMssageViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
    }
    WarMssageView.prototype.onInit = function () {
        this.ui = this.create("Guild", "WarMssageView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.messagelist = this.ui.getChild("messagelist").asList;
        this.jingongBtn = this.ui.getChild("jingongBtn").asButton;
        this.fangshouBtn = this.ui.getChild("fangshouBtn").asButton;
        this.clickAdd();
        this.updateView();
    };
    WarMssageView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.jingongBtn, this.onClick, this);
        this.addClickListener(this.fangshouBtn, this.onClick, this);
    };
    WarMssageView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.jingongBtn:
                break;
            case this.fangshouBtn:
                break;
        }
    };
    WarMssageView.prototype.updateView = function () {
        this.messagelist.removeChildrenToPool();
        for (var i = 0; i < 3; i++) {
            var info = this.messagelist.addItemFromPool().asCom;
        }
    };
    return WarMssageView;
}(ak.EasyUI));
__reflect(WarMssageView.prototype, "WarMssageView");
/**
 * 英雄背包数据
 */
var HeroBagData = (function () {
    function HeroBagData() {
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    HeroBagData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new HeroBagData();
        }
        return Class._instance;
    };
    /**根据index,paginalIndex返回英雄数组 */
    HeroBagData.prototype.GetHeroGroupInfoByIndex = function (index, paginalIndex) {
        var heroGroups = [];
        var heroTab = ak.JsonTableMgr.get("hero");
        switch (index) {
            case 0:
                for (var i = 0; i < HeroBagData.cardArr().length; i++) {
                    heroGroups.push(HeroBagData.cardArr()[i]);
                }
                heroGroups.sort(this.GroupSort1);
                break;
            case 1:
            case 2:
            case 3:
            case 4:
            case 5:
            case 6:
                if (paginalIndex == 0) {
                    for (var i = 0; i < HeroBagData.cardArr().length; i++) {
                        var heroInfo = heroTab.getRowFromColName("id", "" + HeroBagData.cardArr()[i][1].heroID);
                        var type = heroInfo.getValFromColName("race");
                        if (type == index) {
                            heroGroups.push(HeroBagData.cardArr()[i]);
                        }
                    }
                    heroGroups.sort(this.GroupSort1);
                }
                else {
                    for (var i = 0; i < heroTab.size(); i++) {
                        var heroInfo = heroTab.getRow(i);
                        var type = heroInfo.getValFromColName("race");
                        var isShow = heroInfo.getValFromColName("isShow");
                        if (type == index && isShow == 1) {
                            var heroID = heroInfo.getValFromColName("id");
                            var race = heroInfo.getValFromColName("race");
                            var star = heroInfo.getValFromColName("star");
                            var level = HeroBagData.HeroBookLevel[star - 1];
                            var heroinfo = { heroID: heroID, race: race, starMax: star, level: level };
                            heroGroups.push([0, heroinfo]);
                        }
                    }
                    heroGroups.sort(this.GroupSort2);
                }
                break;
        }
        return heroGroups;
    };
    /**根据index,paginalIndex返回英雄数组
     * 远征用
    */
    HeroBagData.prototype.GetHeroGroupInfoByIndex2 = function (index, paginalIndex) {
        var heroGroups = [];
        var heroTab = ak.JsonTableMgr.get("hero");
        switch (index) {
            case 0:
                for (var i = 0; i < HeroBagData.cardArr().length; i++) {
                    if (HeroBagData.cardArr()[i][1].level >= 40) {
                        heroGroups.push(HeroBagData.cardArr()[i]);
                    }
                }
                heroGroups.sort(this.GroupSort1);
                break;
            case 1:
            case 2:
            case 3:
            case 4:
            case 5:
            case 6:
                if (paginalIndex == 0) {
                    for (var i = 0; i < HeroBagData.cardArr().length; i++) {
                        var heroInfo = heroTab.getRowFromColName("id", "" + HeroBagData.cardArr()[i][1].heroID);
                        var type = heroInfo.getValFromColName("race");
                        if (type == index && HeroBagData.cardArr()[i][1].level >= 40) {
                            heroGroups.push(HeroBagData.cardArr()[i]);
                        }
                    }
                    heroGroups.sort(this.GroupSort1);
                }
                else {
                    for (var i = 0; i < heroTab.size(); i++) {
                        var heroInfo = heroTab.getRow(i);
                        var type = heroInfo.getValFromColName("race");
                        var isShow = heroInfo.getValFromColName("isShow");
                        if (type == index && isShow == 1) {
                            var heroID = heroInfo.getValFromColName("id");
                            var race = heroInfo.getValFromColName("race");
                            var star = heroInfo.getValFromColName("star");
                            var level = HeroBagData.HeroBookLevel[star - 1];
                            var heroinfo = { heroID: heroID, race: race, starMax: star, level: level };
                            heroGroups.push([0, heroinfo]);
                        }
                    }
                    heroGroups.sort(this.GroupSort2);
                }
                break;
        }
        return heroGroups;
    };
    /**
     * 英雄数组排序
     * { 1级为星级,2级为等级,3级为类型 }
     */
    HeroBagData.prototype.GroupSort1 = function (a, b) {
        var heroTab = ak.JsonTableMgr.get("hero");
        var aheroInfo = heroTab.getRowFromColName("id", "" + a[1].heroID);
        var astar = aheroInfo.getValFromColName("star");
        var alevel = a[1].level;
        var atype = aheroInfo.getValFromColName("race");
        var bheroInfo = heroTab.getRowFromColName("id", "" + b[1].heroID);
        var bstar = bheroInfo.getValFromColName("star");
        var blevel = b[1].level;
        var btype = bheroInfo.getValFromColName("race");
        if (astar > bstar)
            return -1;
        if (astar < bstar)
            return 1;
        if (astar == bstar) {
            if (alevel > blevel)
                return -1;
            if (alevel < blevel)
                return 1;
            if (alevel == blevel) {
                if (atype > btype)
                    return 1;
                if (atype < btype)
                    return -1;
            }
        }
        return 0;
    };
    /**
     * 图鉴数组排序
     * { 倒叙 }
     */
    HeroBagData.prototype.GroupSort2 = function (a, b) {
        var heroTab = ak.JsonTableMgr.get("hero");
        var aheroInfo = heroTab.getRowFromColName("id", "" + a[1].heroID);
        var astar = aheroInfo.getValFromColName("star");
        var alevel = a[1].level;
        var atype = aheroInfo.getValFromColName("race");
        var bheroInfo = heroTab.getRowFromColName("id", "" + b[1].heroID);
        var bstar = bheroInfo.getValFromColName("star");
        var blevel = b[1].level;
        var btype = bheroInfo.getValFromColName("race");
        if (astar > bstar)
            return 1;
        if (astar < bstar)
            return -1;
        if (astar == bstar) {
            if (alevel > blevel)
                return 1;
            if (alevel < blevel)
                return -1;
            if (alevel == blevel) {
                if (atype > btype)
                    return -1;
                if (atype < btype)
                    return 1;
            }
        }
        return 0;
    };
    /**
     * 根据id判断自己是否拥有该英雄
     */
    HeroBagData.prototype.isInHeroGroup = function (itemID) {
        var keys = [];
        for (var key in MyData.user.json.cardIDMap) {
            keys.push(key);
        }
        for (var i = 0; i < keys.length; i++) {
            if (itemID == Number(keys[i])) {
                return true;
            }
        }
        return false;
    };
    /**获取英雄列表长度 */
    HeroBagData.prototype.GetHeroGroupLength = function () {
        var length = HeroBagData.cardArr().length;
        return length;
    };
    ;
    /**获取当前网格的数量 */
    HeroBagData.prototype.GetGridNum = function () {
        var number = CardMgr.getCardMaxCount();
        return number;
    };
    HeroBagData.prototype.GetRaceById = function (heroID) {
        var heroTab = ak.JsonTableMgr.get("hero");
        var heroInfo = heroTab.getRowFromColName("id", "" + heroID);
        var race = heroInfo.getValFromColName("race");
        return race;
    };
    HeroBagData.prototype.GetStarById = function (heroID) {
        var heroTab = ak.JsonTableMgr.get("hero");
        var heroInfo = heroTab.getRowFromColName("id", "" + heroID);
        var star = heroInfo.getValFromColName("star");
        return star;
    };
    HeroBagData.prototype.GetRaceById2 = function (heroID) {
        var heroTab = ak.JsonTableMgr.get("itemPiece");
        var heroInfo = heroTab.getRowFromColName("id", "" + heroID);
        var race = heroInfo.getValFromColName("race");
        return race;
    };
    HeroBagData.prototype.GetStarById2 = function (heroID) {
        var heroTab = ak.JsonTableMgr.get("itemPiece");
        var heroInfo = heroTab.getRowFromColName("id", "" + heroID);
        var star = heroInfo.getValFromColName("star");
        return star;
    };
    HeroBagData.prototype.GetNameById = function (heroID) {
        var heroTab = ak.JsonTableMgr.get("hero");
        var heroInfo = heroTab.getRowFromColName("id", "" + heroID);
        var name1 = heroInfo.getValFromColName("name");
        return name1;
    };
    /**
     * 注：此id为卡片数组的卡片唯一标示并非heroID
     */
    HeroBagData.prototype.GetIndexByid = function (id) {
        for (var i = 0; i < HeroBagData.cardArr().length; i++) {
            if (id == HeroBagData.cardArr()[i][1].id) {
                return HeroBagData.cardArr()[i][0];
            }
        }
        return -1;
    };
    /**
     * 获取指定index的卡片内容
     */
    HeroBagData.prototype.GetcardByIndex = function (index) {
        for (var i = 0; i < HeroBagData.cardArr().length; i++) {
            if (index == HeroBagData.cardArr()[i][0]) {
                return HeroBagData.cardArr()[i];
            }
        }
        return null;
    };
    /**
     * 本地英雄数组
     *
     */
    HeroBagData.cardArr = function () {
        var cardArr = [];
        for (var i = 0; i < MyData.user.json.cardArr.length; i++) {
            cardArr.push([i, MyData.user.json.cardArr[i]]);
        }
        return cardArr;
    };
    /**图鉴英雄等级 */
    HeroBagData.HeroBookLevel = [40, 50, 60, 80, 100, 140, 160, 180, 200, 250];
    return HeroBagData;
}());
__reflect(HeroBagData.prototype, "HeroBagData");
/**
 * 英雄背包系统
 */
var HeroBagViewSystem = (function (_super) {
    __extends(HeroBagViewSystem, _super);
    function HeroBagViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    HeroBagViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("HeroBagView");
    };
    HeroBagViewSystem.inst = new HeroBagViewSystem("HeroBagView");
    return HeroBagViewSystem;
}(ak.FairyGUI));
__reflect(HeroBagViewSystem.prototype, "HeroBagViewSystem");
/**
 * 英雄背包界面
 */
var HeroBagView = (function (_super) {
    __extends(HeroBagView, _super);
    function HeroBagView() {
        var _this = _super.call(this, HeroBagViewSystem.inst, MyGame.inst.uiLayer) || this;
        /**英雄数组数据 */
        _this.heroGroups = [];
        return _this;
    }
    /**回调 */
    HeroBagView.prototype.onInit = function () {
        var ui = this.create("HeroBagView", "HeroBagView");
        this.on("netmsg://bag/upgradeCardMaxCountResult", this.updateGrid, this);
        this.on("netmsg://bag/cardUPResult", this.updateGrid, this);
        this.on(GameEvent.heroLvUp, this.updateInfo2, this);
        this.herobtn = ui.getChild("herobtn").asButton;
        this.tujianbtn = ui.getChild("tujianbtn").asButton;
        this.itemlist = ui.getChild("itemlist").asCom;
        this.list = ui.getChild("list").asList;
        this.itemnum = ui.getChild("itemnum").asTextField;
        this.addnumbtn = ui.getChild("addnumbtn").asButton;
        this.btn0 = this.itemlist.getChild("btn0").asButton;
        this.btn1 = this.itemlist.getChild("btn1").asButton;
        this.btn2 = this.itemlist.getChild("btn2").asButton;
        this.btn3 = this.itemlist.getChild("btn3").asButton;
        this.btn4 = this.itemlist.getChild("btn4").asButton;
        this.btn5 = this.itemlist.getChild("btn5").asButton;
        this.btn6 = this.itemlist.getChild("btn6").asButton;
        this.tipsbtn = this.ui.getChild("tipsbtn").asButton;
        this.index = 0;
        this.paginalIndex = 0;
        this.ClickAdd();
        this.setHeroGroupInfo();
        this.updateList();
        this.updateGrid();
    };
    HeroBagView.prototype.ClickAdd = function () {
        this.addClickListener(this.herobtn, this.onClick, this);
        this.addClickListener(this.tujianbtn, this.onClick, this);
        this.addClickListener(this.addnumbtn, this.onClick, this);
        this.addClickListener(this.tipsbtn, this.onClick, this);
        this.addClickListener(this.btn0, this.onClick, this);
        this.addClickListener(this.btn1, this.onClick, this);
        this.addClickListener(this.btn2, this.onClick, this);
        this.addClickListener(this.btn3, this.onClick, this);
        this.addClickListener(this.btn4, this.onClick, this);
        this.addClickListener(this.btn5, this.onClick, this);
        this.addClickListener(this.btn6, this.onClick, this);
        this.onFairyguiEvent(this.list, fairygui.ItemEvent.CLICK, this.itemonclick, this);
    };
    HeroBagView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.herobtn:
                this.paginalIndex = 0;
                this.btn0.visible = true;
                this.itemlist.x = 71;
                this.updateBtn();
                this.updateInfo(0);
                break;
            case this.tujianbtn:
                this.paginalIndex = 1;
                this.btn0.visible = false;
                this.itemlist.x = 41;
                this.updateBtn();
                this.updateInfo(1);
                break;
            case this.btn0:
                this.updateInfo(0);
                break;
            case this.btn1:
                this.updateInfo(1);
                break;
            case this.btn2:
                this.updateInfo(2);
                break;
            case this.btn3:
                this.updateInfo(3);
                break;
            case this.btn4:
                this.updateInfo(4);
                break;
            case this.btn5:
                this.updateInfo(5);
                break;
            case this.btn6:
                this.updateInfo(6);
                break;
            case this.addnumbtn:
                ak.FairyGUI.open(["ChooseTipsView", 0, this.chooseTipsViewInfo()]);
                break;
            case this.tipsbtn:
                ak.FairyGUI.open(["RaceHelpView"]);
                break;
        }
    };
    HeroBagView.prototype.updateInfo = function (index) {
        this.index = index;
        this.setHeroGroupInfo();
        this.updateList();
    };
    HeroBagView.prototype.updateInfo2 = function () {
        this.setHeroGroupInfo();
        this.updateList();
    };
    HeroBagView.prototype.updateList = function () {
        this.list.setVirtual();
        this.list.itemRenderer = this.listItemRenderer.bind(this);
        this.list.callbackThisObj = this;
        this.list.numItems = this.heroGroups.length;
        /*
        for(let i=0 ; i < this.heroGroups.length ;i++) {
            let item:fairygui.GComponent = this.list.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
            item.data = {index:this.heroGroups[i][0],id:this.heroGroups[i][1].heroID};
            let items = new ItemBase(item,this,2);
            items.setItemData(this.heroGroups[i][1].heroID,this.heroGroups[i][1].race,this.heroGroups[i][1].starMax);
            items.setNumber(this.heroGroups[i][1].level);
            items.setDark(!HeroBagData.inst().isInHeroGroup(this.heroGroups[i][1].heroID));
        }*/
    };
    HeroBagView.prototype.listItemRenderer = function (i, item) {
        item.data = { index: this.heroGroups[i][0], id: this.heroGroups[i][1].heroID };
        var items = new ItemBase(item.asCom, this, 2);
        items.setItemData(this.heroGroups[i][1].heroID, this.heroGroups[i][1].race, this.heroGroups[i][1].starMax);
        items.setNumber(this.heroGroups[i][1].level);
        items.setDark(!HeroBagData.inst().isInHeroGroup(this.heroGroups[i][1].heroID));
    };
    /**
     * 设置英雄数据
     * 根据index来设置不同英雄的数据
     */
    HeroBagView.prototype.setHeroGroupInfo = function () {
        this.heroGroups = [];
        this.heroGroups = HeroBagData.inst().GetHeroGroupInfoByIndex(this.index, this.paginalIndex);
    };
    /**更新格子数 */
    HeroBagView.prototype.updateGrid = function () {
        this.itemnum.text = HeroBagData.inst().GetHeroGroupLength() + "/" + HeroBagData.inst().GetGridNum();
    };
    /**重置按钮状态 */
    HeroBagView.prototype.updateBtn = function () {
        this.itemlist.getController("qiehuan").selectedIndex = (0);
    };
    HeroBagView.prototype.chooseTipsViewInfo = function () {
        var heroConfigTab = ak.JsonTableMgr.get("heroConfig");
        var heroinfo = heroConfigTab.getRow(0);
        var addNum = heroinfo.getValFromColName("addNum");
        var Zs = heroinfo.getValFromColName("Zs");
        var str = "\u82B1\u8D39" + Zs * (MyData.user.upgradeCardMaxCount + 1) + "\u94BB\u77F3\u8D2D\u4E70" + addNum + "\u4E2A\u82F1\u96C4\u643A\u5E26\u6570\u91CF\u4E0A\u9650?";
        return str;
    };
    /**每个道具的点击事件 */
    HeroBagView.prototype.itemonclick = function (e) {
        if (this.paginalIndex == 0)
            ak.FairyGUI.open(["HeroCultivateView", e.itemObject.data.index, 0, this.heroGroups]);
        if (this.paginalIndex == 1)
            ak.FairyGUI.open(["HeroCultivateView", e.itemObject.data.index, e.itemObject.data.id, this.heroGroups]);
    };
    return HeroBagView;
}(ak.EasyUI));
__reflect(HeroBagView.prototype, "HeroBagView");
//宝石升级转换界面
var BaoshiUpgradeView = (function (_super) {
    __extends(BaoshiUpgradeView, _super);
    function BaoshiUpgradeView(cardIndex, c1Index) {
        var _this = _super.call(this, HeroCultivateSystem.inst, MyGame.inst.uiLayer2_1) || this;
        _this.suo = 0;
        //界面更新
        _this.nameArr = [0, "生命", "%生命", "%精准率", "速度", "攻击", "%攻击", "%破甲", "%技能伤害", "%暴击", "%暴击伤害", "%神圣伤害", "%格挡"];
        _this.doubleArr = [0, 1, 100, 100, 1, 1, 100, 100, 100, 100, 100, 100, 100];
        _this.cardIndex = cardIndex;
        _this.c1Index = c1Index;
        return _this;
    }
    //初始化回调
    BaoshiUpgradeView.prototype.onInit = function () {
        this.ui = this.create("HeroCultivate", "BaoshiUpgradeView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.zhBtn = this.ui.getChild("n10").asButton;
        this.sjBtn = this.ui.getChild("n27").asButton;
        this.gouxuanBtn = this.ui.getChild("n29").asButton;
        this.baocun = this.ui.getChild("n36").asButton;
        this.item1 = this.ui.getChild("n20").asCom;
        this.item2 = this.ui.getChild("n37").asCom;
        this.needMoneyText = this.ui.getChild("n17").asTextField; //
        this.changeNumText = this.ui.getChild("n18").asTextField; //
        this.name1 = this.ui.getChild("name1").asTextField; //宝石名称1
        this.name2 = this.ui.getChild("name2").asTextField; //宝石名称2
        this.typeData1 = this.ui.getChild("typeData1").asTextField; //
        this.typeData2 = this.ui.getChild("typeData2").asTextField; //
        this.typeData3 = this.ui.getChild("typeData3").asTextField; //
        this.typeDataT1 = this.ui.getChild("typeDataT1").asTextField; //
        this.typeDataT2 = this.ui.getChild("typeDataT2").asTextField; //
        this.typeDataT3 = this.ui.getChild("typeDataT3").asTextField; //
        this.stoneTab = ak.JsonTableMgr.get("stone");
        this.stoneAttrTypeTab = ak.JsonTableMgr.get("stoneAttrType");
        this.clickAdd();
        this.showUpdate();
    };
    BaoshiUpgradeView.prototype.showUpdate = function () {
        this.ui.getController("c1").selectedIndex = (this.c1Index);
        var heroInfo = MyData.user.json.cardArr[this.cardIndex];
        this.gemLevel = heroInfo.gemLevel; //宝石等级
        this.gemType = heroInfo.gemType; //宝石类型：1~11种，对应
        var info = this.stoneTab.getRowFromColName("level", "" + this.gemLevel);
        var star = info.getValFromColName("star"); //星级
        var name = info.getValFromColName("name"); //名称
        var color = info.getValFromColName("color"); //品质颜色
        var power = info.getValFromColName("power"); //战力
        var type = info.getValFromColName("att" + this.gemType); //属性
        var baoshiBase = new ItemBase(this.item1, this, 1);
        baoshiBase.setGemData(this.gemLevel);
        baoshiBase.setColor2(color);
        baoshiBase.setStar2(star);
        var gold, itemID, count, zs;
        if (this.c1Index) {
            gold = info.getValFromColName("levelGold"); //当前等级升级所需金币
            itemID = info.getValFromColName("levelItemID"); //当前等级升级所需道具
            count = info.getValFromColName("levelNum"); //当前等级升级所需数量
            zs = info.getValFromColName("zs"); //锁定所需钻石
        }
        else {
            gold = info.getValFromColName("changeGold"); //转换所需金币
            itemID = info.getValFromColName("changeItemID"); //转换所需道具
            count = info.getValFromColName("changeNum"); //转换所需数量
        }
        var itemArr = MyData.user.json.itemArr;
        var itemCount = 0;
        for (var i = 0; i < itemArr.length; i++) {
            var id = itemArr[i].itemID;
            if (id == itemID) {
                itemCount = itemArr[i].count;
            }
        }
        var money = MyData.user.money; //金币
        var arr = type;
        var num = arr.length;
        this["typeData1"].text = "";
        this["typeData2"].text = "";
        this["typeData3"].text = "";
        this["typeDataT1"].text = "";
        this["typeDataT2"].text = "";
        this["typeDataT3"].text = "";
        var typeNum = 1;
        for (var j = 0; j < num; j++) {
            var attrID = arr[j];
            var attrInfo = this.stoneAttrTypeTab.getRowFromColName("id", "" + attrID);
            this["typeData" + typeNum].text = "+" + arr[j + 1] / this.doubleArr[attrID] + this.nameArr[attrID];
            j++;
            typeNum++;
        }
        this.name1.text = name;
        this.needMoneyText.text = Common.overLength(gold) + "/" + Common.overLength(money);
        this.changeNumText.text = count + "/" + Common.overLength(itemCount);
    };
    BaoshiUpgradeView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this); //关闭界面
        this.addClickListener(this.zhBtn, this.onClick, this); //转换
        this.addClickListener(this.sjBtn, this.onClick, this); //升级
        this.addClickListener(this.gouxuanBtn, this.onClick, this); //勾选
        this.addClickListener(this.baocun, this.onClick, this); //保存
    };
    BaoshiUpgradeView.prototype.onClick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.zhBtn:
                net.cardGemClear(this.cardIndex, function () {
                    _this.showUpdate();
                    _this.selectSuoData(_this.gemLevel, MyData.user.json.gemClear.gemType);
                    _this.ui.getController("c1").selectedIndex = (2);
                    _this.ui.getController("c2").selectedIndex = (1);
                }, this);
                break;
            case this.sjBtn:
                net.cardGemUp(this.cardIndex, this.suo, function () {
                    _this.showUpdate();
                    _this.selectSuoData(_this.gemLevel + 1, _this.gemType);
                    HeroCultivateSystem.HeroCultivateViewUI.updateEqu();
                }, this);
                break;
            case this.gouxuanBtn:
                this.suo = this.gouxuanBtn.getController("button").selectedIndex;
                this.selectSuoData(this.gemLevel + 1, this.gemType);
                this.ui.getController("c2").selectedIndex = (this.suo);
                break;
            case this.baocun:
                net.cardGemClearYes(this.cardIndex, function () {
                    //TipsViewSystem.show("宝石转换成功");
                    _this.ui.getController("c1").selectedIndex = (0);
                    _this.ui.getController("c2").selectedIndex = (0);
                    _this.showUpdate();
                    HeroCultivateSystem.HeroCultivateViewUI.updateEqu();
                    HeroCultivateSystem.HeroCultivateViewUI.showHeroInfo();
                }, this);
                break;
        }
    };
    //选定下级属性
    BaoshiUpgradeView.prototype.selectSuoData = function (gemLevel, gemType) {
        this.name2.text = "";
        this["typeDataT1"].text = "";
        this["typeDataT2"].text = "";
        this["typeDataT3"].text = "";
        var info = this.stoneTab.getRowFromColName("level", "" + gemLevel);
        if (info) {
            var type = info.getValFromColName("att" + gemType); //属性
            var name_26 = info.getValFromColName("name"); //名称
            var color = info.getValFromColName("color"); //
            var star = info.getValFromColName("star"); //
            var baoshiBase = new ItemBase(this.item2, this, 1);
            baoshiBase.setGemData(gemLevel);
            baoshiBase.setColor2(color);
            baoshiBase.setStar2(star);
            var arr = type;
            var num = arr.length;
            var typeNum = 1;
            for (var j = 0; j < num; j++) {
                var attrID = arr[j];
                var attrInfo = this.stoneAttrTypeTab.getRowFromColName("id", "" + attrID);
                this["typeDataT" + typeNum].text = "+" + arr[j + 1] / this.doubleArr[attrID] + this.nameArr[attrID];
                j++;
                typeNum++;
            }
            this.name2.text = name_26;
        }
    };
    return BaoshiUpgradeView;
}(ak.EasyUI));
__reflect(BaoshiUpgradeView.prototype, "BaoshiUpgradeView");
//英雄培养
var HeroCultivateSystem = (function (_super) {
    __extends(HeroCultivateSystem, _super);
    function HeroCultivateSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HeroCultivateSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("HeroCultivate");
    };
    HeroCultivateSystem.inst = new HeroCultivateSystem("HeroCultivate");
    return HeroCultivateSystem;
}(ak.FairyGUI));
__reflect(HeroCultivateSystem.prototype, "HeroCultivateSystem");
//主界面
var HeroCultivateView = (function (_super) {
    __extends(HeroCultivateView, _super);
    function HeroCultivateView(cardIndex, tabHeroID, showHeroArr, oneCardInfoType) {
        if (tabHeroID === void 0) { tabHeroID = 0; }
        if (oneCardInfoType === void 0) { oneCardInfoType = 0; }
        var _this = _super.call(this, HeroCultivateSystem.inst, MyGame.inst.uiLayer2_1) || this;
        //获取技能数据
        _this.skillDataArr = [];
        _this.skillDataArrNext = [];
        _this.needHeroIndexArr = []; //合成新英雄所需卡牌英雄下标
        _this.needHeroIndexArrFiltrate = []; //合成新英雄所需卡牌英雄下标筛选
        _this.needHeroIDArr = []; //所需英雄ID数组
        _this.needHeroIDCountArr = []; //所需英雄ID数量数组
        _this.hero0Arr = []; //所需英雄材料0
        _this.hero1Arr = []; //所需英雄材料1
        _this.hero2Arr = []; //所需英雄材料2
        _this.hero3Arr = []; //所需英雄材料3
        _this.moveItemArr = [];
        _this.nextHeroID = 0;
        _this.onlyHeroID = 0;
        _this.upStarNeed = 0;
        //装备界面更新
        _this.equArr = []; //装备数据
        //穿装
        _this.tihuanPass = false;
        //跳过选择装备界面
        _this.nameArr = [0, "生命", "%生命", "%精准率", "速度", "攻击", "%攻击", "%破甲", "%技能伤害", "%暴击", "%暴击伤害", "%神圣伤害", "%格挡"];
        _this.doubleArr = [0, 1, 100, 100, 1, 1, 100, 100, 100, 100, 100, 100, 100];
        //显示英雄数据
        _this.atkS = 0;
        _this.hpS = 0;
        _this.defS = 0;
        _this.speedS = 0;
        _this.cardIndex = cardIndex;
        _this.tabHeroID = tabHeroID;
        _this.showHeroArr = showHeroArr;
        _this.oneCardInfoType = oneCardInfoType;
        HeroCultivateSystem.HeroCultivateViewUI = _this;
        return _this;
    }
    //初始化回调
    HeroCultivateView.prototype.onInit = function () {
        this.ui = this.create("HeroCultivate", "HeroCultivateView");
        this.on("netmsg://chat/worldChatResult", this.showTip, this);
        this.closebtn = this.ui.getChild("closeBtn").asButton;
        this.shengji = this.ui.getChild("n113").asButton;
        this.jinjie = this.ui.getChild("n114").asButton;
        this.zuojiantou = this.ui.getChild("n60").asButton;
        this.youjiantou = this.ui.getChild("n59").asButton;
        this.suo = this.ui.getChild("n106").asCom;
        this.onekeyTuo = this.ui.getChild("n116").asButton;
        this.oneKeyChuan = this.ui.getChild("n117").asButton;
        this.addition = this.ui.getChild("n99").asButton;
        //分享
        this.fenxiang = this.ui.getChild("n138").asButton;
        this.fenxiangBgClose = this.ui.getChild("fenxiangBgClose").asLoader;
        this.shijie = this.ui.getChild("n160").asButton;
        this.gonghui = this.ui.getChild("n161").asButton;
        this.selectItemUI = this.ui.getChild("n131").asCom;
        this.bgCloseSelectHero = this.selectItemUI.getChild("bgclose").asLoader;
        this.equList = this.selectItemUI.getChild("n5").asList;
        this.equInfoUI = this.ui.getChild("n132").asCom;
        this.bgCloseEquInfo = this.equInfoUI.getChild("bgclose").asLoader;
        this.equIDBtn = this.equInfoUI.getChild("n4").asButton;
        this.tuoyifuBtn = this.equInfoUI.getChild("n14").asButton;
        this.tihuanBtn = this.equInfoUI.getChild("n15").asButton;
        this.tihuanQuery = this.equInfoUI.getChild("n25").asButton;
        this.spsjBtn = this.equInfoUI.getChild("spsjBtn").asButton;
        this.baoshiZH = this.equInfoUI.getChild("n27").asButton;
        this.baoshiSJ = this.equInfoUI.getChild("n28").asButton;
        this.itemname = this.equInfoUI.getChild("itemname").asTextField; //装备名称
        this.itemname2 = this.equInfoUI.getChild("itemname2").asTextField; //套装名称
        this.itemattribute0 = this.equInfoUI.getChild("itemattribute0").asTextField; //属性0
        this.itemattribute1 = this.equInfoUI.getChild("itemattribute1").asTextField; //套装属性1
        this.itemattribute2 = this.equInfoUI.getChild("itemattribute2").asTextField; //套装属性2
        this.itemattribute3 = this.equInfoUI.getChild("itemattribute3").asTextField; //套装属性3
        this.itemnameT = this.equInfoUI.getChild("itemnameT").asTextField; //装备名称
        this.itemnameT2 = this.equInfoUI.getChild("itemnameT2").asTextField; //套装名称
        this.itemattributeT0 = this.equInfoUI.getChild("itemattributeT0").asTextField; //属性0
        this.itemattributeT1 = this.equInfoUI.getChild("itemattributeT1").asTextField; //套装属性1
        this.itemattributeT2 = this.equInfoUI.getChild("itemattributeT2").asTextField; //套装属性2
        this.itemattributeT3 = this.equInfoUI.getChild("itemattributeT3").asTextField; //套装属性3
        this.heroList = this.ui.getChild("n204").asCom.getChild("n5").asList;
        this.bgcloseUpStarUI = this.ui.getChild("n204").asCom.getChild("bgclose").asLoader;
        this.xuanze = this.ui.getChild("n204").asCom.getChild("n4").asButton;
        this.juexingNeed = this.ui.getChild("n198").asTextField; //觉醒需要的材料
        this.juexing = this.ui.getChild("n200").asButton;
        this.heroLvTab = ak.JsonTableMgr.get("heroLv");
        this.heroTab = ak.JsonTableMgr.get("hero");
        this.heroPromotionTab = ak.JsonTableMgr.get("heroPromotion");
        this.heroGrowTab = ak.JsonTableMgr.get("heroGrow");
        this.itemTab = ak.JsonTableMgr.get("item");
        this.itemEquipTab = ak.JsonTableMgr.get("itemEquip");
        this.itemShipinTab = ak.JsonTableMgr.get("itemShipin");
        this.stoneTab = ak.JsonTableMgr.get("stone");
        this.stoneAttrTypeTab = ak.JsonTableMgr.get("stoneAttrType");
        this.heroConfigTab = ak.JsonTableMgr.get("heroConfig");
        this.itemEquipSuitTab = ak.JsonTableMgr.get("itemEquipSuit");
        this.heroComposeTab = ak.JsonTableMgr.get("heroCompose");
        this.onEgretEvent(this.ui.getController("c1"), fairygui.StateChangeEvent.CHANGED, this.cheangeTab, this);
        this.clickAdd();
        this.showSkillUI();
        this.upgradeView();
        this.hideJiantou();
        TopViewSystem.topViewUI.kongzhiqi(1);
    };
    HeroCultivateView.prototype.hideJiantou = function () {
        if (this.oneCardInfoType) {
            this.zuojiantou.visible = false;
            this.youjiantou.visible = false;
        }
    };
    //分享成功
    HeroCultivateView.prototype.showTip = function () {
        TipsViewSystem.show("分享成功");
        this.ui.getController("fenxiang").selectedIndex = (0);
    };
    //显示属性加成
    HeroCultivateView.prototype.showType = function () {
        var _this = this;
        if (this.atkS) {
            var showTypeCom = this.ui.getChild("n153").asCom;
            this.ui.getController("showType").selectedIndex = 1;
            var gongji = showTypeCom.getChild("gongji").asTextField;
            var xueliang = showTypeCom.getChild("xueliang").asTextField;
            var fangyu = showTypeCom.getChild("fangyu").asTextField;
            var sudu = showTypeCom.getChild("sudu").asTextField;
            var pass = 0;
            var cardArr = MyData.user.json.cardArr;
            var heroInfo = cardArr[this.cardIndex];
            var atk = heroInfo.atk;
            var hp = heroInfo.hp;
            var def = heroInfo.def;
            var speed = heroInfo.speed;
            //攻击
            if (this.atkS != atk) {
                if (this.atkS > atk) {
                    gongji.text = "攻击  -" + Math.abs(this.atkS - atk);
                    showTypeCom.getController("atk").selectedIndex = 0;
                }
                else {
                    gongji.text = "攻击  +" + Math.abs(this.atkS - atk);
                    showTypeCom.getController("atk").selectedIndex = 1;
                }
                pass = 1;
            }
            else {
                gongji.text = "";
            }
            //血量
            if (this.hpS != hp) {
                if (this.hpS > hp) {
                    xueliang.text = "血量  -" + Math.abs(this.hpS - hp);
                    showTypeCom.getController("hp").selectedIndex = 0;
                }
                else {
                    xueliang.text = "血量  +" + Math.abs(this.hpS - hp);
                    showTypeCom.getController("hp").selectedIndex = 1;
                }
                pass = 1;
            }
            else {
                xueliang.text = "";
            }
            //防御
            if (this.defS != def) {
                if (this.defS > def) {
                    fangyu.text = "防御  -" + Math.abs(this.defS - def);
                    showTypeCom.getController("def").selectedIndex = 0;
                }
                else {
                    fangyu.text = "防御  +" + Math.abs(this.defS - def);
                    showTypeCom.getController("def").selectedIndex = 1;
                }
                pass = 1;
            }
            else {
                fangyu.text = "";
            }
            //速度
            if (this.speedS != speed) {
                if (this.speedS > speed) {
                    sudu.text = "速度  -" + Math.abs(this.speedS - speed);
                    showTypeCom.getController("speed").selectedIndex = 0;
                }
                else {
                    sudu.text = "速度  +" + Math.abs(this.speedS - speed);
                    showTypeCom.getController("speed").selectedIndex = 1;
                }
                pass = 1;
            }
            else {
                sudu.text = "";
            }
            var tran = this.ui.getTransition("t0");
            tran.play();
            tran.setHook("end", function () {
                _this.ui.getController("showType").selectedIndex = 0;
            }, this);
        }
    };
    //更新界面所有数据
    HeroCultivateView.prototype.upgradeView = function () {
        if (this.tabHeroID) {
            console.log("卡牌id =", this.tabHeroID);
            this.getSkillData(this.tabHeroID);
            this.showMaxHeroInfo();
        }
        else {
            var heroInfo = MyData.user.json.cardArr[this.cardIndex];
            this.onlyHeroID = heroInfo.id;
            this.heroID = heroInfo.heroID;
            console.log("卡牌id=", heroInfo.heroID);
            this.getSkillData(this.heroID);
            this.showHeroInfo();
            this.updateEqu();
            this.showLonggu(this.heroID);
            this.showUpStarData();
            this.showUpStarUI();
        }
        this.showJiantou();
    };
    //点击技能
    HeroCultivateView.prototype.showSkillUI = function () {
        var iconArr = ["n94", "n95", "n96", "n97"];
        for (var i = 0; i < iconArr.length; i++) {
            var skillItem = this.ui.getChild(iconArr[i]).asCom;
            this.onEgretEvent(skillItem, egret.TouchEvent.TOUCH_BEGIN, this.showSkillDataStart, this);
            this.onEgretEvent(skillItem, egret.TouchEvent.TOUCH_RELEASE_OUTSIDE, this.showSkillDataMove, this);
            this.onEgretEvent(skillItem, egret.TouchEvent.TOUCH_END, this.showSkillDataEnd, this);
        }
        var iconArr1 = ["n168", "n182"];
        for (var i = 0; i < iconArr1.length; i++) {
            var skillItem = this.ui.getChild(iconArr1[i]).asCom;
            this.onEgretEvent(skillItem, egret.TouchEvent.TOUCH_BEGIN, this.showSkillDataStartNext, this);
            this.onEgretEvent(skillItem, egret.TouchEvent.TOUCH_RELEASE_OUTSIDE, this.showSkillDataMove, this);
            this.onEgretEvent(skillItem, egret.TouchEvent.TOUCH_END, this.showSkillDataEnd, this);
        }
    };
    //显示技能按下
    HeroCultivateView.prototype.showSkillDataStart = function (evt) {
        this.ui.getController("skillC").selectedIndex = (1);
        this.ui.getController("skillUIWhere").selectedIndex = (0);
        var num = evt.target.data; //第几个技能
        var skillUI = this.ui.getChild("n151").asCom;
        this.setLoaderUrl(skillUI.getChild("n3").asCom.getChild("n64").asLoader, "resource/icon/skillico/" + this.skillDataArr[num - 1][3] + ".png");
        skillUI.getChild("skillName").asTextField.text = this.skillDataArr[num - 1][1];
        skillUI.getChild("skillData").asTextField.text = this.skillDataArr[num - 1][2];
        if (!this.tabHeroID) {
            var star = MyData.user.json.cardArr[this.cardIndex].star;
            if (star < this.skillDataArr[num - 1][4]) {
                skillUI.getChild("n55").asTextField.text = this.skillDataArr[num - 1][4] + "阶解锁";
            }
            else {
                skillUI.getChild("n55").asTextField.text = "";
            }
        }
    };
    //显示技能按下
    HeroCultivateView.prototype.showSkillDataStartNext = function (evt) {
        this.ui.getController("skillC").selectedIndex = (1);
        this.ui.getController("skillUIWhere").selectedIndex = (1);
        var data = evt.target.data; //第几个技能
        var skillUI = this.ui.getChild("n151").asCom;
        if (data.index) {
            this.setLoaderUrl(skillUI.getChild("n3").asCom.getChild("n64").asLoader, "resource/icon/skillico/" + this.skillDataArrNext[data.num - 1][3] + ".png");
            skillUI.getChild("skillName").asTextField.text = this.skillDataArrNext[data.num - 1][1];
            skillUI.getChild("skillData").asTextField.text = this.skillDataArrNext[data.num - 1][2];
        }
        else {
            this.setLoaderUrl(skillUI.getChild("n3").asCom.getChild("n64").asLoader, "resource/icon/skillico/" + this.skillDataArr[data.num - 1][3] + ".png");
            skillUI.getChild("skillName").asTextField.text = this.skillDataArr[data.num - 1][1];
            skillUI.getChild("skillData").asTextField.text = this.skillDataArr[data.num - 1][2];
        }
        skillUI.getChild("n55").asTextField.text = "";
    };
    //显示技能区域外的释放事件
    HeroCultivateView.prototype.showSkillDataMove = function () {
        this.ui.getController("skillC").selectedIndex = (0);
    };
    //显示技能结束
    HeroCultivateView.prototype.showSkillDataEnd = function () {
        this.ui.getController("skillC").selectedIndex = (0);
    };
    HeroCultivateView.prototype.getSkillData = function (heroID) {
        this.skillDataArr = [];
        this.skillDataArrNext = [];
        var heroData = this.heroTab.getRowFromColName("id", "" + heroID);
        var activeSkill = heroData.getValFromColName("activeSkill"); //主动技能
        var activeSkillName = heroData.getValFromColName("activeSkillName"); //主动技能名称
        var activeSkillText = heroData.getValFromColName("activeSkillText"); //主动技能描述
        var activeSkillIcon = heroData.getValFromColName("activeSkillIcon"); //主动技能图标
        var passiveSkill1 = heroData.getValFromColName("passiveSkill1"); //被动技能1
        var passiveSkillName1 = heroData.getValFromColName("passiveSkillName1"); //被动技能1名称
        var passiveSkillText1 = heroData.getValFromColName("passiveSkillText1"); //被动技能1描述
        var passiveSkillIcon1 = heroData.getValFromColName("passiveSkillIcon1"); //被动技能1图标
        var passiveSkillOpen1 = Number(heroData.getValFromColName("passiveSkillOpen1")); //被动技能1开启品阶
        var passiveSkill2 = heroData.getValFromColName("passiveSkill2"); //被动技能2
        var passiveSkillName2 = heroData.getValFromColName("passiveSkillName2"); //被动技能2名称
        var passiveSkillText2 = heroData.getValFromColName("passiveSkillText2"); //被动技能2描述
        var passiveSkillIcon2 = heroData.getValFromColName("passiveSkillIcon2"); //被动技能2图标
        var passiveSkillOpen2 = Number(heroData.getValFromColName("passiveSkillOpen2")); //被动技能2开启品阶
        var passiveSkill3 = heroData.getValFromColName("passiveSkill3"); //被动技能3
        var passiveSkillName3 = heroData.getValFromColName("passiveSkillName3"); //被动技能3名称
        var passiveSkillText3 = heroData.getValFromColName("passiveSkillText3"); //被动技能3描述
        var passiveSkillIcon3 = heroData.getValFromColName("passiveSkillIcon3"); //被动技能3图标
        var passiveSkillOpen3 = Number(heroData.getValFromColName("passiveSkillOpen3")); //被动技能3开启品阶
        var skill = [activeSkill, activeSkillName, activeSkillText, activeSkillIcon, 0];
        var skill1 = [passiveSkill1, passiveSkillName1, passiveSkillText1, passiveSkillIcon1, passiveSkillOpen1];
        var skill2 = [passiveSkill2, passiveSkillName2, passiveSkillText2, passiveSkillIcon2, passiveSkillOpen2];
        var skill3 = [passiveSkill3, passiveSkillName3, passiveSkillText3, passiveSkillIcon3, passiveSkillOpen3];
        this.skillDataArr = [skill, skill1, skill2, skill3];
        var next = heroData.getValFromColName("next"); //下一等阶heroID（6星以上）
        if (next) {
            var heroData2 = this.heroTab.getRowFromColName("id", "" + next);
            var activeSkill_1 = heroData2.getValFromColName("activeSkill"); //主动技能
            var activeSkillName_1 = heroData2.getValFromColName("activeSkillName"); //主动技能名称
            var activeSkillText_1 = heroData2.getValFromColName("activeSkillText"); //主动技能描述
            var activeSkillIcon_1 = heroData2.getValFromColName("activeSkillIcon"); //主动技能图标
            var passiveSkill1_1 = heroData2.getValFromColName("passiveSkill1"); //被动技能1
            var passiveSkillName1_1 = heroData2.getValFromColName("passiveSkillName1"); //被动技能1名称
            var passiveSkillText1_1 = heroData2.getValFromColName("passiveSkillText1"); //被动技能1描述
            var passiveSkillIcon1_1 = heroData2.getValFromColName("passiveSkillIcon1"); //被动技能1图标
            var passiveSkillOpen1_1 = Number(heroData2.getValFromColName("passiveSkillOpen1")); //被动技能1开启品阶
            var passiveSkill2_1 = heroData2.getValFromColName("passiveSkill2"); //被动技能2
            var passiveSkillName2_1 = heroData2.getValFromColName("passiveSkillName2"); //被动技能2名称
            var passiveSkillText2_1 = heroData2.getValFromColName("passiveSkillText2"); //被动技能2描述
            var passiveSkillIcon2_1 = heroData2.getValFromColName("passiveSkillIcon2"); //被动技能2图标
            var passiveSkillOpen2_1 = Number(heroData2.getValFromColName("passiveSkillOpen2")); //被动技能2开启品阶
            var passiveSkill3_1 = heroData2.getValFromColName("passiveSkill3"); //被动技能3
            var passiveSkillName3_1 = heroData2.getValFromColName("passiveSkillName3"); //被动技能3名称
            var passiveSkillText3_1 = heroData2.getValFromColName("passiveSkillText3"); //被动技能3描述
            var passiveSkillIcon3_1 = heroData2.getValFromColName("passiveSkillIcon3"); //被动技能3图标
            var passiveSkillOpen3_1 = Number(heroData2.getValFromColName("passiveSkillOpen3")); //被动技能3开启品阶
            var skill_1 = [activeSkill_1, activeSkillName_1, activeSkillText_1, activeSkillIcon_1, 0];
            var skill1_1 = [passiveSkill1_1, passiveSkillName1_1, passiveSkillText1_1, passiveSkillIcon1_1, passiveSkillOpen1_1];
            var skill2_1 = [passiveSkill2_1, passiveSkillName2_1, passiveSkillText2_1, passiveSkillIcon2_1, passiveSkillOpen2_1];
            var skill3_1 = [passiveSkill3_1, passiveSkillName3_1, passiveSkillText3_1, passiveSkillIcon3_1, passiveSkillOpen3_1];
            this.skillDataArrNext = [skill_1, skill1_1, skill2_1, skill3_1];
        }
    };
    //显示属性或装备界面
    HeroCultivateView.prototype.cheangeTab = function () {
        var index = this.ui.getController("c1").selectedIndex;
        if (index == 1) {
            this.updateEqu();
        }
        else if (index == 2) {
            this.showUpStarData();
        }
    };
    //显示升星界面
    HeroCultivateView.prototype.showUpStarUI = function () {
        var heroData = this.heroTab.getRowFromColName("id", "" + this.heroID);
        var star = heroData.getValFromColName("star"); //下一等阶heroID（6星以上）
        if (star >= 6) {
            this.ui.getController("showUpStarTab").selectedIndex = 1;
        }
        else {
            this.ui.getController("showUpStarTab").selectedIndex = 0;
            //this.ui.getController("c1").selectedIndex=0;
        }
        this.juexing.enabled = false;
    };
    //升星界面数据
    HeroCultivateView.prototype.showUpStarData = function () {
        this.juexing.enabled = false;
        this.needHeroIndexArr = [];
        this.needHeroIDArr = [];
        this.needHeroIDCountArr = [];
        this.hero0Arr = [];
        this.hero1Arr = [];
        this.hero2Arr = [];
        this.hero3Arr = [];
        var heroData1 = this.heroTab.getRowFromColName("id", "" + this.heroID);
        var star1 = heroData1.getValFromColName("star"); //星级
        var next = heroData1.getValFromColName("next"); //下一等阶heroID（6星以上）
        if (next) {
            this.ui.getController("starMax").selectedIndex = 0;
            this.nextHeroID = next;
            var activeSkillA = heroData1.getValFromColName("activeSkill"); //主动技能
            var passiveSkill1A = heroData1.getValFromColName("passiveSkill1"); //被动技能1
            var passiveSkill2A = heroData1.getValFromColName("passiveSkill2"); //被动技能2
            var passiveSkill3A = heroData1.getValFromColName("passiveSkill3"); //被动技能3
            var activeSkillIconA = heroData1.getValFromColName("activeSkillIcon"); //主动技能图标
            var passiveSkillIcon1A = heroData1.getValFromColName("passiveSkillIcon1"); //被动技能1图标
            var passiveSkillIcon2A = heroData1.getValFromColName("passiveSkillIcon2"); //被动技能2图标
            var passiveSkillIcon3A = heroData1.getValFromColName("passiveSkillIcon3"); //被动技能3图标
            var heroData2 = this.heroTab.getRowFromColName("id", "" + next);
            var star2 = heroData2.getValFromColName("star"); //星级
            var race = heroData2.getValFromColName("race"); //种族
            var activeSkillB = heroData2.getValFromColName("activeSkill"); //主动技能
            var passiveSkill1B = heroData2.getValFromColName("passiveSkill1"); //被动技能1
            var passiveSkill2B = heroData2.getValFromColName("passiveSkill2"); //被动技能2
            var passiveSkill3B = heroData2.getValFromColName("passiveSkill3"); //被动技能3
            var activeSkillIconB = heroData1.getValFromColName("activeSkillIcon"); //主动技能图标
            var passiveSkillIcon1B = heroData1.getValFromColName("passiveSkillIcon1"); //被动技能1图标
            var passiveSkillIcon2B = heroData1.getValFromColName("passiveSkillIcon2"); //被动技能2图标
            var passiveSkillIcon3B = heroData1.getValFromColName("passiveSkillIcon3"); //被动技能3图标
            var skillIconA = 0;
            var skillIconB = 0;
            var num = 0;
            if (activeSkillA != activeSkillB) {
                skillIconA = activeSkillIconA;
                skillIconB = activeSkillIconB;
                num = 1;
            }
            else if (passiveSkill1A != passiveSkill1B) {
                skillIconA = passiveSkillIcon1A;
                skillIconB = passiveSkillIcon1B;
                num = 2;
            }
            else if (passiveSkill2A != passiveSkill2B) {
                skillIconA = passiveSkillIcon2A;
                skillIconB = passiveSkillIcon2B;
                num = 3;
            }
            else if (passiveSkill3A != passiveSkill3B) {
                skillIconA = passiveSkillIcon3A;
                skillIconB = passiveSkillIcon3B;
                num = 4;
            }
            var heroPromotionInfo1 = this.heroPromotionTab.getRowFromColName("star", "" + star1);
            var attrShow1 = heroPromotionInfo1.getValFromColName("attrShow"); //属性提升显示百分比
            var maxlv1 = heroPromotionInfo1.getValFromColName("maxlv"); //最高可升级
            this.ui.getChild("n165").asCom.getController("star").selectedIndex = star1; //星级1
            this.setLoaderUrl(this.ui.getChild("n168").asCom.getChild("n64").asLoader, "resource/icon/skillico/" + skillIconA + ".png");
            this.ui.getChild("n205").asTextField.text = attrShow1 + "%";
            this.ui.getChild("n206").asTextField.text = maxlv1;
            this.ui.getChild("n168").asCom.data = { index: 0, num: num };
            this.upStarNeed = star2;
            var heroPromotionInfo2 = this.heroPromotionTab.getRowFromColName("star", "" + star2);
            var attrShow2 = heroPromotionInfo2.getValFromColName("attrShow"); //属性提升显示百分比
            var maxlv2 = heroPromotionInfo2.getValFromColName("maxlv"); //最高可升级
            this.ui.getChild("n181").asCom.getController("star").selectedIndex = star2; //星级2
            this.setLoaderUrl(this.ui.getChild("n182").asCom.getChild("n64").asLoader, "resource/icon/skillico/" + skillIconB + ".png");
            this.ui.getChild("n201").asTextField.text = attrShow2 + "%";
            this.ui.getChild("n202").asTextField.text = maxlv2;
            this.ui.getChild("n182").asCom.data = { index: 1, num: num };
            //英雄材料
            var heroComposeInfo = this.heroComposeTab.getRowFromColName("heroID", "" + next);
            var mainHero = heroComposeInfo.getValFromColName("mainHero"); //主英雄
            var mainHeroNum = heroComposeInfo.getValFromColName("mainHeroNum"); //主英雄数量
            var delHero1 = heroComposeInfo.getValFromColName("delHero1"); //副英雄1
            var delHeroNum1 = heroComposeInfo.getValFromColName("delHeroNum1"); //副英雄数量
            var delHero2 = heroComposeInfo.getValFromColName("delHero2"); //副英雄2
            var delHeroNum2 = heroComposeInfo.getValFromColName("delHeroNum2"); //副英雄数量
            var delHero3 = heroComposeInfo.getValFromColName("delHero3"); //副英雄3
            var delHeroNum3 = heroComposeInfo.getValFromColName("delHeroNum3"); //副英雄数量
            this.needHeroIDArr = [mainHero, delHero1];
            this.needHeroIDCountArr = [mainHeroNum, delHeroNum1];
            if (mainHero) {
                if (delHero2) {
                    this.needHeroIDArr.push(delHero2);
                    this.needHeroIDCountArr.push(delHeroNum2);
                }
                if (delHero3) {
                    this.needHeroIDArr.push(delHero3);
                    this.needHeroIDCountArr.push(delHeroNum3);
                }
            }
            this["hero0Arr"].push(this.cardIndex);
            var count = this.needHeroIDArr.length;
            this.ui.getController("addUpStarHero").selectedIndex = count - 1;
            this.moveItemArr = ["n220", "n221", "n222", "n223"];
            for (var i = 1; i < count; i++) {
                var heroIDS = this.needHeroIDArr[i];
                heroIDS = Math.abs(heroIDS);
                var countS = this.needHeroIDCountArr[i];
                var item_4 = this.ui.getChild(this.moveItemArr[i]).asCom;
                item_4.getController("isNumberOut").selectedIndex = (1);
                item_4.data = { heroIDS: heroIDS, moveItemArrIndex: i, race: race };
                var itemBase = new ItemBase(item_4, this, 2);
                if (heroIDS == 5 || heroIDS == 6 || heroIDS == 109) {
                    if (heroIDS > 100) {
                        itemBase.setGlobalImg(0, heroIDS);
                        itemBase.setColor2(5);
                        item_4.data.race = 0;
                    }
                    else {
                        itemBase.setGlobalImg(race, heroIDS);
                        itemBase.setColor2(heroIDS - 1);
                    }
                }
                else {
                    var heroTabInfo = this.heroTab.getRowFromColName("id", "" + heroIDS);
                    var star = heroTabInfo.getValFromColName("star"); //星级
                    itemBase.setItemData(heroIDS, race, star);
                }
                itemBase.seticonGray(false);
                itemBase.setnumberOut("0/" + countS);
                this.onEgretEvent(item_4, egret.TouchEvent.TOUCH_TAP, this.addHero, this);
            }
            var heroPromotionInfo = this.heroPromotionTab.getRowFromColName("star", "" + this.upStarNeed);
            var item = heroPromotionInfo.getValFromColName("item"); //升到下级消耗道具id
            var cost = heroPromotionInfo.getValFromColName("cost"); //升到下级消耗道具数量
            this.juexingNeed.text = cost;
        }
        else {
            this.ui.getController("starMax").selectedIndex = 1;
            this.ui.getChild("n211").asCom.getController("star").selectedIndex = star1; //星级1
            if (star1 <= 5) {
                var index = this.ui.getController("c1").selectedIndex;
                if (index == 1) {
                    this.ui.getController("c1").selectedIndex = 1;
                }
                else {
                    this.ui.getController("c1").selectedIndex = 0;
                }
            }
        }
    };
    //装上英雄
    HeroCultivateView.prototype.addHero = function (evt) {
        this.ui.getController("upHeroStar").selectedIndex = (1);
        var data = evt.target.data;
        var addHeroID = data.heroIDS; //heroID或星级（-3，-4，-5）
        var selectRace = data.race; //选定种族
        this.moveItemArrIndex = data.moveItemArrIndex; //选定数组位置
        this.heroList.removeChildrenToPool();
        var cardArr = MyData.user.json.cardArr;
        for (var i = 0; i < cardArr.length; i++) {
            var checkHeroID = cardArr[i].heroID;
            var checkRace = cardArr[i].race; //种族
            var checkStar = cardArr[i].starMax; //星级
            var checkLock = cardArr[i].lock; //锁定
            var checkBattle = cardArr[i].battle; //锁定
            var checkLevel = cardArr[i].level; //等级
            if (selectRace == checkRace) {
                if (addHeroID == checkHeroID) {
                    for (var j = 0; j < 4; j++) {
                        var a = this["hero" + ("" + j) + "Arr"].indexOf(i);
                        if (this.moveItemArrIndex == j && a != -1) {
                            var num = this.needHeroIndexArrFiltrate.indexOf(i);
                            this.needHeroIndexArrFiltrate.splice(num, 1);
                        }
                    }
                    var pass = this.needHeroIndexArrFiltrate.indexOf(i);
                    if (pass == -1) {
                        //this.needHeroIndexArrFiltrate.push(i);
                        var item = this.heroList.addItemFromPool().asCom;
                        var itemBase = new ItemBase(item, this, 2);
                        itemBase.setItemData(checkHeroID, checkRace, checkStar);
                        itemBase.setNumber(checkLevel);
                        item.data = i;
                        var arrIndex = this["hero" + ("" + this.moveItemArrIndex) + "Arr"].indexOf(i);
                        if (arrIndex == -1) {
                            itemBase.setGou(false);
                        }
                        else {
                            itemBase.setGou(true);
                        }
                        if (checkLock == 1 || checkBattle == 1) {
                            itemBase.isshowLock(true);
                        }
                        else {
                            itemBase.isshowLock(false);
                        }
                        this.onEgretEvent(item, egret.TouchEvent.TOUCH_TAP, this.xuandingcaozuo, this);
                    }
                }
                else {
                    var star = Math.abs(addHeroID);
                    if (star == checkStar) {
                        var passUse = true;
                        for (var k = 0; k < 4; k++) {
                            var a = this["hero" + ("" + k) + "Arr"].indexOf(i);
                            if (this.moveItemArrIndex != k && a != -1) {
                                passUse = false;
                            }
                        }
                        if (passUse) {
                            var item = this.heroList.addItemFromPool().asCom;
                            var itemBase = new ItemBase(item, this, 2);
                            itemBase.setItemData(checkHeroID, checkRace, checkStar);
                            itemBase.setNumber(checkLevel);
                            item.data = i;
                            var arrIndex = this["hero" + ("" + this.moveItemArrIndex) + "Arr"].indexOf(i);
                            if (arrIndex == -1) {
                                itemBase.setGou(false);
                            }
                            else {
                                itemBase.setGou(true);
                            }
                            if (checkLock == 1 || checkBattle == 1) {
                                itemBase.isshowLock(true);
                            }
                            else {
                                itemBase.isshowLock(false);
                            }
                            this.onEgretEvent(item, egret.TouchEvent.TOUCH_TAP, this.xuandingcaozuo, this);
                        }
                    }
                }
            }
            else {
                if (addHeroID > 100) {
                    var num = addHeroID;
                    num -= 100; //star
                    if (num == checkStar) {
                        var passUse = true;
                        for (var k = 0; k < 4; k++) {
                            var a = this["hero" + ("" + k) + "Arr"].indexOf(i);
                            if (this.moveItemArrIndex != k && a != -1) {
                                passUse = false;
                            }
                        }
                        if (passUse) {
                            var item = this.heroList.addItemFromPool().asCom;
                            var itemBase = new ItemBase(item, this, 2);
                            itemBase.setItemData(checkHeroID, checkRace, checkStar);
                            itemBase.setNumber(checkLevel);
                            item.data = i;
                            var arrIndex = this["hero" + ("" + this.moveItemArrIndex) + "Arr"].indexOf(i);
                            if (arrIndex == -1) {
                                itemBase.setGou(false);
                            }
                            else {
                                itemBase.setGou(true);
                            }
                            if (checkLock == 1 || checkBattle == 1) {
                                itemBase.isshowLock(true);
                            }
                            else {
                                itemBase.isshowLock(false);
                            }
                            this.onEgretEvent(item, egret.TouchEvent.TOUCH_TAP, this.xuandingcaozuo, this);
                        }
                    }
                }
            }
        }
    };
    //选择材料英雄
    HeroCultivateView.prototype.xuandingcaozuo = function (obj) {
        var heroIndex = obj.target.data; //卡牌数组下标
        var cardArr = MyData.user.json.cardArr;
        var checkLock = cardArr[heroIndex].lock;
        var checkBattle = cardArr[heroIndex].battle;
        if (checkLock == 1 || checkBattle == 1) {
            TipsViewSystem.show("不能合成已锁定或防守阵容的英雄");
            return false;
        }
        var itemBase = new ItemBase(obj.target, this, 2);
        var arrIndex = this["hero" + ("" + this.moveItemArrIndex) + "Arr"].indexOf(heroIndex);
        if (arrIndex == -1) {
            var needCount = this.needHeroIDCountArr[this.moveItemArrIndex];
            var count = this["hero" + ("" + this.moveItemArrIndex) + "Arr"].length;
            if (count < needCount) {
                itemBase.setGou(true);
                this["hero" + ("" + this.moveItemArrIndex) + "Arr"].push(heroIndex);
            }
        }
        else {
            itemBase.setGou(false);
            this["hero" + ("" + this.moveItemArrIndex) + "Arr"].splice(arrIndex, 1);
        }
    };
    //选中确认
    HeroCultivateView.prototype.xuanzhongQuery = function () {
        this.ui.getController("upHeroStar").selectedIndex = 0;
        this.needHeroIndexArrFiltrate = [];
        for (var i = 0; i < 4; i++) {
            var count_5 = this["hero" + ("" + i) + "Arr"].length;
            for (var j = 0; j < count_5; j++) {
                this.needHeroIndexArrFiltrate.push(this["hero" + ("" + i) + "Arr"][j]);
            }
        }
        var item = this.ui.getChild(this.moveItemArr[this.moveItemArrIndex]).asCom;
        var itemBase = new ItemBase(item, this, 2);
        var count = this["hero" + ("" + this.moveItemArrIndex) + "Arr"].length;
        var needCount = this.needHeroIDCountArr[this.moveItemArrIndex];
        itemBase.setnumberOut(count + "/" + needCount);
        if (count == needCount) {
            itemBase.seticonGray(true);
        }
        else {
            itemBase.seticonGray(false);
        }
        this.satisfy();
    };
    //判断是否已满足合成条件
    HeroCultivateView.prototype.satisfy = function () {
        this.needHeroIndexArr = [];
        var num = this.needHeroIDCountArr.length;
        var pass = true;
        for (var i = 0; i < num; i++) {
            var heroCount = this["hero" + ("" + i) + "Arr"].length;
            var count = this.needHeroIDCountArr[i];
            if (heroCount != count) {
                //ak.log("卡牌英雄不足");
                this.juexing.enabled = false;
                pass = false;
            }
            for (var j = 0; j < heroCount; j++) {
                var selectHero = MyData.user.json.cardArr[this["hero" + ("" + i) + "Arr"][j]];
                this.needHeroIndexArr.push(this["hero" + ("" + i) + "Arr"][j]);
                // if(selectHero && selectHero.heroID != this.heroID ){
                if (selectHero) {
                    // this.needHeroIndexArr.push(this["hero"+`${i}`+"Arr"][j]);
                    console.log("选中英雄 序号：" + this["hero" + ("" + i) + "Arr"][j] + " id=" + selectHero.id + " level=" + selectHero.level + " MaxStar=" + selectHero.starMax);
                }
                else {
                    console.log("选择的英雄不存在");
                }
            }
        }
        if (pass) {
            this.juexing.enabled = true;
        }
    };
    HeroCultivateView.prototype.updateEqu = function () {
        var heroInfo = MyData.user.json.cardArr[this.cardIndex];
        var arm = heroInfo.arm; //武器ID
        var head = heroInfo.head; //头盔ID
        var ring = heroInfo.ring; //戒子ID
        var clothes = heroInfo.clothes; //衣服ID
        var looking = heroInfo.looking; //饰品ID
        this.gemLevel = heroInfo.gemLevel; //宝石等级
        this.gemType = heroInfo.gemType; //宝石类型：1~11种，对应
        var nameArr = ["n120", "n121", "n122", "n123", "n124", "n125"];
        this.equArr = [this.gemLevel, arm, ring, head, clothes, looking];
        for (var i = 0; i < nameArr.length; i++) {
            var item = this.ui.getChild(nameArr[i]).asCom;
            item._id = i + "";
            var itemBase = new ItemBase(item, this, 1);
            if (i) {
                if (this.equArr[i]) {
                    var info = void 0;
                    if (i == 5) {
                        info = this.itemShipinTab.getRowFromColName("id", "" + this.equArr[i]);
                    }
                    else {
                        info = this.itemEquipTab.getRowFromColName("id", "" + this.equArr[i]);
                    }
                    var star = info.getValFromColName("star"); //星级
                    itemBase.setItemData(this.equArr[i]);
                    itemBase.setStar2(star);
                    this.ui.getChild("equ" + i).asCom.visible = false;
                }
                else {
                    itemBase.clear2();
                    var equJiaShow = this.showEquJia(i);
                    this.ui.getChild("equ" + i).asCom.visible = equJiaShow;
                }
                this.onEgretEvent(item, egret.TouchEvent.TOUCH_TAP, this.editItem, this);
            }
            else {
                if (this.gemLevel == 0) {
                    itemBase.clear2();
                    itemBase.isshowLock(true);
                    itemBase.itemnumberDown.align = 1;
                    var info = this.heroConfigTab.getRow(0);
                    var stoneOpenLevel = Number(info.getValFromColName("stoneOpenLevel")); //宝石开启所需英雄等级
                    itemBase.setNumber2("lv." + stoneOpenLevel, true);
                }
                else {
                    itemBase.itemnumberDown.align = 2;
                    var info = this.stoneTab.getRowFromColName("level", "" + this.gemLevel);
                    var star = info.getValFromColName("star"); //星级
                    var color = info.getValFromColName("color"); //品质颜色
                    itemBase.isshowLock(false);
                    itemBase.setGemData(this.gemLevel);
                    itemBase.setColor2(color);
                    itemBase.setStar2(star);
                    itemBase.setNumber2("", false);
                }
                this.onEgretEvent(item, egret.TouchEvent.TOUCH_TAP, this.editGemItem, this, true);
            }
        }
    };
    //是否可以穿装+号提示
    HeroCultivateView.prototype.showEquJia = function (type) {
        var pass = false;
        var itemArr = MyData.user.json.itemArr;
        var count = itemArr.length;
        for (var i = 0; i < count; i++) {
            var itemID = itemArr[i].itemID;
            if (type == 5) {
                var itemShipinInfo = this.itemShipinTab.getRowFromColName("id", "" + itemID);
                if (itemShipinInfo) {
                    pass = true;
                }
            }
            else {
                var itemEquipInfo = this.itemEquipTab.getRowFromColName("id", "" + itemID);
                if (itemEquipInfo) {
                    var typeE = Number(itemEquipInfo.getValFromColName("type")); //装备类型
                    if (type == typeE) {
                        pass = true;
                    }
                }
            }
        }
        return pass;
    };
    HeroCultivateView.prototype.editGemItem = function (obj) {
        var _this = this;
        if (this.gemLevel == 0) {
            var info = this.heroConfigTab.getRow(0);
            var stoneOpenLevel = Number(info.getValFromColName("stoneOpenLevel")); //宝石开启所需英雄等级
            var heroInfo = MyData.user.json.cardArr[this.cardIndex];
            var level = heroInfo.level; //等级
            if (level < stoneOpenLevel) {
                TipsViewSystem.show("英雄等级不足");
            }
            else {
                net.cardGemStart(this.cardIndex, function () {
                    TipsViewSystem.show("宝石激活成功");
                    _this.updateEqu();
                }, this);
            }
        }
        else {
            this.jumpEditEqu(3);
        }
    };
    HeroCultivateView.prototype.editItem = function (obj) {
        this.equType = obj.target._id; //装备类型
        this.selectEquID = this.equArr[this.equType]; //装备ID
        this.updateEquList();
    };
    //更新装备列表
    HeroCultivateView.prototype.updateEquList = function () {
        var pass = 1;
        var itemArr = MyData.user.json.itemArr;
        this.equList.removeChildrenToPool(); //清空列表
        this.ui.getController("selectItemUI").selectedIndex = (1);
        for (var i = 0; i < itemArr.length; i++) {
            var itemID = itemArr[i].itemID;
            var itemInfo = this.itemTab.getRowFromColName("id", "" + itemID);
            var usetype = itemInfo.getValFromColName("usetype"); //使用类型（5=装备）
            if (usetype == 5 && this.equType != 5) {
                var itemEquipInfo = this.itemEquipTab.getRowFromColName("id", "" + itemID);
                var type = itemEquipInfo.getValFromColName("type"); //装备类型
                if (this.equType == type) {
                    pass = 0;
                    this.equTypeChange(itemArr, itemID, i, itemEquipInfo);
                }
            }
            else if (usetype == 6 && this.equType == 5) {
                pass = 0;
                var itemShipinInfo = this.itemShipinTab.getRowFromColName("id", "" + itemID);
                this.equTypeChange(itemArr, itemID, i, itemShipinInfo);
            }
        }
        this.onFairyguiEvent(this.equList, fairygui.ItemEvent.CLICK, this.editEquOrList, this);
        if (this.selectEquID && pass) {
            this.ui.getController("selectItemUI").selectedIndex = (0);
            this.jumpEditEqu();
        }
    };
    //装备类型改变
    HeroCultivateView.prototype.equTypeChange = function (itemArr, itemID, i, info) {
        var race = info.getValFromColName("race"); //种族
        var star = info.getValFromColName("star"); //星级
        if (this.selectEquID == 0) {
            var item = this.equList.addItemFromPool().asCom;
            var itemBase = new ItemBase(item, this, 1);
            item._id = itemID;
            item.data = i;
            itemBase.setItemData(itemID, race, star);
            itemBase.setStar2(star);
            itemBase.setNumber(itemArr[i].count, true);
        }
        else {
            if (this.tihuanPass) {
                this.ui.getController("selectItemUI").selectedIndex = (1);
                this.ui.getController("equInfo").selectedIndex = (0);
                var item = this.equList.addItemFromPool().asCom;
                var itemBase = new ItemBase(item, this, 1);
                item._id = itemID;
                item.data = i;
                itemBase.setItemData(itemID, race, star);
                itemBase.setStar2(star);
                itemBase.setNumber(itemArr[i].count, true);
            }
            else {
                // if(this.selectEquID == itemID)
                // {
                this.ui.getController("selectItemUI").selectedIndex = (0);
                this.equInfoUI.getController("c1").selectedIndex = (1);
                this.itemArrIndex = i;
                this.jumpEditEqu();
                //}
            }
        }
        var heroInfo = MyData.user.json.cardArr[this.cardIndex];
        var looking = heroInfo.looking; //饰品ID
        if (looking) {
            if (this.equType == 5) {
                var shipinData = this.itemShipinTab.getRowFromColName("id", "" + looking);
                var nextID = Number(shipinData.getValFromColName("nextID")); //下一级id
                if (nextID) {
                    this.equInfoUI.getController("c2").selectedIndex = (1);
                }
                else {
                    this.equInfoUI.getController("c2").selectedIndex = (2);
                }
            }
            else {
                this.equInfoUI.getController("c2").selectedIndex = (0);
            }
        }
        else {
            this.equInfoUI.getController("c2").selectedIndex = (0);
        }
    };
    HeroCultivateView.prototype.editEquOrList = function (obj) {
        if (this.selectEquID == 0) {
            this.equInfoUI.getController("c1").selectedIndex = (0);
            this.selectEquID = Number(obj.itemObject._id);
            this.itemArrIndex = obj.itemObject.data;
            this.jumpEditEqu();
        }
        else {
            if (this.tihuanPass) {
                this.ui.getController("equInfo").selectedIndex = (1);
                this.equInfoUI.getController("c1").selectedIndex = (2);
                this.equInfoUI.getController("c2").selectedIndex = (0);
                var tihuanEquID = Number(obj.itemObject._id); //替换装备ID
                this.tihuanEquItemArrIndex = obj.itemObject.data; //替换装备itemArr下标
                var item = this.equInfoUI.getChild("n18").asCom;
                var equItemBase = new ItemBase(item, this, 1);
                var star = this.backStar(tihuanEquID); //星级
                equItemBase.setItemData(tihuanEquID);
                equItemBase.setStar2(star);
                this.updateItemData(tihuanEquID);
            }
        }
    };
    //更新替换道具框属性
    HeroCultivateView.prototype.updateItemData = function (tihuanEquID) {
        var str = "";
        if (this.equType == 5) {
            var GetShipinTextInfo = WeaponTipsData.inst().GetShipinTextInfo(tihuanEquID);
            for (var i = 0; i < GetShipinTextInfo.length; i++) {
                str += GetShipinTextInfo[i] + "\n";
            }
        }
        else {
            str = WeaponTipsData.inst().GetTextById(tihuanEquID); //属性
        }
        this.itemnameT.text = WeaponTipsData.inst().GetNameById(tihuanEquID);
        this.itemattributeT0.text = str; //属性
        if (WeaponTipsData.inst().isTaozhuang(tihuanEquID)) {
            this.equInfoUI.getController("item2Data").selectedIndex = (1);
            var tzID = BagData.inst().GetTaozhuangIdById(tihuanEquID);
            var info = BagData.inst().GetTaozhuangInfoByTzID(tzID);
            this.itemnameT2.text = "" + info.name;
            this.itemattributeT1.text = "+" + ("" + info.hpRate2); //套装属性1
            this.itemattributeT2.text = "+" + ("" + info.atkRate3); //套装属性2
            this.itemattributeT3.text = "+" + ("" + info.hpRate4); //套装属性3
        }
        else {
            this.equInfoUI.getController("item2Data").selectedIndex = (0);
        }
    };
    //返回星级
    HeroCultivateView.prototype.backStar = function (itemID) {
        var info;
        if (this.equType == 5) {
            info = this.itemShipinTab.getRowFromColName("id", "" + itemID);
        }
        else {
            info = this.itemEquipTab.getRowFromColName("id", "" + itemID);
        }
        var star = info.getValFromColName("star"); //星级
        return star;
    };
    HeroCultivateView.prototype.jumpEditEqu = function (num) {
        if (num === void 0) { num = 0; }
        var equItem = this.equInfoUI.getChild("n8").asCom;
        var equItemBase = new ItemBase(equItem, this, 1);
        var heroInfo = MyData.user.json.cardArr[this.cardIndex];
        if (num) {
            this.itemattributeB0 = this.equInfoUI.getChild("itemattributeB0").asTextField; //
            this.itemattributeB1 = this.equInfoUI.getChild("itemattributeB1").asTextField; //
            this.itemattributeB2 = this.equInfoUI.getChild("itemattributeB2").asTextField; //
            this.itemattribute0.text = "";
            this.itemattributeB0.text = "";
            this.itemattributeB1.text = "";
            this.itemattributeB2.text = "";
            this.equInfoUI.getController("c1").selectedIndex = (3);
            this.equInfoUI.getController("c2").selectedIndex = (0);
            this.equInfoUI.getController("c3").selectedIndex = (1);
            this.equInfoUI.getController("item1Data").selectedIndex = (0);
            var info = this.stoneTab.getRowFromColName("level", "" + this.gemLevel);
            var star = info.getValFromColName("star"); //星级
            var color = info.getValFromColName("color"); //品质颜色
            var type = info.getValFromColName("att" + this.gemType); //属性
            var name_27 = info.getValFromColName("name"); //名称
            var arr = type;
            var num_2 = arr.length;
            var typeNum = 0;
            for (var j = 0; j < num_2; j++) {
                var attrID = arr[j];
                var attrInfo = this.stoneAttrTypeTab.getRowFromColName("id", "" + attrID);
                this["itemattributeB" + typeNum].text = "+" + arr[j + 1] / this.doubleArr[attrID] + this.nameArr[attrID];
                j++;
                typeNum++;
            }
            this.itemname.text = name_27;
            equItemBase.setGemData(this.gemLevel);
            equItemBase.setColor2(color);
            equItemBase.setStar2(star);
        }
        else {
            this.equInfoUI.getController("c3").selectedIndex = (0);
            //道具属性
            var str = "";
            this.itemattribute0.text = "";
            if (this.equType == 5) {
                var GetShipinTextInfo = WeaponTipsData.inst().GetShipinTextInfo(this.selectEquID);
                for (var i = 0; i < GetShipinTextInfo.length; i++) {
                    str += GetShipinTextInfo[i] + "\n";
                }
            }
            else {
                str = WeaponTipsData.inst().GetTextById(this.selectEquID); //属性0
            }
            this.itemname.text = WeaponTipsData.inst().GetNameById(this.selectEquID);
            this.itemattribute0.text = str;
            if (WeaponTipsData.inst().isTaozhuang(this.selectEquID)) {
                this.equInfoUI.getController("item1Data").selectedIndex = (1);
                var tzID = BagData.inst().GetTaozhuangIdById(this.selectEquID);
                var info = BagData.inst().GetTaozhuangInfoByTzID(tzID);
                var tzIDInfo = this.itemEquipSuitTab.getRowFromColName("id", "" + tzID);
                var equipIDStr = tzIDInfo.getValFromColName("equipID"); //套装装备id
                var equipIDArr = equipIDStr;
                equipIDArr = equipIDArr.map(Number);
                var suitNeedCount = equipIDArr.length;
                var suitCount = 0;
                var arm = heroInfo.arm; //武器ID
                var head = heroInfo.head; //头盔ID
                var ring = heroInfo.ring; //戒子ID
                var clothes = heroInfo.clothes; //衣服ID
                var arrIndex1 = equipIDArr.indexOf(arm);
                var arrIndex2 = equipIDArr.indexOf(head);
                var arrIndex3 = equipIDArr.indexOf(ring);
                var arrIndex4 = equipIDArr.indexOf(clothes);
                if (arrIndex1 != -1) {
                    suitCount++;
                }
                if (arrIndex2 != -1) {
                    suitCount++;
                }
                if (arrIndex3 != -1) {
                    suitCount++;
                }
                if (arrIndex4 != -1) {
                    suitCount++;
                }
                this.itemname2.text = "" + (info.name + "  (" + suitCount + "/" + suitNeedCount + ")");
                this.itemattribute1.text = "+" + ("" + info.hpRate2); //套装属性1
                this.itemattribute2.text = "+" + ("" + info.atkRate3); //套装属性2
                this.itemattribute3.text = "+" + ("" + info.hpRate4); //套装属性3
                for (var i = 1; i < 4; i++) {
                    if (i + 1 <= suitCount) {
                        this["itemattribute" + i].color = "#00FF00";
                    }
                    else {
                        this["itemattribute" + i].color = "#CCCCCC";
                    }
                }
            }
            else {
                this.equInfoUI.getController("item1Data").selectedIndex = (0);
            }
            equItemBase.setItemData(this.selectEquID);
            var star1 = this.backStar(this.selectEquID); //星级
            equItemBase.setStar2(star1);
        }
        this.ui.getController("equInfo").selectedIndex = (1);
        var heroItem = this.equInfoUI.getChild("n13").asCom;
        var heroItemBase = new ItemBase(heroItem, this, 2);
        var race = heroInfo.race;
        var starMax = heroInfo.starMax;
        var level = heroInfo.level;
        heroItemBase.setItemData(this.heroID, race, starMax);
        heroItemBase.setNumber(level, false);
    };
    HeroCultivateView.prototype.showHeroInfo = function () {
        this.showType();
        var cardArr = MyData.user.json.cardArr;
        var heroInfo = cardArr[this.cardIndex];
        var race = heroInfo.race;
        var level = heroInfo.level;
        var levelMax = heroInfo.levelMax;
        var star = heroInfo.star;
        var starMax = heroInfo.starMax;
        this.atkS = heroInfo.atk;
        this.defS = heroInfo.def;
        this.hpS = heroInfo.hp;
        this.speedS = heroInfo.speed;
        var lock = heroInfo.lock;
        var job = heroInfo.job;
        var heroData = this.heroTab.getRowFromColName("id", "" + this.heroID);
        var lvInfo = this.heroLvTab.getRowFromColName("lv", "" + level);
        var heroExp = lvInfo.getValFromColName("heroExp");
        var gold = lvInfo.getValFromColName("gold");
        var iconArr = ["n95", "n96", "n97"];
        var passiveSkillIconArr = [this.skillDataArr[1][3], this.skillDataArr[2][3], this.skillDataArr[3][3]];
        var passiveSkillOpenArr = [this.skillDataArr[1][4], this.skillDataArr[2][4], this.skillDataArr[3][4]];
        this.ui.getController("c2").selectedIndex = (1);
        this.setLoaderUrl(this.ui.getChild("n94").asCom.getChild("n64").asLoader, "resource/icon/skillico/" + this.skillDataArr[0][3] + ".png");
        this.ui.getChild("n94").asCom.data = 1;
        for (var i = 0; i < 3; i++) {
            this.ui.getChild(iconArr[i]).asCom.data = i + 2;
            var icon = passiveSkillIconArr[i];
            var num = passiveSkillOpenArr[i];
            if (num <= starMax && icon != 0) {
                this.ui.getController("c2").selectedIndex = (i + 2);
                this.setLoaderUrl(this.ui.getChild(iconArr[i]).asCom.getChild("n64").asLoader, "resource/icon/skillico/" + icon + ".png");
            }
            if (star < num) {
                this.ui.getChild(iconArr[i]).asCom.getChild("n64").enabled = false;
            }
            else {
                this.ui.getChild(iconArr[i]).asCom.getChild("n64").enabled = true;
            }
        }
        if (level == levelMax) {
            this.jinjie.visible = true;
            this.shengji.visible = false;
            this.ui.getController("max").selectedIndex = (1); //最大等级
            if (star == starMax) {
                this.jinjie.visible = false;
            }
        }
        else {
            this.jinjie.visible = false;
            this.shengji.visible = true;
            this.ui.getController("max").selectedIndex = (0); //升级消耗显示
        }
        var lvNum = this.heroLvTab.size(); //最大等级
        if (level != lvNum) {
            this.ui.getChild("n67").asTextField.text = Common.overLength(gold); //消耗金币
            this.ui.getChild("n69").asTextField.text = Common.overLength(heroExp); //消耗英雄经验
        }
        else {
            this.ui.getChild("n67").asTextField.text = "0"; //消耗金币
            this.ui.getChild("n69").asTextField.text = "0"; //消耗英雄经验
        }
        var heroName = heroData.getValFromColName("name"); //昵称
        this.ui.getChild("n62").asCom.getController("kong").selectedIndex = (starMax); //星级最大值
        this.ui.getChild("n62").asCom.getController("man").selectedIndex = (star); //星级
        this.ui.getChild("n77").asTextField.text = level + "/" + levelMax; //等级/最大等级
        this.ui.getChild("n87").asTextField.text = this.atkS + ""; //攻击
        this.ui.getChild("n88").asTextField.text = this.defS + ""; //防御
        this.ui.getChild("n89").asTextField.text = this.speedS + ""; //速度
        this.ui.getChild("n90").asTextField.text = this.hpS + ""; //血量
        this.ui.getChild("n140").asCom.getChild("n4").asTextField.text = Formula.getCardIndexPower(this.cardIndex) + "";
        this.ui.getChild("n152").asCom.getChild("n3").asCom.getController("c1").selectedIndex = (race);
        this.ui.getChild("n152").asCom.getChild("n1").asTextField.text = heroName + "";
        this.ui.getChild("n152").asCom.getChild("n2").asCom.getController("star").selectedIndex = (starMax);
        this.showZhiye(job);
        this.setLock();
    };
    //职业
    HeroCultivateView.prototype.showZhiye = function (job) {
        var jobArr = ["0", "战士", "法师", "牧师", "刺客", "游侠"];
        this.ui.getChild("n78").asTextField.text = jobArr[job];
        this.ui.getChild("n141").asCom.getController("c1").selectedIndex = (job);
    };
    //龙骨显示
    HeroCultivateView.prototype.showLonggu = function (heroID) {
        if (!this.heroNode) {
            this.heroNode = new egret.DisplayObjectContainer();
            this.ui.getChild("longgu").asGraph.setNativeObject(this.heroNode);
        }
        // let tt=new egret.DisplayObjectContainer();
        // this.ui.getChild("longgu").asGraph.setNativeObject(tt);
        this.heroNode.removeChildren();
        var hero = new Hero(heroID).addToParent(this.heroNode);
        hero.touchEnabled = true;
        this.onEgretEvent(hero, egret.TouchEvent.TOUCH_TAP, function () {
            hero.setAction("atk");
        }, this);
    };
    //英雄图鉴
    HeroCultivateView.prototype.showMaxHeroInfo = function () {
        var heroData = this.heroTab.getRowFromColName("id", "" + this.tabHeroID);
        var iconArr = ["n95", "n96", "n97"];
        var passiveSkillIconArr = [this.skillDataArr[1][3], this.skillDataArr[2][3], this.skillDataArr[3][3]];
        this.ui.getController("c2").selectedIndex = (1);
        this.ui.getChild("n94").asCom.data = 1;
        this.setLoaderUrl(this.ui.getChild("n94").asCom.getChild("n64").asLoader, "resource/icon/skillico/" + this.skillDataArr[0][3] + ".png");
        for (var i = 0; i < 3; i++) {
            this.ui.getChild(iconArr[i]).asCom.data = i + 2;
            var icon = passiveSkillIconArr[i];
            if (icon != 0) {
                this.ui.getController("c2").selectedIndex = (i + 2);
                this.setLoaderUrl(this.ui.getChild(iconArr[i]).asCom.getChild("n64").asLoader, "resource/icon/skillico/" + icon + ".png");
            }
        }
        var heroName = heroData.getValFromColName("name"); //昵称
        var race = Number(heroData.getValFromColName("race")); //种族
        var job = Number(heroData.getValFromColName("job")); //职业
        var star = Number(heroData.getValFromColName("star")); //星级
        var heroPromotionInfo = this.heroPromotionTab.getRowFromColName("star", "" + star);
        var maxlv = heroPromotionInfo.getValFromColName("maxlv"); //最高可升级
        var heroComposeInfo = this.heroGrowTab.getRowFromColName("heroID", "" + this.tabHeroID);
        var hp = Number(heroComposeInfo.getValFromColName("hp")); //生命
        var atk = Number(heroComposeInfo.getValFromColName("atk")); //攻击
        var def = Number(heroComposeInfo.getValFromColName("def")); //防御
        var speed = Number(heroComposeInfo.getValFromColName("speed")); //速度
        this.ui.getController("max").selectedIndex = (1); //最大等级
        this.jinjie.visible = false;
        this.shengji.visible = false;
        this.addition.visible = false;
        this.suo.visible = false;
        this.fenxiang.visible = false;
        this.ui.getChild("n55").asButton.visible = false;
        this.ui.getChild("n56").asButton.visible = false;
        this.ui.getChild("n62").asCom.getController("man").selectedIndex = (star); //星级
        this.ui.getChild("n77").asTextField.text = maxlv + "/" + maxlv; //等级/最大等级
        this.ui.getChild("n87").asTextField.text = atk * maxlv + ""; //攻击
        this.ui.getChild("n88").asTextField.text = def * maxlv + ""; //防御
        this.ui.getChild("n89").asTextField.text = speed * maxlv + ""; //速度
        this.ui.getChild("n90").asTextField.text = hp * maxlv + ""; //血量
        this.ui.getChild("n140").asCom.getChild("n4").asTextField.text = Formula.getBattlePower(this.tabHeroID) + "";
        this.ui.getChild("n152").asCom.getChild("n3").asCom.getController("c1").selectedIndex = (race);
        this.ui.getChild("n152").asCom.getChild("n1").asTextField.text = heroName + "";
        this.ui.getChild("n152").asCom.getChild("n2").asCom.getController("star").selectedIndex = (star);
        this.showZhiye(job);
        this.showLonggu(this.tabHeroID);
    };
    HeroCultivateView.prototype.clickAdd = function () {
        this.addClickListener(this.closebtn, this.onClick, this); //关闭界面
        this.addClickListener(this.shengji, this.onClick, this); //升级
        this.addClickListener(this.jinjie, this.onClick, this); //进阶
        this.addClickListener(this.zuojiantou, this.onClick, this); //左箭头
        this.addClickListener(this.youjiantou, this.onClick, this); //右箭头
        this.addClickListener(this.suo, this.onClick, this); //锁定
        this.addClickListener(this.onekeyTuo, this.onClick, this); //一键脱装
        this.addClickListener(this.oneKeyChuan, this.onClick, this); //一键穿戴
        this.addClickListener(this.bgCloseSelectHero, this.onClick, this); //装备列表
        this.addClickListener(this.fenxiang, this.onClick, this); //打开分享界面
        this.addClickListener(this.fenxiangBgClose, this.onClick, this); //关闭分享界面
        this.addClickListener(this.shijie, this.onClick, this); //分享世界
        this.addClickListener(this.gonghui, this.onClick, this); //分享公会
        this.addClickListener(this.bgCloseEquInfo, this.onClick, this); //关闭装备属性
        this.addClickListener(this.equIDBtn, this.onClick, this); //装备确认
        this.addClickListener(this.tuoyifuBtn, this.onClick, this); //脱装备
        this.addClickListener(this.tihuanBtn, this.onClick, this); //替换装备
        this.addClickListener(this.tihuanQuery, this.onClick, this); //替换装备确认
        this.addClickListener(this.spsjBtn, this.onClick, this); //显示饰品升级界面
        this.addClickListener(this.baoshiZH, this.onClick, this); //宝石转换
        this.addClickListener(this.baoshiSJ, this.onClick, this); //宝石升级
        this.addClickListener(this.addition, this.onClick, this); //加成显示
        this.addClickListener(this.bgcloseUpStarUI, this.onClick, this); //关闭选择英雄界面
        this.addClickListener(this.xuanze, this.onClick, this); //确认选择英雄界面
        this.addClickListener(this.juexing, this.onClick, this); //觉醒
    };
    HeroCultivateView.prototype.onClick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.closebtn:
                ak.EventMgr.dispatch(GameEvent.heroLvUp);
                TopViewSystem.topViewUI.kongzhiqi(0);
                this.close();
                break;
            case this.shengji:
                var user = MyData.user;
                var heroInfo = user.json.cardArr[this.cardIndex];
                var level = heroInfo.level;
                var lvInfo = this.heroLvTab.getRowFromColName("lv", "" + level);
                var heroExp = lvInfo.getValFromColName("heroExp");
                var gold = lvInfo.getValFromColName("gold");
                var cardExp = user.cardExp;
                var money = user.money;
                if (cardExp < heroExp || money < gold) {
                    TipsViewSystem.show("金币或英雄经验不足");
                }
                else {
                    net.cardUp(this.cardIndex, function () {
                        //特效
                        var tt = new egret.DisplayObjectContainer();
                        _this.ui.getChild("n321").asGraph.setNativeObject(tt);
                        var eff = new Effect("uiEff_shengji", 1).addToParent(tt);
                        eff.scaleX = 1.2;
                        eff.scaleY = 1.2;
                        _this.showHeroInfo();
                    }, this);
                }
                break;
            case this.jinjie:
                ak.FairyGUI.open(["HeroJinjieView", this.cardIndex]);
                break;
            case this.zuojiantou:
                this.atkS = 0;
                this.backOrNextHeroShow(-1);
                break;
            case this.youjiantou:
                this.atkS = 0;
                this.backOrNextHeroShow(1);
                break;
            case this.suo:
                var lock = this.suo.getController("c1").selectedIndex;
                var arr = [1, 0];
                net.cardLock(this.cardIndex, arr[lock], function () {
                    _this.setLock();
                }, this);
                break;
            case this.onekeyTuo:
                net.cardOneKeyUnwearEqu(this.cardIndex, function () {
                    _this.updateEqu();
                    _this.showHeroInfo();
                }, this);
                break;
            case this.oneKeyChuan:
                net.cardOneKeyWearEqu(this.cardIndex, function () {
                    _this.updateEqu();
                    _this.showHeroInfo();
                }, this);
                break;
            case this.bgCloseSelectHero:
                this.tihuanPass = false;
                this.ui.getController("selectItemUI").selectedIndex = (0);
                break;
            case this.fenxiang:
                this.ui.getController("fenxiang").selectedIndex = (1);
                break;
            case this.fenxiangBgClose:
                this.ui.getController("fenxiang").selectedIndex = (0);
                break;
            case this.shijie:
                var info = MyData.user.json.cardArr[this.cardIndex];
                var json = {};
                json["heroID"] = info.heroID;
                json["star"] = info.star;
                json["starMax"] = info.starMax;
                json["level"] = info.level;
                json["atk"] = info.atk;
                json["def"] = info.def;
                json["hp"] = info.hp;
                json["speed"] = info.speed;
                json["battlePower"] = info.battlePower;
                var jsonStr = JSON.stringify(json);
                net.sendWorldChat(jsonStr, 1);
                break;
            case this.gonghui:
                var cardinfo = MyData.user.json.cardArr[this.cardIndex];
                var cardjson = {};
                cardjson["heroID"] = cardinfo.heroID;
                cardjson["star"] = cardinfo.star;
                cardjson["starMax"] = cardinfo.starMax;
                cardjson["level"] = cardinfo.level;
                cardjson["atk"] = cardinfo.atk;
                cardjson["def"] = cardinfo.def;
                cardjson["hp"] = cardinfo.hp;
                cardjson["speed"] = cardinfo.speed;
                cardjson["battlePower"] = cardinfo.battlePower;
                var cardjsonStr = JSON.stringify(cardjson);
                net.sendUnionChat(cardjsonStr, 1);
                break;
            case this.bgCloseEquInfo:
                this.ui.getController("equInfo").selectedIndex = (0);
                //this.ui.getController("selectItemUI").selectedIndex=(0);
                this.selectEquID = 0;
                this.tihuanPass = false;
                break;
            case this.equIDBtn:
                this.ui.getController("selectItemUI").selectedIndex = (0);
                this.ui.getController("equInfo").selectedIndex = (0);
                net.cardWearEqu(this.cardIndex, this.itemArrIndex, function () {
                    _this.updateEqu();
                    _this.showHeroInfo();
                }, this);
                break;
            case this.tuoyifuBtn:
                net.cardUnwearEqu(this.cardIndex, this.equType, function () {
                    _this.ui.getController("equInfo").selectedIndex = (0);
                    _this.updateEqu();
                    _this.showHeroInfo();
                }, this);
                break;
            case this.tihuanBtn:
                this.tihuanPass = true;
                this.updateEquList();
                break;
            case this.tihuanQuery:
                this.tihuanPass = false;
                this.ui.getController("equInfo").selectedIndex = (0);
                this.ui.getController("selectItemUI").selectedIndex = (0);
                net.cardWearEqu(this.cardIndex, this.tihuanEquItemArrIndex, function () {
                    _this.updateEqu();
                    _this.showHeroInfo();
                }, this);
                break;
            case this.spsjBtn:
                //显示饰品升级界面
                ak.FairyGUI.open(["ShipinUpgradeView", this.cardIndex]);
                this.ui.getController("equInfo").selectedIndex = (0);
                break;
            case this.baoshiZH:
                ak.FairyGUI.open(["BaoshiUpgradeView", this.cardIndex, 0]);
                this.ui.getController("equInfo").selectedIndex = (0);
                break;
            case this.baoshiSJ:
                ak.FairyGUI.open(["BaoshiUpgradeView", this.cardIndex, 1]);
                this.ui.getController("equInfo").selectedIndex = (0);
                break;
            case this.addition:
                ak.FairyGUI.open(["AdditionView", this.cardIndex]);
                break;
            case this.bgcloseUpStarUI:
            case this.xuanze:
                this.xuanzhongQuery();
                break;
            case this.juexing:
                var heroPromotionInfo = this.heroPromotionTab.getRowFromColName("star", "" + this.upStarNeed);
                var item = heroPromotionInfo.getValFromColName("item"); //升到下级消耗道具id
                var cost = heroPromotionInfo.getValFromColName("cost"); //升到下级消耗道具数量
                var pass = 1;
                var itemArr = MyData.user.json.itemArr;
                var itemArrCount = itemArr.length;
                for (var i = 0; i < itemArrCount; i++) {
                    var itemInfo = itemArr[i];
                    var itemID = itemInfo.itemID;
                    var count = itemInfo.count;
                    if (itemID == item && count >= cost) {
                        pass = 0; //为0表示道具数量够
                    }
                }
                console.log("英雄升星  pass =", pass);
                if (pass) {
                    TipsViewSystem.show("勇气徽章不足");
                }
                else {
                    console.log("发送参数", this.needHeroIndexArr);
                    net.cardCompose(this.nextHeroID, this.needHeroIndexArr, function () {
                        TipsViewSystem.show("合成成功");
                        var cardArr = MyData.user.json.cardArr;
                        var count = cardArr.length;
                        for (var i = 0; i < count; i++) {
                            var heroInfo_1 = cardArr[i];
                            var onlyIDS = heroInfo_1.id;
                            if (_this.onlyHeroID == onlyIDS) {
                                _this.cardIndex = i;
                                _this.showHeroArr = HeroBagData.inst().GetHeroGroupInfoByIndex(0, 0);
                                _this.upgradeView();
                                ak.FairyGUI.open(["ChooseTipsView", 9, heroInfo_1.starMax + "星英雄养成礼包（限时）已激活，是否去购买", function () {
                                        _this.close();
                                        ak.FairyGUI.open(["ActivityCommonView", "ActivityLimitGiftView"]);
                                    }]);
                            }
                        }
                    }, this);
                }
                break;
        }
    };
    //显示左右英雄
    HeroCultivateView.prototype.backOrNextHeroShow = function (num) {
        var count = this.showHeroArr.length;
        var index = 0;
        for (var i = 0; i < count; i++) {
            if (this.tabHeroID) {
                var heroIDS = this.showHeroArr[i][1].heroID;
                if (heroIDS == this.tabHeroID) {
                    index = this.showHeroArr[i + num][1].heroID;
                }
            }
            else {
                var indexS = this.showHeroArr[i][0];
                if (this.cardIndex == indexS) {
                    index = this.showHeroArr[i + num][0];
                }
            }
        }
        if (this.tabHeroID) {
            this.tabHeroID = index;
        }
        else {
            this.cardIndex = index;
        }
        this.upgradeView();
    };
    //设置箭头
    HeroCultivateView.prototype.showJiantou = function () {
        var count = this.showHeroArr.length;
        var index = 0;
        for (var i = 0; i < count; i++) {
            if (this.tabHeroID) {
                var heroIDS = Number(this.showHeroArr[i][1].heroID);
                if (heroIDS == this.tabHeroID) {
                    index = i;
                }
            }
            else {
                var indexS = this.showHeroArr[i][0];
                if (this.cardIndex == indexS) {
                    index = i;
                }
            }
        }
        //左箭头
        if (index == 0) {
            this.zuojiantou.visible = false;
        }
        else {
            this.zuojiantou.visible = true;
        }
        //右箭头
        if (count == index + 1) {
            this.youjiantou.visible = false;
        }
        else {
            this.youjiantou.visible = true;
        }
    };
    //设置锁
    HeroCultivateView.prototype.setLock = function () {
        var lock = MyData.user.json.cardArr[this.cardIndex].lock;
        this.suo.getController("c1").selectedIndex = (lock);
    };
    return HeroCultivateView;
}(ak.EasyUI));
__reflect(HeroCultivateView.prototype, "HeroCultivateView");
//卡牌进阶成功界面
var HeroJinjieOkView = (function (_super) {
    __extends(HeroJinjieOkView, _super);
    function HeroJinjieOkView(cardIndex, star) {
        var _this = _super.call(this, HeroCultivateSystem.inst, MyGame.inst.uiLayer2_1) || this;
        _this.cardIndex = cardIndex;
        _this.star = star;
        return _this;
    }
    //初始化回调
    HeroJinjieOkView.prototype.onInit = function () {
        this.ui = this.create("HeroCultivate", "HeroJinjieOkView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.heroPromotionTab = ak.JsonTableMgr.get("heroPromotion");
        this.heroGrowTab = ak.JsonTableMgr.get("heroGrow");
        this.clickAdd();
        this.showUpdate();
    };
    //界面更新
    HeroJinjieOkView.prototype.showUpdate = function () {
        var heroInfo = MyData.user.json.cardArr[this.cardIndex];
        var level = heroInfo.level;
        var info = this.heroPromotionTab.getRowFromColName("star", "" + this.star);
        var hpPro = Number(info.getValFromColName("hpPro")) / 10000; //
        var atkPro = Number(info.getValFromColName("atkPro")) / 10000; //
        var defPro = Number(info.getValFromColName("defPro")) / 10000; //
        var speedPro = Number(info.getValFromColName("speedPro")) / 10000; //
        var nextInfo = this.heroPromotionTab.getRowFromColName("star", "" + (this.star + 1));
        var maxlv = nextInfo.getValFromColName("maxlv"); //当前星级最高可升级
        var hpProNext = Number(nextInfo.getValFromColName("hpPro")) / 10000; //
        var atkProNext = Number(nextInfo.getValFromColName("atkPro")) / 10000; //
        var defProNext = Number(nextInfo.getValFromColName("defPro")) / 10000; //
        var speedProNext = Number(nextInfo.getValFromColName("speedPro")) / 10000; //
        var heroGrowRow = this.heroGrowTab.getRowFromColName("heroID", "" + heroInfo.heroID);
        var hp = Number(heroGrowRow.getValFromColName("hp")); //生命
        var atk = Number(heroGrowRow.getValFromColName("atk")); //攻击
        var def = Number(heroGrowRow.getValFromColName("def")); //防御
        var speed = Number(heroGrowRow.getValFromColName("speed")); //速度
        var hpGrow = Number(heroGrowRow.getValFromColName("hpGrow")); //生命成长
        var atkGrow = Number(heroGrowRow.getValFromColName("atkGrow")); //攻击成长
        var defGrow = Number(heroGrowRow.getValFromColName("defGrow")); //防御成长
        var speedGrow = Number(heroGrowRow.getValFromColName("speedGrow")); //速度成长
        hp += (level - 1) * hpGrow;
        atk += (level - 1) * atkGrow;
        def += (level - 1) * defGrow;
        speed += (level - 1) * speedGrow;
        this.ui.getChild("typeData1").asTextField.text = level;
        this.ui.getChild("typeData2").asTextField.text = Math.floor(atk * atkPro) + "";
        this.ui.getChild("typeData3").asTextField.text = Math.floor(def * defPro) + "";
        this.ui.getChild("typeData4").asTextField.text = Math.floor(hp * hpPro) + "";
        this.ui.getChild("typeData5").asTextField.text = Math.floor(speed * speedPro) + "";
        this.ui.getChild("typeDataT1").asTextField.text = maxlv;
        this.ui.getChild("typeDataT2").asTextField.text = Math.floor(atk * atkProNext) + "";
        this.ui.getChild("typeDataT3").asTextField.text = Math.floor(def * defProNext) + "";
        this.ui.getChild("typeDataT4").asTextField.text = Math.floor(hp * hpProNext) + "";
        this.ui.getChild("typeDataT5").asTextField.text = Math.floor(speed * speedProNext) + "";
    };
    HeroJinjieOkView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this); //关闭界面
    };
    HeroJinjieOkView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
        }
    };
    return HeroJinjieOkView;
}(ak.EasyUI));
__reflect(HeroJinjieOkView.prototype, "HeroJinjieOkView");
//卡牌英雄进阶界面
var HeroJinjieView = (function (_super) {
    __extends(HeroJinjieView, _super);
    function HeroJinjieView(cardIndex) {
        var _this = _super.call(this, HeroCultivateSystem.inst, MyGame.inst.uiLayer2_1) || this;
        _this.cardIndex = cardIndex;
        return _this;
    }
    //初始化回调
    HeroJinjieView.prototype.onInit = function () {
        this.ui = this.create("HeroCultivate", "HeroJinjieView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.jinjieBtn = this.ui.getChild("n67").asButton;
        this.needMoneyText = this.ui.getChild("n17").asTextField; //
        this.changeNumText = this.ui.getChild("n18").asTextField; //
        this.heroPromotionTab = ak.JsonTableMgr.get("heroPromotion");
        this.heroGrowTab = ak.JsonTableMgr.get("heroGrow");
        this.heroTab = ak.JsonTableMgr.get("hero");
        this.clickAdd();
        this.showUpdate();
    };
    //界面更新
    HeroJinjieView.prototype.showUpdate = function () {
        var heroInfo = MyData.user.json.cardArr[this.cardIndex];
        this.star = heroInfo.star;
        var starMax = heroInfo.starMax;
        var level = heroInfo.level;
        var levelMax = heroInfo.levelMax;
        if (level == levelMax && this.star < starMax) {
            var info = this.heroPromotionTab.getRowFromColName("star", "" + this.star);
            var gold = info.getValFromColName("gold"); //升到下级消耗金币
            var itemID = info.getValFromColName("item"); //升到下级消耗道具id
            var cost = info.getValFromColName("cost"); //升到下级消耗道具数量
            var itemArr = MyData.user.json.itemArr;
            var itemCount = 0;
            for (var i = 0; i < itemArr.length; i++) {
                var id = itemArr[i].itemID;
                if (id == itemID) {
                    itemCount = itemArr[i].count;
                }
            }
            var money = MyData.user.money; //金币
            this.needMoneyText.text = Common.overLength(gold) + "/" + Common.overLength(money);
            this.changeNumText.text = cost + "/" + Common.overLength(itemCount);
            var hpPro = Number(info.getValFromColName("hpPro")) / 10000; //
            var atkPro = Number(info.getValFromColName("atkPro")) / 10000; //
            var defPro = Number(info.getValFromColName("defPro")) / 10000; //
            var speedPro = Number(info.getValFromColName("speedPro")) / 10000; //
            var nextInfo = this.heroPromotionTab.getRowFromColName("star", "" + (this.star + 1));
            var maxlv = nextInfo.getValFromColName("maxlv"); //当前星级最高可升级
            var hpProNext = Number(nextInfo.getValFromColName("hpPro")) / 10000; //
            var atkProNext = Number(nextInfo.getValFromColName("atkPro")) / 10000; //
            var defProNext = Number(nextInfo.getValFromColName("defPro")) / 10000; //
            var speedProNext = Number(nextInfo.getValFromColName("speedPro")) / 10000; //
            var heroGrowRow = this.heroGrowTab.getRowFromColName("heroID", "" + heroInfo.heroID);
            var hp = Number(heroGrowRow.getValFromColName("hp")); //生命
            var atk = Number(heroGrowRow.getValFromColName("atk")); //攻击
            var def = Number(heroGrowRow.getValFromColName("def")); //防御
            var speed = Number(heroGrowRow.getValFromColName("speed")); //速度
            var hpGrow = Number(heroGrowRow.getValFromColName("hpGrow")); //生命成长
            var atkGrow = Number(heroGrowRow.getValFromColName("atkGrow")); //攻击成长
            var defGrow = Number(heroGrowRow.getValFromColName("defGrow")); //防御成长
            var speedGrow = Number(heroGrowRow.getValFromColName("speedGrow")); //速度成长
            hp += (level - 1) * hpGrow;
            atk += (level - 1) * atkGrow;
            def += (level - 1) * defGrow;
            speed += (level - 1) * speedGrow;
            this.ui.getChild("typeData1").asTextField.text = level;
            this.ui.getChild("typeData2").asTextField.text = Math.floor(atk * atkPro) + "";
            this.ui.getChild("typeData3").asTextField.text = Math.floor(def * defPro) + "";
            this.ui.getChild("typeData4").asTextField.text = Math.floor(hp * hpPro) + "";
            this.ui.getChild("typeData5").asTextField.text = Math.floor(speed * speedPro) + "";
            this.ui.getChild("typeDataT1").asTextField.text = maxlv;
            this.ui.getChild("typeDataT2").asTextField.text = Math.floor(atk * atkProNext) + "";
            this.ui.getChild("typeDataT3").asTextField.text = Math.floor(def * defProNext) + "";
            this.ui.getChild("typeDataT4").asTextField.text = Math.floor(hp * hpProNext) + "";
            this.ui.getChild("typeDataT5").asTextField.text = Math.floor(speed * speedProNext) + "";
            this.showSkill(heroInfo.heroID, this.star + 1);
        }
    };
    HeroJinjieView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this); //关闭界面
        this.addClickListener(this.jinjieBtn, this.onClick, this); //关闭界面
    };
    HeroJinjieView.prototype.onClick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.jinjieBtn:
                net.cardUpStar(this.cardIndex, function () {
                    //TipsViewSystem.show("卡牌进阶成功");
                    ak.FairyGUI.open(["HeroJinjieOkView", _this.cardIndex, _this.star]);
                    HeroCultivateSystem.HeroCultivateViewUI.showHeroInfo();
                    _this.close();
                }, this);
                break;
        }
    };
    //显示技能
    HeroJinjieView.prototype.showSkill = function (heroID, star) {
        var heroData = this.heroTab.getRowFromColName("id", "" + heroID);
        var activeSkill = heroData.getValFromColName("activeSkill"); //主动技能
        var activeSkillName = heroData.getValFromColName("activeSkillName"); //主动技能名称
        var activeSkillText = heroData.getValFromColName("activeSkillText"); //主动技能描述
        var activeSkillIcon = heroData.getValFromColName("activeSkillIcon"); //主动技能图标
        var passiveSkill1 = heroData.getValFromColName("passiveSkill1"); //被动技能1
        var passiveSkillName1 = heroData.getValFromColName("passiveSkillName1"); //被动技能1名称
        var passiveSkillText1 = heroData.getValFromColName("passiveSkillText1"); //被动技能1描述
        var passiveSkillIcon1 = heroData.getValFromColName("passiveSkillIcon1"); //被动技能1图标
        var passiveSkillOpen1 = heroData.getValFromColName("passiveSkillOpen1"); //被动技能1开启品阶
        var passiveSkill2 = heroData.getValFromColName("passiveSkill2"); //被动技能2
        var passiveSkillName2 = heroData.getValFromColName("passiveSkillName2"); //被动技能2名称
        var passiveSkillText2 = heroData.getValFromColName("passiveSkillText2"); //被动技能2描述
        var passiveSkillIcon2 = heroData.getValFromColName("passiveSkillIcon2"); //被动技能2图标
        var passiveSkillOpen2 = heroData.getValFromColName("passiveSkillOpen2"); //被动技能2开启品阶
        var passiveSkill3 = heroData.getValFromColName("passiveSkill3"); //被动技能3
        var passiveSkillName3 = heroData.getValFromColName("passiveSkillName3"); //被动技能3名称
        var passiveSkillText3 = heroData.getValFromColName("passiveSkillText3"); //被动技能3描述
        var passiveSkillIcon3 = heroData.getValFromColName("passiveSkillIcon3"); //被动技能3图标
        var passiveSkillOpen3 = heroData.getValFromColName("passiveSkillOpen3"); //被动技能3开启品阶
        var passiveSkillIconArr = [passiveSkillIcon1, passiveSkillIcon2, passiveSkillIcon3];
        var passiveSkillOpenArr = [passiveSkillOpen1, passiveSkillOpen2, passiveSkillOpen3];
        this.ui.getController("c2").selectedIndex = (0);
        for (var i = 0; i < 3; i++) {
            var icon = passiveSkillIconArr[i];
            var num = passiveSkillOpenArr[i];
            if (star == num) {
                this.ui.getController("c2").selectedIndex = (1);
                this.setLoaderUrl(this.ui.getChild("n56").asCom.getChild("n64").asLoader, "resource/icon/skillico/" + icon + ".png");
            }
        }
    };
    return HeroJinjieView;
}(ak.EasyUI));
__reflect(HeroJinjieView.prototype, "HeroJinjieView");
//饰品升级界面
var ShipinUpgradeView = (function (_super) {
    __extends(ShipinUpgradeView, _super);
    function ShipinUpgradeView(cardIndex) {
        var _this = _super.call(this, HeroCultivateSystem.inst, MyGame.inst.uiLayer2_1) || this;
        //列表舒心
        _this.allDataArr = [];
        //饰品列表数据操作
        _this.lookingItemIDArr = []; //材料ID
        _this.lookingIndexArr = []; //材料索引数组
        _this.lookingCountArr = []; //材料数量数组
        _this.addAllExp = 0; //添加总经验值
        _this.listIndex = -1; //列表位置
        _this.cardIndex = cardIndex;
        return _this;
    }
    //初始化回调
    ShipinUpgradeView.prototype.onInit = function () {
        this.ui = this.create("HeroCultivate", "ShipinUpgradeView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.addClose = this.ui.getChild("addClose").asLoader;
        this.btnClose = this.ui.getChild("btnClose").asButton;
        this.shengjiBtn = this.ui.getChild("n15").asButton;
        this.shipinList = this.ui.getChild("n5").asList;
        this.jindutiao = this.ui.getChild('n14').asProgress;
        this.addOne = this.ui.getChild("n24").asButton;
        this.addTen = this.ui.getChild("n23").asButton;
        this.itemTab = ak.JsonTableMgr.get("item");
        this.itemShipinTab = ak.JsonTableMgr.get("itemShipin");
        this.clickAdd();
        this.showList();
    };
    ; //饰品列表数据
    ShipinUpgradeView.prototype.showList = function () {
        var heroInfo = MyData.user.json.cardArr[this.cardIndex];
        var looking = heroInfo.looking; //饰品ID
        this.allDataArr = [];
        var itemArr = MyData.user.json.itemArr;
        this.shipinList.removeChildrenToPool(); //清空列表
        var num = -1;
        for (var i = 0; i < itemArr.length; i++) {
            var itemID = itemArr[i].itemID;
            var count = itemArr[i].count;
            var itemInfo = this.itemTab.getRowFromColName("id", "" + itemID);
            var usetype = itemInfo.getValFromColName("usetype"); //使用类型（5=装备）
            if (usetype == 6) {
                num++;
                var shipinInfo_1 = this.itemShipinTab.getRowFromColName("id", "" + itemID);
                var star_1 = shipinInfo_1.getValFromColName("star"); //星级
                var item = this.shipinList.addItemFromPool().asCom;
                var itemBase = new ItemBase(item, this, 1);
                item.data = num;
                itemBase.setItemData(itemID);
                itemBase.setStar2(star_1);
                itemBase.setNumber(count, true);
                this.allDataArr.push([itemID, i, count]);
            }
        }
        this.onFairyguiEvent(this.shipinList, fairygui.ItemEvent.CLICK, this.getShiPinListData, this);
        var shipinInfo = this.itemShipinTab.getRowFromColName("id", "" + looking);
        var star = shipinInfo.getValFromColName("star"); //星级
        var nextID = Number(shipinInfo.getValFromColName("nextID")); //下一级id
        var shipinItem = this.ui.getChild("n11").asCom;
        var shipin1Item = this.ui.getChild("n12").asCom;
        var shipinItemBase = new ItemBase(shipinItem, this, 1);
        shipinItemBase.setItemData(looking);
        shipinItemBase.setStar2(star);
        var needExp = shipinInfo.getValFromColName("needExp"); //升级所需经验
        this.jindutiao.max = needExp;
        if (nextID) {
            var shipin1ItemBase = new ItemBase(shipin1Item, this, 1);
            var shipinInfo1 = this.itemShipinTab.getRowFromColName("id", "" + nextID);
            var star1 = shipinInfo1.getValFromColName("star"); //星级
            shipin1ItemBase.setItemData(nextID);
            shipin1ItemBase.setStar2(star1);
        }
    };
    ShipinUpgradeView.prototype.getShiPinListData = function (obj) {
        this.listIndex = obj.itemObject.data;
        this.ui.getController("c1").selectedIndex = 1;
        this.updateSelectItem();
    };
    //更新选中材料界面
    ShipinUpgradeView.prototype.updateSelectItem = function () {
        var oneInfo = this.allDataArr[this.listIndex];
        var itemID = oneInfo[0];
        var item = this.ui.getChild("n25").asCom;
        var itemBase = new ItemBase(item, this, 1);
        itemBase.setItemData(itemID);
        var str = "";
        var GetShipinTextInfo = WeaponTipsData.inst().GetShipinTextInfo(itemID);
        for (var i = 0; i < GetShipinTextInfo.length; i++) {
            str += GetShipinTextInfo[i] + "\n";
        }
        this.ui.getChild("n26").asTextField.text = WeaponTipsData.inst().GetNameById(itemID);
        this.ui.getChild("n27").asTextField.text = str;
    };
    //扣减数量
    ShipinUpgradeView.prototype.koujianCount = function (type) {
        if (this.listIndex != -1) {
            var oneInfo = this.allDataArr[this.listIndex];
            var itemID = oneInfo[0];
            var itemArrIndex = oneInfo[1]; //道具数组索引位置
            var itemArrIndexCount = oneInfo[2]; //道具数组索引位置数量
            var num = 1;
            if (type) {
                if (itemArrIndexCount >= 10) {
                    num = 10;
                }
                else {
                    num = itemArrIndexCount;
                }
            }
            for (var i = 0; i < num; i++) {
                if (itemArrIndexCount >= 1) {
                    var pass = this.lookingIndexArr.indexOf(itemArrIndex);
                    if (pass == -1) {
                        this.lookingItemIDArr.push(itemID);
                        this.lookingIndexArr.push(itemArrIndex);
                        this.lookingCountArr.push(1);
                    }
                    else {
                        this.lookingCountArr[pass]++;
                    }
                    this.allDataArr[this.listIndex][2]--;
                    var item = this.shipinList.getChildAt(this.listIndex).asCom;
                    var shipinItemBase = new ItemBase(item, this, 1);
                    shipinItemBase.setNumber(this.allDataArr[this.listIndex][2], true);
                    var shipinInfo = this.itemShipinTab.getRowFromColName("id", "" + itemID);
                    this.addAllExp += Number(shipinInfo.getValFromColName("exp")); //经验值
                    this.jindutiao.value = this.addAllExp;
                }
            }
        }
    };
    ShipinUpgradeView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this); //关闭界面
        this.addClickListener(this.addClose, this.onClick, this); //切换界面
        this.addClickListener(this.btnClose, this.onClick, this); //关闭界面
        this.addClickListener(this.shengjiBtn, this.onClick, this); //升级按钮
        this.addClickListener(this.addOne, this.onClick, this); //添加一个
        this.addClickListener(this.addTen, this.onClick, this); //添加十个
    };
    ShipinUpgradeView.prototype.onClick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.addClose:
                this.ui.getController("c1").selectedIndex = 0;
                break;
            case this.shengjiBtn:
                if (this.addAllExp >= this.jindutiao.max) {
                    net.cardLookingUp(this.cardIndex, this.lookingIndexArr, this.lookingCountArr, function () {
                        TipsViewSystem.show("饰品升级成功");
                        var heroInfo = MyData.user.json.cardArr[_this.cardIndex];
                        var looking = heroInfo.looking; //饰品ID
                        var shipinData = _this.itemShipinTab.getRowFromColName("id", "" + looking);
                        var nextID = Number(shipinData.getValFromColName("nextID")); //下一级id
                        if (nextID) {
                            _this.cleanData();
                        }
                        else {
                            _this.close();
                        }
                        HeroCultivateSystem.HeroCultivateViewUI.updateEqu();
                    }, this);
                }
                else {
                    TipsViewSystem.show("请放入足够材料");
                }
                break;
            case this.btnClose:
                this.cleanData();
                break;
            case this.addOne:
                this.koujianCount(0);
                break;
            case this.addTen:
                this.koujianCount(1);
                break;
        }
    };
    //清理数据
    ShipinUpgradeView.prototype.cleanData = function () {
        this.showList();
        this.lookingItemIDArr = [];
        this.lookingIndexArr = [];
        this.lookingCountArr = [];
        this.addAllExp = 0;
        this.jindutiao.value = 0;
    };
    return ShipinUpgradeView;
}(ak.EasyUI));
__reflect(ShipinUpgradeView.prototype, "ShipinUpgradeView");
//卡牌英雄数据
var HeroDataViewSystem = (function (_super) {
    __extends(HeroDataViewSystem, _super);
    function HeroDataViewSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HeroDataViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("CardDegree");
    };
    HeroDataViewSystem.inst = new HeroDataViewSystem("CardDegree");
    return HeroDataViewSystem;
}(ak.FairyGUI));
__reflect(HeroDataViewSystem.prototype, "HeroDataViewSystem");
//主界面
var HeroDataView = (function (_super) {
    __extends(HeroDataView, _super);
    function HeroDataView(heroID, json) {
        var _this = _super.call(this, HeroDataViewSystem.inst, MyGame.inst.tipLayer) || this;
        //英雄技能
        _this.skillDataArr = [];
        _this.heroID = heroID;
        _this.json = json;
        return _this;
    }
    //初始化回调
    HeroDataView.prototype.onInit = function () {
        this.ui = this.create("CardDegree", "HeroDataView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.heroTab = ak.JsonTableMgr.get("hero");
        this.heroPromotionTab = ak.JsonTableMgr.get("heroPromotion");
        this.heroGrowTab = ak.JsonTableMgr.get("heroGrow");
        this.clickAdd();
        this.showSkillUI();
        this.showHeroSkill();
        if (this.json) {
            this.showUserHeroInfo();
        }
        else {
            this.showHeroInfo();
        }
    };
    HeroDataView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this); //关闭界面
    };
    HeroDataView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
        }
    };
    //玩家英雄数据
    HeroDataView.prototype.showUserHeroInfo = function () {
        var heroItem = this.ui.getChild("n10").asCom;
        var heroItemBase = new ItemBase(heroItem, this, 2);
        var heroInfo = this.heroTab.getRowFromColName("id", "" + this.json["heroID"]);
        var race = Number(heroInfo.getValFromColName("race")); //种族
        var name = heroInfo.getValFromColName("name"); //名称
        heroItemBase.setItemData(this.heroID, race, this.json["starMax"]);
        heroItemBase.setNumber(this.json["level"]);
        this.ui.getChild("n51").text = name + ""; //名称
        this.ui.getChild("n26").text = Math.floor(this.json["atk"]) + ""; //攻击
        this.ui.getChild("n27").text = Math.floor(this.json["def"]) + ""; //防御
        this.ui.getChild("n28").text = Math.floor(this.json["hp"]) + ""; //血量
        this.ui.getChild("n29").text = Math.floor(this.json["speed"]) + ""; //速度
        this.ui.getChild("n72").asCom.getController("man").selectedIndex = (this.json["star"]); //星级最大值
        this.ui.getChild("n71").asCom.getChild("n4").asTextField.text = this.json["battlePower"]; //战力
    };
    //系统英雄数据
    HeroDataView.prototype.showHeroInfo = function () {
        var heroItem = this.ui.getChild("n10").asCom;
        var heroItemBase = new ItemBase(heroItem, this, 2);
        var heroInfo = this.heroTab.getRowFromColName("id", "" + this.heroID);
        var race = Number(heroInfo.getValFromColName("race")); //种族
        var star = Number(heroInfo.getValFromColName("star")); //星级
        var name = heroInfo.getValFromColName("name"); //名称
        var heroPromotionInfo = this.heroPromotionTab.getRowFromColName("star", "" + star);
        var maxlv = heroPromotionInfo.getValFromColName("maxlv"); //最高可升级
        var hpPro = heroPromotionInfo.getValFromColName("hpPro"); //生命属性系数（万分比）
        var atkPro = heroPromotionInfo.getValFromColName("atkPro"); //攻击属性系数
        var defPro = heroPromotionInfo.getValFromColName("defPro"); //防御属性系数
        var speedPro = heroPromotionInfo.getValFromColName("speedPro"); //速度属性系数
        var heroComposeInfo = this.heroGrowTab.getRowFromColName("heroID", "" + this.heroID);
        var hp = heroComposeInfo.getValFromColName("hp"); //生命
        var atk = heroComposeInfo.getValFromColName("atk"); //攻击
        var def = heroComposeInfo.getValFromColName("def"); //防御
        var speed = heroComposeInfo.getValFromColName("speed"); //速度
        var hpGrow = heroComposeInfo.getValFromColName("hpGrow"); //生命成长
        var atkGrow = heroComposeInfo.getValFromColName("atkGrow"); //攻击成长
        var defGrow = heroComposeInfo.getValFromColName("defGrow"); //防御成长
        var speedGrow = heroComposeInfo.getValFromColName("speedGrow"); //速度成长
        //初始+成长*最高等级*属性系数/10000
        var allHp = Number(hp) + hpGrow * maxlv * hpPro / 10000;
        var allHtk = Number(atk) + atkGrow * maxlv * atkPro / 10000;
        var allDef = Number(def) + defGrow * maxlv * defPro / 10000;
        var allSpeed = Number(speed) + speedGrow * maxlv * speedPro / 10000;
        heroItemBase.setItemData(this.heroID, race, star);
        heroItemBase.setNumber(maxlv);
        this.ui.getChild("n51").text = name + ""; //名称
        this.ui.getChild("n26").text = Math.floor(allHtk) + ""; //攻击
        this.ui.getChild("n27").text = Math.floor(allDef) + ""; //防御
        this.ui.getChild("n28").text = Math.floor(allHp) + ""; //血量
        this.ui.getChild("n29").text = Math.floor(allSpeed) + ""; //速度
        this.ui.getChild("n72").asCom.getController("man").selectedIndex = (star); //星级最大值
        this.ui.getChild("n71").asCom.getChild("n4").asTextField.text = Formula.getBattlePower(this.heroID) + ""; //战力
    };
    HeroDataView.prototype.showHeroSkill = function () {
        this.skillDataArr = [];
        var heroData = this.heroTab.getRowFromColName("id", "" + this.heroID);
        var activeSkill = heroData.getValFromColName("activeSkill"); //主动技能
        var activeSkillName = heroData.getValFromColName("activeSkillName"); //主动技能名称
        var activeSkillText = heroData.getValFromColName("activeSkillText"); //主动技能描述
        var activeSkillIcon = heroData.getValFromColName("activeSkillIcon"); //主动技能图标
        var passiveSkill1 = heroData.getValFromColName("passiveSkill1"); //被动技能1
        var passiveSkillName1 = heroData.getValFromColName("passiveSkillName1"); //被动技能1名称
        var passiveSkillText1 = heroData.getValFromColName("passiveSkillText1"); //被动技能1描述
        var passiveSkillIcon1 = heroData.getValFromColName("passiveSkillIcon1"); //被动技能1图标
        var passiveSkillOpen1 = heroData.getValFromColName("passiveSkillOpen1"); //被动技能1开启品阶
        var passiveSkill2 = heroData.getValFromColName("passiveSkill2"); //被动技能2
        var passiveSkillName2 = heroData.getValFromColName("passiveSkillName2"); //被动技能2名称
        var passiveSkillText2 = heroData.getValFromColName("passiveSkillText2"); //被动技能2描述
        var passiveSkillIcon2 = heroData.getValFromColName("passiveSkillIcon2"); //被动技能2图标
        var passiveSkillOpen2 = heroData.getValFromColName("passiveSkillOpen2"); //被动技能2开启品阶
        var passiveSkill3 = heroData.getValFromColName("passiveSkill3"); //被动技能3
        var passiveSkillName3 = heroData.getValFromColName("passiveSkillName3"); //被动技能3名称
        var passiveSkillText3 = heroData.getValFromColName("passiveSkillText3"); //被动技能3描述
        var passiveSkillIcon3 = heroData.getValFromColName("passiveSkillIcon3"); //被动技能3图标
        var passiveSkillOpen3 = heroData.getValFromColName("passiveSkillOpen3"); //被动技能3开启品阶
        var skill = [activeSkill, activeSkillName, activeSkillText, activeSkillIcon, 0];
        var skill1 = [passiveSkill1, passiveSkillName1, passiveSkillText1, passiveSkillIcon1, passiveSkillOpen1];
        var skill2 = [passiveSkill2, passiveSkillName2, passiveSkillText2, passiveSkillIcon2, passiveSkillOpen2];
        var skill3 = [passiveSkill3, passiveSkillName3, passiveSkillText3, passiveSkillIcon3, passiveSkillOpen3];
        this.skillDataArr = [skill, skill1, skill2, skill3];
        var iconArr = ["jineng2", "jineng3", "jineng4"];
        var passiveSkillIconArr = [passiveSkillIcon1, passiveSkillIcon2, passiveSkillIcon3];
        this.ui.getController("jineng").selectedIndex = (1);
        this.setLoaderUrl(this.ui.getChild("jineng1").asCom.getChild("n64").asLoader, "resource/icon/skillico/" + activeSkillIcon + ".png");
        this.ui.getChild("jineng1").asCom.data = 1;
        for (var i = 0; i < 3; i++) {
            this.ui.getChild(iconArr[i]).asCom.data = i + 2;
            var icon = passiveSkillIconArr[i];
            if (icon != 0) {
                this.ui.getController("jineng").selectedIndex = (i + 2);
                this.setLoaderUrl(this.ui.getChild(iconArr[i]).asCom.getChild("n64").asLoader, "resource/icon/skillico/" + icon + ".png");
            }
        }
    };
    //点击技能
    HeroDataView.prototype.showSkillUI = function () {
        var iconArr = ["jineng1", "jineng2", "jineng3", "jineng4"];
        for (var i = 0; i < iconArr.length; i++) {
            var skillItem = this.ui.getChild(iconArr[i]).asCom;
            this.onEgretEvent(skillItem, egret.TouchEvent.TOUCH_BEGIN, this.showSkillDataStart, this);
            this.onEgretEvent(skillItem, egret.TouchEvent.TOUCH_RELEASE_OUTSIDE, this.showSkillDataMove, this);
            this.onEgretEvent(skillItem, egret.TouchEvent.TOUCH_END, this.showSkillDataEnd, this);
        }
    };
    //显示技能按下
    HeroDataView.prototype.showSkillDataStart = function (evt) {
        this.ui.getController("skillC").selectedIndex = (1);
        var num = evt.target.data; //第几个技能
        var skillUI = this.ui.getChild("n83").asCom;
        this.setLoaderUrl(skillUI.getChild("n3").asCom.getChild("n64").asLoader, "resource/icon/skillico/" + this.skillDataArr[num - 1][3] + ".png");
        skillUI.getChild("skillName").asTextField.text = this.skillDataArr[num - 1][1];
        skillUI.getChild("skillData").asTextField.text = this.skillDataArr[num - 1][2];
    };
    //显示技能区域外的释放事件
    HeroDataView.prototype.showSkillDataMove = function () {
        this.ui.getController("skillC").selectedIndex = (0);
    };
    //显示技能结束
    HeroDataView.prototype.showSkillDataEnd = function () {
        this.ui.getController("skillC").selectedIndex = (0);
    };
    return HeroDataView;
}(ak.EasyUI));
__reflect(HeroDataView.prototype, "HeroDataView");
var LookupInfoViewSystem = (function (_super) {
    __extends(LookupInfoViewSystem, _super);
    function LookupInfoViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    LookupInfoViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("LookupInfoView");
    };
    LookupInfoViewSystem.inst = new LookupInfoViewSystem("LookupInfoView");
    return LookupInfoViewSystem;
}(ak.FairyGUI));
__reflect(LookupInfoViewSystem.prototype, "LookupInfoViewSystem");
/**
 * 查看信息
 */
var LookupInfoView = (function (_super) {
    __extends(LookupInfoView, _super);
    function LookupInfoView(id, msg, type) {
        var _this = _super.call(this, LookupInfoViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.id = 0; //玩家ID
        _this.msg = null; //玩家信息 msg[] = {head, level, userID, unionName, nickname ,battlePower, defCardArr[]}
        _this.type = 0; //信息类型：0：默认类型 1：会长管理成员 2：公会成员
        _this.id = id;
        _this.msg = msg;
        _this.type = type || 0;
        return _this;
    }
    /**回调 */
    LookupInfoView.prototype.onInit = function () {
        var ui = this.create("LookupInfoView", "LookupInfoView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.useritem = ui.getChild("useritem").asCom;
        this.userUnion = ui.getChild("userUnion").asTextField;
        this.userID = ui.getChild("userID").asTextField;
        this.username = ui.getChild("username").asTextField;
        this.power = ui.getChild("power").asTextField;
        this.addbtn = ui.getChild("addbtn").asButton;
        this.removebtn = ui.getChild("removebtn").asButton;
        this.defriendbtn = ui.getChild("defriendbtn").asButton;
        this.hero0 = ui.getChild("hero0").asCom;
        this.hero1 = ui.getChild("hero1").asCom;
        this.hero2 = ui.getChild("hero2").asCom;
        this.hero3 = ui.getChild("hero3").asCom;
        this.hero4 = ui.getChild("hero4").asCom;
        this.hero5 = ui.getChild("hero5").asCom;
        this.controllerC1 = ui.getController("c1");
        this.btnAppointCommander = ui.getChild("btnAppointCommander").asButton;
        this.btnDropMember = ui.getChild("btnDropMember").asButton;
        this.btnUpgradeOfficer = ui.getChild("btnUpgradeOfficer").asButton;
        this.btnKickGuild = ui.getChild("btnKickGuild").asButton;
        this.ClickAdd();
        this.updateView();
        this.updateGuildBtn();
    };
    LookupInfoView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.addbtn, this.onClick, this);
        this.addClickListener(this.removebtn, this.onClick, this);
        this.addClickListener(this.defriendbtn, this.onClick, this);
        this.addClickListener(this.btnAppointCommander, this.onClick, this);
        this.addClickListener(this.btnDropMember, this.onClick, this);
        this.addClickListener(this.btnUpgradeOfficer, this.onClick, this);
        this.addClickListener(this.btnKickGuild, this.onClick, this);
    };
    LookupInfoView.prototype.updateView = function () {
        this.controllerC1.selectedIndex = this.type;
        /**判断该玩家是否已经是自己好友 */
        if (MyData.friendMap[this.id]) {
            this.addbtn.visible = false;
            this.removebtn.visible = true;
        }
        else if (this.id == MyData.user.id) {
            this.addbtn.visible = false;
            this.removebtn.visible = false;
            this.controllerC1.selectedIndex = 2;
        }
        else {
            this.addbtn.visible = true;
            this.removebtn.visible = false;
        }
        if (this.msg == null)
            return;
        var items = new ItemBase(this.useritem, this, 2);
        items.setIcons2("hero" + this.msg.head);
        items.setNumber(this.msg.level, true);
        this.userID.text = "ID " + this.msg.userID;
        this.userUnion.text = "工会：" + this.msg.unionName;
        this.username.text = "" + this.msg.nickname;
        this.power.text = "" + this.msg.battlePower;
        for (var i = 0; i < this.msg.defCardArr.length; i++) {
            if (this.msg.defCardArr[i] && this.msg.defCardArr[i][0] != -1) {
                var heroID = this.msg.defCardArr[i][0];
                var items_1 = new ItemBase(this["hero" + i], this, 2);
                items_1.setItemData(heroID, HeroBagData.inst().GetRaceById(heroID), HeroBagData.inst().GetStarById(heroID));
                items_1.setNumber(this.msg.defCardArr[i][1]);
            }
        }
    };
    //刷新公会按钮
    LookupInfoView.prototype.updateGuildBtn = function () {
        if (MyData.user.unionID != 0 && MyData.myUnionInfo != null) {
            var memberMap = MyData.myUnionInfo.json.memberMap;
            if (memberMap[this.id].job == 1) {
                this.btnUpgradeOfficer.visible = false;
                this.btnAppointCommander.visible = false;
                this.btnDropMember.visible = false;
                this.btnKickGuild.visible = false;
            }
            else if (memberMap[MyData.user.id].job == 2) {
                this.btnUpgradeOfficer.visible = false;
                this.btnAppointCommander.visible = false;
                this.btnDropMember.visible = false;
                this.btnKickGuild.visible = true;
            }
            else {
                this.btnUpgradeOfficer.visible = memberMap[this.id].job == 0;
                this.btnAppointCommander.visible = true;
                this.btnDropMember.visible = memberMap[this.id].job != 0;
                this.btnKickGuild.visible = true;
            }
        }
    };
    LookupInfoView.prototype.onClick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.addbtn:
                net.reqFirend(this.id, function () {
                    TipsViewSystem.show("申请成功");
                }, this);
                break;
            case this.removebtn:
                ak.FairyGUI.open(["ChooseTipsView", 2, "确认删除好友吗？", function () {
                        _this.close();
                        ak.EventMgr.dispatch(GameEvent.defriend);
                        TipsViewSystem.show("删除成功");
                    }, this.id]);
                break;
            case this.defriendbtn:
                net.addBlackFriend(this.id, function () {
                    _this.close();
                    ak.EventMgr.dispatch(GameEvent.defriend);
                    TipsViewSystem.show("设置成功");
                }, this);
                break;
            case this.btnAppointCommander:
                net.changeUnionLeader(this.id, function () {
                    _this.close();
                    ak.EventMgr.dispatch(GameEvent.guildRecruitMember);
                }, this);
                break;
            case this.btnDropMember:
                net.upJob(this.id, 0, function () {
                    _this.close();
                    ak.EventMgr.dispatch(GameEvent.guildRecruitMember);
                }, this);
                break;
            case this.btnUpgradeOfficer:
                net.upJob(this.id, 1, function () {
                    _this.close();
                    ak.EventMgr.dispatch(GameEvent.guildRecruitMember);
                }, this);
                break;
            case this.btnKickGuild:
                net.kick(this.id, function () {
                    _this.close();
                    ak.EventMgr.dispatch(GameEvent.guildRecruitMember);
                }, this);
                break;
        }
    };
    /**查看对方信息界面 */
    LookupInfoView.GetPlayerInfo = function (id) {
        net.getRoleBaseInfo(id, function (msg) {
            ak.FairyGUI.open(["LookupInfoView", id, msg]);
        }, this);
    };
    return LookupInfoView;
}(ak.EasyUI));
__reflect(LookupInfoView.prototype, "LookupInfoView");
//主界面
var MailDetailedView = (function (_super) {
    __extends(MailDetailedView, _super);
    function MailDetailedView(mailID) {
        var _this = _super.call(this, MailViewSystem.inst, MyGame.inst.uiLayer2) || this;
        _this.mailArr = [];
        _this.mailID = mailID;
        return _this;
    }
    //初始化回调
    MailDetailedView.prototype.onInit = function () {
        this.ui = this.create("MailView", "MailDetailedView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.lingqu = this.ui.getChild("n5").asButton;
        this.getMail();
        this.clickAdd();
    };
    MailDetailedView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this); //关闭界面
        this.addClickListener(this.lingqu, this.onClick, this); //领取
    };
    MailDetailedView.prototype.onClick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.lingqu:
                net.getMailRes(this.mailID, function (msg) {
                    _this.mailArr[_this.mailIndex][5] = 1;
                    _this.showDetailed();
                    ak.EventMgr.dispatch(GameEvent.updateMailList);
                }, this);
                break;
        }
    };
    //显示邮件信息
    MailDetailedView.prototype.showDetailed = function () {
        var info;
        var count = this.mailArr.length;
        for (var i = 0; i < count; i++) {
            var data = this.mailArr[i];
            var mailID = data[0];
            if (this.mailID == mailID) {
                this.mailIndex = i;
                info = data;
            }
        }
        var title = info[1];
        var text = info[2];
        var time = info[3];
        var dropMap = info[4];
        var status = Number(info[5]);
        this.ui.getChild("n8").asTextField.text = title;
        this.ui.getChild("n9").asTextField.text = "    " + text;
        var arr = Object.keys(dropMap);
        var num = arr.length;
        if (num) {
            this.ui.getController("c1").selectedIndex = 0;
            if (status) {
                this.ui.getController("c2").selectedIndex = 2;
            }
            else {
                this.ui.getController("c2").selectedIndex = 1;
            }
            var list = this.ui.getChild("n11").asList;
            list.removeChildrenToPool();
            for (var type in dropMap) {
                for (var itemID in dropMap[type]) {
                    var item = list.addItemFromPool().asCom;
                    var itemBase = new ItemBase(item, this, Number(type));
                    itemBase.setItemData(Number(itemID));
                    itemBase.setNumber(dropMap[type][itemID], true);
                }
            }
        }
        else {
            this.ui.getController("c1").selectedIndex = 1;
        }
    };
    //获取邮件
    MailDetailedView.prototype.getMail = function () {
        var _this = this;
        net.getMail(function (msg) {
            _this.mailArr = msg;
            _this.showDetailed();
        }, this);
    };
    return MailDetailedView;
}(ak.EasyUI));
__reflect(MailDetailedView.prototype, "MailDetailedView");
//邮件
var MailViewSystem = (function (_super) {
    __extends(MailViewSystem, _super);
    function MailViewSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MailViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("MailView");
    };
    MailViewSystem.inst = new MailViewSystem("MailView");
    return MailViewSystem;
}(ak.FairyGUI));
__reflect(MailViewSystem.prototype, "MailViewSystem");
//主界面
var MailView = (function (_super) {
    __extends(MailView, _super);
    function MailView() {
        var _this = _super.call(this, MailViewSystem.inst, MyGame.inst.uiLayer2) || this;
        _this.mailArr = [];
        return _this;
    }
    //初始化回调
    MailView.prototype.onInit = function () {
        this.ui = this.create("MailView", "MailView");
        this.on(GameEvent.updateMailList, this.updateMailList, this);
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.list = this.ui.getChild("n4").asList;
        this.oneKeyLingqu = this.ui.getChild("n5").asButton;
        this.kuaiSuDel = this.ui.getChild("n6").asButton;
        this.getMail();
        this.clickAdd();
    };
    MailView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this); //关闭界面
        this.addClickListener(this.oneKeyLingqu, this.onClick, this); //一键领取
        this.addClickListener(this.kuaiSuDel, this.onClick, this); //快速删除
    };
    MailView.prototype.onClick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.oneKeyLingqu:
                var pass = 1;
                var count = this.mailArr.length;
                for (var i = 0; i < count; i++) {
                    var lingqu = this.mailArr[i][5];
                    if (pass != lingqu) {
                        pass = 0;
                    }
                }
                if (pass) {
                    TipsViewSystem.show("没有可领取的邮件");
                }
                else {
                    net.getMailRes(0, function (msg) {
                        _this.getMail();
                    }, this);
                }
                break;
            case this.kuaiSuDel:
                net.removeMail(0, function (msg) {
                    _this.getMail();
                }, this);
                break;
        }
    };
    //回调更新列表
    MailView.prototype.updateMailList = function () {
        this.mailArr[Number(this.mailIndex)][5] = 1;
        this.showList();
    };
    //更新列表
    MailView.prototype.showList = function () {
        this.list.removeChildrenToPool();
        var count = this.mailArr.length;
        if (count) {
            this.ui.getController("c1").selectedIndex = 0;
        }
        else {
            this.ui.getController("c1").selectedIndex = 1;
        }
        this.ui.getChild("n3").asTextField.text = "邮件数量：" + count + "/50";
        for (var i = 0; i < count; i++) {
            var itemMail = this.list.addItemFromPool().asCom;
            var mailID = this.mailArr[i][0];
            var title = this.mailArr[i][1];
            //let text = this.mailArr[i][2];
            var time = this.mailArr[i][3];
            var dropMap = this.mailArr[i][4];
            var status_5 = Number(this.mailArr[i][5]);
            itemMail.data = mailID;
            itemMail._id = "" + i;
            var arr = Object.keys(dropMap);
            var num = arr.length;
            if (num) {
                itemMail.getController("c1").selectedIndex = 1;
                if (status_5) {
                    itemMail.getController("c1").selectedIndex = 2;
                }
                else {
                    itemMail.getController("c1").selectedIndex = 1;
                }
            }
            else {
                itemMail.getController("c1").selectedIndex = 0;
            }
            itemMail.getChild("title").asTextField.text = title;
            itemMail.getChild("time").asTextField.text = Common.passTime(Math.floor(DateUtils.formatStrTimeToS(time) / 1000));
        }
        this.onFairyguiEvent(this.list, fairygui.ItemEvent.CLICK, this.openMailDetailed, this);
    };
    //打开邮件详情界面
    MailView.prototype.openMailDetailed = function (obj) {
        var item = obj.itemObject;
        //前往
        if (this.hitTestPointWithFairyGUIComponent(item, obj.stageX, obj.stageY)) {
            var mailID = item.data; //前往ID
            this.mailIndex = item._id; //arrIndex
            ak.FairyGUI.open(["MailDetailedView", mailID]);
        }
    };
    //获取邮件
    MailView.prototype.getMail = function () {
        var _this = this;
        net.getMail(function (msg) {
            _this.mailArr = msg;
            _this.showList();
        }, this);
    };
    return MailView;
}(ak.EasyUI));
__reflect(MailView.prototype, "MailView");
//市场
var MarketplaceViewSystem = (function (_super) {
    __extends(MarketplaceViewSystem, _super);
    function MarketplaceViewSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    MarketplaceViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("MarketplaceView");
    };
    MarketplaceViewSystem.inst = new MarketplaceViewSystem("MarketplaceView");
    return MarketplaceViewSystem;
}(ak.FairyGUI));
__reflect(MarketplaceViewSystem.prototype, "MarketplaceViewSystem");
//主界面
var MarketplaceView = (function (_super) {
    __extends(MarketplaceView, _super);
    function MarketplaceView() {
        var _this = _super.call(this, MarketplaceViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
        _this.timer = new ak.Timer();
        //显示列表
        _this.shopMap = {};
        return _this;
    }
    //初始化回调
    MarketplaceView.prototype.onInit = function () {
        this.ui = this.create("MarketplaceView", "MarketplaceView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.closeBtn = this.ui.getChild("closeBtn").asButton;
        this.shuaxinBtn = this.ui.getChild("n8").asButton;
        this.shuaxinBtn1 = this.ui.getChild("n11").asButton;
        this.timeText = this.ui.getChild("n9").asTextField;
        this.n88Group = this.ui.getChild("n88").asGroup;
        this.shopList = this.ui.getChild("n7").asList;
        this.quxiao = this.ui.getChild("n21").asButton;
        this.queding = this.ui.getChild("n20").asButton;
        this.marketTab = ak.JsonTableMgr.get("market");
        this.marketConfigTab = ak.JsonTableMgr.get("marketConfig");
        this.clickAdd();
        this.showTime();
        this.showList();
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.onEnterFrame, this);
    };
    MarketplaceView.prototype.onEnterFrame = function () {
        if (this.timer.getTime() >= 1000) {
            this.timer.reset();
            this.showTime();
        }
    };
    MarketplaceView.prototype.clickAdd = function () {
        this.addClickListener(this.closeBtn, this.onClick, this); //关闭界面
        this.addClickListener(this.bgclose, this.onClick, this); //关闭界面
        this.addClickListener(this.shuaxinBtn, this.onClick, this); //刷新
        this.addClickListener(this.shuaxinBtn1, this.onClick, this); //刷新
        this.addClickListener(this.quxiao, this.onClick, this); //取消
        this.addClickListener(this.queding, this.onClick, this); //确定
    };
    MarketplaceView.prototype.onClick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.closeBtn:
                this.close();
                break;
            case this.shuaxinBtn:
            case this.shuaxinBtn1:
                net.marketFlush(function () {
                    _this.showTime();
                    _this.showList();
                }, this);
                break;
            case this.quxiao:
            case this.bgclose:
                this.ui.getController("showBuy").selectedIndex = 0;
                break;
            case this.queding:
                net.marketBuy(this.selectIndex, function () {
                    _this.showList();
                    _this.ui.getController("showBuy").selectedIndex = 0;
                }, this);
                break;
        }
    };
    MarketplaceView.prototype.showList = function () {
        this.shopMap = {};
        var market = MyData.user.json.market;
        this.shopList.removeChildrenToPool();
        var itemArr = market.itemArr;
        var count = itemArr.length;
        for (var i = 0; i < count; i++) {
            var info = itemArr[i];
            var itemID = info.itemID;
            var buySign = info.buySign;
            var marketInfo = this.marketTab.getRowFromColName("id", itemID);
            var dropStr = marketInfo.getValFromColName("drop");
            var need = Number(marketInfo.getValFromColName("need"));
            var needNum = marketInfo.getValFromColName("needNum");
            var sales = Number(marketInfo.getValFromColName("sales"));
            var arr = ItemMgr.getDropGroupByID(dropStr);
            var typeS = arr[0][1];
            var itemIDS = arr[0][2];
            var countS = arr[0][3];
            var map = {};
            map["typeS"] = typeS;
            map["itemIDS"] = itemIDS;
            map["countS"] = countS;
            this.shopMap[i] = map;
            var shopFrame = this.shopList.addItemFromPool().asCom;
            shopFrame.data = i;
            var item = shopFrame.getChild("n2").asCom;
            var itemBase = new ItemBase(item, this, typeS);
            itemBase.clear2();
            itemBase = new ItemBase(item, this, typeS);
            itemBase.setItemData(Number(itemIDS));
            itemBase.setNumber(countS, true);
            if (sales != 10) {
                shopFrame.getController("zhe").selectedIndex = 1;
            }
            else {
                shopFrame.getController("zhe").selectedIndex = 0;
            }
            shopFrame.getController("wan").selectedIndex = buySign;
            if (buySign) {
                shopFrame.getChild("n6").asTextField.visible = false;
                shopFrame.getChild("n8").asTextField.visible = false;
                shopFrame.getChild("n9").asImage.visible = false;
            }
            else {
                shopFrame.getChild("n6").asTextField.visible = true;
                shopFrame.getChild("n8").asTextField.visible = true;
                shopFrame.getChild("n9").asImage.visible = true;
            }
            shopFrame.getChild("n4").asTextField.text = sales + "折";
            if (need) {
                this.setLoaderUrl(shopFrame.getChild("icon").asLoader, "rmbmoney_png");
            }
            else {
                this.setLoaderUrl(shopFrame.getChild("icon").asLoader, "jinbi_png");
            }
            Common.labelIsOverLenght(shopFrame.getChild("n6").asTextField, needNum);
            Common.labelIsOverLenght(shopFrame.getChild("n8").asTextField, needNum / 10 * sales);
        }
        this.onFairyguiEvent(this.shopList, fairygui.ItemEvent.CLICK, this.buyMarket, this);
    };
    //购买
    MarketplaceView.prototype.buyMarket = function (obj) {
        var item = obj.itemObject;
        this.selectIndex = item.data;
        var market = MyData.user.json.market;
        var marketItem = market.itemArr[this.selectIndex];
        var buySign = marketItem.buySign;
        if (buySign) {
            TipsViewSystem.show("该物品已被购买");
            return false;
        }
        var itemID = marketItem.itemID;
        var marketInfo = this.marketTab.getRowFromColName("id", itemID);
        var need = Number(marketInfo.getValFromColName("need"));
        var needNum = marketInfo.getValFromColName("needNum");
        var sales = Number(marketInfo.getValFromColName("sales"));
        if (need) {
            var diamond = MyData.user.diamond;
            var diamond2 = MyData.user.diamond2;
            needNum = needNum / 10 * sales;
            if (needNum > (diamond + diamond2)) {
                TipsViewSystem.show("钻石不足");
                return false;
            }
        }
        else {
            var money = MyData.user.money;
            needNum = needNum / 10 * sales;
            if (needNum > money) {
                TipsViewSystem.show("金币不足");
                return false;
            }
        }
        if (this.hitTestPointWithFairyGUIComponent(item.getChild("n2").asCom, obj.stageX, obj.stageY)) {
            var map = this.shopMap[this.selectIndex];
            var typeS = map["typeS"];
            var itemIDS = map["itemIDS"];
            var countS = map["countS"];
            if (typeS != 3) {
                var bagtype = ak.JsonTableMgr.get("item").getRowFromColName("id", "" + itemIDS).getValFromColName("bagtype");
                ak.FairyGUI.open(["WeaponTipsView", itemIDS, countS, 1]);
            }
            else {
                ak.FairyGUI.open(["ResourceTipsView", itemIDS, countS]);
            }
        }
        else {
            this.ui.getController("showBuy").selectedIndex = 1;
        }
    };
    //显示刷新次数
    MarketplaceView.prototype.showTime = function () {
        var arr = MarketMgr.refreshCount();
        var count = arr[0]; //次数
        var maxCount = arr[1]; //最大次数
        var time = arr[2]; //倒计时
        if (count) {
            this.ui.getController("c1").selectedIndex = 0;
            this.shuaxinBtn.title = "免费刷新 \n (" + count + "/" + maxCount + ")";
        }
        else {
            var info = this.marketConfigTab.getRow(0);
            var zs = info.getValFromColName("zs"); //钻石刷新消耗
            this.ui.getController("c1").selectedIndex = 1;
            this.shuaxinBtn1.getChild("number").asTextField.text = zs;
        }
        if (time) {
            this.n88Group.visible = true;
            this.timeText.text = DateUtils.getFormatBySecond(time, DateUtils.TIME_FORMAT_12);
        }
        else {
            this.n88Group.visible = false;
        }
    };
    return MarketplaceView;
}(ak.EasyUI));
__reflect(MarketplaceView.prototype, "MarketplaceView");
var MoneyData = (function () {
    function MoneyData() {
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    MoneyData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new MoneyData();
        }
        return Class._instance;
    };
    /**判断是否需要倒计时 */
    MoneyData.prototype.isshowTime = function () {
        var time0 = MyData.user.json.getGold.time;
        var getGoldConfigTab = ak.JsonTableMgr.get("getGoldConfig");
        var freeTime = Number(getGoldConfigTab.getRow(0).getValFromColName("cd"));
        var finaltime = ak.time() - time0 + MyData.timeBase;
        if (finaltime >= freeTime) {
            return false;
        }
        else {
            return true;
        }
    };
    MoneyData.prototype.GetTime = function () {
        var time0 = MyData.user.json.getGold.time;
        var getGoldConfigTab = ak.JsonTableMgr.get("getGoldConfig");
        var freeTime = Number(getGoldConfigTab.getRow(0).getValFromColName("cd"));
        var finaltime = ak.time() - time0 + MyData.timeBase;
        if (finaltime >= freeTime) {
            return 0;
        }
        else {
            return freeTime - finaltime;
        }
    };
    /**判断是否已经点金过 */
    MoneyData.prototype.isGolded = function (id) {
        if (!MyData.user.json.getGold.idMap[id]) {
            return false;
        }
        else {
            var getGoldTab = ak.JsonTableMgr.get("getGold");
            var getGoldInfo = getGoldTab.getRowFromColName("id", String(id));
            var time = getGoldInfo.getValFromColName("time");
            if (MyData.user.json.getGold.idMap[id] < time) {
                return false;
            }
            else {
                return true;
            }
        }
    };
    /**获得表里面3个配置 */
    MoneyData.prototype.GetInfo = function (id) {
        var getGoldTab = ak.JsonTableMgr.get("getGold");
        var getGoldInfo = getGoldTab.getRowFromColName("id", String(id));
        var golds = getGoldInfo.getValFromColName("gold");
        var mod = getGoldInfo.getValFromColName("mod");
        var zs = getGoldInfo.getValFromColName("zs");
        var gold = Number(golds) + Number(mod) * (MyData.user.level - 1);
        var info = {};
        info = { gold: gold, zs: zs };
        return info;
    };
    return MoneyData;
}());
__reflect(MoneyData.prototype, "MoneyData");
var MoneyViewSystem = (function (_super) {
    __extends(MoneyViewSystem, _super);
    function MoneyViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    MoneyViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("MoneyView");
    };
    MoneyViewSystem.inst = new MoneyViewSystem("MoneyView");
    return MoneyViewSystem;
}(ak.FairyGUI));
__reflect(MoneyViewSystem.prototype, "MoneyViewSystem");
/**
 *
 */
var MoneyView = (function (_super) {
    __extends(MoneyView, _super);
    function MoneyView() {
        return _super.call(this, MoneyViewSystem.inst, MyGame.inst.tipLayer) || this;
    }
    /**回调 */
    MoneyView.prototype.onInit = function () {
        var ui = this.create("MoneyView", "MoneyView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.moneytxt1 = ui.getChild("moneytxt1").asTextField;
        this.moneytxt2 = ui.getChild("moneytxt2").asTextField;
        this.moneytxt3 = ui.getChild("moneytxt3").asTextField;
        this.endimg1 = ui.getChild("endimg1").asImage;
        this.endimg2 = ui.getChild("endimg2").asImage;
        this.endimg3 = ui.getChild("endimg3").asImage;
        this.buybtn1 = ui.getChild("buybtn1").asButton;
        this.buybtn2 = ui.getChild("buybtn2").asButton;
        this.buybtn3 = ui.getChild("buybtn3").asButton;
        this.timetxt = ui.getChild("timetxt").asTextField;
        this.timetxt2 = ui.getChild("timetxt2").asTextField;
        this.timeimg1 = ui.getChild("timeimg1").asImage;
        this.timeimg2 = ui.getChild("timeimg2").asImage;
        this.ClickAdd();
        this.staticView();
        this.updateView();
    };
    MoneyView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.buybtn1, this.onClick, this);
        this.addClickListener(this.buybtn2, this.onClick, this);
        this.addClickListener(this.buybtn3, this.onClick, this);
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.timeDown, this);
    };
    MoneyView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.buybtn1:
                this.rpcGetGold(1);
                break;
            case this.buybtn2:
                this.rpcGetGold(2);
                break;
            case this.buybtn3:
                this.rpcGetGold(3);
                break;
        }
    };
    MoneyView.prototype.staticView = function () {
        this.moneytxt1.text = "" + MoneyData.inst().GetInfo(1).gold + "金币";
        this.moneytxt2.text = "" + MoneyData.inst().GetInfo(2).gold + "金币";
        this.moneytxt3.text = "" + MoneyData.inst().GetInfo(3).gold + "金币";
        this.buybtn2.getChild("number").asTextField.text = "" + MoneyData.inst().GetInfo(3).zs;
        this.buybtn3.getChild("number").asTextField.text = "" + MoneyData.inst().GetInfo(3).zs;
    };
    MoneyView.prototype.rpcGetGold = function (id) {
        var _this = this;
        var vipstr = "";
        if (MyData.user.vip > 0) {
            vipstr = "(贵族" + MyData.user.vip + "加成)";
        }
        net.getGold(id, function (dropMap) {
            TipsViewSystem.show("" + dropMap[3][2] + "金币" + vipstr);
            _this.updateView();
        }, this);
    };
    MoneyView.prototype.updateView = function () {
        if (!MoneyData.inst().isshowTime()) {
            this.endimg1.visible = false;
            this.endimg2.visible = false;
            this.endimg3.visible = false;
            this.buybtn1.visible = true;
            this.buybtn2.visible = true;
            this.buybtn3.visible = true;
        }
        else {
            if (MoneyData.inst().isGolded(1)) {
                this.buybtn1.visible = false;
                this.endimg1.visible = true;
            }
            else {
                this.buybtn1.visible = true;
                this.endimg1.visible = false;
            }
            if (MoneyData.inst().isGolded(2)) {
                this.buybtn2.visible = false;
                this.endimg2.visible = true;
            }
            else {
                this.buybtn2.visible = true;
                this.endimg2.visible = false;
            }
            if (MoneyData.inst().isGolded(3)) {
                this.buybtn3.visible = false;
                this.endimg3.visible = true;
            }
            else {
                this.buybtn3.visible = true;
                this.endimg3.visible = false;
            }
        }
    };
    /**倒计时 */
    MoneyView.prototype.timeDown = function () {
        var time = MoneyData.inst().GetTime();
        var Time1 = 0;
        if (time > 0) {
            Time1 = time - 1;
            this.timetxt.visible = true;
            this.timetxt2.visible = true;
            this.timeimg1.visible = true;
            this.timeimg2.visible = true;
            this.timetxt.text = "" + DateUtils.getFormatBySecond(Time1, DateUtils.TIME_FORMAT_12);
        }
        else {
            this.timetxt.visible = false;
            this.timetxt2.visible = false;
            this.timeimg1.visible = false;
            this.timeimg2.visible = false;
        }
    };
    //销毁回调
    MoneyView.prototype.onDestroy = function () {
        //清理
        this.removeEventListener(egret.Event.ENTER_FRAME, this.timeDown, this);
    };
    return MoneyView;
}(ak.EasyUI));
__reflect(MoneyView.prototype, "MoneyView");
//新手奖励系统
var NewHandRewardSystem = (function (_super) {
    __extends(NewHandRewardSystem, _super);
    function NewHandRewardSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    NewHandRewardSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("NewHandReward");
    };
    NewHandRewardSystem.inst = new NewHandRewardSystem("NewHandReward");
    return NewHandRewardSystem;
}(ak.FairyGUI));
__reflect(NewHandRewardSystem.prototype, "NewHandRewardSystem");
var NewHandRewardView = (function (_super) {
    __extends(NewHandRewardView, _super);
    function NewHandRewardView() {
        var _this = _super.call(this, NewHandRewardSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.itembaselist = []; //itembase奖励数组
        return _this;
    }
    NewHandRewardView.prototype.onInit = function () {
        var ui = this.create("NewHandReward", "NewHandRewardView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.timer = this.ui.getChild("n5").asTextField;
        this.timer2 = this.ui.getChild("n13").asTextField;
        this.awardlist = this.ui.getChild("n6").asList;
        this.n3 = this.ui.getChild("n3").asCom;
        this.onlinePrize = ak.JsonTableMgr.get("onlinePrize");
        this.clickAdd();
        this.showlist();
    };
    NewHandRewardView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.Onclick, this);
        this.addClickListener(this.n3, this.Onclick, this);
        this.onFairyguiEvent(this.awardlist, fairygui.ItemEvent.CLICK, this.getaward, this);
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.timedown, this);
    };
    NewHandRewardView.prototype.Onclick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.n3:
                this.close();
                break;
        }
    };
    //列表内容
    NewHandRewardView.prototype.showlist = function () {
        this.awardlist.removeChildrenToPool();
        var count = this.onlinePrize.size();
        for (var i = 0; i < count; i++) {
            var it0 = this.awardlist.addItemFromPool().asCom;
            var onlinePrizeInfo = this.onlinePrize.getRow(i);
            var onlinePrizeID = onlinePrizeInfo.getValFromColName("id"); //物品ID
            var onlinePrizeDrop = onlinePrizeInfo.getValFromColName("drop"); //物品掉落组
            var arr = ItemMgr.getDropGroupByID(onlinePrizeDrop);
            var typeS = arr[0][1];
            var itemIDS = arr[0][2];
            var countS = arr[0][3];
            var item = it0.getChild("n0").asCom; //获取框框
            var item_list = []; //领取所需要的数据
            item_list["id"] = onlinePrizeID;
            item_list["index"] = i;
            item.data = item_list;
            var itemBase = new ItemBase(item, this, typeS);
            itemBase.setItemData(Number(itemIDS));
            itemBase.setNumber(countS, true);
            this.itembaselist[i] = itemBase;
            if (MyData.user.json.onlineReward.idMap[i + 1]) {
                it0.getController("ispick").selectedIndex = 1;
                itemBase.isshowLight(false);
                item.enabled = false;
            }
        }
    };
    NewHandRewardView.prototype.getaward = function (obj) {
        var _this = this;
        var item = obj.itemObject;
        var itemCom = item.getChild("n0").asCom;
        if (MyData.user.json.onlineReward.idMap[1] == null || MyData.user.json.onlineReward.idMap[itemCom.data.index] != null) {
            net.onlineReward(itemCom.data.id, function () {
                _this.showlist();
            }, this);
        }
    };
    NewHandRewardView.prototype.timedown = function () {
        var count = this.onlinePrize.size();
        var cd = 0;
        for (var i = 0; i < count; i++) {
            var onlinePrizeInfo = this.onlinePrize.getRow(i);
            var onlineTime = onlinePrizeInfo.getValFromColName("cd"); //等待时间
            cd = cd + onlineTime;
            if ((Common.getOnlieSceond() + MyData.user.onlineSeconds) <= cd && !MyData.user.json.onlineReward.idMap[i + 1]) {
                this.timer.visible = true;
                this.timer2.visible = true;
                var text = DateUtils.getFormatBySecond(cd - (Common.getOnlieSceond() + MyData.user.onlineSeconds), DateUtils.TIME_FORMAT_12);
                this.timer2.text = text;
                break;
            }
            else if ((Common.getOnlieSceond() + MyData.user.onlineSeconds) > cd && MyData.user.json.onlineReward.idMap[i + 1] == null) {
                this.timer.visible = false;
                this.timer2.visible = false;
                this.itembaselist[i].isshowLight(true);
                this.showlist();
                break;
            }
        }
    };
    return NewHandRewardView;
}(ak.EasyUI));
__reflect(NewHandRewardView.prototype, "NewHandRewardView");
var RaceHelpViewSystem = (function (_super) {
    __extends(RaceHelpViewSystem, _super);
    function RaceHelpViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    RaceHelpViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("RaceHelpView");
    };
    RaceHelpViewSystem.inst = new RaceHelpViewSystem("RaceHelpView");
    return RaceHelpViewSystem;
}(ak.FairyGUI));
__reflect(RaceHelpViewSystem.prototype, "RaceHelpViewSystem");
/**
 *
 */
var RaceHelpView = (function (_super) {
    __extends(RaceHelpView, _super);
    function RaceHelpView() {
        var _this = _super.call(this, RaceHelpViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.additionTxT = ["免控率", "暴击", "攻击", "格挡率", "破甲率", "生命"];
        _this.imgGroup = ["ico_zz2", "ico_zz3", "ico_zz4", "ico_zz5", "ico_zz6", "ico_zz7"];
        return _this;
    }
    /**回调 */
    RaceHelpView.prototype.onInit = function () {
        var ui = this.create("RaceHelpView", "RaceHelpView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.list = ui.getChild("list").asList;
        this.n10 = ui.getChild("n10").asCom;
        this.ClickAdd();
        this.updatelistInfo();
    };
    RaceHelpView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.close, this);
        this.addClickListener(this.n10, this.close, this);
    };
    RaceHelpView.prototype.updatelistInfo = function () {
        var lineupTab = ak.JsonTableMgr.get("lineup");
        this.list.removeChildrenToPool();
        for (var i = 0; i < lineupTab.size(); i++) {
            var lineupitem = this.list.addItemFromPool().asCom;
            var bgimg = lineupitem.getChild("bgimg").asLoader;
            var img0 = lineupitem.getChild("img0").asLoader;
            var img1 = lineupitem.getChild("img1").asLoader;
            var img2 = lineupitem.getChild("img2").asLoader;
            var img3 = lineupitem.getChild("img3").asLoader;
            var img4 = lineupitem.getChild("img4").asLoader;
            var img5 = lineupitem.getChild("img5").asLoader;
            var addition0 = lineupitem.getChild("addition0").asTextField;
            var addition1 = lineupitem.getChild("addition1").asTextField;
            this.setLoaderUrl(bgimg, "ui://RaceHelpView/" + this.GetInfoById(i + 1).icon);
            this.setLoaderUrl(img0, "ui://common/" + this.imgGroup[this.GetInfoById(i + 1).imgGroups[0]]);
            this.setLoaderUrl(img1, "ui://common/" + this.imgGroup[this.GetInfoById(i + 1).imgGroups[1]]);
            this.setLoaderUrl(img2, "ui://common/" + this.imgGroup[this.GetInfoById(i + 1).imgGroups[2]]);
            this.setLoaderUrl(img3, "ui://common/" + this.imgGroup[this.GetInfoById(i + 1).imgGroups[3]]);
            this.setLoaderUrl(img4, "ui://common/" + this.imgGroup[this.GetInfoById(i + 1).imgGroups[4]]);
            this.setLoaderUrl(img5, "ui://common/" + this.imgGroup[this.GetInfoById(i + 1).imgGroups[5]]);
            addition0.text = this.GetInfoById(i + 1).additions[0];
            addition1.text = this.GetInfoById(i + 1).additions[1];
        }
    };
    RaceHelpView.prototype.GetInfoById = function (id) {
        var lineupTab = ak.JsonTableMgr.get("lineup");
        var lineupInfo = lineupTab.getRowFromColName("id", "" + id);
        var icon = lineupInfo.getValFromColName("icon");
        var imgGroups = [];
        var additions = [];
        var race1 = Number(lineupInfo.getValFromColName("race1"));
        var race2 = Number(lineupInfo.getValFromColName("race2"));
        var race3 = Number(lineupInfo.getValFromColName("race3"));
        var race4 = Number(lineupInfo.getValFromColName("race4"));
        var race5 = Number(lineupInfo.getValFromColName("race5"));
        var race6 = Number(lineupInfo.getValFromColName("race6"));
        var antiControl = Number(lineupInfo.getValFromColName("antiControl"));
        var critRate = Number(lineupInfo.getValFromColName("critRate"));
        var atkRate = Number(lineupInfo.getValFromColName("atkRate"));
        var blockRate = Number(lineupInfo.getValFromColName("blockRate"));
        var antiDefend = Number(lineupInfo.getValFromColName("antiDefend"));
        var hpRate = Number(lineupInfo.getValFromColName("hpRate"));
        var raceGroup = [race1, race2, race3, race4, race5, race6];
        var additonGroup = [antiControl, critRate, atkRate, blockRate, antiDefend, hpRate];
        for (var i = 0; i < raceGroup.length; i++) {
            for (var j = 0; j < raceGroup[i]; j++) {
                imgGroups.push(i);
            }
        }
        for (var i = 0; i < additonGroup.length; i++) {
            if (additonGroup[i] != 0) {
                additions.push(this.additionTxT[i] + "+" + additonGroup[i] / 100 + "%");
            }
        }
        var info = { icon: icon, imgGroups: imgGroups, additions: additions };
        return info;
    };
    return RaceHelpView;
}(ak.EasyUI));
__reflect(RaceHelpView.prototype, "RaceHelpView");
var RankAllViewSystem = (function (_super) {
    __extends(RankAllViewSystem, _super);
    function RankAllViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    RankAllViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("RankAllView");
    };
    RankAllViewSystem.inst = new RankAllViewSystem("RankAllView");
    return RankAllViewSystem;
}(ak.FairyGUI));
__reflect(RankAllViewSystem.prototype, "RankAllViewSystem");
/**
 * 排行榜
 */
var RankAllView = (function (_super) {
    __extends(RankAllView, _super);
    function RankAllView() {
        return _super.call(this, RankAllViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
    }
    /**回调 */
    RankAllView.prototype.onInit = function () {
        this.ui = this.create("RankAllView", "RankAllView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.list = this.ui.getChild("list").asList;
        this.mobai = this.ui.getChild("n16").asCom.getChild("n17").asButton;
        this.onEgretEvent(this.ui.getController("c1"), fairygui.StateChangeEvent.CHANGED, this.onChanged, this);
        this.clickAdd();
        this.onChanged();
        this.showTabRed();
    };
    RankAllView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.mobai, this.onClick, this); //膜拜
    };
    RankAllView.prototype.onClick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.mobai:
                var selectedIndex = this.ui.getController("c1").selectedIndex;
                selectedIndex += 1;
                net.worship(selectedIndex, function (msg) {
                    _this.mobai.enabled = false;
                    _this.mobai.getController("red").selectedIndex = 0;
                    _this.showTabRed();
                }, this);
                break;
        }
    };
    //选项卡红点
    RankAllView.prototype.showTabRed = function () {
        var arrName = ["n27", "n29", "n30", "n28"];
        var redArr = RedDotMgr.getWorshipTabRedDot();
        var count = redArr.length;
        for (var i = 0; i < count; i++) {
            this.ui.getChild(arrName[i]).asButton.getController("red").selectedIndex = redArr[i] ? 0 : 1;
        }
    };
    RankAllView.prototype.onChanged = function () {
        var _this = this;
        var selectedIndex = this.ui.getController("c1").selectedIndex;
        if (selectedIndex == 0) {
            net.hookRank(function (msg) {
                _this.listData = msg[1];
                _this.updateList();
            }, this);
        }
        else if (selectedIndex == 1) {
            net.battlePowerRank(function (msg) {
                _this.listData = msg[1];
                _this.updateList();
            }, this);
        }
        else if (selectedIndex == 2) {
            net.stageRank(function (msg) {
                _this.listData = msg[1];
                _this.updateList();
            }, this);
        }
        else if (selectedIndex == 3) {
            net.unionRank(function (msg) {
                _this.listData = msg[1];
                _this.updateList();
            }, this);
        }
    };
    //更新列表
    RankAllView.prototype.updateList = function () {
        this.list.removeChildrenToPool(); //清空列表
        var arr = this.listData.arr;
        var arrCount = arr.length;
        var sIndex = this.ui.getController("c1").selectedIndex;
        var worship = MyData.user.json.worship;
        var rankS = sIndex + 1;
        var worshipRankNum = 0;
        if (rankS == 1) {
            worshipRankNum = worship.barrierRank;
        }
        else if (rankS == 2) {
            worshipRankNum = worship.battlePowerRank;
        }
        else if (rankS == 3) {
            worshipRankNum = worship.stageRank;
        }
        else if (rankS == 4) {
            worshipRankNum = worship.unionRank;
        }
        if (worshipRankNum) {
            this.mobai.enabled = false;
            this.mobai.getController("red").selectedIndex = 0;
        }
        else {
            this.mobai.enabled = true;
            this.mobai.getController("red").selectedIndex = 1;
        }
        if (!arrCount) {
            var rankItem1_1 = this.ui.getChild("n16").asCom;
            if (rankS == 4) {
                rankItem1_1.getController("c2").selectedIndex = 1;
            }
            else {
                rankItem1_1.getController("c2").selectedIndex = 0;
            }
            var useritem = rankItem1_1.getChild("useritem").asCom;
            var headItem = new ItemBase(useritem, this, 2);
            headItem.clear2();
            rankItem1_1.getChild("username").asTextField.text = ""; //昵称
            rankItem1_1.getChild("gonghui").asTextField.text = ""; //工会
            rankItem1_1.getChild("num").asTextField.text = ""; //数值
            rankItem1_1.getController("c1").selectedIndex = sIndex;
            this.ui.getChild("round").asTextField.text = 0 + ""; //我的排名值
            this.ui.getController("myRank").selectedIndex = 0;
            this.ui.getController("kong").selectedIndex = 0;
            return false;
        }
        var userInfoMap;
        var rankItem1 = this.ui.getChild("n16").asCom;
        if (rankS == 4) {
            userInfoMap = this.listData.unionInfoMap;
            rankItem1.getController("c2").selectedIndex = 1;
            rankItem1.getChild("username").asTextField.text = userInfoMap[arr[0][0]][0]; //昵称
            rankItem1.getChild("gonghui").asTextField.text = userInfoMap[arr[0][0]][2]; //工会
            rankItem1.getChild("num").asTextField.text = userInfoMap[arr[0][0]][1]; //数值
            var flag = userInfoMap[arr[0][0]][5]; //旗子
            var flagUrl = flag < 10 ? "img_qz_0" + flag + "_png" : "img_qz_" + flag + "_png";
            this.setLoaderUrl(rankItem1.getChild("n22").asLoader, flagUrl);
        }
        else {
            userInfoMap = this.listData.userInfoMap;
            rankItem1.getController("c2").selectedIndex = 0;
            var useritem = rankItem1.getChild("useritem").asCom;
            var headItem = new ItemBase(useritem, this, 2);
            headItem.setIcons2("hero" + userInfoMap[arr[0][0]][0]); //头像
            headItem.setNumber(userInfoMap[arr[0][0]][1], true); //等级
            rankItem1.getChild("username").asTextField.text = userInfoMap[arr[0][0]][2]; //昵称
            rankItem1.getChild("gonghui").asTextField.text = userInfoMap[arr[0][0]][3]; //工会
            rankItem1.getChild("num").asTextField.text = arr[0][1]; //数值
        }
        rankItem1.getController("c1").selectedIndex = sIndex;
        this.ui.getController("kong").selectedIndex = 1;
        var count = arr.length;
        for (var i = 1; i < count; i++) {
            var userID = arr[i][0];
            var num = arr[i][1];
            var rankItem = this.list.addItemFromPool().asCom;
            if (rankS == 4) {
                rankItem.getController("item").selectedIndex = 1;
                rankItem.getChild("username").asTextField.text = userInfoMap[userID][0]; //昵称
                rankItem.getChild("gonghui").asTextField.text = userInfoMap[userID][2]; //工会
                rankItem.getChild("roundnum").asTextField.text = userInfoMap[userID][1]; //数值
                var flag = userInfoMap[userID][5]; //旗子
                var flagUrl = flag < 10 ? "img_qz_0" + flag + "_png" : "img_qz_" + flag + "_png";
                this.setLoaderUrl(rankItem.getChild("n17").asLoader, flagUrl);
            }
            else {
                rankItem.getController("item").selectedIndex = 0;
                var useritem = rankItem.getChild("useritem").asCom;
                var headItem = new ItemBase(useritem, this, 2);
                headItem.setIcons2("hero" + userInfoMap[userID][0]); //头像
                headItem.setNumber(userInfoMap[userID][1], true); //等级
                rankItem.getChild("username").asTextField.text = userInfoMap[userID][2]; //昵称
                rankItem.getChild("gonghui").asTextField.text = userInfoMap[userID][3]; //工会
                rankItem.getChild("roundnum").asTextField.text = num; //排名值
            }
            rankItem.getChild("ranknum").asTextField.text = i + 1 + ""; //排名
            if (i == 1 || i == 2) {
                rankItem.getController("c1").selectedIndex = i + 1;
            }
            else {
                rankItem.getController("c1").selectedIndex = 0;
            }
            rankItem.getController("c3").selectedIndex = sIndex;
        }
        var myNum = this.listData.myNum;
        var myScore = this.listData.myScore;
        if (rankS == 4) {
            var userID = MyData.user.id;
            if (userInfoMap[userID]) {
                var i = 0;
                while (i <= count) {
                    var userIDS = arr[i][0];
                    if (userIDS == userID) {
                        myNum = i + 1;
                        break;
                    }
                    i++;
                }
                myScore = userInfoMap[userID][1];
            }
        }
        this.ui.getChild("round").asTextField.text = myScore + ""; //我的排名值
        this.ui.getChild("myrank").asTextField.text = myNum + "";
        if (myNum > 0) {
            this.ui.getController("myRank").selectedIndex = 1;
        }
        else {
            this.ui.getController("myRank").selectedIndex = 0;
        }
    };
    return RankAllView;
}(ak.EasyUI));
__reflect(RankAllView.prototype, "RankAllView");
var RankViewSystem = (function (_super) {
    __extends(RankViewSystem, _super);
    function RankViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    RankViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("RankView");
    };
    RankViewSystem.inst = new RankViewSystem("RankView");
    return RankViewSystem;
}(ak.FairyGUI));
__reflect(RankViewSystem.prototype, "RankViewSystem");
/**
 * 排行榜
 * 单个
 */
var RankView = (function (_super) {
    __extends(RankView, _super);
    function RankView(type, rankstr) {
        var _this = _super.call(this, RankViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.type = 0;
        _this.rankstr = "";
        _this.type = type;
        _this.rankstr = rankstr;
        return _this;
    }
    /**回调 */
    RankView.prototype.onInit = function () {
        var ui = this.create("RankView", "RankView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.uninlist = ui.getChild("uninlist").asImage;
        this.myranktxt = ui.getChild("myranktxt").asTextField;
        this.myrank = ui.getChild("myrank").asTextField;
        this.roundtxt = ui.getChild("roundtxt").asTextField;
        this.round = ui.getChild("round").asTextField;
        this.list = ui.getChild("list").asList;
        this.ClickAdd();
        this.getListInfo();
        this.roundtxt.text = this.rankstr;
    };
    RankView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
    };
    RankView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
        }
    };
    RankView.prototype.getListInfo = function () {
        var _this = this;
        //获取列表信息
        if (this.type == 1) {
            net.hookRank(function (msg) {
                _this.listInfo = msg[1];
                ak.log(_this.listInfo);
                _this.updateList();
                _this.updateMyinfo();
            }, this);
        }
        if (this.type == 2) {
            net.getFriendRank(function (msg) {
                _this.listInfo = msg[1];
                ak.log(_this.listInfo);
                _this.updateList();
                _this.updateMyinfo();
            }, this);
        }
        if (this.type == 3) {
            net.towerRank(function (msg) {
                _this.listInfo = msg[1];
                ak.log(_this.listInfo);
                _this.updateList();
                _this.updateMyinfo();
            }, this);
        }
    };
    RankView.prototype.updateList = function () {
        this.list.removeChildrenToPool();
        for (var i = 0; i < this.listInfo.arr.length; i++) {
            var item = this.list.addItemFromPool().asCom;
            var ranknum = item.getChild("ranknum").asTextField;
            var rankloader = item.getChild("rankloader").asLoader;
            var useritem = item.getChild("useritem").asCom;
            var username = item.getChild("username").asTextField;
            var roundnum = item.getChild("roundnum").asTextField;
            var rankstr = item.getChild("rankstr").asTextField;
            if (i == 0) {
                ranknum.visible = false;
                rankloader.visible = true;
                this.setLoaderUrl(rankloader, "ui://common/img_paihangbang_1");
            }
            else if (i == 1) {
                ranknum.visible = false;
                rankloader.visible = true;
                this.setLoaderUrl(rankloader, "ui://common/img_paihangbang_2");
            }
            else if (i == 2) {
                ranknum.visible = false;
                rankloader.visible = true;
                this.setLoaderUrl(rankloader, "ui://common/img_paihangbang_3");
            }
            else {
                ranknum.visible = true;
                rankloader.visible = false;
                ranknum.text = "" + (i + 1);
            }
            username.text = "" + this.listInfo.userInfoMap[this.listInfo.arr[i][0]][2];
            roundnum.text = "" + this.listInfo.arr[i][1];
            var item0 = new ItemBase(useritem, this, 2);
            var imgID = this.listInfo.userInfoMap[this.listInfo.arr[i][0]][0];
            item0.setIcons2("hero" + imgID);
            item0.setNumber(this.listInfo.userInfoMap[this.listInfo.arr[i][0]][1], true);
            rankstr.text = this.rankstr;
        }
    };
    RankView.prototype.updateMyinfo = function () {
        if (this.listInfo.myNum != 0) {
            this.uninlist.visible = false;
            this.myrank.visible = true;
            this.round.visible = true;
            this.myrank.text = "" + this.listInfo.myNum;
            if (this.type == 1) {
                this.round.text = "" + MyData.user.barrierID;
            }
            else if (this.type == 3) {
                this.round.text = "" + MyData.user.towerID;
            }
        }
        else {
            this.uninlist.visible = true;
            this.myrank.visible = false;
            this.round.visible = false;
        }
    };
    return RankView;
}(ak.EasyUI));
__reflect(RankView.prototype, "RankView");
/**
 * 充值系统
 */
var RechargeViewSystem = (function (_super) {
    __extends(RechargeViewSystem, _super);
    function RechargeViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    RechargeViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("RechargeView");
    };
    RechargeViewSystem.inst = new RechargeViewSystem("RechargeView");
    return RechargeViewSystem;
}(ak.FairyGUI));
__reflect(RechargeViewSystem.prototype, "RechargeViewSystem");
/**
 * 充值界面
 */
var RechargeView = (function (_super) {
    __extends(RechargeView, _super);
    function RechargeView(openViewIndex) {
        var _this = _super.call(this, RechargeViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.iconVipUrl = "ui://RechargeView/ico_sale_vip";
        //(做记录配置只刷一次)
        _this.isLoaditemlist01 = false; //记录是否读取过钻石充值界面配置
        _this.isLoaditemlist012 = false; //记录是否读取过vip特权详情
        _this.openViewIndex = openViewIndex || 0;
        return _this;
    }
    /**回调 */
    RechargeView.prototype.onInit = function () {
        this.ui = this.create("RechargeView", "RechargeView");
        this.c1_control = this.ui.getController("c1");
        this.zhuanshibtn = this.ui.getChild("btn01").asButton;
        this.welfaregiftbtn = this.ui.getChild("btn02").asButton;
        this.privilegegiftbtn = this.ui.getChild("btn03").asButton;
        this.dailystorebtn = this.ui.getChild("btn04").asButton;
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.rechargeTab = ak.JsonTableMgr.get("recharge");
        this.vipTab = ak.JsonTableMgr.get("vip");
        this.vipRightTab = ak.JsonTableMgr.get("vipRight");
        this.rechargeRightTab = ak.JsonTableMgr.get("rechargeRight");
        this.rechargeShopDailyTab = ak.JsonTableMgr.get("rechargeShopDaily");
        this.rechargeGiftTab = ak.JsonTableMgr.get("rechargeGift");
        this.redPoint1 = this.ui.getChild("redPoint1").asImage;
        this.redPoint2 = this.ui.getChild("redPoint2").asImage;
        this.redPoint1.visible = RedDotMgr.rechargeWelfareGiftRedDot();
        this.redPoint2.visible = RedDotMgr.rechargeDailyShopRedDot();
        this.ClickAdd();
        this.loadRechargeview01();
        this.loadRechargeview02();
        this.loadRechargeview03();
        this.loadRechargeview04();
        this.openFristView();
    };
    RechargeView.prototype.openFristView = function () {
        this.c1_control.selectedIndex = this.openViewIndex;
        if (this.openViewIndex == 0) {
            this.updateList01();
        }
        else if (this.openViewIndex == 1) {
            this.updateList02();
        }
        else if (this.openViewIndex == 2) {
            this.updateList03();
        }
        else if (this.openViewIndex == 3) {
            this.updateList04();
        }
    };
    //销毁回调
    RechargeView.prototype.onDestroy = function () {
        this.isLoaditemlist01 = null;
        this.isLoaditemlist012 = null;
    };
    RechargeView.prototype.ClickAdd = function () {
        this.addClickListener(this.zhuanshibtn, this.onClick, this);
        this.addClickListener(this.welfaregiftbtn, this.onClick, this);
        this.addClickListener(this.privilegegiftbtn, this.onClick, this);
        this.addClickListener(this.dailystorebtn, this.onClick, this);
        this.addClickListener(this.bgclose, this.onClick, this);
        this.on("netmsg://rechargeDataResult", this.updateList01, this);
    };
    RechargeView.prototype.onClick = function (e) {
        this.bg_imgage.visible = (e.target == this.turn_right_btn ||
            e.target == this.turn_left_btn ||
            e.target == this.guizu_tequan_btn ||
            e.target == this.welfaregiftbtn) ? false : true;
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.zhuanshibtn://钻石界面
                this.updateList01();
                break;
            case this.goto_recharge_btn://点击前往充值按钮
                this.updateList01();
                break;
            case this.guizu_tequan_btn://贵族特权按钮
                this.updateList012();
                break;
            case this.welfaregiftbtn://福利礼包
                this.updateList02();
                break;
            case this.privilegegiftbtn://特权礼包
                this.updateList03();
                break;
            case this.dailystorebtn://每日商店
                this.updateList04();
                break;
            case this.turn_right_btn://贵族详情页前移一页
                this.itemlist012.scrollPane.scrollRight(1);
                break;
            case this.turn_left_btn://贵族详情页后移一页
                this.itemlist012.scrollPane.scrollLeft(1);
                break;
        }
    };
    RechargeView.prototype.onClickItemGenPay = function (e) {
        net.genPayOrder(e.itemObject.data);
    };
    //刷新列表道具物品
    RechargeView.prototype.flushListItem = function (itemlist_cfg, ListItem) {
        ListItem.removeChildrenToPool();
        for (var j = 0; j < itemlist_cfg.length; j++) {
            var item_type = itemlist_cfg[j][1];
            var item_id = itemlist_cfg[j][2];
            var item_count = itemlist_cfg[j][3];
            this.flushtem(ListItem.addItemFromPool().asCom, item_id, item_count, item_type);
        }
        this.onFairyguiEvent(ListItem, fairygui.ItemEvent.CLICK, this.onClickItem, this);
    };
    //点击物品框
    RechargeView.prototype.onClickItem = function (e) {
        var itemData = e.itemObject.data;
        if (itemData.item_type == 3)
            ak.FairyGUI.open(["ResourceTipsView", itemData.item_id, itemData.item_count]);
        else
            ak.FairyGUI.open(["WeaponTipsView", itemData.item_id, itemData.item_count, itemData.item_type]);
    };
    //刷新道具物品
    RechargeView.prototype.flushtem = function (itemCom, item_id, item_count, item_type) {
        var itemBase = new ItemBase(itemCom, this, item_type);
        itemBase.setItemData(Number(item_id));
        itemBase.setNumber(item_count, true);
        itemCom.data = { item_id: item_id, item_count: item_count, item_type: item_type };
    };
    ///////////////钻石界面////////////////////
    RechargeView.prototype.loadRechargeview01 = function () {
        this.jindutiao = this.ui.getChild("vip_progress_bar").asProgress;
        this.itemlist01 = this.ui.getChild("itemlist01").asList;
        this.itemlist012 = this.ui.getChild("itemlist012").asList;
        this.goto_recharge_btn = this.ui.getChild("goto_recharge_btn").asButton;
        this.guizu_tequan_btn = this.ui.getChild("guizu_tequan_btn").asButton;
        this.cur_vip_text = this.ui.getChild("cur_vip_text").asTextField;
        this.recharge_money_text = this.ui.getChild("recharge_money_text").asTextField;
        this.next_vip = this.ui.getChild("next_vip").asTextField;
        this.bg_imgage = this.ui.getChild("n44").asImage;
        this.guizu_tequan = this.ui.getChild("guizu_tequan").asGroup;
        this.cur_vip_bg = this.ui.getChild("cur_vip_bg").asLoader;
        this.next_vip_bg = this.ui.getChild("next_vip_bg").asLoader;
        this.next_vip_group = this.ui.getChild("next_vip_group").asGroup;
        this.turn_right_btn = this.ui.getChild("turn_right_btn").asButton;
        this.turn_left_btn = this.ui.getChild("turn_left_btn").asButton;
        this.goto_recharge_btn.visible = false;
        this.addClickListener(this.goto_recharge_btn, this.onClick, this);
        this.addClickListener(this.guizu_tequan_btn, this.onClick, this);
        this.addClickListener(this.turn_right_btn, this.onClick, this);
        this.addClickListener(this.turn_left_btn, this.onClick, this);
        this.onFairyguiEvent(this.itemlist01, fairygui.ItemEvent.CLICK, this.onClickItemGenPay, this);
    };
    RechargeView.prototype.updateList01 = function () {
        this.itemlistExchangeShow(false);
        var maxVipLevel = this.vipTab.size() - 1;
        this.cur_vip_text.text = MyData.user.vip;
        var cur_vip_url = this.iconVipUrl + this.vipTab.getRow(MyData.user.vip).getValFromColName("icon");
        this.setLoaderUrl(this.cur_vip_bg, cur_vip_url);
        if (MyData.user.vip == maxVipLevel) {
            this.jindutiao.max = 1;
            this.jindutiao.value = 1;
            this.recharge_money_text.text = "VIP已满级";
            this.jindutiao.getChild("title").asTextField.text = "--/--";
            this.next_vip_group.visible = false;
        }
        else {
            this.next_vip_group.visible = true;
            var vipInfo = this.vipTab.getRow(MyData.user.vip + 1);
            var need_exp = Number(vipInfo.getValFromColName("vipExp")); //需要vip经验
            this.jindutiao.max = need_exp;
            this.jindutiao.value = MyData.user.vipExp;
            var need_money = (need_exp - MyData.user.vipExp) / 10;
            this.recharge_money_text.text = "\u518D\u5145\u503C[color=" + Color.green + "]" + need_money + "[/color]\u5143\u5373\u53EF\u6210\u4E3A";
            this.next_vip.text = MyData.user.vip + 1;
            var next_vip_url = this.iconVipUrl + vipInfo.getValFromColName("icon");
            this.setLoaderUrl(this.next_vip_bg, next_vip_url);
        }
        if (this.isLoaditemlist01 == true)
            return;
        this.itemlist01.removeChildrenToPool();
        var count = this.rechargeTab.size();
        for (var i = 0; i < count; i++) {
            var rechargeInfo = this.rechargeTab.getRow(i);
            var firstTimes = Number(rechargeInfo.getValFromColName("firstTimes")); //首次购买倍数
            var recharge_zs = Number(rechargeInfo.getValFromColName("zs")); //获得钻石
            var recharge_id = Number(rechargeInfo.getValFromColName("id")); //id
            var recharge_rmb = Common.getMoneyByPayID(recharge_id); //人民币（元）
            var lvItem = this.itemlist01.addItemFromPool().asCom;
            lvItem.getChild("recharge_money").asTextField.text = recharge_rmb + "元";
            lvItem.getChild("get_diamond").asTextField.text = "可获得" + recharge_zs + "钻石";
            var tip_url_path = "ui://RechargeView/img_sale_pop" + recharge_id;
            var ext = (firstTimes) * recharge_zs;
            lvItem.getChild("get_diamond_ext").asTextField.text = "" + ext;
            // this.setLoaderUrl(lvItem.getChild("img_recharge_tip").asLoader,tip_url_path);
            var box_url_path = "ui://RechargeView/img_sale_zs" + recharge_id;
            if (recharge_id > 8)
                box_url_path = "ui://RechargeView/img_sale_zs8";
            this.setLoaderUrl(lvItem.getChild("img_diamond").asLoader, box_url_path);
            lvItem.data = recharge_id;
        }
        this.isLoaditemlist01 = true;
    };
    //刷新贵族特权list
    RechargeView.prototype.updateList012 = function () {
        this.itemlistExchangeShow(true);
        this.itemlist012.removeChildrenToPool();
        for (var i = 1; i < this.vipTab.size(); i++) {
            var vipInfo = this.vipTab.getRow(i);
            var lv = vipInfo.getValFromColName("lv");
            var icon = vipInfo.getValFromColName("icon");
            var right = vipInfo.getValFromColName("right"); //特权
            var monthDrop = Number(vipInfo.getValFromColName("monthDrop"));
            var vipPrizeDrop = Number(vipInfo.getValFromColName("vipPrizeDrop"));
            var vipPrizeZsNormal = vipInfo.getValFromColName("vipPrizeZsNormal");
            var vipPrizeZs = vipInfo.getValFromColName("vipPrizeZs");
            var lvItem = this.itemlist012.addItemFromPool().asCom;
            lvItem.getChild("vip_lv").asTextField.text = lv; //vip等级
            this.setLoaderUrl(lvItem.getChild("vip_lv_bg").asLoader, this.iconVipUrl + icon);
            var item_Cfg01 = ItemMgr.getDropGroupByID(monthDrop); //高级特权月卡每日额外获得
            var proplist01 = lvItem.getChild("proplist01").asList;
            this.flushListItem(item_Cfg01, proplist01);
            var quanxian_itemList = lvItem.getChild("quanxian_desList").asList;
            quanxian_itemList.removeChildrenToPool();
            for (var j = 0; j < right.length; j++) {
                if (j % 2 == 0) {
                    var vipRightInfo = this.vipRightTab.getRowFromColName("id", right[j]);
                    var str = vipRightInfo.getValFromColName("right");
                    var item = quanxian_itemList.addItemFromPool().asCom;
                    var des_str = right[j] < 100 ? str : ak.strFormat(str, right[j + 1]);
                    item.getChild("quanxian_text").asRichTextField.text = des_str;
                }
            }
            var item_Cfg02 = ItemMgr.getDropGroupByID(vipPrizeDrop); //vip礼包获得
            var proplist02 = lvItem.getChild("proplist02").asList;
            this.flushListItem(item_Cfg02, proplist02);
            lvItem.getChild("original_price").asTextField.text = vipPrizeZsNormal;
            lvItem.getChild("current_price").asTextField.text = vipPrizeZs;
            var vipGiftBuy_btn = lvItem.getChild("vipGiftBuy_btn").asButton;
            var buyMap = MyData.user.json.vipPackage.buyMap;
            vipGiftBuy_btn.data = lv;
            vipGiftBuy_btn.enabled = MyData.user.vip >= lv && buyMap[lv] == null;
            vipGiftBuy_btn.getChild("title").asTextField.text = buyMap[lv] != null ? "已购买" : "购买";
            if (!this.isLoaditemlist012) {
                this.addClickListener(vipGiftBuy_btn, this.onClickBuyVipGift, this);
            }
        }
        this.isLoaditemlist012 = true;
    };
    //贵族特权 充值界面来回切换 部分组件相反显示
    RechargeView.prototype.itemlistExchangeShow = function (is_show) {
        //贵族详情		
        this.goto_recharge_btn.visible = is_show;
        this.guizu_tequan.visible = is_show;
        //充值界面
        this.guizu_tequan_btn.visible = !is_show;
        this.itemlist01.visible = !is_show;
    };
    //点击购买按钮
    RechargeView.prototype.onClickBuyVipGift = function (e) {
        net.vipPackageBuy(e.target.data, this.updateList012, this);
    };
    ///////////////福利礼包////////////////////
    RechargeView.prototype.loadRechargeview02 = function () {
        this.itemlist02 = this.ui.getChild("itemlist02").asList;
        this.receivebtn = this.ui.getChild("receivebtn").asButton;
        this.img_point = this.ui.getChild("img_point").asImage;
        this.c2_control = this.ui.getController("c2");
        this.addClickListener(this.receivebtn, this.onClickReceive, this);
        this.onFairyguiEvent(this.itemlist02, fairygui.ItemEvent.CLICK, this.itemOnClick02, this);
        this.on("netmsg://rechargeDataResult", this.updateList02, this);
    };
    RechargeView.prototype.itemOnClick02 = function (obj) {
        var Item = obj.itemObject;
        var itemData = Item.data;
        var buyMap = MyData.user.json.welfarePackage.buyMap;
        var propList = Item.getChild("proplist").asList;
        if (!this.hitTestPointWithFairyGUIComponent(propList, obj.stageX, obj.stageY)) {
            if (buyMap[itemData.id] == null) {
                net.genPayOrder(itemData.pay); //福利礼包订单生成
            }
            else {
                TipsViewSystem.show("已购买礼包");
            }
        }
    };
    //点击领取按钮
    RechargeView.prototype.onClickReceive = function (e) {
        net.welfarePackage(e.target.data, this.updateList02, this); //福利礼包购买
    };
    RechargeView.prototype.updateList02 = function () {
        var rechargeGiftInfo = this.rechargeGiftTab.getRow(0);
        var id = rechargeGiftInfo.getValFromColName("id");
        var buyMap = MyData.user.json.welfarePackage.buyMap;
        var isReceive = buyMap[id] != null;
        this.receivebtn.data = id;
        this.c2_control.selectedIndex = isReceive ? 1 : 0;
        this.receivebtn.enabled = !isReceive;
        this.img_point.visible = !isReceive;
        this.receivebtn.title = isReceive ? "今日已领取" : "今日可领取";
        this.redPoint1.visible = RedDotMgr.rechargeWelfareGiftRedDot();
        this.itemlist02.removeChildrenToPool();
        for (var i = 1; i < this.rechargeGiftTab.size(); i++) {
            var rechargeGiftInfo_1 = this.rechargeGiftTab.getRow(i);
            var id_1 = rechargeGiftInfo_1.getValFromColName("id");
            var name_28 = rechargeGiftInfo_1.getValFromColName("name");
            var pay = rechargeGiftInfo_1.getValFromColName("pay");
            var drop = rechargeGiftInfo_1.getValFromColName("drop");
            var money = Common.getMoneyByPayID(pay);
            var Item = this.itemlist02.addItemFromPool().asCom;
            Item.data = { pay: pay, id: id_1 };
            var text = buyMap[id_1] != null ? "已购买" : money + "元";
            Item.getChild("moneyText").asTextField.text = text;
            Item.getChild("giftName").asTextField.text = name_28;
            var item_Cfg = ItemMgr.getDropGroupByID(drop);
            Item.getController("c1").selectedIndex = id_1 - 2;
            var proplist = Item.getChild("proplist").asList;
            this.flushListItem(item_Cfg, proplist);
        }
    };
    ///////////////特权礼包////////////////////
    RechargeView.prototype.loadRechargeview03 = function () {
        this.itemlist03 = this.ui.getChild("itemlist03").asList;
        this.titleList = this.ui.getChild("titleList").asList;
        this.onFairyguiEvent(this.itemlist03, fairygui.ItemEvent.CLICK, this.itemOnClick03, this);
        this.on("netmsg://rechargeDataResult", this.updateList03, this);
    };
    RechargeView.prototype.updateList03 = function () {
        this.titleList.removeChildrenToPool();
        for (var i = 0; i < 3; i++) {
            var Item = this.titleList.addItemFromPool().asCom;
            var bannerLoader = Item.getChild("bannerLoader").asLoader;
            this.setLoaderUrl(bannerLoader, "ui://RechargeView/bg_sale_banner" + (i + 3));
        }
        this.itemlist03.removeChildrenToPool();
        for (var i = 0; i < this.rechargeRightTab.size(); i++) {
            var rechargeRightInfo = this.rechargeRightTab.getRow(i);
            var id = rechargeRightInfo.getValFromColName("id");
            var pay = rechargeRightInfo.getValFromColName("pay");
            var zs = rechargeRightInfo.getValFromColName("zs");
            var drop = rechargeRightInfo.getValFromColName("drop");
            var item_Cfg = ItemMgr.getDropGroupByID(drop);
            var Item = this.itemlist03.addItemFromPool().asCom;
            if (pay == 0) {
                Item.getController("c2").selectedIndex = 0;
            }
            else {
                Item.getController("c2").selectedIndex = 1;
            }
            Item.getController("c1").selectedIndex = id - 1;
            var buyMap = MyData.user.json.rightPackage.buyMap;
            Item.getChild("img_ygm").asImage.visible = buyMap[id] != null;
            var money = pay != 0 ? Common.getMoneyByPayID(pay) : 0;
            var btnBuyMoney = Item.getChild("btnBuyMoney").asButton;
            btnBuyMoney.getChild("title").asTextField.text = money + "元";
            btnBuyMoney.data = pay;
            var btnBuyZS = Item.getChild("btnBuyZS").asButton;
            btnBuyZS.getChild("title").asTextField.text = zs;
            btnBuyZS.getChild("number").asTextField.visible = false;
            btnBuyZS.data = id;
            btnBuyMoney.visible = buyMap[id] == null;
            btnBuyZS.visible = buyMap[id] == null;
            var proplist = Item.getChild("proplist").asList;
            this.flushListItem(item_Cfg, proplist);
        }
    };
    RechargeView.prototype.itemOnClick03 = function (obj) {
        var Item = obj.itemObject;
        var btnBuyMoney = Item.getChild("btnBuyMoney").asButton;
        var btnBuyZS = Item.getChild("btnBuyZS").asButton;
        if (this.hitTestPointWithFairyGUIComponent(btnBuyMoney, obj.stageX, obj.stageY)) {
            net.genPayOrder(btnBuyMoney.data);
        }
        else if (this.hitTestPointWithFairyGUIComponent(btnBuyZS, obj.stageX, obj.stageY)) {
            net.rightPackageBuy(btnBuyZS.data, this.updateList03, this);
        }
    };
    ///////////////每日商店//////////////
    RechargeView.prototype.loadRechargeview04 = function () {
        this.itemlist04 = this.ui.getChild("itemlist04").asList;
        this.onFairyguiEvent(this.itemlist04, fairygui.ItemEvent.CLICK, this.itemonclick04, this);
    };
    RechargeView.prototype.itemonclick04 = function (obj) {
        var Item = obj.itemObject;
        var itemCom = Item.getChild("itemCom").asCom;
        if (this.hitTestPointWithFairyGUIComponent(itemCom, obj.stageX, obj.stageY)) {
            var itemData = itemCom.data;
            if (itemData.item_type == 3)
                ak.FairyGUI.open(["ResourceTipsView", itemData.item_id, itemData.item_count]);
            else
                ak.FairyGUI.open(["WeaponTipsView", itemData.item_id, itemData.item_count, itemData.item_type]);
        }
        else if (this.hitTestPointWithFairyGUIComponent(Item, obj.stageX, obj.stageY)) {
            if (MyData.user.diamond + MyData.user.diamond2 >= Item.data.costNum) {
                net.dailyShopBuy(Item.data.id, this.updateList04, this);
            }
            else {
                TipsViewSystem.show("钻石不足");
            }
        }
    };
    RechargeView.prototype.updateList04 = function () {
        this.itemlist04.removeChildrenToPool();
        this.redPoint2.visible = RedDotMgr.rechargeDailyShopRedDot();
        for (var i = 0; i < this.rechargeShopDailyTab.size(); i++) {
            var rechargeShopDailyInfo = this.rechargeShopDailyTab.getRow(i);
            var id = rechargeShopDailyInfo.getValFromColName("id");
            var item_id = rechargeShopDailyInfo.getValFromColName("item");
            var item_count = rechargeShopDailyInfo.getValFromColName("num");
            var costNum = rechargeShopDailyInfo.getValFromColName("costNum");
            var sales = rechargeShopDailyInfo.getValFromColName("sales");
            var limit = rechargeShopDailyInfo.getValFromColName("limit");
            var vip = rechargeShopDailyInfo.getValFromColName("vip");
            var Item = this.itemlist04.addItemFromPool().asCom;
            var limitBuy = Item.getChild("limitBuy").asTextField;
            var residueCount = Item.getChild("residueCount").asTextField;
            var originalPrice = Item.getChild("originalPrice").asTextField;
            var currentPrice = Item.getChild("currentPrice").asTextField;
            var redPoint = Item.getChild("redPoint").asImage;
            redPoint.visible = i == 0 ? RedDotMgr.rechargeDailyShopRedDot() : false;
            var itemCom = Item.getChild("itemCom").asCom;
            var isBuy = Item.getController("isBuy");
            var c2Controller = Item.getController("c2");
            var buyCount = MyData.user.json.dailyShop.buyMap[id] || 0;
            limitBuy.text = sales + "折";
            residueCount.text = MyData.user.vip < vip ? "VIP" + vip + "\u4E13\u5C5E" : "\u4ECA\u65E5\u5269\u4F59" + (limit - buyCount) + "\u6B21";
            currentPrice.text = costNum == 0 ? "0" : (costNum * (sales / 10)).toString();
            originalPrice.text = costNum;
            isBuy.selectedIndex = (limit - buyCount) != 0 ? 0 : 1;
            c2Controller.selectedIndex = sales < 5 ? 0 : 1;
            var item_type = 1;
            this.flushtem(itemCom, item_id, item_count, item_type);
            Item.data = { id: id, costNum: Number(currentPrice.text) };
        }
    };
    return RechargeView;
}(ak.EasyUI));
__reflect(RechargeView.prototype, "RechargeView");
//排行榜奖励预览系统
var RankRewardViewSystem = (function (_super) {
    __extends(RankRewardViewSystem, _super);
    function RankRewardViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    RankRewardViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("SecretAreaView");
    };
    RankRewardViewSystem.inst = new RankRewardViewSystem("SecretAreaView");
    return RankRewardViewSystem;
}(ak.FairyGUI));
__reflect(RankRewardViewSystem.prototype, "RankRewardViewSystem");
//排行榜奖励预览界面
var RankRewardView = (function (_super) {
    __extends(RankRewardView, _super);
    function RankRewardView(itemType) {
        var _this = _super.call(this, RankRewardViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.itemType = itemType;
        return _this;
    }
    /**回调 */
    RankRewardView.prototype.onInit = function () {
        this.create("SecretAreaView", "RankRewardView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.list = this.ui.getChild("list").asList;
        this.titleText = this.ui.getChild("titleText").asLabel;
        this.viewTypeController = this.ui.getController("viewType");
        this.ClickAdd();
        this.updateList();
    };
    RankRewardView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
    };
    RankRewardView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
        }
    };
    RankRewardView.prototype.updateList = function () {
        this.viewTypeController.selectedIndex = this.itemType;
        this.titleText.title = this.itemType == 0 ? "目标奖励" : "排行榜";
        this.list.removeChildrenToPool();
        var listData = this.itemType == 0 ? [] : [];
        for (var i = 0; i < listData.length; i++) {
            var Item = this.list.addItemFromPool().asCom;
            Item.getController("itemType").selectedIndex = this.itemType;
            if (this.itemType == 0) {
            }
            else {
            }
        }
    };
    return RankRewardView;
}(ak.EasyUI));
__reflect(RankRewardView.prototype, "RankRewardView");
//秘境系统
var SecretAreaViewSystem = (function (_super) {
    __extends(SecretAreaViewSystem, _super);
    function SecretAreaViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    SecretAreaViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("SecretAreaView");
    };
    SecretAreaViewSystem.inst = new SecretAreaViewSystem("SecretAreaView");
    return SecretAreaViewSystem;
}(ak.FairyGUI));
__reflect(SecretAreaViewSystem.prototype, "SecretAreaViewSystem");
/**
 *秘境界面
 */
var SecretAreaView = (function (_super) {
    __extends(SecretAreaView, _super);
    function SecretAreaView() {
        var _this = _super.call(this, SecretAreaViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.yaoShuiList = []; //药水组
        _this.propList = []; //道具物品组
        return _this;
    }
    /**回调 */
    SecretAreaView.prototype.onInit = function () {
        this.create("SecretAreaView", "SecretAreaView");
        this.closebtn = this.ui.getChild("closebtn").asButton;
        this.btnPreView = this.ui.getChild("btnPreView").asButton;
        this.btnRank = this.ui.getChild("btnRank").asButton;
        this.btnShop = this.ui.getChild("btnShop").asButton;
        this.btnTip = this.ui.getChild("btnTip").asButton;
        this.heroList = this.ui.getChild("heroList").asList;
        this.curLevel = this.ui.getChild("curLevel").asTextField;
        this.time = this.ui.getChild("time").asTextField;
        for (var i = 0; i < 4; i++) {
            if (i < 3) {
                this.yaoShuiList[i] = this.ui.getChild("yaoshui" + i).asCom;
            }
            this.propList[i] = this.ui.getChild("prop" + i).asCom;
        }
        this.ClickAdd();
        this.updateView();
    };
    SecretAreaView.prototype.ClickAdd = function () {
        this.addClickListener(this.closebtn, this.onClick, this);
        this.addClickListener(this.btnPreView, this.onClick, this);
        this.addClickListener(this.btnRank, this.onClick, this);
        this.addClickListener(this.btnShop, this.onClick, this);
        this.addClickListener(this.btnTip, this.onClick, this);
    };
    SecretAreaView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.closebtn:
                this.close();
                break;
            case this.btnPreView:
                ak.FairyGUI.open(["RankRewardView", 0]);
                break;
            case this.btnRank:
                ak.FairyGUI.open(["RankRewardView", 1]);
                break;
            case this.btnShop:
                break;
            case this.btnTip:
                ak.FairyGUI.open(["HelpTipsView", 12]);
                break;
        }
    };
    SecretAreaView.prototype.updateView = function () {
    };
    //龙骨显示
    SecretAreaView.prototype.showLonggu = function (heroID) {
        var tt = new egret.DisplayObjectContainer();
        this.ui.getChild("longgu").asGraph.setNativeObject(tt);
        var hero = new Hero(heroID).addToParent(tt);
        hero.touchEnabled = true;
        this.onEgretEvent(hero, egret.TouchEvent.TOUCH_TAP, function () {
            hero.setAction("atk");
        }, this);
    };
    return SecretAreaView;
}(ak.EasyUI));
__reflect(SecretAreaView.prototype, "SecretAreaView");
var HeadChangeViewSystem = (function (_super) {
    __extends(HeadChangeViewSystem, _super);
    function HeadChangeViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    HeadChangeViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("SetupView");
    };
    HeadChangeViewSystem.inst = new HeadChangeViewSystem("SetupView");
    return HeadChangeViewSystem;
}(ak.FairyGUI));
__reflect(HeadChangeViewSystem.prototype, "HeadChangeViewSystem");
/**
 * 排行榜
 * 单个
 */
var HeadChangeView = (function (_super) {
    __extends(HeadChangeView, _super);
    function HeadChangeView() {
        return _super.call(this, HeadChangeViewSystem.inst, MyGame.inst.tipLayer) || this;
    }
    /**回调 */
    HeadChangeView.prototype.onInit = function () {
        var ui = this.create("SetupView", "HeadChangeView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.list = ui.getChild("list").asList;
        this.updateView();
        this.ClickAdd();
    };
    HeadChangeView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.onFairyguiEvent(this.list, fairygui.ItemEvent.CLICK, this.itemonclick, this);
    };
    HeadChangeView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
        }
    };
    HeadChangeView.prototype.updateView = function () {
        this.list.removeChildrenToPool();
        var listArr = SetUpData.inst().GetHeadListInfo();
        for (var i = 0; i < listArr.length; i++) {
            var item = this.list.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
            item.data = listArr[i];
            var items = new ItemBase(item, this, 2);
            items.setItemData(listArr[i].heroid, 0, 0);
        }
    };
    HeadChangeView.prototype.itemonclick = function (e) {
        if (this.ui.getController("c1").selectedIndex == 0) {
            var data = e.itemObject.data;
            net.changHead(data.id, function () {
                ak.EventMgr.dispatch(GameEvent.changeHead);
            }, this);
            this.close();
        }
        else if (this.ui.getController("c1").selectedIndex == 1) {
            TipsViewSystem.show("该功能暂未开放");
            return;
        }
        else if (this.ui.getController("c1").selectedIndex == 2) {
            TipsViewSystem.show("该功能暂未开放");
            return;
        }
    };
    return HeadChangeView;
}(ak.EasyUI));
__reflect(HeadChangeView.prototype, "HeadChangeView");
var NameChangeViewSystem = (function (_super) {
    __extends(NameChangeViewSystem, _super);
    function NameChangeViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    NameChangeViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("SetupView");
    };
    NameChangeViewSystem.inst = new NameChangeViewSystem("SetupView");
    return NameChangeViewSystem;
}(ak.FairyGUI));
__reflect(NameChangeViewSystem.prototype, "NameChangeViewSystem");
/**
 * 排行榜
 * 单个
 */
var NameChangeView = (function (_super) {
    __extends(NameChangeView, _super);
    function NameChangeView() {
        return _super.call(this, NameChangeViewSystem.inst, MyGame.inst.tipLayer) || this;
    }
    /**回调 */
    NameChangeView.prototype.onInit = function () {
        var ui = this.create("SetupView", "NameChangeView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.nametxt = ui.getChild("nametxt").asTextInput;
        this.changebtn = ui.getChild("changebtn").asButton;
        this.ClickAdd();
        this.updateView();
    };
    NameChangeView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.changebtn, this.onClick, this);
    };
    NameChangeView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.changebtn:
                this.changeName();
                break;
        }
    };
    NameChangeView.prototype.changeName = function () {
        var _this = this;
        var name0 = this.nametxt.text;
        if (name0.length >= 2 && name0.length <= 6) {
            net.changeNickname(this.nametxt.text, function () {
                _this.close();
                ak.EventMgr.dispatch(GameEvent.changeName);
            }, this);
        }
        else {
            TipsViewSystem.show("名字需要2-6个字符");
            return;
        }
    };
    NameChangeView.prototype.updateView = function () {
        var number = this.changebtn.getChild("number").asTextField;
        var info = SetUpData.inst().getChangeNameInfo();
        if (MyData.user.json.modifNicknameCount >= info.num) {
            number.text = "" + info.zs;
        }
        else {
            number.text = "" + 0;
        }
    };
    return NameChangeView;
}(ak.EasyUI));
__reflect(NameChangeView.prototype, "NameChangeView");
var SetUpData = (function () {
    function SetUpData() {
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    SetUpData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new SetUpData();
        }
        return Class._instance;
    };
    SetUpData.prototype.GetLvNowMax = function () {
        var playerLvTab = ak.JsonTableMgr.get("playerLv");
        var nextlv = MyData.user.level + 1;
        if (nextlv > playerLvTab.size()) {
            nextlv = MyData.user.level;
        }
        var playerLvInfo = playerLvTab.getRowFromColName("level", String(nextlv));
        var exp = playerLvInfo.getValFromColName("exp");
        return exp;
    };
    SetUpData.prototype.GetHeadListInfo = function () {
        var headTab = ak.JsonTableMgr.get("head");
        var infoArr = [];
        for (var i = 0; i < headTab.size(); i++) {
            var headInfo = headTab.getRow(i);
            var id = headInfo.getValFromColName("id");
            var type = headInfo.getValFromColName("type");
            var heroid = headInfo.getValFromColName("heroid");
            var first = headInfo.getValFromColName("first");
            var info = { id: id, type: type, heroid: heroid, first: first };
            if (first == 1) {
                infoArr.push(info);
            }
            else {
                if (HeroBagData.inst().isInHeroGroup(heroid)) {
                    infoArr.push(info);
                }
            }
        }
        return infoArr;
    };
    /**获取改名表信息 */
    SetUpData.prototype.getChangeNameInfo = function () {
        var changeNameConfigTab = ak.JsonTableMgr.get("changeNameConfig");
        var changeNameConfigInfo = changeNameConfigTab.getRow(0);
        var num = changeNameConfigInfo.getValFromColName("num");
        var zs = changeNameConfigInfo.getValFromColName("zs");
        var info = { num: num, zs: zs };
        return info;
    };
    return SetUpData;
}());
__reflect(SetUpData.prototype, "SetUpData");
var SetupViewSystem = (function (_super) {
    __extends(SetupViewSystem, _super);
    function SetupViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    SetupViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("SetupView");
    };
    SetupViewSystem.inst = new SetupViewSystem("SetupView");
    return SetupViewSystem;
}(ak.FairyGUI));
__reflect(SetupViewSystem.prototype, "SetupViewSystem");
/**
 * item提示框
 */
var SetupView = (function (_super) {
    __extends(SetupView, _super);
    function SetupView() {
        var _this = _super.call(this, SetupViewSystem.inst, MyGame.inst.tipLayer) || this;
        //调用更改头像
        _this.on(GameEvent.changeHead, _this.updateView, _this);
        "";
        return _this;
    }
    /**回调 */
    SetupView.prototype.onInit = function () {
        var _this = this;
        var ui = this.create("SetupView", "SetupView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.userbtn = ui.getChild("userbtn").asButton;
        this.functionbtn = ui.getChild("functionbtn").asButton;
        this.noticebtn = ui.getChild("noticebtn").asButton;
        this.backbtn = ui.getChild("backbtn").asButton;
        this.itemCom = ui.getChild("itemCom").asCom;
        this.changebtn = ui.getChild("changebtn").asButton;
        this.changenamebtn = ui.getChild("changenamebtn").asButton;
        this.changeuserbtn = ui.getChild("changeuserbtn").asButton;
        this.myname = ui.getChild("myname").asTextField;
        this.unionname = ui.getChild("unionname").asTextField;
        this.myid = ui.getChild("myid").asTextField;
        this.mylv = ui.getChild("mylv").asTextField;
        this.goldnum = ui.getChild("goldnum").asTextField;
        this.expnum = ui.getChild("expnum").asTextField;
        this.soulnum = ui.getChild("soulnum").asTextField;
        this.zsnum = ui.getChild("zsnum").asTextField;
        this.jifennum = ui.getChild("jifennum").asTextField;
        this.offernum = ui.getChild("offernum").asTextField;
        this.expbar = ui.getChild("expbar").asProgress;
        this.exchangenum = ui.getChild("exchangenum").asTextInput;
        this.exchangebtn = ui.getChild("exchangebtn").asButton;
        this.slider1 = ui.getChild("slider1").asSlider;
        this.slider2 = ui.getChild("slider2").asSlider;
        this.list = ui.getChild("list").asList;
        this.backtxt = ui.getChild("backtxt").asTextField;
        this.backbtn0 = ui.getChild("backbtn0").asButton;
        this.musicbtn1 = ui.getChild("musicbtn1").asButton;
        this.musicbtn2 = ui.getChild("musicbtn2").asButton;
        // this.versionText = ui.getChild("n91").asTextField;
        this.controller_c1 = ui.getController("c1");
        this.ClickAdd();
        this.soundSetup();
        this.staticView();
        this.addClickListener(this.exchangebtn, function () {
            var sn = _this.exchangenum.text;
            net.cdkey(sn, function () { }, _this);
        }, this);
        this.getLocalresVersion(function (res) {
            var text = "";
            var app = "";
            var resouce = "";
            var ui = "";
            var js = "";
            if (res) {
                for (var i = 0; i < res.length; i++) {
                    if (res[i].resName == "AppVersion")
                        app = res[i].resVersion;
                    if (res[i].resName == "ui")
                        ui = res[i].resVersion;
                    if (res[i].resName == "js")
                        js = res[i].resVersion;
                    if (res[i].resName == "resource")
                        resouce = res[i].resVersion;
                }
            }
            // this.versionText.text = MyConfig.appVersion + "." + resouce + "." + js + "." + ui 
        }, this);
    };
    SetupView.prototype.getLocalresVersion = function (callback, thisObj) {
        var str = GameLocalStorage.loadByUid(GameLocalStorage.localresVersion);
        var arr = [];
        if (str && str != "") {
            arr = ak.json_decode(str);
            callback.call(thisObj, arr);
        }
        else {
            RES.getResByUrl(MyConfig.LocalclientResUrl, function (res) {
                GameLocalStorage.saveByUid(GameLocalStorage.localresVersion, ak.json_encode(res));
                callback.call(thisObj, res);
            });
        }
    };
    SetupView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onclick, this);
        this.addClickListener(this.userbtn, this.onclick, this);
        this.addClickListener(this.functionbtn, this.onclick, this);
        this.addClickListener(this.noticebtn, this.onclick, this);
        this.addClickListener(this.backbtn, this.onclick, this);
        this.addClickListener(this.backbtn0, this.onclick, this);
        this.addClickListener(this.musicbtn1, this.onclick, this);
        this.addClickListener(this.musicbtn2, this.onclick, this);
        this.addClickListener(this.changebtn, this.onclick, this);
        this.addClickListener(this.changenamebtn, this.onclick, this);
        this.addClickListener(this.changeuserbtn, this.onclick, this);
        this.onFairyguiEvent(this.list, fairygui.ItemEvent.CLICK, this.itemonclick, this);
    };
    SetupView.prototype.onclick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.backbtn0:
                if (MyConfig.loginType == 0) {
                    ak.FairyGUI.open(["GMorderView"]);
                }
                break;
            case this.userbtn:
                this.controller_c1.selectedIndex = 0;
                break;
            case this.functionbtn:
                this.controller_c1.selectedIndex = 1;
                break;
            case this.noticebtn:
                this.controller_c1.selectedIndex = 2;
                break;
            case this.backbtn:
                this.controller_c1.selectedIndex = 3;
                break;
            case this.musicbtn1:
                var str1 = this.musicbtn1.selected == true ? "0" : "1";
                GameLocalStorage.saveByUid(GameLocalStorage.usermusicvalue_1, str1);
                this.soundSetup();
                break;
            case this.musicbtn2:
                var str2 = this.musicbtn2.selected == true ? "0" : "1";
                GameLocalStorage.saveByUid(GameLocalStorage.usermusicvalue_2, str2);
                this.soundSetup();
                break;
            case this.changebtn:
                ak.FairyGUI.open(["HeadChangeView"]);
                break;
            case this.changenamebtn:
                this.close();
                ak.FairyGUI.open(["NameChangeView"]);
                break;
            case this.changeuserbtn:
                TipsViewSystem.show("该功能暂未开放");
                // ak.FairyGUI.open(["LoginOut"]);
                // MyClient.inst.closeConnectServer();
                // MyGame.inst.loginSdk();
                // ak.FairyGUI.open(["ChooseServerView"]);
                this.close();
                break;
        }
    };
    /**公告 */
    SetupView.prototype.itemonclick = function (e) {
    };
    SetupView.prototype.staticView = function () {
        this.myname.text = "" + MyData.user.nickname;
        this.unionname.text = "" + MyData.user.unionName;
        this.myid.text = "" + MyData.user.id;
        this.mylv.text = "" + MyData.user.level;
        this.goldnum.text = "" + MyData.user.money;
        this.expnum.text = "" + MyData.user.cardExp;
        this.soulnum.text = "" + SummonData.inst().GetItemnumByid(2001);
        this.zsnum.text = "" + (MyData.user.diamond + MyData.user.diamond2);
        this.jifennum.text = "" + MyData.user.offerScore;
        this.offernum.text = "" + 0;
        var item = new ItemBase(this.itemCom, this, 2);
        item.setIcons2("hero" + MyData.user.head);
        this.expbar.max = SetUpData.inst().GetLvNowMax();
        this.expbar.value = MyData.user.exp;
    };
    SetupView.prototype.updateView = function () {
        //更新头像 总共3个类型 以下是topView和setupView的头像
        var user = MyData.user;
        this.setLoaderUrl(this.itemCom.getChild("icon").asLoader, "hero" + MyData.user.head + "_png");
    };
    SetupView.prototype.soundSetup = function () {
        var str1 = GameLocalStorage.loadByUid(GameLocalStorage.usermusicvalue_1);
        var str2 = GameLocalStorage.loadByUid(GameLocalStorage.usermusicvalue_2);
        ak.SoundMgr.inst.openMusic = str1 == null || Number(str1) == 1 ? true : false;
        ak.SoundMgr.inst.openSound = str2 == null || Number(str2) == 1 ? true : false;
        this.musicbtn1.selected = str1 != null && Number(str1) == 0;
        this.musicbtn2.selected = str2 != null && Number(str2) == 0;
    };
    SetupView.soundSetup = function () {
        var str1 = GameLocalStorage.loadByUid(GameLocalStorage.usermusicvalue_1);
        var str2 = GameLocalStorage.loadByUid(GameLocalStorage.usermusicvalue_2);
        ak.SoundMgr.inst.openMusic = str1 == null || Number(str1) == 1 ? true : false;
        ak.SoundMgr.inst.openSound = str2 == null || Number(str2) == 1 ? true : false;
    };
    return SetupView;
}(ak.EasyUI));
__reflect(SetupView.prototype, "SetupView");
//铁匠铺
var SmithyViewSystem = (function (_super) {
    __extends(SmithyViewSystem, _super);
    function SmithyViewSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    SmithyViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("Smithy");
    };
    SmithyViewSystem.inst = new SmithyViewSystem("Smithy");
    return SmithyViewSystem;
}(ak.FairyGUI));
__reflect(SmithyViewSystem.prototype, "SmithyViewSystem");
//主界面
var SmithyView = (function (_super) {
    __extends(SmithyView, _super);
    function SmithyView() {
        var _this = _super.call(this, SmithyViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
        //放入道具
        _this.maxNum = 0; //最多合成几件装备
        _this.selectNum = 0; //合成几件装备
        _this.itemIndexShow = 0; //显示选中位置
        return _this;
    }
    //初始化回调
    SmithyView.prototype.onInit = function () {
        DownViewSystem.hide();
        this.ui = this.create("Smithy", "SmithyView");
        this.closebtn = this.ui.getChild("closeBtn").asButton;
        this.hecheng = this.ui.getChild("n134").asButton;
        this.jianBtn = this.ui.getChild("n135").asButton;
        this.jiaBtn = this.ui.getChild("n136").asButton;
        this.showEQ1 = this.ui.getChild("n130").asCom;
        this.showEQ2 = this.ui.getChild("n131").asCom;
        this.equList = this.ui.getChild("n126").asList;
        this.itemEquipTab = ak.JsonTableMgr.get("itemEquip");
        this.onEgretEvent(this.ui.getController("c1"), fairygui.StateChangeEvent.CHANGED, this.onChanged, this);
        this.clickAdd();
        this.onChanged();
    };
    //更新选项卡红点
    SmithyView.prototype.updateTabRed = function () {
        var redArr = RedDotMgr.oneEquSmithyRed();
        this.ui.getChild("n55").asButton.getController("red").selectedIndex = redArr[0];
        this.ui.getChild("n56").asButton.getController("red").selectedIndex = redArr[1];
        this.ui.getChild("n128").asButton.getController("red").selectedIndex = redArr[2];
        this.ui.getChild("n129").asButton.getController("red").selectedIndex = redArr[3];
    };
    SmithyView.prototype.onChanged = function () {
        this.selectItemID = -1;
        this.equList.removeChildrenToPool(); //清空列表
        var equType = this.ui.getController("c1").selectedIndex + 1; //装备类型
        var itemArr = MyData.user.json.itemArr;
        var itemArrCount = itemArr.length;
        var num = 0;
        this.itemIndexShow = 0;
        var itemEquCount = this.itemEquipTab.size();
        for (var j = 0; j < itemEquCount; j++) {
            var itemInfo = this.itemEquipTab.getRow(j);
            var type = Number(itemInfo.getValFromColName("type")); //装备类型：1=武器；2=戒子；3=头盔；4=衣服；
            var needID = Number(itemInfo.getValFromColName("needID")); //
            if (equType == type && needID) {
                var item = this.equList.addItemFromPool().asCom;
                var itemBase = new ItemBase(item, this, 1);
                var itemID = Number(itemInfo.getValFromColName("id")); //
                var star = Number(itemInfo.getValFromColName("star"));
                var needNum = Number(itemInfo.getValFromColName("needNum")); //合成需要数量
                itemBase.setItemData(itemID);
                itemBase.setStar2(star);
                item._id = num + "";
                item.data = itemID;
                var pass = false;
                for (var i = 0; i < itemArrCount; i++) {
                    var itemIDS = itemArr[i].itemID;
                    if (needID == itemIDS) {
                        var itemCount = itemArr[i].count;
                        if (itemCount >= needNum) {
                            pass = true;
                        }
                    }
                }
                itemBase.isshowreddot(pass);
                if (this.selectItemID == -1) {
                    itemBase.setGou(true);
                    this.selectItemID = itemID;
                }
                else {
                    itemBase.setGou(false);
                }
                num++;
            }
        }
        this.onFairyguiEvent(this.equList, fairygui.ItemEvent.CLICK, this.intoItem, this);
        this.updateView();
        this.updateTabRed();
    };
    SmithyView.prototype.intoItem = function (obj) {
        this.selectItemID = obj.itemObject.data;
        //√旧勾选
        var oldSelectItem = this.equList.getChildAt(this.itemIndexShow).asCom;
        var oldItemBase = new ItemBase(oldSelectItem, this, 1);
        oldItemBase.setGou(false);
        this.itemIndexShow = Number(obj.itemObject._id);
        //√新勾选
        var selectItem = this.equList.getChildAt(this.itemIndexShow).asCom;
        var itemBase = new ItemBase(selectItem, this, 1);
        itemBase.setGou(true);
        this.updateView();
    };
    SmithyView.prototype.updateView = function () {
        var itemInfo1 = this.itemEquipTab.getRowFromColName("id", "" + this.selectItemID);
        var needID = Number(itemInfo1.getValFromColName("needID")); //合成需要装备id
        var needNum = Number(itemInfo1.getValFromColName("needNum")); //合成需要数量
        this.needGold = Number(itemInfo1.getValFromColName("needGold")); //合成消耗金币
        var star1 = Number(itemInfo1.getValFromColName("star"));
        var itemBase1 = new ItemBase(this.showEQ2, this, 1);
        itemBase1.setItemData(this.selectItemID);
        itemBase1.setStar2(star1);
        this.showEQ2.data = { itemID: this.selectItemID, itemCount: 1 };
        var itemArr = MyData.user.json.itemArr;
        var itemCount = 0;
        for (var i = 0; i < itemArr.length; i++) {
            var info = itemArr[i];
            var itemID = info.itemID;
            if (needID == itemID) {
                itemCount = info.count;
            }
        }
        var itemInfo = this.itemEquipTab.getRowFromColName("id", "" + needID);
        var star = Number(itemInfo.getValFromColName("star"));
        this.showEQ1.data = { itemID: needID, itemCount: itemCount };
        var itemBase = new ItemBase(this.showEQ1, this, 1);
        itemBase.setItemData(needID);
        itemBase.setStar2(star);
        this.showEQ1.getController("isNumberOut").selectedIndex = (1);
        itemBase.setnumberOut(itemCount + "/" + needNum);
        this.maxNum = Math.floor(itemCount / needNum);
        this.selectNum = this.maxNum;
        this.ui.getChild("n140").asTextField.text = Common.overLength(this.maxNum * this.needGold) + "";
        this.ui.getChild("n141").asTextField.text = this.maxNum + "";
        this.upgradeJiaJian();
    };
    //更新加减按钮
    SmithyView.prototype.upgradeJiaJian = function () {
        if (this.selectNum == 0) {
            this.jianBtn.enabled = false;
        }
        else {
            this.jianBtn.enabled = true;
        }
        if (this.selectNum == this.maxNum) {
            this.jiaBtn.enabled = false;
        }
        else {
            this.jiaBtn.enabled = true;
        }
        this.ui.getChild("n140").asTextField.text = Common.overLength(this.selectNum * this.needGold) + "";
        this.ui.getChild("n141").asTextField.text = this.selectNum + "";
    };
    SmithyView.prototype.clickAdd = function () {
        this.addClickListener(this.closebtn, this.onClick, this); //关闭界面
        this.addClickListener(this.jianBtn, this.onClick, this); //减按钮
        this.addClickListener(this.jiaBtn, this.onClick, this); //加按钮
        this.addClickListener(this.hecheng, this.onClick, this); //合成
        this.addClickListener(this.showEQ1, this.onClick, this); //显示装备1数据
        this.addClickListener(this.showEQ2, this.onClick, this); //显示装备2数据
    };
    SmithyView.prototype.onClick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.closebtn:
                this.close();
                DownViewSystem.show();
                break;
            case this.hecheng:
                if (this.selectNum == 0) {
                    TipsViewSystem.show("合成材料不足");
                    return;
                }
                net.cardEquCompose(this.selectItemID, this.selectNum, function () {
                    _this.onChanged();
                }, this);
                break;
            case this.jianBtn:
                this.selectNum--;
                this.upgradeJiaJian();
                break;
            case this.jiaBtn:
                this.selectNum++;
                this.upgradeJiaJian();
                break;
            case this.showEQ1:
                var data = this.showEQ1.data;
                var itemID = data.itemID;
                var itemCount = data.itemCount;
                var bagtype = ak.JsonTableMgr.get("item").getRowFromColName("id", "" + itemID).getValFromColName("bagtype");
                ak.FairyGUI.open(["WeaponTipsView", itemID, itemCount, bagtype - 1, 0, true]);
                break;
            case this.showEQ2:
                var data2 = this.showEQ2.data;
                var itemID2 = data2.itemID;
                var itemCount2 = data2.itemCount;
                var bagtype2 = ak.JsonTableMgr.get("item").getRowFromColName("id", "" + itemID2).getValFromColName("bagtype");
                ak.FairyGUI.open(["WeaponTipsView", itemID2, itemCount2, bagtype2 - 1, 0, true]);
                break;
        }
    };
    return SmithyView;
}(ak.EasyUI));
__reflect(SmithyView.prototype, "SmithyView");
/**
 * 召唤系统(获得)
 */
var SummonIngViewSystem = (function (_super) {
    __extends(SummonIngViewSystem, _super);
    function SummonIngViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    SummonIngViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("SummonIngView");
    };
    SummonIngViewSystem.inst = new SummonIngViewSystem("SummonIngView");
    return SummonIngViewSystem;
}(ak.FairyGUI));
__reflect(SummonIngViewSystem.prototype, "SummonIngViewSystem");
/**
 * 召唤界面(获得)
 */
var SummonIngView = (function (_super) {
    __extends(SummonIngView, _super);
    function SummonIngView(itemIDGruop, summonType) {
        var _this = _super.call(this, SummonIngViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.itemIDGruop = [];
        //抽卡类型//召唤（1=普通1次，2=普通10次，3=高级1次，4=高级10次，5=友情1次，6=友情10次，7=积分召唤）
        _this.summonType = 0;
        _this.itemIDGruop = itemIDGruop;
        _this.summonType = summonType;
        return _this;
    }
    /**回调 */
    SummonIngView.prototype.onInit = function () {
        var ui = this.create("SummonIngView", "SummonIngView");
        this.on(GameEvent.guide_randomCardAniComplete, this.openactivity, this);
        this.surebtn = ui.getChild("surebtn").asButton;
        this.againSummonbtn = ui.getChild("againSummonbtn").asButton;
        this.GainGroup = ui.getChild("GainGroup").asGroup;
        this.GainItem = ui.getChild("GainItem").asCom;
        this.itemGroup = ui.getChild("itemGroup").asGroup;
        this.itemGroups = [];
        for (var i = 0; i < 10; i++) {
            var item = ui.getChild("GainItem" + i).asCom;
            this.itemGroups.push(item);
        }
        this.mcGroup = ui.getChild("mcGroup").asGraph;
        this.ClickAdd();
        this.showSummonGainView();
        this.setBtnShow();
    };
    SummonIngView.prototype.ClickAdd = function () {
        this.addClickListener(this.surebtn, this.onClick, this);
        this.addClickListener(this.againSummonbtn, this.onClick, this);
    };
    SummonIngView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.surebtn:
                this.close();
                break;
            case this.againSummonbtn:
                this.againSummon();
                break;
        }
    };
    /**再抽一次 */
    SummonIngView.prototype.againSummon = function () {
        var _this = this;
        net.randomCard(this.summonType, function (getCardArr) {
            _this.GainGroup.visible = false;
            _this.itemIDGruop = getCardArr;
            _this.showSummonGainView();
            _this.setBtnShow();
        }, this);
    };
    /**成功消耗次数或者道具后展现 */
    SummonIngView.prototype.showSummonGainView = function () {
        this.GainGroup.visible = false;
        this.mcGroup.visible = true;
        if (this.itemIDGruop.length == 1) {
            //单抽
            this.itemGroup.visible = false;
            this.GainItem.visible = true;
            var item = new ItemBase(this.GainItem, this, 2);
            item.setItemData(this.itemIDGruop[0].heroID, this.itemIDGruop[0].race, this.itemIDGruop[0].starMax);
            if (this.itemIDGruop[0].starMax == 5) {
                item.isshowLight(true);
            }
            else {
                item.isshowLight(false);
            }
        }
        else {
            //10连
            //打乱10连抽
            var randomNumGroup = [];
            var newitemIDGruop = [];
            var oldNumGroup = [0, 1, 2, 3, 4, 5, 6, 7, 8, 9];
            while (randomNumGroup.length < this.itemIDGruop.length) {
                var randomNum = oldNumGroup[Math.floor(Math.random() * 10)];
                if (randomNumGroup.indexOf(randomNum) < 0) {
                    randomNumGroup.push(randomNum);
                }
            }
            for (var j = 0; j < 10; j++) {
                newitemIDGruop.push(this.itemIDGruop[randomNumGroup[j]]);
            }
            this.itemGroup.visible = true;
            this.GainItem.visible = false;
            for (var i = 0; i < 10; i++) {
                var item = new ItemBase(this.itemGroups[i], this, 2);
                //item.setItemData(this.itemIDGruop[i].heroID,this.itemIDGruop[i].race,this.itemIDGruop[i].starMax);
                item.setItemData(newitemIDGruop[i].heroID, newitemIDGruop[i].race, newitemIDGruop[i].starMax);
                if (newitemIDGruop[i].starMax == 5) {
                    item.isshowLight(true);
                }
                else {
                    item.isshowLight(false);
                }
            }
        }
        //egret.setTimeout(()=>{
        //	this.GainGroup.visible = true;
        //},this,2000);
        /**
         * 测试
         */
        //播放抽卡音乐
        ak.SoundMgr.inst.playSound("resource/sound/zhaohuan.mp3");
        //MC
        this.mc = new ak.MovieClip("zhanhuan_json", "zhanhuan_png", "zhanhuan", 1);
        this.mc.scaleX = 2;
        this.mc.scaleY = 2;
        this.mcGroup.setNativeObject(this.mc);
        this.mc.addEventListener(egret.Event.COMPLETE, this.mcCompleteHandle, this);
    };
    SummonIngView.prototype.mcCompleteHandle = function () {
        this.mcGroup.visible = false;
        this.GainGroup.visible = true;
        ak.EventMgr.dispatch(GameEvent.guide_randomCardAniComplete);
    };
    /**btn显示 */
    SummonIngView.prototype.setBtnShow = function () {
        var number = this.againSummonbtn.getChild("number").asTextField;
        var icon = this.againSummonbtn.getChild("icon").asLoader;
        var title = this.againSummonbtn.getChild("title").asTextField;
        this.againSummonbtn.visible = true;
        switch (this.summonType) {
            case 1:
                number.text = "1";
                this.setLoaderUrl(icon, "ui://common/token_zhyj");
                title.text = "一次";
                break;
            case 2:
                number.text = "10";
                this.setLoaderUrl(icon, "ui://common/token_zhyj");
                title.text = "十次";
                break;
            case 3:
                if (SummonData.inst().GetItemnumByid(2010) > 0) {
                    number.text = "1";
                    this.setLoaderUrl(icon, "ui://common/token_xzyj");
                }
                else {
                    number.text = "13200";
                    this.setLoaderUrl(icon, "ui://common/token_zs");
                }
                title.text = "一次";
                break;
            case 4:
                if (SummonData.inst().GetItemnumByid(2010) > 9) {
                    number.text = "10";
                    this.setLoaderUrl(icon, "ui://common/token_xzyj");
                }
                else {
                    number.text = "120000";
                    this.setLoaderUrl(icon, "ui://common/token_zs");
                }
                title.text = "十次";
                break;
            case 5:
                number.text = "10";
                this.setLoaderUrl(icon, "ui://common/token_yqyj");
                title.text = "一次";
                break;
            case 6:
                number.text = "90";
                this.setLoaderUrl(icon, "ui://common/token_yqyj");
                title.text = "十次";
                break;
            case 7:
                this.againSummonbtn.visible = false;
                break;
        }
    };
    /**打开活动 */
    SummonIngView.prototype.openactivity = function () {
        var _this = this;
        if (this.isHave5starhero() && !Guide.isInGuide()) {
            egret.setTimeout(function () {
                ak.FairyGUI.open(["ChooseTipsView", 9, "5星英雄养成礼包（限时）已激活，是否去购买", function () {
                        _this.close();
                        ak.FairyGUI.open(["ActivityCommonView", "ActivityLimitGiftView"]);
                    }]);
            }, this, 500);
        }
    };
    SummonIngView.prototype.isHave5starhero = function () {
        for (var i = 0; i < this.itemIDGruop.length; i++) {
            if (this.itemIDGruop[i].starMax == 5) {
                return true;
            }
        }
        return false;
    };
    return SummonIngView;
}(ak.EasyUI));
__reflect(SummonIngView.prototype, "SummonIngView");
/**
 * 召唤系统
 */
var SummonViewSystem = (function (_super) {
    __extends(SummonViewSystem, _super);
    function SummonViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    SummonViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("SummonView");
    };
    SummonViewSystem.inst = new SummonViewSystem("SummonView");
    return SummonViewSystem;
}(ak.FairyGUI));
__reflect(SummonViewSystem.prototype, "SummonViewSystem");
/**
 * 召唤界面
 */
var SummonView = (function (_super) {
    __extends(SummonView, _super);
    function SummonView() {
        return _super.call(this, SummonViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
    }
    /**回调 */
    SummonView.prototype.onInit = function () {
        var ui = this.create("SummonView", "SummonView");
        this.on("netmsg://randomCardResult", this.updateitemNum, this);
        this.addbtn = ui.getChild("addbtn").asButton;
        this.closebtn = ui.getChild("closebtn").asButton;
        this.summontips = ui.getChild("summontips").asButton;
        this.basisSummonbtn1 = ui.getChild("basisSummonbtn1").asButton;
        this.basisSummonbtn2 = ui.getChild("basisSummonbtn2").asButton;
        this.basisSummonbtn3 = ui.getChild("basisSummonbtn3").asButton;
        this.seniorSummonbtn1 = ui.getChild("seniorSummonbtn1").asButton;
        this.seniorSummonbtn2 = ui.getChild("seniorSummonbtn2").asButton;
        this.seniorSummonbtn3 = ui.getChild("seniorSummonbtn3").asButton;
        this.friendSummonbtn1 = ui.getChild("friendSummonbtn1").asButton;
        this.friendSummonbtn2 = ui.getChild("friendSummonbtn2").asButton;
        this.basisSummonnum = ui.getChild("basisSummonnum").asTextField;
        this.seniorSummonnum = ui.getChild("seniorSummonnum").asTextField;
        this.friendSummonnum = ui.getChild("friendSummonnum").asTextField;
        this.summonexp = ui.getChild("summonexp").asProgress;
        this.group0 = ui.getChild("group0").asGroup;
        this.group1 = ui.getChild("group1").asGroup;
        this.group2 = ui.getChild("group2").asGroup;
        this.item_number = ui.getChild("item_00num").asCom.getChild("number").asTextField;
        this.timetips0 = ui.getChild("timetips0").asTextField;
        this.timetips1 = ui.getChild("timetips1").asTextField;
        this.vip3summonbtn = ui.getChild("vip3summonbtn").asButton;
        this.addbtn.visible = MyConfig.openBuyDiamond;
        this.ClickAdd();
        this.playIconTween();
        this.staticView();
        this.updateitemNum();
    };
    SummonView.prototype.ClickAdd = function () {
        this.addClickListener(this.closebtn, this.onClick, this);
        this.addClickListener(this.basisSummonbtn1, this.onClick, this);
        this.addClickListener(this.basisSummonbtn2, this.onClick, this);
        this.addClickListener(this.basisSummonbtn3, this.onClick, this);
        this.addClickListener(this.seniorSummonbtn1, this.onClick, this);
        this.addClickListener(this.seniorSummonbtn2, this.onClick, this);
        this.addClickListener(this.seniorSummonbtn3, this.onClick, this);
        this.addClickListener(this.friendSummonbtn1, this.onClick, this);
        this.addClickListener(this.friendSummonbtn2, this.onClick, this);
        this.addClickListener(this.addbtn, this.onClick, this);
        this.addClickListener(this.summontips, this.onClick, this);
        this.addClickListener(this.vip3summonbtn, this.onClick, this);
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.timeDown, this);
    };
    SummonView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.closebtn:
                this.close();
                break;
            case this.basisSummonbtn1:
            case this.basisSummonbtn3:
                net.randomCard(1, function (getCardArr) {
                    ak.log(getCardArr);
                    ak.FairyGUI.open(["SummonIngView", getCardArr, 1]);
                }, this);
                break;
            case this.basisSummonbtn2:
                net.randomCard(2, function (getCardArr) {
                    ak.FairyGUI.open(["SummonIngView", getCardArr, 2]);
                }, this);
                break;
            case this.seniorSummonbtn1:
            case this.seniorSummonbtn3:
                net.randomCard(3, function (getCardArr) {
                    ak.FairyGUI.open(["SummonIngView", getCardArr, 3]);
                }, this);
                break;
            case this.seniorSummonbtn2:
                net.randomCard(4, function (getCardArr) {
                    ak.FairyGUI.open(["SummonIngView", getCardArr, 4]);
                }, this);
                break;
            case this.friendSummonbtn1:
                net.randomCard(5, function (getCardArr) {
                    ak.FairyGUI.open(["SummonIngView", getCardArr, 5]);
                }, this);
                break;
            case this.friendSummonbtn2:
                net.randomCard(6, function (getCardArr) {
                    ak.FairyGUI.open(["SummonIngView", getCardArr, 6]);
                }, this);
                break;
            case this.addbtn:
                ak.FairyGUI.open(["RechargeView"]);
                break;
            case this.summontips:
                ak.FairyGUI.open(["HelpTipsView", 2]);
                break;
            case this.vip3summonbtn:
                ak.FairyGUI.open(["JifenTipsView"]);
                break;
        }
    };
    /**
     * 播放icon缓动
     */
    SummonView.prototype.playIconTween = function () {
        var _this = this;
        egret.Tween.removeTweens(this.group0);
        egret.Tween.removeTweens(this.group1);
        egret.Tween.removeTweens(this.group2);
        egret.Tween.get(this.group0).to({ x: 13 }, 250).call(function () {
            egret.Tween.removeTweens(_this.group0);
        });
        egret.Tween.get(this.group1).to({ x: 13 }, 250).call(function () {
            egret.Tween.removeTweens(_this.group1);
        });
        egret.Tween.get(this.group2).to({ x: 13 }, 250).call(function () {
            egret.Tween.removeTweens(_this.group2);
        });
    };
    /**事件派发调用后 */
    SummonView.prototype.updateitemNum = function () {
        this.basisSummonnum.text = "" + SummonData.inst().GetItemnumByid(2009);
        this.seniorSummonnum.text = "" + SummonData.inst().GetItemnumByid(2010);
        this.friendSummonnum.text = "" + SummonData.inst().GetItemnumByid(2013);
        this.item_number.text = "" + SummonData.inst().GetDiamondnum();
        this.summonexp.max = 1000;
        this.summonexp.value = SummonData.inst().GetSummonScore();
        //按钮的显示
        var showGroup = SummonData.inst().summonbtnshow();
        if (showGroup[0] == 1) {
            this.basisSummonbtn1.visible = true;
            this.timetips0.visible = this.basisSummonbtn3.visible = false;
        }
        else {
            this.basisSummonbtn1.visible = false;
            this.timetips0.visible = this.basisSummonbtn3.visible = true;
        }
        if (showGroup[1] == 1) {
            this.seniorSummonbtn1.visible = true;
            this.timetips1.visible = this.seniorSummonbtn3.visible = false;
        }
        else {
            this.seniorSummonbtn1.visible = false;
            this.timetips1.visible = this.seniorSummonbtn3.visible = true;
        }
        var summon3Tab = ak.JsonTableMgr.get("summon3");
        var summon3Row = summon3Tab.getRow(0);
        var summon4Tab = ak.JsonTableMgr.get("summon4");
        var summon4Row = summon4Tab.getRow(0);
        var seniorSummonbtn2icon = this.seniorSummonbtn2.getChild("icon").asLoader;
        var seniorSummonbtn3icon = this.seniorSummonbtn3.getChild("icon").asLoader;
        var seniorSummonbtn2inumber = this.seniorSummonbtn2.getChild("number").asTextField;
        var seniorSummonbtn3inumber = this.seniorSummonbtn3.getChild("number").asTextField;
        if (showGroup[2] == 1) {
            this.setLoaderUrl(seniorSummonbtn3icon, "ui://common/token_xzyj");
            seniorSummonbtn3inumber.text = "1";
        }
        else {
            this.setLoaderUrl(seniorSummonbtn3icon, "ui://common/token_zs");
            seniorSummonbtn3inumber.text = summon3Row.getValFromColName("Zs"); //"220";
        }
        if (showGroup[3] == 1) {
            this.setLoaderUrl(seniorSummonbtn2icon, "ui://common/token_xzyj");
            seniorSummonbtn2inumber.text = "10";
        }
        else {
            this.setLoaderUrl(seniorSummonbtn2icon, "ui://common/token_zs");
            seniorSummonbtn2inumber.text = summon4Row.getValFromColName("Zs"); //"2000";
        }
    };
    SummonView.prototype.staticView = function () {
        var basisicon = this.basisSummonbtn2.getChild("icon").asLoader;
        var basisico3 = this.basisSummonbtn3.getChild("icon").asLoader;
        var senioricon = this.seniorSummonbtn2.getChild("icon").asLoader;
        var senioricon3 = this.seniorSummonbtn3.getChild("icon").asLoader;
        var friendicon = this.friendSummonbtn2.getChild("icon").asLoader;
        var friendicon1 = this.friendSummonbtn1.getChild("icon").asLoader;
        var basisnumber = this.basisSummonbtn2.getChild("number").asTextField;
        var basisnumber3 = this.basisSummonbtn3.getChild("number").asTextField;
        var seniornumber = this.seniorSummonbtn2.getChild("number").asTextField;
        var seniornumber3 = this.seniorSummonbtn3.getChild("number").asTextField;
        var friendnumber = this.friendSummonbtn2.getChild("number").asTextField;
        var friendnumber1 = this.friendSummonbtn1.getChild("number").asTextField;
        this.setLoaderUrl(basisicon, "ui://common/token_zhyj");
        this.setLoaderUrl(basisico3, "ui://common/token_zhyj");
        this.setLoaderUrl(friendicon1, "ui://common/token_yqyj");
        this.setLoaderUrl(friendicon, "ui://common/token_yqyj");
        basisnumber.text = "10";
        basisnumber3.text = "1";
        seniornumber.text = "2000";
        friendnumber.text = "90";
        friendnumber1.text = "10";
        seniornumber3.text = "220";
        this.summonexp.max = 1000;
        this.summonexp.value = 0;
        this.item_number.text = "0";
    };
    /**倒计时 */
    SummonView.prototype.timeDown = function () {
        var time1 = SummonData.inst().GetTime1();
        var time2 = SummonData.inst().GetTime2();
        var summonTime1 = 0;
        var summonTime2 = 0;
        if (time1 > 0) {
            summonTime1 = time1 - 1;
            this.timetips0.text = DateUtils.getFormatBySecond(summonTime1, DateUtils.TIME_FORMAT_12) + "\u540E\u5237\u65B0";
        }
        else {
            if (!this.basisSummonbtn3.visible) {
                this.updateitemNum();
            }
        }
        if (time2 > 0) {
            summonTime2 = time2 - 1;
            this.timetips1.text = DateUtils.getFormatBySecond(summonTime2, DateUtils.TIME_FORMAT_12) + "\u540E\u5237\u65B0";
        }
        else {
            if (!this.seniorSummonbtn3.visible) {
                this.updateitemNum();
            }
        }
    };
    //销毁回调
    SummonView.prototype.onDestroy = function () {
        //清理
        //this.removeEventListener(egret.Event.ENTER_FRAME,this.timeDown,this);
    };
    return SummonView;
}(ak.EasyUI));
__reflect(SummonView.prototype, "SummonView");
/**
 * 召唤处理
 */
var SummonData = (function () {
    function SummonData() {
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    SummonData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new SummonData();
        }
        return Class._instance;
    };
    /**
     * 判断界面的显示
     * 0,1位判断第一第二个免费按钮是否显示
     * 2,3位判断高级召唤的第一，第二个按钮显示的状态
     * 0,1位[0表示不显示,1表示显示];2,3位[0表示显示道具不足,1表示道具充足]
     * */
    SummonData.prototype.summonbtnshow = function () {
        var showGroup = [];
        if (this.isshowSummon1Time()) {
            showGroup.push(1);
        }
        else {
            showGroup.push(0);
        }
        if (this.isshowSummon3Time()) {
            showGroup.push(1);
        }
        else {
            showGroup.push(0);
        }
        if (this.GetItemnumByid(2010) > 0) {
            showGroup.push(1);
        }
        else {
            showGroup.push(0);
        }
        if (this.GetItemnumByid(2010) > 9) {
            showGroup.push(1);
        }
        else {
            showGroup.push(0);
        }
        return showGroup;
    };
    /**判断是否显示第一个免费 */
    SummonData.prototype.isshowSummon1Time = function () {
        var summonTab1 = ak.JsonTableMgr.get("summon1");
        var freeTime1 = Number(summonTab1.getRowFromColName("id", "" + 1).getValFromColName("freeTime"));
        var dt1 = ak.time() - MyData.user.randCardTime0 + MyData.timeBase;
        if (dt1 >= freeTime1) {
            return true;
        }
        else {
            return false;
        }
    };
    /**判断是否显示第二个免费 */
    SummonData.prototype.isshowSummon3Time = function () {
        var summonTab3 = ak.JsonTableMgr.get("summon3");
        var freeTime3 = Number(summonTab3.getRowFromColName("id", "" + 3).getValFromColName("freeTime"));
        var dt3 = ak.time() - MyData.user.randCardTime1 + MyData.timeBase;
        if (dt3 >= freeTime3) {
            return true;
        }
        else {
            return false;
        }
    };
    /**返回第一个倒计时的时间戳 */
    SummonData.prototype.GetTime1 = function () {
        var summonTab1 = ak.JsonTableMgr.get("summon1");
        var freeTime1 = summonTab1.getRowFromColName("id", "" + 1).getValFromColName("freeTime");
        var dt1 = (new Date().getTime() / 1000) - MyData.user.randCardTime0 + MyData.timeBase;
        if (dt1 >= freeTime1) {
            return 0;
        }
        else {
            var spareTime = freeTime1 - dt1;
            return spareTime;
        }
    };
    /**返回第二个倒计时的时间戳 */
    SummonData.prototype.GetTime2 = function () {
        var summonTab3 = ak.JsonTableMgr.get("summon3");
        var freeTime3 = summonTab3.getRowFromColName("id", "" + 3).getValFromColName("freeTime");
        var dt3 = (new Date().getTime() / 1000) - MyData.user.randCardTime1 + MyData.timeBase;
        if (dt3 >= freeTime3) {
            return 0;
        }
        else {
            var spareTime = freeTime3 - dt3;
            return spareTime;
        }
    };
    /**根据道具id获取当前背包道具数量 */
    SummonData.prototype.GetItemnumByid = function (itemID) {
        for (var key = 0; key < MyData.user.json.itemArr.length; key++) {
            var itemIDs = Number(MyData.user.json.itemArr[key].itemID);
            if (itemID == itemIDs) {
                var count = MyData.user.json.itemArr[key].count;
                return count;
            }
        }
        return 0;
    };
    /**获得钻石数量 */
    SummonData.prototype.GetDiamondnum = function () {
        var num = MyData.user.diamond + MyData.user.diamond2;
        return num;
    };
    /**获得召唤积分 */
    SummonData.prototype.GetSummonScore = function () {
        var num = MyData.user.randCardScore;
        return num;
    };
    SummonData.SUMMONTYPLE_BASIS = 0; //普通召唤类型
    SummonData.SUMMONTYPLE_SENIOR = 1; //高级召唤类型
    SummonData.SUMMONTYPLE_FRIEND = 2; //友情召唤类型
    return SummonData;
}());
__reflect(SummonData.prototype, "SummonData");
/**
 * 超级基金奖励预览系统
 */
var RewardPreViewSystem = (function (_super) {
    __extends(RewardPreViewSystem, _super);
    function RewardPreViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    RewardPreViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("SuperFundView");
    };
    RewardPreViewSystem.inst = new RewardPreViewSystem("SuperFundView");
    return RewardPreViewSystem;
}(ak.FairyGUI));
__reflect(RewardPreViewSystem.prototype, "RewardPreViewSystem");
/**
 * 超级基金奖励预览界面
 */
var RewardPreView = (function (_super) {
    __extends(RewardPreView, _super);
    function RewardPreView() {
        return _super.call(this, RewardPreViewSystem.inst, MyGame.inst.tipLayer) || this;
    }
    RewardPreView.prototype.onInit = function () {
        var ui = this.create("SuperFundView", "RewardPreView");
        this.itemList = ui.getChild("itemList").asList;
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.superFundTab = ak.JsonTableMgr.get("superFund");
        this.ClickAdd();
        this.updateView();
    };
    RewardPreView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.close, this);
        this.onFairyguiEvent(this.itemList, fairygui.ItemEvent.CLICK, this.itemonclick, this);
    };
    RewardPreView.prototype.itemonclick = function (obj) {
        var item = obj.itemObject;
        var itemCom = item.getChild("itemCom").asCom;
        if (this.hitTestPointWithFairyGUIComponent(itemCom, obj.stageX, obj.stageY)) {
            var itemData = itemCom.data;
            if (itemData.item_type == 3)
                ak.FairyGUI.open(["ResourceTipsView", itemData.item_id, itemData.item_count]);
            else
                ak.FairyGUI.open(["WeaponTipsView", itemData.item_id, itemData.item_count, 1]);
        }
    };
    RewardPreView.prototype.updateView = function () {
        this.itemList.removeChildrenToPool();
        var fundType = SuperFundData.inst().getViewType();
        var superFundInfo = this.superFundTab.getRowFromColName("id", fundType.toString());
        for (var i = 1; i <= 30; i++) {
            var item_cfg = superFundInfo.getValFromColName("day" + i);
            var item_type = item_cfg[0];
            var item_id = item_cfg[1];
            var item_count = item_cfg[2];
            var Item = this.itemList.addItemFromPool().asCom;
            var itemCom = Item.getChild("itemCom").asCom;
            var itemBase = new ItemBase(itemCom, this, item_type);
            itemBase.setItemData(Number(item_id));
            itemBase.setNumber(item_count, true);
            itemCom.data = { item_id: item_id, item_count: item_count, item_type: item_type };
            Item.getChild("itemText").asTextField.text = "\u7D2F\u8BA1[color=" + Color.green + "]" + i + "[/color]\u5929";
            var rewardShowArr = superFundInfo.getValFromColName("show");
            var isShowEffect = false;
            for (var j = 0; j < rewardShowArr.length; j++) {
                if (rewardShowArr[j] == i) {
                    isShowEffect = true;
                    break;
                }
            }
            itemBase.isshowLight(isShowEffect);
        }
    };
    return RewardPreView;
}(ak.EasyUI));
__reflect(RewardPreView.prototype, "RewardPreView");
var SuperFundData = (function () {
    function SuperFundData() {
        /**
         * 获取一个单例
         * @returns {any}
         */
        this.viewType = 1;
    }
    SuperFundData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new SuperFundData();
        }
        return Class._instance;
    };
    SuperFundData.prototype.getViewType = function () {
        return this.viewType;
    };
    SuperFundData.prototype.setViewType = function (type) {
        this.viewType = type;
    };
    return SuperFundData;
}());
__reflect(SuperFundData.prototype, "SuperFundData");
/**
 * 超级基金系统
 */
var SuperFundSystem = (function (_super) {
    __extends(SuperFundSystem, _super);
    function SuperFundSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    SuperFundSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("SuperFundView");
    };
    SuperFundSystem.inst = new SuperFundSystem("SuperFundView");
    return SuperFundSystem;
}(ak.FairyGUI));
__reflect(SuperFundSystem.prototype, "SuperFundSystem");
/**
 * 超级基金界面
 */
var SuperFundView = (function (_super) {
    __extends(SuperFundView, _super);
    function SuperFundView(stackView) {
        var _this = _super.call(this, SuperFundSystem.inst, stackView) || this;
        _this.pay = 0;
        return _this;
    }
    SuperFundView.prototype.onInit = function () {
        var ui = this.create("SuperFundView", "SuperFundView");
        this.itemList = ui.getChild("itemList").asList;
        this.btnBuy = ui.getChild("btnBuy").asButton;
        this.btnPreView = ui.getChild("btnPreView").asButton;
        this.superFundTab = ak.JsonTableMgr.get("superFund");
        this.fundTypeController = ui.getController("fundType");
        this.isBuyController = ui.getController("isBuy");
        this.ClickAdd();
        this.updateView();
    };
    SuperFundView.prototype.ClickAdd = function () {
        this.on(GameEvent.changeSuperFundView, this.updateView, this);
        this.addClickListener(this.btnBuy, this.onClickBuy, this);
        this.addClickListener(this.btnPreView, this.onClickRewardPreView, this);
        this.onFairyguiEvent(this.itemList, fairygui.ItemEvent.CLICK, this.itemonclick, this);
        this.btnBuy.touchable = true;
        this.on("netmsg://rechargeDataResult", this.updateView, this);
    };
    SuperFundView.prototype.onClickBuy = function () {
        console.log("充值基金按钮", this.pay);
        net.genPayOrder(this.pay);
    };
    SuperFundView.prototype.onClickRewardPreView = function () {
        ak.FairyGUI.open(["RewardPreView"]);
    };
    SuperFundView.prototype.itemonclick = function (obj) {
        var item = obj.itemObject;
        var itemCom = item.getChild("itemCom").asCom;
        if (this.hitTestPointWithFairyGUIComponent(itemCom, obj.stageX, obj.stageY)) {
            var itemData = itemCom.data;
            if (itemData.item_type == 3)
                ak.FairyGUI.open(["ResourceTipsView", itemData.item_id, itemData.item_count]);
            else
                ak.FairyGUI.open(["WeaponTipsView", itemData.item_id, itemData.item_count, 1]);
        }
    };
    SuperFundView.prototype.updateView = function () {
        var fundType = SuperFundData.inst().getViewType();
        this.fundTypeController.selectedIndex = fundType == 1 ? 0 : 1;
        var superFund = MyData.user.json.superfund;
        var superFundInfo = this.superFundTab.getRowFromColName("id", fundType.toString());
        var total = superFundInfo.getValFromColName("total");
        var getNow = superFundInfo.getValFromColName("zs");
        this.ui.getChild("total").asTextField.text = "" + total;
        this.ui.getChild("getNow").asTextField.text = "" + getNow;
        if (fundType == 1) {
            this.isBuyController.selectedIndex = (superFund.recvCount1 != 1) ? 0 : 1;
        }
        else {
            this.isBuyController.selectedIndex = (superFund.recvCount2 != 1) ? 0 : 1;
        }
        this.itemList.removeChildrenToPool();
        var rewardShowArr = superFundInfo.getValFromColName("show");
        this.pay = superFundInfo.getValFromColName("pay");
        for (var i = 0; i < rewardShowArr.length; i++) {
            var item_cfg = superFundInfo.getValFromColName("day" + rewardShowArr[i]);
            var item_type = item_cfg[0];
            var item_id = item_cfg[1];
            var item_count = item_cfg[2];
            var Item = this.itemList.addItemFromPool().asCom;
            var itemCom = Item.getChild("itemCom").asCom;
            var itemBase = new ItemBase(itemCom, this, item_type);
            itemBase.setItemData(Number(item_id));
            itemBase.setNumber(item_count, true);
            itemCom.data = { item_id: item_id, item_count: item_count, item_type: item_type };
            this.btnBuy.getChild("title").asTextField.text = Common.getMoneyByPayID(this.pay) + "元";
            Item.getChild("itemText").asTextField.text = "\u7D2F\u8BA1[color=" + Color.green + "]" + rewardShowArr[i] + "[/color]\u5929";
        }
    };
    return SuperFundView;
}(ak.EasyUI));
__reflect(SuperFundView.prototype, "SuperFundView");
//主界面
var TaskView = (function (_super) {
    __extends(TaskView, _super);
    function TaskView(index) {
        var _this = _super.call(this, TavernViewSystem.inst, MyGame.inst.uiLayer2) || this;
        _this.selectRace = 0;
        _this.num = 0;
        //英雄出战
        _this.selectCardArrIndex = [];
        _this.selectListIndex = [];
        _this.taskIndex = index;
        return _this;
    }
    //初始化回调
    TaskView.prototype.onInit = function () {
        this.ui = this.create("TavernView", "TaskView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.heroList = this.ui.getChild("n23").asList;
        this.queryList = this.ui.getChild("n43").asList;
        this.raceList = this.ui.getChild("n40").asList;
        this.jifen = this.ui.getChild("n28").asTextField;
        this.oneKeyChuZhan = this.ui.getChild("n36").asButton;
        this.paiqian = this.ui.getChild("n35").asButton;
        this.tavernTab = ak.JsonTableMgr.get("tavern");
        this.onEgretEvent(this.ui.getChild("n25").asCom.getController("qiehuan"), fairygui.StateChangeEvent.CHANGED, this.changeTab, this);
        this.clickAdd();
        this.showHeroData();
        this.showTavernData();
        this.paiqian.enabled = false;
    };
    //更换了种族
    TaskView.prototype.changeTab = function () {
        this.selectRace = this.ui.getChild("n25").asCom.getController("qiehuan").selectedIndex;
        this.showHeroData();
    };
    TaskView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this); //关闭界面
        this.addClickListener(this.oneKeyChuZhan, this.onClick, this); //一键出战
        this.addClickListener(this.paiqian, this.onClick, this); //派遣
    };
    TaskView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.oneKeyChuZhan:
                this.oneKeyChuZhanAffirm();
                break;
            case this.paiqian:
                this.paiqianAffirm(); //派遣
                break;
        }
    };
    //一键出战
    TaskView.prototype.oneKeyChuZhanAffirm = function () {
        this.selectCardArrIndex = [];
        var pubTask = MyData.user.json.pub.taskArr[this.taskIndex];
        var tavernID = pubTask.tavernID;
        this.cardCount = pubTask.cardCount;
        var raceIDArr = pubTask.raceIDArr;
        var starMax = pubTask.starMax;
        var passMap = {};
        var count = this.cardArr.length;
        var num = 0;
        //判断星级种族同时存在再放入
        for (var i = count - 1; i > 0; i--) {
            var index = this.cardArr[i][0];
            var pubTaskID = this.cardArr[i][1].pubTaskID;
            var race = this.cardArr[i][1].race;
            if (!pubTaskID) {
                var starMaxS = this.cardArr[i][1].starMax;
                var pass = raceIDArr.indexOf(race);
                if (starMax <= starMaxS && !passMap["starMax"] && pass != -1) {
                    var item = this.queryList.getChildAt(0).asCom;
                    item.data = index;
                    passMap["starMax"] = race;
                    passMap[race] = index;
                    this.selectCardArrIndex.push(index);
                    num++;
                }
            }
        }
        //再放入种族
        for (var i = count - 1; i > 0; i--) {
            var index = this.cardArr[i][0];
            var pubTaskID = this.cardArr[i][1].pubTaskID;
            if (!pubTaskID) {
                var race = this.cardArr[i][1].race;
                var raceS = passMap["starMax"];
                if (raceS != race) {
                    var arr = Object.keys(passMap);
                    var arrCount = arr.length;
                    var newArr = arr.map(Number);
                    var passRace = newArr.indexOf(race);
                    if (passRace == -1) {
                        var pass = raceIDArr.indexOf(race);
                        if (pass != -1) {
                            passMap[race] = index;
                            this.selectCardArrIndex.push(index);
                            var item = this.queryList.getChildAt(num).asCom;
                            item.data = index;
                            num++;
                        }
                    }
                }
                else {
                    var starMaxS = this.cardArr[i][1].starMax;
                    if (starMax <= starMaxS && !passMap["starMax"]) {
                        passMap["starMax"] = race;
                        passMap[race] = index;
                        this.selectCardArrIndex.push(index);
                        var item = this.queryList.getChildAt(num).asCom;
                        item.data = index;
                        num++;
                    }
                }
            }
        }
        this.showHeroData();
        this.updateHeroOut();
    };
    //派遣
    TaskView.prototype.paiqianAffirm = function () {
        var _this = this;
        if (this.paiqianPass) {
            if (MyData.user.offerScore >= this.needJifen) {
                net.pubBeginTask(this.taskIndex, this.selectCardArrIndex, function () {
                    TipsViewSystem.show("接受酒馆任务成功");
                    ak.EventMgr.dispatch(GameEvent.tavernViewList);
                    _this.close();
                }, this);
            }
            else {
                TipsViewSystem.show("悬赏积分不足");
            }
        }
        else {
            TipsViewSystem.show("派遣条件不满足");
        }
    };
    TaskView.prototype.showHeroData = function () {
        this.num = 0;
        this.selectListIndex = [];
        this.cardArr = HeroBagData.cardArr();
        this.cardArr.sort(this.cardArrStarSort);
        this.cardArr.sort(this.cardArrPubTaskIDSort);
        this.heroList.setVirtual();
        this.heroList.itemRenderer = this.updateList.bind(this);
        this.heroList.callbackThisObj = this;
        //this.heroList.numItems = this.cardArr.length;
        this.showCardArr = [];
        var count = this.cardArr.length;
        for (var i = 0; i < count; i++) {
            if (this.selectRace) {
                var race = this.cardArr[i][1].race;
                if (this.selectRace == race) {
                    this.showCardArr.push(this.cardArr[i]);
                }
            }
            else {
                this.showCardArr.push(this.cardArr[i]);
            }
        }
        this.heroList.numItems = this.showCardArr.length;
    };
    TaskView.prototype.updateList = function (i, item) {
        var heroID = this.showCardArr[i][1].heroID;
        var starMax = this.showCardArr[i][1].starMax;
        var race = this.showCardArr[i][1].race;
        var pubTaskID = this.showCardArr[i][1].pubTaskID;
        var cardIndex = this.showCardArr[i][0];
        if (this.selectRace) {
            if (this.selectRace == race) {
                item.data = cardIndex;
                item._id = i + "";
                var itemBase = new ItemBase(item, this, 2);
                itemBase.setItemData(heroID, race, starMax);
                var pass = this.selectCardArrIndex.indexOf(cardIndex);
                if (pass == -1) {
                    itemBase.setGou(false);
                }
                else {
                    itemBase.setGou(true);
                    this.selectListIndex.push(i);
                }
                if (pubTaskID) {
                    itemBase.setGou(true);
                }
            }
        }
        else {
            item.data = cardIndex;
            item._id = i + "";
            var itemBase = new ItemBase(item, this, 2);
            itemBase.setItemData(heroID, race, starMax);
            var pass = this.selectCardArrIndex.indexOf(cardIndex);
            if (pass == -1) {
                itemBase.setGou(false);
            }
            else {
                itemBase.setGou(true);
                this.selectListIndex.push(i);
            }
            if (pubTaskID) {
                itemBase.setGou(true);
            }
        }
        this.onFairyguiEvent(this.heroList, fairygui.ItemEvent.CLICK, this.heroInto, this);
    };
    TaskView.prototype.heroInto = function (obj) {
        var cardIndex = Number(obj.itemObject.data);
        var cardArr = MyData.user.json.cardArr;
        var cardInfo = cardArr[cardIndex];
        var pubTaskID = cardInfo.pubTaskID;
        if (pubTaskID) {
            TipsViewSystem.show("卡牌已上阵");
            return false;
        }
        var count = Number(obj.itemObject._id);
        for (var i = 0; i < this.heroList.numChildren; i++) {
            var item = this.heroList.getChildAt(i).asCom;
            var id = Number(item.id);
            if (id == count) {
                var itemBase = new ItemBase(item, this, 2);
                var pass = this.selectCardArrIndex.indexOf(cardIndex);
                if (pass == -1) {
                    if (this.selectCardArrIndex.length < this.cardCount) {
                        itemBase.setGou(true);
                        this.selectCardArrIndex.push(cardIndex);
                        this.selectListIndex.push(count);
                    }
                }
                else {
                    itemBase.setGou(false);
                    this.selectCardArrIndex.splice(pass, 1);
                    this.selectListIndex.splice(pass);
                }
                this.updateHeroOut();
                break;
            }
        }
    };
    //更新出战英雄
    TaskView.prototype.updateHeroOut = function () {
        var cardArr = MyData.user.json.cardArr;
        var count = this.selectCardArrIndex.length;
        for (var i = 0; i < this.cardCount; i++) {
            var item = this.queryList.getChildAt(i).asCom;
            var itemBase = new ItemBase(item, this, 2);
            if (i < count) {
                var cardIndex = this.selectCardArrIndex[i];
                var cardInfo = cardArr[cardIndex];
                var heroID = cardInfo.heroID;
                var race = cardInfo.race;
                var starMax = cardInfo.starMax;
                item.data = cardIndex;
                itemBase.setItemData(heroID, race, starMax);
            }
            else {
                itemBase.clear2();
            }
            this.onEgretEvent(item, egret.TouchEvent.TOUCH_TAP, this.outHero, this);
        }
        this.cardCondition();
    };
    TaskView.prototype.cardCondition = function () {
        var json = MyData.user.json;
        var pubTask = json.pub.taskArr[this.taskIndex];
        var starMax = pubTask.starMax;
        var raceIDArr = pubTask.raceIDArr;
        var cardArr = json.cardArr;
        var passMap = {};
        var count = this.selectCardArrIndex.length;
        for (var i = 0; i < count; i++) {
            var index = this.selectCardArrIndex[i];
            var cardInfo = cardArr[index];
            var race = cardInfo.race;
            var starMaxS = cardInfo.starMax;
            var pass = raceIDArr.indexOf(race);
            if (pass != -1) {
                passMap[race] = true;
            }
            if (starMax <= starMaxS) {
                passMap["starMax"] = true;
            }
        }
        var starItem = this.raceList.getChildAt(0).asCom;
        if (passMap["starMax"]) {
            starItem.enabled = true;
        }
        else {
            starItem.enabled = false;
        }
        var arr = Object.keys(passMap);
        var arrCount = arr.length;
        var raceIDCount = raceIDArr.length;
        for (var i = 0; i < raceIDCount; i++) {
            var raceItem = this.raceList.getChildAt(i + 1).asCom;
            var newArr = arr.map(Number);
            var pass = newArr.indexOf(raceIDArr[i]);
            if (pass != -1) {
                raceItem.enabled = true;
            }
            else {
                raceItem.enabled = false;
            }
        }
        if (arrCount == raceIDCount + 1) {
            this.paiqianPass = true;
            this.paiqian.enabled = true;
            this.ui.getController("color").selectedIndex = 1;
        }
        else {
            this.paiqianPass = false;
            this.paiqian.enabled = false;
            this.ui.getController("color").selectedIndex = 0;
        }
    };
    //卸掉出战英雄
    TaskView.prototype.outHero = function (obj) {
        var cardIndex = obj.target.data;
        var pass = this.selectCardArrIndex.indexOf(cardIndex);
        if (pass != -1) {
            var listIndex = this.selectListIndex[pass];
            var selectItem = this.heroList.getChildAt(listIndex).asCom;
            var itemBase = new ItemBase(selectItem, this, 2);
            itemBase.setGou(false);
            this.selectCardArrIndex.splice(pass, 1);
            this.selectListIndex.splice(pass, 1);
            this.showHeroData();
        }
        this.updateHeroOut();
    };
    TaskView.prototype.showTavernData = function () {
        var pubTask = MyData.user.json.pub.taskArr[this.taskIndex];
        var tavernID = pubTask.tavernID;
        this.cardCount = pubTask.cardCount;
        var raceIDArr = pubTask.raceIDArr;
        var starMax = pubTask.starMax;
        var tavernInfo = this.tavernTab.getRowFromColName("id", tavernID);
        this.needJifen = Number(tavernInfo.getValFromColName("jifen")); //消耗积分
        var time = Number(tavernInfo.getValFromColName("time")); //消耗时间（秒）
        var star = Number(tavernInfo.getValFromColName("star")); //星级条件
        //时间
        var hour = (time / 60 / 60) + "小时";
        this.ui.getChild("n30").asTextField.text = hour;
        //积分
        this.jifen.text = MyData.user.offerScore + "/" + this.needJifen;
        //种族
        this.queryList.removeChildrenToPool();
        for (var i = 0; i < this.cardCount; i++) {
            this.queryList.addItemFromPool().asCom;
        }
        //星级
        this.raceList.removeChildrenToPool();
        var starItem = this.raceList.addItemFromPool().asCom;
        starItem.getController("c1").selectedIndex = (star);
        starItem.enabled = false;
        var count = raceIDArr.length;
        for (var i = 0; i < count; i++) {
            var raceItem = this.raceList.addItemFromPool("ui://icm1v6zys1zr89").asCom;
            raceItem.getController("c1").selectedIndex = (raceIDArr[i]);
            raceItem.enabled = false;
        }
    };
    /**
     * 星级排序（大到小）
     */
    TaskView.prototype.cardArrStarSort = function (a, b) {
        var astarMax = a[1].starMax;
        var bstarMax = b[1].starMax;
        var aheroID = a[1].heroID;
        var bheroID = b[1].heroID;
        if (astarMax < bstarMax)
            return 1;
        if (astarMax > bstarMax)
            return -1;
        if (astarMax == bstarMax) {
            if (aheroID < bheroID)
                return 1;
            if (aheroID > bheroID)
                return -1;
        }
        return 0;
    };
    /**
     * 已酒馆出战
     */
    TaskView.prototype.cardArrPubTaskIDSort = function (a, b) {
        var aPubTaskID = a[1].pubTaskID;
        var bPubTaskID = b[1].pubTaskID;
        var astarMax = a[1].starMax;
        var bstarMax = b[1].starMax;
        if (aPubTaskID < bPubTaskID)
            return -1;
        if (aPubTaskID > bPubTaskID)
            return 1;
        if (aPubTaskID == bPubTaskID) {
            if (astarMax < bstarMax)
                return 1;
            if (astarMax > bstarMax)
                return -1;
            var aheroID = a[1].heroID;
            var bheroID = b[1].heroID;
            if (astarMax == bstarMax) {
                if (aheroID < bheroID)
                    return 1;
                if (aheroID > bheroID)
                    return -1;
            }
        }
        return 0;
    };
    return TaskView;
}(ak.EasyUI));
__reflect(TaskView.prototype, "TaskView");
//酒馆
var TavernViewSystem = (function (_super) {
    __extends(TavernViewSystem, _super);
    function TavernViewSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TavernViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("TavernView");
    };
    TavernViewSystem.inst = new TavernViewSystem("TavernView");
    return TavernViewSystem;
}(ak.FairyGUI));
__reflect(TavernViewSystem.prototype, "TavernViewSystem");
//主界面
var TavernView = (function (_super) {
    __extends(TavernView, _super);
    function TavernView() {
        var _this = _super.call(this, TavernViewSystem.inst, MyGame.inst.uiLayer2) || this;
        _this.timer = new ak.Timer();
        //战斗
        _this.sIndex = -1; //任务数组下标
        _this.listIndex = -1; //列表下标
        return _this;
    }
    //初始化回调
    TavernView.prototype.onInit = function () {
        this.ui = this.create("TavernView", "TavernView");
        this.on(GameEvent.tavernViewList, this.paiqianStatus, this);
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.bgclose1 = this.ui.getChild("bgclose1").asLoader;
        this.tavernList = this.ui.getChild("n12").asList;
        this.jifen = this.ui.getChild("n20").asProgress;
        this.bangzu = this.ui.getChild("n14").asButton;
        this.shuaxin = this.ui.getChild("n15").asButton;
        this.shuaxinZ = this.ui.getChild("n21").asButton;
        this.shuaxinConfirm = this.ui.getChild("n29").asButton;
        this.quxiao = this.ui.getChild("n30").asButton;
        this.showTip = this.ui.getChild("n32").asLoader;
        this.itemTab = ak.JsonTableMgr.get("item");
        this.barrierConfigTab = ak.JsonTableMgr.get("barrierConfig");
        this.tavernTab = ak.JsonTableMgr.get("tavern");
        this.tavernConfigTab = ak.JsonTableMgr.get("tavernConfig");
        this.dropTab = ak.JsonTableMgr.get("drop");
        this.dropGroupTab = ak.JsonTableMgr.get("dropGroup");
        this.heroTab = ak.JsonTableMgr.get("hero");
        this.itemPieceTab = ak.JsonTableMgr.get("itemPiece");
        this.ResourceTab = ak.JsonTableMgr.get("Resource");
        this.clickAdd();
        this.showTavernList();
        this.showShuxinBtn();
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.onEnterFrame, this);
    };
    TavernView.prototype.onEnterFrame = function () {
        if (this.timer.getTime() >= 1000) {
            this.timer.reset();
            this.showTime();
        }
    };
    TavernView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this); //关闭界面
        this.addClickListener(this.bgclose1, this.onClick, this); //关闭刷新确认界面
        this.addClickListener(this.shuaxin, this.onClick, this); //刷新确认界面
        this.addClickListener(this.shuaxinZ, this.onClick, this); //刷新确认界面
        this.addClickListener(this.bangzu, this.onClick, this); //帮助
        this.addClickListener(this.shuaxinConfirm, this.onClick, this); //刷新
        this.addClickListener(this.quxiao, this.onClick, this); //关闭刷新确认界面
        this.onEgretEvent(this.showTip, egret.TouchEvent.TOUCH_BEGIN, this.showSkillDataStartNext, this);
        this.onEgretEvent(this.showTip, egret.TouchEvent.TOUCH_RELEASE_OUTSIDE, this.showSkillDataMove, this);
        this.onEgretEvent(this.showTip, egret.TouchEvent.TOUCH_END, this.showSkillDataEnd, this);
    };
    TavernView.prototype.onClick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.shuaxinZ:
            case this.shuaxin:
                var pass = this.ifShuaxin();
                if (!pass) {
                    net.pubFlush(function () {
                        _this.showTavernList();
                        _this.showShuxinBtn();
                    }, this);
                }
                break;
            case this.shuaxinConfirm:
                net.pubFlush(function () {
                    _this.showTavernList();
                    _this.showShuxinBtn();
                    _this.ui.getController("c2").selectedIndex = 0;
                }, this);
                break;
            case this.bangzu:
                ak.FairyGUI.open(["HelpTipsView", 4]);
                break;
            case this.bgclose1:
            case this.quxiao:
                this.ui.getController("c2").selectedIndex = 0;
                break;
        }
    };
    //显示技能按下
    TavernView.prototype.showSkillDataStartNext = function (evt) {
        this.ui.getController("showTip").selectedIndex = (1);
        var result = Vip.getRight(202);
        if (result) {
            this.ui.getChild("n37").asTextField.text = "已激活";
        }
        else {
            this.ui.getChild("n37").asTextField.text = "未激活";
        }
        var result1 = Vip.getRight(203);
        if (result1) {
            this.ui.getChild("n40").asTextField.text = "已激活";
        }
        else {
            this.ui.getChild("n40").asTextField.text = "未激活";
        }
    };
    //显示技能区域外的释放事件
    TavernView.prototype.showSkillDataMove = function () {
        this.ui.getController("showTip").selectedIndex = (0);
    };
    //显示技能结束
    TavernView.prototype.showSkillDataEnd = function () {
        this.ui.getController("showTip").selectedIndex = (0);
    };
    //派遣刷新状态
    TavernView.prototype.paiqianStatus = function () {
        var taskArr = MyData.user.json.pub.taskArr;
        this.taskArrN[this.listIndex][1].status = taskArr[this.sIndex].status;
        this.taskArrN[this.listIndex][1].time = taskArr[this.sIndex].time;
        this.jifen.value = MyData.user.offerScore;
        this.showTime();
    };
    //确认是否刷新
    TavernView.prototype.ifShuaxin = function () {
        var pass = 0;
        var count = this.taskArr.length;
        for (var i = 0; i < count; i++) {
            var status_6 = this.taskArr[i].status;
            if (!status_6) {
                var tavernID = this.taskArr[i].tavernID;
                var tavernInfo = this.tavernTab.getRowFromColName("id", tavernID);
                var color = Number(tavernInfo.getValFromColName("color")); //颜色
                if (color >= 3) {
                    pass = 1;
                }
            }
        }
        this.ui.getController("c2").selectedIndex = pass;
        return pass;
    };
    //任务排序
    TavernView.prototype.taskArrNew = function () {
        this.taskArrN = [];
        for (var i = 0; i < this.taskArr.length; i++) {
            this.taskArrN.push([i, this.taskArr[i]]);
        }
    };
    TavernView.prototype.showTavernList = function () {
        var info = this.barrierConfigTab.getRow(0);
        var maxScroe = Number(info.getValFromColName("maxScroe")); //悬赏积分最大值
        this.jifen.max = maxScroe;
        this.jifen.value = MyData.user.offerScore;
        this.tavernList.removeChildrenToPool();
        var pub = MyData.user.json.pub;
        this.taskArr = pub.taskArr;
        var count = this.taskArr.length;
        this.taskArrNew();
        this.taskArrN.sort(this.taskArrStatusSort);
        this.taskArrN.sort(this.taskArrFinishSort);
        for (var j = 0; j < count; j++) {
            var index = this.taskArrN[j][0];
            for (var i = 0; i < count; i++) {
                if (index == i) {
                    var taskInfo = this.taskArr[i];
                    var tavernID = taskInfo.tavernID;
                    var status_7 = taskInfo.status; //任务状态
                    var time = taskInfo.time; //任务开启时间
                    var tavernInfo = this.tavernTab.getRowFromColName("id", tavernID);
                    var name_29 = tavernInfo.getValFromColName("name"); //任务名称
                    var color = Number(tavernInfo.getValFromColName("color")); //颜色
                    var jifen = tavernInfo.getValFromColName("jifen"); //消耗积分
                    var consumeTime = Number(tavernInfo.getValFromColName("time")); //消耗时间（秒）
                    var drop = tavernInfo.getValFromColName("drop"); //掉落奖励
                    var taskFrame = this.tavernList.addItemFromPool().asCom;
                    taskFrame.data = i;
                    taskFrame._id = j + "";
                    var item = taskFrame.getChild("n9").asCom;
                    var arr = ItemMgr.getDropGroupByID(drop);
                    var type = Number(arr[0][1]);
                    var itemid = arr[0][2];
                    var count_6 = arr[0][3];
                    var itemBase = new ItemBase(item, this, type);
                    itemBase.isShowPiece(false);
                    itemBase.setStar2(0);
                    itemBase.setItemData(Number(itemid));
                    if (type == 2) {
                        var heroInfo = this.heroTab.getRowFromColName("id", "" + itemid);
                        var race = heroInfo.getValFromColName("race"); //最高可升级
                        var star = heroInfo.getValFromColName("star"); //最高可升级
                        itemBase.setItemData(Number(itemid), race, star);
                    }
                    itemBase.setNumber(count_6, true);
                    taskFrame.getController("lv").selectedIndex = (color);
                    taskFrame.getChild("n8").asTextField.text = name_29;
                    taskFrame.getChild("n18").asTextField.text = jifen;
                }
            }
        }
        this.showTime();
        this.onFairyguiEvent(this.tavernList, fairygui.ItemEvent.CLICK, this.taskCaozuo, this);
    };
    TavernView.prototype.taskCaozuo = function (obj) {
        var _this = this;
        var item = obj.itemObject;
        this.sIndex = item.data;
        this.listIndex = Number(item._id);
        if (this.hitTestPointWithFairyGUIComponent(item.getChild("n12").asCom, obj.stageX, obj.stageY)) {
            ak.FairyGUI.open(["TaskView", this.sIndex]); //派遣
        }
        else if (this.hitTestPointWithFairyGUIComponent(item.getChild("n13").asCom, obj.stageX, obj.stageY)) {
            net.pubEndTask(this.sIndex, function () {
                _this.showTavernList(); //领取
            }, this);
        }
        else if (this.hitTestPointWithFairyGUIComponent(item.getChild("n16").asCom, obj.stageX, obj.stageY)) {
            net.pubEndTaskQuick(this.sIndex, function () {
                _this.showTavernList(); //加速
            }, this);
        }
    };
    //排序(可接取-进行中)
    TavernView.prototype.taskArrStatusSort = function (a, b) {
        var aStatus = a[1].status; //任务状态
        var bStatus = b[1].status;
        if (aStatus < bStatus)
            return -1;
        if (aStatus > bStatus)
            return 1;
        if (aStatus == bStatus)
            return 0;
    };
    //排序(已完成-可接取-进行中)
    TavernView.prototype.taskArrFinishSort = function (a, b) {
        var tavernTab = ak.JsonTableMgr.get("tavern");
        var aStatus = a[1].status; //任务状态
        var bStatus = b[1].status;
        var atime = a[1].time; //任务开启时间
        var btime = b[1].time;
        var atavernID = a[1].tavernID;
        var btavernID = b[1].tavernID;
        var atavernInfo = tavernTab.getRowFromColName("id", atavernID);
        var btavernInfo = tavernTab.getRowFromColName("id", btavernID);
        var aconsumeTime = Number(atavernInfo.getValFromColName("time")); //消耗时间（秒）
        var bconsumeTime = Number(btavernInfo.getValFromColName("time")); //消耗时间（秒）
        var now = ak.time() + MyData.timeBase; //当前时间戳 + 本地与服务器时间差
        var apastTime = atime + aconsumeTime; //任务结束时间
        var bpastTime = btime + bconsumeTime; //任务结束时间
        var aPass = 1;
        var bPass = 1;
        if (apastTime < now) {
            aPass = 0;
        }
        if (bpastTime < now) {
            bPass = 0;
        }
        if (aPass < bPass)
            return -1;
        if (aPass > bPass)
            return 1;
        if (aPass == bPass) {
            if (aStatus < bStatus)
                return 1;
            if (aStatus > bStatus)
                return -1;
        }
        return 0;
    };
    //更新刷新任务按钮
    TavernView.prototype.showShuxinBtn = function () {
        var pub = MyData.user.json.pub;
        var flushCount = pub.flushCount; //当日刷新次数
        var info = this.tavernConfigTab.getRow(0);
        var freeNum = Number(info.getValFromColName("freeNum")); //每日免费刷新次数
        if (flushCount >= freeNum) {
            this.ui.getController("c1").selectedIndex = 1;
            var itemID = Number(info.getValFromColName("item")); //刷新道具
            var itemNum = Number(info.getValFromColName("itemNum")); //道具数量
            var itemArr = MyData.user.json.itemArr;
            var count = itemArr.length;
            var pass = true;
            for (var i = 0; i < count; i++) {
                var itemInfo = itemArr[i];
                var itemIDS = itemInfo.itemID;
                var itemIDCount = itemInfo.count;
                if (itemID == itemIDS && itemIDCount >= itemNum) {
                    pass = false;
                    this.shuaxinZ.title = "刷新";
                    this.ui.getChild("n18").asTextField.text = itemIDCount;
                    this.shuaxinZ.getChild("number").text = itemIDCount;
                    this.setLoaderUrl(this.shuaxinZ.getChild("icon").asLoader, "item_2014_png");
                }
            }
            if (pass) {
                var zs = info.getValFromColName("zs"); //刷新钻石
                this.shuaxinZ.getChild("number").text = zs;
                this.setLoaderUrl(this.shuaxinZ.getChild("icon").asLoader, "rmbmoney_png");
            }
        }
        else {
            var itemID = Number(info.getValFromColName("item")); //刷新道具
            var itemNum = Number(info.getValFromColName("itemNum")); //道具数量
            var itemArr = MyData.user.json.itemArr;
            var count = itemArr.length;
            for (var i = 0; i < count; i++) {
                var itemInfo = itemArr[i];
                var itemIDS = itemInfo.itemID;
                var itemIDCount = itemInfo.count;
                if (itemID == itemIDS && itemIDCount >= itemNum) {
                    this.ui.getChild("n18").asTextField.text = itemIDCount;
                }
            }
        }
    };
    //时间状态
    TavernView.prototype.showTime = function () {
        var tavernConfigInfo = this.tavernConfigTab.getRow(0);
        var count = this.taskArr.length;
        for (var i = 0; i < count; i++) {
            var taskInfo = this.taskArrN[i][1];
            var tavernID = taskInfo.tavernID;
            var status_8 = taskInfo.status; //任务状态
            var time = taskInfo.time; //任务开启时间
            var tavernInfo = this.tavernTab.getRowFromColName("id", tavernID);
            var consumeTime = Number(tavernInfo.getValFromColName("time")); //消耗时间（秒）
            var taskFrame = this.tavernList.getChildAt(i).asCom;
            if (status_8) {
                var now = ak.time() + MyData.timeBase; //当前时间戳 + 本地与服务器时间差
                var pastTime = time + consumeTime; //任务结束时间
                if (pastTime >= now) {
                    taskFrame.getController("finish").selectedIndex = (status_8);
                    var residueTime = pastTime - now; //剩余时间
                    taskFrame.getChild("n15").asTextField.text = DateUtils.getFormatBySecond(residueTime, DateUtils.TIME_FORMAT_12);
                    var passTime1 = consumeTime - residueTime; //经过时间
                    taskFrame.getChild("n22").asProgress.max = consumeTime;
                    taskFrame.getChild("n22").asProgress.value = passTime1;
                    taskFrame.getChild("n22").asProgress.getChild("title").visible = false;
                    var hour = residueTime / 60 / 60;
                    var arr = [0, 2, 4, 6, 8, 10, 12, 14, 999];
                    var id = 1;
                    for (var i_10 = 0; i_10 < arr.length; i_10++) {
                        if (arr[i_10] <= hour && hour <= arr[i_10 + 1]) {
                            var zaID = tavernConfigInfo.getValFromColName("zs" + id); //加速消耗钻石
                            taskFrame.getChild("n16").asButton.getChild("number").asTextField.text = zaID;
                        }
                        else {
                            id++;
                        }
                    }
                }
                else {
                    taskFrame.getController("finish").selectedIndex = 2;
                }
            }
            else {
                taskFrame.getController("finish").selectedIndex = (status_8);
            }
        }
    };
    return TavernView;
}(ak.EasyUI));
__reflect(TavernView.prototype, "TavernView");
var TipsView1 = (function () {
    function TipsView1() {
    }
    return TipsView1;
}());
__reflect(TipsView1.prototype, "TipsView1");
var PreciousShowViewSystem = (function (_super) {
    __extends(PreciousShowViewSystem, _super);
    function PreciousShowViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    PreciousShowViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("TowerView");
    };
    PreciousShowViewSystem.inst = new PreciousShowViewSystem("TowerView");
    return PreciousShowViewSystem;
}(ak.FairyGUI));
__reflect(PreciousShowViewSystem.prototype, "PreciousShowViewSystem");
/**
 * 爬塔系统
 */
var PreciousShowView = (function (_super) {
    __extends(PreciousShowView, _super);
    function PreciousShowView(dropID) {
        var _this = _super.call(this, TowerViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.idGroup = [];
        _this.dropID = 0;
        _this.dropID = dropID;
        return _this;
    }
    /**回调 */
    PreciousShowView.prototype.onInit = function () {
        var ui = this.create("TowerView", "PreciousShowView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.list = ui.getChild("list").asList;
        this.ClickAdd();
        this.listShow();
    };
    PreciousShowView.prototype.ClickAdd = function () {
        var _this = this;
        this.addClickListener(this.bgclose, function () { _this.close(); }, this);
    };
    PreciousShowView.prototype.listShow = function () {
        this.list.removeChildrenToPool();
        var itemGroup = ItemMgr.getDropGroupByID(this.dropID);
        ak.log(itemGroup);
        for (var i = 0; i < itemGroup.length; i++) {
            var item = this.list.addItemFromPool("ui://icm1v6zy9qs54b").asCom;
            var items = new ItemBase(item, this, itemGroup[i][1]);
            items.setItemData(itemGroup[i][2]);
            items.setNumber(itemGroup[i][3], true);
        }
    };
    return PreciousShowView;
}(ak.EasyUI));
__reflect(PreciousShowView.prototype, "PreciousShowView");
/**
 * 爬塔数据
 */
var TowerData = (function () {
    function TowerData() {
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    TowerData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new TowerData();
        }
        return Class._instance;
    };
    TowerData.prototype.towerMax = function () {
        var towerTab = ak.JsonTableMgr.get("tower");
        var max = towerTab.size();
        return max;
    };
    /**根据id获取该层 */
    TowerData.prototype.GetTowerInfoById = function (towerID) {
        var towerTab = ak.JsonTableMgr.get("tower");
        var towerInfo = towerTab.getRowFromColName("id", "" + towerID);
        var model = towerInfo.getValFromColName("model");
        var bossID = towerInfo.getValFromColName("bossID");
        var fightMap = towerInfo.getValFromColName("fightMap");
        var drop = towerInfo.getValFromColName("drop");
        var info = { model: model, bossID: bossID, fightMap: fightMap, drop: drop };
        return info;
    };
    /**爬塔材料info */
    TowerData.prototype.GetConfigInfo = function () {
        var towerConfigTab = ak.JsonTableMgr.get("towerConfig");
        var towerConfigInfo = towerConfigTab.getRow(0);
        var Resource = towerConfigInfo.getValFromColName("Resource");
        var maxNum = towerConfigInfo.getValFromColName("maxNum");
        var time = towerConfigInfo.getValFromColName("time");
        var buy = towerConfigInfo.getValFromColName("buy");
        var info = { Resource: Resource, maxNum: maxNum, time: time, buy: buy };
        return info;
    };
    return TowerData;
}());
__reflect(TowerData.prototype, "TowerData");
var TowerViewSystem = (function (_super) {
    __extends(TowerViewSystem, _super);
    function TowerViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    TowerViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("TowerView");
    };
    TowerViewSystem.inst = new TowerViewSystem("TowerView");
    return TowerViewSystem;
}(ak.FairyGUI));
__reflect(TowerViewSystem.prototype, "TowerViewSystem");
/**
 * 爬塔系统
 */
var TowerView = (function (_super) {
    __extends(TowerView, _super);
    function TowerView() {
        var _this = _super.call(this, TowerViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
        _this.heroNode = [];
        _this.idGroup = [];
        /**新界面 */
        _this.comInfo = [];
        _this.comMC_x = [{ star: 93, final: 640 }, { star: 383, final: 93 }, { star: 117, final: 383 }, { star: 319, final: 117 }];
        _this.comMC_y = [{ star: 322, final: 1136 }, { star: 297, final: 322 }, { star: 305, final: 297 }, { star: 283, final: 305 }];
        _this.comMC_aph = [{ star: 1, final: 1 }, { star: 0.9, final: 1 }, { star: 0.7, final: 0.9 }, { star: 0.7, final: 0.7 }];
        _this.comMC_scaleX = [{ star: 1, final: 1 }, { star: 0.5, final: 1 }, { star: 0.35, final: 0.5 }, { star: 0.2, final: 0.35 }];
        _this.comMC_scaleY = [{ star: 1, final: 1 }, { star: 0.5, final: 1 }, { star: 0.35, final: 0.5 }, { star: 0.2, final: 0.35 }];
        /**更新列表id */
        _this.towersign = 7;
        /**更新资源数量 */
        _this.ResNum = 10;
        return _this;
    }
    /**回调 */
    TowerView.prototype.onInit = function () {
        var ui = this.create("TowerView", "TowerView");
        this.on("netmsg://tower/buyMagicCrystalResult", this.updateResource, this);
        this.on(GameEvent.fightCloseUI, this.updateView, this);
        this.closebtn = ui.getChild("closebtn").asButton;
        this.addbtn = ui.getChild("addbtn").asButton;
        this.rankbtn = ui.getChild("rankbtn").asButton;
        this.tipsbtn = ui.getChild("tipsbtn").asButton;
        this.list = ui.getChild("list").asList;
        this.itemnum = ui.getChild("itemnum").asTextField;
        this.restime = ui.getChild("restime").asTextField;
        this.stage1 = ui.getChild("stage1").asCom;
        this.stage2 = ui.getChild("stage2").asCom;
        this.stage3 = ui.getChild("stage3").asCom;
        this.stage4 = ui.getChild("stage4").asCom;
        this.towername1 = ui.getChild("towername1").asTextField;
        this.towername2 = ui.getChild("towername2").asTextField;
        this.idGroup = [];
        this.ClickAdd();
        //this.updateidGroup();
        //this.updateList();
        this.updateCom();
        this.updateTowername();
        this.updateResource();
    };
    TowerView.prototype.ClickAdd = function () {
        this.addClickListener(this.closebtn, this.onClick, this);
        this.addClickListener(this.addbtn, this.onClick, this);
        this.addClickListener(this.rankbtn, this.onClick, this);
        this.addClickListener(this.tipsbtn, this.onClick, this);
        //this.list.addEventListener(fairygui.ItemEvent.CLICK,this.onitemClick,this);
        this.onEgretEvent(this, egret.Event.ENTER_FRAME, this.timeshow, this);
        this.addClickListener(this.stage1, this.fightClick, this);
    };
    TowerView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.closebtn:
                this.close();
                break;
            case this.addbtn:
                ak.FairyGUI.open(["BuyTipsView",
                    BagData.inst().GetResourceIcon(TowerData.inst().GetConfigInfo().Resource),
                    BagData.inst().GetResourceColor(TowerData.inst().GetConfigInfo().Resource),
                    BagData.inst().GetResourceName(TowerData.inst().GetConfigInfo().Resource),
                    TowerData.inst().GetConfigInfo().buy,
                    0
                ]);
                break;
            case this.rankbtn:
                ak.FairyGUI.open(["RankView", 3, "层数"]);
                break;
            case this.tipsbtn:
                ak.FairyGUI.open(["HelpTipsView", 6]);
                break;
        }
    };
    TowerView.prototype.fightClick = function (e) {
        ak.FairyGUI.open(["FightReadyView", 3]);
    };
    TowerView.prototype.onitemClick = function (e) {
        var _this = this;
        var upCardIndexArr = [0, -1, -1, -1, -1, -1,];
        var nowID = MyData.user.towerID;
        if (nowID < e.itemObject.data.id) {
            TipsViewSystem.show("请通关上一个关卡");
        }
        else if (nowID == e.itemObject.data.id) {
            net.towerBattle(upCardIndexArr, function () {
                _this.updateidGroup();
                _this.updateList();
            }, this);
        }
        else {
            return;
        }
    };
    TowerView.prototype.onitemClick2 = function (e) {
        var upCardIndexArr = [0, -1, -1, -1, -1, -1,];
        var nowID = MyData.user.towerID;
        if (nowID < e.target.data.id) {
            TipsViewSystem.show("请通关上一个关卡");
        }
        else if (nowID == e.target.data.id) {
            /*
            net.towerBattle(upCardIndexArr,()=>{
                this.updateidGroup();
                this.updateList();
            },this);*/
            ak.FairyGUI.open(["FightReadyView", 3]);
        }
        else {
            return;
        }
    };
    TowerView.prototype.updateView = function () {
        //this.updateidGroup();
        //this.updateList();
        this.comMC();
        this.updateCom();
        this.updateTowername();
    };
    TowerView.prototype.updateData = function () {
    };
    TowerView.prototype.updateCom = function () {
        for (var i = 0; i < 4; i++) {
            this["stage" + (i + 1)].data = { id: MyData.user.towerID + i };
            var heroGraph = this["stage" + (i + 1)].getChild("heroGraph").asGraph;
            this["stage" + (i + 1)].getChild("challenge").asImage.visible = i == 0 ? true : false;
            if (this["stage" + (i + 1)].data.id % 10 == 0) {
                this["stage" + (i + 1)].getController("c1").selectedIndex = 1;
                heroGraph.visible = false;
            }
            else {
                this["stage" + (i + 1)].getController("c1").selectedIndex = 0;
                if (!this.heroNode[i]) {
                    this.heroNode[i] = new egret.DisplayObjectContainer();
                    heroGraph.setNativeObject(this.heroNode[i]);
                }
                this.heroNode[i].removeChildren();
                var hero = new Hero(TowerData.inst().GetTowerInfoById(this["stage" + (i + 1)].data.id).model).addToParent(this.heroNode[i]);
                hero.scaleX = 0.8;
                hero.scaleY = 0.8;
                hero.x = 90;
                hero.y = 200;
                heroGraph.visible = true;
            }
        }
    };
    TowerView.prototype.updateTowername = function () {
        this.towername1.text = "神殿守卫 " + MyData.user.towerID;
        this.towername2.text = "神殿守卫 " + MyData.user.towerID;
    };
    TowerView.prototype.comMC = function () {
        var _this = this;
        egret.Tween.get(this.stage1).to({ x: this.comMC_x[0].final, y: this.comMC_y[0].final, alpha: this.comMC_aph[0].final,
            scaleX: this.comMC_scaleX[0].final, scaleY: this.comMC_scaleY[0].final }, 1000).call(function () {
            _this.stage1.x = _this.comMC_x[0].star;
            _this.stage1.y = _this.comMC_y[0].star;
            _this.stage1.alpha = _this.comMC_aph[0].star;
            _this.stage1.scaleX = _this.comMC_scaleX[0].star;
            _this.stage1.scaleY = _this.comMC_scaleY[0].star;
        });
        egret.Tween.get(this.stage2).to({ x: this.comMC_x[1].final, y: this.comMC_y[1].final, alpha: this.comMC_aph[1].final,
            scaleX: this.comMC_scaleX[1].final, scaleY: this.comMC_scaleY[1].final }, 1000).call(function () {
            _this.stage2.x = _this.comMC_x[1].star;
            _this.stage2.y = _this.comMC_y[1].star;
            _this.stage2.alpha = _this.comMC_aph[1].star;
            _this.stage2.scaleX = _this.comMC_scaleX[1].star;
            _this.stage2.scaleY = _this.comMC_scaleY[1].star;
        });
        egret.Tween.get(this.stage3).to({ x: this.comMC_x[2].final, y: this.comMC_y[2].final, alpha: this.comMC_aph[2].final,
            scaleX: this.comMC_scaleX[2].final, scaleY: this.comMC_scaleY[2].final }, 1000).call(function () {
            _this.stage3.x = _this.comMC_x[2].star;
            _this.stage3.y = _this.comMC_y[2].star;
            _this.stage3.alpha = _this.comMC_aph[2].star;
            _this.stage3.scaleX = _this.comMC_scaleX[2].star;
            _this.stage3.scaleY = _this.comMC_scaleY[2].star;
        });
        egret.Tween.get(this.stage4).to({ x: this.comMC_x[3].final, y: this.comMC_y[3].final, alpha: this.comMC_aph[3].final,
            scaleX: this.comMC_scaleX[3].final, scaleY: this.comMC_scaleY[3].final }, 1000).call(function () {
            _this.stage4.x = _this.comMC_x[3].star;
            _this.stage4.y = _this.comMC_y[3].star;
            _this.stage4.alpha = _this.comMC_aph[3].star;
            _this.stage4.scaleX = _this.comMC_scaleX[3].star;
            _this.stage4.scaleY = _this.comMC_scaleY[3].star;
        });
    };
    /**刷新列表 */
    TowerView.prototype.updateList = function () {
        var nowID = MyData.user.towerID;
        this.list.removeChildrenToPool();
        for (var i = 0; i < 18; i++) {
            var item = this.list.addItemFromPool().asCom;
            item.data = { id: this.idGroup[i] };
            var control_c1 = item.getController("c1");
            var control_door = item.getController("door");
            var control_chest = item.getController("chest");
            var control_cloud = item.getController("cloud");
            var title = item.getChild("title").asTextField;
            var heroGraph = item.getChild("heroGraph").asGraph;
            var preciousbtn = item.getChild("preciousbtn").asLoader;
            var touchloder = item.getChild("touchloder").asLoader;
            if ((i % 2 == 0)) {
                control_c1.selectedIndex = (0);
            }
            else {
                control_c1.selectedIndex = (1);
            }
            if (item.data.id % 10 == 0) {
                if (item.data.id >= nowID) {
                    control_chest.selectedIndex = (1);
                    preciousbtn.data = { id: Number(TowerData.inst().GetTowerInfoById(this.idGroup[i]).drop) };
                    if (!preciousbtn.hasClickListener())
                        this.addClickListener(preciousbtn, this.showPrecious, this);
                }
                else {
                    control_chest.selectedIndex = (2);
                }
            }
            else {
                control_chest.selectedIndex = (0);
            }
            if (item.data.id == nowID) {
                control_door.setSelectedIndex(1);
            }
            else {
                control_door.setSelectedIndex(0);
            }
            if (i == 0 || i == 1) {
                control_cloud.selectedIndex = 1;
                if (control_chest.selectedIndex == 2) {
                    control_chest.selectedIndex = 0;
                }
            }
            else {
                control_cloud.selectedIndex = 0;
                if (item.data.id >= nowID) {
                    var tt = new egret.DisplayObjectContainer();
                    heroGraph.setNativeObject(tt);
                    var hero = new Hero(TowerData.inst().GetTowerInfoById(item.data.id).model).addToParent(tt);
                    hero.scaleX = 0.6;
                    hero.scaleY = 0.6;
                    hero.x = 120;
                    hero.y = 180;
                }
            }
            title.text = "\u7B2C" + item.data.id + "\u5173";
            touchloder.data = item.data;
            if (!touchloder.hasClickListener())
                this.addClickListener(touchloder, this.onitemClick2, this);
        }
        /**更新列表的位置 */
        this.listMc();
    };
    TowerView.prototype.updateidGroup = function () {
        //判断18个关卡id
        var nowID = MyData.user.towerID;
        if (nowID < 8) {
            this.towersign = nowID - 1;
            for (var i = 0; i < 18; i++) {
                this.idGroup.push(i + 1);
            }
        }
        else if (nowID + 10 >= TowerData.inst().towerMax()) {
            for (var i = 0; i < 18; i++) {
                var id = TowerData.inst().towerMax() - 18 + (i + 1);
                this.idGroup.push(id);
                if (nowID == id) {
                    this.towersign = i;
                }
            }
        }
        else {
            for (var i = 0; i < 7; i++) {
                this.idGroup.push(nowID - 7 + i);
            }
            this.idGroup.push(nowID);
            for (var j = 0; j < 10; j++) {
                this.idGroup.push(nowID + (j + 1));
            }
            this.towersign = 7;
        }
        this.idGroup.reverse();
    };
    /**列表的位置处理 */
    TowerView.prototype.listMc = function () {
        this.list.scrollPane.posY = (15 - this.towersign) * 210;
    };
    TowerView.prototype.updateResource = function () {
        var staticNum = (new Date().getTime() / 1000 - MyData.user.magicCrystalTime + MyData.timeBase) / TowerData.inst().GetConfigInfo().time;
        if (staticNum > TowerData.inst().GetConfigInfo().maxNum)
            staticNum = TowerData.inst().GetConfigInfo().maxNum;
        this.ResNum = Math.floor(Number(MyData.user.magicCrystal) + Number(staticNum));
        this.itemnum.text = "" + this.ResNum;
        this.isShowTime();
    };
    /**是否显示倒计时 */
    TowerView.prototype.isShowTime = function () {
        if (this.ResNum >= 10) {
            this.restime.visible = false;
        }
        else {
            this.restime.visible = true;
        }
    };
    TowerView.prototype.timeshow = function () {
        if (this.ResNum >= 10)
            return;
        var staticNum = Math.floor((new Date().getTime() / 1000 - MyData.user.magicCrystalTime + MyData.timeBase) / TowerData.inst().GetConfigInfo().time);
        var timeIns = staticNum * TowerData.inst().GetConfigInfo().time + MyData.user.magicCrystalTime;
        var timeIns2 = new Date().getTime() / 1000 - timeIns;
        var timeIns3 = TowerData.inst().GetConfigInfo().time - timeIns2;
        this.restime.text = "" + DateUtils.getFormatBySecond(timeIns3, DateUtils.TIME_FORMAT_12);
    };
    /**展示物品 */
    TowerView.prototype.showPrecious = function (e) {
        ak.FairyGUI.open(["PreciousShowView", e.target.data.id]);
    };
    return TowerView;
}(ak.EasyUI));
__reflect(TowerView.prototype, "TowerView");
//试炼
var TrialViewSystem = (function (_super) {
    __extends(TrialViewSystem, _super);
    function TrialViewSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TrialViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("TrialView");
    };
    TrialViewSystem.inst = new TrialViewSystem("TrialView");
    return TrialViewSystem;
}(ak.FairyGUI));
__reflect(TrialViewSystem.prototype, "TrialViewSystem");
//主界面
var TrialView = (function (_super) {
    __extends(TrialView, _super);
    function TrialView() {
        return _super.call(this, TrialViewSystem.inst, MyGame.inst.uiLayer2_2) || this;
    }
    //初始化回调
    TrialView.prototype.onInit = function () {
        this.ui = this.create("TrialView", "TrialView");
        this.on(GameEvent.fightRpcComplete, this.updateCount, this);
        this.closeBtn = this.ui.getChild("closeBtn").asButton;
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.addCount = this.ui.getChild("n23").asButton;
        this.help = this.ui.getChild("n25").asButton;
        this.confirm = this.ui.getChild("n44").asButton;
        this.left = this.ui.getChild("n53").asButton;
        this.right = this.ui.getChild("n52").asButton;
        this.pk = this.ui.getChild("n50").asButton;
        this.onEgretEvent(this.ui.getController("showIndex"), fairygui.StateChangeEvent.CHANGED, this.changeTab, this);
        this.trialTab = ak.JsonTableMgr.get("trial");
        this.trialConfigTab = ak.JsonTableMgr.get("trialConfig");
        this.itemPieceTab = ak.JsonTableMgr.get("itemPiece");
        this.ResourceTab = ak.JsonTableMgr.get("Resource");
        this.monsterTab = ak.JsonTableMgr.get("monster");
        this.clickAdd();
        this.changeTab();
        this.updateUI();
    };
    TrialView.prototype.updateUI = function () {
        var nameArr = ["n47", "n48", "n49"];
        var strArr = ["丰收试炼", "经验试炼", "无畏试炼"];
        for (var i = 0; i < 3; i++) {
            var item = this.ui.getChild(nameArr[i]).asCom;
            item.getChild("itemname").asTextField.text = strArr[i];
        }
    };
    TrialView.prototype.clickAdd = function () {
        this.addClickListener(this.closeBtn, this.onClick, this); //关闭界面
        this.addClickListener(this.bgclose, this.onClick, this); //关闭购买界面
        this.addClickListener(this.addCount, this.onClick, this); //打开购买界面
        this.addClickListener(this.confirm, this.onClick, this); //确定购买
        this.addClickListener(this.help, this.onClick, this); //帮助
        this.addClickListener(this.left, this.onClick, this); //左选
        this.addClickListener(this.right, this.onClick, this); //右选
        this.addClickListener(this.pk, this.onClick, this); //交战
    };
    TrialView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.closeBtn:
                this.close();
                break;
            case this.bgclose:
                this.ui.getController("c1").selectedIndex = 0;
                break;
            case this.addCount:
                this.updateBuyCount();
                break;
            case this.confirm:
                this.confirmBuyCount();
                break;
            case this.help:
                ak.FairyGUI.open(["HelpTipsView", 5]);
                break;
            case this.left:
                this.diffLv -= 1;
                this.arrowsRefresh();
                break;
            case this.right:
                this.diffLv += 1;
                this.arrowsRefresh();
                break;
            case this.pk:
                this.startFire();
                break;
        }
    };
    //红点显示
    TrialView.prototype.updateRed = function () {
        var nameArr = ["n47", "n48", "n49"];
        var redArr = RedDotMgr.trialTab();
        var num = redArr.length;
        for (var i = 0; i < num; i++) {
            var pass = redArr[i];
            this.ui.getChild(nameArr[i]).asCom.getController("red").selectedIndex = pass ? 1 : 0;
        }
    };
    //龙骨显示
    TrialView.prototype.showLonggu = function (heroID) {
        if (!this.heroNode) {
            this.heroNode = new egret.DisplayObjectContainer();
            this.ui.getChild("longgu").asGraph.setNativeObject(this.heroNode);
        }
        this.heroNode.removeChildren();
        var hero = new Hero(heroID).addToParent(this.heroNode);
        hero.touchEnabled = true;
        this.onEgretEvent(hero, egret.TouchEvent.TOUCH_TAP, function () {
            hero.setAction("atk");
        }, this);
    };
    //箭头刷新
    TrialView.prototype.arrowsRefresh = function () {
        if (this.diffLv == 1) {
            this.left.visible = false;
        }
        else {
            this.left.visible = true;
        }
        var showR = true;
        var count = this.trialTab.size();
        var num = 0;
        for (var i = 0; i < count; i++) {
            var row = this.trialTab.getRow(i);
            var type = row.getValFromColName("type");
            if (this.tabIndex == type) {
                num++;
            }
        }
        if (this.diffLv >= num) {
            this.right.visible = false;
        }
        else {
            this.right.visible = true;
        }
        this.showInfo();
    };
    //确认购买
    TrialView.prototype.confirmBuyCount = function () {
        var _this = this;
        net.testBuy(this.tabIndex, 1, function () {
            _this.ui.getController("c1").selectedIndex = 0;
            _this.updateCount();
        }, this);
    };
    //更新购买界面
    TrialView.prototype.updateBuyCount = function () {
        this.ui.getController("c1").selectedIndex = 1;
        var trialConfigInfo = this.trialConfigTab.getRow(0);
        var buyCost = trialConfigInfo.getValFromColName("buyCost");
        var count = trialConfigInfo.getValFromColName("count");
        this.ui.getChild("n38").asTextField.text = buyCost + ",是否购买";
        var addCount = Vip.getRight(106);
        var info = MyData.user.json.test["info" + this.tabIndex];
        var residueCount = count + addCount - info.maxCount;
        this.ui.getChild("n40").asTextField.text = residueCount + "";
    };
    //更新次数
    TrialView.prototype.updateCount = function () {
        var info = MyData.user.json.test["info" + this.tabIndex];
        var trialCount = info.count;
        var trialMaxCount = info.maxCount;
        this.ui.getChild("n22").asTextField.text = (trialMaxCount - trialCount) + "";
        this.updateRed();
    };
    //切换现象卡界面
    TrialView.prototype.changeTab = function () {
        this.tabIndex = this.ui.getController("showIndex").selectedIndex + 1;
        this.diffLv = 1;
        this.arrowsRefresh();
        this.updateCount();
    };
    //更新界面
    TrialView.prototype.showInfo = function () {
        var count = this.trialTab.size();
        for (var i = 0; i < count; i++) {
            var trialInfo = this.trialTab.getRow(i);
            var type = Number(trialInfo.getValFromColName("type")); //试炼类型（1=英雄，2=金币，3=经验）
            if (type == this.tabIndex) {
                var diff = Number(trialInfo.getValFromColName("diff")); //难度
                if (this.diffLv == diff) {
                    var id = trialInfo.getValFromColName("id"); //试炼id
                    var drop = trialInfo.getValFromColName("drop"); //掉落
                    var power = trialInfo.getValFromColName("power"); //战斗力
                    var openLv = trialInfo.getValFromColName("openLv"); //开启等级
                    var diffText = trialInfo.getValFromColName("diffText"); //难度描述
                    var monster = trialInfo.getValFromColName("monster"); //怪物（对应monster表group）
                    this.pk.data = id;
                    var arrItem = ["n56", "n57"];
                    var arr = ItemMgr.getDropGroupByID(drop);
                    for (var j = 0; j < 2; j++) {
                        var type_3 = arr[j][1];
                        var itemID = arr[j][2];
                        var count_7 = arr[j][3];
                        var item = this.ui.getChild(arrItem[j]).asCom;
                        item.data = [itemID, count_7, type_3];
                        var itemBase = new ItemBase(item, this, type_3);
                        itemBase.clear2();
                        itemBase = new ItemBase(item, this, type_3);
                        itemBase.setItemData(Number(itemID));
                        itemBase.setNumber(count_7, true);
                        this.onEgretEvent(item, egret.TouchEvent.TOUCH_TAP, this.showItem, this);
                    }
                    var level = MyData.user.level;
                    if (level >= openLv) {
                        this.pk.enabled = true;
                        this.pk.title = "战斗";
                    }
                    else {
                        this.pk.enabled = false;
                        this.pk.title = "lv" + openLv;
                    }
                    this.ui.getChild("n51").asTextField.text = "战力：" + power;
                    this.ui.getChild("n54").asCom.getChild("title").asTextField.text = diffText + "";
                    var row = this.monsterTab.getRow(monster);
                    var heroID = row.getValFromColName("heroID"); //对应英雄id
                    this.showLonggu(heroID);
                }
            }
        }
    };
    //道具详情
    TrialView.prototype.showItem = function (obj) {
        var item = obj.target;
        var itemID = item.data[0];
        var count = item.data[1];
        var type = item.data[2];
        if (this.hitTestPointWithFairyGUIComponent(item, obj.stageX, obj.stageY)) {
            if (type != 3) {
                var bagtype = ak.JsonTableMgr.get("item").getRowFromColName("id", "" + itemID).getValFromColName("bagtype");
                ak.FairyGUI.open(["WeaponTipsView", itemID, count, bagtype - 1, 0, true]);
            }
            else {
                ak.FairyGUI.open(["ResourceTipsView", itemID, count]);
            }
        }
    };
    //战斗
    TrialView.prototype.startFire = function () {
        var id = this.pk.data;
        var trialInfo = this.trialTab.getRowFromColName("id", "" + id);
        var openLv = Number(trialInfo.getValFromColName("openLv")); //开启等级
        var level = MyData.user.level;
        if (level >= openLv) {
            var info = MyData.user.json.test["info" + this.tabIndex];
            var count = info.count;
            var maxCount = info.maxCount;
            if (count < maxCount) {
                ak.FairyGUI.open(["FightReadyView", 2, id]);
            }
            else {
                TipsViewSystem.show("挑战次数已用完");
            }
        }
        else {
            TipsViewSystem.show("玩家等级不足");
        }
    };
    return TrialView;
}(ak.EasyUI));
__reflect(TrialView.prototype, "TrialView");
var DeblockingwayViewSystem = (function (_super) {
    __extends(DeblockingwayViewSystem, _super);
    function DeblockingwayViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    DeblockingwayViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("WarnTipsView");
    };
    DeblockingwayViewSystem.inst = new DeblockingwayViewSystem("WarnTipsView");
    return DeblockingwayViewSystem;
}(ak.FairyGUI));
__reflect(DeblockingwayViewSystem.prototype, "DeblockingwayViewSystem");
/**
 * 玩法解锁界面
 */
var DeblockingwayView = (function (_super) {
    __extends(DeblockingwayView, _super);
    function DeblockingwayView(id) {
        var _this = _super.call(this, HelpTipsViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.id = 0;
        _this.id = id;
        return _this;
    }
    /**回调 */
    DeblockingwayView.prototype.onInit = function () {
        var ui = this.create("WarnTipsView", "DeblockingwayView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.names = ui.getChild("names").asTextField;
        this.dec = ui.getChild("dec").asTextField;
        this.loders = ui.getChild("loders").asLoader;
        this.closebtn = ui.getChild("closebtn").asCom;
        this.ClickAdd();
        this.staticView();
    };
    DeblockingwayView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
        this.addClickListener(this.closebtn, this.onClick, this);
    };
    DeblockingwayView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                //派发新手引导
                ak.EventMgr.dispatch(GameEvent.guide_Exopen);
                break;
            case this.closebtn:
                this.close();
                //派发新手引导
                ak.EventMgr.dispatch(GameEvent.guide_Exopen);
                break;
        }
    };
    DeblockingwayView.prototype.staticView = function () {
        this.names.text = "" + this.getInfoByID(this.id).name;
        this.dec.text = "" + this.getInfoByID(this.id).text;
        if (this.getInfoByID(this.id).pic != "0") {
            this.setLoaderUrl(this.loders, "ui://WarnTipsView/" + this.getInfoByID(this.id).pic);
        }
    };
    DeblockingwayView.prototype.getInfoByID = function (id) {
        var systemOpenTab = ak.JsonTableMgr.get("systemOpen");
        var systemOpenInfo = systemOpenTab.getRowFromColName("id", "" + id);
        var name = systemOpenInfo.getValFromColName("name");
        var text = systemOpenInfo.getValFromColName("text");
        var pic = systemOpenInfo.getValFromColName("pic");
        var info = { name: name, text: text, pic: pic };
        return info;
    };
    return DeblockingwayView;
}(ak.EasyUI));
__reflect(DeblockingwayView.prototype, "DeblockingwayView");
var HelpTipsViewSystem = (function (_super) {
    __extends(HelpTipsViewSystem, _super);
    function HelpTipsViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    HelpTipsViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("WarnTipsView");
    };
    HelpTipsViewSystem.inst = new HelpTipsViewSystem("WarnTipsView");
    return HelpTipsViewSystem;
}(ak.FairyGUI));
__reflect(HelpTipsViewSystem.prototype, "HelpTipsViewSystem");
/**
 * 帮助提示界面
 */
var HelpTipsView = (function (_super) {
    __extends(HelpTipsView, _super);
    function HelpTipsView(index) {
        var _this = _super.call(this, HelpTipsViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.index = index;
        return _this;
    }
    /**回调 */
    HelpTipsView.prototype.onInit = function () {
        var ui = this.create("WarnTipsView", "HelpTipsView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        ui.getController("c1").selectedIndex = (this.index);
        this.ClickAdd();
    };
    HelpTipsView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
    };
    HelpTipsView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
        }
    };
    return HelpTipsView;
}(ak.EasyUI));
__reflect(HelpTipsView.prototype, "HelpTipsView");
var JifenTipsViewSystem = (function (_super) {
    __extends(JifenTipsViewSystem, _super);
    function JifenTipsViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    JifenTipsViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("WarnTipsView");
    };
    JifenTipsViewSystem.inst = new JifenTipsViewSystem("WarnTipsView");
    return JifenTipsViewSystem;
}(ak.FairyGUI));
__reflect(JifenTipsViewSystem.prototype, "JifenTipsViewSystem");
/**
 * 召唤界面(获得)
 */
var JifenTipsView = (function (_super) {
    __extends(JifenTipsView, _super);
    function JifenTipsView() {
        return _super.call(this, JifenTipsViewSystem.inst, MyGame.inst.tipLayer) || this;
    }
    /**回调 */
    JifenTipsView.prototype.onInit = function () {
        var ui = this.create("WarnTipsView", "JifenTipsView");
        this.heroitem = ui.getChild("heroitem").asCom;
        this.summonbtn = ui.getChild("summonbtn").asButton;
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.ClickAdd();
        this.staticView();
    };
    JifenTipsView.prototype.ClickAdd = function () {
        this.addClickListener(this.summonbtn, this.onClick, this);
        this.addClickListener(this.bgclose, this.onClick, this);
    };
    JifenTipsView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.summonbtn:
                this.vip3summon();
                break;
            case this.bgclose:
                this.close();
                break;
        }
    };
    JifenTipsView.prototype.staticView = function () {
        var item = new ItemBase(this.heroitem, this, 2);
        item.setIcons2("hero_5");
        item.setStar2(5);
        item.setColor2(4);
    };
    /**vip3召唤 */
    JifenTipsView.prototype.vip3summon = function () {
        var _this = this;
        if (SummonData.inst().GetSummonScore() < 1000) {
            TipsViewSystem.show("积分不足");
            return;
        }
        if (MyData.user.vip < 3) {
            TipsViewSystem.show("vip3方可以召唤");
            return;
        }
        net.randomCard(7, function (getCardArr) {
            _this.close();
            ak.FairyGUI.open(["SummonIngView", getCardArr, 7]);
        }, this);
    };
    return JifenTipsView;
}(ak.EasyUI));
__reflect(JifenTipsView.prototype, "JifenTipsView");
var UpgradeTipsViewSystem = (function (_super) {
    __extends(UpgradeTipsViewSystem, _super);
    function UpgradeTipsViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    UpgradeTipsViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("WarnTipsView");
    };
    UpgradeTipsViewSystem.inst = new UpgradeTipsViewSystem("WarnTipsView");
    return UpgradeTipsViewSystem;
}(ak.FairyGUI));
__reflect(UpgradeTipsViewSystem.prototype, "UpgradeTipsViewSystem");
/**
 * 升级提示界面
 */
var UpgradeTipsView = (function (_super) {
    __extends(UpgradeTipsView, _super);
    function UpgradeTipsView() {
        return _super.call(this, HelpTipsViewSystem.inst, MyGame.inst.tipLayer) || this;
    }
    /**回调 */
    UpgradeTipsView.prototype.onInit = function () {
        var ui = this.create("WarnTipsView", "UpgradeTipsView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.lvnum = ui.getChild("lvnum").asTextField;
        this.zsnum = ui.getChild("zsnum").asTextField;
        this.hua1 = ui.getChild("hua1").asGraph;
        this.hua2 = ui.getChild("hua2").asGraph;
        this.ClickAdd();
        this.staticView();
    };
    UpgradeTipsView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onClick, this);
    };
    UpgradeTipsView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                /**判断是否开启玩法界面 */
                this.deblockingwayHandle();
                break;
        }
    };
    UpgradeTipsView.prototype.staticView = function () {
        this.lvnum.text = "" + MyData.user.level;
        this.zsnum.text = "+" + this.getZs(MyData.user.level);
        var mc1 = new ak.MovieClip("rwsjhua_json", "rwsjhua_png", "rwsjhua");
        this.hua1.setNativeObject(mc1);
        var mc2 = new ak.MovieClip("rwsjhua_json", "rwsjhua_png", "rwsjhua");
        mc2.scaleX = -1;
        this.hua2.setNativeObject(mc2);
    };
    /**玩法解锁处理 */
    UpgradeTipsView.prototype.deblockingwayHandle = function () {
        var GuideID = GuideData.inst().GetGuideIDByTab();
        if (MyData.user.level >= GuideData.inst().GetTabInfoById(GuideID).beginCondition.lv && ak.FairyGUI.getOpenUI("ExplorationView").length != 0) {
            ak.FairyGUI.open(["DeblockingwayView", this.getWayID(GuideData.inst().GetTabInfoById(GuideID).beginCondition.lv)]);
        }
    };
    /**获得钻石根据lv */
    UpgradeTipsView.prototype.getZs = function (lv) {
        var playerLvTab = ak.JsonTableMgr.get("playerLv");
        var playerLvInfo = playerLvTab.getRowFromColName("level", "" + lv);
        var zs = playerLvInfo.getValFromColName("zs");
        return zs;
    };
    /**获取开启的id */
    UpgradeTipsView.prototype.getWayID = function (lv) {
        var systemOpenTab = ak.JsonTableMgr.get("systemOpen");
        var systemOpenInfo = systemOpenTab.getRowFromColName("openLv", "" + lv);
        var id = systemOpenInfo.getValFromColName("id");
        return id;
    };
    return UpgradeTipsView;
}(ak.EasyUI));
__reflect(UpgradeTipsView.prototype, "UpgradeTipsView");
var BuyTipsViewSystem = (function (_super) {
    __extends(BuyTipsViewSystem, _super);
    function BuyTipsViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    BuyTipsViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("WeaponTipsView");
    };
    BuyTipsViewSystem.inst = new BuyTipsViewSystem("WeaponTipsView");
    return BuyTipsViewSystem;
}(ak.FairyGUI));
__reflect(BuyTipsViewSystem.prototype, "BuyTipsViewSystem");
/**
 * item提示框
 */
var BuyTipsView = (function (_super) {
    __extends(BuyTipsView, _super);
    /**
     * itemID 道具id
     * count 道具数量
     */
    function BuyTipsView(icon, color, names, buy, type) {
        var _this = _super.call(this, BuyTipsViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.nowSellcount = 1;
        _this.icon = "";
        _this.color = 0;
        _this.names = "";
        _this.buy = 0;
        /**默认为0，0为爬塔材料，1为许愿池材料 ,2为竞技场材料*/
        _this.type = 0;
        _this.icon = icon;
        _this.color = color;
        _this.names = names;
        _this.buy = buy;
        _this.type = type;
        return _this;
    }
    /**回调 */
    BuyTipsView.prototype.onInit = function () {
        var ui = this.create("WeaponTipsView", "BuyTipsView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.itemname3 = ui.getChild("itemname3").asTextField;
        this.item2 = ui.getChild("item2").asCom;
        this.numleftbtn = ui.getChild("numleftbtn").asButton;
        this.numrightbtn = ui.getChild("numrightbtn").asButton;
        this.nownum = ui.getChild("nownum").asTextField;
        this.nowmoney = ui.getChild("nowmoney").asTextField;
        this.buybtn2 = ui.getChild("buybtn2").asButton;
        this.controller_c1 = ui.getController("c1");
        this.nowSellcount = 1;
        this.ClickAdd();
        this.showItemInfo();
    };
    BuyTipsView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onclick, this);
        this.addClickListener(this.numleftbtn, this.onclick, this);
        this.addClickListener(this.numrightbtn, this.onclick, this);
        this.addClickListener(this.buybtn2, this.onclick, this);
    };
    BuyTipsView.prototype.onclick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.numleftbtn:
                this.Setleftnum();
                break;
            case this.numrightbtn:
                this.Setrightnum();
                break;
            case this.buybtn2:
                this.buyItemHandle2();
                break;
        }
    };
    BuyTipsView.prototype.showItemInfo = function () {
        var icon = this.icon;
        var color = this.color;
        var names = this.names;
        var items2 = new ItemBase(this.item2, this, 1);
        items2.setIcons2(icon);
        items2.setColor2(color);
        this.itemname3.text = "" + names;
        this.itemname3.color = Color.itemColor[color];
        this.nownum.text = String(this.nowSellcount);
        this.nowmoney.text = this.buy * this.nowSellcount + "/" + (MyData.user.diamond + MyData.user.diamond2);
    };
    BuyTipsView.prototype.buyItemHandle2 = function () {
        var _this = this;
        switch (this.type) {
            case 0:
                net.towerBuyMagicCrystal(this.nowSellcount, function () {
                    _this.close();
                }, this);
                break;
            case 1:
                net.wishPoolBuy(this.nowSellcount, function () {
                    _this.close();
                    ak.EventMgr.dispatch(GameEvent.wishPoolBuy);
                }, this);
                break;
            case 2:
                net.buyArenaTicket(this.nowSellcount, function (msg) {
                    _this.close();
                    ak.EventMgr.dispatch(GameEvent.arenaBuyTicket);
                }, this);
                break;
        }
    };
    BuyTipsView.prototype.Setleftnum = function () {
        if (this.nowSellcount >= 2) {
            this.nowSellcount--;
            this.nownum.text = String(this.nowSellcount);
        }
        else {
            TipsViewSystem.show("已经是最小值了");
        }
        this.nowmoney.text = this.buy * this.nowSellcount + "/" + (MyData.user.diamond + MyData.user.diamond2);
    };
    BuyTipsView.prototype.Setrightnum = function () {
        var myDiamond = MyData.user.diamond + MyData.user.diamond2;
        var nowDiamond = this.buy * this.nowSellcount;
        if (myDiamond > nowDiamond) {
            this.nowSellcount++;
            this.nownum.text = String(this.nowSellcount);
        }
        else {
            TipsViewSystem.show("已经是最大值了");
        }
        this.nowmoney.text = this.buy * this.nowSellcount + "/" + (MyData.user.diamond + MyData.user.diamond2);
    };
    return BuyTipsView;
}(ak.EasyUI));
__reflect(BuyTipsView.prototype, "BuyTipsView");
var ResourceTipsViewSystem = (function (_super) {
    __extends(ResourceTipsViewSystem, _super);
    function ResourceTipsViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    ResourceTipsViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("WeaponTipsView");
    };
    ResourceTipsViewSystem.inst = new ResourceTipsViewSystem("WeaponTipsView");
    return ResourceTipsViewSystem;
}(ak.FairyGUI));
__reflect(ResourceTipsViewSystem.prototype, "ResourceTipsViewSystem");
/**
 * item提示框
 */
var ResourceTipsView = (function (_super) {
    __extends(ResourceTipsView, _super);
    /**
     * itemID 道具id
     * count 道具数量
     */
    function ResourceTipsView(id, count) {
        var _this = _super.call(this, ResourceTipsViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.id = 0;
        _this.count = 0;
        _this.id = id;
        _this.count = count;
        return _this;
    }
    /**回调 */
    ResourceTipsView.prototype.onInit = function () {
        var ui = this.create("WeaponTipsView", "ResourceTipsView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.itemCom = ui.getChild("itemCom").asCom;
        this.itemname = ui.getChild("itemname").asTextField;
        this.itemattribute0 = ui.getChild("itemattribute0").asTextField;
        this.ClickAdd();
        this.updateView();
    };
    ResourceTipsView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onclick, this);
    };
    ResourceTipsView.prototype.onclick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
        }
    };
    ResourceTipsView.prototype.updateView = function () {
        console.log("道具：", this.id);
        var items = new ItemBase(this.itemCom, this, 3);
        items.setItemData(this.id);
        items.setNumber("" + this.count, true);
        this.itemname.text = BagData.inst().GetResourceName(this.id);
        this.itemattribute0.text = BagData.inst().GetResourceText(this.id);
    };
    return ResourceTipsView;
}(ak.EasyUI));
__reflect(ResourceTipsView.prototype, "ResourceTipsView");
var ShipinTipsViewSystem = (function (_super) {
    __extends(ShipinTipsViewSystem, _super);
    function ShipinTipsViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    ShipinTipsViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("WeaponTipsView");
    };
    ShipinTipsViewSystem.inst = new ShipinTipsViewSystem("WeaponTipsView");
    return ShipinTipsViewSystem;
}(ak.FairyGUI));
__reflect(ShipinTipsViewSystem.prototype, "ShipinTipsViewSystem");
/**
 * item提示框
 */
var ShipinTipsView = (function (_super) {
    __extends(ShipinTipsView, _super);
    /**
     * itemID 道具id
     * count 道具数量
     */
    function ShipinTipsView(itemID, count, itemindex, c1) {
        var _this = _super.call(this, ShipinTipsViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.itemID = 0;
        _this.count = 0;
        _this.itemindex = 0;
        _this.nowSellcount = 0;
        _this.c1 = -1;
        _this.itemID = itemID;
        _this.count = count;
        _this.itemindex = itemindex;
        _this.nowSellcount = _this.count;
        if (c1)
            _this.c1 = c1;
        return _this;
    }
    /**回调 */
    ShipinTipsView.prototype.onInit = function () {
        var ui = this.create("WeaponTipsView", "ShipinTipsView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.itemname = ui.getChild("itemname").asTextField;
        this.itemtype = ui.getChild("itemtype").asTextField;
        this.itemCom = ui.getChild("itemCom").asCom;
        this.list = ui.getChild("list").asList;
        this.buybtn = ui.getChild("buybtn").asButton;
        this.imgbg = ui.getChild("imgbg").asLoader;
        this.itemname3 = ui.getChild("itemname3").asTextField;
        this.item2 = ui.getChild("item2").asCom;
        this.numleftbtn = ui.getChild("numleftbtn").asButton;
        this.numrightbtn = ui.getChild("numrightbtn").asButton;
        this.nownum = ui.getChild("nownum").asTextInput;
        this.nowmoney = ui.getChild("nowmoney").asTextField;
        this.buybtn2 = ui.getChild("buybtn2").asButton;
        this.controller_c1 = ui.getController("c1");
        this.ClickAdd();
        this.showItemInfo();
    };
    ShipinTipsView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onclick, this);
        this.addClickListener(this.buybtn, this.onclick, this);
        this.addClickListener(this.numleftbtn, this.onclick, this);
        this.addClickListener(this.numrightbtn, this.onclick, this);
        this.addClickListener(this.buybtn2, this.onclick, this);
        this.onFairyguiEvent(this.nownum, egret.FocusEvent.FOCUS_OUT, this.numchange, this);
    };
    ShipinTipsView.prototype.onclick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.buybtn:
                this.buyItemHandle();
                break;
            case this.numleftbtn:
                this.Setleftnum();
                break;
            case this.numrightbtn:
                this.Setrightnum();
                break;
            case this.buybtn2:
                this.buyItemHandle2();
                break;
        }
    };
    /**根据玩家输入数量去操作 */
    ShipinTipsView.prototype.numchange = function () {
        var textnum = Number(this.nownum.text);
        if (textnum < 1) {
            TipsViewSystem.show("已经超过最小值了");
            this.nownum.text = "" + 1;
            this.nowSellcount = 1;
            this.nowmoney.text = String(BagData.inst().GetitemMoneyById(this.itemID) * this.nowSellcount);
            return;
        }
        if (textnum > this.count) {
            TipsViewSystem.show("已经超过最大值了");
            this.nownum.text = "" + this.count;
            this.nowSellcount = this.count;
            this.nowmoney.text = String(BagData.inst().GetitemMoneyById(this.itemID) * this.nowSellcount);
            return;
        }
        this.nowSellcount = textnum;
        this.nownum.text = String(this.nowSellcount);
        this.nowmoney.text = String(BagData.inst().GetitemMoneyById(this.itemID) * this.nowSellcount);
    };
    ShipinTipsView.prototype.showItemInfo = function () {
        var items = new ItemBase(this.itemCom, this, 1);
        items.setItemData(this.itemID);
        items.setStar2(BagData.inst().GetStarById(this.itemID));
        items.setNumber2("", true);
        if (BagData.inst().GetBagtypeById(this.itemID) == 3) {
            var race = BagData.inst().isOnlyRacePiece(this.itemID);
            items.setType(race);
        }
        else {
            items.setType(0);
        }
        var items2 = new ItemBase(this.item2, this, 1);
        items2.setItemData(this.itemID);
        items2.setStar2(BagData.inst().GetStarById(this.itemID));
        items2.setNumber(String(this.count), true);
        if (BagData.inst().GetBagtypeById(this.itemID) == 3) {
            var race = BagData.inst().isOnlyRacePiece(this.itemID);
            items2.setType(race);
        }
        else {
            items2.setType(0);
        }
        this.itemname.text = WeaponTipsData.inst().GetNameById(this.itemID);
        this.itemname.color = Color.itemColor[BagData.inst().GetColorById(this.itemID)];
        this.itemname3.text = WeaponTipsData.inst().GetNameById(this.itemID);
        this.itemname3.color = Color.itemColor[BagData.inst().GetColorById(this.itemID)];
        this.itemtype.text = WeaponTipsData.inst().GetTypeById(this.itemID);
        this.nownum.text = String(this.nowSellcount);
        this.nowmoney.text = String(BagData.inst().GetitemMoneyById(this.itemID) * this.nowSellcount);
        var GetShipinTextInfo = WeaponTipsData.inst().GetShipinTextInfo(this.itemID);
        this.list.removeChildrenToPool();
        for (var i = 0; i < GetShipinTextInfo.length; i++) {
            var item = this.list.addItemFromPool().asCom;
            var text = item.getChild("text").asTextField;
            text.text = GetShipinTextInfo[i];
        }
        this.imgbg.height = 351 + (GetShipinTextInfo.length - 2) * 22;
        this.buybtn.y = 663 + (GetShipinTextInfo.length - 2) * 22;
        if (this.c1 != -1) {
            this.controller_c1.selectedIndex = (2);
        }
    };
    ShipinTipsView.prototype.buyItemHandle = function () {
        var _this = this;
        if (this.count >= 2) {
            this.controller_c1.selectedIndex = (1);
        }
        else {
            net.itemSell(this.itemindex, 1, function () {
                _this.close();
            }, this);
        }
    };
    ShipinTipsView.prototype.buyItemHandle2 = function () {
        var _this = this;
        net.itemSell(this.itemindex, this.nowSellcount, function () {
            _this.close();
        }, this);
    };
    ShipinTipsView.prototype.Setleftnum = function () {
        if (this.nowSellcount >= 2) {
            this.nowSellcount--;
            this.nownum.text = String(this.nowSellcount);
        }
        else {
            TipsViewSystem.show("已经是最小值了");
        }
        this.nowmoney.text = String(BagData.inst().GetitemMoneyById(this.itemID) * this.nowSellcount);
    };
    ShipinTipsView.prototype.Setrightnum = function () {
        if (this.nowSellcount < this.count) {
            this.nowSellcount++;
            this.nownum.text = String(this.nowSellcount);
        }
        else {
            TipsViewSystem.show("已经是最大值了");
        }
        this.nowmoney.text = String(BagData.inst().GetitemMoneyById(this.itemID) * this.nowSellcount);
    };
    return ShipinTipsView;
}(ak.EasyUI));
__reflect(ShipinTipsView.prototype, "ShipinTipsView");
/**
 * 道具提示框数据
 */
var WeaponTipsData = (function () {
    function WeaponTipsData() {
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    WeaponTipsData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new WeaponTipsData();
        }
        return Class._instance;
    };
    /**获取道具名字 */
    WeaponTipsData.prototype.GetNameById = function (itemID) {
        var itemTab = ak.JsonTableMgr.get("item");
        var itemInfo = itemTab.getRowFromColName("id", "" + itemID);
        var names = itemInfo.getValFromColName("name");
        return names;
    };
    /**获取道具类型文字 */
    WeaponTipsData.prototype.GetTypeById = function (itemID) {
        var itemTab = ak.JsonTableMgr.get("item");
        var itemInfo = itemTab.getRowFromColName("id", "" + itemID);
        var types = itemInfo.getValFromColName("bagtype");
        return BagData.BAGNAME[types - 1];
    };
    /**获取道具使用类型 */
    WeaponTipsData.prototype.GetUsetypeById = function (itemID) {
        var itemTab = ak.JsonTableMgr.get("item");
        var itemInfo = itemTab.getRowFromColName("id", "" + itemID);
        var usetype = itemInfo.getValFromColName("usetype");
        return usetype;
    };
    /**获取道具描述 */
    WeaponTipsData.prototype.GetTextById = function (itemID) {
        var itemTab = ak.JsonTableMgr.get("item");
        var itemInfo = itemTab.getRowFromColName("id", "" + itemID);
        var types = itemInfo.getValFromColName("bagtype");
        var itemattribute0_str = "";
        if (types == 1) {
            var itemskillInfo = ak.JsonTableMgr.get("itemEquip").getRowFromColName("id", "" + itemID);
            var skillDamageRate = Number(itemskillInfo.getValFromColName("skillDamageRate"));
            var critRate = Number(itemskillInfo.getValFromColName("critRate"));
            var atk = Number(itemskillInfo.getValFromColName("atk"));
            var atkRate = Number(itemskillInfo.getValFromColName("atkRate"));
            var hp = Number(itemskillInfo.getValFromColName("hp"));
            var blockRate = Number(itemskillInfo.getValFromColName("blockRate"));
            var deDamageRate = Number(itemskillInfo.getValFromColName("deDamageRate"));
            var attr = [skillDamageRate, critRate, atk, atkRate, hp, blockRate, deDamageRate];
            for (var i = 0; i < attr.length; i++) {
                var str = "";
                if (attr[i] != 0) {
                    if (WeaponTipsData.SKILLPC[i]) {
                        str = "+" + attr[i] / 100 + "%" + WeaponTipsData.SKILLNAME[i];
                    }
                    else {
                        str = "+" + attr[i] + WeaponTipsData.SKILLNAME[i];
                    }
                    if (itemattribute0_str == "") {
                        itemattribute0_str = str;
                    }
                    else {
                        itemattribute0_str += ("\n" + str);
                    }
                }
            }
        }
        else {
            itemattribute0_str = itemInfo.getValFromColName("text");
        }
        return itemattribute0_str;
    };
    /**判断该物品是否有套装 */
    WeaponTipsData.prototype.isTaozhuang = function (itemID) {
        var itemTab = ak.JsonTableMgr.get("item");
        var itemInfo = itemTab.getRowFromColName("id", "" + itemID);
        var types = itemInfo.getValFromColName("bagtype");
        if (types == 1) {
            var itemskillInfo = ak.JsonTableMgr.get("itemEquip").getRowFromColName("id", "" + itemID);
            var tzID = Number(itemskillInfo.getValFromColName("tzID"));
            if (tzID != 0)
                return true;
        }
        return false;
    };
    /**判断是否是一个指点的碎片 */
    WeaponTipsData.prototype.isOnly = function (itemID) {
        var itemTab = ak.JsonTableMgr.get("item");
        var itemInfo = itemTab.getRowFromColName("id", "" + itemID);
        var types = itemInfo.getValFromColName("bagtype");
        if (types == 3) {
            var itemPieceTab = ak.JsonTableMgr.get("itemPiece");
            var itemPieceInfo = itemPieceTab.getRowFromColName("id", "" + itemID);
            var heroID = itemPieceInfo.getValFromColName("heroID");
            if (heroID != 0) {
                return true;
            }
        }
        return false;
    };
    /**获取碎片合成英雄的ID */
    WeaponTipsData.prototype.GetHeroID = function (itemID) {
        var itemTab = ak.JsonTableMgr.get("item");
        var itemInfo = itemTab.getRowFromColName("id", "" + itemID);
        var types = itemInfo.getValFromColName("bagtype");
        if (types == 3) {
            var itemPieceTab = ak.JsonTableMgr.get("itemPiece");
            var itemPieceInfo = itemPieceTab.getRowFromColName("id", "" + itemID);
            var heroID = itemPieceInfo.getValFromColName("heroID");
            if (heroID != 0) {
                return heroID;
            }
        }
        return 0;
    };
    /**判断是否可以一次性合成2个英雄以上 */
    WeaponTipsData.prototype.isMoreOnePiecehz = function (itemID, count) {
        var max = BagData.inst().GetPieceMaxNum(itemID);
        if (count >= max * 2)
            return true;
        return false;
    };
    /**
     * 根据id获取道具的获取途径
     */
    WeaponTipsData.prototype.GetItemWayById = function (itemID) {
        var itemTab = ak.JsonTableMgr.get("item");
        var itemInfo = itemTab.getRowFromColName("id", "" + itemID);
        var way1 = itemInfo.getValFromColName("way1");
        var way2 = itemInfo.getValFromColName("way2");
        var way3 = itemInfo.getValFromColName("way3");
        var way4 = itemInfo.getValFromColName("way4");
        var way5 = itemInfo.getValFromColName("way5");
        var allway = [way1, way2, way3, way4, way5];
        var wayGroup = [];
        for (var i = 0; i < allway.length; i++) {
            if (allway[i] != 0)
                wayGroup.push(allway[i]);
        }
        return wayGroup;
    };
    /**
     * 获得路径的信息
     */
    WeaponTipsData.prototype.GetWayInfoyByWayId = function (wayID) {
        var itemTab = ak.JsonTableMgr.get("Jump");
        var itemInfo = itemTab.getRowFromColName("id", "" + wayID);
        var jump = itemInfo.getValFromColName("jump");
        var pic = itemInfo.getValFromColName("pic");
        var name = itemInfo.getValFromColName("name");
        var type = itemInfo.getValFromColName("type");
        var isMainUI = itemInfo.getValFromColName("isMainUI");
        var info = { jump: jump, pic: pic, name: name, type: type, isMainUI: isMainUI };
        return info;
    };
    WeaponTipsData.prototype.GetShipinTextInfo = function (itemID) {
        var infoGroup = [];
        var itemShipinTab = ak.JsonTableMgr.get("itemShipin");
        var itemTab = ak.JsonTableMgr.get("item");
        var itemInfo = itemTab.getRowFromColName("id", "" + itemID);
        var itemShipinInfo = itemShipinTab.getRowFromColName("id", "" + itemID);
        //基础属性
        var blockRate = itemShipinInfo.getValFromColName("blockRate");
        var critRate = itemShipinInfo.getValFromColName("critRate");
        var skillDamageRate = itemShipinInfo.getValFromColName("skillDamageRate");
        var hpRate = itemShipinInfo.getValFromColName("hpRate");
        var atkRate = itemShipinInfo.getValFromColName("atkRate");
        var holyAtk = itemShipinInfo.getValFromColName("holyAtk");
        var critDamageRate = itemShipinInfo.getValFromColName("critDamageRate");
        var accurateRate = itemShipinInfo.getValFromColName("accurateRate");
        var speed = itemShipinInfo.getValFromColName("speed");
        var deDamageRate = itemShipinInfo.getValFromColName("deDamageRate");
        var atk = itemShipinInfo.getValFromColName("atk");
        var attr = [blockRate, critRate, skillDamageRate, hpRate, atkRate, holyAtk, critDamageRate, accurateRate, speed, deDamageRate, atk];
        for (var i = 0; i < attr.length; i++) {
            if (attr[i] != 0) {
                if (i != attr.length - 1 && WeaponTipsData.ShipinQuality[i] != "速度") {
                    infoGroup.push("+" + attr[i] / 100 + "%" + WeaponTipsData.ShipinQuality[i]);
                }
                else {
                    infoGroup.push("+" + attr[i] + WeaponTipsData.ShipinQuality[i]);
                }
            }
        }
        //描述
        var dec = itemInfo.getValFromColName("text");
        if (dec != "0")
            infoGroup.push(dec);
        var race = itemShipinInfo.getValFromColName("race");
        if (race != 0) {
            //种族描述
            infoGroup.push("\u5C5E\u6027\u6FC0\u6D3B\u9650\u5B9A\uFF1A" + WeaponTipsData.raceText[race - 1]);
            //种族属性
            var raceBuffAntiDefend = itemShipinInfo.getValFromColName("raceBuffAntiDefend");
            var raceBuffSkillDamageRate = itemShipinInfo.getValFromColName("raceBuffSkillDamageRate");
            var raceBuffBlockRate = itemShipinInfo.getValFromColName("raceBuffBlockRate");
            var raceBuffCritRate = itemShipinInfo.getValFromColName("raceBuffCritRate");
            var raceBuffCritDamageRate = itemShipinInfo.getValFromColName("raceBuffCritDamageRate");
            var raceBuffHpRate = itemShipinInfo.getValFromColName("raceBuffHpRate");
            var raceBuffAntiControl = itemShipinInfo.getValFromColName("raceBuffAntiControl");
            var raceBuffHolyAtk = itemShipinInfo.getValFromColName("raceBuffHolyAtk");
            var raceBuffAtkRate = itemShipinInfo.getValFromColName("raceBuffAtkRate");
            var attr2 = [raceBuffAntiDefend, raceBuffSkillDamageRate, raceBuffBlockRate, raceBuffCritRate, raceBuffCritDamageRate,
                raceBuffHpRate, raceBuffAntiControl, raceBuffHolyAtk, raceBuffAtkRate];
            for (var j = 0; j < attr2.length; j++) {
                if (attr2[j] != 0) {
                    infoGroup.push("+" + attr2[j] / 100 + "%" + WeaponTipsData.ShipinQuality[j]);
                }
            }
        }
        return infoGroup;
    };
    WeaponTipsData.SKILLNAME = ["技能伤害率", "暴击", "攻击", "攻击", "生命", "格挡", "减伤率"];
    WeaponTipsData.SKILLPC = [true, true, false, true, false, true, true];
    /**获取饰品描述 */
    WeaponTipsData.ShipinQuality = ["格挡率", "暴击", "技能伤害", "生命", "攻击", "神圣一击", "暴击伤害", "精准", "速度", "减伤", "攻击"];
    WeaponTipsData.Rate = ["破甲", "技能伤害", "格挡", "暴击伤害", "暴击", "生命", "免控", "神圣伤害", "攻击"];
    WeaponTipsData.raceText = ["邪恶", "联盟", "自由", "巢穴", "混沌", "守序"];
    return WeaponTipsData;
}());
__reflect(WeaponTipsData.prototype, "WeaponTipsData");
var WeaponTipsViewSystem = (function (_super) {
    __extends(WeaponTipsViewSystem, _super);
    function WeaponTipsViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    WeaponTipsViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("WeaponTipsView");
    };
    WeaponTipsViewSystem.inst = new WeaponTipsViewSystem("WeaponTipsView");
    return WeaponTipsViewSystem;
}(ak.FairyGUI));
__reflect(WeaponTipsViewSystem.prototype, "WeaponTipsViewSystem");
/**
 * item提示框
 */
var WeaponTipsView = (function (_super) {
    __extends(WeaponTipsView, _super);
    /**
     * itemID 道具id
     * count 道具数量
     */
    function WeaponTipsView(itemID, count, index, itemindex, controller) {
        if (controller === void 0) { controller = false; }
        var _this = _super.call(this, WeaponTipsViewSystem.inst, MyGame.inst.tipLayer) || this;
        _this.itemID = 0;
        _this.count = 0;
        _this.index = 0;
        _this.wayindex = 0;
        _this.nowSellcount = 0;
        /**道具索引 */
        _this.itemindex = 0;
        _this.Piecenowmax = 0;
        _this.Itemnowmax = 0;
        _this.itemID = itemID;
        _this.count = count;
        _this.index = index;
        _this.nowSellcount = _this.count;
        _this.itemindex = itemindex;
        _this.isIncontroller_10 = false;
        _this.controller = controller;
        return _this;
    }
    /**回调 */
    WeaponTipsView.prototype.onInit = function () {
        var ui = this.create("WeaponTipsView", "WeaponTipsView");
        this.bgclose = ui.getChild("bgclose").asLoader;
        this.itemname = ui.getChild("itemname").asTextField;
        this.itemname2 = ui.getChild("itemname2").asTextField;
        this.itemtype = ui.getChild("itemtype").asTextField;
        this.waytext = ui.getChild("waytext").asTextField;
        this.itemattribute0 = ui.getChild("itemattribute0").asTextField;
        this.itemattribute1 = ui.getChild("itemattribute1").asTextField;
        this.itemattribute2 = ui.getChild("itemattribute2").asTextField;
        this.itemattribute3 = ui.getChild("itemattribute3").asTextField;
        this.waybtn = ui.getChild("waybtn").asButton;
        this.buybtn = ui.getChild("buybtn").asButton;
        this.hechengbtn = ui.getChild("hechengbtn").asButton;
        this.hechengbtn2 = ui.getChild("hechengbtn2").asButton;
        this.xiangqingbtn = ui.getChild("xiangqingbtn").asButton;
        this.waylist = ui.getChild("waylist").asList;
        this.itemCom = ui.getChild("itemCom").asCom;
        this.controller_c1 = ui.getController("c1");
        this.itemname3 = ui.getChild("itemname3").asTextField;
        this.nownum = ui.getChild("nownum").asTextInput;
        this.nowmoney = ui.getChild("nowmoney").asTextField;
        this.buybtn2 = ui.getChild("buybtn2").asButton;
        this.numleftbtn = ui.getChild("numleftbtn").asButton;
        this.numrightbtn = ui.getChild("numrightbtn").asButton;
        this.item2 = ui.getChild("item2").asCom;
        this.usebtn = ui.getChild("usebtn").asButton;
        this.use2btn = ui.getChild("use2btn").asButton;
        this.ClickAdd();
        this.setItemInfo();
        this.SetController_2();
        this.isIncontroller_10 = false;
        this.Piecenowmax = 0;
    };
    WeaponTipsView.prototype.ClickAdd = function () {
        this.addClickListener(this.bgclose, this.onclick, this);
        this.addClickListener(this.waybtn, this.onclick, this);
        this.addClickListener(this.buybtn, this.onclick, this);
        this.addClickListener(this.hechengbtn, this.onclick, this);
        this.addClickListener(this.buybtn2, this.onclick, this);
        this.addClickListener(this.numleftbtn, this.onclick, this);
        this.addClickListener(this.numrightbtn, this.onclick, this);
        this.addClickListener(this.xiangqingbtn, this.onclick, this);
        this.addClickListener(this.hechengbtn2, this.onclick, this);
        this.addClickListener(this.usebtn, this.onclick, this);
        this.addClickListener(this.use2btn, this.onclick, this);
        this.onFairyguiEvent(this.waylist, fairygui.ItemEvent.CLICK, this.waylistHandle, this);
        this.onFairyguiEvent(this.nownum, egret.FocusEvent.FOCUS_OUT, this.numchange, this);
    };
    WeaponTipsView.prototype.onclick = function (e) {
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.waybtn:
                this.controller_c1.selectedIndex = (this.wayindex);
                break;
            case this.buybtn:
                this.controller_c1.selectedIndex = (8);
                break;
            case this.hechengbtn:
                this.hechengitemHanle();
                break;
            case this.buybtn2:
                this.buyitemHanle();
                break;
            case this.numleftbtn:
                this.Setleftnum();
                break;
            case this.numrightbtn:
                this.Setrightnum();
                break;
            case this.xiangqingbtn:
                var heroID = WeaponTipsData.inst().GetHeroID(this.itemID);
                if (heroID == 0) {
                    return;
                }
                else {
                    this.close();
                    ak.FairyGUI.open(["HeroCultivateView", 0, heroID, [], 1]);
                }
                break;
            case this.hechengbtn2:
                this.hechengitemHanle2();
                break;
            case this.usebtn:
                this.useitemHandle();
                break;
            case this.use2btn:
                this.useitemHandle2();
                break;
        }
    };
    /**根据玩家输入数量去操作 */
    WeaponTipsView.prototype.numchange = function () {
        var textnum = Number(this.nownum.text);
        if (textnum < 1) {
            TipsViewSystem.show("已经超过最小值了");
            this.nownum.text = "" + 1;
            this.nowSellcount = 1;
            this.nowmoney.text = String(BagData.inst().GetitemMoneyById(this.itemID) * this.nowSellcount);
            return;
        }
        if (this.isIncontroller_10) {
            if (textnum > this.Piecenowmax) {
                TipsViewSystem.show("已经超过最大值了");
                this.nownum.text = "" + this.Piecenowmax;
                this.nowSellcount = this.Piecenowmax;
                this.nowmoney.text = String(BagData.inst().GetitemMoneyById(this.itemID) * this.nowSellcount);
                return;
            }
        }
        else {
            if (textnum > this.count) {
                TipsViewSystem.show("已经超过最大值了");
                this.nownum.text = "" + this.count;
                this.nowSellcount = this.count;
                this.nowmoney.text = String(BagData.inst().GetitemMoneyById(this.itemID) * this.nowSellcount);
                return;
            }
        }
        this.nowSellcount = textnum;
        this.nownum.text = String(this.nowSellcount);
        this.nowmoney.text = String(BagData.inst().GetitemMoneyById(this.itemID) * this.nowSellcount);
    };
    WeaponTipsView.prototype.setItemInfo = function () {
        var items = new ItemBase(this.itemCom, this, 1);
        items.setItemData(this.itemID);
        if (this.index != 1) {
            items.setStar2(BagData.inst().GetStarById(this.itemID));
        }
        else {
            items.setStar2(0);
        }
        items.setNumber(String(this.count), true);
        if (BagData.inst().GetBagtypeById(this.itemID) == 3) {
            var race = BagData.inst().isOnlyRacePiece(this.itemID);
            items.setType(race);
        }
        else {
            items.setType(0);
        }
        if (BagData.inst().GetBagtypeById(this.itemID) == 1) {
            if (WeaponTipsData.inst().isTaozhuang(this.itemID)) {
                var tzID = BagData.inst().GetTaozhuangIdById(this.itemID);
                var info = BagData.inst().GetTaozhuangInfoByTzID(tzID);
                this.itemname2.text = info.name + "(4)";
                this.itemattribute1.text = "" + info.hpRate2;
                this.itemattribute2.text = "" + info.atkRate3;
                this.itemattribute3.text = "" + info.hpRate4;
            }
        }
        this.itemname.text = WeaponTipsData.inst().GetNameById(this.itemID);
        this.itemname.color = Color.itemColor[BagData.inst().GetColorById(this.itemID)];
        this.itemtype.text = WeaponTipsData.inst().GetTypeById(this.itemID);
        this.itemattribute0.text = WeaponTipsData.inst().GetTextById(this.itemID);
        if (!this.controller)
            this.SetController();
        this.SetNumViewInfo();
        this.isshowWay();
    };
    WeaponTipsView.prototype.SetController = function () {
        if (this.index == 0 || this.index == 3) {
            if (WeaponTipsData.inst().isTaozhuang(this.itemID)) {
                this.controller_c1.selectedIndex = (1);
                this.wayindex = 5;
            }
            else {
                this.controller_c1.selectedIndex = (0);
                this.wayindex = 4;
            }
        }
        if (this.index == 1) {
            //this.controller_c1.selectedIndex=(2);
            if (WeaponTipsData.inst().GetUsetypeById(this.itemID) == 1) {
                this.controller_c1.selectedIndex = (11);
            }
            else {
                this.controller_c1.selectedIndex = (2);
            }
            this.wayindex = 6;
        }
        if (this.index == 2) {
            if (WeaponTipsData.inst().isOnly(this.itemID)) {
                this.controller_c1.selectedIndex = (9);
            }
            else {
                this.controller_c1.selectedIndex = (3);
            }
            this.wayindex = 7;
        }
    };
    WeaponTipsView.prototype.SetController_2 = function () {
        if (this.controller)
            this.controller_c1.selectedIndex = (2);
    };
    WeaponTipsView.prototype.SetNumViewInfo = function () {
        var items = new ItemBase(this.item2, this, 1);
        items.setItemData(this.itemID);
        if (this.index != 1) {
            items.setStar2(BagData.inst().GetStarById(this.itemID));
        }
        else {
            items.setStar2(0);
        }
        items.setNumber(String(this.count), true);
        if (BagData.inst().GetBagtypeById(this.itemID) == 3) {
            var race = BagData.inst().isOnlyRacePiece(this.itemID);
            items.setType(race);
        }
        else {
            items.setType(0);
        }
        this.itemname3.text = WeaponTipsData.inst().GetNameById(this.itemID);
        this.itemname3.color = Color.itemColor[BagData.inst().GetColorById(this.itemID)];
        this.nownum.text = String(this.nowSellcount);
        this.nowmoney.text = String(BagData.inst().GetitemMoneyById(this.itemID) * this.nowSellcount);
    };
    WeaponTipsView.prototype.Setleftnum = function () {
        if (this.nowSellcount >= 2) {
            this.nowSellcount--;
            this.nownum.text = String(this.nowSellcount);
        }
        else {
            TipsViewSystem.show("已经是最小值了");
        }
        this.nowmoney.text = String(BagData.inst().GetitemMoneyById(this.itemID) * this.nowSellcount);
    };
    WeaponTipsView.prototype.Setrightnum = function () {
        if (this.isIncontroller_10) {
            if (this.nowSellcount < this.Piecenowmax) {
                this.nowSellcount++;
                this.nownum.text = String(this.nowSellcount);
            }
            else {
                TipsViewSystem.show("已经是最大值了");
            }
        }
        else {
            if (this.nowSellcount < this.count) {
                this.nowSellcount++;
                this.nownum.text = String(this.nowSellcount);
            }
            else {
                TipsViewSystem.show("已经是最大值了");
            }
        }
        this.nowmoney.text = String(BagData.inst().GetitemMoneyById(this.itemID) * this.nowSellcount);
    };
    /**卖出rpc */
    WeaponTipsView.prototype.buyitemHanle = function () {
        var _this = this;
        net.itemSell(this.itemindex, this.nowSellcount, function () {
            _this.close();
        }, this);
    };
    /**碎片合成rpc */
    WeaponTipsView.prototype.hechengitemHanle = function () {
        var _this = this;
        if (WeaponTipsData.inst().isMoreOnePiecehz(this.itemID, this.count)) {
            this.controller_c1.selectedIndex = (10);
            this.setPieceMaxnum();
            this.isIncontroller_10 = true;
        }
        else {
            var max = BagData.inst().GetPieceMaxNum(this.itemID);
            var now = SummonData.inst().GetItemnumByid(this.itemID);
            if (now < max) {
                TipsViewSystem.show("碎片不足");
                return;
            }
            net.itemPieceCompose(this.itemindex, 1, function () {
                _this.close();
            }, this);
        }
    };
    /**碎片合成rpc */
    WeaponTipsView.prototype.hechengitemHanle2 = function () {
        var _this = this;
        var max = BagData.inst().GetPieceMaxNum(this.itemID);
        var now = SummonData.inst().GetItemnumByid(this.itemID);
        if (now < max) {
            TipsViewSystem.show("碎片不足");
            return;
        }
        net.itemPieceCompose(this.itemindex, this.nowSellcount, function () {
            _this.close();
        }, this);
    };
    /**使用道具 */
    WeaponTipsView.prototype.useitemHandle = function () {
        this.controller_c1.selectedIndex = (12);
        this.setItemMaxnum();
    };
    /**使用道具rpc */
    WeaponTipsView.prototype.useitemHandle2 = function () {
        var _this = this;
        net.itemUse(this.itemindex, this.nowSellcount, function () {
            _this.close();
        }, this);
    };
    /**碎片最大值赋值 */
    WeaponTipsView.prototype.setPieceMaxnum = function () {
        var max = BagData.inst().GetPieceMaxNum(this.itemID);
        var nowmax = Math.floor(this.count / max);
        this.Piecenowmax = nowmax;
        this.nowSellcount = this.Piecenowmax;
        this.nownum.text = String(this.nowSellcount);
    };
    WeaponTipsView.prototype.setItemMaxnum = function () {
        var nowmax = SummonData.inst().GetItemnumByid(this.itemID);
        this.Itemnowmax = nowmax;
        this.nowSellcount = this.Itemnowmax;
        this.nownum.text = String(this.nowSellcount);
    };
    /**判断是否显示获取路径 */
    WeaponTipsView.prototype.isshowWay = function () {
        var waylistattr = WeaponTipsData.inst().GetItemWayById(this.itemID);
        this.waytext.visible = this.waybtn.visible = (waylistattr.length > 0);
        if (waylistattr.length > 0) {
            this.waylist.removeChildrenToPool();
            for (var i = 0; i < waylistattr.length; i++) {
                var atr = "" + waylistattr[i];
                if (waylistattr[i] < 10) {
                    atr = "0" + waylistattr[i];
                }
                var item = this.waylist.addItemFromPool().asButton;
                var icon = item.getChild("icon").asLoader;
                var txt = item.getChild("txt").asTextField;
                var info = WeaponTipsData.inst().GetWayInfoyByWayId(waylistattr[i]);
                this.setLoaderUrl(icon, "ui://WeaponTipsView/" + info.pic);
                txt.text = "" + info.name;
                item.data = { jump: info.jump };
            }
        }
    };
    WeaponTipsView.prototype.waylistHandle = function (obj) {
        var item = obj.itemObject;
        var jump = item.data.jump;
        this.close();
        ak.FairyGUI.open(jump["open"]);
    };
    return WeaponTipsView;
}(ak.EasyUI));
__reflect(WeaponTipsView.prototype, "WeaponTipsView");
var WishingwellData = (function () {
    function WishingwellData() {
    }
    /**
     * 获取一个单例
     * @returns {any}
     */
    WishingwellData.inst = function () {
        var Class = this;
        if (!Class._instance) {
            Class._instance = new WishingwellData();
        }
        return Class._instance;
    };
    /**
     * 判断是否可以免费刷新
     */
    WishingwellData.prototype.isFreeRefurbish = function (type) {
        return false;
    };
    /**
     * 获取道具
     */
    WishingwellData.prototype.getItemGroup = function (type) {
        var itemGroup1 = MyData.user.json.wishPool.resArr;
        var itemGroup2 = MyData.user.json.wishPool.resArr2;
        if (type == 0) {
            return itemGroup1;
        }
        else {
            return itemGroup2;
        }
    };
    /**
     * 获取许愿池表信息
     */
    WishingwellData.prototype.GetWishwellInfo = function () {
        var wishPoorConfigTab = ak.JsonTableMgr.get("wishPoorConfig");
        var wishPoorConfigInfo = wishPoorConfigTab.getRow(0);
        var item = wishPoorConfigInfo.getValFromColName("item");
        var zs = wishPoorConfigInfo.getValFromColName("zs");
        var prize = wishPoorConfigInfo.getValFromColName("prize");
        var prizeNum = wishPoorConfigInfo.getValFromColName("prizeNum");
        var info = { item: item, zs: zs, prize: prize, prizeNum: prizeNum };
        return info;
    };
    /**
     * 判断道具是否可以重复抽取
     */
    WishingwellData.prototype.IsItemRepeat = function (type, index) {
        var wishPoorPickfigTab = ak.JsonTableMgr.get("wishPoorPick");
        for (var i = 0; i < wishPoorPickfigTab.size(); i++) {
            var wishPoorPickfigInfo = wishPoorPickfigTab.getRowFromColName("id", String(i + 1));
            var type0 = wishPoorPickfigInfo.getValFromColName("type");
            if (type == type0) {
                var minlevel = wishPoorPickfigInfo.getValFromColName("levelMin");
                var maxlevel = wishPoorPickfigInfo.getValFromColName("levelMax");
                var lv = MyData.user.level;
                if (lv >= minlevel && lv <= maxlevel) {
                    var repeat1 = wishPoorPickfigInfo.getValFromColName("repeat1");
                    var repeat2 = wishPoorPickfigInfo.getValFromColName("repeat2");
                    var repeat3 = wishPoorPickfigInfo.getValFromColName("repeat3");
                    var repeat4 = wishPoorPickfigInfo.getValFromColName("repeat4");
                    var repeat5 = wishPoorPickfigInfo.getValFromColName("repeat5");
                    var repeat6 = wishPoorPickfigInfo.getValFromColName("repeat6");
                    var repeat7 = wishPoorPickfigInfo.getValFromColName("repeat7");
                    var repeat8 = wishPoorPickfigInfo.getValFromColName("repeat8");
                    var repeatArr = [repeat1, repeat2, repeat3, repeat4, repeat5, repeat6, repeat7, repeat8];
                    var finalnum = repeatArr[index];
                    if (finalnum == 1) {
                        return true;
                    }
                    else {
                        return false;
                    }
                }
            }
        }
        return true;
    };
    WishingwellData.prototype.getItemMax = function (id) {
        var wishPoorTab = ak.JsonTableMgr.get("wishPoor");
        var wishPoorInfo = wishPoorTab.getRowFromColName("id", "" + id);
        var ten = wishPoorInfo.getValFromColName("ten");
        return ten;
    };
    return WishingwellData;
}());
__reflect(WishingwellData.prototype, "WishingwellData");
var WishingwellViewSystem = (function (_super) {
    __extends(WishingwellViewSystem, _super);
    function WishingwellViewSystem(groupName) {
        return _super.call(this, groupName) || this;
    }
    WishingwellViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("WishingwellView");
    };
    WishingwellViewSystem.inst = new WishingwellViewSystem("WishingwellView");
    return WishingwellViewSystem;
}(ak.FairyGUI));
__reflect(WishingwellViewSystem.prototype, "WishingwellViewSystem");
/**
 * 许愿池
 */
var WishingwellView = (function (_super) {
    __extends(WishingwellView, _super);
    function WishingwellView() {
        var _this = _super.call(this, WishingwellViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
        _this.index = 0;
        _this.itemGroup = [];
        _this.listinfo = null;
        return _this;
    }
    //初始化回调
    WishingwellView.prototype.onInit = function () {
        var ui = this.create("WishingwellView", "WishingwellView");
        this.on(GameEvent.wishPoolBuy, this.updateView, this);
        this.on(GameEvent.wishPoolMCupdate, this.updateMC, this);
        this.closebtn = ui.getChild("closebtn").asButton;
        this.tipsbtn = ui.getChild("tipsbtn").asButton;
        this.tab = ui.getChild("tab").asCom;
        this.onebtn = ui.getChild("onebtn").asButton;
        this.tenbtn = ui.getChild("tenbtn").asButton;
        this.list = ui.getChild("list").asList;
        this.addbtn = ui.getChild("addbtn").asButton;
        this.itemnum = ui.getChild("itemnum").asTextField;
        this.jinbi = ui.getChild("jinbi").asLoader;
        this.leftbtn = this.ui.getChild("tab").asCom.getChild("leftbtn").asButton;
        this.rightbtn = this.ui.getChild("tab").asCom.getChild("rightbtn").asButton;
        this.updatebtn = this.ui.getChild("updatebtn").asLoader;
        this.freetxt = this.ui.getChild("freetxt").asTextField;
        this.nofreeGroup = this.ui.getChild("nofreeGroup").asGroup;
        this.zuannum = this.ui.getChild("zuannum").asTextField;
        this.rotateCom = this.ui.getChild("rotateCom").asCom;
        this.control_c1 = this.ui.getController("c1");
        this.wishpoolshop = this.ui.getChild("n55").asButton;
        for (var i = 0; i < 8; i++) {
            this.itemGroup.push(this.ui.getChild("rotateCom").asCom.getChild("item" + i).asCom);
        }
        this.ClickAdd();
        this.staticView();
        this.updateView();
        this.staticMC();
        this.rpcupdate();
        this.updateList();
    };
    WishingwellView.prototype.ClickAdd = function () {
        this.addClickListener(this.closebtn, this.onClick, this);
        this.addClickListener(this.tipsbtn, this.onClick, this);
        this.addClickListener(this.onebtn, this.onClick, this);
        this.addClickListener(this.tenbtn, this.onClick, this);
        this.addClickListener(this.addbtn, this.onClick, this);
        this.addClickListener(this.leftbtn, this.onClick, this);
        this.addClickListener(this.rightbtn, this.onClick, this);
        this.addClickListener(this.updatebtn, this.onClick, this);
        this.addClickListener(this.wishpoolshop, this.onClick, this);
        for (var i = 0; i < this.itemGroup.length; i++) {
            this.addClickListener(this.itemGroup[i], this.itemonclick, this);
        }
    };
    WishingwellView.prototype.staticView = function () {
        var title1 = this.leftbtn.getChild("title").asTextField;
        var title2 = this.rightbtn.getChild("title").asTextField;
        title1.text = "普通祭坛";
        title2.text = "高级祭坛";
    };
    WishingwellView.prototype.onClick = function (e) {
        switch (e.target) {
            case this.closebtn:
                this.close();
                break;
            case this.tipsbtn:
                ak.FairyGUI.open(["HelpTipsView", 8]);
                break;
            case this.onebtn:
                this.luckDraw(this.index + 1, 1);
                break;
            case this.tenbtn:
                this.luckDraw(this.index + 1, 2);
                break;
            case this.addbtn:
                ak.FairyGUI.open(["BuyTipsView",
                    BagData.inst().GetIconById(WishingwellData.inst().GetWishwellInfo().item),
                    BagData.inst().GetColorById(WishingwellData.inst().GetWishwellInfo().item),
                    BagData.inst().GetNameById(WishingwellData.inst().GetWishwellInfo().item),
                    WishingwellData.inst().GetWishwellInfo().zs,
                    1
                ]);
                break;
            case this.leftbtn:
                this.index = 0;
                this.showViewStack();
                break;
            case this.rightbtn:
                if (this.isopen()) {
                    this.index = 1;
                    this.showViewStack();
                }
                else {
                    this.index = 0;
                    this.rightbtn.selected = false;
                    this.leftbtn.selected = true;
                    TipsViewSystem.show("等级45或vip17开启");
                }
                break;
            case this.updatebtn:
                this.wishPoolFlush();
                break;
            case this.wishpoolshop:
                ak.FairyGUI.open(["WishPoolShopView"]);
                //TipsViewSystem.show("转盘商店暂未开放");
                break;
        }
    };
    WishingwellView.prototype.showViewStack = function () {
        this.control_c1.selectedIndex = this.index;
        this.updateView();
        this.updateList();
    };
    /**
     * 根据index的修改界面的信息
     */
    WishingwellView.prototype.updateView = function () {
        var icon1 = this.onebtn.getChild("icon").asLoader;
        var icon2 = this.tenbtn.getChild("icon").asLoader;
        var number1 = this.onebtn.getChild("number").asTextField;
        var number2 = this.tenbtn.getChild("number").asTextField;
        number1.text = "1";
        if (this.index == 0) {
            this.setLoaderUrl(this.jinbi, "ui://WishingwellView/token_ptyb");
            this.setLoaderUrl(icon1, "ui://WishingwellView/token_ptyb");
            this.setLoaderUrl(icon2, "ui://WishingwellView/token_ptyb");
            this.addbtn.visible = true;
            number2.text = "" + WishingwellData.inst().getItemMax(1);
        }
        else {
            this.setLoaderUrl(this.jinbi, "ui://WishingwellView/token_gjyb");
            this.setLoaderUrl(icon1, "ui://WishingwellView/token_gjyb");
            this.setLoaderUrl(icon2, "ui://WishingwellView/token_gjyb");
            this.addbtn.visible = false;
            number2.text = "" + WishingwellData.inst().getItemMax(2);
        }
        this.updateItem();
        this.updateRefurbish();
        this.updateItemNum();
    };
    WishingwellView.prototype.rpcupdate = function () {
        var _this = this;
        net.get10(function (msg) {
            _this.listinfo = msg[2];
        }, this);
    };
    /**更新下面滚动的文字 */
    WishingwellView.prototype.updateList = function () {
        var infoGroup = [];
        if (this.listinfo != null) {
            infoGroup = this.index == 0 ? this.listinfo.arr : this.listinfo.arr2;
        }
        else {
            infoGroup = [];
        }
        this.list.removeChildrenToPool();
        for (var i = 0; i < infoGroup.length; i++) {
            var item = this.list.addItemFromPool().asCom;
            var text = item.getChild("text").asTextField;
            text.text = infoGroup[i].nickname + "\u83B7\u5F97" + BagData.inst().GetNameByTYPEandID(infoGroup[i].res.type, infoGroup[i].res.id) + "X" + infoGroup[i].res.num;
        }
        var y = 0;
        if (infoGroup.length >= 9) {
            y = infoGroup.length - 8;
        }
        this.ListMC(y);
    };
    WishingwellView.prototype.ListMC = function (y) {
        var _this = this;
        egret.Tween.removeTweens(this.list.scrollPane);
        this.list.scrollPane.posY = 0;
        egret.Tween.get(this.list.scrollPane, { loop: false }).
            to({ posY: this.list.scrollPane.viewHeight + 40 * y }, 3000).call(function () {
            _this.updateList();
        });
    };
    /**更新8个道具 */
    WishingwellView.prototype.updateItem = function () {
        var GroupInfo = WishingwellData.inst().getItemGroup(this.index);
        if (GroupInfo.length < 1)
            return;
        for (var i = 0; i < this.itemGroup.length; i++) {
            var nowGroupInfo = GroupInfo[i];
            this.itemGroup[i].data = nowGroupInfo;
            var items = new ItemBase(this.itemGroup[i], this, nowGroupInfo.type);
            items.setItemData(nowGroupInfo.id);
            items.setNumber(nowGroupInfo.num, true);
            /**如果抽过不可重复的道具，需要致灰 */
            if (this.index == 0) {
                if (MyData.user.json.wishPool.getResArrIndexMap[i] && !WishingwellData.inst().IsItemRepeat(this.index + 1, i)) {
                    this.itemGroup[i].enabled = false;
                }
                else {
                    this.itemGroup[i].enabled = true;
                }
            }
            else {
                if (MyData.user.json.wishPool.getResArrIndexMap2[i] && !WishingwellData.inst().IsItemRepeat(this.index + 1, i)) {
                    this.itemGroup[i].enabled = false;
                }
                else {
                    this.itemGroup[i].enabled = true;
                }
            }
        }
    };
    /**更新按钮文字 */
    WishingwellView.prototype.updateRefurbish = function () {
        if (WishingwellData.inst().isFreeRefurbish(this.index)) {
            this.freetxt.visible = true;
            this.nofreeGroup.visible = false;
        }
        else {
            this.freetxt.visible = false;
            this.nofreeGroup.visible = true;
            if (this.index == 0) {
                this.zuannum.text = "3000";
            }
            else {
                this.zuannum.text = "6000";
            }
        }
    };
    /**更新道具数量 */
    WishingwellView.prototype.updateItemNum = function () {
        var nownum = this.index == 0 ? SummonData.inst().GetItemnumByid(2007) : SummonData.inst().GetItemnumByid(2008);
        this.itemnum.text = "" + nownum;
    };
    WishingwellView.prototype.wishPoolFlush = function () {
        var _this = this;
        net.wishPoolFlush(this.index + 1, function () {
            _this.updateView();
        }, this);
    };
    WishingwellView.prototype.luckDraw = function (type, num) {
        var _this = this;
        if (type == 1) {
            if (num == 1) {
                if (SummonData.inst().GetItemnumByid(2007) < 1) {
                    TipsViewSystem.show("道具不足");
                    return;
                }
            }
            else {
                if (Vip.getRight(17) == 1) {
                    if (SummonData.inst().GetItemnumByid(2007) < WishingwellData.inst().getItemMax(1)) {
                        TipsViewSystem.show("道具不足");
                        return;
                    }
                }
                else {
                    TipsViewSystem.show("vip17" + "开启普通许愿池十连抽");
                    return;
                }
            }
        }
        else {
            if (num == 1) {
                if (SummonData.inst().GetItemnumByid(2008) < 1) {
                    TipsViewSystem.show("道具不足");
                    return;
                }
            }
            else {
                if (SummonData.inst().GetItemnumByid(2008) < WishingwellData.inst().getItemMax(2)) {
                    TipsViewSystem.show("道具不足");
                    return;
                }
            }
        }
        net.luckDraw(type, num, function (msg) {
            _this.luckDrawMC(msg);
            _this.updateItem();
            _this.rpcupdate();
        }, this);
    };
    WishingwellView.prototype.staticMC = function () {
        egret.Tween.removeTweens(this.rotateCom);
        egret.Tween.get(this.rotateCom, { loop: true }).to({ rotation: -30 }, 1000).to({ rotation: 0 }, 2000);
    };
    WishingwellView.prototype.luckDrawMC = function (msg) {
        var _this = this;
        this.touchendandok(0);
        egret.Tween.removeTweens(this.rotateCom);
        egret.Tween.get(this.rotateCom).to({ rotation: 360 - this.rotationNum(msg[2]) * 45 }, 1000).call(function () {
            _this.updateView();
            _this.touchendandok(1);
            ak.FairyGUI.open(["GainitemView", msg[2]]);
        });
    };
    WishingwellView.prototype.rotationNum = function (msg) {
        var GroupInfo = WishingwellData.inst().getItemGroup(this.index);
        var list = [];
        var num = 0;
        for (var i = 0; i < msg.length; i++) {
            list.push({ type: msg[i].type, id: msg[i].id, count: msg[i].num });
        }
        for (var i = 0; i < 8; i++) {
            var nowGroupInfo = GroupInfo[i];
            if (nowGroupInfo.id == Number(list[0].id) && nowGroupInfo.type == list[0].type && nowGroupInfo.num == list[0].count) {
                num = i;
            }
        }
        return num;
    };
    WishingwellView.prototype.updateMC = function () {
        this.rotateCom.rotation = 0;
        this.staticMC();
    };
    WishingwellView.prototype.touchendandok = function (num) {
        this.closebtn.visible = num == 0 ? false : true;
        this.tipsbtn.visible = num == 0 ? false : true;
        this.onebtn.visible = num == 0 ? false : true;
        this.tenbtn.visible = num == 0 ? false : true;
        this.leftbtn.visible = num == 0 ? false : true;
        this.rightbtn.visible = num == 0 ? false : true;
        this.updatebtn.visible = num == 0 ? false : true;
        this.wishpoolshop.visible = num == 0 ? false : true;
        if (this.index == 0) {
            this.addbtn.visible = num == 0 ? false : true;
        }
        else {
            this.addbtn.visible = false;
        }
    };
    WishingwellView.prototype.itemonclick = function (e) {
        if (e.target.data.type != 3) {
            var bagtype = ak.JsonTableMgr.get("item").getRowFromColName("id", "" + e.target.data.id).getValFromColName("bagtype");
            ak.FairyGUI.open(["WeaponTipsView", e.target.data.id, e.target.data.num, bagtype - 1, 0, true]);
        }
        else {
            ak.FairyGUI.open(["ResourceTipsView", e.target.data.id, e.target.data.num]);
        }
    };
    /**
     * 判断是否开启高级许愿池
     */
    WishingwellView.prototype.isopen = function () {
        // if(Vip.getRight(17) == 1) {
        if (MyData.user.vip >= 17) {
            return true;
        }
        if (GameSystem.isSysOpen(3, false)) {
            return true;
        }
        return false;
    };
    return WishingwellView;
}(ak.EasyUI));
__reflect(WishingwellView.prototype, "WishingwellView");
//许愿池商店系统
var WishPoolShopViewSystem = (function (_super) {
    __extends(WishPoolShopViewSystem, _super);
    function WishPoolShopViewSystem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    WishPoolShopViewSystem.prototype.init = function () {
        fairygui.UIPackage.addPackage("WishingwellView");
    };
    WishPoolShopViewSystem.inst = new WishPoolShopViewSystem("WishingwellView");
    return WishPoolShopViewSystem;
}(ak.FairyGUI));
__reflect(WishPoolShopViewSystem.prototype, "WishPoolShopViewSystem");
var WishPoolShopView = (function (_super) {
    __extends(WishPoolShopView, _super);
    function WishPoolShopView() {
        return _super.call(this, WishPoolShopViewSystem.inst, MyGame.inst.uiLayer2_1) || this;
    }
    //初始化
    WishPoolShopView.prototype.onInit = function () {
        var ui = this.create("WishingwellView", "WishPoolShopView");
        this.bgclose = this.ui.getChild("bgclose").asLoader;
        this.wishpoollist = this.ui.getChild("n10").asList;
        this.resetbutton = this.ui.getChild("n8").asButton;
        this.myzhuanpanjifen = this.ui.getChild("n9").asCom;
        this.wishpoolshopTab = ak.JsonTableMgr.get("shopWishPool");
        this.wishpoolshopConfigTab = ak.JsonTableMgr.get("shopWishPoolConfig");
        this.clickAdd();
        this.setstaticView();
        this.showWishpoolList();
    };
    WishPoolShopView.prototype.clickAdd = function () {
        this.addClickListener(this.bgclose, this.Onclick, this);
        this.addClickListener(this.resetbutton, this.Onclick, this);
        this.onFairyguiEvent(this.wishpoollist, fairygui.ItemEvent.CLICK, this.buyMarket, this);
    };
    WishPoolShopView.prototype.Onclick = function (e) {
        var _this = this;
        switch (e.target) {
            case this.bgclose:
                this.close();
                break;
            case this.resetbutton:
                net.wishPoolShopFlush(function () { _this.showWishpoolList(); }, this); //刷新许愿池商店
                break;
        }
    };
    WishPoolShopView.prototype.showWishpoolList = function () {
        ShopData.inst().setShopView(this, 1, this.wishpoollist, MyData.user.json.wishPoolShop.buyIDArr, this.wishpoolshopTab, MyData.user.json.wishPoolShop.buyCountMap, this.myzhuanpanjifen);
    };
    //购买
    WishPoolShopView.prototype.buyMarket = function (obj) {
        var item = obj.itemObject;
        for (var i = 0; i < 3; i++) {
            var itemCom = item.getChild("n1" + (i + 1)).asCom;
            var item1 = itemCom.getChild("n2").asCom; //获取元素中的物品栏
            if (this.hitTestPointWithFairyGUIComponent(itemCom, obj.stageX, obj.stageY)) {
                if (this.hitTestPointWithFairyGUIComponent(item1, obj.stageX, obj.stageY)) {
                    ak.FairyGUI.open(["WeaponTipsView", item1.data.id, item1.data.num, 1]);
                }
                else {
                    if (itemCom.data.limit - MyData.user.json.wishPoolShop.buyCountMap[itemCom.data.index] != 0) {
                        if (SummonData.inst().GetItemnumByid(itemCom.data.CostItem) >= itemCom.data.CostNum) {
                            ak.FairyGUI.open(["ChooseTipsView", 4, '确定购买当前商品？', this.showWishpoolList.bind(this), itemCom.data.index]);
                        }
                        else {
                            TipsViewSystem.show("转盘积分不够");
                            return;
                        }
                    }
                    else {
                        TipsViewSystem.show("当天购买次数已达到上限");
                        return;
                    }
                }
            }
        }
    };
    WishPoolShopView.prototype.setstaticView = function () {
        var photo_url_path = "ui://common/token_xyjf";
        //重置按钮
        var icon1 = this.resetbutton.getChild("icon").asLoader;
        var number1 = this.resetbutton.getChild("number").asTextField;
        var res_text = this.resetbutton.getChild("title").asTextField;
        //我的转盘积分
        var icon2 = this.myzhuanpanjifen.getChild("icon").asLoader;
        var number2 = this.myzhuanpanjifen.getChild("number").asTextField;
        this.setLoaderUrl(icon1, photo_url_path);
        this.setLoaderUrl(icon2, photo_url_path);
        var wishpoolshopConfigInfo = this.wishpoolshopConfigTab.getRow(0);
        number1.text = wishpoolshopConfigInfo.getValFromColName("freshNum");
        res_text.text = "重置";
        //我的转盘积分 默认为0
        number2.text = "" + SummonData.inst().GetItemnumByid(wishpoolshopConfigInfo.getValFromColName("freshCost"));
        Common.labelIsOverLenght(number2, number2.text);
    };
    return WishPoolShopView;
}(ak.EasyUI));
__reflect(WishPoolShopView.prototype, "WishPoolShopView");
//卡牌管理器
var CardMgr = (function () {
    function CardMgr() {
    }
    //获取卡牌最大数量
    CardMgr.getCardMaxCount = function () {
        return (MyData.user.cardMaxCount + Vip.getRight(101));
    };
    //获取卡牌信息
    CardMgr.getCard = function (index) {
        var cardArr = MyData.user.json.cardArr;
        return cardArr[index];
    };
    //根据ID获取卡牌
    CardMgr.getItemByID = function (heroID) {
        var cardArr = MyData.user.json.cardArr;
        var c = cardArr.length;
        for (var i = 0; i < c; ++i) {
            var card = cardArr[i];
            if (card.heroID == heroID) {
                return card;
            }
        }
        return null;
    };
    //英雄合成所有条件是否满足
    CardMgr.isCardCompose = function (heroID) {
        var heroComposeTab = ak.JsonTableMgr.get("heroCompose");
        var heroTab = ak.JsonTableMgr.get("hero");
        var needHeroIDArr = [];
        var needHeroIDCountArr = [];
        var heroTabInfo = heroTab.getRowFromColName("id", "" + heroID);
        var race = Number(heroTabInfo.getValFromColName("race")); //种族
        var star = Number(heroTabInfo.getValFromColName("star")); //星级
        var heroComposeInfo = heroComposeTab.getRowFromColName("heroID", "" + heroID); //选中的英雄
        var mainHero = Number(heroComposeInfo.getValFromColName("mainHero")); //主英雄
        var mainHeroNum = Number(heroComposeInfo.getValFromColName("mainHeroNum")); //主英雄数量
        var delHero1 = Number(heroComposeInfo.getValFromColName("delHero1")); //副英雄1（负数为同种族对应星级，比如-3为同种族3星）
        var delHeroNum1 = Number(heroComposeInfo.getValFromColName("delHeroNum1")); //副英雄数量1
        var delHero2 = Number(heroComposeInfo.getValFromColName("delHero2")); //副英雄2
        var delHeroNum2 = Number(heroComposeInfo.getValFromColName("delHeroNum2")); //副英雄数量2
        var delHero3 = Number(heroComposeInfo.getValFromColName("delHero3")); //副英雄3
        var delHeroNum3 = Number(heroComposeInfo.getValFromColName("delHeroNum3")); //副英雄数量3
        needHeroIDArr.push(mainHero, delHero1, delHero2, delHero3);
        needHeroIDCountArr.push(mainHeroNum, delHeroNum1, delHeroNum2, delHeroNum3);
        var count = needHeroIDArr.length;
        var cardArr = MyData.user.json.cardArr;
        var cardArrCount = cardArr.length;
        var satisfyCompositeMap = {};
        var pass = true;
        for (var i = 0; i < count; i++) {
            var needHeroID = needHeroIDArr[i];
            var needHeroIDCount = needHeroIDCountArr[i];
            if (needHeroID == -3 || needHeroID == -4 || needHeroID == -5) {
                for (var j = 0; j < cardArrCount; j++) {
                    var heroInfo = cardArr[j];
                    var heroIDS = heroInfo.heroID;
                    var starMaxS = heroInfo.starMax;
                    var raceS = heroInfo.race;
                    if (Math.abs(needHeroID) == starMaxS && race == raceS) {
                        if (satisfyCompositeMap[needHeroID]) {
                            satisfyCompositeMap[needHeroID] += 1;
                        }
                        else {
                            satisfyCompositeMap[needHeroID] = 1;
                        }
                    }
                }
            }
            else {
                if (!satisfyCompositeMap[needHeroID]) {
                    for (var j = 0; j < cardArrCount; j++) {
                        var heroInfo = cardArr[j];
                        var heroIDS = heroInfo.heroID;
                        if (heroIDS == needHeroID) {
                            if (satisfyCompositeMap[needHeroID]) {
                                satisfyCompositeMap[needHeroID] += 1;
                            }
                            else {
                                satisfyCompositeMap[needHeroID] = 1;
                            }
                        }
                    }
                }
            }
            if (satisfyCompositeMap[needHeroID] < needHeroIDCount || !satisfyCompositeMap[needHeroID]) {
                pass = false;
            }
        }
        if (needHeroIDArr[0] == needHeroIDArr[1]) {
            var num_3 = needHeroIDCountArr[0] + needHeroIDCountArr[1];
            if (satisfyCompositeMap[needHeroIDArr[0]] < num_3 || !satisfyCompositeMap[needHeroIDArr[0]]) {
                pass = false;
            }
        }
        var num = 0;
        if (star == 5) {
            num = needHeroIDCountArr[0] + needHeroIDCountArr[1] + needHeroIDCountArr[3];
        }
        else if (star == 6) {
            num = needHeroIDCountArr[0] + needHeroIDCountArr[1] + needHeroIDCountArr[2] + needHeroIDCountArr[3];
        }
        if (satisfyCompositeMap[needHeroIDArr[3]] < num || !satisfyCompositeMap[needHeroIDArr[3]]) {
            pass = false;
        }
        return pass;
    };
    //
    /**
     * 英雄单个材料是否满足
     * heroID 			英雄ID
     * race 			英雄种族
     * heroCount 		需要的英雄数量
     * usedHeroCount 	已使用英雄数量
     * usedCardIndexArr 已使用的英雄下标
     */
    CardMgr.isCardOneCompose = function (heroID, race, heroCount, usedHeroCount, usedCardIndexArr) {
        var pass = true;
        var cardArr = MyData.user.json.cardArr;
        var cardArrCount = cardArr.length;
        var num = 0;
        for (var i = 0; i < cardArrCount; i++) {
            var info = cardArr[i];
            var heroIDS = info.heroID;
            var raceS = info.race;
            var starMaxS = info.starMax;
            if (heroID == 3 || heroID == 4 || heroID == 5) {
                if (race == raceS && heroID == starMaxS) {
                    var pass_1 = usedCardIndexArr.indexOf(i);
                    if (pass_1 == -1) {
                        num += 1;
                    }
                }
            }
            else {
                if (heroID == heroIDS) {
                    var pass_2 = usedCardIndexArr.indexOf(i);
                    if (pass_2 == -1) {
                        num += 1;
                    }
                }
            }
        }
        if ((num + usedHeroCount) < heroCount) {
            pass = false;
        }
        return pass;
    };
    return CardMgr;
}());
__reflect(CardMgr.prototype, "CardMgr");
//颜色
var Color = (function () {
    function Color() {
    }
    Color.red = 0xCC0000; //红色
    Color.green = 0x339900; //绿色
    Color.white = 0xFFFFFF; //白色
    Color.blue = 0x0033CC; //蓝色
    Color.purple = 0x9933CC; //紫色
    Color.orange = 0xFF6600; //橙色
    //物品颜色数组
    Color.itemColor = [
        Color.white,
        Color.green,
        Color.blue,
        Color.purple,
        Color.orange,
        Color.red //5
    ];
    return Color;
}());
__reflect(Color.prototype, "Color");
//公共方法
var Common = (function () {
    function Common() {
    }
    /**
     * 万字的显示
     * @param label
     * @param num
     */
    Common.labelIsOverLenght = function (label, num) {
        label.text = this.overLength(num);
    };
    Common.overLength = function (num) {
        var str = null;
        if (num < 100000) {
            str = Math.floor(num) + "";
        }
        else if (num > 100000000) {
            num = (num / 100000000);
            num = Math.floor(num * 10) / 10;
            str = num + "亿";
        }
        else {
            num = (num / 10000);
            num = Math.floor(num * 10) / 10;
            if (num % 1 === 0) {
                str = num + ".0万";
            }
            else {
                var numsrt = String(num).replace(".", "");
                var num1 = numsrt.substring(0, numsrt.length - 1);
                var num2 = numsrt.substring(numsrt.length - 1, numsrt.length);
                str = num1 + "." + num2 + "万";
            }
        }
        return str;
    };
    /**
     * 获取一个对象的长度
     * @param list
     */
    Common.getObjectLength = function (list) {
        var num = 0;
        for (var i in list) {
            num++;
        }
        return num;
    };
    /**
     * 深度复制
     * @param _data
     */
    Common.copyDataHandler = function (obj) {
        var newObj;
        if (obj instanceof Array) {
            newObj = [];
        }
        else if (obj instanceof Object) {
            newObj = {};
        }
        else {
            return obj;
        }
        var keys = Object.keys(obj);
        for (var i = 0, len = keys.length; i < len; i++) {
            var key = keys[i];
            newObj[key] = this.copyDataHandler(obj[key]);
        }
        return newObj;
    };
    //获取id计数字典中id对应的数量
    Common.idMapGetCount = function (idMap, id) {
        if (idMap[id]) {
            return idMap[id];
        }
        return 0;
    };
    /**
     * 获取发生时间
     * timestampS：时间戳（秒）
     */
    Common.passTime = function (timestampS) {
        var now = ak.time() + MyData.timeBase; //当前时间
        var passTime = now - timestampS; //经过多长时间
        var str = null;
        var count = 0;
        if (passTime < 3600) {
            count = Math.floor(passTime / 60);
            str = count + "分钟前";
        }
        else if (3600 <= passTime && passTime <= 86400) {
            count = Math.floor(passTime / 3600);
            str = count + "小时前";
        }
        else {
            count = Math.floor(passTime / 86400);
            str = count + "天前";
        }
        return str;
    };
    /**
     * 字符串换行 str：字符串 num：第n个字符换行
     */
    Common.stringlinefeed = function (str, num) {
        var bytesCount = 0;
        var s = "";
        for (var i = 0; i < str.length; i++) {
            var c = str.charCodeAt(i);
            //统计字符串的字符长度
            if ((c >= 0x0001 && c <= 0x007e) || (0xff60 <= c && c <= 0xff9f)) {
                bytesCount += 1;
            }
            else {
                bytesCount += 2;
            }
            //换行
            s += str.charAt(i);
            if (bytesCount > num) {
                s = s + '\n';
                //重置
                bytesCount = 0;
            }
        }
        return s;
    };
    ;
    /**
     * 获取资源道具卡牌名称
     */
    Common.getResourceItemName = function (id, type) {
        var name = "";
        if (type == 1) {
            name = ak.JsonTableMgr.get("item").getRowFromColName("id", "" + id).getValFromColName("name");
        }
        else if (type == 2) {
            name = ak.JsonTableMgr.get("hero").getRowFromColName("id", "" + id).getValFromColName("name");
        }
        else if (type == 3) {
            name = ak.JsonTableMgr.get("Resource").getRowFromColName("id", "" + id).getValFromColName("name");
        }
        return name;
    };
    ;
    //获取在线秒数
    Common.getOnlieSceond = function () {
        var onlinetime = ak.time() - ak.strtotime(MyData.user.loginTime) + MyData.timeBase;
        return onlinetime;
    };
    //根据支付ID获取人民币值
    Common.getMoneyByPayID = function (id) {
        var payTab = ak.JsonTableMgr.get("pay");
        var payInfo = payTab.getRowFromColName("id", id.toString());
        return payInfo.getValFromColName("rmb") / 100;
    };
    //获取创角第几天
    Common.getCreateUserDays = function () {
        var genTime = MyData.user.genTime;
        var createUserDate = genTime.split(" ")[0];
        var days = (ak.strtotime(ak.date()) - ak.strtotime(createUserDate)) / (60 * 60 * 24) + 1;
        return days;
    };
    //获取开服第几天
    Common.getBeginDays = function () {
        var days = (ak.strtotime(ak.date()) - ak.strtotime(MyData.beginDate)) / (60 * 60 * 24) + 1;
        return days;
    };
    //获取合服第几天
    Common.getJoinDays = function () {
        var days = (ak.strtotime(ak.date()) - ak.strtotime(MyData.joinDate)) / (60 * 60 * 24) + 1;
        return days;
    };
    //获取星期 剩余天数
    Common.getWeekDays = function () {
        var days = 7 - (((this.getBeginDays() - 1) % 7) + 1);
        return days;
    };
    //获取月 剩余天数
    Common.getMonthDay = function () {
        var days = 30 - (((this.getBeginDays() - 1) % 30) + 1);
        return days;
    };
    //替换指定的字符
    Common.exchangeString = function (str, oldstr, exchangstr) {
        var newstr = "";
        newstr = str.replace(oldstr, exchangstr);
        return newstr;
    };
    //根据任务ID 获取任务信息
    Common.getTaskDataByTaskId = function (taskId) {
        var taskTypeTab = ak.JsonTableMgr.get("taskType");
        for (var i = 0; i < taskTypeTab.size(); i++) {
            var taskInfo = taskTypeTab.getRow(i);
            if (taskInfo.getValFromColName("type") == taskId) {
                return { type: taskId, text: taskInfo.getValFromColName("text") };
            }
        }
        return null;
    };
    //根据技能ID获取技能名
    Common.getSkillNameBySkillId = function (skillId) {
        var stoneAttrTypeTab = ak.JsonTableMgr.get("stoneAttrType");
        for (var i = 0; i < stoneAttrTypeTab.size(); i++) {
            var taskInfo = stoneAttrTypeTab.getRow(i);
            if (taskInfo.getValFromColName("id") == skillId) {
                return { id: taskInfo.getValFromColName("id"), name: taskInfo.getValFromColName("name") };
            }
        }
        return null;
    };
    return Common;
}());
__reflect(Common.prototype, "Common");
var DateMgr = (function () {
    function DateMgr(format, from, to, isFormatNum) {
        /**格式 */
        this.format = [];
        /** 起始精确度*/
        this.from = 0;
        /**结束精确度 */
        this.to = 0;
        /**是否补齐0 */
        this.isFormatNum = false;
    }
    return DateMgr;
}());
__reflect(DateMgr.prototype, "DateMgr");
var DateUtils = (function () {
    function DateUtils() {
    }
    /**
     * 获取时间格式化的字符串
     * @second 秒
     * @style 格式化风格, 例如 :DateUtils.STYLE_1
     *  */
    DateUtils.getFormatTimeByStyle = function (second, style) {
        if (style === void 0) { style = DateUtils.STYLE_1; }
        if (second < 0) {
            second = 0;
            //debug.log("输入参数有误!时间为负数:" + second);
        }
        if (style.from > style.to) {
            //debug.log("输入参数有误!to参数必须大于等于from参数,请检查style参数的值");
            return "";
        }
        second = second >> 0;
        var result = "";
        for (var i = style.to; i >= style.from; i--) {
            var time = second / this.mul[i]; //总共
            var timeStr = "";
            if (i != style.to)
                time = time % this.mod[i]; //剩余
            if (style.isFormatNum && time < 10)
                timeStr = "0" + (time >> 0).toString(); //补0
            else
                timeStr = (time >> 0).toString();
            result += (timeStr + style.format[i]);
        }
        return result;
    };
    /**
     * 获取时间格式化的字符串
     * @ms 毫秒
     * @style 格式化风格, 例如 :DateUtils.STYLE_1
     *  */
    DateUtils.getFormatTimeByStyle1 = function (ms, style) {
        if (style === void 0) { style = DateUtils.STYLE_1; }
        return this.getFormatTimeByStyle(ms / this.MS_PER_SECOND);
    };
    /**
     * 把MiniDateTime转化为距离1970-01-01的毫秒数
     * @param mdt 从2010年开始算起的秒数
     * @return 从1970年开始算起的毫秒数
     */
    DateUtils.formatMiniDateTime = function (mdt) {
        return DateUtils.MINI_DATE_TIME_BASE + (mdt & 0x7FFFFFFF) * DateUtils.MS_PER_SECOND;
    };
    /**转成服务器要用的时间***/
    DateUtils.formatServerTime = function (time) {
        return (time - DateUtils.MINI_DATE_TIME_BASE) / DateUtils.MS_PER_SECOND;
    };
    /**
     * 根据秒数格式化字符串
     * @param  {number} second            秒数
     * @param  {number=1} type            时间格式类型（参考DateUtils.TIME_FORMAT_1, DateUtils.TIME_FORMAT_2...)
     * @param  {showLength}    showLength    显示长度（一个时间单位为一个长度，且仅在type为DateUtils.TIME_FORMAT_5的情况下有效）
     * @returns string
     */
    DateUtils.getFormatBySecond = function (second, type, showLength) {
        if (type === void 0) { type = 1; }
        if (showLength === void 0) { showLength = 2; }
        var str = "";
        var ms = second * 1000;
        switch (type) {
            case this.TIME_FORMAT_1:
                str = this.format_1(ms);
                break;
            case this.TIME_FORMAT_2:
                str = this.format_2(ms);
                break;
            case this.TIME_FORMAT_3:
                str = this.format_3(ms);
                break;
            case this.TIME_FORMAT_4:
                str = this.format_4(ms);
                break;
            case this.TIME_FORMAT_5:
                str = this.format_5(ms, showLength);
                break;
            case this.TIME_FORMAT_6:
                str = this.format_6(ms);
                break;
            case this.TIME_FORMAT_7:
                str = this.format_7(ms);
                break;
            case this.TIME_FORMAT_8:
                str = this.format_8(ms);
                break;
            case this.TIME_FORMAT_9:
                str = this.format_9(ms);
                break;
            case this.TIME_FORMAT_10:
                str = this.format_10(ms);
                break;
            case this.TIME_FORMAT_11:
                str = this.format_11(ms);
                break;
            case this.TIME_FORMAT_12:
                str = this.format_12(ms);
                break;
            case this.TIME_FORMAT_13:
                str = this.format_13(ms);
                break;
            case this.TIME_FORMAT_14:
                str = this.format_14(ms);
                break;
            case this.TIME_FORMAT_15:
                str = this.format_15(ms);
                break;
            case this.TIME_FORMAT_16:
                str = this.format_16(ms);
                break;
        }
        return str;
    };
    /**
     * 获取到指定日期00：00的秒数
     * **/
    DateUtils.getRenainSecond = function (ms) {
        var tmpDate = ms ? new Date(ms) : new Date();
        //tmpDate.setDate(tmpDate.getDate()+1);
        var ptime = (DateUtils.getTodayZeroSecond(tmpDate) + 60 * 60 * 24) - tmpDate.getTime() / 1000;
        // ak.log("ptime = " + ptime);
        return ptime.toFixed(0);
    };
    /**
     * 今天已过去的秒数
     * **/
    DateUtils.getTodayPassedSecond = function () {
        var tmpDate = new Date();
        var tdyPassTime = ((Date.now() - (new Date(tmpDate.getFullYear(), tmpDate.getMonth(), tmpDate.getDate()).getTime())) / 1000).toFixed(0);
        return parseInt(tdyPassTime);
    };
    /**
     * 获取指定日期00:00时刻的秒数
     * @parma 毫秒
     * @returns {number}
     */
    DateUtils.getTodayZeroSecond = function (tdate) {
        var tmpDate = tdate ? tdate : new Date();
        return parseInt(((new Date(tmpDate.getFullYear(), tmpDate.getMonth(), tmpDate.getDate()).getTime()) / 1000).toFixed(0));
    };
    /**
     * 获取本周第一天
     * **/
    DateUtils.showWeekFirstDay = function () {
        var Nowdate = new Date();
        var day = Nowdate.getDay();
        day = day ? day : 7;
        var WeekFirstDay = new Date(Nowdate - (day - 1) * 86400000);
        // var M=Number(WeekFirstDay.getMonth())+1
        // return WeekFirstDay.getYear()+"-"+M+"-"+WeekFirstDay.getDate();
        return WeekFirstDay;
    };
    /**
     * 获取本周最后一天
     * @param 毫秒差
     */
    DateUtils.showWeekLastDay = function () {
        var Nowdate = new Date();
        var WeekFirstDay = DateUtils.showWeekFirstDay();
        var WeekLastDay = new Date((WeekFirstDay / 1000 + 6 * 86400) * 1000);
        // var M=Number(WeekLastDay.getMonth())+1
        // return WeekLastDay.getYear()+"-"+M+"-"+WeekLastDay.getDate();
        return WeekLastDay;
    };
    /**
     * 获取本周最后一天
     * return 秒数
     */
    DateUtils.getWeekLastDay = function () {
        var now_day = new Date().getDay(); //今天星期几
        var time = (7 - now_day) * this.SECOND_PER_DAY; //剩余天数 * 每天秒数
        var passTime = DateUtils.getTodayPassedSecond(); //经过时间
        var residueTime = this.SECOND_PER_DAY - passTime; //倒计时
        return residueTime + time;
    };
    /**
     * 求出当前时间离下周一凌晨0点还差
     * @param 毫秒差
     * **/
    DateUtils.calcWeekFirstDay = function () {
        // var lastDay = showWeekLastDay().getDay();
        // lastDay = lastDay > 0?lastDay:7;
        var Nowdate = new Date();
        var curDay = Nowdate.getDay();
        curDay = curDay > 0 ? curDay : 7;
        var difday = 7 - curDay; //用
        var hours = Nowdate.getHours();
        var minutes = Nowdate.getMinutes();
        var seconds = Nowdate.getSeconds();
        // ak.log("difday = "+difday);
        // ak.log("hours = "+hours);
        // ak.log("minutes = "+minutes);
        // ak.log("seconds = "+seconds);
        var sum = difday * 86400 * 1000 + 86400 * 1000 - (hours * 3600 * 1000 + minutes * 60 * 1000 + seconds * 1000);
        return new Date(sum);
    };
    /**
     * 格式1  00:00:00
     * @param  {number} sec 毫秒数
     * @returns string
     */
    DateUtils.format_1 = function (ms) {
        var n = 0;
        var result = "##:##:##";
        n = Math.floor(ms / DateUtils.MS_PER_HOUR);
        result = result.replace("##", DateUtils.formatTimeNum(n));
        if (n)
            ms -= n * DateUtils.MS_PER_HOUR;
        n = Math.floor(ms / DateUtils.MS_PER_MINUTE);
        result = result.replace("##", DateUtils.formatTimeNum(n));
        if (n)
            ms -= n * DateUtils.MS_PER_MINUTE;
        n = Math.floor(ms / 1000);
        result = result.replace("##", DateUtils.formatTimeNum(n));
        return result;
    };
    /**
     * 格式2  yyyy-mm-dd h:m:s
     * @param  {number} ms        毫秒数
     * @returns string            返回自1970年1月1号0点开始的对应的时间点
     */
    DateUtils.format_2 = function (ms) {
        var date = new Date(ms);
        var year = date.getFullYear();
        var month = date.getMonth() + 1; //返回的月份从0-11；
        var day = date.getDate();
        var hours = date.getHours();
        var minute = date.getMinutes();
        var second = date.getSeconds();
        return year + "-" + month + "-" + day + " " + hours + ":" + minute + ":" + second;
    };
    /**
     * 格式3  00:00
     * @param  {number} ms        毫秒数
     * @returns string            分:秒
     */
    DateUtils.format_3 = function (ms) {
        var str = this.format_1(ms);
        var strArr = str.split(":");
        return strArr[1] + ":" + strArr[2];
    };
    /**
     * 格式4  xx天前，xx小时前，xx分钟前
     * @param  {number} ms        毫秒
     * @returns string
     */
    DateUtils.format_4 = function (ms) {
        if (ms < this.MS_PER_HOUR) {
            return Math.floor(ms / this.MS_PER_MINUTE) + "分钟前";
        }
        else if (ms < this.MS_PER_DAY) {
            return Math.floor(ms / this.MS_PER_HOUR) + "小时前";
        }
        else {
            return Math.floor(ms / this.MS_PER_DAY) + "天前";
        }
    };
    /**
     * 格式5 X天X小时X分X秒
     * @param  {number} ms                毫秒
     * @param  {number=2} showLength    显示长度（一个时间单位为一个长度）
     * @returns string
     */
    DateUtils.format_5 = function (ms, showLength) {
        if (showLength === void 0) { showLength = 2; }
        var result = "";
        var unitStr = ["天", "时", "分", "秒"];
        var arr = [];
        var d = Math.floor(ms / this.MS_PER_DAY);
        arr.push(d);
        ms -= d * this.MS_PER_DAY;
        var h = Math.floor(ms / this.MS_PER_HOUR);
        arr.push(h);
        ms -= h * this.MS_PER_HOUR;
        var m = Math.floor(ms / this.MS_PER_MINUTE);
        arr.push(m);
        ms -= m * this.MS_PER_MINUTE;
        var s = Math.floor(ms / 1000);
        arr.push(s);
        for (var k in arr) {
            if (arr[k] > 0) {
                result += this.formatTimeNum(arr[k], Number(k)) + unitStr[k];
                showLength--;
                if (showLength <= 0)
                    break;
            }
        }
        return result;
    };
    /**
     * 格式6  h:m:s
     * @param  {number} ms        毫秒
     * @returns string            返回自1970年1月1号0点开始的对应的时间点（不包含年月日）
     */
    DateUtils.format_6 = function (ms) {
        var date = new Date(ms);
        var hours = date.getHours();
        var minute = date.getMinutes();
        var second = date.getSeconds();
        return this.formatTimeNum(hours) + ":" + this.formatTimeNum(minute) + ":" + this.formatTimeNum(second);
    };
    /**
     * 格式7  X天/X小时/<1小时
     * @param  {number} ms        毫秒
     * @returns string
     */
    DateUtils.format_7 = function (ms) {
        if (ms < this.MS_PER_HOUR) {
            return "<1小时";
        }
        else if (ms < this.MS_PER_DAY) {
            return Math.floor(ms / this.MS_PER_HOUR) + "小时";
        }
        else {
            return Math.floor(ms / this.MS_PER_DAY) + "天";
        }
    };
    //8:yyyy-mm-dd h:m
    DateUtils.format_8 = function (time) {
        var date = new Date(time);
        var year = date.getFullYear();
        var month = date.getMonth() + 1; //返回的月份从0-11；
        var day = date.getDate();
        var hours = date.getHours();
        var minute = date.getMinutes();
        return year + "-" + month + "-" + day + " " + hours + ":" + minute;
    };
    /**
     * 格式9  x小时x分钟x秒
     * @param  {number} ms        毫秒
     * @returns string
     */
    DateUtils.format_9 = function (ms) {
        var h = Math.floor(ms / this.MS_PER_HOUR);
        ms -= h * this.MS_PER_HOUR;
        var m = Math.floor(ms / this.MS_PER_MINUTE);
        ms -= m * this.MS_PER_MINUTE;
        var s = Math.floor(ms / 1000);
        return h + "小时" + m + "分钟" + s + "秒";
    };
    /**
     * 格式10  x分x秒
     * @param  {number} ms        毫秒
     * @returns string
     */
    DateUtils.format_10 = function (ms) {
        // let h: number = Math.floor(ms / this.MS_PER_HOUR);
        // ms -= h * this.MS_PER_HOUR;
        var m = Math.floor(ms / this.MS_PER_MINUTE);
        ms -= m * this.MS_PER_MINUTE;
        var s = Math.floor(ms / 1000);
        return m + "分" + s + "秒";
    };
    DateUtils.format_11 = function (ms) {
        var h = Math.floor(ms / this.MS_PER_HOUR);
        ms -= h * this.MS_PER_HOUR;
        var m = Math.floor(ms / this.MS_PER_MINUTE);
        ms -= m * this.MS_PER_MINUTE;
        var s = Math.floor(ms / 1000);
        return h + "时" + m + "分" + s + "秒";
    };
    DateUtils.format_12 = function (ms) {
        var h = Math.floor(ms / this.MS_PER_HOUR);
        ms -= h * this.MS_PER_HOUR;
        var m = Math.floor(ms / this.MS_PER_MINUTE);
        ms -= m * this.MS_PER_MINUTE;
        var s = Math.floor(ms / 1000);
        return DateUtils.formatTimeNum(h) + ":" + DateUtils.formatTimeNum(m) + ":" + DateUtils.formatTimeNum(s);
    };
    /**x月x日（周几）h:m */
    DateUtils.format_13 = function (time) {
        var date = new Date(time);
        var year = date.getFullYear();
        var month = date.getMonth() + 1; //返回的月份从0-11；
        var week = date.getDay();
        var day = date.getDate();
        var hours = date.getHours();
        var minute = date.getMinutes();
        return month + "月" + day + "日(周" + this.WEEK_CN[week] + ") " + DateUtils.formatTimeNum(hours) + ":" + DateUtils.formatTimeNum(minute);
    };
    /**时 分 */
    DateUtils.format_14 = function (time) {
        var date = new Date(time);
        var hours = date.getHours();
        var minute = date.getMinutes();
        return hours + "时" + minute + "分";
    };
    //15:yyyy-mm-dd h:m
    DateUtils.format_15 = function (time) {
        var date = new Date(time);
        var month = date.getMonth() + 1; //返回的月份从0-11；
        var day = date.getDate();
        var hours = date.getHours();
        var minute = date.getMinutes();
        return DateUtils.formatTimeNum(month) + "-" + DateUtils.formatTimeNum(day) + " " + DateUtils.formatTimeNum(hours) + ":" + DateUtils.formatTimeNum(minute);
    };
    /**
     * 格式16  yyyy-mm-dd
     * @param  {number} ms        毫秒数
     * @returns string            返回自1970年1月1号0点开始的对应的时间点
     */
    DateUtils.format_16 = function (ms) {
        var date = new Date(ms);
        var year = date.getFullYear();
        var month = date.getMonth() + 1; //返回的月份从0-11；
        var day = date.getDate();
        return year + "-" + month + "-" + day;
    };
    /**
     * 格式化时间数为两位数
     * @param  {number} t 时间数
     * @returns String
     */
    DateUtils.formatTimeNum = function (t, k) {
        return t >= 10 ? t.toString() : (k == 0 ? t.toString() : "0" + t);
    };
    /**
     * 检验时间是否大于现在时间+天数
     * @param  time时间
     * @param  days天数
     * @returns String
     */
    DateUtils.checkTime = function (time, days) {
        var currentDate = new Date().getTime();
        var t = (time > (currentDate + days * this.MS_PER_DAY));
        return t;
    };
    /**
     * 格式化当前时间
     * @param  time时间
     * @returns String 2018年12月12日（周二） 12:12
     */
    DateUtils.formatFullTime = function (time) {
        var format;
        var date = new Date(time);
        var year = date.getFullYear();
        var month = date.getMonth() + 1;
        var day = date.getDate();
        var weekDay = date.getDay();
        var hour = date.getHours();
        var hourStr;
        if (hour < 10) {
            hourStr = "0" + hour;
        }
        else {
            hourStr = hour.toString();
        }
        var min = date.getMinutes();
        var minStr;
        if (min < 10) {
            minStr = "0" + min;
        }
        else {
            minStr = min.toString();
        }
        var weekDayStr;
        switch (weekDay) {
            case 1:
                weekDayStr = "一";
                break;
            case 2:
                weekDayStr = "二";
                break;
            case 3:
                weekDayStr = "三";
                break;
            case 4:
                weekDayStr = "四";
                break;
            case 5:
                weekDayStr = "五";
                break;
            case 6:
                weekDayStr = "六";
                break;
            case 0:
                weekDayStr = "日";
                break;
        }
        format = year + "年" + month + "月" + day + "日（周" + weekDayStr + "） " + hourStr + ":" + minStr;
        return format;
    };
    /**
     *把字符串时间转换为毫秒数
     * 2018.3.14-0:0
     * */
    DateUtils.formatStrTimeToMs = function (str) {
        var date = new Date();
        var strList = str.split(".");
        date.setFullYear(strList[0]);
        date.setMonth((+strList[1]) - 1);
        var strL2 = strList[2].split("-");
        date.setDate(strL2[0]);
        var strL3 = strL2[1].split(":");
        date.setHours(strL3[0]);
        date.setMinutes(strL3[1]);
        date.setSeconds(0);
        return date.getTime();
    };
    /**
     *把字符串时间转换为毫秒数
     * "2018-12-24 11:51:54"
     * */
    DateUtils.formatStrTimeToS = function (str) {
        var date = new Date();
        var strList = str.split("-");
        date.setFullYear(strList[0]);
        date.setMonth((+strList[1]) - 1);
        var strL2 = strList[2].split(" ");
        date.setDate(strL2[0]);
        var strL3 = strL2[1].split(":");
        date.setHours(strL3[0]);
        date.setMinutes(strL3[1]);
        date.setSeconds(strL3[2]);
        return date.getTime();
    };
    /**
     *把字符串时间转换为毫秒数
     * "2018-12-24" (年-月-日)
     * */
    DateUtils.formatStrTimeToYMD = function (str) {
        var date = new Date("'" + str + "'");
        return date.getTime();
    };
    /**
    * 获取当天凌晨12点
    * return 秒数
    */
    DateUtils.getWeeHours12Time = function () {
        var now = ak.time() + MyData.timeBase; //当前时间戳 + 本地与服务器时间差
        return (now + this.SECOND_PER_DAY) - DateUtils.getTodayPassedSecond();
    };
    /**
    * 获取当天22点
    * return 秒数
    */
    DateUtils.getWeeHours10Time = function () {
        var now = ak.time() + MyData.timeBase; //当前时间戳 + 本地与服务器时间差
        return (now + this.SECOND_PER_HOUR * 22) - DateUtils.getTodayPassedSecond();
    };
    /**时间格式1 00:00:00 */
    DateUtils.TIME_FORMAT_1 = 1;
    /**时间格式2 yyyy-mm-dd h:m:s */
    DateUtils.TIME_FORMAT_2 = 2;
    /**时间格式3 00:00 */
    DateUtils.TIME_FORMAT_3 = 3;
    /**时间格式4 xx天前/xx小时前/xx分钟前 */
    DateUtils.TIME_FORMAT_4 = 4;
    /**时间格式5 x天x小时x分x秒 */
    DateUtils.TIME_FORMAT_5 = 5;
    /**时间格式6 h:m:s */
    DateUtils.TIME_FORMAT_6 = 6;
    /**时间格式7 xx天/xx小时/<1小时 */
    DateUtils.TIME_FORMAT_7 = 7;
    /**时间格式8 yyyy-mm-dd h:m */
    DateUtils.TIME_FORMAT_8 = 8;
    /**时间格式9 x小时x分钟x秒 */
    DateUtils.TIME_FORMAT_9 = 9;
    /**时间格式10 x分x秒**/
    DateUtils.TIME_FORMAT_10 = 10;
    /**时间格式11x时x分x秒**/
    DateUtils.TIME_FORMAT_11 = 11;
    /**时间格式12 x:x:x**/
    DateUtils.TIME_FORMAT_12 = 12;
    /**时间格式13 x月x日（周几）h:m**/
    DateUtils.TIME_FORMAT_13 = 13;
    /**时间格式14 x时x分**/
    DateUtils.TIME_FORMAT_14 = 14;
    /**时间格式15 mm-dd h:m */
    DateUtils.TIME_FORMAT_15 = 15;
    /**时间格式16 yyyy-mm-dd h:m:s */
    DateUtils.TIME_FORMAT_16 = 16;
    /**一秒的毫秒数 */
    DateUtils.MS_PER_SECOND = 1000;
    /**一分钟的毫秒数 */
    DateUtils.MS_PER_MINUTE = 60 * 1000;
    /**一小时的毫秒数 */
    DateUtils.MS_PER_HOUR = 60 * 60 * 1000;
    /**一天的毫秒数 */
    DateUtils.MS_PER_DAY = 24 * 60 * 60 * 1000;
    DateUtils.SECOND_PER_HOUR = 3600; //一小时的秒数
    DateUtils.SECOND_PER_DAY = 86400; //一天的秒数
    DateUtils.SECOND_PER_MONTH = 2592000; //一个月(30天)的秒数
    DateUtils.SECOND_PER_YEAR = 31104000; //一年(360天)的秒数
    DateUtils.DAYS_PER_WEEK = 7; //一周的天数
    DateUtils.YEAR_PER_YEAR = 1; //每年的年数
    DateUtils.MONTH_PER_YEAR = 12; //每年的月数
    DateUtils.DAYS_PER_MONTH = 30; //每月的天数
    DateUtils.HOURS_PER_DAY = 24; //每天的小时数
    DateUtils.MUNITE_PER_HOUR = 60; //每小时的分钟数
    DateUtils.SECOND_PER_MUNITE = 60; //每分钟的秒数
    DateUtils.SECOND_PER_SECOND = 1; //每秒的秒数字
    DateUtils.SECOND_2010 = 1262275200; //1970年~2010年1月1日0时0分0秒的时间戳(单位:秒)
    /**余数 ,用来计算时间*/
    DateUtils.mod = [DateUtils.SECOND_PER_MUNITE, DateUtils.MUNITE_PER_HOUR, DateUtils.HOURS_PER_DAY, DateUtils.DAYS_PER_MONTH, DateUtils.MONTH_PER_YEAR, DateUtils.YEAR_PER_YEAR];
    /**除数 用来计算用来计算时间*/
    DateUtils.mul = [DateUtils.SECOND_PER_SECOND, DateUtils.SECOND_PER_MUNITE, DateUtils.SECOND_PER_HOUR, DateUtils.SECOND_PER_DAY, DateUtils.SECOND_PER_MONTH, DateUtils.SECOND_PER_YEAR];
    /**一周的天数 */
    /**一天的小时数 */
    /** 本游戏中使用的MiniDateTime时间的起始日期相对于flash时间(1970-01-01)的时差（毫秒） */
    DateUtils.MINI_DATE_TIME_BASE = Date.UTC(2010, 0) + new Date().getTimezoneOffset() * DateUtils.MS_PER_MINUTE;
    /**
     * 时区偏移（毫秒数）<BR>
     * 目前中国采用东八区，即比世界协调时间（UTC）/格林尼治时间（GMT）快8小时的时区 */
    DateUtils.TIME_ZONE_OFFSET = 8 * DateUtils.MS_PER_HOUR;
    /**精确度 */
    DateUtils.TO_SECOND = 0;
    DateUtils.TO_MINUTE = 1;
    DateUtils.TO_HOUR = 2;
    DateUtils.TO_DAY = 3;
    DateUtils.TO_MONTH = 4;
    DateUtils.TO_YEAR = 5;
    /** n年n月n日n时n分n秒 */
    DateUtils.FORMAT_1 = ["秒", "分", "时", "天", "月", "年"];
    /** xx:xx:xx */
    DateUtils.FORMAT_2 = [":", ":", ":", ":", ":", ":"];
    DateUtils.WEEK_CN = ["\u65E5", "\u4E00", "\u4E8C", "\u4E09", "\u56DB", "\u4E94", "\u516D"];
    /**x小时x分x秒 */
    DateUtils.STYLE_1 = new DateMgr(DateUtils.FORMAT_1, DateUtils.TO_SECOND, DateUtils.TO_HOUR, false);
    /** x天x小时x分钟x秒 */
    DateUtils.STYLE_2 = new DateMgr(DateUtils.FORMAT_1, DateUtils.TO_SECOND, DateUtils.TO_DAY, false);
    /** 00:00:00 */
    DateUtils.STYLE_3 = new DateMgr(DateUtils.FORMAT_2, DateUtils.TO_SECOND, DateUtils.TO_HOUR, true);
    /** x分x秒 */
    DateUtils.STYLE_4 = new DateMgr(DateUtils.FORMAT_1, DateUtils.TO_SECOND, DateUtils.TO_MINUTE, true);
    return DateUtils;
}());
__reflect(DateUtils.prototype, "DateUtils");
//公式库
var Formula = (function () {
    function Formula() {
    }
    /**
     * 计算卡牌基础属性满级战力
     * （攻击+防御+生命+速度）*最大等级
     */
    Formula.getBattlePower = function (heroID) {
        var heroTab = ak.JsonTableMgr.get("hero");
        var heroPromotionTab = ak.JsonTableMgr.get("heroPromotion");
        var heroGrowTab = ak.JsonTableMgr.get("heroGrow");
        var heroInfo = heroTab.getRowFromColName("id", "" + heroID);
        var star = heroInfo.getValFromColName("star"); //星级
        var heroGrowRow = heroGrowTab.getRowFromColName("heroID", "" + heroID);
        var hp = Number(heroGrowRow.getValFromColName("hp")); //生命
        var atk = Number(heroGrowRow.getValFromColName("atk")); //攻击
        var def = Number(heroGrowRow.getValFromColName("def")); //防御
        var speed = Number(heroGrowRow.getValFromColName("speed")); //速度
        var hpGrow = Number(heroGrowRow.getValFromColName("hpGrow")); //生命成长
        var atkGrow = Number(heroGrowRow.getValFromColName("atkGrow")); //攻击成长
        var defGrow = Number(heroGrowRow.getValFromColName("defGrow")); //防御成长
        var speedGrow = Number(heroGrowRow.getValFromColName("speedGrow")); //速度成长
        var heroPromotionInfo = heroPromotionTab.getRowFromColName("star", "" + star);
        var maxlv = Number(heroPromotionInfo.getValFromColName("maxlv")); //最高可升级
        var hpPro = Number(heroPromotionInfo.getValFromColName("hpPro")) / 10000; //
        var atkPro = Number(heroPromotionInfo.getValFromColName("atkPro")) / 10000; //
        var defPro = Number(heroPromotionInfo.getValFromColName("defPro")) / 10000; //
        var speedPro = Number(heroPromotionInfo.getValFromColName("speedPro")) / 10000; //
        hp += (maxlv - 1) * hpGrow;
        atk += (maxlv - 1) * atkGrow;
        def += (maxlv - 1) * defGrow;
        speed += (maxlv - 1) * speedGrow;
        hp *= hpPro;
        atk *= atkPro;
        def *= defPro;
        speed *= speedPro;
        var power = Math.floor(hp + atk + def + speed);
        return power;
    };
    /**
     * 计算卡牌培养战力(已包括所有额外加成)
     */
    Formula.getCardIndexPower = function (cardIndex) {
        var heroInfo = MyData.user.json.cardArr[cardIndex];
        var power = heroInfo.battlePower;
        return power;
    };
    return Formula;
}());
__reflect(Formula.prototype, "Formula");
//游戏事件
var GameEvent = (function () {
    function GameEvent() {
    }
    ////////////////////////////////////////////////////////////////////////////
    //触发新手事件
    GameEvent.guide_open = "gameEvent://guide_open"; //打开新手引导
    GameEvent.guide_randomCardAniComplete = "gameEvent://guide_randomCardAniComplete"; //抽卡动画完成
    GameEvent.guide_nextGuide = "gameEvent://guide_nextGuide"; //新手引导下一步（表里没有事件时用）
    GameEvent.guide_myPowerFull = "gameEvent://guide_myPowerFull"; //战斗场景中我方角色怒气满
    GameEvent.guide_Viewcomplete = "gameEvent://guide_Viewcomplete"; //加载界面完毕派发
    GameEvent.guide_Exopen = "gameEvent://guide_Exopen"; //打开新手引导（升级，通关）
    GameEvent.guide_barrierIDchange = "gameEvent://guide_barrierIDchange"; //通关设计派发
    ////////////////////////////////////////////////////////////////////////////
    //神器能量事件，参数1=队伍ID；参数2=能量值
    GameEvent.godWeaponPower = "gameEvent://godWeaponPower";
    /**
     * 选择地图
     * 系统：探险
     * */
    GameEvent.selectMap = "gameEvent://selectMap";
    /**
     * 设置挂机点
     * 系统：探险
     */
    GameEvent.hookSelectPlace = "gameEvent://hookSelectPlace";
    GameEvent.tavernViewList = "gameEvent://savernList"; //更新酒馆任务里列表
    GameEvent.heroLvUp = "gameEvent://heroLvUp"; //英雄培养后显示新的数据
    /**
     * 购买许愿池金币
     * 系统：许愿池
     */
    GameEvent.wishPoolBuy = "gameEvent://wishPoolBuy";
    /**
     * MC重置
     * 系统：许愿池
     */
    GameEvent.wishPoolMCupdate = "gameEvent://wishPoolMCupdate";
    /**
     * 战斗回合数字更新
     * 系统：战斗
     */
    GameEvent.fightRoundupdate = "gameEvent://fightRoundupdate";
    /**
     * 战斗结束回调
     * 系统：战斗
     */
    GameEvent.fightComplete = "gameEvent://fightComplete";
    /**
     * 关闭战斗界面
     * 系统：战斗
     */
    GameEvent.fightCloseUI = "gameEvent://fightCloseUI";
    /**
     * 战斗请求返回后刷新界面
     * 系统:各个调用战斗的界面
     */
    GameEvent.fightRpcComplete = "gameEvent://fightRpcComplete";
    /**
     * 刷新邮件列表
     */
    GameEvent.updateMailList = "gameEvent://updateMailList";
    /**
     * 拉黑好友或者删除好友返回
     * 系统：好友系统
     */
    GameEvent.defriend = "gameEvent://defriend";
    /**
     * 更换头像
     * 系统：设置
     */
    GameEvent.changeHead = "gameEvent://changeHead";
    /**
     * 修改名字
     * 系统：设置
     */
    GameEvent.changeName = "gameEvent://changeName";
    /**
     * 竞技场购买挑战卷
     * 系统：竞技场
     */
    GameEvent.arenaBuyTicket = "gameEvent://arenaBuyTicket";
    /**
     * 主界面下面系统选项卡
     */
    GameEvent.mainUIDownTab = "gameEvent://mainUIDownTab";
    /**
     * 主界面下面系统选项卡-切换主城
     */
    GameEvent.changeMainCity = "gameEvent://changeMainCity";
    /**
     * 主界面派发
     */
    GameEvent.changeMainCity2 = "gameEvent://changeMainCity2";
    /**
     * 主界面下面系统选项卡-切换英雄背包
     */
    GameEvent.changeHeroBag = "gameEvent://changeHeroBag";
    /**
     * 主界面下面系统选项卡-切换公会
     */
    GameEvent.changeGuild = "gameEvent://changeGuild";
    /**
     * 主界面聊天红点
     * 系统：聊天红点
     */
    GameEvent.chatRedPoint = "gameEvent://chatRedPoint";
    /**
     * 公会选择旗帜
     * 系统：公会创建
     */
    GameEvent.guildSelectFlag = "gameEvent://guildSelectFlag";
    /**
     * 公会成员刷新
     * 系统：公会成员
     */
    GameEvent.guildMember = "gameEvent://guildMember";
    /**
     * 公会管理成员刷新
     * 系统：公会管理成员
     */
    GameEvent.guildRecruitMember = "gameEvent://guildRecruitMember";
    /**
     * 公会改名
     * 系统：公会设置
     */
    GameEvent.guildChangeName = "gameEvent://guildChangeName";
    /**
     * 公会技能重置
     * 系统：公会技能
     */
    GameEvent.guildResetSkill = "gameEvent://guildResetSkill";
    /**
     * 切换界面
     * 系统：超级基金
     */
    GameEvent.changeSuperFundView = "gameEvent://changeSuperFundView";
    /**
     * 切换界面
     * 系统：限时礼包
     */
    GameEvent.changeLimitGiftView = "gameEvent://changeLimitGiftView";
    /**
     * 切换界面
     * 系统：精彩活动
     */
    GameEvent.changeWonderfulView = "gameEvent://changeWonderfulView";
    /**
     * 刷新顶部金币、钻石数量
     * 系统：限时活动
     */
    GameEvent.flushLimitActMoneyZs = "gameEvent://flushLimitActMoneyZs";
    /**
     * 刷新顶部按钮红点
     * 系统：限时活动
     */
    GameEvent.flushLimitActRedPoint = "gameEvent://flushLimitActRedPoint";
    /**
     *
     * 系统：登录界面
    */
    GameEvent.chooseServerView = "gameEvent://chooseServerView";
    /**
     *
     * 系统：显示登录
    */
    GameEvent.openChooseServerView = "gameEvent://openChooseServerView";
    /**
     *
     * 系统：打开热更显示
    */
    GameEvent.openHotUpdateView = "gameEvent://openHotUpdateView";
    /**
     *
     * 系统：更新加载进度
    */
    GameEvent.UpdatehotUpdateBar = "gameEvent://UpdatehotUpdateBar";
    /**
     *
     * 系统：更新加载进度
    */
    GameEvent.StopHotUpdateBar = "gameEvent://StopHotUpdateBar";
    /**
     *
     * 系统：更新加载描述
    */
    GameEvent.StopHotUpdateDesc = "gameEvent://StopHotUpdateDesc";
    /**
     * 派发系统开放
     */
    GameEvent.systemOpen_update = "gameEvent://systemOpen_update";
    /**
     * 系统：公会
     * 刷新公会主界面红点
    */
    GameEvent.flushGuildViewRedPoint = "gameEvent://flushGuildViewRedPoint";
    return GameEvent;
}());
__reflect(GameEvent.prototype, "GameEvent");
/**
 * 数据存储key值
 */
var GameLocalStorage = (function () {
    function GameLocalStorage() {
    }
    /**
     * 存储
     */
    GameLocalStorage.save = function (key, str) {
        var userID = String(MyData.user.id) + "//";
        egret.localStorage.setItem(userID + key, str);
    };
    /**
     * 获得
     */
    GameLocalStorage.load = function (key) {
        var userID = String(MyData.user.id) + "//";
        var str = egret.localStorage.getItem(userID + key);
        return str;
    };
    /**
     * 存储
     */
    GameLocalStorage.saveByUid = function (key, str) {
        var userID = String(MyData.uid) + "//";
        egret.localStorage.setItem(userID + key, str);
    };
    /**
     * 获得
     */
    GameLocalStorage.loadByUid = function (key) {
        var userID = String(MyData.uid) + "//";
        var str = egret.localStorage.getItem(userID + key);
        return str;
    };
    /**
     * 挂机战斗上阵
     * 系统:战斗
     */
    GameLocalStorage.explorationFightGroup = "GameLocalStorage://explorationFightGroup";
    /**
     * 挂机战斗神器ID
     * 系统：战斗
     */
    GameLocalStorage.explorationFightWeaponID = "GameLocalStorage://explorationFightWeaponID";
    /**
     * 每日试炼战斗上阵
     * 系统:战斗
     */
    GameLocalStorage.testFightGroup = "GameLocalStorage://testFightGroup";
    /**
     * 每日试炼战斗神器ID
     * 系统:战斗
     */
    GameLocalStorage.testFightWeaponID = "GameLocalStorage://testFightWeaponID";
    /**
     * 爬塔战斗上阵
     * 系统:战斗
     */
    GameLocalStorage.towerFightGroup = "GameLocalStorage://towerFightGroup";
    /**
     * 爬塔战斗神器ID
     * 系统:战斗
     */
    GameLocalStorage.towerFightWeaponID = "GameLocalStorage://towerFightWeaponID";
    /**
     * 音乐保存
     * 系统:玩家信息
     */
    GameLocalStorage.usermusicvalue_1 = "GameLocalStorage://usermusicvalue_1";
    /**
     * 音效保存
     * 系统:玩家信息
     */
    GameLocalStorage.usermusicvalue_2 = "GameLocalStorage://usermusicvalue_2";
    /**
     * 好友boss战斗上阵
     * 系统：好友
     */
    GameLocalStorage.friendBossFightGroup = "GameLocalStorage://friendBossFightGroup";
    /**
     * 好友boss战斗神器ID
     * 系统：好友
     */
    GameLocalStorage.friendBossFightWeaponID = "GameLocalStorage://friendBossFightWeaponID";
    /**
     * 竞技场防守阵容保存
     * 系统：竞技场
     */
    GameLocalStorage.arenaDefendFightGroup = "GameLocalStorage://arenaDefendFightGroup";
    /**
     * 竞技场防守阵容神器ID
     * 系统：竞技场
     */
    GameLocalStorage.arenaDefendFightWeaponID = "GameLocalStorage://arenaDefendFightWeaponID";
    /**
     * 好友pk阵容保存
     * 系统：好友
     */
    GameLocalStorage.friendPKFightGroup = "GameLocalStorage://friendPKFightGroup";
    /**
     * 好友pk阵容神器ID
     * 系统：好友
     */
    GameLocalStorage.friendPKFightWeaponID = "GameLocalStorage://friendPKFightWeaponID";
    /**
     * 新手引导id
     * 系统：新手引导
     */
    GameLocalStorage.guideID = "GameLocalStorage://guideID";
    /**
     * 新手引导已完成组id
     * 系统：新手引导
     */
    GameLocalStorage.completeGuideGroupID = "GameLocalStorage://completeGuideGroupID";
    /**
     * 竞技场挑战对手阵容保存
     * 系统：好友
     */
    GameLocalStorage.arenaChallengeRivalFightGroup = "GameLocalStorage://arenaChallengeRivalFightGroup";
    /**
     * 竞技场挑战对手阵容神器ID
     * 系统：好友
     */
    GameLocalStorage.arenaChallengeRivalFightWeaponID = "GameLocalStorage://arenaChallengeRivalFightWeaponID";
    /**
     * 公会boss阵容
     *
     */
    GameLocalStorage.guildbossFightGroup = "GameLocalStorage://guildbossFightGroup";
    /**
     * 公会bosss神器ID
     *
     */
    GameLocalStorage.guildbossFightWeaponID = "GameLocalStorage://guildbossFightWeaponID";
    /**
     * 远征战斗阵容
     */
    GameLocalStorage.expeditionFightGroup = "GameLocalStorage://expeditionFightGroup";
    /**
     * 远征战斗神器ID
     */
    GameLocalStorage.expeditionFightWeaponID = "GameLocalStorage://expeditionFightWeaponID";
    /**
     *登录信息
     */
    GameLocalStorage.chooseServer = "GameLocalStorage://chooseServer";
    /**
     *登录信息--userid 角色ID
     */
    GameLocalStorage.chooseServerUid = "GameLocalStorage://chooseServerUserId";
    /**
     * 系统开放系统ID组
     */
    GameLocalStorage.systemOpenIdGroup = "GameLocalStorage://systemOpenIdGroup";
    /**
     * 热更版本
     */
    GameLocalStorage.localresVersion = "GameLocalStorage://localresVersion";
    /**
     * 战斗加速
     */
    GameLocalStorage.fightTimeSpeed = "GameLocalStorage://fightTimeSpeed";
    return GameLocalStorage;
}());
__reflect(GameLocalStorage.prototype, "GameLocalStorage");
var GameSystem = (function () {
    function GameSystem() {
    }
    //查询系统是否开放
    GameSystem.isSysOpen = function (sysID, type) {
        var level = MyData.user.level;
        var systemOpenTab = ak.JsonTableMgr.get("systemOpen");
        var row = systemOpenTab.getRowFromColName("id", "" + sysID);
        if (row) {
            var openLv = row.getValFromColName("openLv"); //开放等级
            if (level >= openLv) {
                return true;
            }
        }
        /**新增系统开放判定 */
        var systemOpenIdGroupstr = "";
        if (MyData.user) {
            systemOpenIdGroupstr = GameLocalStorage.load(GameLocalStorage.systemOpenIdGroup);
        }
        var GroupIDarr = {};
        if (systemOpenIdGroupstr != "" && systemOpenIdGroupstr != null) {
            GroupIDarr = ak.json_decode(systemOpenIdGroupstr);
        }
        if (GroupIDarr[sysID]) {
            return true;
        }
        if (type) {
            var tip = row.getValFromColName("tip"); //未开放提示
            TipsViewSystem.show(tip);
        }
        //未开放
        return false;
    };
    return GameSystem;
}());
__reflect(GameSystem.prototype, "GameSystem");
//物品管理器
var ItemMgr = (function () {
    function ItemMgr() {
    }
    //获取物品信息
    ItemMgr.getItem = function (index) {
        var itemArr = MyData.user.json.itemArr;
        return itemArr[index];
    };
    //根据ID获取物品
    ItemMgr.getItemByID = function (id) {
        var itemArr = MyData.user.json.itemArr;
        var c = itemArr.length;
        for (var i = 0; i < c; ++i) {
            var item = itemArr[i];
            if (item.itemID == id) {
                return item;
            }
        }
        return null;
    };
    /**
     * 根据掉落id获得掉落数组
     * 数组内单个元素对应表里面的[几率,类型,道具id,数量]
     */
    ItemMgr.getDropGroupByID = function (id) {
        var dropGroupTab = ak.JsonTableMgr.get("dropGroup");
        var dropGroupInfo = dropGroupTab.getRowFromColName("id", "" + id);
        var drop0 = [];
        drop0 = dropGroupInfo.getValFromColName("drop");
        var drop0arr = [];
        drop0arr = drop0;
        var drop0arr2 = [];
        for (var i = 0; i < drop0arr.length; i += 2) {
            drop0arr2.push([Number(drop0arr[i]), Number(drop0arr[i + 1])]);
        }
        var dropTab = ak.JsonTableMgr.get("drop");
        var finaldropGroup = [];
        for (var j = 0; j < drop0arr2.length; j++) {
            var dropInfo = dropTab.getRowFromColName("id", "" + drop0arr2[j][1]);
            var drop = dropInfo.getValFromColName("drop");
            var droparr = drop;
            for (var k = 0; k < droparr.length; k += 4) {
                var droparr0 = Number(droparr[k]);
                var droparr1 = Number(droparr[k + 1]);
                var droparr2 = Number(droparr[k + 2]);
                var droparr3 = Number(droparr[k + 3]);
                if (droparr1 != 0)
                    finaldropGroup.push([droparr0, droparr1, droparr2, droparr3]);
            }
        }
        return finaldropGroup;
    };
    return ItemMgr;
}());
__reflect(ItemMgr.prototype, "ItemMgr");
//市场管理器
var MarketMgr = (function () {
    function MarketMgr() {
    }
    //刷新次数
    MarketMgr.refreshCount = function () {
        var market = MyData.user.json.market;
        var time = market.time; //刷新开始时间（秒）
        var flushNum = market.flushNum; //刷新次数
        var now = ak.time() + MyData.timeBase; //当前时间戳 + 本地与服务器时间差
        var marketConfigInfo = ak.JsonTableMgr.get("marketConfig").getRow(0);
        var timeMarket = Number(marketConfigInfo.getValFromColName("time")); //恢复时间（秒）
        var countMarket = Number(marketConfigInfo.getValFromColName("count")); //恢复点数
        var limitMarket = Number(marketConfigInfo.getValFromColName("limit")); //点数上限
        var passTime = now - time; //经过多长时间
        var residueTime = 0;
        var num = Math.floor(passTime / timeMarket) * countMarket + market.flushNum;
        ;
        if (num > limitMarket) {
            num = limitMarket; //可以恢复次数
        }
        if (num != limitMarket) {
            residueTime = timeMarket - (passTime - timeMarket * num); //剩余时间
        }
        var arr = [num, limitMarket, residueTime];
        return arr;
    };
    return MarketMgr;
}());
__reflect(MarketMgr.prototype, "MarketMgr");
//怪物管理器
var MonsterMgr = (function () {
    function MonsterMgr() {
    }
    //获取monster.xlsx中行数组
    MonsterMgr.getMonsterRowArr = function (monsterGroupID) {
        if (this.monsterGroupMap) {
            return this.monsterGroupMap[monsterGroupID];
        }
        this.monsterGroupMap = {};
        var monsterTab = ak.JsonTableMgr.get("monster");
        var c = monsterTab.size();
        for (var i = 0; i < c; ++i) {
            var row = monsterTab.getRow(i);
            var groupID = row.getValFromColName("group");
            var arr = this.monsterGroupMap[groupID];
            if (arr) {
                arr.push(row);
            }
            else {
                arr = [];
                arr.push(row);
                this.monsterGroupMap[groupID] = arr;
            }
        }
        return this.monsterGroupMap[monsterGroupID];
    };
    return MonsterMgr;
}());
__reflect(MonsterMgr.prototype, "MonsterMgr");
//背景音乐管理器
var MusicMgr = (function () {
    function MusicMgr() {
    }
    //播放选区音乐
    MusicMgr.playSelectServerMusic = function () {
        ak.SoundMgr.inst.playMusic("resource/sound/denglu.mp3");
    };
    //播放主城音乐
    MusicMgr.playMainCityMusic = function () {
        ak.SoundMgr.inst.playMusic("resource/sound/city.mp3");
    };
    //播放战斗音乐
    MusicMgr.playBattleMusic = function () {
        var index = Math.floor(Math.random() * this.battleMusicArr.length);
        ak.SoundMgr.inst.playMusic(this.battleMusicArr[index]);
    };
    MusicMgr.battleMusicArr = [
        "resource/sound/fight_1.mp3",
        "resource/sound/fight_2.mp3",
        "resource/sound/fight_3.mp3",
    ];
    return MusicMgr;
}());
__reflect(MusicMgr.prototype, "MusicMgr");
//红点管理器
var RedDotMgr = (function () {
    function RedDotMgr() {
    }
    /**
     * 系统：铁匠铺
     * 获取选项卡红点
     */
    RedDotMgr.oneEquSmithyRed = function () {
        var itemArr = MyData.user.json.itemArr;
        var itemArrCount = itemArr.length;
        var itemEquipTab = ak.JsonTableMgr.get("itemEquip");
        var itemEquCount = itemEquipTab.size();
        var redTabArr = [];
        for (var i = 1; i < 5; i++) {
            var pass = 0;
            var j = 0;
            while (j < itemEquCount) {
                var row = itemEquipTab.getRow(j);
                var equId = row.getValFromColName("id");
                var type = row.getValFromColName("type");
                var needID = Number(row.getValFromColName("needID")); //
                var needNum = Number(row.getValFromColName("needNum")); //合成需要数量
                if (i == type && needID) {
                    var k = 0;
                    while (k < itemArrCount) {
                        var itemIDS = itemArr[k].itemID;
                        if (needID == itemIDS) {
                            var itemCount = itemArr[k].count;
                            if (itemCount >= needNum) {
                                pass = 1;
                            }
                        }
                        if (pass) {
                            break;
                        }
                        k++;
                    }
                }
                if (pass) {
                    break;
                }
                j++;
            }
            redTabArr.push(pass);
        }
        return redTabArr;
    };
    /**
     * 系统：邮件
     * 获取邮件外部红点
     */
    RedDotMgr.getMailRedDot = function () {
        if (MyData.mailArr == null)
            return false;
        var mailArrUnreadCount = 0;
        for (var i = 0; i < MyData.mailArr.length; i++) {
            if (MyData.mailArr[i][5] != 1) {
                mailArrUnreadCount++;
            }
        }
        return mailArrUnreadCount != 0 ? true : false;
    };
    /**
     * 系统：聊天
     * 获取聊天外部红点
     */
    RedDotMgr.getChatRedDot = function () {
        return MyData.worldChatUnreadCount != 0 ? true : false;
    };
    RedDotMgr.setChatRedDot = function (clear) {
        MyData.worldChatUnreadCount = clear;
    };
    /**
     * 系统：排行榜
     * 获取排行榜外部红点
     */
    RedDotMgr.getWorshipRedDot = function () {
        var worship = MyData.user.json.worship;
        if (worship.barrierRank == 0 || worship.battlePowerRank == 0 || worship.stageRank == 0 || worship.unionRank == 0) {
            return true;
        }
        return false;
    };
    /**
     * 系统：好友
     * 获取好友外部红点(好友送心)
     */
    RedDotMgr.getFriendRedDot = function () {
        if (MyData.friendMap != null) {
            var friendList = MyData.friendMap;
            for (var id in friendList) {
                if (friendList[id].recv == 1) {
                    return true;
                }
            }
        }
        return false;
    };
    /**
     * 系统：好友
     * 获取好友外部红点(好友探宝)
     */
    RedDotMgr.getFriendTreasureRedDot = function () {
        if (MyData.user == null || MyData.user.json == null || MyData.user.json.friendSys == null) {
            return false;
        }
        var friendTab = ak.JsonTableMgr.get("friend");
        var freeTime1 = friendTab.getRow(0).getValFromColName("treasureTime");
        var dt1 = (new Date().getTime() / 1000) - MyData.user.json.friendSys.searchTreasureTime + MyData.timeBase;
        return dt1 >= freeTime1 ? true : false;
    };
    /**
     * 系统：任务
     * 获取任务外部红点(成就)
     */
    RedDotMgr.getTaskRedDot = function () {
        var taskTab = ak.JsonTableMgr.get("task");
        var taskTypeTab = ak.JsonTableMgr.get("taskType");
        var achievementTask = MyData.user.json.achievementTask;
        var taskTypeList = [];
        taskTypeList[101] = MyData.user.level;
        taskTypeList[102] = achievementTask.heroStar4Count; //获得%0个4星英雄
        taskTypeList[103] = achievementTask.heroStar5Count; //获得%0个5星英雄
        taskTypeList[104] = achievementTask.heroStar6Count; //获得%0个6星英雄
        taskTypeList[105] = achievementTask.heroStar9Count; //获得%0个9星英雄
        taskTypeList[106] = achievementTask.heroDecomposeCount; //分解%0个英雄
        taskTypeList[107] = achievementTask.equColor3Count; //获得%0件紫色装备
        taskTypeList[108] = achievementTask.equColor4Count; //获得%0件橙色装备
        taskTypeList[109] = achievementTask.equColor5Count; //获得%0件红色装备
        taskTypeList[110] = achievementTask.stageWinCount; //自由竞技场胜%0次
        taskTypeList[111] = achievementTask.stageScore; //自由竞技场达到%0分
        taskTypeList[112] = achievementTask.pubTaskColor2Count; //完成蓝色悬赏任务%0次
        taskTypeList[113] = achievementTask.pubTaskColor3Count; //完成紫色悬赏%0次
        taskTypeList[114] = achievementTask.pubTaskColor4Count; //完成橙色悬赏任务%0次
        taskTypeList[115] = achievementTask.pubTaskColor5Count; //完成红色悬赏任务%0次
        taskTypeList[116] = achievementTask.friendSearchCount; //好友搜寻%0次敌人
        taskTypeList[117] = 0; //十字军通过第%0关
        taskTypeList[118] = achievementTask.wishPoolGetHeroStar5Count; //许愿获得%0次5星英雄
        taskTypeList[119] = achievementTask.worldTreeRandomCardCount; //在世界树召唤%0次
        taskTypeList[120] = achievementTask.heroStar10Count; //获得%0个10星英雄
        var newArr = [];
        var arr = Object.keys(achievementTask.idMap);
        if (arr.length) {
            newArr = arr.map(Number);
        }
        for (var i = 0; i < taskTypeTab.size(); i++) {
            var rowType = taskTypeTab.getRow(i);
            var type = rowType.getValFromColName("type"); //任务类型
            var taskId = 0;
            var pass = 1;
            var finish = 0;
            for (var j = 0; j < taskTab.size(); j++) {
                var rowT = taskTab.getRow(j);
                var id = rowT.getValFromColName("id"); //成就任务ID
                var next = rowT.getValFromColName("next"); //下一个任务
                var typeTask = rowT.getValFromColName("type"); //任务类型
                var passRace = newArr.indexOf(id);
                if (passRace == -1 && typeTask == type && pass) {
                    taskId = id;
                    pass = 0;
                }
                if (next == 0 && typeTask == type && pass) {
                    taskId = id;
                    pass = 0;
                    finish = 1;
                }
            }
            if (taskId) {
                var rowT = taskTab.getRowFromColName("id", "" + taskId);
                var num = rowT.getValFromColName("num"); //所需数量
                var count = taskTypeList[type] || 0;
                if (count >= num && finish == 0) {
                    return true;
                }
            }
        }
        return false;
    };
    /**
     * 系统：任务
     * 获取任务外部红点(日常任务)
     */
    RedDotMgr.getTaskRedDot2 = function () {
        var taskDailyTab = ak.JsonTableMgr.get("taskDaily");
        var dailyTask = MyData.user.json.dailyTask;
        var row = taskDailyTab.getRowFromColName("id", "" + 1);
        var idMap = dailyTask.idMap;
        var arrCount = Object.keys(idMap).length;
        if (arrCount == 10) {
            return true;
        }
        var taskDataList = [];
        taskDataList[2] = dailyTask.randomCardNormalCount; //完成%0次普通祭祀
        taskDataList[3] = dailyTask.randomCardTopCount; //完成%0次高级祭祀
        taskDataList[4] = dailyTask.hookCount; //获取%0次探险收益
        taskDataList[5] = dailyTask.getGoldCount; //完成%0次点金
        taskDataList[6] = dailyTask.friendGiveHeartCount; //赠送好友%0次友情印记
        taskDataList[7] = dailyTask.wishNormalCount; //抽取%0次普通许愿池
        taskDataList[8] = dailyTask.equComposeCount; //合成%0件装备
        taskDataList[9] = dailyTask.pubTaskCount; //完成%0个悬赏
        taskDataList[10] = dailyTask.stageReqBattleCount; //挑战%0次自由竞技场
        taskDataList[11] = dailyTask.testCount; //挑战%0次每日试炼
        for (var i = 2; i <= taskDailyTab.size(); i++) {
            var row_5 = taskDailyTab.getRowFromColName("id", "" + i);
            var num = row_5.getValFromColName("num"); //所需数量
            var count = taskDataList[i] || 0;
            if (count >= num) {
                if (!idMap[i]) {
                    return true;
                }
            }
        }
        return false;
    };
    /**
     * 系统：排行榜
     * 获取膜拜选项卡红点
     */
    RedDotMgr.getWorshipTabRedDot = function () {
        var worship = MyData.user.json.worship;
        var redArr = [worship.barrierRank, worship.battlePowerRank, worship.stageRank, worship.unionRank];
        return redArr;
    };
    /**
     * 系统：探险
     * 获取快速探险免费红点
     */
    RedDotMgr.speedExplorationRedDot = function () {
        if (MyData.user.json.hook.getResCountQuick == 0) {
            return 1;
        }
        return 0;
    };
    /**
     * 系统：背包
     * 获取碎片合成红点
     */
    RedDotMgr.bagPieceRedDot = function () {
        var itemGroups = BagData.inst().GetItemGroupInfoByIndex(0, 2);
        for (var i = 0; i < itemGroups.length; i++) {
            var itemID = itemGroups[i][1].itemID;
            var count = itemGroups[i][1].count;
            if (count >= BagData.inst().GetPieceMaxNum(itemGroups[i][1].itemID)) {
                return 1;
            }
        }
        return 0;
    };
    /**
     * 系统：充值
     * 获取福利礼包红点
     */
    RedDotMgr.rechargeWelfareGiftRedDot = function () {
        var buyMap = MyData.user.json.welfarePackage.buyMap;
        return buyMap[1] == null;
    };
    /**
     * 系统：充值
     * 获取每日商店红点
     */
    RedDotMgr.rechargeDailyShopRedDot = function () {
        var buyMap = MyData.user.json.dailyShop.buyMap;
        return buyMap[1] == null;
    };
    /**
     * 系统：每日首冲
     * 领取红点
     */
    RedDotMgr.everydayRechargeRedDot = function () {
        var fristRechargeDailyTab = ak.JsonTableMgr.get("fristRechargeDaily");
        var fristRechargeDailyInfo = fristRechargeDailyTab.getRow(0);
        var pay = fristRechargeDailyInfo.getValFromColName("pay");
        var money = MyData.user.json.recharge.dailyPay;
        var dailyPayReward = MyData.user.json.recharge.dailyPayReward;
        if (money >= pay && dailyPayReward == 0) {
            return 1;
        }
        return 0;
    };
    /**
     * 系统：首冲
     * 领取红点
     */
    RedDotMgr.fristRechargeRedDot = function () {
        var keys = Object.keys(MyData.user.json.recharge.loginMap);
        for (var i = 0; i < keys.length; i++) {
            var loginDays = MyData.user.json.recharge.loginMap[keys[i]].loginDays;
            var rewardMap = MyData.user.json.recharge.loginMap[keys[i]].rewardMap;
            for (var j = 0; j < loginDays; j++) {
                if (rewardMap[j + 1]) {
                    //领取了
                }
                else {
                    return 1;
                }
            }
        }
        return 0;
    };
    /**
     * 系统：7日活动
     * 7日活动领取红点
     */
    RedDotMgr.sevenDayActivityRedDot = function () {
        var creatday = Common.getCreateUserDays();
        for (var x = 0; x < 6; x++) {
            var progressRecvMap = MyData.user.json.createUser7Day.progressRecvMap;
            if (!progressRecvMap[x + 1]) {
                var nowNum = ActivityOpenserverData.inst().getCompleteTaskNum();
                var boxneedNum = ActivityOpenserverData.inst().getboxInfobyIndex(x).num;
                if (nowNum > boxneedNum) {
                    return 1;
                }
            }
        }
        for (var i = 0; i < creatday; i++) {
            var infoarr = ActivityOpenserverData.inst().getInfobyDay(i + 1);
            if ((i + 1) <= Common.getCreateUserDays()) {
                for (var j = 0; j < infoarr.length; j++) {
                    var iscomplete = ActivityOpenserverData.inst().getTaskProgress(infoarr[j].id).iscomplete;
                    if (iscomplete && infoarr[j].type != 3) {
                        if (!MyData.user.json.createUser7Day.recvMap[infoarr[j].id]) {
                            return 1;
                        }
                    }
                }
            }
        }
        return 0;
    };
    /**
     * 系统：7日活动
     * 天数按钮红点
     */
    RedDotMgr.sevenDayActivityDaybtnRedDot = function (day) {
        var infoarr = ActivityOpenserverData.inst().getInfobyDay(day);
        if (day <= Common.getCreateUserDays()) {
            for (var j = 0; j < infoarr.length; j++) {
                var iscomplete = ActivityOpenserverData.inst().getTaskProgress(infoarr[j].id).iscomplete;
                if (iscomplete && infoarr[j].type != 3) {
                    if (!MyData.user.json.createUser7Day.recvMap[infoarr[j].id] && (day)) {
                        return 1;
                    }
                }
            }
        }
        return 0;
    };
    /**
     * 系统：7天活动
     * 标签页红点
     */
    RedDotMgr.sevenDayActivityTypebtnRedDot = function (day, page) {
        var infoarr = ActivityOpenserverData.inst().getInfobyDayandType(day, page);
        if (day <= Common.getCreateUserDays()) {
            for (var j = 0; j < infoarr.length; j++) {
                var iscomplete = ActivityOpenserverData.inst().getTaskProgress(infoarr[j].id).iscomplete;
                if (iscomplete && page != 4) {
                    if (!MyData.user.json.createUser7Day.recvMap[infoarr[j].id]) {
                        return 1;
                    }
                }
            }
        }
        return 0;
    };
    /**
     * 系统：充值
     * 充值外部红点
     */
    RedDotMgr.rechargeRedDot = function () {
        if (RedDotMgr.rechargeWelfareGiftRedDot() == true) {
            return 1;
        }
        if (RedDotMgr.rechargeDailyShopRedDot() == true) {
            return 1;
        }
        return 0;
    };
    /**
     * 系统：登录奖励
     * 奖励领取红点
     */
    RedDotMgr.sginRedDot = function () {
        var signInCount = MyData.user.json.signIn.signInCount;
        var loginDays = MyData.user.loginDays;
        if (loginDays > signInCount) {
            return 1;
        }
        return 0;
    };
    /**
     * 系统：限时活动
     * 领取红点
     */
    RedDotMgr.activityTimeRedDot = function () {
        var activityInfo = ActivityData.inst().getMainUIactivityData("2");
        for (var i = 0; i < activityInfo.length; i++) {
            var jump = activityInfo[i].getValFromColName("jump");
            var id = activityInfo[i].getValFromColName("id");
            var num = RedDotMgr.activityListBtnTimeRedDot(jump[1], id) ? 1 : 0;
            if (num == 1) {
                return 1;
            }
        }
        return 0;
    };
    /**
     * 系统：限时活动
     * 限时活动列表按钮红点
     */
    RedDotMgr.activityListBtnTimeRedDot = function (viewtype, actId) {
        var actTab = ActivityWonderfulCommonData.inst().getConfigByActId(actId.toString());
        var limitActivity = MyData.user.json.limitActivity;
        if (viewtype == 9) {
            var exchangeMap = limitActivity.map_type1[actId] != null ? limitActivity.map_type1[actId].exchangeMap : [];
            var buyMap = (MyData.limitActivity_type1 != null && MyData.limitActivity_type1.map[actId] != null) ? MyData.limitActivity_type1.map[actId].buyMap : [];
            for (var i = 0; i < actTab.size(); i++) {
                var actInfo = actTab.getRow(i);
                var id = actInfo.getValFromColName("id");
                var lv = actInfo.getValFromColName("lv");
                var limit = actInfo.getValFromColName("limit");
                if (MyData.user.level >= lv && exchangeMap[id] == null && limit - (buyMap[id] || 0) > 0) {
                    //等级达到 && 未领取 && 剩余份数大于零
                    return true;
                }
            }
            return false;
        }
        else if (viewtype == 4) {
            for (var i = 0; i < actTab.size(); i++) {
                var actInfo = actTab.getRow(i);
                var id = actInfo.getValFromColName("id");
                var day = actInfo.getValFromColName("day");
                var payMap = limitActivity.map_type4[actId] != null ? limitActivity.map_type4[actId].payMap : [];
                var rechargeday = Object.keys(payMap).length;
                var exchangeMap = limitActivity.map_type4[actId] != null ? limitActivity.map_type4[actId].exchangeMap : [];
                if (exchangeMap[id] == null && rechargeday >= day) {
                    return true;
                }
            }
            return false;
        }
        else if (viewtype == 6) {
            for (var i = 0; i < actTab.size(); i++) {
                var actInfo = actTab.getRow(i);
                var activityID = actInfo.getValFromColName("activityID");
                if (actId == activityID) {
                    var money = actInfo.getValFromColName("money") / 100;
                    var id = actInfo.getValFromColName("id");
                    var exchangeMap = limitActivity.map_type6[actId] != null ? limitActivity.map_type6[actId].exchangeMap : [];
                    var rmb = limitActivity.map_type6[actId] != null ? limitActivity.map_type6[actId].rmb / 100 : 0;
                    if (rmb >= money && exchangeMap[id] == null) {
                        return true;
                    }
                }
            }
            return false;
        }
        return false;
    };
    /**
     * 系统：等级基金
     * 领取红点
     */
    RedDotMgr.levelRedDot = function (mylevel, level) {
        var islevel = mylevel / level >= 1 ? 1 : 0;
        return islevel;
    };
    /**
     * 系统：探险
     * 通关奖励红点
     */
    RedDotMgr.explorationBossAwardRedDot = function () {
        var list = ExplorationData.inst().GetAwardlistInfo();
        for (var i = 0; i < list.length; i++) {
            if (list[i][2] == 1) {
                return 1;
            }
        }
        return 0;
    };
    /**
     * 系统：在线奖励
     * 奖励领取红点
     */
    RedDotMgr.onlineRedDot = function () {
        var onlinePrize = ak.JsonTableMgr.get("onlinePrize");
        var count = onlinePrize.size();
        var cd = 0;
        for (var i = 0; i < count; i++) {
            var onlinePrizeInfo = onlinePrize.getRow(i);
            var onlineTime = onlinePrizeInfo.getValFromColName("cd"); //等待时间
            cd = cd + onlineTime;
            if ((Common.getOnlieSceond() + MyData.user.onlineSeconds) <= cd && !MyData.user.json.onlineReward.idMap[i + 1]) {
                return 0;
            }
            else if ((Common.getOnlieSceond() + MyData.user.onlineSeconds) > cd && MyData.user.json.onlineReward.idMap[i + 1] == null) {
                return 1;
            }
        }
    };
    /**
     * 系统：神器
     * 单件神器任务完成红点
     */
    RedDotMgr.singGodWeaponTaskCompleteRedDot = function (weaponId) {
        var taskData = GodWeaponData.inst().getTaskListByGodWeaponID(weaponId);
        var count = 0;
        var godWeaponSys = MyData.user.json.godWeaponSys;
        //=================所有任务已完成==================
        for (var i = 0; i < taskData.length; i++) {
            var id = taskData[i].getValFromColName("id");
            if (godWeaponSys.idMap[id] == 1) {
                count++;
            }
        }
        if (taskData.length == count) {
            return false;
        }
        else {
            var achievementTask = MyData.user.json.achievementTask;
            var taskTypeList = [];
            taskTypeList[101] = MyData.user.level;
            taskTypeList[102] = achievementTask.heroStar4Count; //获得%0个4星英雄
            taskTypeList[103] = achievementTask.heroStar5Count; //获得%0个5星英雄
            taskTypeList[104] = achievementTask.heroStar6Count; //获得%0个6星英雄
            taskTypeList[105] = achievementTask.heroStar9Count; //获得%0个9星英雄
            taskTypeList[106] = achievementTask.heroDecomposeCount; //分解%0个英雄
            taskTypeList[107] = achievementTask.equColor3Count; //获得%0件紫色装备
            taskTypeList[108] = achievementTask.equColor4Count; //获得%0件橙色装备
            taskTypeList[109] = achievementTask.equColor5Count; //获得%0件红色装备
            taskTypeList[110] = achievementTask.stageWinCount; //自由竞技场胜%0次
            taskTypeList[111] = achievementTask.stageScore; //自由竞技场达到%0分
            taskTypeList[112] = achievementTask.pubTaskColor2Count; //完成蓝色悬赏任务%0次
            taskTypeList[113] = achievementTask.pubTaskColor3Count; //完成紫色悬赏%0次
            taskTypeList[114] = achievementTask.pubTaskColor4Count; //完成橙色悬赏任务%0次
            taskTypeList[115] = achievementTask.pubTaskColor5Count; //完成红色悬赏任务%0次
            taskTypeList[116] = achievementTask.friendSearchCount; //好友搜寻%0次敌人
            taskTypeList[117] = MyData.user.json.remoteBattle.battleMaxCount; //十字军通过第%0关
            taskTypeList[118] = achievementTask.wishPoolGetHeroStar5Count; //许愿获得%0次5星英雄
            taskTypeList[119] = achievementTask.worldTreeRandomCardCount; //在世界树召唤%0次
            taskTypeList[120] = achievementTask.heroStar10Count; //获得%0个10星英雄
            taskTypeList[121] = MyData.user.barrierID; //冒险通关层数
            taskTypeList[123] = achievementTask.dailyTaskCompleteCount; //完成日常任务次数
            taskTypeList[124] = achievementTask.hookGetResQuickCount; //进行快速探险次数
            taskTypeList[125] = achievementTask.stageReqBattleCount; //挑战自由竞技场次数
            taskTypeList[126] = achievementTask.wishNormalCount; //进行普通许愿次数
            taskTypeList[127] = achievementTask.joinOrCreateUnionCount; //加入或创建公会次数
            taskTypeList[128] = achievementTask.testCount; //挑战每日试炼次数
            taskTypeList[129] = achievementTask.marketBuyCount; //市场购买次数
            taskTypeList[130] = achievementTask.randomCardTopCount; //完成高级祭祀次数
            taskTypeList[131] = MyData.user.towerID; //爬塔通关层数
            taskTypeList[132] = achievementTask.pubTaskCount; //完成悬赏任务次数
            taskTypeList[133] = achievementTask.cardComposeCountByStar5OrStar6; //通过合成法阵合成一个5星或6星英雄次数
            for (var i = 0; i < taskData.length; i++) {
                var id = taskData[i].getValFromColName("id");
                var type = taskData[i].getValFromColName("type");
                var num = taskData[i].getValFromColName("num");
                var taskInfo = Common.getTaskDataByTaskId(type);
                if (type == 122) {
                    if (godWeaponSys.idMap[id] != 1) {
                        var cardArr = MyData.user.json.cardArr;
                        for (var i_11 = 0; i_11 < cardArr.length; i_11++) {
                            if (cardArr[i_11].level >= num) {
                                return true;
                            }
                        }
                    }
                }
                else if (type == 121) {
                    if ((taskTypeList[type] || 0) > num && godWeaponSys.idMap[id] != 1) {
                        return true;
                    }
                }
                else {
                    if ((taskTypeList[type] || 0) >= num && godWeaponSys.idMap[id] != 1) {
                        return true;
                    }
                }
            }
        }
        return false;
    };
    /**
     * 系统：神器
     * 神器外部红点
     */
    RedDotMgr.allGodWeaponTaskCompleteRedDot = function () {
        var godWeaponTab = GodWeaponData.inst().getGodWeaponCfgList();
        var godWeaponSys = MyData.user.json.godWeaponSys;
        for (var i = 0; i < godWeaponTab.size(); i++) {
            var godWeaponInfo = godWeaponTab.getRow(i);
            var id = godWeaponInfo.getValFromColName("id");
            if (i == 0 || godWeaponSys.activeCount >= i) {
                if (RedDotMgr.singGodWeaponTaskCompleteRedDot(id) == true) {
                    return true;
                }
            }
        }
        return false;
    };
    /**
     * 系统：试炼
     * 选项卡红点
     */
    RedDotMgr.trialTab = function () {
        var redArr = [];
        for (var i = 1; i < 4; i++) {
            var info = MyData.user.json.test["info" + i];
            var trialCount = info.count;
            var trialMaxCount = info.maxCount;
            var num = trialMaxCount - trialCount;
            if (num > 0) {
                redArr.push(1);
            }
            else {
                redArr.push(0);
            }
        }
        return redArr;
    };
    /**
     * 系统：限时招募
     * 限时招募活动红点
     */
    RedDotMgr.limitSummonRedDot = function () {
        var HeroActivity = MyData.user.json.getHeroActivity;
        for (var i = 1; i < 4; i++) {
            var sign = HeroActivity["sign" + i];
            var reward = HeroActivity["reward" + i];
            if (sign > 0 && reward != 1) {
                return true;
            }
        }
        if (HeroActivity.reward1 == 1 && HeroActivity.reward2 == 1 && HeroActivity.reward3 == 1 && HeroActivity.reward4 == 0) {
            return true;
        }
        return false;
    };
    /**
     * 系统：公会
     * 公会捐献红点
     */
    RedDotMgr.guildDonateRedPoint = function () {
        var donateID = MyData.user.json.unionInfo.donateID;
        return donateID == 0;
    };
    /**
     * 系统：公会
     * 公会boss红点
     */
    RedDotMgr.guildMaoxianRedPoint = function () {
        var isredpoint;
        if (MyData.user.json.unionInfo.hitBossMap == null || MyData.user.json.unionInfo.hitBossMap[MyData.myUnionInfo.json.bossID] == null) {
            isredpoint = true;
        }
        else {
            isredpoint = MyData.user.json.unionInfo.hitBossMap[MyData.myUnionInfo.json.bossID] < 2 ? true : false;
        }
        return isredpoint;
    };
    return RedDotMgr;
}());
__reflect(RedDotMgr.prototype, "RedDotMgr");
//VIP管理器
var Vip = (function () {
    function Vip() {
    }
    //获取特权系数
    Vip.getRight = function (vipRightID) {
        var vip = MyData.user.vip;
        var vipTab = ak.JsonTableMgr.get("vip");
        for (var i = vip; i >= 0; i--) {
            var row = vipTab.getRowFromColName("lv", i);
            var rightArr = row.getValFromColName("right"); //特权(特权id，系数)
            var count = rightArr.length;
            for (var j = 0; j < count; j += 2) {
                var vrID = rightArr[j]; //特权id
                if (vrID == vipRightID) {
                    var coefficient = rightArr[j + 1]; //系数
                    return coefficient;
                }
            }
        }
        //特权字典
        var rightMap = MyData.user.json.rightMap;
        if (rightMap[vipRightID]) {
            //特权字典中存在的特权，其特权系统为1
            return (1);
        }
        //没有特权
        return 0;
    };
    //获得特权需要的vip等级
    Vip.getLv = function (vipRightID) {
        var vipTab = ak.JsonTableMgr.get("vip");
        for (var i = 0; i < vipTab.size(); i++) {
            var row = vipTab.getRow(i);
            var rightArr = row.getValFromColName("right"); //特权(特权id，系数)
            var lv = row.getValFromColName("lv");
            var count = rightArr.length;
            for (var j = 0; j < count; j += 2) {
                var vrID = rightArr[j]; //特权id
                if (vrID == vipRightID) {
                    return lv;
                }
            }
        }
        return 0;
    };
    return Vip;
}());
__reflect(Vip.prototype, "Vip");
